//-------------Mission 11-------------
// Originally: Paramedic sub-mission

:M11_PARAMEDIC
03A4: name_thread 'AMBULAN'
054C: use_GXT_table 'AMBULAE'
gosub @MISSION_START_AMBULANCE
gosub @AMBULANCE_FAILED
end_thread

:MISSION_START_AMBULANCE
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_PARAMEDIC_MISSION = 1
wait 0 ms
0004: $PARAMEDIC_MISSION_TIMER = 0
0004: $PARAMEDIC_MISSION_CAR = 0
0004: $PARAMEDIC_DISPLAYED_RADIO_OUT_OF_RANGE_MESSAGE = 0
0004: $AMBULANCE_HEALTH_LAST = 0
0004: $AMBULANCE_HEALTH_NOW = 0
0004: $TIME_DROP = 0
0004: $MAX_PEDS_IN_CAR = 0
0004: $PEDS_IN_CAR = 0
0004: $PARAMEDIC_CLOSE_ENOUGH_TO_HOSPITAL = 0
0004: $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL = 1
0004: $PED_COUNTER = 0
0004: $PARAMEDIC_CREATED_PATIENT1 = 0
0004: $PARAMEDIC_CREATED_PATIENT2 = 0
0004: $PARAMEDIC_CREATED_PATIENT3 = 0
0004: $PARAMEDIC_CREATED_PATIENT4 = 0
0004: $PARAMEDIC_CREATED_PATIENT5 = 0
0004: $PARAMEDIC_CREATED_PATIENT6 = 0
0004: $PARAMEDIC_CREATED_PATIENT7 = 0
0004: $PARAMEDIC_CREATED_PATIENT8 = 0
0004: $PARAMEDIC_CREATED_PATIENT9 = 0
0004: $PARAMEDIC_CREATED_PATIENT10 = 0
0004: $PARAMEDIC_CREATED_PATIENT11 = 0
0004: $PARAMEDIC_CREATED_PATIENT12 = 0
0004: $SAVED_PEDS = 0
//0004: $FIRST_RESCUE_FLAG = 0          NEVER USED
//0004: $FIRST_CHUNK_FLAG = 0           NEVER USED
0005: $TIME_CHUNK_DIVIDER = 11.0
0004: $PARAMEDIC_MISSION_LEVEL = 1
0004: $TIME_CHUNK = 0
0004: $TIME_CHUNK_IN_SECS = 0
0004: $SCORE_AM = 0
0004: $BONUS_TIME_FLAG = 0
0004: $DROP_OFF_TIME_BONUS = 0
0004: $HOSPITAL_BLIP_FLAG = 0
0004: $MISSION_END_BUTTON_AMBULANCE = 0
0004: $CAR_FULL_FLAG = 0
0004: $SAVED_PEDS_THIS_GO = 0
0004: $PARAMEDIC_ISLAND_PATIENT_IS_ON = 0
00BC: print_now 'ATUTOR2' 3000 ms 1   // ~g~Drive the patients to Hospital CAREFULLY. Each bump reduces their chances of survival.
wait 3000 ms
03C7: set_wanted_multiplier 0.5

:MISSION_ROOT
01E5: text_1number_highpriority 'ALEVEL' $PARAMEDIC_MISSION_LEVEL 5000 ms 4   // Paramedic Mission Level ~1~
014F: stop_timer $PARAMEDIC_MISSION_TIMER
0004: $PARAMEDIC_MISSION_TIMER = 0
03E6: remove_text_box
if
    0038:   $DISPLAYED_AMBULANCE_HELP == 0
then
	if
		82BD:   NOT   debug_mode == DEBUG_SKIPHELP
	then
		// Code optimized and made compatible with GInput
		0293: $CONTROLMODE = current_controls
		if
			0038:   $CONTROLMODE == 1
		then
			03E5: text_box 'SIREN_2'   // To turn on this vehicle's sirens tap the ~h~~k~~VEHICLE_HORN~ button~w~.
		else
			if
				0038:   $CONTROLMODE == 2
			then
				03E5: text_box 'SIREN_3'   // To turn on this vehicle's sirens tap the ~h~~k~~VEHICLE_HORN~ button~w~.
			else
				if
					0038:   $CONTROLMODE == 3
				then
					03E5: text_box 'SIREN_4'   // To turn on this vehicle's sirens tap the ~h~~k~~VEHICLE_HORN~ button~w~.
				else
					03E5: text_box 'SIREN_1'   // To turn on this vehicle's sirens tap the ~h~~k~~VEHICLE_HORN~ button~w~.
				end
			end
		end
	end
    0004: $DISPLAYED_AMBULANCE_HELP = 1
end
while 001C:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > $PED_COUNTER
    gosub @GENERATE_RANDOM_COORD
    gosub @CREATE_RANDOM_INJURED_PED
    gosub @GENERATE_TIMELIMIT
    0008: $PED_COUNTER += 1
end
if
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 3
then
    0004: $BONUS_TIME_FLAG = 1
else
    0004: $BONUS_TIME_FLAG = 0
end
0084: $TIME_CHUNK = $PARAMEDIC_MISSION_TIMER
0070: $TIME_CHUNK /= $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL
0014: $TIME_CHUNK /= 2
0084: $BRACKETS_VAR = $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL
0008: $BRACKETS_VAR += 1
0068: $TIME_CHUNK *= $BRACKETS_VAR
0058: $PARAMEDIC_MISSION_TIMER += $TIME_CHUNK
0070: $PARAMEDIC_MISSION_TIMER /= $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL
0084: $TIME_CHUNK = $PARAMEDIC_MISSION_TIMER
0014: $TIME_CHUNK /= 2
014E: set_timer_to $PARAMEDIC_MISSION_TIMER type 1
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    018A: $HOSPITAL_BLIP = create_checkpoint_at $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z
end
jump @AMBULANCE_LOOP

:CREATE_RANDOM_INJURED_PED
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 0
    0038:   $PARAMEDIC_CREATED_PATIENT1 == 0
then
    0376: $PATIENT1 = create_random_actor $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y $PARAMEDIC_CREATE_PATIENT_Z
    0004: $PARAMEDIC_CREATED_PATIENT1 = 1
    0332: set_actor $PATIENT1 bleeding_to 1 (true)
    02A9: set_actor $PATIENT1 immune_to_nonplayer 1
    0208: $PATIENT_Z_ANGLE = random_float 0.0 359.875
    0173: set_actor $PATIENT1 z_angle_to $PATIENT_Z_ANGLE
    0319: set_actor $PATIENT1 running 1
    01ED: reset_actor $PATIENT1 flags
    0187: $INJURED_PED_1_BLIP = create_marker_above_actor $PATIENT1
    0192: set_actor $PATIENT1 objective_to_stand_still
    return
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 1
    0038:   $PARAMEDIC_CREATED_PATIENT2 == 0
then
    0376: $PATIENT2 = create_random_actor $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y $PARAMEDIC_CREATE_PATIENT_Z
    0004: $PARAMEDIC_CREATED_PATIENT2 = 1
    0332: set_actor $PATIENT2 bleeding_to 1 (true)
    02A9: set_actor $PATIENT2 immune_to_nonplayer 1
    0208: $PATIENT_Z_ANGLE = random_float 0.0 359.875
    0173: set_actor $PATIENT2 z_angle_to $PATIENT_Z_ANGLE
    0319: set_actor $PATIENT2 running 1
    01ED: reset_actor $PATIENT2 flags
    0187: $INJURED_PED_2_BLIP = create_marker_above_actor $PATIENT2
    0192: set_actor $PATIENT2 objective_to_stand_still
    return
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 2
    0038:   $PARAMEDIC_CREATED_PATIENT3 == 0
then
    0376: $PATIENT3 = create_random_actor $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y $PARAMEDIC_CREATE_PATIENT_Z
    0004: $PARAMEDIC_CREATED_PATIENT3 = 1
    0332: set_actor $PATIENT3 bleeding_to 1 (true)
    02A9: set_actor $PATIENT3 immune_to_nonplayer 1
    0208: $PATIENT_Z_ANGLE = random_float 0.0 359.875
    0173: set_actor $PATIENT3 z_angle_to $PATIENT_Z_ANGLE
    0319: set_actor $PATIENT3 running 1
    01ED: reset_actor $PATIENT3 flags
    0187: $INJURED_PED_3_BLIP = create_marker_above_actor $PATIENT3
    0192: set_actor $PATIENT3 objective_to_stand_still
    return
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 3
    0038:   $PARAMEDIC_CREATED_PATIENT4 == 0
then
    0376: $PATIENT4 = create_random_actor $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y $PARAMEDIC_CREATE_PATIENT_Z
    0004: $PARAMEDIC_CREATED_PATIENT4 = 1
    0332: set_actor $PATIENT4 bleeding_to 1 (true)
    02A9: set_actor $PATIENT4 immune_to_nonplayer 1
    0208: $PATIENT_Z_ANGLE = random_float 0.0 359.875
    0173: set_actor $PATIENT4 z_angle_to $PATIENT_Z_ANGLE
    0319: set_actor $PATIENT4 running 1
    01ED: reset_actor $PATIENT4 flags
    0187: $INJURED_PED_4_BLIP = create_marker_above_actor $PATIENT4
    0192: set_actor $PATIENT4 objective_to_stand_still
    return
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 4
    0038:   $PARAMEDIC_CREATED_PATIENT5 == 0
then
    0376: $PATIENT5 = create_random_actor $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y $PARAMEDIC_CREATE_PATIENT_Z
    0004: $PARAMEDIC_CREATED_PATIENT5 = 1
    0332: set_actor $PATIENT5 bleeding_to 1 (true)
    02A9: set_actor $PATIENT5 immune_to_nonplayer 1
    0208: $PATIENT_Z_ANGLE = random_float 0.0 359.875
    0173: set_actor $PATIENT5 z_angle_to $PATIENT_Z_ANGLE
    0319: set_actor $PATIENT5 running 1
    01ED: reset_actor $PATIENT5 flags
    0187: $INJURED_PED_5_BLIP = create_marker_above_actor $PATIENT5
    0192: set_actor $PATIENT5 objective_to_stand_still
    return
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 5
    0038:   $PARAMEDIC_CREATED_PATIENT6 == 0
then
    0376: $PATIENT6 = create_random_actor $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y $PARAMEDIC_CREATE_PATIENT_Z
    0004: $PARAMEDIC_CREATED_PATIENT6 = 1
    0332: set_actor $PATIENT6 bleeding_to 1 (true)
    02A9: set_actor $PATIENT6 immune_to_nonplayer 1
    0208: $PATIENT_Z_ANGLE = random_float 0.0 359.875
    0173: set_actor $PATIENT6 z_angle_to $PATIENT_Z_ANGLE
    0319: set_actor $PATIENT6 running 1
    01ED: reset_actor $PATIENT6 flags
    0187: $INJURED_PED_6_BLIP = create_marker_above_actor $PATIENT6
    0192: set_actor $PATIENT6 objective_to_stand_still
    return
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 6
    0038:   $PARAMEDIC_CREATED_PATIENT7 == 0
then
    0376: $PATIENT7 = create_random_actor $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y $PARAMEDIC_CREATE_PATIENT_Z
    0004: $PARAMEDIC_CREATED_PATIENT7 = 1
    0332: set_actor $PATIENT7 bleeding_to 1 (true)
    02A9: set_actor $PATIENT7 immune_to_nonplayer 1
    0208: $PATIENT_Z_ANGLE = random_float 0.0 359.875
    0173: set_actor $PATIENT7 z_angle_to $PATIENT_Z_ANGLE
    0319: set_actor $PATIENT7 running 1
    01ED: reset_actor $PATIENT7 flags
    0187: $INJURED_PED_7_BLIP = create_marker_above_actor $PATIENT7
    0192: set_actor $PATIENT7 objective_to_stand_still
    return
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 7
    0038:   $PARAMEDIC_CREATED_PATIENT8 == 0
then
    0376: $PATIENT8 = create_random_actor $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y $PARAMEDIC_CREATE_PATIENT_Z
    0004: $PARAMEDIC_CREATED_PATIENT8 = 1
    0332: set_actor $PATIENT8 bleeding_to 1 (true)
    02A9: set_actor $PATIENT8 immune_to_nonplayer 1
    0208: $PATIENT_Z_ANGLE = random_float 0.0 359.875
    0173: set_actor $PATIENT8 z_angle_to $PATIENT_Z_ANGLE
    0319: set_actor $PATIENT8 running 1
    01ED: reset_actor $PATIENT8 flags
    0187: $INJURED_PED_8_BLIP = create_marker_above_actor $PATIENT8
    0192: set_actor $PATIENT8 objective_to_stand_still
    return
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 8
    0038:   $PARAMEDIC_CREATED_PATIENT9 == 0
then
    0376: $PATIENT9 = create_random_actor $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y $PARAMEDIC_CREATE_PATIENT_Z
    0004: $PARAMEDIC_CREATED_PATIENT9 = 1
    0332: set_actor $PATIENT9 bleeding_to 1 (true)
    02A9: set_actor $PATIENT9 immune_to_nonplayer 1
    0208: $PATIENT_Z_ANGLE = random_float 0.0 359.875
    0319: set_actor $PATIENT9 running 1
    01ED: reset_actor $PATIENT9 flags
    0187: $INJURED_PED_9_BLIP = create_marker_above_actor $PATIENT9
    0192: set_actor $PATIENT9 objective_to_stand_still
    return
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 9
    0038:   $PARAMEDIC_CREATED_PATIENT10 == 0
then
    0376: $PATIENT10 = create_random_actor $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y $PARAMEDIC_CREATE_PATIENT_Z
    0004: $PARAMEDIC_CREATED_PATIENT10 = 1
    0332: set_actor $PATIENT10 bleeding_to 1 (true)
    02A9: set_actor $PATIENT10 immune_to_nonplayer 1
    0208: $PATIENT_Z_ANGLE = random_float 0.0 359.875
    0173: set_actor $PATIENT10 z_angle_to $PATIENT_Z_ANGLE
    0319: set_actor $PATIENT10 running 1
    01ED: reset_actor $PATIENT10 flags
    0187: $INJURED_PED_10_BLIP = create_marker_above_actor $PATIENT10
    0192: set_actor $PATIENT10 objective_to_stand_still
    return
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 10
    0038:   $PARAMEDIC_CREATED_PATIENT11 == 0
then
    0376: $PATIENT11 = create_random_actor $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y $PARAMEDIC_CREATE_PATIENT_Z
    0004: $PARAMEDIC_CREATED_PATIENT11 = 1
    0332: set_actor $PATIENT11 bleeding_to 1 (true)
    02A9: set_actor $PATIENT11 immune_to_nonplayer 1
    0208: $PATIENT_Z_ANGLE = random_float 0.0 359.875
    0173: set_actor $PATIENT11 z_angle_to $PATIENT_Z_ANGLE
    0319: set_actor $PATIENT11 running 1
    01ED: reset_actor $PATIENT11 flags
    0187: $INJURED_PED_11_BLIP = create_marker_above_actor $PATIENT11
    0192: set_actor $PATIENT11 objective_to_stand_still
    return
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 11
    0038:   $PARAMEDIC_CREATED_PATIENT12 == 0
then
    0376: $PATIENT12 = create_random_actor $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y $PARAMEDIC_CREATE_PATIENT_Z
    0004: $PARAMEDIC_CREATED_PATIENT12 = 1
    0332: set_actor $PATIENT12 bleeding_to 1 (true)
    02A9: set_actor $PATIENT12 immune_to_nonplayer 1
    0208: $PATIENT_Z_ANGLE = random_float 0.0 359.875
    0173: set_actor $PATIENT12 z_angle_to $PATIENT_Z_ANGLE
    0319: set_actor $PATIENT12 running 1
    01ED: reset_actor $PATIENT12 flags
    0187: $INJURED_PED_12_BLIP = create_marker_above_actor $PATIENT12
    0192: set_actor $PATIENT12 objective_to_stand_still
    return
end
return

:GENERATE_RANDOM_COORD
wait 0 ms
0054: store_player $PLAYER position_to $PLAYER1_A_X $PLAYER1_A_Y $PLAYER1_A_Z
if
    03C6:   is_collision_in_memory 1
then
    0208: $PARAMEDIC_PATIENT_RANDOM_X = random_float 443.0 1205.0
    0208: $PARAMEDIC_PATIENT_RANDOM_Y = random_float -1110.0 0.0
    0005: $PARAMEDIC_CHECKPOINT_X = 806.5
    0005: $PARAMEDIC_CHECKPOINT_Y = -595.188
    0005: $PARAMEDIC_CHECKPOINT_Z = 19.875
    0005: $PARAMEDIC_INSIDE_HOSPITAL_X = 814.12
    0005: $PARAMEDIC_INSIDE_HOSPITAL_Y = -597.312
    0004: $PARAMEDIC_DISPLAYED_RADIO_OUT_OF_RANGE_MESSAGE = 0
    0004: $PARAMEDIC_CLOSE_ENOUGH_TO_HOSPITAL = 1
    0004: $PARAMEDIC_ISLAND_PATIENT_IS_ON = 1
end
if
    03C6:   is_collision_in_memory 2
then
    0208: $PARAMEDIC_PATIENT_RANDOM_X = random_float -527.0 210.0
    0208: $PARAMEDIC_PATIENT_RANDOM_Y = random_float -1626.0 98.0
    0005: $PARAMEDIC_CHECKPOINT_X = -157.5
    0005: $PARAMEDIC_CHECKPOINT_Y = -23.5625
    0005: $PARAMEDIC_CHECKPOINT_Z = 21.1875
    0005: $PARAMEDIC_INSIDE_HOSPITAL_X = -153.75
    0005: $PARAMEDIC_INSIDE_HOSPITAL_Y = -15.75
    0004: $PARAMEDIC_DISPLAYED_RADIO_OUT_OF_RANGE_MESSAGE = 0
    0004: $PARAMEDIC_CLOSE_ENOUGH_TO_HOSPITAL = 1
    0004: $PARAMEDIC_ISLAND_PATIENT_IS_ON = 2
end
if
    03C6:   is_collision_in_memory 3
then
    0208: $PARAMEDIC_PATIENT_RANDOM_X = random_float -1635.0 -749.0
    0208: $PARAMEDIC_PATIENT_RANDOM_Y = random_float -608.75 380.0
    0005: $PARAMEDIC_CHECKPOINT_X = -1590.5
    0005: $PARAMEDIC_CHECKPOINT_Y = -144.375
    0005: $PARAMEDIC_CHECKPOINT_Z = 63.75
    0005: $PARAMEDIC_INSIDE_HOSPITAL_X = -1581.75
    0005: $PARAMEDIC_INSIDE_HOSPITAL_Y = -139.062
    0004: $PARAMEDIC_DISPLAYED_RADIO_OUT_OF_RANGE_MESSAGE = 0
    0004: $PARAMEDIC_CLOSE_ENOUGH_TO_HOSPITAL = 1
    0004: $PARAMEDIC_ISLAND_PATIENT_IS_ON = 3
end
if and
    0038:   $PARAMEDIC_CLOSE_ENOUGH_TO_HOSPITAL == 0
    0038:   $PARAMEDIC_DISPLAYED_RADIO_OUT_OF_RANGE_MESSAGE == 0
then
    if
        0038:   $PARAMEDIC_DISPLAYED_RADIO_OUT_OF_RANGE_MESSAGE == 0
    then
        00BC: print_now 'A_RANGE' 5000 ms 1   // ~g~The ambulance radio is out of range get closer to a hospital!
        0004: $PARAMEDIC_DISPLAYED_RADIO_OUT_OF_RANGE_MESSAGE = 1
    end
    jump @AMBULANCE_FAILED
end
0293: $CONTROLMODE = current_controls
if
    8038:   NOT   $CONTROLMODE == 3
then
    if
        00E1:   key_pressed 0 19      //PAD1 RIGHTSHOCK
    then
        0004: $MISSION_END_BUTTON_AMBULANCE = 1
    end
else
    if
        00E1:   key_pressed 0 14      //PAD1 SQUARE
    then
        0004: $MISSION_END_BUTTON_AMBULANCE = 1
    end
end
if
    0038:   $MISSION_END_BUTTON_AMBULANCE == 1
then
    if
        8038:   NOT   $CONTROLMODE == 3
    then
        if
            80E1:   NOT   key_pressed 0 19      //PAD1 RIGHTSHOCK
        then
            00BC: print_now 'A_CANC' 3000 ms 1   // ~r~Paramedic mission cancelled!
            jump @AMBULANCE_FAILED
        end
    else
        if
            80E1:   NOT   key_pressed 0 14      //PAD1 SQUARE
        then
            00BC: print_now 'A_CANC' 3000 ms 1   // ~r~Paramedic mission cancelled!
            jump @AMBULANCE_FAILED
        end
    end
end
if
    80DE:   NOT   player $PLAYER driving_vehicle_type #AMBULAN
then
    00BC: print_now 'A_CANC' 3000 ms 1   // ~r~Paramedic mission cancelled!
    jump @AMBULANCE_FAILED
end
02C0: set $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y $PARAMEDIC_CREATE_PATIENT_Z to_ped_path_coords_closest_to $PARAMEDIC_PATIENT_RANDOM_X $PARAMEDIC_PATIENT_RANDOM_Y $PLAYER1_A_Z
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > 1063.0         // COLOMBIAN BOAT
    0022:   1280.0 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -965.0
    0022:   -902.0 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > 544.0         // BACK OF LUIGI'S
    0022:   557.0 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -427.0
    0022:   -407.0 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > 609.75           // FISH FACTORY
    0022:   682.06 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -1148.75
    0022:   -1076.5601 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > 585.75           // CHINATOWN MARKET
    0022:   669.0 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -754.188
    0022:   -670.0 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > 335.0          // CALAHAN BRIDGE
    0022:   700.0 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -953.0
    0022:   -912.0 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > 1029.0         // DOCKS INDUSTRIAL
    0022:   1306.0 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -1165.0
    0022:   -617.0 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > 314.0        // TUNNEL ENTRANCE INDUSTRIAL
    0022:   731.0 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > 25.0
    0022:   217.0 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > -1946.5        // AIRPORT SUBURBAN
    0022:   -1080.25 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -1001.88
    0022:   -371.188 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > 604.75        // OLD SCHOOL HALL AND PARK AREA
    0022:   700.56 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -901.25
    0022:   -828.188 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > 880.25          // DOG FOOD FACTORY
    0022:   888.69 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -839.375
    0022:   -763.562 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > 510.25          // INDUSTRIAL SAFEHOUSE
    0022:   564.562 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -312.562
    0022:   -295.688 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > -202.25          // DOJO COMMERCIAL
    0022:   -236.6875 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -1284.75
    0022:   -1273.0 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > -317.3125       // COLOMBIAN OJG COMPOUND
    0022:   273.0 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -388.688
    0022:   -312.375 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > -1590.38     // BAIT WAREHOUSE CARPARK SUBURBIA
    0022:   -1522.88 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > 80.5625
    0022:   123.375 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > 1051.38       // FRANKIES HOUSE
    0022:   1140.75 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -292.062
    0022:   -168.0 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if and
    0020:   $PARAMEDIC_CREATE_PATIENT_X > 431.688       // FOOT BRIDGE CHINATOWN
    0022:   516.75 > $PARAMEDIC_CREATE_PATIENT_X
    0020:   $PARAMEDIC_CREATE_PATIENT_Y > -604.062
    0022:   -558.188 > $PARAMEDIC_CREATE_PATIENT_Y
then
    jump @GENERATE_RANDOM_COORD
end
if
    0038:   $PARAMEDIC_ISLAND_PATIENT_IS_ON == 1         // INDUSTRIAL
then
    if or
        8020:   NOT   $PARAMEDIC_CREATE_PATIENT_X > 443.0
        8022:   NOT   1205.0 > $PARAMEDIC_CREATE_PATIENT_X
        8020:   NOT   $PARAMEDIC_CREATE_PATIENT_Y > -1110.0
        8022:   NOT   190.0 > $PARAMEDIC_CREATE_PATIENT_Y
    then
        jump @GENERATE_RANDOM_COORD
    end
end
if
    0038:   $PARAMEDIC_ISLAND_PATIENT_IS_ON == 2             // COMMERCIAL
then
    if or
        8020:   NOT   $PARAMEDIC_CREATE_PATIENT_X > -527.0
        8022:   NOT   210.0 > $PARAMEDIC_CREATE_PATIENT_X
        8020:   NOT   $PARAMEDIC_CREATE_PATIENT_Y > -1626.0
        8022:   NOT   98.0 > $PARAMEDIC_CREATE_PATIENT_Y
    then
        jump @GENERATE_RANDOM_COORD
    end
end
if
    0038:   $PARAMEDIC_ISLAND_PATIENT_IS_ON == 3             // SUBURBIA
then
    if or
        8020:   NOT   $PARAMEDIC_CREATE_PATIENT_X > -1635.0
        8022:   NOT   -749.0 > $PARAMEDIC_CREATE_PATIENT_X
        8020:   NOT   $PARAMEDIC_CREATE_PATIENT_Y > -608.75
        8022:   NOT   380.0 > $PARAMEDIC_CREATE_PATIENT_Y
    then
        jump @GENERATE_RANDOM_COORD
    end
end
if
    0022:   -1.0 > $PARAMEDIC_CREATE_PATIENT_Z
then
    jump @GENERATE_RANDOM_COORD
end
0086: $DIFFERENCE_X_FLOAT_A = $PLAYER1_A_X
0061: $DIFFERENCE_X_FLOAT_A -= $PARAMEDIC_CREATE_PATIENT_X
0086: $DIFFERENCE_Y_FLOAT_A = $PLAYER1_A_Y
0061: $DIFFERENCE_Y_FLOAT_A -= $PARAMEDIC_CREATE_PATIENT_Y
0069: $DIFFERENCE_X_FLOAT_A *= $DIFFERENCE_X_FLOAT_A
0069: $DIFFERENCE_Y_FLOAT_A *= $DIFFERENCE_Y_FLOAT_A
0086: $SUM_DIFFERENCE_A_XY = $DIFFERENCE_X_FLOAT_A
0059: $SUM_DIFFERENCE_A_XY += $DIFFERENCE_Y_FLOAT_A
01FB: $PLAYERS_DISTANCE_FROM_PED = square_root $SUM_DIFFERENCE_A_XY
if
    0022:   120.0 > $PLAYERS_DISTANCE_FROM_PED
then
    jump @GENERATE_RANDOM_COORD
end
0086: $DIFFERENCE_X_FLOAT_A = $PARAMEDIC_CHECKPOINT_X
0061: $DIFFERENCE_X_FLOAT_A -= $PARAMEDIC_CREATE_PATIENT_X
0086: $DIFFERENCE_Y_FLOAT_A = $PARAMEDIC_CHECKPOINT_Y
0061: $DIFFERENCE_Y_FLOAT_A -= $PARAMEDIC_CREATE_PATIENT_Y
0069: $DIFFERENCE_X_FLOAT_A *= $DIFFERENCE_X_FLOAT_A
0069: $DIFFERENCE_Y_FLOAT_A *= $DIFFERENCE_Y_FLOAT_A
0086: $SUM_DIFFERENCE_A_XY = $DIFFERENCE_X_FLOAT_A
0059: $SUM_DIFFERENCE_A_XY += $DIFFERENCE_Y_FLOAT_A
01FB: $PLAYERS_DISTANCE_FROM_HOSPITAL = square_root $SUM_DIFFERENCE_A_XY
if
    0022:   100.0 > $PLAYERS_DISTANCE_FROM_HOSPITAL
then
    jump @GENERATE_RANDOM_COORD
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT1 > 0
then
    if
        8118:   NOT   actor $PATIENT1 dead
    then
        if
            00EC:   actor $PATIENT1 0 near_point $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y radius 25.0 25.0
        then
            jump @GENERATE_RANDOM_COORD
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT2 > 0
then
    if
        8118:   NOT   actor $PATIENT2 dead
    then
        if
            00EC:   actor $PATIENT2 0 near_point $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y radius 25.0 25.0
        then
            jump @GENERATE_RANDOM_COORD
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT3 > 0
then
    if
        8118:   NOT   actor $PATIENT3 dead
    then
        if
            00EC:   actor $PATIENT3 0 near_point $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y radius 25.0 25.0
        then
            jump @GENERATE_RANDOM_COORD
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT4 > 0
then
    if
        8118:   NOT   actor $PATIENT4 dead
    then
        if
            00EC:   actor $PATIENT4 0 near_point $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y radius 25.0 25.0
        then
            jump @GENERATE_RANDOM_COORD
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT5 > 0
then
    if
        8118:   NOT   actor $PATIENT5 dead
    then
        if
            00EC:   actor $PATIENT5 0 near_point $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y radius 25.0 25.0
        then
            jump @GENERATE_RANDOM_COORD
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT6 > 0
then
    if
        8118:   NOT   actor $PATIENT6 dead
    then
        if
            00EC:   actor $PATIENT6 0 near_point $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y radius 25.0 25.0
        then
            jump @GENERATE_RANDOM_COORD
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT7 > 0
then
    if
        8118:   NOT   actor $PATIENT7 dead
    then
        if
            00EC:   actor $PATIENT7 0 near_point $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y radius 25.0 25.0
        then
            jump @GENERATE_RANDOM_COORD
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT8 > 0
then
    if
        8118:   NOT   actor $PATIENT8 dead
    then
        if
            00EC:   actor $PATIENT8 0 near_point $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y radius 25.0 25.0
        then
            jump @GENERATE_RANDOM_COORD
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT9 > 0
then
    if
        8118:   NOT   actor $PATIENT9 dead
    then
        if
            00EC:   actor $PATIENT9 0 near_point $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y radius 25.0 25.0
        then
            jump @GENERATE_RANDOM_COORD
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT10 > 0
then
    if
        8118:   NOT   actor $PATIENT10 dead
    then
        if
            00EC:   actor $PATIENT10 0 near_point $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y radius 25.0 25.0
        then
            jump @GENERATE_RANDOM_COORD
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT11 > 0
then
    if
        8118:   NOT   actor $PATIENT11 dead
    then
        if
            00EC:   actor $PATIENT11 0 near_point $PARAMEDIC_CREATE_PATIENT_X $PARAMEDIC_CREATE_PATIENT_Y radius 25.0 25.0
        then
            jump @GENERATE_RANDOM_COORD
        end
    end
end
return

:GENERATE_TIMELIMIT
if
    0038:   $PARAMEDIC_ISLAND_PATIENT_IS_ON == 3
then
    0005: $TIME_CHUNK_DIVIDER = 10.0
end
0086: $PED_TIME_LIMIT_FLOAT = $PLAYERS_DISTANCE_FROM_HOSPITAL
0071: $PED_TIME_LIMIT_FLOAT /= $TIME_CHUNK_DIVIDER
0011: $PED_TIME_LIMIT_FLOAT *= 1000.0
008C: $PED_TIME_LIMIT_TEMP = float_to_integer $PED_TIME_LIMIT_FLOAT
0058: $PARAMEDIC_MISSION_TIMER += $PED_TIME_LIMIT_TEMP
return

:AMBULANCE_LOOP
wait 0 ms
0293: $CONTROLMODE = current_controls
if
    8038:   NOT   $CONTROLMODE == 3
then
    if
        00E1:   key_pressed 0 19
    then
        0004: $MISSION_END_BUTTON_AMBULANCE = 1
    end
else
    if
        00E1:   key_pressed 0 14
    then
        0004: $MISSION_END_BUTTON_AMBULANCE = 1
    end
end
if
    0038:   $MISSION_END_BUTTON_AMBULANCE == 1
then
    if
        8038:   NOT   $CONTROLMODE == 3
    then
        if
            80E1:   NOT   key_pressed 0 19
        then
            00BC: print_now 'A_CANC' 3000 ms 1   // ~r~Paramedic mission cancelled!
            jump @AMBULANCE_FAILED
        end
    else
        if
            80E1:   NOT   key_pressed 0 14
        then
            00BC: print_now 'A_CANC' 3000 ms 1   // ~r~Paramedic mission cancelled!
            jump @AMBULANCE_FAILED
        end
    end
end
if
    80DE:   NOT   player $PLAYER driving_vehicle_type #AMBULAN
then
    00BC: print_now 'A_CANC' 3000 ms 1   // ~r~Paramedic mission cancelled!
    jump @AMBULANCE_FAILED
else
    00DA: $PARAMEDIC_MISSION_CAR = player $PLAYER car
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 6
    0038:   $BONUS_TIME_FLAG == 2
    0038:   $DROP_OFF_TIME_BONUS == 0
then
    0004: $BONUS_TIME_FLAG = 1
    0008: $DROP_OFF_TIME_BONUS += 1
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 9
    0038:   $BONUS_TIME_FLAG == 2
    0038:   $DROP_OFF_TIME_BONUS == 1
then
    0004: $BONUS_TIME_FLAG = 1
    0008: $DROP_OFF_TIME_BONUS += 1
end
if and
    0018:   $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL > 12
    0038:   $BONUS_TIME_FLAG == 2
    0038:   $DROP_OFF_TIME_BONUS == 2
then
    0004: $BONUS_TIME_FLAG = 1
    0008: $DROP_OFF_TIME_BONUS += 1
end
if
    0038:   $AMBULANCE_PAGER_FLAG == 0
then
    if
        0018:   $PARAMEDIC_MISSIONS_DONE > 34
    then
        014D: add_pager_message 'PAGEB13'  140  100  1   // Health delivered to hideout
        gosub @PROGRESS_COUNTER
        0004: $AMBULANCE_PAGER_FLAG = 1
    end
end
if
    0038:   $AMBULANCE_PAGER_FLAG == 1
then
    if
        0018:   $PARAMEDIC_MISSIONS_DONE > 69
    then
        014D: add_pager_message 'PAGEB14'  140  100  1   // Adrenaline delivered to hideout
        gosub @PROGRESS_COUNTER
        0004: $AMBULANCE_PAGER_FLAG = 2
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT1 > 0
then
    if
        0118:   actor $PATIENT1 dead
    then
        00BC: print_now 'A_FAIL3' 3000 ms 1   // ~r~The patient is dead!!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_MISSION_TIMER == 0
    then
        0321: explode_char_head $PATIENT1
        034F: remove_char_elegantly $PATIENT1
        00BC: print_now 'A_FAIL2' 3000 ms 1   // ~r~Your lack of urgency has been fatal to the patient!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT1 == 3
    then
        if
            03A3:   $PATIENT1 is_male
        then
            0004: $PED_SEX_FLAG = 0
        else
            0004: $PED_SEX_FLAG = 1
        end
        00A0: store_actor $PATIENT1 position_to $SOUND_X $SOUND_Y $SOUND_Z
        gosub @CHUNK1_AMBULANCE
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT1 == 1
    then
        if
            00FD:   player $PLAYER 0 near_actor $PATIENT1 in_car radius 10.0 10.0 2.0
        then
            gosub @CHUNK2_AMBULANCE
            if
                0038:   $CAR_FULL_FLAG == 0
            then
                01D4: actor $PATIENT1 go_to_car $PARAMEDIC_MISSION_CAR and_enter_it_as_a_passenger
                0004: $PARAMEDIC_CREATED_PATIENT1 = 2
            end
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT1 == 2
    then
        if
            80EB:   NOT   player $PLAYER 0 near_actor_in_car $PATIENT1 radius 25.0 25.0
        then
            0004: $PARAMEDIC_CREATED_PATIENT1 = 1
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT1 == 2
    then
        if
            00DF:   actor $PATIENT1 driving
        then
            0164: remove_blip $INJURED_PED_1_BLIP
            gosub @CHUNK3_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT1 = 3
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT1 == 3
    then
        if
            00FA:   player $PLAYER stopped 1 near_point_in_car $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z radius 6.0 6.0 2.0
        then
            01D3: actor $PATIENT1 leave_car $PARAMEDIC_MISSION_CAR
            0004: $PARAMEDIC_CREATED_PATIENT1 = 4
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT1 == 4
    then
        if
            80DF:   NOT   actor $PATIENT1 driving
        then
            0211: actor $PATIENT1 walk_to $PARAMEDIC_INSIDE_HOSPITAL_X $PARAMEDIC_INSIDE_HOSPITAL_Y
            01C2: remove_references_to_actor $PATIENT1  // Like turning an actor into a random pedestrian
            gosub @CHUNK4_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT1 = 0
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT2 > 0
then
    if
        0118:   actor $PATIENT2 dead
    then
        00BC: print_now 'A_FAIL3' 3000 ms 1   // ~r~The patient is dead!!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_MISSION_TIMER == 0
    then
        0321: explode_char_head $PATIENT2
        034F: remove_char_elegantly $PATIENT2
        00BC: print_now 'A_FAIL2' 3000 ms 1   // ~r~Your lack of urgency has been fatal to the patient!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT2 == 3
    then
        if
            03A3:   $PATIENT2 is_male
        then
            0004: $PED_SEX_FLAG = 0
        else
            0004: $PED_SEX_FLAG = 1
        end
        00A0: store_actor $PATIENT2 position_to $SOUND_X $SOUND_Y $SOUND_Z
        gosub @CHUNK1_AMBULANCE
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT2 == 1
    then
        if
            00FD:   player $PLAYER 0 near_actor $PATIENT2 in_car radius 10.0 10.0 2.0
        then
            gosub @CHUNK2_AMBULANCE
            if
                0038:   $CAR_FULL_FLAG == 0
            then
                01D4: actor $PATIENT2 go_to_car $PARAMEDIC_MISSION_CAR and_enter_it_as_a_passenger
                0004: $PARAMEDIC_CREATED_PATIENT2 = 2
            end
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT2 == 2
    then
        if
            80EB:   NOT   player $PLAYER 0 near_actor_in_car $PATIENT2 radius 25.0 25.0
        then
            0004: $PARAMEDIC_CREATED_PATIENT2 = 1
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT2 == 2
    then
        if
            00DF:   actor $PATIENT2 driving
        then
            0164: remove_blip $INJURED_PED_2_BLIP
            gosub @CHUNK3_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT2 = 3
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT2 == 3
    then
        if
            00FA:   player $PLAYER stopped 1 near_point_in_car $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z radius 6.0 6.0 2.0
        then
            01D3: actor $PATIENT2 leave_car $PARAMEDIC_MISSION_CAR
            0004: $PARAMEDIC_CREATED_PATIENT2 = 4
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT2 == 4
    then
        if
            80DF:   NOT   actor $PATIENT2 driving
        then
            0211: actor $PATIENT2 walk_to $PARAMEDIC_INSIDE_HOSPITAL_X $PARAMEDIC_INSIDE_HOSPITAL_Y
            01C2: remove_references_to_actor $PATIENT2  // Like turning an actor into a random pedestrian
            gosub @CHUNK4_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT2 = 0
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT3 > 0
then
    if
        0118:   actor $PATIENT3 dead
    then
        00BC: print_now 'A_FAIL3' 3000 ms 1   // ~r~The patient is dead!!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_MISSION_TIMER == 0
    then
        0321: explode_char_head $PATIENT3
        034F: remove_char_elegantly $PATIENT3
        00BC: print_now 'A_FAIL2' 3000 ms 1   // ~r~Your lack of urgency has been fatal to the patient!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT3 == 3
    then
        if
            03A3:   $PATIENT3 is_male
        then
            0004: $PED_SEX_FLAG = 0
        else
            0004: $PED_SEX_FLAG = 1
        end
        00A0: store_actor $PATIENT3 position_to $SOUND_X $SOUND_Y $SOUND_Z
        gosub @CHUNK1_AMBULANCE
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT3 == 1
    then
        if
            00FD:   player $PLAYER 0 near_actor $PATIENT3 in_car radius 10.0 10.0 2.0
        then
            gosub @CHUNK2_AMBULANCE
            if
                0038:   $CAR_FULL_FLAG == 0
            then
                01D4: actor $PATIENT3 go_to_car $PARAMEDIC_MISSION_CAR and_enter_it_as_a_passenger
                0004: $PARAMEDIC_CREATED_PATIENT3 = 2
            end
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT3 == 2
    then
        if
            80EB:   NOT   player $PLAYER 0 near_actor_in_car $PATIENT3 radius 25.0 25.0
        then
            0004: $PARAMEDIC_CREATED_PATIENT3 = 1
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT3 == 2
    then
        if
            00DF:   actor $PATIENT3 driving
        then
            0164: remove_blip $INJURED_PED_3_BLIP
            gosub @CHUNK3_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT3 = 3
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT3 == 3
    then
        if
            00FA:   player $PLAYER stopped 1 near_point_in_car $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z radius 6.0 6.0 2.0
        then
            01D3: actor $PATIENT3 leave_car $PARAMEDIC_MISSION_CAR
            0004: $PARAMEDIC_CREATED_PATIENT3 = 4
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT3 == 4
    then
        if
            80DF:   NOT   actor $PATIENT3 driving
        then
            0211: actor $PATIENT3 walk_to $PARAMEDIC_INSIDE_HOSPITAL_X $PARAMEDIC_INSIDE_HOSPITAL_Y
            01C2: remove_references_to_actor $PATIENT3  // Like turning an actor into a random pedestrian
            gosub @CHUNK4_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT3 = 0
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT4 > 0
then
    if
        0118:   actor $PATIENT4 dead
    then
        00BC: print_now 'A_FAIL3' 3000 ms 1   // ~r~The patient is dead!!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_MISSION_TIMER == 0
    then
        0321: explode_char_head $PATIENT4
        034F: remove_char_elegantly $PATIENT4
        00BC: print_now 'A_FAIL2' 3000 ms 1   // ~r~Your lack of urgency has been fatal to the patient!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT4 == 3
    then
        if
            03A3:   $PATIENT4 is_male
        then
            0004: $PED_SEX_FLAG = 0
        else
            0004: $PED_SEX_FLAG = 1
        end
        00A0: store_actor $PATIENT4 position_to $SOUND_X $SOUND_Y $SOUND_Z
        gosub @CHUNK1_AMBULANCE
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT4 == 1
    then
        if
            00FD:   player $PLAYER 0 near_actor $PATIENT4 in_car radius 10.0 10.0 2.0
        then
            gosub @CHUNK2_AMBULANCE
            if
                0038:   $CAR_FULL_FLAG == 0
            then
                01D4: actor $PATIENT4 go_to_car $PARAMEDIC_MISSION_CAR and_enter_it_as_a_passenger
                0004: $PARAMEDIC_CREATED_PATIENT4 = 2
            end
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT4 == 2
    then
        if
            80EB:   NOT   player $PLAYER 0 near_actor_in_car $PATIENT4 radius 25.0 25.0
        then
            0004: $PARAMEDIC_CREATED_PATIENT4 = 1
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT4 == 2
    then
        if
            00DF:   actor $PATIENT4 driving
        then
            0164: remove_blip $INJURED_PED_4_BLIP
            gosub @CHUNK3_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT4 = 3
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT4 == 3
    then
        if
            00FA:   player $PLAYER stopped 1 near_point_in_car $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z radius 6.0 6.0 2.0
        then
            01D3: actor $PATIENT4 leave_car $PARAMEDIC_MISSION_CAR
            0004: $PARAMEDIC_CREATED_PATIENT4 = 4
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT4 == 4
    then
        if
            80DF:   NOT   actor $PATIENT4 driving
        then
            0211: actor $PATIENT4 walk_to $PARAMEDIC_INSIDE_HOSPITAL_X $PARAMEDIC_INSIDE_HOSPITAL_Y
            01C2: remove_references_to_actor $PATIENT4  // Like turning an actor into a random pedestrian
            gosub @CHUNK4_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT4 = 0
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT5 > 0
then
    if
        0118:   actor $PATIENT5 dead
    then
        00BC: print_now 'A_FAIL3' 3000 ms 1   // ~r~The patient is dead!!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_MISSION_TIMER == 0
    then
        0321: explode_char_head $PATIENT5
        034F: remove_char_elegantly $PATIENT5
        00BC: print_now 'A_FAIL2' 3000 ms 1   // ~r~Your lack of urgency has been fatal to the patient!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT5 == 3
    then
        if
            03A3:   $PATIENT5 is_male
        then
            0004: $PED_SEX_FLAG = 0
        else
            0004: $PED_SEX_FLAG = 1
        end
        00A0: store_actor $PATIENT5 position_to $SOUND_X $SOUND_Y $SOUND_Z
        gosub @CHUNK1_AMBULANCE
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT5 == 1
    then
        if
            00FD:   player $PLAYER 0 near_actor $PATIENT5 in_car radius 10.0 10.0 2.0
        then
            gosub @CHUNK2_AMBULANCE
            if
                0038:   $CAR_FULL_FLAG == 0
            then
                01D4: actor $PATIENT5 go_to_car $PARAMEDIC_MISSION_CAR and_enter_it_as_a_passenger
                0004: $PARAMEDIC_CREATED_PATIENT5 = 2
            end
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT5 == 2
    then
        if
            80EB:   NOT   player $PLAYER 0 near_actor_in_car $PATIENT5 radius 25.0 25.0
        then
            0004: $PARAMEDIC_CREATED_PATIENT5 = 1
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT5 == 2
    then
        if
            00DF:   actor $PATIENT5 driving
        then
            0164: remove_blip $INJURED_PED_5_BLIP
            gosub @CHUNK3_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT5 = 3
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT5 == 3
    then
        if
            00FA:   player $PLAYER stopped 1 near_point_in_car $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z radius 6.0 6.0 2.0
        then
            01D3: actor $PATIENT5 leave_car $PARAMEDIC_MISSION_CAR
            0004: $PARAMEDIC_CREATED_PATIENT5 = 4
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT5 == 4
    then
        if
            80DF:   NOT   actor $PATIENT5 driving
        then
            0211: actor $PATIENT5 walk_to $PARAMEDIC_INSIDE_HOSPITAL_X $PARAMEDIC_INSIDE_HOSPITAL_Y
            01C2: remove_references_to_actor $PATIENT5  // Like turning an actor into a random pedestrian
            gosub @CHUNK4_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT5 = 0
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT6 > 0
then
    if
        0118:   actor $PATIENT6 dead
    then
        00BC: print_now 'A_FAIL3' 3000 ms 1   // ~r~The patient is dead!!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_MISSION_TIMER == 0
    then
        0321: explode_char_head $PATIENT6
        034F: remove_char_elegantly $PATIENT6
        00BC: print_now 'A_FAIL2' 3000 ms 1   // ~r~Your lack of urgency has been fatal to the patient!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT6 == 3
    then
        if
            03A3:   $PATIENT6 is_male
        then
            0004: $PED_SEX_FLAG = 0
        else
            0004: $PED_SEX_FLAG = 1
        end
        00A0: store_actor $PATIENT6 position_to $SOUND_X $SOUND_Y $SOUND_Z
        gosub @CHUNK1_AMBULANCE
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT6 == 1
    then
        if
            00FD:   player $PLAYER 0 near_actor $PATIENT6 in_car radius 10.0 10.0 2.0
        then
            gosub @CHUNK2_AMBULANCE
            if
                0038:   $CAR_FULL_FLAG == 0
            then
                01D4: actor $PATIENT6 go_to_car $PARAMEDIC_MISSION_CAR and_enter_it_as_a_passenger
                0004: $PARAMEDIC_CREATED_PATIENT6 = 2
            end
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT6 == 2
    then
        if
            80EB:   NOT   player $PLAYER 0 near_actor_in_car $PATIENT6 radius 25.0 25.0
        then
            0004: $PARAMEDIC_CREATED_PATIENT6 = 1
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT6 == 2
    then
        if
            00DF:   actor $PATIENT6 driving
        then
            0164: remove_blip $INJURED_PED_6_BLIP
            gosub @CHUNK3_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT6 = 3
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT6 == 3
    then
        if
            00FA:   player $PLAYER stopped 1 near_point_in_car $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z radius 6.0 6.0 2.0
        then
            01D3: actor $PATIENT6 leave_car $PARAMEDIC_MISSION_CAR
            0004: $PARAMEDIC_CREATED_PATIENT6 = 4
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT6 == 4
    then
        if
            80DF:   NOT   actor $PATIENT6 driving
        then
            0211: actor $PATIENT6 walk_to $PARAMEDIC_INSIDE_HOSPITAL_X $PARAMEDIC_INSIDE_HOSPITAL_Y
            01C2: remove_references_to_actor $PATIENT6  // Like turning an actor into a random pedestrian
            gosub @CHUNK4_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT6 = 0
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT7 > 0
then
    if
        0118:   actor $PATIENT7 dead
    then
        00BC: print_now 'A_FAIL3' 3000 ms 1   // ~r~The patient is dead!!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_MISSION_TIMER == 0
    then
        0321: explode_char_head $PATIENT7
        034F: remove_char_elegantly $PATIENT7
        00BC: print_now 'A_FAIL2' 3000 ms 1   // ~r~Your lack of urgency has been fatal to the patient!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT7 == 3
    then
        if
            03A3:   $PATIENT7 is_male
        then
            0004: $PED_SEX_FLAG = 0
        else
            0004: $PED_SEX_FLAG = 1
        end
        00A0: store_actor $PATIENT7 position_to $SOUND_X $SOUND_Y $SOUND_Z
        gosub @CHUNK1_AMBULANCE
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT7 == 1
    then
        if
            00FD:   player $PLAYER 0 near_actor $PATIENT7 in_car radius 10.0 10.0 2.0
        then
            gosub @CHUNK2_AMBULANCE
            if
                0038:   $CAR_FULL_FLAG == 0
            then
                01D4: actor $PATIENT7 go_to_car $PARAMEDIC_MISSION_CAR and_enter_it_as_a_passenger
                0004: $PARAMEDIC_CREATED_PATIENT7 = 2
            end
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT7 == 2
    then
        if
            80EB:   NOT   player $PLAYER 0 near_actor_in_car $PATIENT7 radius 25.0 25.0
        then
            0004: $PARAMEDIC_CREATED_PATIENT7 = 1
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT7 == 2
    then
        if
            00DF:   actor $PATIENT7 driving
        then
            0164: remove_blip $INJURED_PED_7_BLIP
            gosub @CHUNK3_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT7 = 3
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT7 == 3
    then
        if
            00FA:   player $PLAYER stopped 1 near_point_in_car $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z radius 6.0 6.0 2.0
        then
            01D3: actor $PATIENT7 leave_car $PARAMEDIC_MISSION_CAR
            0004: $PARAMEDIC_CREATED_PATIENT7 = 4
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT7 == 4
    then
        if
            80DF:   NOT   actor $PATIENT7 driving
        then
            0211: actor $PATIENT7 walk_to $PARAMEDIC_INSIDE_HOSPITAL_X $PARAMEDIC_INSIDE_HOSPITAL_Y
            01C2: remove_references_to_actor $PATIENT7  // Like turning an actor into a random pedestrian
            gosub @CHUNK4_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT7 = 0
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT8 > 0
then
    if
        0118:   actor $PATIENT8 dead
    then
        00BC: print_now 'A_FAIL3' 3000 ms 1   // ~r~The patient is dead!!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_MISSION_TIMER == 0
    then
        0321: explode_char_head $PATIENT8
        034F: remove_char_elegantly $PATIENT8
        00BC: print_now 'A_FAIL2' 3000 ms 1   // ~r~Your lack of urgency has been fatal to the patient!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT8 == 3
    then
        if
            03A3:   $PATIENT8 is_male
        then
            0004: $PED_SEX_FLAG = 0
        else
            0004: $PED_SEX_FLAG = 1
        end
        00A0: store_actor $PATIENT8 position_to $SOUND_X $SOUND_Y $SOUND_Z
        gosub @CHUNK1_AMBULANCE
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT8 == 1
    then
        if
            00FD:   player $PLAYER 0 near_actor $PATIENT8 in_car radius 10.0 10.0 2.0
        then
            gosub @CHUNK2_AMBULANCE
            if
                0038:   $CAR_FULL_FLAG == 0
            then
                01D4: actor $PATIENT8 go_to_car $PARAMEDIC_MISSION_CAR and_enter_it_as_a_passenger
                0004: $PARAMEDIC_CREATED_PATIENT8 = 2
            end
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT8 == 2
    then
        if
            80EB:   NOT   player $PLAYER 0 near_actor_in_car $PATIENT8 radius 25.0 25.0
        then
            0004: $PARAMEDIC_CREATED_PATIENT8 = 1
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT8 == 2
    then
        if
            00DF:   actor $PATIENT8 driving
        then
            0164: remove_blip $INJURED_PED_8_BLIP
            gosub @CHUNK3_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT8 = 3
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT8 == 3
    then
        if
            00FA:   player $PLAYER stopped 1 near_point_in_car $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z radius 6.0 6.0 2.0
        then
            01D3: actor $PATIENT8 leave_car $PARAMEDIC_MISSION_CAR
            0004: $PARAMEDIC_CREATED_PATIENT8 = 4
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT8 == 4
    then
        if
            80DF:   NOT   actor $PATIENT8 driving
        then
            0211: actor $PATIENT8 walk_to $PARAMEDIC_INSIDE_HOSPITAL_X $PARAMEDIC_INSIDE_HOSPITAL_Y
            01C2: remove_references_to_actor $PATIENT8  // Like turning an actor into a random pedestrian
            gosub @CHUNK4_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT8 = 0
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT9 > 0
then
    if
        0118:   actor $PATIENT9 dead
    then
        00BC: print_now 'A_FAIL3' 3000 ms 1   // ~r~The patient is dead!!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_MISSION_TIMER == 0
    then
        0321: explode_char_head $PATIENT9
        034F: remove_char_elegantly $PATIENT9
        00BC: print_now 'A_FAIL2' 3000 ms 1   // ~r~Your lack of urgency has been fatal to the patient!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT9 == 3
    then
        if
            03A3:   $PATIENT9 is_male
        then
            0004: $PED_SEX_FLAG = 0
        else
            0004: $PED_SEX_FLAG = 1
        end
        00A0: store_actor $PATIENT9 position_to $SOUND_X $SOUND_Y $SOUND_Z
        gosub @CHUNK1_AMBULANCE
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT9 == 1
    then
        if
            00FD:   player $PLAYER 0 near_actor $PATIENT9 in_car radius 10.0 10.0 2.0
        then
            gosub @CHUNK2_AMBULANCE
            if
                0038:   $CAR_FULL_FLAG == 0
            then
                01D4: actor $PATIENT9 go_to_car $PARAMEDIC_MISSION_CAR and_enter_it_as_a_passenger
                0004: $PARAMEDIC_CREATED_PATIENT9 = 2
            end
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT9 == 2
    then
        if
            80EB:   NOT   player $PLAYER 0 near_actor_in_car $PATIENT9 radius 25.0 25.0
        then
            0004: $PARAMEDIC_CREATED_PATIENT9 = 1
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT9 == 2
    then
        if
            00DF:   actor $PATIENT9 driving
        then
            0164: remove_blip $INJURED_PED_9_BLIP
            gosub @CHUNK3_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT9 = 3
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT9 == 3
    then
        if
            00FA:   player $PLAYER stopped 1 near_point_in_car $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z radius 6.0 6.0 2.0
        then
            01D3: actor $PATIENT9 leave_car $PARAMEDIC_MISSION_CAR
            0004: $PARAMEDIC_CREATED_PATIENT9 = 4
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT9 == 4
    then
        if
            80DF:   NOT   actor $PATIENT9 driving
        then
            0211: actor $PATIENT9 walk_to $PARAMEDIC_INSIDE_HOSPITAL_X $PARAMEDIC_INSIDE_HOSPITAL_Y
            01C2: remove_references_to_actor $PATIENT9  // Like turning an actor into a random pedestrian
            gosub @CHUNK4_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT9 = 0
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT10 > 0
then
    if
        0118:   actor $PATIENT10 dead
    then
        00BC: print_now 'A_FAIL3' 3000 ms 1   // ~r~The patient is dead!!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_MISSION_TIMER == 0
    then
        0321: explode_char_head $PATIENT10
        034F: remove_char_elegantly $PATIENT10
        00BC: print_now 'A_FAIL2' 3000 ms 1   // ~r~Your lack of urgency has been fatal to the patient!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT10 == 3
    then
        if
            03A3:   $PATIENT10 is_male
        then
            0004: $PED_SEX_FLAG = 0
        else
            0004: $PED_SEX_FLAG = 1
        end
        00A0: store_actor $PATIENT10 position_to $SOUND_X $SOUND_Y $SOUND_Z
        gosub @CHUNK1_AMBULANCE
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT10 == 1
    then
        if
            00FD:   player $PLAYER 0 near_actor $PATIENT10 in_car radius 10.0 10.0 2.0
        then
            gosub @CHUNK2_AMBULANCE
            if
                0038:   $CAR_FULL_FLAG == 0
            then
                01D4: actor $PATIENT10 go_to_car $PARAMEDIC_MISSION_CAR and_enter_it_as_a_passenger
                0004: $PARAMEDIC_CREATED_PATIENT10 = 2
            end
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT10 == 2
    then
        if
            80EB:   NOT   player $PLAYER 0 near_actor_in_car $PATIENT10 radius 25.0 25.0
        then
            0004: $PARAMEDIC_CREATED_PATIENT10 = 1
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT10 == 2
    then
        if
            00DF:   actor $PATIENT10 driving
        then
            0164: remove_blip $INJURED_PED_10_BLIP
            gosub @CHUNK3_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT10 = 3
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT10 == 3
    then
        if
            00FA:   player $PLAYER stopped 1 near_point_in_car $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z radius 6.0 6.0 2.0
        then
            01D3: actor $PATIENT10 leave_car $PARAMEDIC_MISSION_CAR
            0004: $PARAMEDIC_CREATED_PATIENT10 = 4
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT10 == 4
    then
        if
            80DF:   NOT   actor $PATIENT10 driving
        then
            0211: actor $PATIENT10 walk_to $PARAMEDIC_INSIDE_HOSPITAL_X $PARAMEDIC_INSIDE_HOSPITAL_Y
            01C2: remove_references_to_actor $PATIENT10  // Like turning an actor into a random pedestrian
            gosub @CHUNK4_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT10 = 0
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT11 > 0
then
    if
        0118:   actor $PATIENT11 dead
    then
        00BC: print_now 'A_FAIL3' 3000 ms 1   // ~r~The patient is dead!!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_MISSION_TIMER == 0
    then
        0321: explode_char_head $PATIENT11
        034F: remove_char_elegantly $PATIENT11
        00BC: print_now 'A_FAIL2' 3000 ms 1   // ~r~Your lack of urgency has been fatal to the patient!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT11 == 3
    then
        if
            03A3:   $PATIENT11 is_male
        then
            0004: $PED_SEX_FLAG = 0
        else
            0004: $PED_SEX_FLAG = 1
        end
        00A0: store_actor $PATIENT11 position_to $SOUND_X $SOUND_Y $SOUND_Z
        gosub @CHUNK1_AMBULANCE
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT11 == 1
    then
        if
            00FD:   player $PLAYER 0 near_actor $PATIENT11 in_car radius 10.0 10.0 2.0
        then
            gosub @CHUNK2_AMBULANCE
            if
                0038:   $CAR_FULL_FLAG == 0
            then
                01D4: actor $PATIENT11 go_to_car $PARAMEDIC_MISSION_CAR and_enter_it_as_a_passenger
                0004: $PARAMEDIC_CREATED_PATIENT11 = 2
            end
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT11 == 2
    then
        if
            80EB:   NOT   player $PLAYER 0 near_actor_in_car $PATIENT11 radius 25.0 25.0
        then
            0004: $PARAMEDIC_CREATED_PATIENT11 = 1
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT11 == 2
    then
        if
            00DF:   actor $PATIENT11 driving
        then
            0164: remove_blip $INJURED_PED_11_BLIP
            gosub @CHUNK3_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT11 = 3
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT11 == 3
    then
        if
            00FA:   player $PLAYER stopped 1 near_point_in_car $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z radius 6.0 6.0 2.0
        then
            01D3: actor $PATIENT11 leave_car $PARAMEDIC_MISSION_CAR
            0004: $PARAMEDIC_CREATED_PATIENT11 = 4
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT11 == 4
    then
        if
            80DF:   NOT   actor $PATIENT11 driving
        then
            0211: actor $PATIENT11 walk_to $PARAMEDIC_INSIDE_HOSPITAL_X $PARAMEDIC_INSIDE_HOSPITAL_Y
            01C2: remove_references_to_actor $PATIENT11  // Like turning an actor into a random pedestrian
            gosub @CHUNK4_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT11 = 0
        end
    end
end
if
    0018:   $PARAMEDIC_CREATED_PATIENT12 > 0
then
    if
        0118:   actor $PATIENT12 dead
    then
        00BC: print_now 'A_FAIL3' 3000 ms 1   // ~r~The patient is dead!!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_MISSION_TIMER == 0
    then
        0321: explode_char_head $PATIENT12
        034F: remove_char_elegantly $PATIENT12
        00BC: print_now 'A_FAIL2' 3000 ms 1   // ~r~Your lack of urgency has been fatal to the patient!
        jump @AMBULANCE_FAILED
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT12 == 3
    then
        if
            03A3:   $PATIENT12 is_male
        then
            0004: $PED_SEX_FLAG = 0
        else
            0004: $PED_SEX_FLAG = 1
        end
        00A0: store_actor $PATIENT12 position_to $SOUND_X $SOUND_Y $SOUND_Z
        gosub @CHUNK1_AMBULANCE
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT12 == 1
    then
        if
            00FD:   player $PLAYER 0 near_actor $PATIENT12 in_car radius 10.0 10.0 2.0
        then
            gosub @CHUNK2_AMBULANCE
            if
                0038:   $CAR_FULL_FLAG == 0
            then
                01D4: actor $PATIENT12 go_to_car $PARAMEDIC_MISSION_CAR and_enter_it_as_a_passenger
                0004: $PARAMEDIC_CREATED_PATIENT12 = 2
            end
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT12 == 2
    then
        if
            80EB:   NOT   player $PLAYER 0 near_actor_in_car $PATIENT12 radius 25.0 25.0
        then
            0004: $PARAMEDIC_CREATED_PATIENT12 = 1
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT12 == 2
    then
        if
            00DF:   actor $PATIENT12 driving
        then
            0164: remove_blip $INJURED_PED_12_BLIP
            gosub @CHUNK3_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT12 = 3
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT12 == 3
    then
        if
            00FA:   player $PLAYER stopped 1 near_point_in_car $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z radius 6.0 6.0 2.0
        then
            01D3: actor $PATIENT12 leave_car $PARAMEDIC_MISSION_CAR
            0004: $PARAMEDIC_CREATED_PATIENT12 = 4
        end
    end
    if
        0038:   $PARAMEDIC_CREATED_PATIENT12 == 4
    then
        if
            80DF:   NOT   actor $PATIENT12 driving
        then
            0211: actor $PATIENT12 walk_to $PARAMEDIC_INSIDE_HOSPITAL_X $PARAMEDIC_INSIDE_HOSPITAL_Y
            01C2: remove_references_to_actor $PATIENT12  // Like turning an actor into a random pedestrian
            gosub @CHUNK4_AMBULANCE
            0004: $PARAMEDIC_CREATED_PATIENT12 = 0
        end
    end
end
if
    003A:   $SAVED_PEDS == $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL
then
    0084: $SCORE_AM = $SAVED_PEDS
    0068: $SCORE_AM *= $PARAMEDIC_MISSION_LEVEL
    0010: $SCORE_AM *= 100
    01E3: text_1number_styled 'REWARD' $SCORE_AM 6000 ms 6   // REWARD $~1~
    0058: $PARAMEDIC_MISSIONS_DONE += $SAVED_PEDS
    if
        0038:   $AMBULANCE_PAGER_FLAG == 0
    then
        if
            0018:   $PARAMEDIC_MISSIONS_DONE > 34
        then
            014D: add_pager_message 'PAGEB13'  140  100  1   // Health delivered to hideout
            gosub @PROGRESS_COUNTER
            0004: $AMBULANCE_PAGER_FLAG = 1
        end
    end
    if
        0038:   $AMBULANCE_PAGER_FLAG == 1
    then
        if
            0018:   $PARAMEDIC_MISSIONS_DONE > 69
        then
            014D: add_pager_message 'PAGEB14'  140  100  1   // Adrenaline delivered to hideout
            gosub @PROGRESS_COUNTER
            0004: $AMBULANCE_PAGER_FLAG = 2
        end
    end
    0058: $SAVED_PEDS_THIS_GO += $SAVED_PEDS
    0008: $PARAMEDIC_PEOPLE_TO_SAVE_THIS_LEVEL += 1
    0004: $SAVED_PEDS = 0
    0004: $PED_COUNTER = 0
    0109: player $PLAYER money += $SCORE_AM
    0004: $HOSPITAL_BLIP_FLAG = 0
    0164: remove_blip $HOSPITAL_BLIP
    0164: remove_blip $INJURED_PED_1_BLIP
    0164: remove_blip $INJURED_PED_2_BLIP
    0164: remove_blip $INJURED_PED_3_BLIP
    0164: remove_blip $INJURED_PED_4_BLIP
    0164: remove_blip $INJURED_PED_5_BLIP
    0164: remove_blip $INJURED_PED_6_BLIP
    0164: remove_blip $INJURED_PED_7_BLIP
    0164: remove_blip $INJURED_PED_8_BLIP
    0164: remove_blip $INJURED_PED_9_BLIP
    0164: remove_blip $INJURED_PED_10_BLIP
    0164: remove_blip $INJURED_PED_11_BLIP
    0164: remove_blip $INJURED_PED_12_BLIP
    0403: save_highest_ambulance_level $PARAMEDIC_MISSION_LEVEL
    0008: $PARAMEDIC_MISSION_LEVEL += 1
    if
        0038:   $PARAMEDIC_MISSION_LEVEL == 13
    then
        00BA: text_styled 'A_COMP1' 5000 ms 5   // Paramedic missions complete!
        00BA: text_styled 'A_COMP2' 6000 ms 6   // You will never get tired!
        014D: add_pager_message 'A_COMP3'  140  100  1   // Paramedic missions complete! You will never get tired when running!
        0394: play_music 1
        0330: set_player $PLAYER infinite_run_to 1 (true)
        030C: set_mission_points += 1
        return
    end
    jump @MISSION_ROOT
end
jump @AMBULANCE_LOOP

:AMBULANCE_FAILED
014F: stop_timer $PARAMEDIC_MISSION_TIMER
03E6: remove_text_box
00BA: text_styled 'A_FAIL1' 5000 ms 5   // Paramedic mission ended.
01E3: text_1number_styled 'A_SAVES' $SAVED_PEDS_THIS_GO 6000 ms 6   // PEOPLE SAVED: ~1~
0004: $HOSPITAL_BLIP_FLAG = 0
0164: remove_blip $HOSPITAL_BLIP
0164: remove_blip $INJURED_PED_1_BLIP
0164: remove_blip $INJURED_PED_2_BLIP
0164: remove_blip $INJURED_PED_3_BLIP
0164: remove_blip $INJURED_PED_4_BLIP
0164: remove_blip $INJURED_PED_5_BLIP
0164: remove_blip $INJURED_PED_6_BLIP
0164: remove_blip $INJURED_PED_7_BLIP
0164: remove_blip $INJURED_PED_8_BLIP
0164: remove_blip $INJURED_PED_9_BLIP
0164: remove_blip $INJURED_PED_10_BLIP
0164: remove_blip $INJURED_PED_11_BLIP
0164: remove_blip $INJURED_PED_12_BLIP
03C7: set_wanted_multiplier 1.0
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_PARAMEDIC_MISSION = 0
mission_cleanup
return

:CHUNK1_AMBULANCE
0227: $AMBULANCE_HEALTH_NOW = car $PARAMEDIC_MISSION_CAR health
if
    001C:   $AMBULANCE_HEALTH_LAST > $AMBULANCE_HEALTH_NOW
then
    0084: $TIME_DROP = $AMBULANCE_HEALTH_LAST
    0060: $TIME_DROP -= $AMBULANCE_HEALTH_NOW
    0010: $TIME_DROP *= 50
    0060: $PARAMEDIC_MISSION_TIMER -= $TIME_DROP
    // VC treats these sounds differently than III
    if
        0038:   $PED_SEX_FLAG == 0
    then
        018C: play_sound 19 at $SOUND_X $SOUND_Y $SOUND_Z  // male pain
    else
        018C: play_sound 20 at $SOUND_X $SOUND_Y $SOUND_Z  // female pain
    end
    /*
    0209: $RANDOM_SCREAM = random_int 0 2
    if
        0038:   $PED_SEX_FLAG == 0
    then
        if
            0038:   $RANDOM_SCREAM == 0
        then
            018C: play_sound 17 at $SOUND_X $SOUND_Y $SOUND_Z   //unsure about sound numbers
        else
            018C: play_sound 18 at $SOUND_X $SOUND_Y $SOUND_Z
        end
    else
        if
            0038:   $RANDOM_SCREAM == 0
        then
            018C: play_sound 19 at $SOUND_X $SOUND_Y $SOUND_Z
        else
            018C: play_sound 20 at $SOUND_X $SOUND_Y $SOUND_Z
        end
    end
    */
    if
        001A:   0 > $PARAMEDIC_MISSION_TIMER
    then
        0004: $PARAMEDIC_MISSION_TIMER = 0
    end
    0084: $AMBULANCE_HEALTH_LAST = $AMBULANCE_HEALTH_NOW
end
return

:CHUNK2_AMBULANCE
01E9: $PEDS_IN_CAR = car $PARAMEDIC_MISSION_CAR num_passengers
01EA: $MAX_PEDS_IN_CAR = car $PARAMEDIC_MISSION_CAR max_passengers
if
    003A:   $PEDS_IN_CAR == $MAX_PEDS_IN_CAR
then
    00BC: print_now 'A_FULL' 5000 ms 1   // ~r~Ambulance full!!
    0004: $CAR_FULL_FLAG = 1
else
    0004: $CAR_FULL_FLAG = 0
end
0227: $AMBULANCE_HEALTH_LAST = car $PARAMEDIC_MISSION_CAR health
return

:CHUNK3_AMBULANCE
if
    0038:   $HOSPITAL_BLIP_FLAG == 0
then
    018A: $HOSPITAL_BLIP = create_checkpoint_at $PARAMEDIC_CHECKPOINT_X $PARAMEDIC_CHECKPOINT_Y $PARAMEDIC_CHECKPOINT_Z
    0004: $HOSPITAL_BLIP_FLAG = 1
end
0084: $TIME_CHUNK_IN_SECS = $TIME_CHUNK
0014: $TIME_CHUNK_IN_SECS /= 1000
01E3: text_1number_styled 'A_TIME' $TIME_CHUNK_IN_SECS 6000 ms 6   // +~1~ seconds
0058: $PARAMEDIC_MISSION_TIMER += $TIME_CHUNK
return

:CHUNK4_AMBULANCE
00BA: text_styled 'A_PASS' 3000 ms 5   // Rescued!
if
    0038:   $BONUS_TIME_FLAG == 1
then
    0084: $TIME_CHUNK_IN_SECS = $TIME_CHUNK
    0014: $TIME_CHUNK_IN_SECS /= 1000
    01E3: text_1number_styled 'A_TIME' $TIME_CHUNK_IN_SECS 6000 ms 6   // +~1~ seconds
    00DA: $PARAMEDIC_MISSION_CAR = player $PLAYER car
    0227: $PARAMEDIC_CAR_HEALTH = car $PARAMEDIC_MISSION_CAR health
    0008: $PARAMEDIC_CAR_HEALTH += 110
    0224: set_car $PARAMEDIC_MISSION_CAR health_to $PARAMEDIC_CAR_HEALTH
    0058: $PARAMEDIC_MISSION_TIMER += $TIME_CHUNK
    0008: $BONUS_TIME_FLAG += 1
end
018C: play_sound 1 at 0.0 0.0 0.0
0008: $SAVED_PEDS += 1
0401: increment_people_saved_in_ambulance
return

:PROGRESS_COUNTER
030C: set_mission_points += 1
return
