//-------------Mission 46-------------
// Originally: Asuka mission 3 'PAPARAZZI PURGE'

:M46_PAPARAZZIPURGE
03A4: name_thread 'ASUKA3'
054C: use_GXT_table 'ASU3'
058E: set_restart_mission_taxi_destination 118.24 -684.80 21.96 angle 181.0
gosub @MISSION_START_ASUKA3
if
    wasted_or_busted
then
    gosub @MISSION_ASUKA3_FAILED
end
gosub @MISSION_CLEANUP_ASUKA3
end_thread

:MISSION_START_ASUKA3
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_ASUKA1 = 1
0004: $HELP1_DISPLAYED = 0
0004: $HELP2_DISPLAYED = 0
wait 0 ms
0004: $BEEN_IN_COP_BOAT_BEFORE = 0
023C: load_special_actor 1 'PLAYER'
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'NOTE'
0247: request_model #REEFER
0247: request_model #SPEEDER
0247: request_model #PREDATOR
0247: request_model #STALLION
0247: request_model #CONDO_IVY
0247: request_model #KMRICNDO01
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CONDO_IVY available
        8248:   NOT   model #KMRICNDO01 available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'A2_PP'
0244: set_cutscene_pos 188.062 -636.938 21.5625
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
02E5: $CS_NOTE = create_cutscene_object #CUTOBJ02
02E6: set_cutscene_anim $CS_NOTE 'NOTE'
0395: clear_area 1 at 188.562 -639.375 22.5625 range 1.0
0055: set_player_coordinates $PLAYER at 188.562 -639.375 22.0
0171: set_player $PLAYER z_angle_to 180.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   3406 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM3_A' 10000 ms 1   // // A reporter has been nosing around.
while 001A:   5677 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM3_B' 10000 ms 1   // // Maria and I have taken a little holiday together until you can get rid of this perverted voyeur.
while 001A:   11354 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM3_C' 10000 ms 1   // // He's probably out in the bay as you read this! Steal a police boat and sink his career!
while 001A:   16000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
03AD: set_rubbish 1 (visible)
02EA: clear_cutscene
03C8: set_camera_in_front_of_player
wait 1000 ms
016A: fade 1 (back)  1500 ms
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CONDO_IVY
0249: mark_model_as_no_longer_needed #KMRICNDO01
0296: unload_special_actor 1
while true
    if or
        8248:   NOT   model #SPEEDER available
        8248:   NOT   model #STALLION available
        8248:   NOT   model #PREDATOR available
        8248:   NOT   model #REEFER available
    jf break
    wait 0 ms
end
0395: clear_area 1 at 305.0 -608.0 6.0 range 6.0
00A5: $SPY_BOAT = create_car #SPEEDER at 277.0 -597.0 6.0
0175: set_car $SPY_BOAT z_angle_to 0.0
02AA: set_car $SPY_BOAT immune_to_nonplayer 1
0224: set_car $SPY_BOAT health_to 1500
03AB: set_vehicle $SPY_BOAT strong 1
0129: $SPY_BLOKE = create_actor 4 #MALE01 in_car $SPY_BOAT driverseat
0395: clear_area 1 at 233.0 -686.0 6.0 range 6.0
00A5: $ASUKA_BOAT = create_car #REEFER at 233.0 -686.0 6.0
0175: set_car $ASUKA_BOAT z_angle_to 180.0
0395: clear_area 1 at 219.75 -767.562 6.0 range 6.0
00A5: $COP_BOAT = create_car #PREDATOR at 219.75 -767.562 6.0
0186: $BLIP1_AS3 = create_marker_above_car $COP_BOAT
if
    8118:   NOT   actor $SPY_BLOKE dead
then
    0187: $BLIP2_AS3 = create_marker_above_actor $SPY_BLOKE
    018B: change_blip $BLIP2_AS3 display 1
end
wait 1500 ms
01B4: set_player $PLAYER can_move 0 (frozen)
02A3: toggle_widescreen 1 (on)
015F: set_camera_position 191.0 -643.25 25.5625 0.0 0.0 0.0
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    0158: camera_on_vehicle $SPY_BOAT 15 2
end
wait 3000 ms
01B4: set_player $PLAYER can_move 1 (unfrozen)
02A3: toggle_widescreen 0 (off)
015A: restore_camera
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    0227: $BOAT_HEALTH = car $SPY_BOAT health
    03C4: set_status_text_to $BOAT_HEALTH 1 (bar)  'DAM'   // // Damage
    gosub @BOAT_HEALTH
end
0006: 17@ = 0

while true
    if and
        81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 55.0 55.0 0
        0185:   car $SPY_BOAT health >= 1499
    jf break
    wait 0 ms
    if
        0038:   $HELP1_DISPLAYED == 0
    then
        if
            0019:   17@ > 4000
        then
            if
                82BD:   NOT   debug_mode == DEBUG_SKIPHELP
            then
                // Code fixed
                0293: $CONTROLMODE = current_controls
                if
                    0038:   $CONTROLMODE == 2
                then
                    03E5: text_box 'BOATIN3'   // // Jump into a boat and press the ~h~~k~~VEHICLE_ENTER_EXIT~ button ~w~to get in.
                else
                    03E5: text_box 'BOATIN1'   // // Jump into a boat and press the ~h~~k~~VEHICLE_ENTER_EXIT~ button ~w~to get in.
                end
            end
            0004: $HELP1_DISPLAYED = 1
        end
    end
    if
        0038:   $HELP2_DISPLAYED == 0
    then
        if
            0019:   17@ > 11000
        then
            // Code fixed
            0293: $CONTROLMODE = current_controls
            if
                0038:   $CONTROLMODE == 2
            then
                03E5: text_box 'BOATIN4'   // // You can press the ~h~~k~~VEHICLE_ENTER_EXIT~ button ~w~if you are near a boat to get in it.
            else
                03E5: text_box 'BOATIN2'   // // You can press the ~h~~k~~VEHICLE_ENTER_EXIT~ button ~w~if you are near a boat to get in it.
            end
            0004: $HELP2_DISPLAYED = 1
        end
    end
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02AA: set_car $SPY_BOAT immune_to_nonplayer 0
    02DB: set_boat $SPY_BOAT speed_to 48.0
end
wait 0 ms
//LOCATION1
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 409.75 -350.062 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 409.75 -350.062 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION2
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 393.875 -133.688 6.0
    02DB: set_boat $SPY_BOAT speed_to 45.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 393.875 -133.688 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION3
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 300.5 24.6875 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 300.5 24.6875 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION4
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 411.562 252.875 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 411.562 252.875 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION5
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 537.062 335.875 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 537.062 335.875 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION6
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 729.5 180.75 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 729.5 180.75 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION7
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 927.0 166.0 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 927.0 166.0 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION8
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 1231.0 52.0 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 1231.0 52.0 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LCOATION9
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 1260.0 -154.0 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 1260.0 -154.0 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION10
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 1220.0 -299.0 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 1220.0 -299.0 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION11
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 1282.0 -600.0 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 1282.0 -600.0 6.0 radius 5.0 5.0 5.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION12
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 1282.0 -762.0 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 1282.0 -762.0 6.0 radius 5.0 5.0 5.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION13
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 1302.0 -950.0 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 1302.0 -950.0 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION14
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 1200.0 -1173.0 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 1200.0 -1173.0 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION15
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 933.0 -1273.0 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 933.0 -1273.0 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION16
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02D3: boat $SPY_BOAT drive_to 603.062 -1226.38 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 603.062 -1226.38 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION17
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02DB: set_boat $SPY_BOAT speed_to 45.0
    02D3: boat $SPY_BOAT drive_to 283.0 -1083.0 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 283.0 -1083.0 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION18
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02DB: set_boat $SPY_BOAT speed_to 35.0
    02D3: boat $SPY_BOAT drive_to 225.0 -899.0 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 225.0 -899.0 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
//LOCATION19
if
    8119:   NOT   car $SPY_BOAT wrecked
then
    02DB: set_boat $SPY_BOAT speed_to 20.0
    02D3: boat $SPY_BOAT drive_to 213.0 -795.0 6.0
end
while 81AF:   NOT   car $SPY_BOAT 0 near_point 213.0 -795.0 6.0 radius 6.0 6.0 6.0
    wait 0 ms
    if or
        0119:   car $SPY_BOAT wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_BOAT radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_BOAT wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_BOAT
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
    if
        8119:   NOT   car $SPY_BOAT wrecked
    then
        gosub @BOAT_HEALTH
    end
end //while
wait 1000 ms
if and
    8119:   NOT   car $SPY_BOAT wrecked
    8118:   NOT   actor $SPY_BLOKE dead
then
    02D4: boat_stop $SPY_BOAT engine
    0323: anchor_boat $SPY_BOAT flag 1
    0362: remove_actor $SPY_BLOKE from_car_and_place_at 212.25 -778.375 -100.0
    0151: remove_status_text $BOAT_HEALTH
end
00A5: $SPY_CAR = create_car #STALLION at 164.688 -734.375 -100.0
0175: set_car $SPY_CAR z_angle_to 90.0
0319: set_actor $SPY_BLOKE running 1
0239: actor $SPY_BLOKE run_to 175.0 -775.562
while 8126:   NOT   actor $SPY_BLOKE walking
    wait 0 ms
    if
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    gosub @CHECK_BOATS_DEAD
end //while
0239: actor $SPY_BLOKE run_to 170.188 -751.062
while 8126:   NOT   actor $SPY_BLOKE walking
    wait 0 ms
    if
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    gosub @CHECK_BOATS_DEAD
end
0239: actor $SPY_BLOKE run_to 166.062 -749.5
while 8126:   NOT   actor $SPY_BLOKE walking
    wait 0 ms
    if
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    gosub @CHECK_BOATS_DEAD
end
if
    8119:   NOT   car $SPY_CAR wrecked
then
    01D5: actor $SPY_BLOKE go_to_and_drive_car $SPY_CAR
end
while 80DB:   NOT   actor $SPY_BLOKE in_car $SPY_CAR
    wait 0 ms
    if
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if and
        0119:   car $SPY_CAR wrecked
        8118:   NOT   actor $SPY_BLOKE dead
    then
        jump @IS_HE_DEAD_YET
    end
    gosub @CHECK_BOATS_DEAD
end
if
    8119:   NOT   car $SPY_CAR wrecked
then
    02C2: car $SPY_CAR drive_to_point 128.0 -727.375 22.0625
    00AF: set_car $SPY_CAR mission 13  // MISSION_GOTOCOORDS_STRAIGHT_ACCURATE
    00AE: set_car $SPY_CAR driving_style 1  // DRIVINGMODE_SLOWDOWNFORCARS
    00AD: set_car $SPY_CAR max_speed_to 15.0
end
while 81AF:   NOT   car $SPY_CAR 0 near_point 128.0 -727.375 22.0625 radius 3.0 3.0 3.0
    wait 0 ms
    if or
        0119:   car $SPY_CAR wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        80DB:   NOT   actor $SPY_BLOKE in_car $SPY_CAR
    then
        jump @IS_HE_DEAD_YET
    end
    if
        8119:   NOT   car $SPY_CAR wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_CAR radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_CAR wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_CAR
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
end
if
    8119:   NOT   car $SPY_CAR wrecked
then
    02C2: car $SPY_CAR drive_to_point 121.0 -707.062 22.0
    00AF: set_car $SPY_CAR mission 13  // MISSION_GOTOCOORDS_STRAIGHT_ACCURATE
end
while 81AF:   NOT   car $SPY_CAR 0 near_point 121.0 -707.062 22.0 radius 3.0 3.0 3.0
    wait 0 ms
    if or
        0119:   car $SPY_CAR wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        80DB:   NOT   actor $SPY_BLOKE in_car $SPY_CAR
    then
        jump @IS_HE_DEAD_YET
    end
    if
        8119:   NOT   car $SPY_CAR wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_CAR radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_CAR wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_CAR
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
end
if
    8119:   NOT   car $SPY_CAR wrecked
then
    02C2: car $SPY_CAR drive_to_point 124.0 -678.062 22.0
    00AF: set_car $SPY_CAR mission 13  // MISSION_GOTOCOORDS_STRAIGHT_ACCURATE
end
while 81AF:   NOT   car $SPY_CAR 0 near_point 124.0 -678.062 22.0 radius 3.0 3.0 3.0
    wait 0 ms
    if or
        0119:   car $SPY_CAR wrecked
        0118:   actor $SPY_BLOKE dead
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        80DB:   NOT   actor $SPY_BLOKE in_car $SPY_CAR
    then
        jump @IS_HE_DEAD_YET
    end
    if
        8119:   NOT   car $SPY_CAR wrecked
    then
        if
            81FC:   NOT   player $PLAYER near_car $SPY_CAR radius 160.0 160.0 0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if and
                8119:   NOT   car $SPY_CAR wrecked
                8118:   NOT   actor $SPY_BLOKE dead
            then
                00A6: destroy_car $SPY_CAR
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
end //while
if
    8119:   NOT   car $SPY_CAR wrecked
then
    00A8: set_car $SPY_CAR to_psycho_driver
    00AE: set_car $SPY_CAR driving_style 2  // DRIVINGMODE_AVOIDCARS
    00AD: set_car $SPY_CAR max_speed_to 25.0
end
while 8118:   NOT   actor $SPY_BLOKE dead
    wait 0 ms
    if
        8118:   NOT   actor $SPY_BLOKE dead
    then
        if
            80E9:   NOT   player $PLAYER 0 near_actor $SPY_BLOKE radius 160.0 160.0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if
                8118:   NOT   actor $SPY_BLOKE dead
            then
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    if
        0119:   car $SPY_CAR wrecked
    then
        jump @MISSION_ASUKA3_PASSED
    end
    if
        80DB:   NOT   actor $SPY_BLOKE in_car $SPY_CAR
    then
        jump @IS_HE_DEAD_YET
    end
    gosub @CHECK_BOATS_DEAD
end //while

:IS_HE_DEAD_YET
01D0: actor $SPY_BLOKE avoid_player $PLAYER

while 8118:   NOT   actor $SPY_BLOKE dead
    wait 0 ms
    if
        8118:   NOT   actor $SPY_BLOKE dead
    then
        if
            80E9:   NOT   player $PLAYER 0 near_actor $SPY_BLOKE radius 160.0 160.0
        then
            00BC: print_now 'AWAY' 5000 ms 2   // // ~r~He's clean out of here!
            if
                8118:   NOT   actor $SPY_BLOKE dead
            then
                009B: destroy_actor_instantly $SPY_BLOKE
            end
            jump @MISSION_ASUKA3_FAILED
        end
    end
    gosub @CHECK_BOATS_DEAD
end
jump @MISSION_ASUKA3_PASSED

:MISSION_ASUKA3_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // // MISSION FAILED!
return

:MISSION_ASUKA3_PASSED
0151: remove_status_text $BOAT_HEALTH
0004: $PAPARAZZI_PURGE_COMPLETED = 1
0394: play_music 1
01E3: text_1number_styled 'M_PASS' 10000 5000 ms 1   // // MISSION PASSED! $~1~
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 10000
0318: set_latest_mission_passed 'AM3'   // // 'PAPARAZZI PURGE'
030C: set_mission_points += 1
004F: create_thread @ASUKA_MISSION4_LOOP
return

:MISSION_CLEANUP_ASUKA3
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_ASUKA1 = 0
0164: remove_blip $BLIP1_AS3
0164: remove_blip $BLIP2_AS3
0249: mark_model_as_no_longer_needed #SPEEDER
0249: mark_model_as_no_longer_needed #REEFER
0249: mark_model_as_no_longer_needed #PREDATOR
0249: mark_model_as_no_longer_needed #STALLION
0151: remove_status_text $BOAT_HEALTH
mission_cleanup
return

:BOAT_HEALTH
0227: $BOAT_HEALTH = car $SPY_BOAT health
0004: $BOAT_HEALTH2 = 1500
0060: $BOAT_HEALTH2 -= $BOAT_HEALTH
if
    0018:   $BOAT_HEALTH2 > 1500
then
    0004: $BOAT_HEALTH2 = 1500
end
0084: $BOAT_HEALTH = $BOAT_HEALTH2
0014: $BOAT_HEALTH /= 15
return

:CHECK_BOATS_DEAD
if
    8119:   NOT   car $COP_BOAT wrecked
then
    if and
        00DC:   player $PLAYER driving $COP_BOAT
        0038:   $BEEN_IN_COP_BOAT_BEFORE == 0
    then
        // Code made compatible with GInput
        0293: $CONTROLMODE = current_controls
        if
            0038:   $CONTROLMODE == 2
        then
            // Text altered for GInput
            03E5: text_box 'PBOAT_2'   // Press  ~c~  to fire the boat cannons.
        else
            if
                0038:   $CONTROLMODE == 4
            then
                // New text for GInput
                03E5: text_box 'PBOAT_3'   // Press  ~i~  to fire the boat cannons.
            else
                03E5: text_box 'PBOAT_1'   // Press the ~h~~k~~PED_FIREWEAPON~ button~w~ to fire the boat cannons.
            end
        end
        0164: remove_blip $BLIP1_AS3
        0004: $BEEN_IN_COP_BOAT_BEFORE = 1
    end
else
    if
        0038:   $BEEN_IN_COP_BOAT_BEFORE == 0
    then
        0164: remove_blip $BLIP1_AS3
        0004: $BEEN_IN_COP_BOAT_BEFORE = 1
    end
end
return
