//-------------Mission 72-------------
// Originally: Asuka Suburban Mission 2 'ESPRESSO-2-GO!'

:M72_ESPRESSO2GO
03A4: name_thread 'ASUSB2'
054C: use_GXT_table 'ASU7'
058E: set_restart_mission_taxi_destination 26.0 -398.2 27.64 90.0
gosub @MISSION_START_AS2
if
    wasted_or_busted
then
    gosub @MISSION_AS2_FAILED
end
gosub @MISSION_CLEANUP_AS2
end_thread

:MISSION_START_AS2
increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_ASUKA2 = 1
wait 0 ms
0004: $FLAG_KAPPA1_DEAD = 0
0004: $FLAG_KAPPA2_DEAD = 0
0004: $FLAG_KAPPA3_DEAD = 0
0004: $FLAG_KAPPA4_DEAD = 0
0004: $FLAG_KAPPA5_DEAD = 0
0004: $FLAG_KAPPA6_DEAD = 0
0004: $FLAG_KAPPA7_DEAD = 0
0004: $FLAG_KAPPA8_DEAD = 0
0004: $FLAG_KAPPA9_DEAD = 0
0004: $FLAG_KAPPA10_DEAD = 0
0004: $FLAG_KAPPA11_DEAD = 0
0004: $FLAG_KAPPA12_DEAD = 0

0004: $FLAG_KAPPA1_CREATED = 0
0004: $FLAG_KAPPA2_CREATED = 0
0004: $FLAG_KAPPA3_CREATED = 0
0004: $FLAG_KAPPA4_CREATED = 0
0004: $FLAG_KAPPA5_CREATED = 0
0004: $FLAG_KAPPA6_CREATED = 0
0004: $FLAG_KAPPA7_CREATED = 0
0004: $FLAG_KAPPA8_CREATED = 0
0004: $FLAG_KAPPA9_CREATED = 0
0004: $FLAG_KAPPA10_CREATED = 0
0004: $FLAG_KAPPA11_CREATED = 0
0004: $FLAG_KAPPA12_CREATED = 0

0004: $BLIP_KAPPA1_CREATED = 0
0004: $BLIP_KAPPA2_CREATED = 0
0004: $BLIP_KAPPA3_CREATED = 0
0004: $BLIP_KAPPA4_CREATED = 0
0004: $BLIP_KAPPA5_CREATED = 0
0004: $BLIP_KAPPA6_CREATED = 0
0004: $BLIP_KAPPA7_CREATED = 0
0004: $BLIP_KAPPA8_CREATED = 0
0004: $BLIP_KAPPA9_CREATED = 0
0004: $BLIP_KAPPA10_CREATED = 0
0004: $BLIP_KAPPA11_CREATED = 0
0004: $BLIP_KAPPA12_CREATED = 0

0004: $COUNTER_KAPPA_DEAD = 0

0004: $PARTICLE_TIME_AS2 = 0

0004: $COUNTER_KAPPA_DEAD_IND = 0
0004: $COUNTER_KAPPA_DEAD_COM = 0
0004: $COUNTER_KAPPA_DEAD_SUB = 0

0004: $FLAG_AS2_1 = 0
0004: $FLAG_AS2_2 = 0
0004: $FLAG_AS2_3 = 0
0004: $FLAG_PARTICLE_AS2 = 0

0004: $FLAG_GUARD1_CREATED = 0

0004: $FLAG_TIMER_STARTED = 0

0005: $KAPPA1_X = 1007.0  // DOCK ENTRANCE
0005: $KAPPA1_Y = -821.0

0005: $KAPPA2_X = 689.1  // TUBE STATION - //never used
0005: $KAPPA2_Y = -465.57

0005: $KAPPA3_X = 1016.22  // ST MARKS
0005: $KAPPA3_Y = -259.56

0005: $KAPPA4_X = -48.6  // NEWPORT
0005: $KAPPA4_Y = -667.8

0005: $KAPPA5_X = -307.0  // PARK
0005: $KAPPA5_Y = -850.0

0005: $KAPPA6_X = -320.84  // BED POINT
0005: $KAPPA6_Y = -1140.0

0005: $KAPPA7_X = -261.84  // BED POINT
0005: $KAPPA7_Y = -1359.8

0005: $KAPPA8_X = -556.0  // ASPATRIA - //never used
0005: $KAPPA8_Y = -197.0

0005: $KAPPA9_X = -52.2  // TORRINGTON
0005: $KAPPA9_Y = -1492.4

0005: $KAPPA10_X = -979.0  // AIRPORT
0005: $KAPPA10_Y = -721.5

0005: $KAPPA11_X = -547.0  // CEDAR GROVE - //never used
0005: $KAPPA11_Y = 310.0

0005: $KAPPA12_X = -1590.0  // PIKE CREEK
0005: $KAPPA12_Y = -113.0
if
    02BD:   debug_mode == DEBUG_MASTEREXTRAS2
then
    $TOTAL_ESPRESSO_STANDS = 12
    $KAPPA_TIME = 650000   // 11 minutes
    $KAPPA_TIME_MIN = 11
    $TOTAL_STANDS_IND = 3
    $TOTAL_STANDS_COM = 6
    $TOTAL_STANDS_SUB = 3
    $ESPRESSO_2_GO_REWARD = 55000
else
    $TOTAL_ESPRESSO_STANDS = 9
    $KAPPA_TIME = 470000  // 8 minutes
    $KAPPA_TIME_MIN = 8
    $TOTAL_STANDS_IND = 2
    $TOTAL_STANDS_COM = 5
    $TOTAL_STANDS_SUB = 2
    $ESPRESSO_2_GO_REWARD = 40000
end
0247: request_model #CSITECUTSCENE
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'ASUKA'
023C: load_special_actor 3 'MIGUEL'
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'ASUKAH'
02F3: load_object #CUTOBJ03 'WHIP'
038B: load_all_models_now
while 8248:   NOT   model #CSITECUTSCENE available
    wait 0 ms
end
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        823D:   NOT   special_actor 3 loaded
    jf break
    wait 0 ms
end
while true
    if or
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CUTOBJ03 available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'A7_ETG'
03AF: set_streaming 1 (enabled)
0244: set_cutscene_pos 34.0 -327.5 24.4375
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_ASUKA = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_ASUKA 'ASUKA'
02E5: $INTRO_MIGUEL = create_cutscene_object #SPECIAL03
02E6: set_cutscene_anim $INTRO_MIGUEL 'MIGUEL'
02E5: $CS_WHIP = create_cutscene_object #CUTOBJ03
02E6: set_cutscene_anim $CS_WHIP 'WHIP'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
//02F4: create_cutscene_actor $ASUKA_CSHEAD _from_head #CUTOBJ02 _and_body  $CUTSCENE_ASUKA
//02F5: set_head_anim $ASUKA_CSHEAD 'ASUKA'
0055: set_player_coordinates $PLAYER at 38.75 -327.25 23.1875
0171: set_player $PLAYER z_angle_to 270.0
016A: fade 1 (back)  250 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 0 (disabled)
03B7: process_cut_scene_only 0 (true)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   3445 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AS2_A1' 10000 ms 1   // // ~w~Miguel certainly has some of that famous Latin stamina.
while 001A:   7961 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AS2_A2' 10000 ms 1   // // ~w~I'm quite exhausted.
while 001A:   9836 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AS2_A' 10000 ms 1   // // ~w~We underestimated Catalina's plans for SPANK.
while 001A:   13013 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AS2_B' 10000 ms 1   // // ~w~It reaches far beyond the Yardies selling it on the street corners.
while 001A:   16802 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AS2_C' 10000 ms 1   // // ~w~The Cartel have a front company The Kappa Coffee House.
while 001A:   20591 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AS2_D' 10000 ms 1   // // ~w~They've been selling SPANK through the street stalls.
while 001A:   23499 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AS2_E' 10000 ms 1   // // ~w~We have no choice but to put these drug stands out of operation.
while 001A:   27594 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AS2_F' 10000 ms 1   // // ~w~Smash them to splinters!!
while 001A:   30000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
016A: fade 0  0 ms
0373: set_camera_directly_behind_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
0296: unload_special_actor 2
0296: unload_special_actor 3
0249: mark_model_as_no_longer_needed #CSITECUTSCENE
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CUTOBJ03
03AD: set_rubbish 1 (visible)
03AF: set_streaming 1 (enabled)
03B7: process_cut_scene_only 1 (false)
03C4: set_status_text_to $COUNTER_KAPPA_DEAD 0  'KILLS'   // // KILLS:
01BD: $TIMER_AS2_START = current_time_in_ms
00BC: print_now 'AS2_12' 5000 ms 1   // // ~g~Cruise Liberty's districts to find ~b~Espresso-2-Go stalls!
01E6: print_with_number_soon 'AS2_12A' $KAPPA_TIME_MIN 5000 ms 1   // // ~g~After you trash the first stall you will have ~1~ minutes before the Cartel warn their pushers!
0237: set_gang 0 primary_weapon_to 17 secondary_weapon_to 23
0247: request_model #COFFEE
0247: request_model #COLUMB
0247: request_model #GANG11
0247: request_model #GANG12
0247: request_model #UZI
0247: request_model #SHOTGUN
while true
    if or
        8248:   NOT   model #COFFEE available
        8248:   NOT   model #COLUMB available
        8248:   NOT   model #GANG11 available
        8248:   NOT   model #GANG12 available
        8248:   NOT   model #UZI available
        8248:   NOT   model #SHOTGUN available
    jf break
    wait 0 ms
end
while 001C:   $TOTAL_ESPRESSO_STANDS > $COUNTER_KAPPA_DEAD
    wait 0 ms
    //-------------------------------------------CREATE KAPPAS------------------------------------------------------------------------------------
    if
        03C6:   is_collision_in_memory 1
    then
        if
            0038:   $FLAG_KAPPA1_CREATED == 0
        then
            if
                00E3:   player $PLAYER 0 near_point $KAPPA1_X $KAPPA1_Y radius 150.0 150.0
            then
                009A: $KAPPA_CARTEL1 = create_actor 12 #GANG11 at $KAPPA1_X $KAPPA1_Y -100.0
                011A: set_actor $KAPPA_CARTEL1 flags 1
                01B2: give_actor $KAPPA_CARTEL1 weapon 23 ammo 60  // Load the weapon model before using this
                0350: set_char_stay_in_same_place $KAPPA_CARTEL1  1
                0107: $KAPPA_1 = create_object #COFFEE at $KAPPA1_X $KAPPA1_Y -100.0
                0177: set_object $KAPPA_1 z_angle_to 180.0
                0382: set_object $KAPPA_1 collision_detection 1
                0392: object $KAPPA_1 toggle_in_moving_list 0
                if
                    0038:   $BLIP_KAPPA1_CREATED == 0
                then
                    0188: $BLIP_KAPPA1 = create_marker_above_object $KAPPA_1
                    0004: $BLIP_KAPPA1_CREATED = 1
                end
                0004: $FLAG_KAPPA1_CREATED = 1
            end
        end
        if
            02BD:   debug_mode == DEBUG_MASTEREXTRAS2
        then
            if
                $FLAG_KAPPA2_CREATED == 0
            then
                if
                    00E3:   player $PLAYER 0 near_point $KAPPA2_X $KAPPA2_Y radius 70.0 70.0
                 then
                    009A: $KAPPA_CARTEL2 = create_actor 12 #GANG11 at $KAPPA2_X $KAPPA2_Y -100.0
                    //0173: set_actor $KAPPA_CARTEL2 z_angle_to 270.0
                    011A: set_actor $KAPPA_CARTEL2 flags 1
                    01B2: give_actor $KAPPA_CARTEL2 weapon 23 ammo 60
                    0350: set_char_stay_in_same_place $KAPPA_CARTEL2  1
                    0107: $KAPPA_2 = create_object #COFFEE at $KAPPA2_X $KAPPA2_Y -100.0
                    0177: set_object $KAPPA_2 z_angle_to 270.0
                    0382: set_object $KAPPA_2 collision_detection 1
                    0392: object $KAPPA_2 toggle_in_moving_list 0
                    if
                        $BLIP_KAPPA2_CREATED == 0
                    then
                        0188: $BLIP_KAPPA2 = create_marker_above_object $KAPPA_2
                        $BLIP_KAPPA2_CREATED = 1
                    end
                    $FLAG_KAPPA2_CREATED = 1
                end
            end
        end
        if
            0038:   $FLAG_KAPPA3_CREATED == 0
        then
            if
                0121:   player $PLAYER in_zone 'LITTLEI'
            then
                009A: $KAPPA_CARTEL3 = create_actor 12 #GANG11 at $KAPPA3_X $KAPPA3_Y -100.0
                0173: set_actor $KAPPA_CARTEL3 z_angle_to 270.0
                011A: set_actor $KAPPA_CARTEL3 flags 1
                01B2: give_actor $KAPPA_CARTEL3 weapon 21 ammo 10  // Load the weapon model before using this
                0350: set_char_stay_in_same_place $KAPPA_CARTEL3  1
                0107: $KAPPA_3 = create_object #COFFEE at $KAPPA3_X $KAPPA3_Y -100.0
                0177: set_object $KAPPA_3 z_angle_to 180.0
                0382: set_object $KAPPA_3 collision_detection 1
                0392: object $KAPPA_3 toggle_in_moving_list 0
                if
                    0038:   $BLIP_KAPPA3_CREATED == 0
                then
                    0188: $BLIP_KAPPA3 = create_marker_above_object $KAPPA_3
                    0004: $BLIP_KAPPA3_CREATED = 1
                end
                0004: $FLAG_KAPPA3_CREATED = 1
            end
        end
    end
    if
        03C6:   is_collision_in_memory 2
    then
        if
            0038:   $FLAG_KAPPA4_CREATED == 0
        then
            009A: $KAPPA_CARTEL4 = create_actor 12 #GANG12 at $KAPPA4_X $KAPPA4_Y -100.0
            0173: set_actor $KAPPA_CARTEL4 z_angle_to 360.0
            011A: set_actor $KAPPA_CARTEL4 flags 1
            01B2: give_actor $KAPPA_CARTEL4 weapon 23 ammo 60  // Load the weapon model before using this
            0350: set_char_stay_in_same_place $KAPPA_CARTEL4  1
            035F: set_actor $KAPPA_CARTEL4 armour_to 100
            0107: $KAPPA_4 = create_object #COFFEE at $KAPPA4_X $KAPPA4_Y -100.0
            0177: set_object $KAPPA_4 z_angle_to 270.0
            0382: set_object $KAPPA_4 collision_detection 1
            0392: object $KAPPA_4 toggle_in_moving_list 0
            if
                0038:   $BLIP_KAPPA4_CREATED == 0
            then
                0188: $BLIP_KAPPA4 = create_marker_above_object $KAPPA_4
                0004: $BLIP_KAPPA4_CREATED = 1
            end
            0004: $FLAG_KAPPA4_CREATED = 1
        end
        if
            0038:   $FLAG_KAPPA5_CREATED == 0
        then
            if
                0121:   player $PLAYER in_zone 'PARK'
            then
                009A: $KAPPA_CARTEL5 = create_actor 12 #GANG11 at $KAPPA5_X $KAPPA5_Y -100.0
                011A: set_actor $KAPPA_CARTEL5 flags 1
                01B2: give_actor $KAPPA_CARTEL5 weapon 23 ammo 60  // Load the weapon model before using this
                0350: set_char_stay_in_same_place $KAPPA_CARTEL5  1
                0107: $KAPPA_5 = create_object #COFFEE at $KAPPA5_X $KAPPA5_Y -100.0
                0382: set_object $KAPPA_5 collision_detection 1
                0392: object $KAPPA_5 toggle_in_moving_list 0
                if
                    0038:   $BLIP_KAPPA5_CREATED == 0
                then
                    0188: $BLIP_KAPPA5 = create_marker_above_object $KAPPA_5
                    0004: $BLIP_KAPPA5_CREATED = 1
                end
                0004: $FLAG_KAPPA5_CREATED = 1
            end
        end
        if
            0038:   $FLAG_KAPPA6_CREATED == 0
        then
            if
                0121:   player $PLAYER in_zone 'SHOPING'
            then
                009A: $KAPPA_CARTEL6 = create_actor 12 #GANG12 at $KAPPA6_X $KAPPA6_Y -100.0
                0173: set_actor $KAPPA_CARTEL6 z_angle_to 190.0
                011A: set_actor $KAPPA_CARTEL6 flags 1
                01B2: give_actor $KAPPA_CARTEL6 weapon 23 ammo 60  // Load the weapon model before using this
                0350: set_char_stay_in_same_place $KAPPA_CARTEL6  1
                0107: $KAPPA_6 = create_object #COFFEE at $KAPPA6_X $KAPPA6_Y -100.0
                0177: set_object $KAPPA_6 z_angle_to 145.0
                0382: set_object $KAPPA_6 collision_detection 1
                0392: object $KAPPA_6 toggle_in_moving_list 0
                if
                    0038:   $BLIP_KAPPA6_CREATED == 0
                then
                    0188: $BLIP_KAPPA6 = create_marker_above_object $KAPPA_6
                    0004: $BLIP_KAPPA6_CREATED = 1
                end
                0004: $FLAG_KAPPA6_CREATED = 1
            end
        end
        if
            0038:   $FLAG_KAPPA7_CREATED == 0
        then
            if
                0121:   player $PLAYER in_zone 'SHOPING'
            then
                009A: $KAPPA_CARTEL7 = create_actor 12 #GANG11 at $KAPPA7_X $KAPPA7_Y -100.0
                011A: set_actor $KAPPA_CARTEL7 flags 1
                01B2: give_actor $KAPPA_CARTEL7 weapon 23 ammo 60  // Load the weapon model before using this
                0350: set_char_stay_in_same_place $KAPPA_CARTEL7  1
                0107: $KAPPA_7 = create_object #COFFEE at $KAPPA7_X $KAPPA7_Y -100.0
                0382: set_object $KAPPA_7 collision_detection 1
                0392: object $KAPPA_7 toggle_in_moving_list 0
                if
                    0038:   $BLIP_KAPPA7_CREATED == 0
                then
                    0188: $BLIP_KAPPA7 = create_marker_above_object $KAPPA_7
                    0004: $BLIP_KAPPA7_CREATED = 1
                end
                0004: $FLAG_KAPPA7_CREATED = 1
            end
        end
        if
            02BD:   debug_mode == DEBUG_MASTEREXTRAS2
        then
            if
                $FLAG_KAPPA8_CREATED == 0
            then
                if
                    0121:   player $PLAYER in_zone 'STADIUM'
                 then
                    009A: $KAPPA_CARTEL8 = create_actor 12 #GANG11 at $KAPPA8_X $KAPPA8_Y 17.8
                    0173: set_actor $KAPPA_CARTEL8 z_angle_to 350.0
                    011A: set_actor $KAPPA_CARTEL8 flags 1
                    01B2: give_actor $KAPPA_CARTEL8 weapon 21 ammo 10
                    0350: set_char_stay_in_same_place $KAPPA_CARTEL8  1
                    0107: $KAPPA_8 = create_object #COFFEE at $KAPPA8_X $KAPPA8_Y -100.0
                    0177: set_object $KAPPA_8 z_angle_to 270.0
                    0382: set_object $KAPPA_8 collision_detection 1
                    0392: object $KAPPA_8 toggle_in_moving_list 0
                    if
                        $BLIP_KAPPA8_CREATED == 0
                    then
                        0188: $BLIP_KAPPA8 = create_marker_above_object $KAPPA_8
                        $BLIP_KAPPA8_CREATED = 1
                    end
                    $FLAG_KAPPA8_CREATED = 1
                end
            end
        end
        if
            0038:   $FLAG_KAPPA9_CREATED == 0
        then
            if
                0121:   player $PLAYER in_zone 'YAKUSA'
            then
                009A: $KAPPA_CARTEL9 = create_actor 12 #GANG11 at $KAPPA9_X $KAPPA9_Y 29.6875
                011A: set_actor $KAPPA_CARTEL9 flags 1
                01B2: give_actor $KAPPA_CARTEL9 weapon 21 ammo 10  // Load the weapon model before using this
                0350: set_char_stay_in_same_place $KAPPA_CARTEL9  1
                0107: $KAPPA_9 = create_object #COFFEE at $KAPPA9_X $KAPPA9_Y -100.0
                0177: set_object $KAPPA_9 z_angle_to 270.0
                0382: set_object $KAPPA_9 collision_detection 1
                0392: object $KAPPA_9 toggle_in_moving_list 0
                if
                    0038:   $BLIP_KAPPA9_CREATED == 0
                then
                    0188: $BLIP_KAPPA9 = create_marker_above_object $KAPPA_9
                    0004: $BLIP_KAPPA9_CREATED = 1
                end
                0004: $FLAG_KAPPA9_CREATED = 1
            end
        end
    end
    if
        03C6:   is_collision_in_memory 3
    then
        if
            0038:   $FLAG_KAPPA10_CREATED == 0
        then
            if
                0121:   player $PLAYER in_zone 'AIRPORT'
            then
                009A: $KAPPA_CARTEL10 = create_actor 12 #GANG12 at $KAPPA10_X $KAPPA10_Y 24.875
                0173: set_actor $KAPPA_CARTEL10 z_angle_to 50.0
                011A: set_actor $KAPPA_CARTEL10 flags 1
                01B2: give_actor $KAPPA_CARTEL10 weapon 23 ammo 60  // Load the weapon model before using this
                0350: set_char_stay_in_same_place $KAPPA_CARTEL10  1
                0107: $KAPPA_10 = create_object #COFFEE at $KAPPA10_X $KAPPA10_Y -100.0
                0382: set_object $KAPPA_10 collision_detection 1
                0392: object $KAPPA_10 toggle_in_moving_list 0
                if
                    0038:   $BLIP_KAPPA10_CREATED == 0
                then
                    0188: $BLIP_KAPPA10 = create_marker_above_object $KAPPA_10
                    0004: $BLIP_KAPPA10_CREATED = 1
                end
                0004: $FLAG_KAPPA10_CREATED = 1
            end
        end
        if
            02BD:   debug_mode == DEBUG_MASTEREXTRAS2
        then
            if
                $FLAG_KAPPA11_CREATED == 0
            then
                if //or
                    00E3:   player $PLAYER 0 near_point $KAPPA11_X $KAPPA11_Y radius 100.0 100.0      //this works better if the user is coming via helicopter
                    //0121:   player $PLAYER in_zone 'SWANKS'
                    //0121:   player $PLAYER in_zone 'PROJECT'
                  then
                    009A: $KAPPA_CARTEL11 = create_actor 12 #GANG11 at $KAPPA11_X $KAPPA11_Y 9.1
                    0173: set_actor $KAPPA_CARTEL11 z_angle_to 90.0
                    011A: set_actor $KAPPA_CARTEL11 flags 1
                    01B2: give_actor $KAPPA_CARTEL11 weapon 23 ammo 60
                    0350: set_char_stay_in_same_place $KAPPA_CARTEL11  1
                    0107: $KAPPA_11 = create_object #COFFEE at $KAPPA11_X $KAPPA11_Y -100.0
                    0177: set_object $KAPPA_11 z_angle_to 270.0
                    0382: set_object $KAPPA_11 collision_detection 1
                    0392: object $KAPPA_11 toggle_in_moving_list 0
                    if
                        $BLIP_KAPPA11_CREATED == 0
                    then
                        0188: $BLIP_KAPPA11 = create_marker_above_object $KAPPA_11
                        $BLIP_KAPPA11_CREATED = 1
                    end
                    $FLAG_KAPPA11_CREATED = 1
                end
            end
        end
        if
            0038:   $FLAG_KAPPA12_CREATED == 0
        then
            if
                0121:   player $PLAYER in_zone 'SUB_IND'
            then
                009A: $KAPPA_CARTEL12 = create_actor 12 #GANG12 at $KAPPA12_X $KAPPA12_Y -100.0
                011A: set_actor $KAPPA_CARTEL12 flags 1
                01B2: give_actor $KAPPA_CARTEL12 weapon 23 ammo 60  // Load the weapon model before using this
                0107: $KAPPA_12 = create_object #COFFEE at $KAPPA12_X $KAPPA12_Y -100.0
                0350: set_char_stay_in_same_place $KAPPA_CARTEL12  1
                0382: set_object $KAPPA_12 collision_detection 1
                0392: object $KAPPA_12 toggle_in_moving_list 0
                if
                    0038:   $BLIP_KAPPA12_CREATED == 0
                then
                    0188: $BLIP_KAPPA12 = create_marker_above_object $KAPPA_12
                    0004: $BLIP_KAPPA12_CREATED = 1
                end
                0004: $FLAG_KAPPA12_CREATED = 1
            end
        end
        if or
            0038:   $FLAG_KAPPA10_CREATED == 1
            0038:   $FLAG_KAPPA12_CREATED == 1
        then
            if
                0038:   $FLAG_GUARD1_CREATED == 0
            then
                00A5: $PATRIOT_1 = create_car #COLUMB at -1041.25 -285.688 24.25
                0129: $VARMINT_1 = create_actor 12 #GANG11 in_car $PATRIOT_1 driverseat
                01B2: give_actor $VARMINT_1 weapon 23 ammo 60  // Load the weapon model before using this
                01CC: actor $VARMINT_1 kill_player $PLAYER
                0004: $FLAG_GUARD1_CREATED = 1
            end
        end
    end
    //---------------------------------------KAPPA DEATH CHECK---------------------------------------------------------------------------------------
    if and
        0038:   $FLAG_KAPPA1_DEAD == 0
        0038:   $FLAG_KAPPA1_CREATED == 1
    then
        if
            0366:   object $KAPPA_1 blown_up
        then
            0004: $FLAG_KAPPA1_DEAD = 1
            0008: $COUNTER_KAPPA_DEAD += 1
            0008: $COUNTER_KAPPA_DEAD_IND += 1
            if      //this was added to GTA:LC to prevent the last text from showing when the mission completes
                001C:   $TOTAL_ESPRESSO_STANDS > $COUNTER_KAPPA_DEAD
            then
                036D: text_1number_styled 'AS2_11' $COUNTER_KAPPA_DEAD $TOTAL_ESPRESSO_STANDS 2000 ms 1   // // ~g~~1~ OF ~1~!
            end
            0164: remove_blip $BLIP_KAPPA1
            if
                8118:   NOT   actor $KAPPA_CARTEL1 dead
            then
                01ED: reset_actor $KAPPA_CARTEL1 flags
                0239: actor $KAPPA_CARTEL1 run_to 1000.5 -820.5
            end
        end
        if
            8118:   NOT   actor $KAPPA_CARTEL1 dead
        then
            020F: actor $KAPPA_CARTEL1 look_at_player $PLAYER
        end
    end
    if
        0018:   $FLAG_KAPPA1_DEAD > 0
    then
        if
            8118:   NOT   actor $KAPPA_CARTEL1 dead
        then
            if
                0126:   actor $KAPPA_CARTEL1 walking
            then
                020F: actor $KAPPA_CARTEL1 look_at_player $PLAYER
                0350: set_char_stay_in_same_place $KAPPA_CARTEL1  0
                011A: set_actor $KAPPA_CARTEL1 flags 1
            end
        end
    end
    if
        02BD:   debug_mode == DEBUG_MASTEREXTRAS2    //stands 2, 8, and 11 are all here to reduce the extras2 checks
    then
        if and
            $FLAG_KAPPA2_DEAD == 0
            $FLAG_KAPPA2_CREATED == 1
        then
            if
                0366:   object $KAPPA_2 blown_up
            then
                $FLAG_KAPPA2_DEAD = 1
                0008: $COUNTER_KAPPA_DEAD += 1
                0008: $COUNTER_KAPPA_DEAD_IND += 1
                if
                    001C:   $TOTAL_ESPRESSO_STANDS > $COUNTER_KAPPA_DEAD
                then
                    036D: text_1number_styled 'AS2_11' $COUNTER_KAPPA_DEAD $TOTAL_ESPRESSO_STANDS 2000 ms 1   // // ~g~~1~ OF ~1~!
                end
                0164: remove_blip $BLIP_KAPPA2
            end
            if
                8118:   NOT is_char_dead    $KAPPA_CARTEL2
            then
                020F: actor $KAPPA_CARTEL2 look_at_player $PLAYER
            end
        end
        if and
            $FLAG_KAPPA8_DEAD == 0
            $FLAG_KAPPA8_CREATED == 1
        then
            if
                0366:   object $KAPPA_8 blown_up
            then
                $FLAG_KAPPA8_DEAD = 1
                0008: $COUNTER_KAPPA_DEAD += 1
                0008: $COUNTER_KAPPA_DEAD_COM += 1
                if
                    001C:   $TOTAL_ESPRESSO_STANDS > $COUNTER_KAPPA_DEAD
                then
                    036D: text_1number_styled 'AS2_11' $COUNTER_KAPPA_DEAD $TOTAL_ESPRESSO_STANDS 2000 ms 1   // // ~g~~1~ OF ~1~!
                end
                0164: remove_blip $BLIP_KAPPA8
            end
            if
                8118:   NOT is_char_dead    $KAPPA_CARTEL8
            then
                020F: actor $KAPPA_CARTEL8 look_at_player $PLAYER
            end
        end
        if and
            $FLAG_KAPPA11_DEAD == 0
            $FLAG_KAPPA11_CREATED == 1
        then
            if
                0366:   object $KAPPA_11 blown_up
            then
                $FLAG_KAPPA11_DEAD = 1
                0008: $COUNTER_KAPPA_DEAD += 1
                0008: $COUNTER_KAPPA_DEAD_SUB += 1
                if
                    001C:   $TOTAL_ESPRESSO_STANDS > $COUNTER_KAPPA_DEAD
                then
                    036D: text_1number_styled 'AS2_11' $COUNTER_KAPPA_DEAD $TOTAL_ESPRESSO_STANDS 2000 ms 1   // // ~g~~1~ OF ~1~!
                end
                0164: remove_blip $BLIP_KAPPA11
            end
            if
                8118:   NOT is_char_dead    $KAPPA_CARTEL11
            then
                020F: actor $KAPPA_CARTEL11 look_at_player $PLAYER
            end
        end
    end //extras2 check
    if and
        0038:   $FLAG_KAPPA3_DEAD == 0
        0038:   $FLAG_KAPPA3_CREATED == 1
    then
        if
            0366:   object $KAPPA_3 blown_up
        then
            0004: $FLAG_KAPPA3_DEAD = 1
            0008: $COUNTER_KAPPA_DEAD += 1
            0008: $COUNTER_KAPPA_DEAD_IND += 1
            if
                001C:   $TOTAL_ESPRESSO_STANDS > $COUNTER_KAPPA_DEAD
            then
                036D: text_1number_styled 'AS2_11' $COUNTER_KAPPA_DEAD $TOTAL_ESPRESSO_STANDS 2000 ms 1   // // ~g~~1~ OF ~1~!
            end
            0164: remove_blip $BLIP_KAPPA3
            if
                8118:   NOT   actor $KAPPA_CARTEL3 dead
            then
                01ED: reset_actor $KAPPA_CARTEL3 flags
                0239: actor $KAPPA_CARTEL3 run_to 1007.6899 -259.0
            end
        end
        if
            8118:   NOT   actor $KAPPA_CARTEL3 dead
        then
            020F: actor $KAPPA_CARTEL3 look_at_player $PLAYER
        end
    end
    if
        0018:   $FLAG_KAPPA3_DEAD > 0
    then
        if
            8118:   NOT   actor $KAPPA_CARTEL3 dead
        then
            if
                0126:   actor $KAPPA_CARTEL3 walking
            then
                020F: actor $KAPPA_CARTEL3 look_at_player $PLAYER
                0350: set_char_stay_in_same_place $KAPPA_CARTEL3  0
                011A: set_actor $KAPPA_CARTEL3 flags 1
            end
        end
    end
    if and
        0038:   $FLAG_KAPPA4_DEAD == 0
        0038:   $FLAG_KAPPA4_CREATED == 1
    then
        if
            0366:   object $KAPPA_4 blown_up
        then
            0004: $FLAG_KAPPA4_DEAD = 1
            0008: $COUNTER_KAPPA_DEAD += 1
            0008: $COUNTER_KAPPA_DEAD_COM += 1
            if
                001C:   $TOTAL_ESPRESSO_STANDS > $COUNTER_KAPPA_DEAD
            then
                036D: text_1number_styled 'AS2_11' $COUNTER_KAPPA_DEAD $TOTAL_ESPRESSO_STANDS 2000 ms 1   // // ~g~~1~ OF ~1~!
            end
            0164: remove_blip $BLIP_KAPPA4
            if
                8118:   NOT   actor $KAPPA_CARTEL4 dead
            then
                01ED: reset_actor $KAPPA_CARTEL4 flags
                0239: actor $KAPPA_CARTEL4 run_to -55.0 -676.5
            end
        end
        if
            8118:   NOT   actor $KAPPA_CARTEL4 dead
        then
            020F: actor $KAPPA_CARTEL4 look_at_player $PLAYER
        end
    end
    if
        0018:   $FLAG_KAPPA4_DEAD > 0
    then
        if
            8118:   NOT   actor $KAPPA_CARTEL4 dead
        then
            if
                0126:   actor $KAPPA_CARTEL4 walking
            then
                020F: actor $KAPPA_CARTEL4 look_at_player $PLAYER
                0350: set_char_stay_in_same_place $KAPPA_CARTEL4  0
                011A: set_actor $KAPPA_CARTEL4 flags 1
            end
        end
    end
    if and
        0038:   $FLAG_KAPPA5_DEAD == 0
        0038:   $FLAG_KAPPA5_CREATED == 1
    then
        if
            0366:   object $KAPPA_5 blown_up
        then
            0004: $FLAG_KAPPA5_DEAD = 1
            0008: $COUNTER_KAPPA_DEAD += 1
            0008: $COUNTER_KAPPA_DEAD_COM += 1
            if
                001C:   $TOTAL_ESPRESSO_STANDS > $COUNTER_KAPPA_DEAD
            then
                036D: text_1number_styled 'AS2_11' $COUNTER_KAPPA_DEAD $TOTAL_ESPRESSO_STANDS 2000 ms 1   // // ~g~~1~ OF ~1~!
            end
            0164: remove_blip $BLIP_KAPPA5
            if
                8118:   NOT   actor $KAPPA_CARTEL5 dead
            then
                01ED: reset_actor $KAPPA_CARTEL5 flags
                0239: actor $KAPPA_CARTEL5 run_to -300.5 -850.0
            end
        end
        if
            8118:   NOT   actor $KAPPA_CARTEL5 dead
        then
            020F: actor $KAPPA_CARTEL5 look_at_player $PLAYER
        end
    end
    if
        0018:   $FLAG_KAPPA5_DEAD > 0
    then
        if
            8118:   NOT   actor $KAPPA_CARTEL5 dead
        then
            if
                0126:   actor $KAPPA_CARTEL5 walking
            then
                020F: actor $KAPPA_CARTEL5 look_at_player $PLAYER
                0350: set_char_stay_in_same_place $KAPPA_CARTEL5  0
                011A: set_actor $KAPPA_CARTEL5 flags 1
            end
        end
    end
    if and
        0038:   $FLAG_KAPPA6_DEAD == 0
        0038:   $FLAG_KAPPA6_CREATED == 1
    then
        if
            0366:   object $KAPPA_6 blown_up
        then
            0004: $FLAG_KAPPA6_DEAD = 1
            0008: $COUNTER_KAPPA_DEAD += 1
            0008: $COUNTER_KAPPA_DEAD_COM += 1
            if
                001C:   $TOTAL_ESPRESSO_STANDS > $COUNTER_KAPPA_DEAD
            then
                036D: text_1number_styled 'AS2_11' $COUNTER_KAPPA_DEAD $TOTAL_ESPRESSO_STANDS 2000 ms 1   // // ~g~~1~ OF ~1~!
            end
            0164: remove_blip $BLIP_KAPPA6
            if
                8118:   NOT   actor $KAPPA_CARTEL6 dead
            then
                01ED: reset_actor $KAPPA_CARTEL6 flags
                0239: actor $KAPPA_CARTEL6 run_to -321.3125 -1135.25
            end
        end
        if
            8118:   NOT   actor $KAPPA_CARTEL6 dead
        then
            020F: actor $KAPPA_CARTEL6 look_at_player $PLAYER
        end
    end
    if
        0018:   $FLAG_KAPPA6_DEAD > 0
    then
        if
            8118:   NOT   actor $KAPPA_CARTEL6 dead
        then
            if
                0126:   actor $KAPPA_CARTEL6 walking
            then
                020F: actor $KAPPA_CARTEL6 look_at_player $PLAYER
                0350: set_char_stay_in_same_place $KAPPA_CARTEL6  0
                011A: set_actor $KAPPA_CARTEL6 flags 1
            end
        end
    end
    if and
        0038:   $FLAG_KAPPA7_DEAD == 0
        0038:   $FLAG_KAPPA7_CREATED == 1
    then
        if
            0366:   object $KAPPA_7 blown_up
        then
            0004: $FLAG_KAPPA7_DEAD = 1
            0008: $COUNTER_KAPPA_DEAD += 1
            0008: $COUNTER_KAPPA_DEAD_COM += 1
            if
                001C:   $TOTAL_ESPRESSO_STANDS > $COUNTER_KAPPA_DEAD
            then
                036D: text_1number_styled 'AS2_11' $COUNTER_KAPPA_DEAD $TOTAL_ESPRESSO_STANDS 2000 ms 1   // // ~g~~1~ OF ~1~!
            end
            0164: remove_blip $BLIP_KAPPA7
            if
                8118:   NOT   actor $KAPPA_CARTEL7 dead
            then
                01ED: reset_actor $KAPPA_CARTEL7 flags
                0239: actor $KAPPA_CARTEL7 run_to -256.0 -1361.0
            end
        end
        if
            8118:   NOT   actor $KAPPA_CARTEL7 dead
        then
            020F: actor $KAPPA_CARTEL7 look_at_player $PLAYER
        end
    end
    if
        0018:   $FLAG_KAPPA7_DEAD > 0
    then
        if
            8118:   NOT   actor $KAPPA_CARTEL7 dead
        then
            if
                0126:   actor $KAPPA_CARTEL7 walking
            then
                020F: actor $KAPPA_CARTEL7 look_at_player $PLAYER
                0350: set_char_stay_in_same_place $KAPPA_CARTEL7  0
                011A: set_actor $KAPPA_CARTEL7 flags 1
            end
        end
    end
    if and
        0038:   $FLAG_KAPPA9_DEAD == 0
        0038:   $FLAG_KAPPA9_CREATED == 1
    then
        if
            0366:   object $KAPPA_9 blown_up
        then
            0004: $FLAG_KAPPA9_DEAD = 1
            0008: $COUNTER_KAPPA_DEAD += 1
            0008: $COUNTER_KAPPA_DEAD_COM += 1
            if
                001C:   $TOTAL_ESPRESSO_STANDS > $COUNTER_KAPPA_DEAD
            then
                036D: text_1number_styled 'AS2_11' $COUNTER_KAPPA_DEAD $TOTAL_ESPRESSO_STANDS 2000 ms 1   // // ~g~~1~ OF ~1~!
            end
            0164: remove_blip $BLIP_KAPPA9
            if
                8118:   NOT   actor $KAPPA_CARTEL9 dead
            then
                01ED: reset_actor $KAPPA_CARTEL9 flags
                0239: actor $KAPPA_CARTEL9 run_to -52.5 -1501.0
            end
        end
        if
            8118:   NOT   actor $KAPPA_CARTEL9 dead
        then
            020F: actor $KAPPA_CARTEL9 look_at_player $PLAYER
        end
    end
    if
        0018:   $FLAG_KAPPA9_DEAD > 0
    then
        if
            8118:   NOT   actor $KAPPA_CARTEL9 dead
        then
            if
                0126:   actor $KAPPA_CARTEL9 walking
            then
                020F: actor $KAPPA_CARTEL9 look_at_player $PLAYER
                0350: set_char_stay_in_same_place $KAPPA_CARTEL9  0
                011A: set_actor $KAPPA_CARTEL9 flags 1
            end
        end
    end
    if and
        0038:   $FLAG_KAPPA10_DEAD == 0
        0038:   $FLAG_KAPPA10_CREATED == 1
    then
        if
            0366:   object $KAPPA_10 blown_up
        then
            0004: $FLAG_KAPPA10_DEAD = 1
            0008: $COUNTER_KAPPA_DEAD += 1
            0008: $COUNTER_KAPPA_DEAD_SUB += 1
            if
                001C:   $TOTAL_ESPRESSO_STANDS > $COUNTER_KAPPA_DEAD
            then
                036D: text_1number_styled 'AS2_11' $COUNTER_KAPPA_DEAD $TOTAL_ESPRESSO_STANDS 2000 ms 1   // // ~g~~1~ OF ~1~!
            end
            0164: remove_blip $BLIP_KAPPA10
            if
                8118:   NOT   actor $KAPPA_CARTEL10 dead
            then
                01ED: reset_actor $KAPPA_CARTEL10 flags
                0239: actor $KAPPA_CARTEL10 run_to -973.75 -721.562
            end
        end
        if
            8118:   NOT   actor $KAPPA_CARTEL10 dead
        then
            020F: actor $KAPPA_CARTEL10 look_at_player $PLAYER
        end
    end
    if
        0018:   $FLAG_KAPPA10_DEAD > 0
    then
        if
            8118:   NOT   actor $KAPPA_CARTEL10 dead
        then
            if
                0126:   actor $KAPPA_CARTEL10 walking
            then
                020F: actor $KAPPA_CARTEL10 look_at_player $PLAYER
                0350: set_char_stay_in_same_place $KAPPA_CARTEL10  0
                011A: set_actor $KAPPA_CARTEL10 flags 1
            end
        end
    end
    if and
        0038:   $FLAG_KAPPA12_DEAD == 0
        0038:   $FLAG_KAPPA12_CREATED == 1
    then
        if
            0366:   object $KAPPA_12 blown_up
        then
            0004: $FLAG_KAPPA12_DEAD = 1
            0008: $COUNTER_KAPPA_DEAD += 1
            0008: $COUNTER_KAPPA_DEAD_SUB += 1
            if
                001C:   $TOTAL_ESPRESSO_STANDS > $COUNTER_KAPPA_DEAD
            then
                036D: text_1number_styled 'AS2_11' $COUNTER_KAPPA_DEAD $TOTAL_ESPRESSO_STANDS 2000 ms 1   // // ~g~~1~ OF ~1~!
            end
            0164: remove_blip $BLIP_KAPPA12
            if
                8118:   NOT   actor $KAPPA_CARTEL12 dead
            then
                01ED: reset_actor $KAPPA_CARTEL12 flags
                0239: actor $KAPPA_CARTEL12 run_to -1586.0 -114.5
            end
        end
        if
            8118:   NOT   actor $KAPPA_CARTEL12 dead
        then
            020F: actor $KAPPA_CARTEL12 look_at_player $PLAYER
        end
    end
    if
        0018:   $FLAG_KAPPA12_DEAD > 0
    then
        if
            8118:   NOT   actor $KAPPA_CARTEL12 dead
        then
            if
                0126:   actor $KAPPA_CARTEL12 walking
            then
                020F: actor $KAPPA_CARTEL12 look_at_player $PLAYER
                0350: set_char_stay_in_same_place $KAPPA_CARTEL12  0
                011A: set_actor $KAPPA_CARTEL12 flags 1
            end
        end
    end
    //---------------------STEAM--------------------------
    01BD: $TIMER_AS2_NOW = current_time_in_ms
    0084: $TIMER_AS2_DIF = $TIMER_AS2_NOW
    0060: $TIMER_AS2_DIF -= $TIMER_AS2_START
    if
        001C:   $TIMER_AS2_DIF > $PARTICLE_TIME_AS2
    then
        0008: $PARTICLE_TIME_AS2 += 50
        0004: $FLAG_PARTICLE_AS2 = 1
    end
    if
        0038:   $FLAG_PARTICLE_AS2 == 1
    then
        if and
            0038:   $FLAG_KAPPA1_DEAD == 0
            0038:   $FLAG_KAPPA1_CREATED == 1
        then
            01BB: store_object $KAPPA_1 position_to $STEAM_X $STEAM_Y $STEAM_Z
            000D: $STEAM_Y -= 1.0
            039D: scatter_particles 12 0.25 0 0 0 50 at $STEAM_X $STEAM_Y $STEAM_Z 0.0 0.0 0.0
        end
        if and
            0038:   $FLAG_KAPPA1_DEAD == 1
            0038:   $FLAG_KAPPA1_CREATED == 1
        then
            01BB: store_object $KAPPA_1 position_to $STEAM_X $STEAM_Y $STEAM_Z
            000D: $STEAM_Y -= 1.0
            02CF: $KAPPA_1_FIRE = create_fire_at $STEAM_X $STEAM_Y $STEAM_Z
            0004: $FLAG_KAPPA1_DEAD = 2
        end
        if      //again, 2, 8, and 11 are all together
            02BD:   debug_mode == DEBUG_MASTEREXTRAS2
        then
            if and
                $FLAG_KAPPA2_DEAD == 0
                $FLAG_KAPPA2_CREATED == 1
            then
                01BB: store_object $KAPPA_2 position_to $STEAM_X $STEAM_Y $STEAM_Z
                0009: $STEAM_X += 1.0
                039D: scatter_particles 12 0.3 0 0 0 50 at $STEAM_X $STEAM_Y $STEAM_Z 0.0 0.0 0.0
            end
            if and
                $FLAG_KAPPA2_DEAD == 1
                $FLAG_KAPPA2_CREATED == 1
            then
                01BB: store_object $KAPPA_2 position_to $STEAM_X $STEAM_Y $STEAM_Z
                0009: $STEAM_X += 1.0
                02CF: $KAPPA_2_FIRE = create_fire_at $STEAM_X $STEAM_Y $STEAM_Z
                $FLAG_KAPPA2_DEAD = 2
            end

            if and
                $FLAG_KAPPA8_DEAD == 0
                $FLAG_KAPPA8_CREATED == 1
            then
                01BB: store_object $KAPPA_8 position_to $STEAM_X $STEAM_Y $STEAM_Z
                0009: $STEAM_X += 1.0
                039D: scatter_particles 12 0.3 0 0 0 50 at $STEAM_X $STEAM_Y $STEAM_Z 0.0 0.0 0.0
            end
            if and
                $FLAG_KAPPA8_DEAD == 1
                $FLAG_KAPPA8_CREATED == 1
            then
                01BB: store_object $KAPPA_8 position_to $STEAM_X $STEAM_Y $STEAM_Z
                0009: $STEAM_X += 1.0
                02CF: $KAPPA_8_FIRE = create_fire_at $STEAM_X $STEAM_Y $STEAM_Z
                $FLAG_KAPPA8_DEAD = 2
            end

            if and
                $FLAG_KAPPA11_DEAD == 0
                $FLAG_KAPPA11_CREATED == 1
            then
                01BB: store_object $KAPPA_11 position_to $STEAM_X $STEAM_Y $STEAM_Z
                0009: $STEAM_X += 1.0
                039D: scatter_particles 12 0.3 0 0 0 50 at $STEAM_X $STEAM_Y $STEAM_Z 0.0 0.0 0.0
            end
            if  and
                $FLAG_KAPPA11_DEAD == 1
                $FLAG_KAPPA11_CREATED == 1
            then
                01BB: store_object $KAPPA_11 position_to $STEAM_X $STEAM_Y $STEAM_Z
                000D: $STEAM_Y -= 1.0
                02CF: $KAPPA_11_FIRE = create_fire_at $STEAM_X $STEAM_Y $STEAM_Z
                $FLAG_KAPPA11_DEAD = 2
            end
        end
        if and
            0038:   $FLAG_KAPPA3_DEAD == 0
            0038:   $FLAG_KAPPA3_CREATED == 1
        then
            01BB: store_object $KAPPA_3 position_to $STEAM_X $STEAM_Y $STEAM_Z
            000D: $STEAM_Y -= 1.0
            039D: scatter_particles 12 0.25 0 0 0 50 at $STEAM_X $STEAM_Y $STEAM_Z 0.0 0.0 0.0
        end
        if and
            0038:   $FLAG_KAPPA3_DEAD == 1
            0038:   $FLAG_KAPPA3_CREATED == 1
        then
            01BB: store_object $KAPPA_3 position_to $STEAM_X $STEAM_Y $STEAM_Z
            000D: $STEAM_Y -= 1.0
            02CF: $KAPPA_3_FIRE = create_fire_at $STEAM_X $STEAM_Y $STEAM_Z
            0004: $FLAG_KAPPA3_DEAD = 2
        end
        if and
            0038:   $FLAG_KAPPA4_DEAD == 0
            0038:   $FLAG_KAPPA4_CREATED == 1
        then
            01BB: store_object $KAPPA_4 position_to $STEAM_X $STEAM_Y $STEAM_Z
            0009: $STEAM_X += 1.0
            039D: scatter_particles 12 0.25 0 0 0 50 at $STEAM_X $STEAM_Y $STEAM_Z 0.0 0.0 0.0
        end
        if and
            0038:   $FLAG_KAPPA4_DEAD == 1
            0038:   $FLAG_KAPPA4_CREATED == 1
        then
            01BB: store_object $KAPPA_4 position_to $STEAM_X $STEAM_Y $STEAM_Z
            0009: $STEAM_X += 1.0
            02CF: $KAPPA_4_FIRE = create_fire_at $STEAM_X $STEAM_Y $STEAM_Z
            0004: $FLAG_KAPPA4_DEAD = 2
        end
        if and
            0038:   $FLAG_KAPPA5_DEAD == 0
            0038:   $FLAG_KAPPA5_CREATED == 1
        then
            01BB: store_object $KAPPA_5 position_to $STEAM_X $STEAM_Y $STEAM_Z
            0009: $STEAM_Y += 1.0
            039D: scatter_particles 12 0.25 0 0 0 50 at $STEAM_X $STEAM_Y $STEAM_Z 0.0 0.0 0.0
        end
        if and
            0038:   $FLAG_KAPPA5_DEAD == 1
            0038:   $FLAG_KAPPA5_CREATED == 1
        then
            01BB: store_object $KAPPA_5 position_to $STEAM_X $STEAM_Y $STEAM_Z
            0009: $STEAM_Y += 1.0
            02CF: $KAPPA_5_FIRE = create_fire_at $STEAM_X $STEAM_Y $STEAM_Z
            0004: $FLAG_KAPPA5_DEAD = 2
        end
        if and
            0038:   $FLAG_KAPPA6_DEAD == 0
            0038:   $FLAG_KAPPA6_CREATED == 1
        then
            01BB: store_object $KAPPA_6 position_to $STEAM_X $STEAM_Y $STEAM_Z
            000D: $STEAM_X -= 1.0
            000D: $STEAM_Y -= 1.0
            039D: scatter_particles 12 0.25 0 0 0 50 at $STEAM_X $STEAM_Y $STEAM_Z 0.0 0.0 0.0
        end
        if and
            0038:   $FLAG_KAPPA6_DEAD == 1
            0038:   $FLAG_KAPPA6_CREATED == 1
        then
            01BB: store_object $KAPPA_6 position_to $STEAM_X $STEAM_Y $STEAM_Z
            000D: $STEAM_X -= 1.0
            000D: $STEAM_Y -= 1.0
            02CF: $KAPPA_6_FIRE = create_fire_at $STEAM_X $STEAM_Y $STEAM_Z
            0004: $FLAG_KAPPA6_DEAD = 2
        end
        if and
            0038:   $FLAG_KAPPA7_DEAD == 0
            0038:   $FLAG_KAPPA7_CREATED == 1
        then
            01BB: store_object $KAPPA_7 position_to $STEAM_X $STEAM_Y $STEAM_Z
            0009: $STEAM_Y += 1.0
            039D: scatter_particles 12 0.25 0 0 0 50 at $STEAM_X $STEAM_Y $STEAM_Z 0.0 0.0 0.0
        end
        if and
            0038:   $FLAG_KAPPA7_DEAD == 1
            0038:   $FLAG_KAPPA7_CREATED == 1
        then
            01BB: store_object $KAPPA_7 position_to $STEAM_X $STEAM_Y $STEAM_Z
            0009: $STEAM_Y += 1.0
            02CF: $KAPPA_7_FIRE = create_fire_at $STEAM_X $STEAM_Y $STEAM_Z
            0004: $FLAG_KAPPA7_DEAD = 2
        end
        if and
            0038:   $FLAG_KAPPA9_DEAD == 0
            0038:   $FLAG_KAPPA9_CREATED == 1
        then
            01BB: store_object $KAPPA_9 position_to $STEAM_X $STEAM_Y $STEAM_Z
            0009: $STEAM_X += 1.0
            039D: scatter_particles 12 0.25 0 0 0 50 at $STEAM_X $STEAM_Y $STEAM_Z 0.0 0.0 0.0
        end
        if and
            0038:   $FLAG_KAPPA9_DEAD == 1
            0038:   $FLAG_KAPPA9_CREATED == 1
        then
            01BB: store_object $KAPPA_9 position_to $STEAM_X $STEAM_Y $STEAM_Z
            0009: $STEAM_X += 1.0
            02CF: $KAPPA_9_FIRE = create_fire_at $STEAM_X $STEAM_Y $STEAM_Z
            0004: $FLAG_KAPPA9_DEAD = 2
        end
        if and
            0038:   $FLAG_KAPPA10_DEAD == 0
            0038:   $FLAG_KAPPA10_CREATED == 1
        then
            01BB: store_object $KAPPA_10 position_to $STEAM_X $STEAM_Y $STEAM_Z
            0009: $STEAM_Y += 1.0
            039D: scatter_particles 12 0.25 0 0 0 50 at $STEAM_X $STEAM_Y $STEAM_Z 0.0 0.0 0.0
        end
        if and
            0038:   $FLAG_KAPPA10_DEAD == 1
            0038:   $FLAG_KAPPA10_CREATED == 1
        then
            01BB: store_object $KAPPA_10 position_to $STEAM_X $STEAM_Y $STEAM_Z
            0009: $STEAM_Y += 1.0
            02CF: $KAPPA_10_FIRE = create_fire_at $STEAM_X $STEAM_Y $STEAM_Z
            0004: $FLAG_KAPPA10_DEAD = 2
        end
        if and
            0038:   $FLAG_KAPPA12_DEAD == 0
            0038:   $FLAG_KAPPA12_CREATED == 1
        then
            01BB: store_object $KAPPA_12 position_to $STEAM_X $STEAM_Y $STEAM_Z
            0009: $STEAM_Y += 1.0
            039D: scatter_particles 12 0.25 0 0 0 50 at $STEAM_X $STEAM_Y $STEAM_Z 0.0 0.0 0.0
        end
        if and
            0038:   $FLAG_KAPPA12_DEAD == 1
            0038:   $FLAG_KAPPA12_CREATED == 1
        then
            01BB: store_object $KAPPA_12 position_to $STEAM_X $STEAM_Y $STEAM_Z
            0009: $STEAM_Y += 1.0
            02CF: $KAPPA_12_FIRE = create_fire_at $STEAM_X $STEAM_Y $STEAM_Z
            0004: $FLAG_KAPPA12_DEAD = 2
        end
        0004: $FLAG_PARTICLE_AS2 = 0
    end
    //-------------------------------------------TIMER-------TIMER----TIMER----------------------------------------
    if
        001A:   1 > $KAPPA_TIME
    then
        00BC: print_now 'AS2_4' 3000 ms 1   // // ~r~The Cartel have warned their pushers!!
        jump @MISSION_AS2_FAILED
    end
    if and
        0038:   $COUNTER_KAPPA_DEAD == 1
        0038:   $FLAG_TIMER_STARTED == 0
    then
        014E: set_timer_to $KAPPA_TIME type 1
        0004: $FLAG_TIMER_STARTED = 1
    end
    //----------------------------------------PLAYER INFO----------------------------------------------------------
    if and
        003A:   $COUNTER_KAPPA_DEAD_IND == $TOTAL_STANDS_IND
        0038:   $FLAG_AS2_1 == 0
        803A:   NOT $TOTAL_ESPRESSO_STANDS == $COUNTER_KAPPA_DEAD
    then
        00BC: print_now 'AS2_1' 3000 ms 1   // // ~g~All espresso stalls in Portland wrecked!!
        wait 3000 ms
        0004: $FLAG_AS2_1 = 1
        if and
            0038:   $FLAG_AS2_2 == 0
            0038:   $FLAG_AS2_3 == 0
        then
            00BC: print_now 'AS2_5' 4000 ms 1   // // ~g~There are still espresso stalls in Shoreside Vale and on Staunton Island!
            wait 3000 ms
        end
        if and
            0038:   $FLAG_AS2_2 == 1
            0038:   $FLAG_AS2_3 == 0
        then
            00BC: print_now 'AS2_6' 4000 ms 1   // // ~g~There are still espresso stalls in Shoreside Vale!
            wait 3000 ms
        end
        if and
            0038:   $FLAG_AS2_2 == 0
            0038:   $FLAG_AS2_3 == 1
        then
            00BC: print_now 'AS2_7' 4000 ms 1   // // ~g~There are still espresso stalls on Staunton Island!
            wait 3000 ms
        end
    end
    if and
        003A:   $COUNTER_KAPPA_DEAD_COM == $TOTAL_STANDS_COM
        0038:   $FLAG_AS2_2 == 0
        803A:   NOT $TOTAL_ESPRESSO_STANDS == $COUNTER_KAPPA_DEAD
   then
        00BC: print_now 'AS2_2' 3000 ms 1   // // ~g~All espresso stalls in Staunton Island wrecked!!
        wait 3000 ms
        0004: $FLAG_AS2_2 = 1
        if and
            0038:   $FLAG_AS2_1 == 0
            0038:   $FLAG_AS2_3 == 0
        then
            00BC: print_now 'AS2_9' 4000 ms 1   // // ~g~There are still espresso stalls in Portland and Shoreside Vale!
            wait 3000 ms
        end
        if and
            0038:   $FLAG_AS2_1 == 1
            0038:   $FLAG_AS2_3 == 0
        then
            00BC: print_now 'AS2_6' 4000 ms 1   // // ~g~There are still espresso stalls in Shoreside Vale!
            wait 3000 ms
        end
        if and
            0038:   $FLAG_AS2_1 == 0
            0038:   $FLAG_AS2_3 == 1
        then
            00BC: print_now 'AS2_8' 4000 ms 1   // // ~g~There are still espresso stalls in Portland!
            wait 3000 ms
        end
    end
    if and
        003A:   $COUNTER_KAPPA_DEAD_SUB == $TOTAL_STANDS_IND
        0038:   $FLAG_AS2_3 == 0
        803A:   NOT $TOTAL_ESPRESSO_STANDS == $COUNTER_KAPPA_DEAD
    then
        00BC: print_now 'AS2_3' 3000 ms 1   // // ~g~All espresso stalls in Shoreside Vale wrecked!!
        wait 3000 ms
        0004: $FLAG_AS2_3 = 1
        if and
            0038:   $FLAG_AS2_1 == 0
            0038:   $FLAG_AS2_2 == 0
        then
            00BC: print_now 'AS2_10' 4000 ms 1   // // ~g~There are still espresso stalls in Portland and on Staunton Island
            wait 3000 ms
        end
        if and
            0038:   $FLAG_AS2_1 == 1
            0038:   $FLAG_AS2_2 == 0
        then
            00BC: print_now 'AS2_7' 4000 ms 1   // // ~g~There are still espresso stalls on Staunton Island!
            wait 3000 ms
        end
        if and
            0038:   $FLAG_AS2_1 == 0
            0038:   $FLAG_AS2_2 == 1
        then
            00BC: print_now 'AS2_8' 4000 ms 1   // // ~g~There are still espresso stalls in Portland!
            wait 3000 ms
        end
    end
end //while
jump @MISSION_AS2_PASSED

:MISSION_AS2_FAILED
00BA: text_styled 'M_FAIL' 2000 ms 1   // // MISSION FAILED!
if
    0130:  player $PLAYER busted        //crash
then
    016E: override_restart at 5.25 -1123.38 31.0 180.0
    //0420: override_police_station  2?         //crash
end
if
    0117:  player $PLAYER wasted
then
    016E: override_restart at -151.5 -17.75 22.1875 180.0
    //041F: override_hospital  2?                //crash
end
return

:MISSION_AS2_PASSED
0004: $ESPRESSO_2_GO_COMPLETED = 1
01E3: text_1number_styled 'M_PASS' $ESPRESSO_2_GO_REWARD 5000 ms 1   // // MISSION PASSED! $~1~
0394: play_music 1
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += $ESPRESSO_2_GO_REWARD
0318: set_latest_mission_passed 'AS2'   // // 'ESPRESSO-2-GO!'
030C: set_mission_points += 1
004F: create_thread @ASUKA_SUBURBAN_MISSION3_LOOP
return

:MISSION_CLEANUP_AS2
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_ASUKA2 = 0
014F: stop_timer $KAPPA_TIME
0151: remove_status_text $COUNTER_KAPPA_DEAD
if
    0038:   $LAST_REQUESTS_COMPLETED == 1
then
    0237: set_gang 0 primary_weapon_to 17 secondary_weapon_to 21
end
if and
    0038:   $FLAG_KAPPA1_DEAD == 0
    0038:   $FLAG_KAPPA1_CREATED == 1
then
    0164: remove_blip $BLIP_KAPPA1
end
if
    02BD:   debug_mode == DEBUG_MASTEREXTRAS2
then
    if and
        $FLAG_KAPPA2_DEAD == 0
        $FLAG_KAPPA2_CREATED == 1
    then
        0164: remove_blip $BLIP_KAPPA2
    end
    if and
        $FLAG_KAPPA8_DEAD == 0
        $FLAG_KAPPA8_CREATED == 1
    then
        0164: remove_blip $BLIP_KAPPA8
    end
    if and
        $FLAG_KAPPA11_DEAD == 0
        $FLAG_KAPPA11_CREATED == 1
    then
        0164: remove_blip $BLIP_KAPPA11
    end
end
if and
    0038:   $FLAG_KAPPA3_DEAD == 0
    0038:   $FLAG_KAPPA3_CREATED == 1
then
    0164: remove_blip $BLIP_KAPPA3
end
if and
    0038:   $FLAG_KAPPA4_DEAD == 0
    0038:   $FLAG_KAPPA4_CREATED == 1
then
    0164: remove_blip $BLIP_KAPPA4
end
if and
    0038:   $FLAG_KAPPA5_DEAD == 0
    0038:   $FLAG_KAPPA5_CREATED == 1
then
    0164: remove_blip $BLIP_KAPPA5
end
if and
    0038:   $FLAG_KAPPA6_DEAD == 0
    0038:   $FLAG_KAPPA6_CREATED == 1
then
    0164: remove_blip $BLIP_KAPPA6
end
if and
    0038:   $FLAG_KAPPA7_DEAD == 0
    0038:   $FLAG_KAPPA7_CREATED == 1
then
    0164: remove_blip $BLIP_KAPPA7
end
if and
    0038:   $FLAG_KAPPA9_DEAD == 0
    0038:   $FLAG_KAPPA9_CREATED == 1
then
    0164: remove_blip $BLIP_KAPPA9
end
if and
    0038:   $FLAG_KAPPA10_DEAD == 0
    0038:   $FLAG_KAPPA10_CREATED == 1
then
    0164: remove_blip $BLIP_KAPPA10
end
if and
    0038:   $FLAG_KAPPA12_DEAD == 0
    0038:   $FLAG_KAPPA12_CREATED == 1
then
    0164: remove_blip $BLIP_KAPPA12
end
031A: remove_all_fires
01C4: remove_references_to_object $KAPPA_1  // This object will now disappear when the player looks away
01C4: remove_references_to_object $KAPPA_2  // This object will now disappear when the player looks away
01C4: remove_references_to_object $KAPPA_3  // This object will now disappear when the player looks away
01C4: remove_references_to_object $KAPPA_4  // This object will now disappear when the player looks away
01C4: remove_references_to_object $KAPPA_5  // This object will now disappear when the player looks away
01C4: remove_references_to_object $KAPPA_6  // This object will now disappear when the player looks away
01C4: remove_references_to_object $KAPPA_7  // This object will now disappear when the player looks away
01C4: remove_references_to_object $KAPPA_8  // This object will now disappear when the player looks away
01C4: remove_references_to_object $KAPPA_9  // This object will now disappear when the player looks away
01C4: remove_references_to_object $KAPPA_10  // This object will now disappear when the player looks away
01C4: remove_references_to_object $KAPPA_11  // This object will now disappear when the player looks away
01C4: remove_references_to_object $KAPPA_12  // This object will now disappear when the player looks away
0249: mark_model_as_no_longer_needed #COLUMB
0249: mark_model_as_no_longer_needed #COFFEE
0249: mark_model_as_no_longer_needed #GANG11
0249: mark_model_as_no_longer_needed #GANG12
mission_cleanup
return
