//-------------Mission 13-------------
// Originally: Vigilante sub-mission

:M13_VIGILANTE
03A4: name_thread 'COPCAR'
054C: use_GXT_table 'COPCAR'
gosub @MISSION_START_COP_CAR
gosub @COP_CAR_FAILED
end_thread

:MISSION_START_COP_CAR
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_VIGILANTE_MISSION = 1
0004: $VIGILANTE_BONUS_KILLS = 5
0004: $TOTAL_CRIMINALS_KILLED = 0
0004: $GOT_COP_BREIF = 0
wait 0 ms

:NEXT_COP_CAR
0004: $GOT_RANGE_MESSAGE = 0
0004: $PLAYER_IN_RANGE = 0
0004: $CAR_MODEL = 0
0004: $CRIMINAL_CAR = 0
0004: $CRIMINAL_CREATED_FLAG = 0
0004: $CRIMINAL = 0
0004: $CRIMINAL_BLIP = 0
0004: $RANDOM_GUN = 0
0004: $COP_TIME_LIMIT = 0
0004: $GOT_CAR_CRIM_IS_IN = 0
0004: $TIMER_RESET_FLAG = 0
0004: $GAME_TIME_FLAG = 0
0004: $MISSION_END_BUTTON = 0
0004: $VIGILANTE_ISLAND_CRIMINAL_IS_ON = 0
0004: $VIGILANTE_MISSION_ENDED = 0
0005: $PLAYER_C_X = 0.0
0005: $PLAYER_C_Y = 0.0
0005: $PLAYER_C_Z = 0.0
0005: $RANDOM_CRIM_X = 0.0
0005: $RANDOM_CRIM_Y = 0.0
0005: $CRIMINAL_COORD_X = 0.0
0005: $CRIMINAL_COORD_Y = 0.0
0005: $CRIMINAL_COORD_Z = 0.0
0005: $DIFF_X_FLOAT = 0.0
0005: $DIFF_Y_FLOAT = 0.0
0005: $SUM_OF_DIFF_XY = 0.0
0005: $PLAYERS_DISTANCE_FROM_CRIMINAL = 0.0
0005: $COP_TIME_LIMIT_FLOAT = 0.0
0005: $CRIMINAL_HEADING = 0.0
0054: store_player $PLAYER position_to $PLAYER_C_X $PLAYER_C_Y $PLAYER_C_Z
if
    00E0:   player $PLAYER driving
then
    03C1: $VIGILANTE_CAR = player $PLAYER car
    053F: set_car $VIGILANTE_CAR tires_vulnerable 0
end
0247: request_model #SENTINEL

:CRIMINAL_IN_CAR
wait 0 ms
if
    0038:   $GOT_COP_BREIF == 0
then
    00BC: print_now 'LEGAL' 3000 ms 1   // ~g~Eliminate the criminal threat!
    0006: 17@ = 0
    0004: $GOT_COP_BREIF = 1
else
    0006: 17@ = 3000
end
if
    03C6:   is_collision_in_memory 1
then
    0208: $RANDOM_CRIM_X = random_float 443.0 1205.0
    0208: $RANDOM_CRIM_Y = random_float -1110.0 190.0
    0004: $GOT_RANGE_MESSAGE = 0
    0004: $PLAYER_IN_RANGE = 1
    0004: $VIGILANTE_ISLAND_CRIMINAL_IS_ON = 1
end
if
    03C6:   is_collision_in_memory 2
then
    0208: $RANDOM_CRIM_X = random_float -527.0 210.0
    0208: $RANDOM_CRIM_Y = random_float -1626.0 98.0
    0004: $GOT_RANGE_MESSAGE = 0
    0004: $PLAYER_IN_RANGE = 1
    0004: $VIGILANTE_ISLAND_CRIMINAL_IS_ON = 2
end
if
    03C6:   is_collision_in_memory 3
then
    0208: $RANDOM_CRIM_X = random_float -1635.0 -749.0
    0208: $RANDOM_CRIM_Y = random_float -608.75 380.0
    0004: $GOT_RANGE_MESSAGE = 0
    0004: $PLAYER_IN_RANGE = 1
    0004: $VIGILANTE_ISLAND_CRIMINAL_IS_ON = 3
end
if
    0038:   $PLAYER_IN_RANGE == 0
then
    if
        0038:   $GOT_RANGE_MESSAGE == 0
    then
        00BC: print_now 'C_RANGE' 5000 ms 1
        0004: $GOT_RANGE_MESSAGE = 1
    end
    jump @COP_CAR_FAILED
end
gosub @COPCAR_CANCELLED_CHECKS
if
    0038:   $VIGILANTE_MISSION_ENDED == 1
then
    jump @COP_CAR_FAILED
end
02C1: set $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z to_car_path_coords_closest_to $RANDOM_CRIM_X $RANDOM_CRIM_Y $PLAYER_C_Z
if and
    0020:   $CRIMINAL_COORD_X > 1063.0     // COLOMBIAN BOAT
    0022:   1280.0 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > -965.0
    0022:   -902.0 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > 544.0       // BACK OF LUIGI'S
    0022:   557.0 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > -427.0
    0022:   -407.0 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > 609.75        // FISH FACTORY
    0022:   682.063 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > -1148.75
    0022:   -1076.563 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > 585.75         // CHINATOWN MARKET
    0022:   669.0 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > -754.1875
    0022:   -670.0 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > 335.0       // CALAHAN BRIDGE
    0022:   700.0 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > -953.0
    0022:   -912.0 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > 1029.0        // DOCKS INDUSTRIAL
    0022:   1306.0 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > -1165.0
    0022:   -617.0 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > 314.0        // TUNNEL ENTRANCE INDUSTRIAL
    0022:   731.0 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > 25.0
    0022:   217.0 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > -1946.5       // AIRPORT SUBURBAN
    0022:   -1080.25 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > -1001.875
    0022:   -371.1875 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > 604.75          // OLD SCHOOL HALL AND PARK AREA
    0022:   700.563 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > -901.25
    0022:   -828.1875 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > 880.25          // DOG FOOD FACTORY
    0022:   888.688 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > -839.375
    0022:   -763.5625 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > 510.25         // INDUSTRIAL SAFEHOUSE
    0022:   564.5625 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > -312.5625
    0022:   -295.6875 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > -448.25        // DOJO COMMERCIAL
    0022:   -236.6875 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > -1284.75
    0022:   -1273.0 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > -317.3125     // COLOMBIAN OJG COMPOUND
    0022:   -243.0 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > -388.6875
    0022:   -312.375 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > -1590.375       // BAIT WAREHOUSE CARPARK SUBURBIA
    0022:   -1522.875 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > 80.5625
    0022:   123.375 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if and
    0020:   $CRIMINAL_COORD_X > 1051.375        // FRANKIES HOUSE
    0022:   1140.75 > $CRIMINAL_COORD_X
    0020:   $CRIMINAL_COORD_Y > -292.0625
    0022:   -168.0 > $CRIMINAL_COORD_Y
then
    jump @CRIMINAL_IN_CAR
end
if
    0038:   $VIGILANTE_ISLAND_CRIMINAL_IS_ON == 1   // INDUSTRIAL
then
    if or
        8020:   NOT   $CRIMINAL_COORD_X > 443.0
        8022:   NOT   1205.0 > $CRIMINAL_COORD_X
        8020:   NOT   $CRIMINAL_COORD_Y > -1110.0
        8022:   NOT   190.0 > $CRIMINAL_COORD_Y
    then
        jump @CRIMINAL_IN_CAR
    end
end
if
    0038:   $VIGILANTE_ISLAND_CRIMINAL_IS_ON == 2   // COMMERCIAL
then
    if or
        8020:   NOT   $CRIMINAL_COORD_X > -527.0
        8022:   NOT   210.0 > $CRIMINAL_COORD_X
        8020:   NOT   $CRIMINAL_COORD_Y > -1626.0
        8022:   NOT   98.0 > $CRIMINAL_COORD_Y
    then
        jump @CRIMINAL_IN_CAR
    end
end
if
    0038:   $VIGILANTE_ISLAND_CRIMINAL_IS_ON == 3    //SUBURBIA
then
    if or
        8020:   NOT   $CRIMINAL_COORD_X > -1635.0
        8022:   NOT   -749.0 > $CRIMINAL_COORD_X
        8020:   NOT   $CRIMINAL_COORD_Y > -608.75
        8022:   NOT   380.0 > $CRIMINAL_COORD_Y
    then
        jump @CRIMINAL_IN_CAR
    end
end
if
    0022:   -1.0 > $CRIMINAL_COORD_Z
then
    jump @CRIMINAL_IN_CAR
end
0086: $DIFF_X_FLOAT = $PLAYER_C_X
0061: $DIFF_X_FLOAT -= $CRIMINAL_COORD_X
0086: $DIFF_Y_FLOAT = $PLAYER_C_Y
0061: $DIFF_Y_FLOAT -= $CRIMINAL_COORD_Y
0069: $DIFF_X_FLOAT *= $DIFF_X_FLOAT
0069: $DIFF_Y_FLOAT *= $DIFF_Y_FLOAT
0086: $SUM_OF_DIFF_XY = $DIFF_X_FLOAT
0059: $SUM_OF_DIFF_XY += $DIFF_Y_FLOAT
01FB: $PLAYERS_DISTANCE_FROM_CRIMINAL = square_root $SUM_OF_DIFF_XY
if
    0022:   150.0 > $PLAYERS_DISTANCE_FROM_CRIMINAL
then
    jump @CRIMINAL_IN_CAR
end
0086: $COP_TIME_LIMIT_FLOAT = $PLAYERS_DISTANCE_FROM_CRIMINAL
0015: $COP_TIME_LIMIT_FLOAT /= 4.0
0011: $COP_TIME_LIMIT_FLOAT *= 1000.0
008C: $COP_TIME_LIMIT = float_to_integer $COP_TIME_LIMIT_FLOAT
if
    001A:   120000 > $COP_TIME_LIMIT
then
    0004: $COP_TIME_LIMIT = 120000
end

:GENERATE_CAR_MODEL
wait 0 ms
0209: $CAR_MODEL = random_int 130 229
if and
    8038:   NOT   $CAR_MODEL == #LANDSTAL
    8038:   NOT   $CAR_MODEL == #IDAHO
    8038:   NOT   $CAR_MODEL == #LINERUN
    8038:   NOT   $CAR_MODEL == #PEREN
    8038:   NOT   $CAR_MODEL == #SENTINEL
    8038:   NOT   $CAR_MODEL == #TRASH
    8038:   NOT   $CAR_MODEL == #STRETCH
then
    if and
        8038:   NOT   $CAR_MODEL == #MANANA
        8038:   NOT   $CAR_MODEL == #INFERNUS
        8038:   NOT   $CAR_MODEL == #YARDIE
        8038:   NOT   $CAR_MODEL == #PONY
        8038:   NOT   $CAR_MODEL == #MULE
        8038:   NOT   $CAR_MODEL == #MOONBEAM
        8038:   NOT   $CAR_MODEL == #ESPERANT
    then
        if and
            8038:   NOT   $CAR_MODEL == #TAXI
            8038:   NOT   $CAR_MODEL == #MAFIA
            8038:   NOT   $CAR_MODEL == #BOBCAT
            8038:   NOT   $CAR_MODEL == #MRWHOOP
            8038:   NOT   $CAR_MODEL == #CABBIE
            8038:   NOT   $CAR_MODEL == #STALLION
            8038:   NOT   $CAR_MODEL == #RUMPO
        then
            if and
                8038:   NOT   $CAR_MODEL == #KURUMA
                8038:   NOT   $CAR_MODEL == #HOODS
                8038:   NOT   $CAR_MODEL == #PATRIOT
                8038:   NOT   $CAR_MODEL == #DIABLOS
                8038:   NOT   $CAR_MODEL == #YAKUZA
                8038:   NOT   $CAR_MODEL == #STINGER
                8038:   NOT   $CAR_MODEL == #CHEETAH
            then
                if and
                    8038:   NOT   $CAR_MODEL == #COLUMB
                    8038:   NOT   $CAR_MODEL == #BLISTA
                    8038:   NOT   $CAR_MODEL == #BELLYUP
                    8038:   NOT   $CAR_MODEL == #MRWONGS
                then
                    jump @GENERATE_CAR_MODEL
                end
            end
        end
    end
end
0247: request_model $CAR_MODEL
while 8248:   NOT   model $CAR_MODEL available
    wait 0 ms
    gosub @COPCAR_CANCELLED_CHECKS
    if
        0038:   $VIGILANTE_MISSION_ENDED == 1
    then
        jump @COP_CAR_FAILED
    end
end
0208: $CRIMINAL_HEADING = random_float 0.0 359.9
while 8019:   NOT   17@ > 3000
    wait 0 ms
    gosub @COPCAR_CANCELLED_CHECKS
    if
        0038:   $VIGILANTE_MISSION_ENDED == 1
    then
        jump @COP_CAR_FAILED
    end
end
00A5: $CRIMINAL_CAR = create_car $CAR_MODEL at $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z
0428: set_car_avoid_level_transitions $CRIMINAL_CAR flag 1
0224: set_car $CRIMINAL_CAR health_to 800
0249: mark_model_as_no_longer_needed $CAR_MODEL
0175: set_car $CRIMINAL_CAR z_angle_to $CRIMINAL_HEADING
02C0: set $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z to_ped_path_coords_closest_to $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z
0376: $CRIMINAL = create_random_actor $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z
0433: set_char_is_chris_criminal $CRIMINAL 1
036A: put_actor $CRIMINAL in_car $CRIMINAL_CAR
0319: set_actor $CRIMINAL running 1
02A9: set_actor $CRIMINAL immune_to_nonplayer 1
01ED: reset_actor $CRIMINAL flags
0243: set_actor $CRIMINAL ped_stats_to 16
011A: set_actor $CRIMINAL flags 1
011A: set_actor $CRIMINAL flags 2
011A: set_actor $CRIMINAL flags 4
011A: set_actor $CRIMINAL flags 8
011A: set_actor $CRIMINAL flags 16
011A: set_actor $CRIMINAL flags 32
011A: set_actor $CRIMINAL flags 64
011A: set_actor $CRIMINAL flags 128
011A: set_actor $CRIMINAL flags 512
011A: set_actor $CRIMINAL flags 256
011A: set_actor $CRIMINAL flags 2048
011A: set_actor $CRIMINAL flags 4096
011A: set_actor $CRIMINAL flags 16384
011A: set_actor $CRIMINAL flags 1024
011A: set_actor $CRIMINAL flags 65536
011A: set_actor $CRIMINAL flags 131072
011A: set_actor $CRIMINAL flags 262144
011A: set_actor $CRIMINAL flags 1048576
011A: set_actor $CRIMINAL flags 2097152
011A: set_actor $CRIMINAL flags 4194304
011A: set_actor $CRIMINAL flags 16777216
0291: set_char_heed_threats $CRIMINAL  1
01C3: remove_references_to_car $CRIMINAL_CAR  // Like turning a car into any random car
0209: $RANDOM_GUN = random_int 0 31
if
    03C6:   is_collision_in_memory 1
    //0038:   $FLAG_STAUNTON_OPEN == 0         // 0 to 5 in III
then
    while true
        if and
            8038:  NOT  $RANDOM_GUN == 0         // fist            0
            8038:  NOT  $RANDOM_GUN == 6         // bat             1
            8038:  NOT  $RANDOM_GUN == 17        // pistol          2
            8038:  NOT  $RANDOM_GUN == 23        // uzi             3
            8038:  NOT  $RANDOM_GUN == 21        // shotgun         4
            8038:  NOT  $RANDOM_GUN == 27        // ak47            5
        jf break
        wait 0 ms
        0209: $RANDOM_GUN = random_int 0 25
    end
end
if
    03C6:   is_collision_in_memory 2
    //0038:   $FLAG_STAUNTON_OPEN == 1         // 2 to 6 in III
then
    while true
        if and
            8038:  NOT  $RANDOM_GUN == 17        // pistol          2
            8038:  NOT  $RANDOM_GUN == 23        // uzi             3
            8038:  NOT  $RANDOM_GUN == 21        // shotgun         4
            8038:  NOT  $RANDOM_GUN == 27        // ak47            5
            8038:  NOT  $RANDOM_GUN == 26        // m16             6
        jf break
        wait 0 ms
        0209: $RANDOM_GUN = random_int 17 26
    end
end
if
    03C6:   is_collision_in_memory 3
    //0038:   $FLAG_SHORESIDE_OPEN == 1        //3 to 10 in III
then
    while true
        if and
            8038:  NOT  $RANDOM_GUN == 23        // uzi             3
            8038:  NOT  $RANDOM_GUN == 21        // shotgun         4
            8038:  NOT  $RANDOM_GUN == 27        // ak47            5
            8038:  NOT  $RANDOM_GUN == 26        // m16             6
            //8038:  NOT  $RANDOM_GUN == 28        // sniper          7  criminal will not fire this gun
            //8038:  NOT  $RANDOM_GUN == 30        // rocket          8  criminal will not fire this gun
            8038:  NOT  $RANDOM_GUN == 31        // flamethrower    9    unknown
            //8038:  NOT  $RANDOM_GUN == 15        // molotov         10 criminal will not fire this gun
        jf break
        wait 0 ms
        0209: $RANDOM_GUN = random_int 21 31
    end
end
01B2: give_actor $CRIMINAL weapon $RANDOM_GUN ammo 1000  // Load the weapon model before using this
0187: $CRIMINAL_BLIP = create_marker_above_actor $CRIMINAL
03E6: remove_text_box
if
    0038:   $GOT_SIREN_HELP_BEFORE == 0
then
    if and // added additional checks
        80DE:   not player $PLAYER driving_vehicle_type #HUNTER
        80DE:   not player $PLAYER driving_vehicle_type #RHINO
    then
        if
            82BD:   NOT   debug_mode == DEBUG_SKIPHELP
        then
            0293: $CONTROLMODE = current_controls
            if
                0038:   $CONTROLMODE == 0
            then
                03E5: text_box 'SIREN_1'
            end
            if
                0038:   $CONTROLMODE == 1
            then
                03E5: text_box 'SIREN_2'
            end
            if
                0038:   $CONTROLMODE == 2
            then
                03E5: text_box 'SIREN_3'
            end
            if
                0038:   $CONTROLMODE == 3
            then
                03E5: text_box 'SIREN_4'
            end
        end
        0004: $GOT_SIREN_HELP_BEFORE = 1
    end
end
if
    0154:   actor $CRIMINAL in_zone 'PORT_W'
then
    0384: text_1string 'C_BREIF' 'PORT_W' 5000 ms 1   // Callahan Point
end
if
    0154:   actor $CRIMINAL in_zone 'PORT_S'
then
    0384: text_1string 'C_BREIF' 'PORT_S' 5000 ms 1   // Atlantic Quays
end
if
    0154:   actor $CRIMINAL in_zone 'PORT_E'
then
    0384: text_1string 'C_BREIF' 'PORT_E' 5000 ms 1   // Portland Harbor
end
if
    0154:   actor $CRIMINAL in_zone 'PORT_I'
then
    0384: text_1string 'C_BREIF' 'PORT_I' 5000 ms 1   // Trenton
end
if
    0154:   actor $CRIMINAL in_zone 'S_VIEW'
then
    0384: text_1string 'C_BREIF' 'S_VIEW' 5000 ms 1   // Portland View
end
if
    0154:   actor $CRIMINAL in_zone 'CHINA'
then
    0384: text_1string 'C_BREIF' 'CHINA' 5000 ms 1   // Chinatown
end
if
    0154:   actor $CRIMINAL in_zone 'EASTBAY'
then
    0384: text_1string 'C_BREIF' 'EASTBAY' 5000 ms 1   // Portland Beach
end
if
    0154:   actor $CRIMINAL in_zone 'LITTLEI'
then
    0384: text_1string 'C_BREIF' 'LITTLEI' 5000 ms 1   // Saint Mark's
end
if
    0154:   actor $CRIMINAL in_zone 'REDLIGH'
then
    0384: text_1string 'C_BREIF' 'REDLIGH' 5000 ms 1   // Redlight District
end
if
    0154:   actor $CRIMINAL in_zone 'TOWERS'
then
    0384: text_1string 'C_BREIF' 'TOWERS' 5000 ms 1   // Hepburn Heights
end
if
    0154:   actor $CRIMINAL in_zone 'HARWOOD'
then
    0384: text_1string 'C_BREIF' 'HARWOOD' 5000 ms 1   // Harwood
end
if
    0154:   actor $CRIMINAL in_zone 'ROADBR1'
then
    0384: text_1string 'C_BREIF' 'ROADBR1' 5000 ms 1   // Callahan Bridge
end
if
    0154:   actor $CRIMINAL in_zone 'ROADBR2'
then
    0384: text_1string 'C_BREIF' 'ROADBR2' 5000 ms 1   // Callahan Bridge
end
if
    0154:   actor $CRIMINAL in_zone 'STADIUM'
then
    0384: text_1string 'C_BREIF' 'STADIUM' 5000 ms 1   // Aspatria
end
if
    0154:   actor $CRIMINAL in_zone 'HOSPI_2'
then
    0384: text_1string 'C_BREIF' 'HOSPI_2' 5000 ms 1   // Rockford
end
if
    0154:   actor $CRIMINAL in_zone 'UNIVERS'
then
    0384: text_1string 'C_BREIF' 'UNIVERS' 5000 ms 1   // Liberty Campus
end
if
    0154:   actor $CRIMINAL in_zone 'CONSTRU'
then
    0384: text_1string 'C_BREIF' 'CONSTRU' 5000 ms 1   // Fort Staunton
end
if
    0154:   actor $CRIMINAL in_zone 'PARK'
then
    0384: text_1string 'C_BREIF' 'PARK' 5000 ms 1   // Belleville Park
end
if
    0154:   actor $CRIMINAL in_zone 'COM_EAS'
then
    0384: text_1string 'C_BREIF' 'COM_EAS' 5000 ms 1   // Newport
end
if
    0154:   actor $CRIMINAL in_zone 'SHOPING'
then
    0384: text_1string 'C_BREIF' 'SHOPING' 5000 ms 1   // Bedford Point
end
if
    0154:   actor $CRIMINAL in_zone 'YAKUSA'
then
    0384: text_1string 'C_BREIF' 'YAKUSA' 5000 ms 1   // Torrington
end
if
    0154:   actor $CRIMINAL in_zone 'AIRPORT'
then
    0384: text_1string 'C_BREIF' 'AIRPORT' 5000 ms 1   // Francis Intl. Airport
end
if
    0154:   actor $CRIMINAL in_zone 'PROJECT'
then
    0384: text_1string 'C_BREIF' 'PROJECT' 5000 ms 1   // Wichita Gardens
end
if
    0154:   actor $CRIMINAL in_zone 'SUB_IND'
then
    0384: text_1string 'C_BREIF' 'SUB_IND' 5000 ms 1   // Pike Creek
end
if
    0154:   actor $CRIMINAL in_zone 'SWANKS'
then
    0384: text_1string 'C_BREIF' 'SWANKS' 5000 ms 1   // Cedar Grove
end
if
    0154:   actor $CRIMINAL in_zone 'BIG_DAM'
then
    0384: text_1string 'C_BREIF' 'BIG_DAM' 5000 ms 1   // Cochrane Dam
end
00A0: store_actor $CRIMINAL position_to $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z
03AA: police_radio_message $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z
0006: 17@ = 0
014E: set_timer_to $COP_TIME_LIMIT type 1
0396: freeze_onscreen_timer 0
while 8118:   NOT   actor $CRIMINAL dead
    if
        001A:   1 > $COP_TIME_LIMIT
    then
        if
            80E9:   NOT   player $PLAYER 0 near_actor $CRIMINAL radius 100.0 100.0
        then
            0164: remove_blip $CRIMINAL_BLIP
            009B: destroy_actor_instantly $CRIMINAL
            0004: $CRIMINAL_CREATED_FLAG = 0
            00BC: print_now 'C_ESCP' 3000 ms 1   // ~r~The suspect has escaped!
        else
            00BC: print_now 'C_TIME' 3000 ms 1   // ~r~Your time as a law enforcer is over!
        end
        jump @COP_CAR_FAILED
    end
    gosub @COPCAR_CANCELLED_CHECKS
    if
        0038:   $VIGILANTE_MISSION_ENDED == 1
    then
        jump @COP_CAR_FAILED
    end
    if
        0038:   $GOT_CAR_CRIM_IS_IN == 0
    then
        if
            8184:   NOT   actor $CRIMINAL health >= 70
        then
            0377: set_actor $CRIMINAL objective_to-32  //SET_CHAR_OBJ_STEAL_ANY_CAR
        end
    end
    if and
        00DF:   actor $CRIMINAL driving
        0038:   $GOT_CAR_CRIM_IS_IN == 0
    then
        01C3: remove_references_to_car $CRIMINAL_CAR  // Like turning a car into any random car
        00D9: $CRIMINAL_CAR = actor $CRIMINAL car
        03ED: set_upsidedown_car_not_damaged $CRIMINAL_CAR 1
        00AE: set_car $CRIMINAL_CAR driving_style 2  // DRIVINGMODE_AVOIDCARS
        00AD: set_car $CRIMINAL_CAR max_speed_to 42.0
        00A8: set_car $CRIMINAL_CAR to_psycho_driver
        0428: set_car_avoid_level_transitions $CRIMINAL_CAR flag 1
        0004: $GOT_CAR_CRIM_IS_IN = 1
    end
    if
        0038:   $GOT_CAR_CRIM_IS_IN == 1
    then
        if
            80DF:   NOT   actor $CRIMINAL driving
        then
            0209: $RANGE_INT = random_int 0 5
            if
                0038:   $RANGE_INT == 0
            then
                01CE: actor $CRIMINAL avoid_player $PLAYER
            end
            if
                0038:   $RANGE_INT == 1
            then
                if
                    00E9:   player $PLAYER 0 near_actor $CRIMINAL radius 150.0 150.0
                then
                    0377: set_actor $CRIMINAL objective_to-32
                else
                    if
                        0248:   model #SENTINEL available
                    then
                        00A0: store_actor $CRIMINAL position_to $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z
                        03D3: point $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z get_nearby_vector $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z $WARP_HEADING_COP
                        01C3: remove_references_to_car $CRIMINAL_CAR  // Like turning a car into any random car
                        00A5: $CRIMINAL_CAR = create_car #SENTINEL at $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z
                        0175: set_car $CRIMINAL_CAR z_angle_to $WARP_HEADING_COP
                        01D5: actor $CRIMINAL go_to_and_drive_car $CRIMINAL_CAR
                    else
                        0377: set_actor $CRIMINAL objective_to-32
                    end
                end
            end
            if
                0038:   $RANGE_INT == 2
            then
                01CC: actor $CRIMINAL kill_player $PLAYER
            end
            if
                0038:   $RANGE_INT == 3
            then
                if
                    00E0:   player $PLAYER driving
                then
                    03C1: $VIGILANTE_CAR = player $PLAYER car
                    01D9: actor $CRIMINAL destroy_car $VIGILANTE_CAR
                else
                    01CC: actor $CRIMINAL kill_player $PLAYER
                end
            end
            if
                0038:   $RANGE_INT == 4
            then
                0209: $RANGE_INT = random_int 0 8
                009C: set_actor $CRIMINAL wander_path_to -1
            end
            0004: $GOT_CAR_CRIM_IS_IN = 0
        end
    end
    if
        0038:   $GOT_CAR_CRIM_IS_IN == 1
    then
        if
            8119:   NOT   car $CRIMINAL_CAR wrecked
        then
            if
                0019:   17@ > 1000
            then
                0006: 17@ = 0
                if
                    00E9:   player $PLAYER 0 near_actor $CRIMINAL radius 20.0 20.0
                then
                    00AD: set_car $CRIMINAL_CAR max_speed_to 46.0
                else
                    if
                        00E9:   player $PLAYER 0 near_actor $CRIMINAL radius 50.0 50.0
                    then
                        00AD: set_car $CRIMINAL_CAR max_speed_to 39.0
                    else
                        if
                            00E9:   player $PLAYER 0 near_actor $CRIMINAL radius 90.0 90.0
                        then
                            00AD: set_car $CRIMINAL_CAR max_speed_to 32.0
                        else
                            if
                                00E9:   player $PLAYER 0 near_actor $CRIMINAL radius 130.0 130.0
                            then
                                00AD: set_car $CRIMINAL_CAR max_speed_to 26.0
                            else
                                00AD: set_car $CRIMINAL_CAR max_speed_to 18.0
                            end
                        end
                    end
                end
            end
            if
                01C1:   car $CRIMINAL_CAR stopped
            then
                if
                    0038:   $TIMER_RESET_FLAG == 0
                then
                    0006: 16@ = 0
                    0004: $TIMER_RESET_FLAG = 1
                end
                if and
                    0019:   16@ > 8000
                    0038:   $TIMER_RESET_FLAG == 1
                then
                    if
                        00E9:   player $PLAYER 0 near_actor $CRIMINAL radius 90.0 90.0
                    then
                        01D3: actor $CRIMINAL leave_car $CRIMINAL_CAR
                        0004: $TIMER_RESET_FLAG = 0
                    else
                        if
                            82CA:   NOT   car $CRIMINAL_CAR bounding_sphere visible
                        then
                            00AA: store_car $CRIMINAL_CAR position_to $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z
                            03D3: point $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z get_nearby_vector $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z $WARP_HEADING_COP
                            if
                                80C2:   NOT   sphere onscreen $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z 4.0
                            then
                                00AB: put_car $CRIMINAL_CAR at $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z
                                0175: set_car $CRIMINAL_CAR z_angle_to $WARP_HEADING_COP
                                0004: $TIMER_RESET_FLAG = 0
                            end
                        end
                    end
                end
            end
            if and
                01F4:   car $CRIMINAL_CAR flipped
                01C1:   car $CRIMINAL_CAR stopped
            then
                if
                    00E9:   player $PLAYER 0 near_actor $CRIMINAL radius 90.0 90.0
                then
                    01D3: actor $CRIMINAL leave_car $CRIMINAL_CAR
                    03ED: set_upsidedown_car_not_damaged $CRIMINAL_CAR 0
                else
                    if
                        82CA:   NOT   car $CRIMINAL_CAR bounding_sphere visible
                    then
                        00AA: store_car $CRIMINAL_CAR position_to $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z
                        03D3: point $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z get_nearby_vector $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z $WARP_HEADING_COP
                        if
                            80C2:   NOT   sphere onscreen $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z 4.0
                        then
                            00AB: put_car $CRIMINAL_CAR at $CRIMINAL_COORD_X $CRIMINAL_COORD_Y $CRIMINAL_COORD_Z
                            0175: set_car $CRIMINAL_CAR z_angle_to $WARP_HEADING_COP
                        end
                    end
                end
            end
            if
                8185:   NOT   car $CRIMINAL_CAR health >= 250
            then
                01D3: actor $CRIMINAL leave_car $CRIMINAL_CAR
            end
        end
    end
    wait 0 ms
end //while
01C2: remove_references_to_actor $CRIMINAL  // Like turning an actor into a random pedestrian
01C3: remove_references_to_car $CRIMINAL_CAR  // Like turning a car into any random car
0008: $TOTAL_CRIMINALS_KILLED += 1
0402: increment_criminals_stopped
018C: play_sound 1 at 0.0 0.0 0.0
if
    0038:   $TOTAL_CRIMINALS_KILLED == 1
then
    03C4: set_status_text_to $TOTAL_CRIMINALS_KILLED 0 (number)  'KILLS'   // KILLS:
end
0164: remove_blip $CRIMINAL_BLIP
0084: $VIGILANTE_REWARD = $TOTAL_CRIMINALS_KILLED
0010: $VIGILANTE_REWARD *= 500
00BA: text_styled 'C_PASS' 5000 ms 5   // THREAT ELIMINATED: $ ~1~
01E3: text_1number_styled 'REWARD' $VIGILANTE_REWARD 5000 ms 6   // REWARD $~1~
0109: player $PLAYER money += $VIGILANTE_REWARD
if
    003A:   $TOTAL_CRIMINALS_KILLED == $VIGILANTE_BONUS_KILLS
then
    0084: $VIGILANTE = $TOTAL_CRIMINALS_KILLED
    0010: $VIGILANTE *= 2
    0010: $VIGILANTE *= 500
    0217: text_styled 'C_VIGIL' 5000 ms 5   // VIGILANTE BONUS!!
    0218: print_with_number_big_q 'REWARD' $VIGILANTE 6000 ms 6   // REWARD $~1~
    0109: player $PLAYER money += $VIGILANTE
    0008: $VIGILANTE_BONUS_KILLS += 5
end
if
    0038:   $VIGILANTE_ISLAND_CRIMINAL_IS_ON == 1
then
    0008: $PORTLAND_VIGILANTES_DONE += 1
end
if
    0038:   $VIGILANTE_ISLAND_CRIMINAL_IS_ON == 2
then
    0008: $STAUNTON_VIGILANTES_DONE += 1
end
if
    0038:   $VIGILANTE_ISLAND_CRIMINAL_IS_ON == 3
then
    0008: $SHORESIDE_VIGILANTES_DONE += 1
end
if
    0038:   $NUM_PORTLAND_POLICE_BRIBES_AT_HIDEOUT == 0
then
    if
        0038:   $PORTLAND_VIGILANTES_DONE == 10
    then
        014D: add_pager_message 'PAGEB12'  140  100  1    //this section of code definitely runs, but pager does not show
        030C: set_mission_points += 1
        0004: $NUM_PORTLAND_POLICE_BRIBES_AT_HIDEOUT = 1
    end
end
if
    0038:   $NUM_PORTLAND_POLICE_BRIBES_AT_HIDEOUT == 1
then
    if
        0038:   $PORTLAND_VIGILANTES_DONE == 20
    then
        014D: add_pager_message 'PAGEB12'  140  100  1
        030C: set_mission_points += 1
        0004: $NUM_PORTLAND_POLICE_BRIBES_AT_HIDEOUT = 2
    end
end
if
    0038:   $NUM_STAUNTON_POLICE_BRIBES_AT_HIDEOUT == 0
then
    if
        0038:   $STAUNTON_VIGILANTES_DONE == 10
    then
        014D: add_pager_message 'PAGEB12'  140  100  1
        030C: set_mission_points += 1
        0004: $NUM_STAUNTON_POLICE_BRIBES_AT_HIDEOUT = 1
    end
end
if
    0038:   $NUM_STAUNTON_POLICE_BRIBES_AT_HIDEOUT == 1
then
    if
        0038:   $STAUNTON_VIGILANTES_DONE == 20
    then
        014D: add_pager_message 'PAGEB12'  140  100  1
        030C: set_mission_points += 1
        0004: $NUM_STAUNTON_POLICE_BRIBES_AT_HIDEOUT = 2
    end
end
if
    0038:   $NUM_SHORESIDE_POLICE_BRIBES_AT_HIDEOUT == 0
then
    if
        0038:   $SHORESIDE_VIGILANTES_DONE == 10
    then
        014D: add_pager_message 'PAGEB12'  140  100  1
        030C: set_mission_points += 1
        0004: $NUM_SHORESIDE_POLICE_BRIBES_AT_HIDEOUT = 1
    end
end
if
    0038:   $NUM_SHORESIDE_POLICE_BRIBES_AT_HIDEOUT == 1
then
    if
        0038:   $SHORESIDE_VIGILANTES_DONE == 20
    then
        014D: add_pager_message 'PAGEB12'  140  100  1
        030C: set_mission_points += 1
        0004: $NUM_SHORESIDE_POLICE_BRIBES_AT_HIDEOUT = 2
    end
end
while true
    if and
        80DE:   NOT   player $PLAYER driving_vehicle_type #POLICE
        80DE:   NOT   player $PLAYER driving_vehicle_type #ENFORCER
        80DE:   NOT   player $PLAYER driving_vehicle_type #VICECHEE
        80DE:   NOT   player $PLAYER driving_vehicle_type #HUNTER
        80DE:   NOT   player $PLAYER driving_vehicle_type #RHINO
        80DE:   NOT   player $PLAYER driving_vehicle_type #FBICAR
    jf break
    if
        0038:   $GAME_TIME_FLAG == 0
    then
        01BD: $GAME_TIMER_START = current_time_in_ms
        if
            0018:   $COP_TIME_LIMIT > 60000
        then
            0004: $COPCAR_TIMER = 60000
        else
            0084: $COPCAR_TIMER = $COP_TIME_LIMIT
        end
        0004: $GAME_TIME_FLAG = 1
    end
    01BD: $GAME_TIME_PRESENT = current_time_in_ms
    0084: $GAME_TIME_DIFFERENCE = $GAME_TIME_PRESENT
    0060: $GAME_TIME_DIFFERENCE -= $GAME_TIMER_START
    0060: $COPCAR_TIMER -= $GAME_TIME_DIFFERENCE
    0084: $GAME_TIMER_START = $GAME_TIME_PRESENT
    0084: $TIMER_IN_SECS = $COPCAR_TIMER
    0014: $TIMER_IN_SECS /= 1000
    01E5: text_1number_highpriority 'COPCART' $TIMER_IN_SECS 200 ms 1   // ~g~You have ~1~ seconds to return to a police vehicle before the mission ends.
    if
        001A:   1 > $TIMER_IN_SECS
    then
        00BC: print_now 'C_TIME' 3000 ms 1   // ~r~Your time as a law enforcer is over!
        jump @COP_CAR_FAILED
    end
    wait 0 ms
end //while
0396: freeze_onscreen_timer 1
if
    00E0:   player $PLAYER driving
then
    03C1: $VIGILANTE_CAR = player $PLAYER car
    053F: set_car $VIGILANTE_CAR tires_vulnerable 0
    0227: $PLAYERS_COP_CAR_HEALTH = car $VIGILANTE_CAR health
    0008: $PLAYERS_COP_CAR_HEALTH += 100
    0224: set_car $VIGILANTE_CAR health_to $PLAYERS_COP_CAR_HEALTH
end
//PASSED
014F: stop_timer $COP_TIME_LIMIT
0164: remove_blip $CRIMINAL_BLIP
if
    0038:   $CRIMINAL_CREATED_FLAG == 1
then
    01C2: remove_references_to_actor $CRIMINAL  // Like turning an actor into a random pedestrian
    0004: $CRIMINAL_CREATED_FLAG = 0
end
jump @NEXT_COP_CAR

:COP_CAR_FAILED
00BA: text_styled 'C_FAIL' 5000 ms 5   // Vigilante mission ended!
01E3: text_1number_styled 'C_KILLS' $TOTAL_CRIMINALS_KILLED 6000 ms 6   // CRIMINALS KILLED: ~1~
014F: stop_timer $COP_TIME_LIMIT
0151: remove_status_text $TOTAL_CRIMINALS_KILLED
0164: remove_blip $CRIMINAL_BLIP
03E6: remove_text_box
0249: mark_model_as_no_longer_needed #SENTINEL
0249: mark_model_as_no_longer_needed $CAR_MODEL
if
    0038:   $CRIMINAL_CREATED_FLAG == 1
then
    01C2: remove_references_to_actor $CRIMINAL  // Like turning an actor into a random pedestrian
    0004: $CRIMINAL_CREATED_FLAG = 0
end
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_VIGILANTE_MISSION = 0
mission_cleanup
return

:COPCAR_CANCELLED_CHECKS
if and
    80DE:   NOT   player $PLAYER driving_vehicle_type #POLICE
    80DE:   NOT   player $PLAYER driving_vehicle_type #ENFORCER
    80DE:   NOT   player $PLAYER driving_vehicle_type #VICECHEE
    80DE:   NOT   player $PLAYER driving_vehicle_type #HUNTER
    80DE:   NOT   player $PLAYER driving_vehicle_type #RHINO
    80DE:   NOT   player $PLAYER driving_vehicle_type #FBICAR
then
    0396: freeze_onscreen_timer 0   //not in original code
    if
        0038:   $GAME_TIME_FLAG == 0
    then
        01BD: $GAME_TIMER_START = current_time_in_ms
        if
            0018:   $COP_TIME_LIMIT > 60000
        then
            0004: $COPCAR_TIMER = 60000
        else
            0084: $COPCAR_TIMER = $COP_TIME_LIMIT
        end
        0004: $GAME_TIME_FLAG = 1
    end
    01BD: $GAME_TIME_PRESENT = current_time_in_ms
    0084: $GAME_TIME_DIFFERENCE = $GAME_TIME_PRESENT
    0060: $GAME_TIME_DIFFERENCE -= $GAME_TIMER_START
    0060: $COPCAR_TIMER -= $GAME_TIME_DIFFERENCE
    0084: $GAME_TIMER_START = $GAME_TIME_PRESENT
    0084: $TIMER_IN_SECS = $COPCAR_TIMER
    0014: $TIMER_IN_SECS /= 1000
    01E5: text_1number_highpriority 'COPCART' $TIMER_IN_SECS 200 ms 1   // ~g~You have ~1~ seconds to return to a police vehicle before the mission ends.
    if
        001A:   1 > $TIMER_IN_SECS
    then
        00BC: print_now 'C_TIME' 3000 ms 1   // ~r~Your time as a law enforcer is over!
        0004: $VIGILANTE_MISSION_ENDED = 1
        return
    end
end
0293: $CONTROLMODE = current_controls
if or
    00DE:   player $PLAYER driving_vehicle_type #POLICE
    00DE:   player $PLAYER driving_vehicle_type #ENFORCER
    00DE:   player $PLAYER driving_vehicle_type #VICECHEE
    00DE:   player $PLAYER driving_vehicle_type #HUNTER
    00DE:   player $PLAYER driving_vehicle_type #RHINO
    00DE:   player $PLAYER driving_vehicle_type #FBICAR
then
    if
        8038:   NOT   $CONTROLMODE == 3
    then
        if
            00E1:   key_pressed 0 19
        then
            0004: $MISSION_END_BUTTON = 1
        end
    else
        if
            00E1:   key_pressed 0 14
        then
            0004: $MISSION_END_BUTTON = 1
        end
    end
    0004: $GAME_TIME_FLAG = 0
end
if
    0038:   $MISSION_END_BUTTON == 1
then
    if
        8038:   NOT   $CONTROLMODE == 3
    then
        if
            80E1:   NOT   key_pressed 0 19
        then
            00BC: print_now 'C_CANC' 3000 ms 1   // ~r~Vigilante mission cancelled!
            0004: $VIGILANTE_MISSION_ENDED = 1
            return
        end
    else
        if
            80E1:   NOT   key_pressed 0 14
        then
            00BC: print_now 'C_CANC' 3000 ms 1   // ~r~Vigilante mission cancelled!
            0004: $VIGILANTE_MISSION_ENDED = 1
            return
        end
    end
end
return
