//-------------Mission 41-------------
// Originally: Diablos mission 2 'I SCREAM YOU SCREAM'

:M41_ISCREAMYOUSCREAM
03A4: name_thread 'DIABLO2'
054C: use_GXT_table 'DIABLO2'
gosub @MISSION_START_DIABLO2
if
    wasted_or_busted
then
    gosub @MISSION_DIABLO2_FAILED
end
gosub @MISSION_CLEANUP_DIABLO2
end_thread

:MISSION_START_DIABLO2
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_DIABLOS = 1
wait 0 ms
03DE: set_pedestrians_density_multiplier_to 0.0
042B: clear_peds_from_cube 555.25 -309.062 6.0 703.06 -133.875 16.0
023C: load_special_actor 1 'PLAYER'
while true
    if
        823D:   NOT   special_actor 1 loaded
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'EL_PH2'
0244: set_cutscene_pos 603.25 -229.5 10.0
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
016A: fade 1 (back)  1500 ms
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime

while 001A:   2000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB2_A' 10000 ms 1   // I started my exotic entertainment business with nothing but the sizeable contents of my leather pants!
while 001A:   9115 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB2_B' 10000 ms 1   // A gang of no-goods has threatened to remove my starring member if I don't pay them a cut.
while 001A:   15149 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB2_C' 10000 ms 1   // They threaten the wrong man amigo.
while 001A:   18028 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB2_D' 10000 ms 1   // They have a weakness for the icecream.
while 001A:   20605 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB2_E' 10000 ms 1   // Pick up the bomb I've hidden in Harwood
while 001A:   22985 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB2_F' 10000 ms 1   // hijack the regular icecream van on its rounds.
while 001A:   26130 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB2_G' 10000 ms 1   // and lure these fools to their doom with the jeengle-jeengle.
while 001A:   30784 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB2_H' 10000 ms 1   // They hide in a warehouse on Atlantic Quay.
while 001A:   33726 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BE: text_clear_all
while 001A:   34000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
03DE: set_pedestrians_density_multiplier_to 1.0
0004: $OJECTIVE_CREAMED_GUY1_DONE_BEFORE = 0
0004: $OJECTIVE_CREAMED_GUY2_DONE_BEFORE = 0
0004: $OJECTIVE_CREAMED_GUY3_DONE_BEFORE = 0
0004: $OJECTIVE_CREAMED_GUY4_DONE_BEFORE = 0
0004: $OJECTIVE_CREAMED_GUYS_PASSED = 0
0004: $CREAMERS_SPOTTED_YOU = 0
0004: $REMOVED_ICE_CREAM_BLIP = 0
0247: request_model #MRWHOOP
0247: request_model #GANG01
0247: request_model #LI_MAN1
0247: request_model #BOMB
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #MRWHOOP available
        8248:   NOT   model #GANG01 available
        8248:   NOT   model #LI_MAN1 available
        8248:   NOT   model #BOMB available
    jf break
    wait 0 ms
end
wait 2000 ms
0213: $DIABLO2_BRIEFCASE = create_pickup #BRIEFCASE type 3 at 599.875 -69.75 14.0625
03DC: $BLIP1_DIABLO2 = create_marker_above_pickup $DIABLO2_BRIEFCASE
00BB: text_lowpriority 'DIAB2_1' 5000 ms 1   // ~g~Pick up the briefcase in Harwood.
while 8214:   NOT   pickup $DIABLO2_BRIEFCASE picked_up
    wait 0 ms
end
0164: remove_blip $BLIP1_DIABLO2
00A5: $ICECREAM_VAN1 = create_car #MRWHOOP at 1046.0 -382.0 -100.0   //may need real z-axis
0129: $ICECREAM_MAN1 = create_actor 4 #LI_MAN1 in_car $ICECREAM_VAN1 driverseat
00AE: set_car $ICECREAM_VAN1 driving_style 2  // DRIVINGMODE_AVOIDCARS
0186: $BLIP1_ICECREAM1 = create_marker_above_car $ICECREAM_VAN1
00BC: print_now 'DIAB2_2' 5000 ms 1   // ~g~Find an icecream van.
while 80DE:   NOT   player $PLAYER driving_vehicle_type #MRWHOOP
    wait 0 ms
    if
        0119:   car $ICECREAM_VAN1 wrecked
    then
        jump @MISSION_DIABLO2_FAILED
    end
end
0164: remove_blip $BLIP1_ICECREAM1
00DA: $ICECREAMVAN_ANY = player $PLAYER car
if
    8119:   NOT   car $ICECREAMVAN_ANY wrecked
then
    0242: car $ICECREAMVAN_ANY bomb_status = 3
    037F: give_player_detonator
    01B8: player $PLAYER armed_weapon_to  34
end
00BC: print_now 'DIAB2_3' 5000 ms 1   // ~g~Park the icecream van down at Atlantic Quays.
0004: $FLAG_CAR_BLIP_DISPLAYED_DM2 = 1
0004: $BLOB_FLAG = 1
while true
    if or
        81AC:   NOT   car $ICECREAMVAN_ANY stopped $BLOB_FLAG in_cube 880.88 -1128.6899 17.1875 875.38 -1123.25 20.1875  // never used in VC
        80DC:   NOT   player $PLAYER driving $ICECREAMVAN_ANY
        8383:   NOT   player $ICECREAMVAN_ANY car_horn_activated == true
    jf break
    wait 0 ms
    if
        0119:   car $ICECREAMVAN_ANY wrecked
    then
        jump @MISSION_DIABLO2_FAILED
    end
    if and
        01AC:   car $ICECREAMVAN_ANY stopped 0 in_cube 880.88 -1128.6899 17.1875 875.38 -1123.25 20.1875  // never used in VC
        00DC:   player $PLAYER driving $ICECREAMVAN_ANY
    then
		// Code optimized and made compatible with GInput
        0293: $CONTROLMODE = current_controls
        if
            0038:   $CONTROLMODE == 1
        then
            00BC: print_now 'DIAB2_4' 1000 ms 1   // ~g~Press the ~w~~k~~VEHICLE_HORN~ button ~g~to activate the Icecream jingle.
        else
			if
				0038:   $CONTROLMODE == 2
			then
				00BC: print_now 'DIAB2_7' 1000 ms 1   // ~g~Press the ~w~~k~~VEHICLE_HORN~ button ~g~to activate the Icecream jingle.
			else
				00BC: print_now 'DIAB2_6' 1000 ms 1   // ~g~Press the ~w~~k~~VEHICLE_HORN~ button ~g~to activate the Icecream jingle.
			end
        end
    end
    if
        00DC:   player $PLAYER driving $ICECREAMVAN_ANY
    then
        if
            0038:   $FLAG_CAR_BLIP_DISPLAYED_DM2 == 1
        then
            018A: $BLIP2_DIABLO2 = create_checkpoint_at 884.69 -1137.1899 17.1875
            0004: $BLOB_FLAG = 1
            0164: remove_blip $BLIP1_ICECREAM1
            0004: $FLAG_CAR_BLIP_DISPLAYED_DM2 = 0
        end
    end
    if
        80DC:   NOT   player $PLAYER driving $ICECREAMVAN_ANY
    then
        if
            0038:   $FLAG_CAR_BLIP_DISPLAYED_DM2 == 0
        then
            0186: $BLIP1_ICECREAM1 = create_marker_above_car $ICECREAMVAN_ANY
            0004: $BLOB_FLAG = 0
            0164: remove_blip $BLIP2_DIABLO2
            00BC: print_now 'IN_VEH' 5000 ms 1   // ~g~Hey! Get back in the vehicle!
            0004: $FLAG_CAR_BLIP_DISPLAYED_DM2 = 1
        end
    end
end
0395: clear_area 1 at 855.5 -1141.1899 17.5625 range 2.0
009A: $CREAMED_GUY1 = create_actor 7 #GANG01 at 855.5 -1141.1899 17.5625
0395: clear_area 1 at 857.5 -1141.1899 17.5625 range 2.0
009A: $CREAMED_GUY2 = create_actor 7 #GANG01 at 857.5 -1141.1899 17.5625
0395: clear_area 1 at 859.5 -1141.1899 17.5625 range 2.0
009A: $CREAMED_GUY3 = create_actor 7 #GANG01 at 859.5 -1141.1899 17.5625
0395: clear_area 1 at 861.5 -1141.1899 17.5625 range 2.0
009A: $CREAMED_GUY4 = create_actor 7 #GANG01 at 861.5 -1141.1899 17.5625
01B2: give_actor $CREAMED_GUY1 weapon 23 ammo 160  // Load the weapon model before using this
01B2: give_actor $CREAMED_GUY2 weapon 23 ammo 160  // Load the weapon model before using this
01B2: give_actor $CREAMED_GUY3 weapon 23 ammo 160  // Load the weapon model before using this
01B2: give_actor $CREAMED_GUY4 weapon 23 ammo 160  // Load the weapon model before using this
0243: set_actor $CREAMED_GUY1 ped_stats_to 16
0243: set_actor $CREAMED_GUY2 ped_stats_to 16
0243: set_actor $CREAMED_GUY3 ped_stats_to 16
0243: set_actor $CREAMED_GUY4 ped_stats_to 16
00BC: print_now 'DIAB2_5' 5000 ms 1   // ~g~Exit the van then use the remote to detonate the Icecream van.
wait 2000 ms
0395: clear_area 1 at 870.56 -1141.0601 17.5625 range 10.0
if
    8118:   NOT   actor $CREAMED_GUY1 dead
then
    0211: actor $CREAMED_GUY1 walk_to 870.56 -1141.0601
end
if
    8118:   NOT   actor $CREAMED_GUY2 dead
then
    0211: actor $CREAMED_GUY2 walk_to 870.56 -1141.0601
end
if
    8118:   NOT   actor $CREAMED_GUY3 dead
then
    0211: actor $CREAMED_GUY3 walk_to 870.56 -1141.0601
end
if
    8118:   NOT   actor $CREAMED_GUY4 dead
then
    0211: actor $CREAMED_GUY4 walk_to 870.56 -1141.0601
end
while 8038:   NOT   $OJECTIVE_CREAMED_GUYS_PASSED == 4
    wait 0 ms
    if and
        0119:   car $ICECREAMVAN_ANY wrecked
        0038:   $REMOVED_ICE_CREAM_BLIP == 0
    then
        0164: remove_blip $BLIP1_ICECREAM1
        0004: $REMOVED_ICE_CREAM_BLIP =  1
    end
    if and
        0118:   actor $CREAMED_GUY1 dead
        0118:   actor $CREAMED_GUY2 dead
        0118:   actor $CREAMED_GUY3 dead
        0118:   actor $CREAMED_GUY4 dead
    then
        jump @MISSION_DIABLO2_PASSED
    end
    if and
        0118:   actor $CREAMED_GUY1 dead
        0038:   $OJECTIVE_CREAMED_GUY1_DONE_BEFORE == 0
    then
        0008: $OJECTIVE_CREAMED_GUYS_PASSED += 1
        0004: $OJECTIVE_CREAMED_GUY1_DONE_BEFORE = 1
    end
    if and
        0118:   actor $CREAMED_GUY2 dead
        0038:   $OJECTIVE_CREAMED_GUY2_DONE_BEFORE == 0
    then
        0008: $OJECTIVE_CREAMED_GUYS_PASSED += 1
        0004: $OJECTIVE_CREAMED_GUY2_DONE_BEFORE = 1
    end
    if and
        0118:   actor $CREAMED_GUY3 dead
        0038:   $OJECTIVE_CREAMED_GUY3_DONE_BEFORE == 0
    then
        0008: $OJECTIVE_CREAMED_GUYS_PASSED += 1
        0004: $OJECTIVE_CREAMED_GUY3_DONE_BEFORE = 1
    end
    if and
        0118:   actor $CREAMED_GUY4 dead
        0038:   $OJECTIVE_CREAMED_GUY4_DONE_BEFORE == 0
    then
        0008: $OJECTIVE_CREAMED_GUYS_PASSED += 1
        0004: $OJECTIVE_CREAMED_GUY4_DONE_BEFORE = 1
    end
    00AA: store_car $ICECREAMVAN_ANY position_to $ICECREAMX $ICECREAMY $ICECREAMZ
    if and
        0126:   actor $CREAMED_GUY1 walking
        0038:   $OJECTIVE_CREAMED_GUY1_DONE_BEFORE == 0
    then
        0211: actor $CREAMED_GUY1 walk_to $ICECREAMX $ICECREAMY
        0008: $OJECTIVE_CREAMED_GUYS_PASSED += 1
        0004: $OJECTIVE_CREAMED_GUY1_DONE_BEFORE = 1
    end
    if and
        0126:   actor $CREAMED_GUY2 walking
        0038:   $OJECTIVE_CREAMED_GUY2_DONE_BEFORE == 0
    then
        0211: actor $CREAMED_GUY2 walk_to $ICECREAMX $ICECREAMY
        0008: $OJECTIVE_CREAMED_GUYS_PASSED += 1
        0004: $OJECTIVE_CREAMED_GUY2_DONE_BEFORE = 1
    end
    if and
        0126:   actor $CREAMED_GUY3 walking
        0038:   $OJECTIVE_CREAMED_GUY3_DONE_BEFORE == 0
    then
        0211: actor $CREAMED_GUY3 walk_to $ICECREAMX $ICECREAMY
        0008: $OJECTIVE_CREAMED_GUYS_PASSED += 1
        0004: $OJECTIVE_CREAMED_GUY3_DONE_BEFORE = 1
    end
    if and
        0126:   actor $CREAMED_GUY4 walking
        0038:   $OJECTIVE_CREAMED_GUY4_DONE_BEFORE == 0
    then
        0211: actor $CREAMED_GUY4 walk_to $ICECREAMX $ICECREAMY
        0008: $OJECTIVE_CREAMED_GUYS_PASSED += 1
        0004: $OJECTIVE_CREAMED_GUY4_DONE_BEFORE = 1
    end
    if
        8118:   NOT   actor $CREAMED_GUY1 dead
    then
        if
            00FB:   player $PLAYER 0 near_actor $CREAMED_GUY1 radius 8.0 8.0 2.0
        then
            01CA: actor $CREAMED_GUY1 kill_player $PLAYER
            011A: set_actor $CREAMED_GUY1 flags 1
        end
    end
    if
        8118:   NOT   actor $CREAMED_GUY2 dead
    then
        if
            00FB:   player $PLAYER 0 near_actor $CREAMED_GUY2 radius 8.0 8.0 2.0
        then
            01CA: actor $CREAMED_GUY2 kill_player $PLAYER
            011A: set_actor $CREAMED_GUY2 flags 1
        end
    end
    if
        8118:   NOT   actor $CREAMED_GUY3 dead
    then
        if
            00FB:   player $PLAYER 0 near_actor $CREAMED_GUY3 radius 8.0 8.0 2.0
        then
            01CA: actor $CREAMED_GUY3 kill_player $PLAYER
            011A: set_actor $CREAMED_GUY3 flags 1
        end
    end
    if
        8118:   NOT   actor $CREAMED_GUY4 dead
    then
        if
            00FB:   player $PLAYER 0 near_actor $CREAMED_GUY4 radius 8.0 8.0 2.0
        then
            01CA: actor $CREAMED_GUY4 kill_player $PLAYER
            011A: set_actor $CREAMED_GUY4 flags 1
        end
    end
    if
        8118:   NOT   actor $CREAMED_GUY1 dead
    then
        0226: $CREAMED_GUY1_HEALTH = actor $CREAMED_GUY1 health
    end
    if
        8118:   NOT   actor $CREAMED_GUY2 dead
    then
        0226: $CREAMED_GUY2_HEALTH = actor $CREAMED_GUY2 health
    end
    if
        8118:   NOT   actor $CREAMED_GUY3 dead
    then
        0226: $CREAMED_GUY3_HEALTH = actor $CREAMED_GUY3 health
    end
    if
        8118:   NOT   actor $CREAMED_GUY4 dead
    then
        0226: $CREAMED_GUY4_HEALTH = actor $CREAMED_GUY4 health
    end
    if or
        001A:   100 > $CREAMED_GUY1_HEALTH
        001A:   100 > $CREAMED_GUY2_HEALTH
        001A:   100 > $CREAMED_GUY3_HEALTH
        001A:   100 > $CREAMED_GUY4_HEALTH
    then
        if
            0038:   $CREAMERS_SPOTTED_YOU == 0
        then
            if
                8118:   NOT   actor $CREAMED_GUY1 dead
            then
                01CA: actor $CREAMED_GUY1 kill_player $PLAYER
                011A: set_actor $CREAMED_GUY1 flags 1
            end
            if
                8118:   NOT   actor $CREAMED_GUY2 dead
            then
                01CA: actor $CREAMED_GUY2 kill_player $PLAYER
                011A: set_actor $CREAMED_GUY2 flags 1
            end
            if
                8118:   NOT   actor $CREAMED_GUY3 dead
            then
                01CA: actor $CREAMED_GUY3 kill_player $PLAYER
                011A: set_actor $CREAMED_GUY3 flags 1
            end
            if
                8118:   NOT   actor $CREAMED_GUY4 dead
            then
                01CA: actor $CREAMED_GUY4 kill_player $PLAYER
                011A: set_actor $CREAMED_GUY4 flags 1
            end
            0004: $CREAMERS_SPOTTED_YOU = 1
        end
    end
end
while true
    if or
        8118:   NOT   actor $CREAMED_GUY1 dead
        8118:   NOT   actor $CREAMED_GUY2 dead
        8118:   NOT   actor $CREAMED_GUY3 dead
        8118:   NOT   actor $CREAMED_GUY4 dead
    jf break
    wait 0 ms
    if and
        0119:   car $ICECREAMVAN_ANY wrecked
        0038:   $REMOVED_ICE_CREAM_BLIP == 0
    then
        0164: remove_blip $BLIP1_ICECREAM1
        0004: $REMOVED_ICE_CREAM_BLIP = 1
    end
    if
        8118:   NOT   actor $CREAMED_GUY1 dead
    then
        0226: $CREAMED_GUY1_HEALTH = actor $CREAMED_GUY1 health
    end
    if
        8118:   NOT   actor $CREAMED_GUY2 dead
    then
        0226: $CREAMED_GUY2_HEALTH = actor $CREAMED_GUY2 health
    end
    if
        8118:   NOT   actor $CREAMED_GUY3 dead
    then
        0226: $CREAMED_GUY3_HEALTH = actor $CREAMED_GUY3 health
    end
    if
        8118:   NOT   actor $CREAMED_GUY4 dead
    then
        0226: $CREAMED_GUY4_HEALTH = actor $CREAMED_GUY4 health
    end
    if or
        001A:   100 > $CREAMED_GUY1_HEALTH
        001A:   100 > $CREAMED_GUY2_HEALTH
        001A:   100 > $CREAMED_GUY3_HEALTH
        001A:   100 > $CREAMED_GUY4_HEALTH
    then
        if
            0038:   $CREAMERS_SPOTTED_YOU == 0
        then
            if
                8118:   NOT   actor $CREAMED_GUY1 dead
            then
                01CA: actor $CREAMED_GUY1 kill_player $PLAYER
                011A: set_actor $CREAMED_GUY1 flags 1
            end
            if
                8118:   NOT   actor $CREAMED_GUY2 dead
            then
                01CA: actor $CREAMED_GUY2 kill_player $PLAYER
                011A: set_actor $CREAMED_GUY2 flags 1
            end
            if
                8118:   NOT   actor $CREAMED_GUY3 dead
            then
                01CA: actor $CREAMED_GUY3 kill_player $PLAYER
                011A: set_actor $CREAMED_GUY3 flags 1
            end
            if
                8118:   NOT   actor $CREAMED_GUY4 dead
            then
                01CA: actor $CREAMED_GUY4 kill_player $PLAYER
                011A: set_actor $CREAMED_GUY4 flags 1
            end
            0004: $CREAMERS_SPOTTED_YOU = 1
        end
    end
    if
        8118:   NOT   actor $CREAMED_GUY1 dead
    then
        if
            00FB:   player $PLAYER 0 near_actor $CREAMED_GUY1 radius 8.0 8.0 2.0
        then
            01CA: actor $CREAMED_GUY1 kill_player $PLAYER
            011A: set_actor $CREAMED_GUY1 flags 1
        end
    end
    if
        8118:   NOT   actor $CREAMED_GUY2 dead
    then
        if
            00FB:   player $PLAYER 0 near_actor $CREAMED_GUY2 radius 8.0 8.0 2.0
        then
            01CA: actor $CREAMED_GUY2 kill_player $PLAYER
            011A: set_actor $CREAMED_GUY2 flags 1
        end
    end
    if
        8118:   NOT   actor $CREAMED_GUY3 dead
    then
        if
            00FB:   player $PLAYER 0 near_actor $CREAMED_GUY3 radius 8.0 8.0 2.0
        then
            01CA: actor $CREAMED_GUY3 kill_player $PLAYER
            011A: set_actor $CREAMED_GUY3 flags 1
        end
    end
    if
        8118:   NOT   actor $CREAMED_GUY4 dead
    then
        if
            00FB:   player $PLAYER 0 near_actor $CREAMED_GUY4 radius 8.0 8.0 2.0
        then
            01CA: actor $CREAMED_GUY4 kill_player $PLAYER
            011A: set_actor $CREAMED_GUY4 flags 1
        end
    end
end
jump @MISSION_DIABLO2_PASSED

:MISSION_DIABLO2_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // MISSION FAILED!
return

:MISSION_DIABLO2_PASSED
0004: $I_SCREAM_YOU_SCREAM_COMPLETED = 1
0394: play_music 1
01E3: text_1number_styled 'M_PASS' 8000 5000 ms 1   // MISSION PASSED! $~1~
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 8000
0318: set_latest_mission_passed 'DIAB2'   // 'I SCREAM YOU SCREAM'
030C: set_mission_points += 1
004F: create_thread @DIABLO_MISSION3_LOOP
return

:MISSION_CLEANUP_DIABLO2
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_DIABLOS = 0
0164: remove_blip $BLIP1_ICECREAM1
0164: remove_blip $BLIP1_DIABLO2
0164: remove_blip $BLIP2_DIABLO2
0215: destroy_pickup $DIABLO2_BRIEFCASE
0249: mark_model_as_no_longer_needed #MRWHOOP
0249: mark_model_as_no_longer_needed #GANG01
0249: mark_model_as_no_longer_needed #LI_MAN1
0249: mark_model_as_no_longer_needed #BOMB
017A: set_player $PLAYER weapon 34 ammo_to 0
mission_cleanup
return
