//-------------Mission 42-------------
// Originally: Diablos mission 3 'TRIAL BY FIRE'

:M42_TRIALBYFIRE
03A4: name_thread 'DIABLO3'
054C: use_GXT_table 'DIABLO3'
gosub @MISSION_START_DIABLO3
if
    wasted_or_busted
then
    gosub @MISSION_DIABLO3_FAILED
end
gosub @MISSION_CLEANUP_DIABLO3
end_thread

:MISSION_START_DIABLO3
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1  
0004: $ON_MISSION_FOR_DIABLOS = 1  
wait 0 ms
0247: request_model #GANG03
0247: request_model #GANG04
0247: request_model #COLT45
023C: load_special_actor 1 'PLAYER'
while true
    if
        823D:   NOT   special_actor 1 loaded
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'EL_PH4'
0244: set_cutscene_pos 603.25 -229.5 10.0
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
016A: fade 1 (back)  1500 ms
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   2000 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB3_A' 10000 ms 1   // Some insolent Triads stole my beautiful car last night
while 001A:   5553 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB3_B' 10000 ms 1   // wrecked it and left it burning.
while 001A:   7767 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB3_C' 10000 ms 1   // Some of my most precious donkey memorabilia was in the trunk -
while 001A:   11105 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB3_D' 10000 ms 1   // real collectibles that are irreplaceable my friend.
while 001A:   14603 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB3_E' 10000 ms 1   // I've hidden a throbbing weapon on the edge of Chinatown.
while 001A:   17813 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB3_F' 10000 ms 1   // Take it and teach these Triad vandals to fear El Burro's well-endowed wrath.
while 001A:   22948 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'DIAB3_G' 10000 ms 1   // Arriba!
while 001A:   23775 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BE: text_clear_all
while 001A:   26333 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
03DE: set_pedestrians_density_multiplier_to 1.0
//015C: set_zone_gang_info 'CHINA' 1 (day)  13 0 1000 0 0 0 0 0 0 0 0          //was 650
//015C: set_zone_gang_info 'CHINA' 0 (night)  10 0 1000 0 0 0 0 0 0 0 0
0004: $ALL_GANG_CREATED_BEFORE = 0  
0004: $COUNTER_DIABLO3 = 0  
0004: $DEAD_BURN_MAN1 = 0  
0004: $DEAD_BURN_MAN2 = 0  
0004: $DEAD_BURN_MAN3 = 0  
0004: $DEAD_BURN_MAN4 = 0  
0004: $DEAD_BURN_MAN5 = 0  
0004: $DEAD_BURN_MAN6 = 0  
0004: $GIVEN_MONEY_BEFORE = 0  
if
    042A:   ped_threat_exists 8 1  // requires updated dinput8.dll
then
    03F2: pedgroup 8 remove_threat 1
    0004: $TRAID_THREAT_CLEARED_D3 = 1  
end
0297: reset_num_of_models_killed_by_player
032B: $FLAMETHROWER_DIABLO3 = create_weapon_pickup #FLAME 3 ammo 0 at 544.188 -810.0 21.0
03DC: $BLIP1_DIABLO3 = create_marker_above_pickup $FLAMETHROWER_DIABLO3
while true  
    if or
        8248:   NOT   model #GANG03 available
        8248:   NOT   model #GANG04 available
        8248:   NOT   model #COLT45 available
    jf break
    wait 0 ms
end
while 8214:   NOT   pickup $FLAMETHROWER_DIABLO3 picked_up
    wait 0 ms
end
0164: remove_blip $BLIP1_DIABLO3
01F9: start_kill_frenzy 'DIAB3_1' 31 151000 25 #GANG03 #GANG04 -1 -1 0   // KILL 25 TRIADS

:DIABLO3_LOOP
wait 0 ms
01FA: $CURRENTSTATUS = rampage_status
if
    0038:   $CURRENTSTATUS == 2  
then
    jump @MISSION_DIABLO3_PASSED
end
if
    0038:   $CURRENTSTATUS == 3  
then
    jump @MISSION_DIABLO3_FAILED
end
if
    0056:   player $PLAYER 0 in_rectangle 703.0 -781.0 503.0 -915.0
then
    if
        0038:   $ALL_GANG_CREATED_BEFORE == 0  
    then
        009A: $DIABLO3_TRIAD1 = create_actor 8 #GANG03 at 597.0 -846.0 20.5
        01B2: give_actor $DIABLO3_TRIAD1 weapon 17 ammo 60  // Load the weapon model before using this
        009A: $DIABLO3_TRIAD2 = create_actor 8 #GANG04 at 598.0 -846.0 20.5
        01B2: give_actor $DIABLO3_TRIAD2 weapon 17 ammo 60  // Load the weapon model before using this
        01DE: tie_actor $DIABLO3_TRIAD2 to_actor $DIABLO3_TRIAD1
        009A: $DIABLO3_TRIAD3 = create_actor 8 #GANG03 at 599.0 -846.0 20.5
        01B2: give_actor $DIABLO3_TRIAD3 weapon 17 ammo 60  // Load the weapon model before using this
        01DE: tie_actor $DIABLO3_TRIAD3 to_actor $DIABLO3_TRIAD1
        009A: $DIABLO3_TRIAD4 = create_actor 8 #GANG04 at 600.0 -846.0 20.5
        01B2: give_actor $DIABLO3_TRIAD4 weapon 17 ammo 60  // Load the weapon model before using this
        01DE: tie_actor $DIABLO3_TRIAD4 to_actor $DIABLO3_TRIAD1
        009A: $DIABLO3_TRIAD5 = create_actor 8 #GANG03 at 601.0 -846.0 20.5
        01B2: give_actor $DIABLO3_TRIAD5 weapon 17 ammo 60  // Load the weapon model before using this
        01DE: tie_actor $DIABLO3_TRIAD5 to_actor $DIABLO3_TRIAD1
        009A: $DIABLO3_TRIAD6 = create_actor 8 #GANG04 at 602.0 -846.0 20.5
        01B2: give_actor $DIABLO3_TRIAD6 weapon 17 ammo 60  // Load the weapon model before using this
        01DE: tie_actor $DIABLO3_TRIAD6 to_actor $DIABLO3_TRIAD1
        0004: $ALL_GANG_CREATED_BEFORE = 1  
    end
    if and
        0118:   actor $DIABLO3_TRIAD1 dead
        0038:   $DEAD_BURN_MAN1 == 0  
    then
        0008: $COUNTER_DIABLO3 += 1  
        0004: $DEAD_BURN_MAN1 = 1  
    end
    if and
        0118:   actor $DIABLO3_TRIAD2 dead
        0038:   $DEAD_BURN_MAN2 == 0  
    then
        0008: $COUNTER_DIABLO3 += 1  
        0004: $DEAD_BURN_MAN2 = 1  
    end
    if and
        0118:   actor $DIABLO3_TRIAD3 dead
        0038:   $DEAD_BURN_MAN3 == 0  
    then
        0008: $COUNTER_DIABLO3 += 1  
        0004: $DEAD_BURN_MAN3 = 1  
    end
    if and
         0118:   actor $DIABLO3_TRIAD4 dead
        0038:   $DEAD_BURN_MAN4 == 0  
    then
        0008: $COUNTER_DIABLO3 += 1  
        0004: $DEAD_BURN_MAN4 = 1  
    end
    if and
        0118:   actor $DIABLO3_TRIAD5 dead
        0038:   $DEAD_BURN_MAN5 == 0  
    then
        0008: $COUNTER_DIABLO3 += 1  
        0004: $DEAD_BURN_MAN5 = 1  
    end
    if and
        0118:   actor $DIABLO3_TRIAD6 dead
        0038:   $DEAD_BURN_MAN6 == 0  
    then
        0008: $COUNTER_DIABLO3 += 1  
        0004: $DEAD_BURN_MAN6 = 1  
    end
    if and
        0038:   $COUNTER_DIABLO3 == 6  
        0038:   $GIVEN_MONEY_BEFORE == 0  
    then
        0109: player $PLAYER money += 6000
        0054: store_player $PLAYER position_to $PLAYER_X $PLAYER_Y $PLAYER_Z
        018C: play_sound 1 at $PLAYER_X $PLAYER_Y $PLAYER_Z
        0004: $GIVEN_MONEY_BEFORE = 1  
    end
    if or
        02D5:   player $PLAYER firing_weapons_in_rectangle 581.0 -863.0 621.0 -830.0 0
        0056:   player $PLAYER 0 in_rectangle 581.0 -863.0 621.0 -830.0
    then
        if
            0038:   $DEAD_BURN_MAN1 == 0  
        then
            01CA: actor $DIABLO3_TRIAD1 kill_player $PLAYER
        end
        if
            0038:   $DEAD_BURN_MAN2 == 0  
        then
            01CA: actor $DIABLO3_TRIAD2 kill_player $PLAYER
        end
        if
            0038:   $DEAD_BURN_MAN3 == 0  
        then
            01CA: actor $DIABLO3_TRIAD3 kill_player $PLAYER
        end
        if
            0038:   $DEAD_BURN_MAN4 == 0  
        then
            01CA: actor $DIABLO3_TRIAD4 kill_player $PLAYER
        end
        if
            0038:   $DEAD_BURN_MAN5 == 0  
        then
            01CA: actor $DIABLO3_TRIAD5 kill_player $PLAYER
        end
        if
            0038:   $DEAD_BURN_MAN6 == 0  
        then
            01CA: actor $DIABLO3_TRIAD6 kill_player $PLAYER
        end
    end
end
01FA: $CURRENTSTATUS = rampage_status
jump @DIABLO3_LOOP

:MISSION_DIABLO3_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // MISSION FAILED!
return

:MISSION_DIABLO3_PASSED
0004: $TRIAL_BY_FIRE_COMPLETED = 1  
0394: play_music 1
01E3: text_1number_styled 'M_PASS' 10000 5000 ms 1   // MISSION PASSED! $~1~
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 10000
0318: set_latest_mission_passed 'DIAB3'   // 'TRIAL BY FIRE'
030C: set_mission_points += 1
03F1: pedtype 8 add_threat 1
004F: create_thread @DIABLO_MISSION4_LOOP
return

:MISSION_CLEANUP_DIABLO3
0004: $FLAG_PLAYER_ON_MISSION = 0  
0004: $ON_MISSION_FOR_DIABLOS = 0  
0164: remove_blip $BLIP1_DIABLO3
0215: destroy_pickup $FLAMETHROWER_DIABLO3
0249: mark_model_as_no_longer_needed #GANG03
0249: mark_model_as_no_longer_needed #GANG04
//015C: set_zone_gang_info 'CHINA' 1 (day)  20 0 200 0 0 0 0 0 20 0 0
//015C: set_zone_gang_info 'CHINA' 0 (night)  10 0 300 0 0 0 0 0 10 0 0
03DF: all_random_peds -1
if
    0038:   $TRAID_THREAT_CLEARED_D3 == 1  
then
    03F1: pedtype 8 add_threat 1
end
mission_cleanup
return
