//-------------Mission 12-------------
// Originally: Firefighter sub-mission

:M12_FIREFIGHTER
03A4: name_thread 'FIRETRU'
054C: use_GXT_table 'FIRETRU'
gosub @MISSION_START_FIRE
gosub @FIRETRUCK_FAILED
end_thread

:MISSION_START_FIRE
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_FIREFIGHTER_MISSION = 1
wait 0 ms
0004: $FIRE_TIME_LIMIT = 0
0004: $FIRE_TO_EXTINGUISH = 0
0004: $FIRE_TO_EXTINGUISH_BLIP = 0
0004: $CAR_ON_FIRE = 0
0004: $RANDOM_CAR_MODEL = 0
0004: $CAR_ON_FIRE_CREATED = 0
0004: $PLAYER_IN_RANGE_FIRE = 0
0004: $FLAG_GOT_RANGE_MSSG = 0
0004: $SCORE_FT = 250
0004: $DISPLAYED_TIMER = 0
0004: $FIRES_EXTINGUISHED = 0
0004: $DISPLAYED_COUNTER = 0
0004: $FIREFIGHTER_MONEY = 0
0004: $FIRST_FIRE_FLAG = 0
0004: $MISSION_END_BUTTON_FT = 0
0004: $FIRE_LOCATION = 0
0005: $TIME_DIVIDER_DIVIDER = 2.0

:NEXT_FIRE
wait 0 ms
03C7: set_wanted_multiplier .5
0054: store_player $PLAYER position_to $FIREFIGHTER_PLAYER_X_COORD $FIREFIGHTER_PLAYER_Y_COORD $FIREFIGHTER_PLAYER_Z_COORD
if
    80DE:   NOT   player $PLAYER driving_vehicle_type #FIRETRUK
then
    00BC: print_now 'F_CANC' 3000 ms 1   // ~r~Fire Fighter mission cancelled!
    jump @FIRETRUCK_FAILED
end
0293: $CONTROLMODE = current_controls
if
    8038:   NOT   $CONTROLMODE == 3
then
    if
        00E1:   key_pressed 0 19
    then
        0004: $MISSION_END_BUTTON_FT = 1  //PAD1 RIGHTSHOCK
    end
else
    if
        00E1:   key_pressed 0 14   //PAD1 SQUARE
    then
        0004: $MISSION_END_BUTTON_FT = 1
    end
end
if
    0038:   $MISSION_END_BUTTON_FT == 1
then
    if
        8038:   NOT   $CONTROLMODE == 3
    then
        if
            80E1:   NOT   key_pressed 0 19
        then
            00BC: print_now 'F_CANC' 3000 ms 1   // ~r~Fire Fighter mission cancelled!
            jump @FIRETRUCK_FAILED
        end
    else
        if
            80E1:   NOT   key_pressed 0 14
        then
            00BC: print_now 'F_CANC' 3000 ms 1   // ~r~Fire Fighter mission cancelled!
            jump @FIRETRUCK_FAILED
        end
    end
end
if
    03C6:   is_collision_in_memory 1
then
    0208: $FIREFIGHTER_CAR_X_COORD = random_float 443.0 1205.0
    0208: $FIREFIGHTER_CAR_Y_COORD = random_float -1110.0 190.0
    0004: $FLAG_GOT_RANGE_MSSG = 0
    0004: $PLAYER_IN_RANGE_FIRE = 1
    0004: $FIRE_LOCATION = 1
    0005: $TIME_DIVIDER = 13.0
end
if
    03C6:   is_collision_in_memory 2
then
    0208: $FIREFIGHTER_CAR_X_COORD = random_float -527.0 210.0
    0208: $FIREFIGHTER_CAR_Y_COORD = random_float -1626.0 98.0
    0004: $FLAG_GOT_RANGE_MSSG = 0
    0004: $PLAYER_IN_RANGE_FIRE = 1
    0004: $FIRE_LOCATION = 2
    0005: $TIME_DIVIDER = 14.0
end
if
    03C6:   is_collision_in_memory 3
then
    0208: $FIREFIGHTER_CAR_X_COORD = random_float -1635.0 -749.0
    0208: $FIREFIGHTER_CAR_Y_COORD = random_float -608.75 380.0
    0004: $FLAG_GOT_RANGE_MSSG = 0
    0004: $PLAYER_IN_RANGE_FIRE = 1
    0004: $FIRE_LOCATION = 3
    0005: $TIME_DIVIDER = 11.0
end
if and
    0038:   $PLAYER_IN_RANGE_FIRE == 0
    0038:   $FLAG_GOT_RANGE_MSSG == 0
then
    if
        0038:   $FLAG_GOT_RANGE_MSSG == 0
    then
        00BC: print_now 'F_RANGE' 5000 ms 1   // ~g~The fire truck radio is out of range, get closer to a fire station!
        0004: $FLAG_GOT_RANGE_MSSG = 1
    end
    jump @FIRETRUCK_FAILED
end
02C1: set $FIRE_COORD_X $FIRE_COORD_Y $FIRE_COORD_Z to_car_path_coords_closest_to $FIREFIGHTER_CAR_X_COORD $FIREFIGHTER_CAR_Y_COORD $FIREFIGHTER_PLAYER_Z_COORD
if and
    0020:   $FIRE_COORD_X > 335.0      // CALAHAN BRIDGE
    0022:   700.0 > $FIRE_COORD_X
    0020:   $FIRE_COORD_Y > -953.0
    0022:   -912.0 > $FIRE_COORD_Y
then
    jump @NEXT_FIRE
end
if and
    0020:   $FIRE_COORD_X > 314.0      // TUNNEL ENTRANCE INDUSTRIAL
    0022:   731.0 > $FIRE_COORD_X
    0020:   $FIRE_COORD_Y > 25.0
    0022:   217.0 > $FIRE_COORD_Y
then
    jump @NEXT_FIRE
end
if and
    0020:   $FIRE_COORD_X > -1946.5     // AIRPORT SUBURBAN
    0022:   -1080.25 > $FIRE_COORD_X
    0020:   $FIRE_COORD_Y > -1001.875
    0022:   -371.1875 > $FIRE_COORD_Y
then
    jump @NEXT_FIRE
end
if and
    0020:   $FIRE_COORD_X > -1590.375   // BAIT WAREHOUSE CARPARK SUBURBIA
    0022:   -1522.875 > $FIRE_COORD_X
    0020:   $FIRE_COORD_Y > 80.5625
    0022:   123.375 > $FIRE_COORD_Y
then
    jump @NEXT_FIRE
end
if and
    0020:   $FIRE_COORD_X > 1051.375    // FRANKIES HOUSE
    0022:   1140.75 > $FIRE_COORD_X
    0020:   $FIRE_COORD_Y > -292.0625
    0022:   -168.0 > $FIRE_COORD_Y
then
    jump @NEXT_FIRE
end
if
    0038:   $FIRE_LOCATION == 1         // INDUSTRIAL
then
    if or
        8020:   NOT   $FIRE_COORD_X > 443.0
        8022:   NOT   1205.0 > $FIRE_COORD_X
        8020:   NOT   $FIRE_COORD_Y > -1110.0
        8022:   NOT   190.0 > $FIRE_COORD_Y
    then
        jump @NEXT_FIRE
    end
end
if
    0038:   $FIRE_LOCATION == 2            // COMMERCIAL
then
    if or
        8020:   NOT   $FIRE_COORD_X > -527.0
        8022:   NOT   210.0 > $FIRE_COORD_X
        8020:   NOT   $FIRE_COORD_Y > -1626.0
        8022:   NOT   98.0 > $FIRE_COORD_Y
    then
        jump @NEXT_FIRE
    end
end
if
    0038:   $FIRE_LOCATION == 3          // SUBURBIA
then
    if or
        8020:   NOT   $FIRE_COORD_X > -1635.0
        8022:   NOT   -749.0 > $FIRE_COORD_X
        8020:   NOT   $FIRE_COORD_Y > -608.75
        8022:   NOT   380.0 > $FIRE_COORD_Y
    then
        jump @NEXT_FIRE
    end
end
if
    0022:   -1.0 > $FIRE_COORD_Z
then
    jump @NEXT_FIRE
end
0086: $DIFFERENCE_X_FLOAT = $FIREFIGHTER_PLAYER_X_COORD
0061: $DIFFERENCE_X_FLOAT -= $FIRE_COORD_X
0086: $DIFFERENCE_Y_FLOAT = $FIREFIGHTER_PLAYER_Y_COORD
0061: $DIFFERENCE_Y_FLOAT -= $FIRE_COORD_Y
0069: $DIFFERENCE_X_FLOAT *= $DIFFERENCE_X_FLOAT
0069: $DIFFERENCE_Y_FLOAT *= $DIFFERENCE_Y_FLOAT
0086: $SUM_DIFFERENCE_XY = $DIFFERENCE_X_FLOAT
0059: $SUM_DIFFERENCE_XY += $DIFFERENCE_Y_FLOAT
01FB: $PLAYERS_DISTANCE_FROM_FIRE = square_root $SUM_DIFFERENCE_XY
if
    0022:   200.0 > $PLAYERS_DISTANCE_FROM_FIRE
then
    jump @NEXT_FIRE
end
0086: $FIRE_TIME_LIMIT_FLOAT = $PLAYERS_DISTANCE_FROM_FIRE
0071: $FIRE_TIME_LIMIT_FLOAT /= $TIME_DIVIDER
0059: $TIME_DIVIDER += $TIME_DIVIDER_DIVIDER
0009: $TIME_DIVIDER_DIVIDER += 2.0
0011: $FIRE_TIME_LIMIT_FLOAT *= 1000.0
008C: $INTERMEDIATE_INT = float_to_integer $FIRE_TIME_LIMIT_FLOAT
0058: $FIRE_TIME_LIMIT += $INTERMEDIATE_INT
if
0038:  $FIRES_EXTINGUISHED == 0 // LC code had this (not sure why) $ALL_FIRE_MISSIONS_DONE == 0
then
    if
        001A:   50000 > $FIRE_TIME_LIMIT
    then
        0004: $FIRE_TIME_LIMIT = 50000
    end
end

:GENERATE_MODEL
wait 0 ms
0209: $RANDOM_CAR_MODEL = random_int 130 229
if and
    8038:   NOT   $RANDOM_CAR_MODEL == #LANDSTAL
    8038:   NOT   $RANDOM_CAR_MODEL == #IDAHO
    8038:   NOT   $RANDOM_CAR_MODEL == #LINERUN
    8038:   NOT   $RANDOM_CAR_MODEL == #PEREN
    8038:   NOT   $RANDOM_CAR_MODEL == #SENTINEL
    8038:   NOT   $RANDOM_CAR_MODEL == #TRASH
    8038:   NOT   $RANDOM_CAR_MODEL == #STRETCH
then
    if and
        8038:   NOT   $RANDOM_CAR_MODEL == #MANANA
        8038:   NOT   $RANDOM_CAR_MODEL == #YARDIE
        8038:   NOT   $RANDOM_CAR_MODEL == #PONY
        8038:   NOT   $RANDOM_CAR_MODEL == #MULE
        8038:   NOT   $RANDOM_CAR_MODEL == #MOONBEAM
        8038:   NOT   $RANDOM_CAR_MODEL == #ESPERANT
        8038:   NOT   $RANDOM_CAR_MODEL == #TAXI
    then
        if and
            8038:   NOT   $RANDOM_CAR_MODEL == #MAFIA
            8038:   NOT   $RANDOM_CAR_MODEL == #BOBCAT
            8038:   NOT   $RANDOM_CAR_MODEL == #MRWHOOP
            8038:   NOT   $RANDOM_CAR_MODEL == #CABBIE
            8038:   NOT   $RANDOM_CAR_MODEL == #STALLION
            8038:   NOT   $RANDOM_CAR_MODEL == #RUMPO
            8038:   NOT   $RANDOM_CAR_MODEL == #KURUMA
        then
            if and
                8038:   NOT   $RANDOM_CAR_MODEL == #HOODS
                8038:   NOT   $RANDOM_CAR_MODEL == #PATRIOT
                8038:   NOT   $RANDOM_CAR_MODEL == #DIABLOS
                8038:   NOT   $RANDOM_CAR_MODEL == #YAKUZA
                8038:   NOT   $RANDOM_CAR_MODEL == #COLUMB
                8038:   NOT   $RANDOM_CAR_MODEL == #BLISTA
                8038:   NOT   $RANDOM_CAR_MODEL == #BELLYUP
            then
                if
                    8038:   NOT   $RANDOM_CAR_MODEL == #MRWONGS
                then
                    jump @GENERATE_MODEL
                end
            end
        end
    end
end
0247: request_model $RANDOM_CAR_MODEL
if
    0038:   $FIRST_FIRE_FLAG == 1
then
    0006: 16@ = 0
else
    0006: 16@ = 3001
    0004: $FIRST_FIRE_FLAG = 1
end
while true
    if or
        8248:   NOT   model $RANDOM_CAR_MODEL available
        8019:   NOT   16@ > 3000
    jf break
    wait 0 ms
    if
        001A:   1 > $FIRE_TIME_LIMIT
    then
        00BC: print_now 'F_FAIL2' 5000 ms 1   // ~r~You're too late!
        jump @FIRETRUCK_FAILED
    end
    if
        80DE:   NOT   player $PLAYER driving_vehicle_type #FIRETRUK
    then
        00BC: print_now 'F_CANC' 3000 ms 1   // ~r~Fire Fighter mission cancelled!
        jump @FIRETRUCK_FAILED
    end
    0293: $CONTROLMODE = current_controls
    if
        8038:   NOT   $CONTROLMODE == 3
    then
        if
            00E1:   key_pressed 0 19
        then
            0004: $MISSION_END_BUTTON_FT = 1
        end
    else
        if
            00E1:   key_pressed 0 14
        then
            0004: $MISSION_END_BUTTON_FT = 1
        end
    end
    if
        0038:   $MISSION_END_BUTTON_FT == 1
    then
        if
            8038:   NOT   $CONTROLMODE == 3
        then
            if
                80E1:   NOT   key_pressed 0 19
            then
                00BC: print_now 'F_CANC' 3000 ms 1   // ~r~Fire Fighter mission cancelled!
                jump @FIRETRUCK_FAILED
            end
        else
            if
                80E1:   NOT   key_pressed 0 14
            then
                00BC: print_now 'F_CANC' 3000 ms 1   // ~r~Fire Fighter mission cancelled!
                jump @FIRETRUCK_FAILED
            end
        end
    end
end
0208: $RANDOM_CAR_HEADING = random_float 0.0 359.9
if
    0038:   $CAR_ON_FIRE_CREATED == 0
then
    00A5: $CAR_ON_FIRE = create_car $RANDOM_CAR_MODEL at $FIRE_COORD_X $FIRE_COORD_Y $FIRE_COORD_Z
    0004: $CAR_ON_FIRE_CREATED = 1
end
0129: $FIRE_MISSION_DRIVER = create_actor 4 #MALE01 in_car $CAR_ON_FIRE driverseat
0249: mark_model_as_no_longer_needed $RANDOM_CAR_MODEL
0175: set_car $CAR_ON_FIRE z_angle_to $RANDOM_CAR_HEADING
0325: $FIRE_TO_EXTINGUISH = create_car $CAR_ON_FIRE fire
0186: $FIRE_TO_EXTINGUISH_BLIP = create_marker_above_car $CAR_ON_FIRE
00A9: set_car $CAR_ON_FIRE to_normal_driver
009F: set_actor $FIRE_MISSION_DRIVER objective_to-1
00AD: set_car $CAR_ON_FIRE max_speed_to 0.0
02AA: set_car $CAR_ON_FIRE immune_to_nonplayer 1
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'PORT_W'
then
    0384: text_1string 'F_START' 'PORT_W' 5000 ms 1   // Callahan Point
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'PORT_S'
then
    0384: text_1string 'F_START' 'PORT_S' 5000 ms 1   // Atlantic Quays
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'PORT_E'
then
    0384: text_1string 'F_START' 'PORT_E' 5000 ms 1   // Portland Harbor
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'PORT_I'
then
    0384: text_1string 'F_START' 'PORT_I' 5000 ms 1   // Trenton
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'S_VIEW'
then
    0384: text_1string 'F_START' 'S_VIEW' 5000 ms 1   // Portland View
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'CHINA'
then
    0384: text_1string 'F_START' 'CHINA' 5000 ms 1   // Chinatown
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'EASTBAY'
then
    0384: text_1string 'F_START' 'EASTBAY' 5000 ms 1   // Portland Beach
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'LITTLEI'
then
    0384: text_1string 'F_START' 'LITTLEI' 5000 ms 1   // Saint Mark's
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'REDLIGH'
then
    0384: text_1string 'F_START' 'REDLIGH' 5000 ms 1   // Redlight District
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'TOWERS'
then
    0384: text_1string 'F_START' 'TOWERS' 5000 ms 1   // Hepburn Heights
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'HARWOOD'
then
    0384: text_1string 'F_START' 'HARWOOD' 5000 ms 1   // Harwood
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'ROADBR1'
then
    0384: text_1string 'F_START' 'ROADBR1' 5000 ms 1   // Callahan Bridge
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'ROADBR2'
then
    0384: text_1string 'F_START' 'ROADBR2' 5000 ms 1   // Callahan Bridge
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'STADIUM'
then
    0384: text_1string 'F_START' 'STADIUM' 5000 ms 1   // Aspatria
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'HOSPI_2'
then
    0384: text_1string 'F_START' 'HOSPI_2' 5000 ms 1   // Rockford
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'UNIVERS'
then
    0384: text_1string 'F_START' 'UNIVERS' 5000 ms 1   // Liberty Campus
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'CONSTRU'
then
    0384: text_1string 'F_START' 'CONSTRU' 5000 ms 1   // Fort Staunton
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'PARK'
then
    0384: text_1string 'F_START' 'PARK' 5000 ms 1   // Belleville Park
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'COM_EAS'
then
    0384: text_1string 'F_START' 'COM_EAS' 5000 ms 1   // Newport
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'SHOPING'
then
    0384: text_1string 'F_START' 'SHOPING' 5000 ms 1   // Bedford Point
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'YAKUSA'
then
    0384: text_1string 'F_START' 'YAKUSA' 5000 ms 1   // Torrington
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'AIRPORT'
then
    0384: text_1string 'F_START' 'AIRPORT' 5000 ms 1   // Francis Intl. Airport
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'PROJECT'
then
    0384: text_1string 'F_START' 'PROJECT' 5000 ms 1   // Wichita Gardens
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'SUB_IND'
then
    0384: text_1string 'F_START' 'SUB_IND' 5000 ms 1   // Pike Creek
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'SWANKS'
then
    0384: text_1string 'F_START' 'SWANKS' 5000 ms 1   // Cedar Grove
end
if
    0154:   actor $FIRE_MISSION_DRIVER in_zone 'BIG_DAM'
then
    0384: text_1string 'F_START' 'BIG_DAM' 5000 ms 1   // Cochrane Dam
end
009B: destroy_actor_instantly $FIRE_MISSION_DRIVER
if
    0038:   $DISPLAYED_TIMER == 0
then
    014E: set_timer_to $FIRE_TIME_LIMIT type 1
    0004: $DISPLAYED_TIMER = 1
end
03E6: remove_text_box
if
    0038:   $GOT_SIREN_HELP_BEFORE == 1
then
    // Code optimized and made compatible with GInput
    0293: $CONTROLMODE = current_controls
    if
        0038:   $CONTROLMODE == 1
    then
        03E5: text_box 'SIREN_2'   // To turn on this vehicle's sirens tap the ~h~~k~~VEHICLE_HORN~ button~w~.
    else
        if
            0038:   $CONTROLMODE == 2
        then
            03E5: text_box 'SIREN_3'   // To turn on this vehicle's sirens tap the ~h~~k~~VEHICLE_HORN~ button~w~.
        else
            if
                0038:   $CONTROLMODE == 3
            then
                03E5: text_box 'SIREN_4'   // To turn on this vehicle's sirens tap the ~h~~k~~VEHICLE_HORN~ button~w~.
            else
                03E5: text_box 'SIREN_1'   // To turn on this vehicle's sirens tap the ~h~~k~~VEHICLE_HORN~ button~w~.
            end
        end
    end
    0004: $GOT_SIREN_HELP_BEFORE = 2
end
if
    0038:   $GOT_SIREN_HELP_BEFORE == 0
then
    if
        82BD:   NOT   debug_mode == DEBUG_SKIPHELP
    then
        // Code optimized and made compatible with GInput
        0293: $CONTROLMODE = current_controls
        if
            0038:   $CONTROLMODE == 2
        then
            // Text altered for GInput
            03E5: text_box 'SPRAY_3'   // Use the  ~c~  button to fire the water cannon. Aim using the ~h~right analog stick~w~.
        else
            if
                0038:   $CONTROLMODE == 4
            then
                // New text for GInput
                03E5: text_box 'SPRAY_5'   // Use the  ~i~  button to fire the water cannon. Aim using the ~h~right analog stick~w~.
            else
                03E5: text_box 'SPRAY_1'   // Use the ~h~~k~~PED_FIREWEAPON~ ~w~button to fire the water cannon. Aim using ~h~~k~~VEHICLE_TURRETLEFT~~w~ and ~h~~k~~VEHICLE_TURRETRIGHT~~w~.
            end
        end
    end
    0004: $GOT_SIREN_HELP_BEFORE = 1
end
while 82D0:   NOT   fire $FIRE_TO_EXTINGUISH extinguished
    wait 0 ms
    if
        0119:   car $CAR_ON_FIRE wrecked
    then
        00BC: print_now 'F_FAIL2' 5000 ms 1   // ~r~You're too late!
        jump @FIRETRUCK_FAILED
    end
    if
        001A:   1 > $FIRE_TIME_LIMIT
    then
        00BC: print_now 'F_FAIL2' 5000 ms 1   // ~r~You're too late!
        jump @FIRETRUCK_FAILED
    end
    if
        80DE:   NOT   player $PLAYER driving_vehicle_type #FIRETRUK
    then
        00BC: print_now 'F_CANC' 3000 ms 1   // ~r~Fire Fighter mission cancelled!
        jump @FIRETRUCK_FAILED
    end
    0227: $CAR_ON_FIRE_HEALTH = car $CAR_ON_FIRE health
    if
        001A:   900 > $CAR_ON_FIRE_HEALTH
    then
        020B: explode_car $CAR_ON_FIRE
    end
    0293: $CONTROLMODE = current_controls
    if
        8038:   NOT   $CONTROLMODE == 3
    then
        if
            00E1:   key_pressed 0 19
        then
            0004: $MISSION_END_BUTTON_FT = 1
        end
    else
        if
            00E1:   key_pressed 0 14
        then
            0004: $MISSION_END_BUTTON_FT = 1
        end
    end
    if
        0038:   $MISSION_END_BUTTON_FT == 1
    then
        if
            8038:   NOT   $CONTROLMODE == 3
        then
            if
                80E1:   NOT   key_pressed 0 19
            then
                00BC: print_now 'F_CANC' 3000 ms 1   // ~r~Fire Fighter mission cancelled!
                jump @FIRETRUCK_FAILED
            end
        else
            if
                80E1:   NOT   key_pressed 0 14
            then
                00BC: print_now 'F_CANC' 3000 ms 1   // ~r~Fire Fighter mission cancelled!
                jump @FIRETRUCK_FAILED
            end
        end
    end
end
0008: $FIRES_EXTINGUISHED += 1
00BA: text_styled 'F_PASS1' 5000 ms 5   // Fire extinguished!
01E3: text_1number_styled 'REWARD' $SCORE_FT 6000 ms 6   // REWARD $~1~
0404: increment_fires_extinguished
if
    0038:   $FIRE_LOCATION == 1
then
    0008: $PORTLAND_FIRE_MISSIONS += 1
end
if
    0038:   $FIRE_LOCATION == 2
then
    0008: $STAUNTON_FIRE_MISSIONS += 1
end
if
    0038:   $FIRE_LOCATION == 3
then
    0008: $SHORESIDE_FIRE_MISSIONS += 1
end
if
    0038:   $ALL_FIRE_MISSIONS_DONE == 0
then
    if and
        0018:   $PORTLAND_FIRE_MISSIONS > 19
        0018:   $STAUNTON_FIRE_MISSIONS > 19
        0018:   $SHORESIDE_FIRE_MISSIONS > 19
    then
        014D: add_pager_message 'PAGEB11'  140  100  1   // Flamethrower delivered to hideout.
        030C: set_mission_points += 1
        0004: $ALL_FIRE_MISSIONS_DONE = 1
    end
end
0109: player $PLAYER money += $SCORE_FT
0058: $FIREFIGHTER_MONEY += $SCORE_FT
0008: $SCORE_FT += 250
031A: remove_all_fires
0164: remove_blip $FIRE_TO_EXTINGUISH_BLIP
018C: play_sound 1 at 0.0 0.0 0.0
if
    00E0:   player $PLAYER driving
then
    00DA: $PLAYERS_FIRETRUCK = player $PLAYER car
    0227: $PLAYERS_FIRETRUCK_HEALTH = car $PLAYERS_FIRETRUCK health
    0008: $PLAYERS_FIRETRUCK_HEALTH += 150
    0224: set_car $PLAYERS_FIRETRUCK health_to $PLAYERS_FIRETRUCK_HEALTH
end
if
    0038:   $DISPLAYED_COUNTER == 0
then
    03C4: set_status_text_to $FIRES_EXTINGUISHED 0 (number)  'F_EXTIN'   // FIRES:
    0004: $DISPLAYED_COUNTER = 1
end
if
    0038:   $CAR_ON_FIRE_CREATED == 1
then
    01C3: remove_references_to_car $CAR_ON_FIRE  // Like turning a car into any random car
    if
        8119:   NOT   car $CAR_ON_FIRE wrecked
    then
        02AA: set_car $CAR_ON_FIRE immune_to_nonplayer 0
    end
    0004: $CAR_ON_FIRE_CREATED = 0
end
0249: mark_model_as_no_longer_needed $RANDOM_CAR_MODEL
jump @NEXT_FIRE

:FIRETRUCK_FAILED
014F: stop_timer $FIRE_TIME_LIMIT
0151: remove_status_text $FIRES_EXTINGUISHED
00BA: text_styled 'F_FAIL1' 5000 ms 5   // Fire Fighter mission ended.
01E3: text_1number_styled 'TSCORE' $FIREFIGHTER_MONEY 6000 ms 6   // EARNINGS: $~1~
031A: remove_all_fires
0164: remove_blip $FIRE_TO_EXTINGUISH_BLIP
03E6: remove_text_box
03C7: set_wanted_multiplier 1.0
if
    0038:   $CAR_ON_FIRE_CREATED == 1
then
    if
        8119:   NOT   car $CAR_ON_FIRE wrecked
    then
        02AA: set_car $CAR_ON_FIRE immune_to_nonplayer 0
        020B: explode_car $CAR_ON_FIRE
    end
    01C3: remove_references_to_car $CAR_ON_FIRE  // Like turning a car into any random car
    0004: $CAR_ON_FIRE_CREATED = 0
end
0249: mark_model_as_no_longer_needed $RANDOM_CAR_MODEL
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_FIREFIGHTER_MISSION = 0
mission_cleanup
return
