//-------------Mission 37-------------
// Originally: Frank mission 2.1 'BOMB DA BASE: ACT I'

:M37_BOMBDABASEACTI
03A4: name_thread 'FRANK21'
054C: use_GXT_table 'FRANK3'
058E: set_restart_mission_taxi_destination 1044.0 -284.0 55.57 0.0
gosub @MISSION_START_FRANKIE21
if
    wasted_or_busted
then
    gosub @MISSION_FRANKIE21_FAILED
end
gosub @MISSION_CLEANUP_FRANKIE21
end_thread

:MISSION_START_FRANKIE21
0004: $FLAG_PLAYER_ON_MISSION = 1
0317: increment_mission_attempts
wait 0 ms
0004: $FLAG_PLAYER_ON_FRANKIE_MISSION = 1
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'FRANKIE'
02F3: load_object #CUTOBJ01 'FRANKH'
0247: request_model #GANG02
0247: request_model #FRANKSCLB02
0247: request_model #SALVSDETAIL
0247: request_model #SWANK_INSIDE
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #GANG02 available
    jf break
    wait 0 ms
end
while true
    if or
        8248:   NOT   model #FRANKSCLB02 available
        8248:   NOT   model #SALVSDETAIL available
        8248:   NOT   model #SWANK_INSIDE available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'S3_RTC'
0244: set_cutscene_pos 1122.75 -185.312 60.875
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_SALVATORE = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_SALVATORE 'FRANKIE'
//02F4: create_cutscene_actor $SALVATORE_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_SALVATORE
//02F5: set_head_anim $SALVATORE_CSHEAD 'FRANK'
02E5: $CUTSCENE_MAFIA = create_cutscene_object #GANG02
02E6: set_cutscene_anim $CUTSCENE_MAFIA 'GANG02'
0395: clear_area 1 at 1120.0601 -187.75 -100.0 range 1.0
0055: set_player_coordinates $PLAYER at 1120.0601 -187.75 -100.0
0171: set_player $PLAYER z_angle_to 180.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   5136 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'FM3_C' 10000 ms 1   // // ~w~The Cartel has got bottomless funds from pushing that SPANK crap.
while 001A:   8848 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'FM3_D' 10000 ms 1   // // ~w~If we make an open attack on them they'll wipe the floor with us.
while 001A:   12450 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'FM3_E' 10000 ms 1   // // ~w~They must be making SPANK on that big boat that Curly lead you to.
while 001A:   15984 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'FM3_F' 10000 ms 1   // // ~w~So we gotta use our heads or rather one head. Your head.
while 001A:   20426 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'FM3_G' 10000 ms 1   // // ~w~I'm asking you to destroy that SPANK factory as a personal favor to me Salvatore Leone.
while 001A:   27076 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'FM3_H' 10000 ms 1   // // ~w~If you do this for me you will be a made man anything you want.
while 001A:   32651 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'FM3_I' 10000 ms 1   // // ~w~Go and see 8-Ball you'll need his expertise to blow-up that boat.
while 001A:   36233 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
03D5: remove_text 'FM3_I'   // // ~w~Go and see 8-Ball you'll need his expertise to blow-up that boat.
while 001A:   38333 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
03AD: set_rubbish 1 (visible)
0373: set_camera_directly_behind_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #GANG02
0249: mark_model_as_no_longer_needed #FRANKSCLB02
0249: mark_model_as_no_longer_needed #SALVSDETAIL
0249: mark_model_as_no_longer_needed #SWANK_INSIDE
jump @MISSION_FRANKIE21_PASSED

:MISSION_FRANKIE21_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // // MISSION FAILED!
return

:MISSION_FRANKIE21_PASSED
0004: $BOMB_DA_BASE_ACT_I_COMPLETED = 1
0004: $FLAG_FRANKIE_SWITCHED_OFF = 1
0318: set_latest_mission_passed 'FM21'   // // 'BOMB DA BASE: ACT I'
030C: set_mission_points += 1
0164: remove_blip $SALVATORE_MISSION_MARKER
02A7: $EIGHTBALL_CONTACT_BLIP = create_icon_marker_and_sphere 10 at 937.1899 -92.875 -100.0
004F: create_thread @FRANKIE_MISSION3_LOOP
return

:MISSION_CLEANUP_FRANKIE21
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $FLAG_PLAYER_ON_FRANKIE_MISSION = 0
mission_cleanup
return
