//-------------Mission 1-------------
// Originally: Hospital cut scene

:M01_HOSPITALHELP
03A4: name_thread 'HEALTH'
gosub @HEALTH_INFO_START
gosub @HEALTH_INFO_CLEANUP
end_thread

:HEALTH_INFO_START
$FLAG_PLAYER_ON_MISSION = 1
wait 0 ms
$INFO_TIME_LAPSED = 0
$INFO_TIME_NOW = 0
$INFO_TIME_START = 0
$FLAG_INFO = 0
$FLAG_BOTTOM = 0
$WANTED_LEVEL = 0
$FLAG_INTRO_JUMP = 0
01B4: set_player $PLAYER can_move 0 (frozen)
01C0: $WANTED_LEVEL = player $PLAYER wanted_level
0110: clear_player $PLAYER wanted_level
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
0247: request_model #AMBULAN
0247: request_model #MEDIC
038B: load_all_models_now

while true
    if or
        8248:   NOT   model #AMBULAN available
        8248:   NOT   model #MEDIC available
    jf break
    wait 0 ms
end
015F: set_camera_position 803.56 -600.0 24.0 0.0 0.0 0.0
0157: camera_on_player $PLAYER 15 1

while true
    if
        001A:   8 > $FLAG_INFO
    jf break
    wait 0 ms
    if
        $FLAG_INFO == 0
    then
        01BD: $INFO_TIME_START = current_time_in_ms
        0395: clear_area 1 at 806.0 -622.0 20.75 range 30.0
        0395: clear_area 1 at 790.75 -594.0 20.75 range 10.0
        01EB: set_car_density_to 0.0
        03DE: set_pedestrians_density_multiplier_to 0.0
        00A5: $WASTED_HELP_AMBULANCE = create_car #AMBULAN at 805.19 -621.5 20.75
        0175: set_car $WASTED_HELP_AMBULANCE z_angle_to 90.0
        009A: $WASTED_HELP_MEDIC = create_actor 4 #MEDIC at 801.75 -617.75 20.6875
        0173: set_actor $WASTED_HELP_MEDIC z_angle_to 25.0
        009F: set_actor $WASTED_HELP_MEDIC objective_to-1
        0350: set_char_stay_in_same_place $WASTED_HELP_MEDIC  1
        03E5: text_box 'HEAL_A'   // Your ~h~health~w~ is displayed in orange in the top right of the screen.
        03E7: flash_hud 4
        $FLAG_INFO = 1
    end
    if
        $FLAG_INTRO_JUMP == 0
    then
        01BD: $INFO_TIME_NOW = current_time_in_ms
        0084: $INFO_TIME_LAPSED = $INFO_TIME_NOW
        0060: $INFO_TIME_LAPSED -= $INFO_TIME_START
    end
    if and
        0018:   $INFO_TIME_LAPSED > 3000
        001A:   2 > $FLAG_INFO
    then
        03E7: flash_hud -1
    end
    if and
        $INFO_TIME_LAPSED > 5000
        $FLAG_INFO == 1
    then
        03E5: text_box 'HEAL_B'   // When you are ~h~'wasted'~w~ you are returned to the nearest hospital.
        0004: $FLAG_INFO = 2
    end
    if and
        $INFO_TIME_LAPSED > 11000
        $FLAG_INFO == 2
    then
        if and
            8119:   NOT   car $WASTED_HELP_AMBULANCE wrecked
            8118:   NOT   actor $WASTED_HELP_MEDIC dead
        then
            015F: set_camera_position 798.0 -613.5 23.0 0.0 0.0 0.0
            0158: camera_on_vehicle $WASTED_HELP_AMBULANCE 15 2
            0350: set_char_stay_in_same_place $WASTED_HELP_MEDIC  0
            01D5: actor $WASTED_HELP_MEDIC go_to_and_drive_car $WASTED_HELP_AMBULANCE
        end
        03E5: text_box 'HEAL_C'   // You will lose your weapons and the doctors will take some cash for patching you up.
        $FLAG_INFO = 3
    end
    if and
        $INFO_TIME_LAPSED > 14000
        $FLAG_INFO == 3
    then
        03E5: text_box 'WANT_I'   // Any mission you were on will be failed.
        $FLAG_INFO = 4
    end
    if and
        $INFO_TIME_LAPSED > 17500
        $FLAG_INFO == 4
    then
        $FLAG_INFO = 5
    end
    if and
        $INFO_TIME_LAPSED > 19500
        $FLAG_INFO == 5
    then
        03E5: text_box 'HEAL_E'   // You will find ways of healing or protecting yourself the more you play the game.
        015F: set_camera_position 803.56 -600.0 24.0 0.0 0.0 0.0
        0160: point_camera 809.25 -603.5 21.0 2
        0213: $WASTED_HELP_HEALTH_PICKUP = create_pickup #HEALTH type 14 at 809.25 -603.5 21.0
        if
            8119:   NOT   car $WASTED_HELP_AMBULANCE wrecked
        then
            00A8: set_car $WASTED_HELP_AMBULANCE to_psycho_driver
        end
        $FLAG_INFO = 6
    end
    if and
        $INFO_TIME_LAPSED > 22500
        $FLAG_INFO == 6
    then
        0160: point_camera 812.0 -601.062 21.0 1
        0213: $WASTED_HELP_ARMOUR_PICKUP = create_pickup #BODYARMOUR type 14 at 812.0 -601.062 21.0
        0004: $FLAG_INFO = 7
    end
    if and
        $INFO_TIME_LAPSED > 24000
        $FLAG_INFO == 7
    then
        0169: set_fade_color 0 0 0
        016A: fade 0 (in)  1500 ms
        03E6: remove_text_box
        while fading
            wait 0
        end
        00A6: destroy_car $WASTED_HELP_AMBULANCE
        009B: destroy_actor_instantly $WASTED_HELP_MEDIC
        0215: destroy_pickup $WASTED_HELP_HEALTH_PICKUP
        0215: destroy_pickup $WASTED_HELP_ARMOUR_PICKUP
        02EB: restore_camera_jumpcut
        01B4: set_player $PLAYER can_move 1 (unfrozen)
        010D: set_player $PLAYER wanted_level_to $WANTED_LEVEL
        0169: set_fade_color 0 0 0
        016A: fade 1 (out)  1500 ms
        while fading
            wait 0
        end
        $FLAG_INFO = 8
    end
    if and
        $INFO_TIME_LAPSED > 16500
        7 > $FLAG_INFO
    then
        if and
            8119:   NOT   car $WASTED_HELP_AMBULANCE wrecked
            8118:   NOT   actor $WASTED_HELP_MEDIC dead
        then
            if and
                00DB:   actor $WASTED_HELP_MEDIC in_car $WASTED_HELP_AMBULANCE
                $FLAG_BOTTOM == 0
            then
                00AD: set_car $WASTED_HELP_AMBULANCE max_speed_to 40.0
                00AE: set_car $WASTED_HELP_AMBULANCE driving_style 2  // DRIVINGMODE_AVOIDCARS
                0397: car $WASTED_HELP_AMBULANCE siren = 1 (on)   // never used in VC
                00A7: car $WASTED_HELP_AMBULANCE drive_to 1038.0 -480.0 25.6875
                0004: $FLAG_BOTTOM = 1
            end
        end
    end
    if and
        $FLAG_INTRO_JUMP == 0
        7 > $FLAG_INFO
    then
        if
            00E1:   key_pressed 0 16
        then
            0004: $INFO_TIME_LAPSED = 24001
            0004: $FLAG_INFO = 7
            0004: $FLAG_INTRO_JUMP = 1
        end
    end
end
return

:HEALTH_INFO_CLEANUP
02EB: restore_camera_jumpcut
02A3: toggle_widescreen 0 (off)
01B4: set_player $PLAYER can_move 1 (unfrozen)
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
01C3: remove_references_to_car $WASTED_HELP_AMBULANCE  // Like turning a car into any random car
01C2: remove_references_to_actor $WASTED_HELP_MEDIC  // Like turning an actor into a random pedestrian
0249: mark_model_as_no_longer_needed #AMBULAN
0249: mark_model_as_no_longer_needed #MEDIC
01EB: set_car_density_to 1.0
03DE: set_pedestrians_density_multiplier_to 1.0
$FLAG_PLAYER_ON_MISSION = 0
$FLAG_HEALTH_INFO = 1
mission_cleanup
return
