//-------------Mission 77-------------
// Originally: Hood Mission 4 'BULLION RUN'

:M77_BULLIONRUN
03A4: name_thread 'HOOD4'
054C: use_GXT_table 'HOOD4'
gosub @MISSION_START_HOOD4
if
    wasted_or_busted
then
    gosub @MISSION_HOOD4_FAILED
end
gosub @MISSION_CLEANUP_HOOD4
end_thread

:MISSION_START_HOOD4
0004: $FLAG_PLAYER_ON_MISSION = 1  
0004: $ON_MISSION_FOR_HOODS = 1  
increment_mission_attempts
wait 0 ms
0004: $TOTAL_NO_PILLS_CARRIED_HM4 = 0  
0004: $FLAG_PLAYER_IN_AREA_HM4 = 0  
0004: $TIMER_HM4 = 361000  
0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_HM4 = 0  
0004: $FLAG_BLIP_ADDED_HM4 = 0  
03DE: set_pedestrians_density_multiplier_to 0.0
042B: clear_peds_from_cube -749.562 97.6875 7.0 -924.25 -101.75 26.0
03CB: set_camera -779.688 -6.3125 8.875
023C: load_special_actor 1 'PLAYER'
while true
    if
        823D:   NOT   special_actor 1 loaded
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'HD_PH4'
0244: set_cutscene_pos -779.688 -6.3125 8.875
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
016A: fade 1 (back)  1500 ms
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime

while 001A:   2096 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM4_A' 10000 ms 1   // Yo a Federal Reserve flight just smashed down at Francis International.
while 001A:   5840 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM4_B' 10000 ms 1   // There's platinum all over the strip.
while 001A:   8171 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM4_C' 10000 ms 1   // Get a car and snatch up as much as you can.
while 001A:   11161 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM4_F' 10000 ms 1   // You can drop the bling off at one of my garages.
while 001A:   13963 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM4_G' 10000 ms 1   // This platinum is mad heavy and it will slow your wheels down some.
while 001A:   17683 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM4_H' 10000 ms 1   // So make regular drop off's at the garage.
while 001A:   19787 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
03D5: remove_text 'HM4_H'   // So make regular drop off's at the garage.
while 001A:   20433 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   not cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
03DE: set_pedestrians_density_multiplier_to 1.0
00BC: print_now 'HM4_D' 5000 ms 1   // ~g~Get a vehicle!

while 80E0:   NOT   player $PLAYER driving
    wait  0 ms
end
00DA: $CAR_HM4 = player $PLAYER car
021B: set_garage $PLATINUM_DROPOFF_GARAGE to_accept_car $CAR_HM4
018A: $RADAR_BLIP_CAR1_HM4 = create_checkpoint_at -1415.0 -163.188 -100.0
00BC: print_now 'HM4_1' 7000 ms 1   // ~g~Head to the location where the cargo is scattered you need to collect 30 pieces of bullion.
04E4: request_collision_at -1415.0 -163.188 // request collision at location
038B: load_requested_models // force collision to load
02C7: scatter_platinum  90  at -1415.0 -163.188 -100.0  100.0
014E: set_timer_to $TIMER_HM4 type 1
03C4: set_status_text_to $TOTAL_NO_PILLS_CARRIED_HM4 0  'COLLECT'   // COLLECTED:

// waiting for the player to get the correct number of pills
while 8028:   NOT   $TOTAL_NO_PILLS_CARRIED_HM4 >= 30  
    wait 0 ms
    02C8: $NO_OF_PILLS_CARRIED_HM4 = platinum_pieces_in_car
    if
        0057:   player $PLAYER 0 in_cube -1159.688 -165.5 38.75 -1178.5 -171.688 43.0
    then
        0110: clear_player $PLAYER wanted_level
    end
    // Checks to see if any pills are carried and switches off airport blip and puts on the drop off blip
    if
        0018:   $NO_OF_PILLS_CARRIED_HM4 > 0  
    then
        if
            0038:   $FLAG_BLIP_ADDED_HM4 == 0  
        then
            0164: remove_blip $RADAR_BLIP_CAR1_HM4
            018A: $RADAR_BLIP_COORD1_HM4 = create_checkpoint_at -1179.875 -169.562 38.75
            00BC: print_now 'HM4_2' 7000 ms 1   // ~g~Remember when the vehicle becomes too heavy and slow goto the garage and drop off the cargo.
            0004: $FLAG_BLIP_ADDED_HM4 = 1  
        end
    end
    // Checks and removes the no of pills that the player has collected	
    if
        00E0:   player $PLAYER driving
    then
        00DA: $CAR_HM4 = player $PLAYER car
        021B: set_garage $PLATINUM_DROPOFF_GARAGE to_accept_car $CAR_HM4
        if and
            01A0:   player $PLAYER stopped 0 in_cube_in_car -1159.688 -165.5 38.75 -1178.5 -171.688 43.0  // never used in VC
            0038:   $FLAG_PLAYER_IN_AREA_HM4 == 0  
        then
            0058: $TOTAL_NO_PILLS_CARRIED_HM4 += $NO_OF_PILLS_CARRIED_HM4  
            018C: play_sound 83 at -1169.875 -168.75 39.875
            02C9: remove_platinum_from_car
            0004: $FLAG_PLAYER_IN_AREA_HM4 = 1  
        end
        if and
            00DC:   player $PLAYER driving $CAR_HM4
            81A0:   NOT   player $PLAYER stopped 0 in_cube_in_car -1159.688 -165.5 38.75 -1178.5 -171.688 43.0  // never used in VC
            0038:   $FLAG_PLAYER_IN_AREA_HM4 == 1  
        then
            0004: $FLAG_PLAYER_IN_AREA_HM4 = 0  
        end
    end
    
    // Checks for the player getting in and out of the car
    if
        80E0:   NOT   player $PLAYER driving
    then
        021B: set_garage $PLATINUM_DROPOFF_GARAGE to_accept_car -1
        if
            0038:   $FLAG_PLAYER_HAD_CAR_MESSAGE_HM4 == 0  
        then
            00BC: print_now 'IN_VEH2' 5000 ms 1   // ~g~You need some wheels for this job!
            if
                0038:   $FLAG_BLIP_ADDED_HM4 == 1  
            then
                0164: remove_blip $RADAR_BLIP_COORD1_HM4
            end
            0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_HM4 = 1  
        end
    else
        00DA: $CAR_HM4 = player $PLAYER car
        021B: set_garage $PLATINUM_DROPOFF_GARAGE to_accept_car $CAR_HM4
        if
            0038:   $FLAG_PLAYER_HAD_CAR_MESSAGE_HM4 == 1  
        then
            if
                0038:   $FLAG_BLIP_ADDED_HM4 == 1  
            then
                018A: $RADAR_BLIP_COORD1_HM4 = create_checkpoint_at -1179.875 -169.562 38.75
            end
            0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_HM4 = 0  
        end
    end
    if
        0038:   $TIMER_HM4 == 0  
    then
        00BC: print_now 'OUTTIME' 5000 ms 1   // ~r~Too slow man too slow!
        jump @MISSION_HOOD4_FAILED
    end
end
0164: remove_blip $RADAR_BLIP_COORD1_HM4
jump @MISSION_HOOD4_PASSED 

:MISSION_HOOD4_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // MISSION FAILED!
021B: set_garage $PLATINUM_DROPOFF_GARAGE to_accept_car -1
if
    0130:  player $PLAYER busted
then
    016E: override_restart at -1594.5 -44.5 63.75 90.0
    //0420: override_police_station  3
end
if
    0117:  player $PLAYER wasted
then
    016E: override_restart at -1588.0 -138.188 63.75 90.0
    //041F: override_hospital  3
end
return

:MISSION_HOOD4_PASSED
0004: $BULLION_RUN_COMPLETED = 1  
0318: set_latest_mission_passed 'HM_4'   // 'BULLION RUN'
030C: set_mission_points += 1
01E3: text_1number_styled 'M_PASS' 25000 5000 ms 1   // MISSION PASSED! $~1~
0394: play_music 1
0109: player $PLAYER money += 25000
0110: clear_player $PLAYER wanted_level
004F: create_thread @HOODS_MISSION5_LOOP
return

:MISSION_CLEANUP_HOOD4
0004: $FLAG_PLAYER_ON_MISSION = 0  
0004: $ON_MISSION_FOR_HOODS = 0  
021B: set_garage $PLATINUM_DROPOFF_GARAGE to_accept_car -1
02C9: remove_platinum_from_car
02C6: clear_pacman
0164: remove_blip $RADAR_BLIP_COORD1_HM4
0164: remove_blip $RADAR_BLIP_CAR1_HM4
014F: stop_timer $TIMER_HM4
0151: remove_status_text $TOTAL_NO_PILLS_CARRIED_HM4
mission_cleanup
return
