//-------------Mission 0-------------
// Originally: Intro movie

:M00_INTRO
03A4: name_thread 'INTRO'
054C: use_GXT_table 'INTRO'
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $SKIP_FLAG = 0
wait 0 ms
0169: set_fade_color 0 0 0
016A: fade 0 (in)  0 ms
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
01B4: set_player $PLAYER can_move 0 (frozen)
0336: set_player_visible $PLAYER 0
03AF: set_streaming 0 (disabled)
03AD: set_rubbish 0 (invisible)
if
    82BD:   NOT   debug_mode == DEBUG_MASTERDEBUG
then
    03EF: player $PLAYER make_safe
    //043D: set_intro_is_playing  1
    //03F7: load_island_data  0
    023C: load_special_actor 1 'CAT'
    023C: load_special_actor 2 'COLROB'
    023C: load_special_actor 3 'MIGUEL'
    023C: load_special_actor 4 'PLAYERX'
    02F3: load_object #CUTOBJ01 'CS_BAN'
    02F3: load_object #CUTOBJ02 'BANKD'
    02F3: load_object #CUTOBJ03 'CS_LOOT'
    02F3: load_object #CUTOBJ04 'COLT1'
    02F3: load_object #CUTOBJ05 'CATH'
    01F5: $SCRIPT_CONTROLLED_PLAYER = get_player_char $PLAYER
    if
        8118:   NOT   actor $SCRIPT_CONTROLLED_PLAYER dead
    then
        0352: set_actor $SCRIPT_CONTROLLED_PLAYER skin_to 'PLAYER'
        while   8248:   NOT   model #NULL available
            wait 0 ms
        end
        if
            8118:   NOT   actor $SCRIPT_CONTROLLED_PLAYER dead
        then
            0353: refresh_actor $SCRIPT_CONTROLLED_PLAYER
        end
    end
    0374: set_motion_blur 5
    01B6: set_weather 3
    00C0: set_current_time 12 0
    03B7: process_cut_scene_only 0
    038B: load_all_models_now

    while true
        if or
            823D:   NOT   special_actor 1 loaded
            823D:   NOT   special_actor 2 loaded
            8248:   NOT   model #CUTOBJ01 available
            8248:   NOT   model #CUTOBJ02 available
            8248:   NOT   model #CUTOBJ03 available
            8248:   NOT   model #CUTOBJ04 available
        jf break
        wait 0 ms
    end
    while true
        if or
            8248:   NOT   model #CUTOBJ05 available
            823D:   NOT   special_actor 3 loaded
            823D:   NOT   special_actor 4 loaded
        jf break
        wait 0 ms
    end
    02E4: load_cutscene_data 'BET'
    03CB: set_camera -894.625 1030.5 46.0
    0244: set_cutscene_pos -872.375 1051.1899 42.875
    02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL04
    02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYERX'
    02E5: $CUTCSENE_CAT = create_cutscene_object #SPECIAL01
    02E6: set_cutscene_anim $CUTCSENE_CAT 'CAT'
    02E5: $INTRO_COLOMBIAN_ROBBER = create_cutscene_object #SPECIAL02
    02E6: set_cutscene_anim $INTRO_COLOMBIAN_ROBBER 'COLROB'
    02E5: $INTRO_MIGUEL = create_cutscene_object #SPECIAL03
    02E6: set_cutscene_anim $INTRO_MIGUEL 'MIGUEL'
    //02F4: create_cutscene_actor $CAT_CSHEAD from_head #CUTOBJ05 and_body $CUTCSENE_CAT
    //02F5: set_head_anim $CAT_CSHEAD 'CAT'
    02E5: $CS_BAN = create_cutscene_object #CUTOBJ01
    02E6: set_cutscene_anim $CS_BAN 'CS_BAN'
    02E5: $INTRO_BANKDOOR = create_cutscene_object #CUTOBJ02
    02E6: set_cutscene_anim $INTRO_BANKDOOR 'BANKD'
    02E5: $CS_LOOT = create_cutscene_object #CUTOBJ03
    02E6: set_cutscene_anim $CS_LOOT 'CS_LOOT'
    02E5: $CS_COLT1 = create_cutscene_object #CUTOBJ04
    02E6: set_cutscene_anim $CS_COLT1 'COLT1'
    02E5: $CS_COLT2 = create_cutscene_object #CUTOBJ04
    02E6: set_cutscene_anim $CS_COLT2 'COLT2'
    0418: set_object_draw_last $CS_BAN 1
    03AF: set_streaming 1
    02E7: start_cutscene
    016A: fade 1 (out)  2000 ms
    02E8: $CUT_SCENE_TIME = cutscenetime

    while 001A:   17166 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end

    0374: set_motion_blur 3  //SETS UP THE GREEN SECURITY CAMERA

    while 001A:   18126 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    043C: set_music_does_fade 0
    if
        82E9:   NOT cutscene_reached_end
    then
        0169: set_fade_color 255 255 255
        016A: fade 0 (in)  100 ms
        0005: $PARTICLE_X = -872.375
        0009: $PARTICLE_X += 1.75
        0005: $PARTICLE_Y = 1051.1899
        000D: $PARTICLE_Y -= 0.375
        0005: $PARTICLE_Z = 42.875
        0009: $PARTICLE_Z += 1.9375
        0005: $PARTICLE_TARGET_X = -872.375
        0009: $PARTICLE_TARGET_X += 2.0625
        0005: $PARTICLE_TARGET_Y = 1051.1899
        000D: $PARTICLE_TARGET_Y -= 0.9375
        0005: $PARTICLE_TARGET_Z = 42.875
        0009: $PARTICLE_TARGET_Z += 2.625
        0086: $TEMP_VAR = $PARTICLE_TARGET_X
        0086: $PARTICLE_TARGET_X = $PARTICLE_X
        0061: $PARTICLE_TARGET_X -= $TEMP_VAR
        0086: $TEMP_VAR = $PARTICLE_TARGET_Y
        0086: $PARTICLE_TARGET_Y = $PARTICLE_Y
        0061: $PARTICLE_TARGET_Y -= $TEMP_VAR
        0086: $TEMP_VAR = $PARTICLE_TARGET_Z
        0086: $PARTICLE_TARGET_Z = $PARTICLE_Z
        0061: $PARTICLE_TARGET_Z -= $TEMP_VAR
        // particle 19 changed to gun flash
        //039D: scatter_particles 19 1.0 0 0 0 0 at $PARTICLE_X $PARTICLE_Y $PARTICLE_Z $PARTICLE_TARGET_X $PARTICLE_TARGET_Y $PARTICLE_TARGET_Z
        058A: create_gun_flash_from $PARTICLE_X $PARTICLE_Y $PARTICLE_Z to $PARTICLE_TARGET_X $PARTICLE_TARGET_Y $PARTICLE_TARGET_Z
        while fading
            wait 0 ms
            gosub @SKIP_INTRO_BUTTON
            if
                0038:   $SKIP_FLAG == 2
            then
                jump @SKIP_INTRO_HERE
            end
        end
    end
    if
        82E9:   NOT cutscene_reached_end
    then
        044D: load_splash 'NEWS'   // I don't get why it's loaded here in GTA3
    end
    if
        82E9:   NOT cutscene_reached_end
    then
        0169: set_fade_color 1 1 1
        016A: fade 0 (in)  0 ms
    end
    while 001A:   18733 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    if
        82E9:   NOT cutscene_reached_end
    then
        0169: set_fade_color 1 1 1
        016A: fade 1 (out)  0 ms
    end
    0374: set_motion_blur 5
    while 001A:   25249 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'BETRA_A' 4000 ms 1   // Sorry, babe.
    while 001A:   26060 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'BETRA_B' 5000 ms 1   // I'm an ambitious girl and you,
    while 001A:   27000 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    0005: $PARTICLE_X = -872.375
    000D: $PARTICLE_X -= 1.3125
    0005: $PARTICLE_Y = 1051.1899
    0009: $PARTICLE_Y += 25.8125
    0005: $PARTICLE_Z = 42.875
    0009: $PARTICLE_Z += 1.3125
    0005: $PARTICLE_TARGET_X = -872.375
    000D: $PARTICLE_TARGET_X -= 0.375
    0005: $PARTICLE_TARGET_Y = 1051.1899
    0009: $PARTICLE_TARGET_Y += 25.8125
    0005: $PARTICLE_TARGET_Z = 42.875
    0009: $PARTICLE_TARGET_Z += 1.4375
    0086: $TEMP_VAR = $PARTICLE_TARGET_X
    0086: $PARTICLE_TARGET_X = $PARTICLE_X
    0061: $PARTICLE_TARGET_X -= $TEMP_VAR
    0086: $TEMP_VAR = $PARTICLE_TARGET_Y
    0086: $PARTICLE_TARGET_Y = $PARTICLE_Y
    0061: $PARTICLE_TARGET_Y -= $TEMP_VAR
    0086: $TEMP_VAR = $PARTICLE_TARGET_Z
    0086: $PARTICLE_TARGET_Z = $PARTICLE_Z
    0061: $PARTICLE_TARGET_Z -= $TEMP_VAR
    // CHANGE PARTICLE TYPE
    058A: create_gun_flash_from $PARTICLE_X $PARTICLE_Y $PARTICLE_Z to $PARTICLE_TARGET_X $PARTICLE_TARGET_Y $PARTICLE_TARGET_Z
    while 001A:   27030 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    0005: $PARTICLE_X = -872.375
    000D: $PARTICLE_X -= 1.8125
    0005: $PARTICLE_Y = 1051.1899
    0009: $PARTICLE_Y += 26.0625
    0005: $PARTICLE_Z = 42.875
    0009: $PARTICLE_Z += 1.3125
    0005: $PARTICLE_TARGET_X = -872.375
    000D: $PARTICLE_TARGET_X -= 0.4375
    0005: $PARTICLE_TARGET_Y = 1051.1899
    0009: $PARTICLE_TARGET_Y += 25.9375
    0005: $PARTICLE_TARGET_Z = 42.875
    0009: $PARTICLE_TARGET_Z += 1.375
    0086: $TEMP_VAR = $PARTICLE_TARGET_X
    0086: $PARTICLE_TARGET_X = $PARTICLE_X
    0061: $PARTICLE_TARGET_X -= $TEMP_VAR
    0086: $TEMP_VAR = $PARTICLE_TARGET_Y
    0086: $PARTICLE_TARGET_Y = $PARTICLE_Y
    0061: $PARTICLE_TARGET_Y -= $TEMP_VAR
    0086: $TEMP_VAR = $PARTICLE_TARGET_Z
    0086: $PARTICLE_TARGET_Z = $PARTICLE_Z
    0061: $PARTICLE_TARGET_Z -= $TEMP_VAR
    // particle 18 changed to gun flash
    //039D: scatter_particles 18 1.0 0 0 0 0 at $PARTICLE_X $PARTICLE_Y $PARTICLE_Z $PARTICLE_TARGET_X $PARTICLE_TARGET_Y $PARTICLE_TARGET_Z
    058A: create_gun_flash_from $PARTICLE_X $PARTICLE_Y $PARTICLE_Z to $PARTICLE_TARGET_X $PARTICLE_TARGET_Y $PARTICLE_TARGET_Z
    while 001A:   27100 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    0374: set_motion_blur 8
    if
        82E9:   NOT cutscene_reached_end
    then
        0169: set_fade_color 255 255 255
        016A: fade 0 (in)  100 ms
        while fading
            wait 0 ms
            gosub @SKIP_INTRO_BUTTON
            if
                0038:   $SKIP_FLAG == 2
            then
                jump @SKIP_INTRO_HERE
            end
        end
    end
    if
        82E9:   NOT cutscene_reached_end
    then
        016A: fade 1 (out)  600 ms
        while fading
            wait 0 ms
            gosub @SKIP_INTRO_BUTTON
            if
                0038:   $SKIP_FLAG == 2
            then
                jump @SKIP_INTRO_HERE
            end
        end
    end
    0169: set_fade_color 0 0 0
    while 001A:   28710 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'BETRA_C' 2282 ms 1   // you're just small time.
    043C: set_music_does_fade 1
    while 001A:   29200 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    0374: set_motion_blur 5
    while 001A:   30800 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    0374: set_motion_blur 8
    while 001A:   30992 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BE: text_clear_all
    03EB: clear_small_prints
    while 001A:   33333 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    044D: load_splash 'NEWS'
    0169: set_fade_color 0 0 0
    016A: fade 0 (in)  4000 ms
    0004: $TEXT_ALPHA = 0
    0004: $TEXT_FADING_FLAG = 0
    03F0: text_draw_toggle 1
    gosub @DRAW_INTRO_TEXT
    while fading
        wait 0 ms
        gosub @DRAW_INTRO_TEXT
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
    end
    while 82E9:   NOT cutscene_reached_end
        wait 0 ms
        gosub @DRAW_INTRO_TEXT
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
    end

    00BE: text_clear_all
    03EB: clear_small_prints
    02EA: clear_cutscene
    03EF: player $PLAYER make_safe
    01B6: set_weather 2
    0421: force_rain 1
    0296: unload_special_actor 1
    0296: unload_special_actor 2
    0296: unload_special_actor 3
    0296: unload_special_actor 4
    0249: mark_model_as_no_longer_needed #CUTOBJ01
    0249: mark_model_as_no_longer_needed #CUTOBJ02
    0249: mark_model_as_no_longer_needed #CUTOBJ03
    0249: mark_model_as_no_longer_needed #CUTOBJ04
    0249: mark_model_as_no_longer_needed #CUTOBJ05
    03AF: set_streaming 0 (disabled)
    //03F7: load_island_data  2?
    04E4: request_collision -138.9375 -1126.938 // substitutes 03F7
    03CB: load_scene -138.9375 -1126.938 31.625 // added to load area around player
    0055: set_player_coordinates $PLAYER at 485.875 -941.062 -100.0
    0169: set_fade_color 0 0 0
    0374: set_motion_blur 6
    023C: load_special_actor 1 'EIGHT'
    023C: load_special_actor 2 'OJG_P'
    023C: load_special_actor 3 'COL1'
    023C: load_special_actor 4 'COL2'
    02F3: load_object #CUTOBJ01 'CS_TRUK'
    02F3: load_object #CUTOBJ02 'REBEL'
    02F3: load_object #CUTOBJ03 'BRBOMB'
    02F3: load_object #CUTOBJ04 'COL1H'
    0247: request_model #BRIDGEFUKA
    0247: request_model #BRIDGEFUKB
    00C0: set_current_time 2 0
    0247: request_model #TRAFFICLIGHT1
    0247: request_model #RD_SRROAD2A50
    0247: request_model #RD_SRROAD2A20
    0247: request_model #RD_SRROAD2A10
    0247: request_model #RD_CROSSRDA1RW22
    0247: request_model #RD_CROSSROADSA24
    0247: request_model #COM_CUST_ROADS25
    0247: request_model #VEG_TREE3
    0247: request_model #DOUBLESTREETLGHT1
    0247: request_model #VEG_TREEA3
    0247: request_model #VEG_TREENEW17

    0247: request_model #STREETLAMP1
    0247: request_model #BOLLARDLIGHT
    0247: request_model #KB_SCRAP_5
    0247: request_model #POLICETENKB1
    0247: request_model #SCRAPERKB3_NIT
    0247: request_model #CHUNK5LAND
    0247: request_model #POLICEALLY
    0247: request_model #POLICE_COM
    0247: request_model #RD_CROSSRDA1W22
    0247: request_model #TREEPATCHKB7
    0247: request_model #ROADPLANTERKB3
    0247: request_model #ROADPLANTERKB1
    0247: request_model #RD_ROAD3A50
    0247: request_model #AMCO_FLOOR
    0247: request_model #COP
    038B: load_all_models_now

    while true
        if or
            823D:   NOT   special_actor 1 loaded
            823D:   NOT   special_actor 2 loaded
            823D:   NOT   special_actor 3 loaded
            823D:   NOT   special_actor 4 loaded
        jf break
        wait 0 ms
        gosub @DRAW_INTRO_TEXT
    end

    while true
        if or
            8248:   NOT   model #CUTOBJ01 available
            8248:   NOT   model #CUTOBJ02 available
            8248:   NOT   model #CUTOBJ03 available
            8248:   NOT   model #CUTOBJ04 available
            8248:   NOT   model #BRIDGEFUKA available
            8248:   NOT   model #BRIDGEFUKB available
            8248:   NOT   model #COP available
        jf break
        wait 0 ms
        gosub @DRAW_INTRO_TEXT
    end
    01F5: $SCRIPT_CONTROLLED_PLAYER = get_player_char $PLAYER
    if
        8118:   NOT   actor $SCRIPT_CONTROLLED_PLAYER dead
    then
        0352: set_actor $SCRIPT_CONTROLLED_PLAYER skin_to 'PLAYERP'
    end
    while 8248:   NOT   model #NULL available
        wait 0 ms
        gosub @DRAW_INTRO_TEXT
    end
    if
        8118:   NOT   actor $SCRIPT_CONTROLLED_PLAYER dead
    then
        0353: refresh_actor $SCRIPT_CONTROLLED_PLAYER
    end
    02E4: load_cutscene_data 'JB'
    0244: set_cutscene_pos -335.0 0.0 6.0
    02E5: $CUTSCENE_PLAYER = create_cutscene_object #NULL
    02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYERP'
    02E5: $CUTSCENE_EIGHT = create_cutscene_object #SPECIAL01
    02E6: set_cutscene_anim $CUTSCENE_EIGHT 'EIGHT'
    02E5: $CUTSCENE_OJG = create_cutscene_object #SPECIAL02
    02E6: set_cutscene_anim $CUTSCENE_OJG 'OJG_P'
    02E5: $CUTSCENE_COL1 = create_cutscene_object #SPECIAL03
    02E6: set_cutscene_anim $CUTSCENE_COL1 'COL1'
    02E5: $CUTSCENE_COL2 = create_cutscene_object #SPECIAL04
    02E6: set_cutscene_anim $CUTSCENE_COL2 'COL2'
    02E5: $CUTSCENE_COP1 = create_cutscene_object #COP
    02E6: set_cutscene_anim $CUTSCENE_COP1 'COP'
    02E5: $CUTSCENE_COP2 = create_cutscene_object #COP
    02E6: set_cutscene_anim $CUTSCENE_COP2 'MALE01'
    //02F4: create_cutscene_actor $COL1_CSHEAD from_head #CUTOBJ04 and_body $CUTSCENE_COL1
    //02F5: set_head_anim $COL1_CSHEAD 'COL1'
    02E5: $CS_COLT1 = create_cutscene_object #CUTOBJ01
    02E6: set_cutscene_anim $CS_COLT1 'CS_TRUK'
    02E5: $CS_COLT2 = create_cutscene_object #CUTOBJ02
    02E6: set_cutscene_anim $CS_COLT2 'REBEL'
    02E5: $BRBOMB = create_cutscene_object #CUTOBJ03
    02E6: set_cutscene_anim $BRBOMB 'BRBOMB'
    0418: set_object_draw_last $CS_COLT1 1
    0418: set_object_draw_last $CS_COLT2 1
    02E7: start_cutscene
    0506: vehicle_model #PATRIOT set_next_variation -1 0    //Needed because LC patriot has an extra the III did not
    0354: set_up_chase_scene 1.0
    03F4: set_all_vehicles_apply_damage_rules 0             //needed to keep chase cars damage free
    00BE: text_clear_all
    03EB: clear_small_prints
    016A: fade 1 (out)  2000 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
    0247: request_model #RD_CROSSRDA1W22
    0247: request_model #RD_ROAD2A20
    0247: request_model #BROADWAYBUILD2
    0247: request_model #BROADWAYBUILD
    0247: request_model #AREA5BUILD2
    0247: request_model #COMSWCENTRALBLD7
    0247: request_model #PAPERMACHN01
    0247: request_model #COMSWCENTRALBLD6
    0247: request_model #COM_21WAY5
    0247: request_model #COM_21WAY50
    0247: request_model #COM_21WAY10
    0247: request_model #CM1WAYCROSSCOM
    0247: request_model #COM_21WAY20
    0247: request_model #TWAT_CAFE
    0247: request_model #VEG_BUSH14
    0247: request_model #TREEPATCHTTWRS
    0247: request_model #FLATIRON1
    0247: request_model #VEG_TREE3
    0247: request_model #VEG_TREENEW17
    0247: request_model #BLOCK4_GROUND01

    while 001A:   9500 > $CUT_SCENE_TIME
        wait 0 ms
        0004: $TEXT_FADING_FLAG = 1
        gosub @DRAW_INTRO_TEXT
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        0250: create_light_at -138.9375 -1126.938 31.625 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    0249: mark_model_as_no_longer_needed #RD_SRROAD2A50
    0249: mark_model_as_no_longer_needed #RD_SRROAD2A20
    0249: mark_model_as_no_longer_needed #RD_SRROAD2A10
    0249: mark_model_as_no_longer_needed #RD_CROSSROADSA24
    0249: mark_model_as_no_longer_needed #COM_CUST_ROADS25
    0249: mark_model_as_no_longer_needed #VEG_TREEA3
    0249: mark_model_as_no_longer_needed #STREETLAMP1
    0249: mark_model_as_no_longer_needed #BOLLARDLIGHT
    0249: mark_model_as_no_longer_needed #KB_SCRAP_5
    0249: mark_model_as_no_longer_needed #POLICETENKB1
    0249: mark_model_as_no_longer_needed #SCRAPERKB3_NIT
    0249: mark_model_as_no_longer_needed #CHUNK5LAND
    0249: mark_model_as_no_longer_needed #POLICEALLY
    0249: mark_model_as_no_longer_needed #POLICE_COM
    0249: mark_model_as_no_longer_needed #TREEPATCHKB7
    0249: mark_model_as_no_longer_needed #ROADPLANTERKB3
    0249: mark_model_as_no_longer_needed #ROADPLANTERKB1
    0249: mark_model_as_no_longer_needed #RD_ROAD3A50
    0249: mark_model_as_no_longer_needed #AMCO_FLOOR
    while 001A:   13007 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @DRAW_INTRO_TEXT
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        0250: create_light_at -138.9375 -1126.938 31.625 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    03F0: text_draw_toggle 0
    00BC: print_now 'JAILB_V' 10000 ms 1   // Liberty City is in shock today
    while 001A:   14500 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        0250: create_light_at -138.9375 -1126.938 31.625 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_A' 10000 ms 1   // as the police and emergency services deal with the aftermath
    while 001A:   15933 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        0250: create_light_at -138.9375 -1126.938 31.625 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    0247: request_model #PLANTER_SHORT
    0247: request_model #COM_RVROADS52
    0247: request_model #ROAD_BROADWAY04
    0247: request_model #COM_ROADSRV
    0247: request_model #RD_ROAD1A20
    0247: request_model #RD_CROSSROADS11
    0247: request_model #DOUBLESTREETLGHT1
    0247: request_model #OFIS_BILDKB_4
    0247: request_model #RD_ROAD1A10
    0247: request_model #COM_ROADKB23
    0247: request_model #COM_CUST_ROADS57
    0247: request_model #COM_RVROADS52
    0249: mark_model_as_no_longer_needed #RD_CROSSRDA1W22
    0249: mark_model_as_no_longer_needed #RD_ROAD2A20
    0249: mark_model_as_no_longer_needed #BROADWAYBUILD2
    0249: mark_model_as_no_longer_needed #BROADWAYBUILD
    0249: mark_model_as_no_longer_needed #AREA5BUILD2
    0249: mark_model_as_no_longer_needed #PAPERMACHN01
    0249: mark_model_as_no_longer_needed #COM_21WAY5
    0249: mark_model_as_no_longer_needed #TWAT_CAFE
    0249: mark_model_as_no_longer_needed #TREEPATCHTTWRS
    0249: mark_model_as_no_longer_needed #FLATIRON1
    0249: mark_model_as_no_longer_needed #VEG_TREE3
    0249: mark_model_as_no_longer_needed #VEG_TREENEW17
    0249: mark_model_as_no_longer_needed #BLOCK4_GROUND01
    0249: mark_model_as_no_longer_needed #COMSWCENTRALBLD7
    0249: mark_model_as_no_longer_needed #PAPERMACHN01
    while 001A:   17514 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        0250: create_light_at -138.9375 -1126.938 31.625 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_B' 10000 ms 1   // of a devastating attack on a police convoy this morning.
    while 001A:   18933 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    0247: request_model #COM_ROADKB23
    0247: request_model #COM_ROADKB22
    0247: request_model #KB_UNDERPASS
    0247: request_model #MUSEUM
    0247: request_model #NBCOM_ROADKB01
    0247: request_model #BVBRIDGSPPRT01
    0247: request_model #FLATIRON1B
    0247: request_model #VEG_TREE3
    0247: request_model #NBBRIDGCABLS01
    0247: request_model #NBBRIDGERDB
    0247: request_model #NBBRIDGERDA
    0247: request_model #NBBRIDGCABLS01
    0247: request_model #BVBRIDGSPPRT01
    0247: request_model #OVERPASS_COMSE
    0247: request_model #COM_LANDNEW221B
    0247: request_model #NBCOM_ROADKB01
    0247: request_model #COM_LANDNEW221
    0247: request_model #FLATIRON1B
    0247: request_model #LODTIRON1B
    0247: request_model #VEG_TREE3
    0247: request_model #OFIS_BILDKB_4
    0247: request_model #KB_OFIS1
    0247: request_model #COMTREEPATCHPRK
    0247: request_model #HOTEL2
    0247: request_model #UNDERGROUND_OVER7
    0247: request_model #RD_ROAD1A50
    0247: request_model #KB_UNDERPASS
    0247: request_model #KBPLANTER4
    0247: request_model #BLOCK4_SCRAPERL0
    0247: request_model #COM_ROADKB12
    0247: request_model #PLANTERBTM_1
    0247: request_model #LODRIDGSPPRT01
    0247: request_model #LODOM_ROADKB01
    0247: request_model #LODRIDGERDA
    0247: request_model #LODRIDGERDB
    0247: request_model #LODRIDGCABLS01
    0249: mark_model_as_no_longer_needed #COM_21WAY20
    0249: mark_model_as_no_longer_needed #CM1WAYCROSSCOM
    0249: mark_model_as_no_longer_needed #COM_21WAY10
    0249: mark_model_as_no_longer_needed #AREA5BUILD2
    0249: mark_model_as_no_longer_needed #COMSWCENTRALBLD6
    041D: set_camera_near_clip 2.5
    while 001A:   20667 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_C' 10000 ms 1   // As yet no details have been released about the prisoners being transferred in the convoy
    while 001A:   22181 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    041D: set_camera_near_clip 4.5
    while 001A:   24522 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_D' 10000 ms 1   // and no group has claimed responsibility.
    while 001A:   27208 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_E' 10000 ms 1   // The convoy left police headquarters early this morning
    while 001A:   29793 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_F' 10000 ms 1   // for a routine transfer of felons to Liberty penitentiary.
    while 001A:   30599 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    041D: set_camera_near_clip 5.5
    0247: request_model #IND_CUSTOMROAD003
    0249: mark_model_as_no_longer_needed #PLANTER_SHORT
    0249: mark_model_as_no_longer_needed #COM_RVROADS52
    0249: mark_model_as_no_longer_needed #ROAD_BROADWAY04
    0249: mark_model_as_no_longer_needed #COM_ROADSRV
    0249: mark_model_as_no_longer_needed #RD_ROAD1A20
    0249: mark_model_as_no_longer_needed #RD_CROSSROADS11
    0249: mark_model_as_no_longer_needed #COM_21WAY50
    0249: mark_model_as_no_longer_needed #RD_ROAD1A10
    0249: mark_model_as_no_longer_needed #COM_CUST_ROADS57

    03AF: set_streaming 1 // added to resume loading of map

    while 001A:   32986 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_G' 10000 ms 1   // The attack took place on the Callahan Bridge
    while 001A:   34817 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_H' 10000 ms 1   // leaving few witnesses and the bridge itself severely damaged.
    while 001A:   38590 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_I' 10000 ms 1   // Some of the convicts are thought to have perished in the explosion
    while 001A:   40842 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_J' 10000 ms 1   // that followed the initial attack.
    while 001A:   42066 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    041D: set_camera_near_clip 4.5
    0247: request_model #KMRICNDO01
    0247: request_model #KMRICNDO02
    0247: request_model #VEG_TREENEW17
    0247: request_model #COM_DOCKSAA
    0247: request_model #COM_PIER3
    0247: request_model #GRD_OVERPASS19KB
    0247: request_model #GRD_OVERPASS19BKB

    while 001A:   42535 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_W' 10000 ms 1   // Revelations as to the professionalism of the attack struck police hours afterward
    while 001A:   46683 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_K' 10000 ms 1   // when identifications of the missing felons were further hampered
    while 001A:   49483 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_L' 10000 ms 1   // by an attack by computer hackers on police headquarter databases.
    while 001A:   53406 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_O' 10000 ms 1   // With the Porter Tunnel project falling behind schedule,
    while 001A:   53666 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    041D: set_camera_near_clip 0.875
    while 001A:   56077 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_P' 5000 ms 1   // this disaster leaves Portland isolated from the rest of the city.
    while 001A:   64200 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    040A: remove_car_from_chase  2
    while 001A:   64333 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    040A: remove_car_from_chase  1
    while 001A:   64566 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    0247: request_model #COM_DOCKSB
    0247: request_model #NEWDOCKBUILDING2
    0247: request_model #NEWDOCKBUILDING
    0247: request_model #BLOCK4_SCRAPERL0
    0249: mark_model_as_no_longer_needed #COM_ROADKB22
    0249: mark_model_as_no_longer_needed #COM_ROADKB23
    0249: mark_model_as_no_longer_needed #NBCOM_ROADKB01
    0249: mark_model_as_no_longer_needed #COM_LANDNEW221
    0249: mark_model_as_no_longer_needed #DOUBLESTREETLGHT1
    0249: mark_model_as_no_longer_needed #MUSEUM
    0249: mark_model_as_no_longer_needed #OFIS_BILDKB_4
    0249: mark_model_as_no_longer_needed #KB_OFIS1
    0249: mark_model_as_no_longer_needed #COMTREEPATCHPRK
    0249: mark_model_as_no_longer_needed #HOTEL2
    0249: mark_model_as_no_longer_needed #UNDERGROUND_OVER7
    0249: mark_model_as_no_longer_needed #TRAFFICLIGHT1
    0249: mark_model_as_no_longer_needed #RD_ROAD1A50
    0249: mark_model_as_no_longer_needed #VEG_BUSH14
    0249: mark_model_as_no_longer_needed #KB_UNDERPASS
    0249: mark_model_as_no_longer_needed #OFIS_BILDKB_4
    0249: mark_model_as_no_longer_needed #KBPLANTER4
    0249: mark_model_as_no_longer_needed #PLANTERBTM_1
    0249: mark_model_as_no_longer_needed #COM_RVROADS52
    while 001A:   66171 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_Q' 1200 ms 1   // Come on!
    while 001A:   69378 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_R' 1600 ms 1   // Senor dickhead!
    while 001A:   71994 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_S' 2000 ms 1   // It's no problem to kill you.
    while 001A:   75623 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_T' 1800 ms 1   // You gonna be sorry.
    while 001A:   79633 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    0249: mark_model_as_no_longer_needed #KMRICNDO01
    0249: mark_model_as_no_longer_needed #KMRICNDO02
    0249: mark_model_as_no_longer_needed #VEG_TREE3
    0249: mark_model_as_no_longer_needed #VEG_TREENEW17
    0249: mark_model_as_no_longer_needed #COM_DOCKSAA
    0249: mark_model_as_no_longer_needed #COM_PIER3
    0249: mark_model_as_no_longer_needed #GRD_OVERPASS19KB
    0249: mark_model_as_no_longer_needed #GRD_OVERPASS19BKB
    while 001A:   86089 > $CUT_SCENE_TIME
    wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BC: print_now 'JAILB_U' 1800 ms 1   // A'right, a'right. Get lost.
    while 001A:   87592 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 235 255 250
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    00BE: text_clear_all
    03EB: clear_small_prints
    while 001A:   98766 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 205 255 230
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    while 001A:   101866 > $CUT_SCENE_TIME
        wait 0 ms
        gosub @SKIP_INTRO_BUTTON
        if
            0038:   $SKIP_FLAG == 2
        then
            jump @SKIP_INTRO_HERE
        end
        0250: create_light_at 445.5 -942.875 45.0 RGB_values 205 255 230
        02E8: $CUT_SCENE_TIME = cutscenetime
    end
    043C: set_music_does_fade 0
    0374: set_motion_blur 7
    if
        82E9:   NOT cutscene_reached_end
    then
        0169: set_fade_color 255 255 255
        016A: fade 0 (in)  100 ms
        00BE: text_clear_all
        while fading
            wait 0 ms
        end
    end

    :SKIP_INTRO_HERE
    044D: load_splash 'SPLASH1'
    if
        0038:   $SKIP_FLAG == 2
    then
        wait 0 ms
        03F0: text_draw_toggle 0
        043C: set_music_does_fade 1
        0169: set_fade_color 0 0 0
        016A: fade 0 (in)  0 ms
    end
    0249: mark_model_as_no_longer_needed #TRAFFICLIGHT1
    0249: mark_model_as_no_longer_needed #RD_SRROAD2A50
    0249: mark_model_as_no_longer_needed #RD_SRROAD2A20
    0249: mark_model_as_no_longer_needed #RD_SRROAD2A10
    0249: mark_model_as_no_longer_needed #RD_CROSSRDA1RW22
    0249: mark_model_as_no_longer_needed #RD_CROSSROADSA24
    0249: mark_model_as_no_longer_needed #COM_CUST_ROADS25
    0249: mark_model_as_no_longer_needed #VEG_TREE3
    0249: mark_model_as_no_longer_needed #DOUBLESTREETLGHT1
    0249: mark_model_as_no_longer_needed #VEG_TREEA3
    0249: mark_model_as_no_longer_needed #VEG_TREENEW17
    0249: mark_model_as_no_longer_needed #STREETLAMP1
    0249: mark_model_as_no_longer_needed #BOLLARDLIGHT
    0249: mark_model_as_no_longer_needed #KB_SCRAP_5
    0249: mark_model_as_no_longer_needed #POLICETENKB1
    0249: mark_model_as_no_longer_needed #SCRAPERKB3_NIT
    0249: mark_model_as_no_longer_needed #CHUNK5LAND
    0249: mark_model_as_no_longer_needed #POLICEALLY
    0249: mark_model_as_no_longer_needed #POLICE_COM
    0249: mark_model_as_no_longer_needed #RD_CROSSRDA1W22
    0249: mark_model_as_no_longer_needed #TREEPATCHKB7
    0249: mark_model_as_no_longer_needed #ROADPLANTERKB3
    0249: mark_model_as_no_longer_needed #ROADPLANTERKB1
    0249: mark_model_as_no_longer_needed #RD_ROAD3A50
    0249: mark_model_as_no_longer_needed #RD_CROSSRDA1W22
    0249: mark_model_as_no_longer_needed #RD_ROAD2A20
    0249: mark_model_as_no_longer_needed #BROADWAYBUILD2
    0249: mark_model_as_no_longer_needed #BROADWAYBUILD
    0249: mark_model_as_no_longer_needed #AREA5BUILD2
    0249: mark_model_as_no_longer_needed #COMSWCENTRALBLD7
    0249: mark_model_as_no_longer_needed #PAPERMACHN01
    0249: mark_model_as_no_longer_needed #COMSWCENTRALBLD6
    0249: mark_model_as_no_longer_needed #COM_21WAY5
    0249: mark_model_as_no_longer_needed #COM_21WAY50
    0249: mark_model_as_no_longer_needed #COM_21WAY10
    0249: mark_model_as_no_longer_needed #CM1WAYCROSSCOM
    0249: mark_model_as_no_longer_needed #COM_21WAY20
    0249: mark_model_as_no_longer_needed #TWAT_CAFE
    0249: mark_model_as_no_longer_needed #VEG_BUSH14
    0249: mark_model_as_no_longer_needed #TREEPATCHTTWRS
    0249: mark_model_as_no_longer_needed #FLATIRON1
    0249: mark_model_as_no_longer_needed #VEG_TREE3
    0249: mark_model_as_no_longer_needed #VEG_TREENEW17
    0249: mark_model_as_no_longer_needed #BLOCK4_GROUND01
    0249: mark_model_as_no_longer_needed #PLANTER_SHORT
    0249: mark_model_as_no_longer_needed #COM_RVROADS52
    0249: mark_model_as_no_longer_needed #ROAD_BROADWAY04
    0249: mark_model_as_no_longer_needed #COM_ROADSRV
    0249: mark_model_as_no_longer_needed #RD_ROAD1A20
    0249: mark_model_as_no_longer_needed #RD_CROSSROADS11
    0249: mark_model_as_no_longer_needed #DOUBLESTREETLGHT1
    0249: mark_model_as_no_longer_needed #OFIS_BILDKB_4
    0249: mark_model_as_no_longer_needed #RD_ROAD1A10
    0249: mark_model_as_no_longer_needed #COM_ROADKB23
    0249: mark_model_as_no_longer_needed #COM_CUST_ROADS57
    0249: mark_model_as_no_longer_needed #COM_RVROADS52
    0249: mark_model_as_no_longer_needed #COM_ROADKB23
    0249: mark_model_as_no_longer_needed #COM_ROADKB22
    0249: mark_model_as_no_longer_needed #KB_UNDERPASS
    0249: mark_model_as_no_longer_needed #MUSEUM
    0249: mark_model_as_no_longer_needed #NBCOM_ROADKB01
    0249: mark_model_as_no_longer_needed #BVBRIDGSPPRT01
    0249: mark_model_as_no_longer_needed #FLATIRON1B
    0249: mark_model_as_no_longer_needed #LODTIRON1B
    0249: mark_model_as_no_longer_needed #VEG_TREE3
    0249: mark_model_as_no_longer_needed #NBBRIDGCABLS01
    0249: mark_model_as_no_longer_needed #NBBRIDGERDB
    0249: mark_model_as_no_longer_needed #NBBRIDGERDA
    0249: mark_model_as_no_longer_needed #NBBRIDGCABLS01
    0249: mark_model_as_no_longer_needed #BVBRIDGSPPRT01
    0249: mark_model_as_no_longer_needed #OVERPASS_COMSE
    0249: mark_model_as_no_longer_needed #COM_LANDNEW221B
    0249: mark_model_as_no_longer_needed #NBCOM_ROADKB01
    0249: mark_model_as_no_longer_needed #COM_LANDNEW221
    0249: mark_model_as_no_longer_needed #FLATIRON1B
    0249: mark_model_as_no_longer_needed #VEG_TREE3
    0249: mark_model_as_no_longer_needed #MUSEUM
    0249: mark_model_as_no_longer_needed #OFIS_BILDKB_4
    0249: mark_model_as_no_longer_needed #KB_OFIS1
    0249: mark_model_as_no_longer_needed #COMTREEPATCHPRK
    0249: mark_model_as_no_longer_needed #HOTEL2
    0249: mark_model_as_no_longer_needed #UNDERGROUND_OVER7
    0249: mark_model_as_no_longer_needed #RD_ROAD1A50
    0249: mark_model_as_no_longer_needed #KB_UNDERPASS
    0249: mark_model_as_no_longer_needed #KBPLANTER4
    0249: mark_model_as_no_longer_needed #BLOCK4_SCRAPERL0
    0249: mark_model_as_no_longer_needed #COM_ROADKB12
    0249: mark_model_as_no_longer_needed #PLANTERBTM_1
    0249: mark_model_as_no_longer_needed #FLATIRON1B
    0249: mark_model_as_no_longer_needed #IND_CUSTOMROAD003
    0249: mark_model_as_no_longer_needed #KMRICNDO01
    0249: mark_model_as_no_longer_needed #KMRICNDO02
    0249: mark_model_as_no_longer_needed #VEG_TREENEW17
    0249: mark_model_as_no_longer_needed #COM_DOCKSAA
    0249: mark_model_as_no_longer_needed #COM_PIER3
    0249: mark_model_as_no_longer_needed #GRD_OVERPASS19KB
    0249: mark_model_as_no_longer_needed #GRD_OVERPASS19BKB
    0249: mark_model_as_no_longer_needed #COM_DOCKSB
    0249: mark_model_as_no_longer_needed #NEWDOCKBUILDING2
    0249: mark_model_as_no_longer_needed #NEWDOCKBUILDING
    0249: mark_model_as_no_longer_needed #BLOCK4_SCRAPERL0
    0249: mark_model_as_no_longer_needed #LODRIDGCABLS01
    03B6: replace_model_at 190.312 -927.062 77.8125 radius 20.0 from #NBBRIDGCABLS01 to #NBBRIDGFK2
    03B6: replace_model_at 371.375 -935.812 73.0625 radius 20.0 from #NBBRIDGCABLS01 to #NBBRIDGFK2
    03B6: replace_model_at 194.0 -920.062 49.5 radius 20.0 from #NBBRIDGERDB to #DAMGBRIDGERDB
    03B6: replace_model_at 367.75 -939.938 44.6875 radius 20.0 from #NBBRIDGERDB to #DAMGBRIDGERDB
    03B6: replace_model_at 194.0 -942.938 49.5 radius 20.0 from #NBBRIDGERDA to #DAMGBBRIDGERDA
    03B6: replace_model_at 367.75 -919.938 44.6875 radius 20.0 from #NBBRIDGERDA to #DAMGBBRIDGERDA
    03B6: replace_model_at 190.312 -927.062 77.8125 radius 20.0 from #LODRIDGCABLS01 to #LODRIDGFK2
    03B6: replace_model_at 371.375 -935.812 73.0625 radius 20.0 from #LODRIDGCABLS01 to #LODRIDGFK2
    03B6: replace_model_at 186.125 -922.938 49.5 radius 20.0 from #LODRIDGERDB to #LODGBRIDGERDB
    03B6: replace_model_at 367.75 -939.938 44.6875 radius 20.0 from #LODRIDGERDB to #LODGBRIDGERDB
    03B6: replace_model_at 194.0 -940.062 49.5 radius 20.0 from #LODRIDGERDA to #LODGBBRIDGERDA
    03B6: replace_model_at 367.75 -919.938 44.6875 radius 20.0 from #LODRIDGERDA to #LODGBBRIDGERDA
    029B: $BROKEN_BRIDGE_REMAINS = init_object #BRIDGEFUKA at 380.688 -937.875 46.1875
    029B: $BROKEN_BRIDGE_POLICE_CARS = init_object #BRIDGEFUKB at 452.812 -939.188 44.9375
    0055: set_player_coordinates $PLAYER at 476.875 -939.938 41.75
    0171: set_player $PLAYER z_angle_to 180.0
    03B7: process_cut_scene_only 1 (false)
    03AF: set_streaming 1 (enabled)
    03F0: text_draw_toggle 0
    0006: 16@ = 6001               //TIMER A
    gosub @DO_BRIDGE_PARTICLES
    018D: $FIRE_SOUND_8BALL = create_sound 102 at 455.5 -935.625 44.0
end  //end skip if debug is on
03F0: text_draw_toggle 0
if
    8038:   NOT   $SKIP_FLAG == 2
then
    0336: set_player_visible $PLAYER 1
    if
        82BD:   NOT   debug_mode == DEBUG_MASTERDEBUG
    then
        0247: request_model #KURUMA
		038B: load_all_models_now
		while 8248:   NOT   model #KURUMA available
			wait 0 ms
			gosub @DO_BRIDGE_PARTICLES
		end
		00A5: $EIGHT_CAR = create_car #KURUMA at 477.0 -945.5 41.75
        0229: set_car $EIGHT_CAR color_to 58 1
    else
        0247: request_model #DELODRV
		0247: request_model #PYTHON
		0247: request_model #SHOTGUN
		0247: request_model #UZI
		0247: request_model #AK47
		0247: request_model #M16
		0247: request_model #LASER
		0247: request_model #ROCKET
		0247: request_model #MOLOTOV
        while true
			if or
				8248:   NOT   model #DELODRV available
				8248:   NOT   model #PYTHON available
				8248:   NOT   model #SHOTGUN available
				8248:   NOT   model #UZI available
			jf break
            wait 0 ms
        end
		while true
			if or
				8248:   NOT   model #AK47 available
				8248:   NOT   model #M16 available
				8248:   NOT   model #LASER available
				8248:   NOT   model #ROCKET available
				8248:   NOT   model #MOLOTOV available
			jf break
            wait 0 ms
        end
        00A5: $EIGHT_CAR = create_car #DELODRV at 477.0 -945.5 41.75
        02AC: set_car $EIGHT_CAR immunities 1 1 1 1 1
		01B1: give_player $PLAYER weapon 21 ammo 100  // shotgun
		01B1: give_player $PLAYER weapon 23 ammo 100  // uzi
		01B1: give_player $PLAYER weapon 27 ammo 100  // ak47
		01B1: give_player $PLAYER weapon 26 ammo 100  // m16
		01B1: give_player $PLAYER weapon 29 ammo 100  // laser
		01B1: give_player $PLAYER weapon 30 ammo 100  // rocket
		01B1: give_player $PLAYER weapon 15 ammo 100  // molotov
		01B1: give_player $PLAYER weapon 18 ammo 100  // python
    end
    0175: set_car $EIGHT_CAR z_angle_to 262.375
    if
        82BD:   NOT   debug_mode == DEBUG_MASTERDEBUG
    then
        009A: $8BALL_CHAR = create_actor 21 #SPECIAL01 at 476.875 -942.438 41.75
        0245: set_actor $8BALL_CHAR walk_style_to  30
        01ED: reset_actor $8BALL_CHAR flags
        01BE: set_actor $8BALL_CHAR to_look_at_spot 476.875 -939.938 41.75
        022D: set_actor $8BALL_CHAR to_look_at_player $PLAYER
        0355: clean_up_chase_scene
        0249: mark_model_as_no_longer_needed #LODRIDGSPPRT01
        0249: mark_model_as_no_longer_needed #LODOM_ROADKB01
        0249: mark_model_as_no_longer_needed #LODRIDGERDA
        0249: mark_model_as_no_longer_needed #LODRIDGERDB
        while 001A:   107172 > $CUT_SCENE_TIME
            wait 0 ms
            gosub @DO_BRIDGE_PARTICLES
            gosub @SKIP_INTRO_BUTTON
            if
                0038:   $SKIP_FLAG == 2
            then
                jump @SKIP_INTRO_HERE
            end
            0250: create_light_at 445.5 -942.875 45.0 RGB_values 205 255 230
            02E8: $CUT_SCENE_TIME = cutscenetime
        end
        if
            82E9:   NOT cutscene_reached_end
        then
            0169: set_fade_color 255 255 255
            016A: fade 1 (out)  6000 ms
            00BE: text_clear_all
        end
        while fading
            wait 0 ms
            gosub @DO_BRIDGE_PARTICLES
        end
        while 001A:   121666 > $CUT_SCENE_TIME
            wait 0 ms
            gosub @DO_BRIDGE_PARTICLES
            gosub @SKIP_INTRO_BUTTON
            if
                0038:   $SKIP_FLAG == 2
            then
                jump @SKIP_INTRO_HERE
            end
            0250: create_light_at 445.5 -942.875 45.0 RGB_values 205 255 230
            02E8: $CUT_SCENE_TIME = cutscenetime
        end
        if
            82E9:   NOT cutscene_reached_end
        then
            043C: set_music_does_fade 1
            0169: set_fade_color 0 0 0
            016A: fade 0 (in)  500 ms
            00BE: text_clear_all
        end
        while fading
            wait 0 ms
            gosub @DO_BRIDGE_PARTICLES
        end
        while 82E9:   NOT cutscene_reached_end
            wait 0 ms
            gosub @DO_BRIDGE_PARTICLES
        end
    end
end //debug skip
043C: set_music_does_fade 1
0374: set_motion_blur 0
041D: set_camera_near_clip 0.875
0355: clean_up_chase_scene
02EA: clear_cutscene
00BE: text_clear_all
03EB: clear_small_prints
0169: set_fade_color 0 0 0
016A: fade 0 (in)  0 ms
03AD: set_rubbish 1 (visible)
03B7: process_cut_scene_only 1 (false)
03AF: set_streaming 1 (enabled)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
01B4: set_player $PLAYER can_move 1 (unfrozen)
0336: set_player $PLAYER visible 1
0055: set_player_coordinates $PLAYER at 476.875 -939.938 41.75
0171: set_player $PLAYER z_angle_to 180.0
01F5: $SCRIPT_CONTROLLED_PLAYER = get_player_char $PLAYER
if
    8118:   NOT   actor $SCRIPT_CONTROLLED_PLAYER dead
then
    if
        82BD:   NOT   debug_mode == DEBUG_MASTERDEBUG
    then
        0352: set_actor $SCRIPT_CONTROLLED_PLAYER skin_to 'PLAYERP'
    else
        0352: set_actor $SCRIPT_CONTROLLED_PLAYER skin_to 'PLAYER'
    end
end
while 8248:   NOT   model #NULL available
    wait 0 ms
    gosub @DO_BRIDGE_PARTICLES
end
if
    8118:   NOT   actor $SCRIPT_CONTROLLED_PLAYER dead
then
    0353: refresh_actor $SCRIPT_CONTROLLED_PLAYER
end
0373: set_camera_directly_behind_player
0296: unload_special_actor 2
0296: unload_special_actor  3
0296: unload_special_actor  4
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CUTOBJ03
0249: mark_model_as_no_longer_needed #CUTOBJ04
0249: mark_model_as_no_longer_needed #CUTOBJ05
0249: mark_model_as_no_longer_needed #COP
//043D: unknown_set_play_intro_flag  0?
043C: set_music_does_fade 1
0421: force_rain 0
if
    82BD:   NOT   debug_mode == DEBUG_MASTERDEBUG
then
    004F: create_thread @LUIGI_MISSION1_LOOP
else
    030C: set_mission_points += 1      //awarded point for skipping GML
    0004: $FLAG_STAUNTON_OPEN = 1                 //only run when debug is on
    0004: $FLAG_SHORESIDE_VALE_OPEN = 1
    0004: $FLAG_REACHED_HIDEOUT = 1
    0004: $LUIGIS_GIRLS_COMPLETED = 1
    01B7: release_weather
    00C0: set_current_time 9 0
    0373: set_camera_directly_behind_player
    041E: set_radio_station 0 0
    0169: set_fade_color 0 0 0
    016A: fade 1 (out)  1000 ms
    while fading
        wait 0 ms
    end
    0169: set_fade_color 0 0 0
    044D: load_splash 'SPLASH1'                 // Wrong splash screen fix
    0109: player $PLAYER money += 1000000
    055E: set_player $PLAYER max_health += 150
    055F: set_player $PLAYER max_armour += 150
end
0004: $FLAG_PLAYER_ON_MISSION = 0
mission_cleanup
end_thread

:SKIP_INTRO_BUTTON
if
    0038:   $SKIP_FLAG == 0
then
    if and
        80E1:   NOT   key_pressed 0 16
        80E1:   NOT   key_pressed 0 12
    then
        0004: $SKIP_FLAG = 1
    end
end
if
    0038:   $SKIP_FLAG == 1
then
    if or
        00E1:   key_pressed 0 16
        00E1:   key_pressed 0 12
    then
        0004: $SKIP_FLAG = 2
    end
end
return

:DRAW_INTRO_TEXT
//0344: set_text_centre_size  580!
//0349: set_text_draw_style  0?
0342: set_text_centre 1
0340: set_text_draw_color 190 190 190 $TEXT_ALPHA
033F: set_text_draw_letter_width_height 0.75 1.0
0348: set_text_draw_proportional 1
//0346: set_text_draw_background_color  0?  0?  0? $TEXT_ALPHA
0345: set_text_draw_in_box 1
033E: text_draw 320.0 400.0 'PAPER1'   // *
if
    0038:   $TEXT_FADING_FLAG == 0
then
    0008: $TEXT_ALPHA += 2
    if
        0018:   $TEXT_ALPHA > 255
    then
        0004: $TEXT_ALPHA = 255
    end
else
    000C: $TEXT_ALPHA -= 3
    if
        001A:   1 > $TEXT_ALPHA
    then
        0004: $TEXT_ALPHA = 0
    end
end
return

:DO_BRIDGE_PARTICLES
if
    0019:   16@ > 6000
then
    0006: 16@ = 0
    039D: scatter_particles 10 1.0 0 0 0 6000 at 456.625 -936.875 44.3125 0.0 0.0 0.0
    039D: scatter_particles 10 1.0 0 0 0 6000 at 453.312 -938.438 44.0625 0.0 0.0 0.0
    039D: scatter_particles 10 1.0 0 0 0 6000 at 451.438 -942.375 45.75 0.0 0.0 0.0
end
return
