//-------------Mission 27-------------
// Originally: Joey mission 4 'CIPRIANI'S CHAUFFEUR'

:M27_CIPRIANISCHAUFFEUR
03A4: name_thread 'JOEY4'
054C: use_GXT_table 'JOEY4'
058E: set_restart_mission_taxi_destination 867.48 -868.85 20.77 angle 133.3
gosub @MISSION_START_JOEY4
if
    wasted_or_busted
then
    gosub @MISSION_JOEY4_FAILED
end
gosub @MISSION_CLEANUP_JOEY4
end_thread

:MISSION_START_JOEY4
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_JOEY = 1
wait 0 ms
if
    0038:   $TONIS_CAR_CREATED_BEFORE == 1
then
    00A6: destroy_car $TONIS_RIDE
end
0004: $FLAG_DISPLAYED_WANTED_MESSAGE_JM4 = 0
//0004: $FLAG_DISPLAYED_HORN_MESSAGE_JM4 = 0
0004: $TONI_ABUSE1_DONE_BEFORE = 0
0004: $OJECTIVE_TRIAD1_DONE_BEFORE = 0
0004: $OJECTIVE_TRIAD2_DONE_BEFORE = 0
0004: $TRIADS_OJECTIVE_PASSED = 0
0004: $TONIS_AUDIO_ALL_FINISHED = 0
0004: $PLAYED_TUNE_BEFORE = 0
01EB: set_car_density_to 0.0
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'JOEY'
023C: load_special_actor 3 'TONY'
02F3: load_object #CUTOBJ01 'JOEDOOR'
02F3: load_object #CUTOBJ02 'JOEYH'
02F3: load_object #CUTOBJ03 'PLAYERH'
02F3: load_object #CUTOBJ04 'TONYH'
0247: request_model #MAFIA
0247: request_model #IDAHO
0247: request_model #STALLION
0247: request_model #JOGARAGEEXT
0247: request_model #JOGARAGEINT
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #MAFIA available
        8248:   NOT   model #IDAHO available
        8248:   NOT   model #STALLION available
    jf break
    wait 0 ms
end
00A5: $TONIS_RIDE = create_car #MAFIA at 854.69 -864.25 20.0625
0004: $TONIS_CAR_CREATED_BEFORE = 1
0175: set_car $TONIS_RIDE z_angle_to -142.0
041E: set_radio_station 1 -1
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        823D:   NOT   special_actor 3 loaded
    jf break
    wait 0 ms
end
while true
    if or
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CUTOBJ03 available
        8248:   NOT   model #CUTOBJ04 available
    jf break
    wait 0 ms
end
while true
    if or
        8248:   NOT   model #JOGARAGEEXT available
        8248:   NOT   model #JOGARAGEINT available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'J4_ETH'
0244: set_cutscene_pos 855.06 -869.812 19.9375
00A5: $CUT_CAR2_LM3 = create_car #IDAHO at 847.5 -857.0 20.0625
0175: set_car $CUT_CAR2_LM3 z_angle_to 291.188
00A5: $CUT_CAR3_LM3 = create_car #STALLION at 857.88 -860.75 20.0
0175: set_car $CUT_CAR3_LM3 z_angle_to 150.0
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_JOEY = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_JOEY 'JOEY'
02E5: $CUTSCENE_TONY = create_cutscene_object #SPECIAL03
02E6: set_cutscene_anim $CUTSCENE_TONY 'TONY'
//02F4: create_cutscene_actor $JOEY_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_JOEY
//02F5: set_head_anim $JOEY_CSHEAD 'JOEY'
//02F4: create_cutscene_actor $TONY_CSHEAD _from_head #CUTOBJ04 _and_body $CUTSCENE_TONY
//02F5: set_head_anim $TONY_CSHEAD 'TONY'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ03 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
02E5: $CS_JOEDOOR = create_cutscene_object #CUTOBJ01
02E6: set_cutscene_anim $CS_JOEDOOR 'JOEDOOR'
0395: clear_area 1 at 860.0 -870.25 21.0 range 10.0
0363: toggle_model_render_at 857.1899 -867.25 20.0625 radius 6.0 object #JOEY_DOOR1 0
0363: toggle_model_render_at 857.1899 -867.25 20.0625 radius 6.0 object #JOEY_DOOR2 0
01BB: store_object $JOEY_DOOR1 position_to $JOEYDOOR1_X $JOEYDOOR1_Y $JOEYDOOR1_Z
01BB: store_object $JOEY_DOOR2 position_to $JOEYDOOR2_X $JOEYDOOR2_Y $JOEYDOOR2_Z
0009: $JOEYDOOR1_Z += 3.0
0009: $JOEYDOOR2_Z += 3.0
while true
    if or
        834E:   NOT slide_object $JOEY_DOOR1 to $JOEYDOOR1_X $JOEYDOOR1_Y $JOEYDOOR1_Z angle 0.0625 0.0625 100.0 0
        834E:   NOT slide_object $JOEY_DOOR2 to $JOEYDOOR2_X $JOEYDOOR2_Y $JOEYDOOR2_Z angle 0.0625 0.0625 100.0 0
    jf break
    wait 0 ms
    if
        0119:   car $TONIS_RIDE wrecked
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if and
        01F4:   car $TONIS_RIDE flipped
        01C1:   car $TONIS_RIDE stopped
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY4_FAILED
    end
end
016A: fade 1 (back)  1800 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   1 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM4_A' 10000 ms 1   // // Yeah I know Toni I've tuned her real sweet. She purrs you know what I mean?
while 001A:   4000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM4_B' 10000 ms 1   // // Oh! Here's the guy I was telling you about!
while 001A:   6180 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM4_C' 10000 ms 1   // // Alright Listen. This guy ain't Italian and he's no mechanic but he can get things fixed.
while 001A:   10230 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM4_D' 10000 ms 1   // // This is Pops Capo Toni Cipriani.
while 001A:   13040 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM4_E' 10000 ms 1   // // Yeah I'm Toni Cipriani
while 001A:   15110 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM4_F' 10000 ms 1   // // Take him to Momma's restaurant at St Marks alright.
while 001A:   18080 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM4_G' 10000 ms 1   // // Now listen to me I'm planning a job that needs a good driver so drop by sometime later Ok?
while 001A:   23511 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BE: text_clear_all
while 001A:   23833 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
03AD: set_rubbish 1 (visible)
00BE: text_clear_all
02EA: clear_cutscene
if
    8119:   NOT   car $TONIS_RIDE wrecked
then
    01C8: $TONI_CIPRIANI = create_actor 21 #SPECIAL03 in_car $TONIS_RIDE passenger_seat 0
    01ED: reset_actor $TONI_CIPRIANI flags
    039E: set_char_cant_be_dragged_out $TONI_CIPRIANI 1
    0526: set_char_to_stay_in_car_when_jacked $TONI_CIPRIANI 1
    035F: set_actor $TONI_CIPRIANI armour_to 100
    0369: put_player $PLAYER in_car $TONIS_RIDE
end
0363: toggle_model_render_at 857.1899 -867.25 20.0625 radius 6.0 object #JOEY_DOOR1 1
0363: toggle_model_render_at 857.1899 -867.25 20.0625 radius 6.0 object #JOEY_DOOR2 1
0395: clear_area 1 at 863.5 -871.375 21.0 range 10.0
015F: set_camera_position 865.8101 -869.312 21.0 0.0 0.0 0.0
0160: point_camera 864.88 -869.688 21.0 2
wait 0 ms
02A3: toggle_widescreen 1 (on)
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
01B4: set_player $PLAYER can_move 0 (frozen)
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CUTOBJ03
0249: mark_model_as_no_longer_needed #CUTOBJ04
0249: mark_model_as_no_longer_needed #IDAHO
0249: mark_model_as_no_longer_needed #STALLION
0249: mark_model_as_no_longer_needed #JOGARAGEEXT
0249: mark_model_as_no_longer_needed #JOGARAGEINT
00A6: destroy_car $CUT_CAR2_LM3
00A6: destroy_car $CUT_CAR3_LM3
03CF: load_wav 'J4T_1' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
00BC: print_now 'JM4_10' 5000 ms 1   // // OK Kid. Drive me to the laundry in Chinatown first I got a bit of business to take care of.
if
    8119:   NOT   car $TONIS_RIDE wrecked
then
    02C2: car $TONIS_RIDE drive_to_point 863.5 -871.375 -100.0
    00AD: set_car $TONIS_RIDE max_speed_to 2.0
    00AE: set_car $TONIS_RIDE driving_style 3  // DRIVINGMODE_PLOUGHTHROUGH
end
if
    8118:   NOT   actor $TONI_CIPRIANI dead
then
    022D: set_actor $TONI_CIPRIANI to_look_at_player $PLAYER
    022E: set_player $PLAYER to_look_at_actor $TONI_CIPRIANI
end
while 81AD:   NOT   car $TONIS_RIDE 0 near_point 863.5 -871.375 2.0 2.0
    wait 0 ms
    if
        0119:   car $TONIS_RIDE wrecked
    then
        jump @MISSION_JOEY4_FAILED
    end
    if
        0038:   $TONIS_AUDIO_ALL_FINISHED == 0
    then
        while 83D2:   NOT   wav 1 ended
            wait 0 ms
            if or
                0119:   car $TONIS_RIDE wrecked
                0118:   actor $TONI_CIPRIANI dead
            then
                00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
                jump @MISSION_JOEY4_FAILED
            end
        end
        03CF: load_wav 'J4T_2' as 1
        while 83D0:   NOT   wav 1 loaded
            wait 0 ms
            if or
                0119:   car $TONIS_RIDE wrecked
                0118:   actor $TONI_CIPRIANI dead
            then
                00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
                jump @MISSION_JOEY4_FAILED
            end
        end
        03D1: play_wav 1
        00BC: print_now 'JM4_11' 5000 ms 1   // // Those washer women aint been payin' their protection money.        //This line runs, gets stuck somewhere after
        while 83D2:   NOT   wav 1 ended
            wait 0 ms
            if or
                0119:   car $TONIS_RIDE wrecked
                0118:   actor $TONI_CIPRIANI dead
            then
                00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
                jump @MISSION_JOEY4_FAILED
            end
        end
            03CF: load_wav 'J4T_3' as 1
            0004: $TONIS_AUDIO_ALL_FINISHED = 1
    end
end
00BE: text_clear_all
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if or
        0119:   car $TONIS_RIDE wrecked
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
end
03D1: play_wav 1
00BC: print_now 'JM4_12' 5000 ms 1   // // And watch the car Joey just fixed this junk heap.
01BB: store_object $JOEY_DOOR1 position_to $JOEYDOOR1_X $JOEYDOOR1_Y $JOEYDOOR1_Z
01BB: store_object $JOEY_DOOR2 position_to $JOEYDOOR2_X $JOEYDOOR2_Y $JOEYDOOR2_Z
000D: $JOEYDOOR1_Z -= 3.0
000D: $JOEYDOOR2_Z -= 3.0
while true
    if or
        834E:   NOT slide_object $JOEY_DOOR1 to $JOEYDOOR1_X $JOEYDOOR1_Y $JOEYDOOR1_Z angle 0.0625 0.0625 0.0625 0
        834E:   NOT slide_object $JOEY_DOOR2 to $JOEYDOOR2_X $JOEYDOOR2_Y $JOEYDOOR2_Z angle 0.0625 0.0625 0.0625 0
    jf break
    wait 0 ms
    if or
        0119:   car $TONIS_RIDE wrecked
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if and
        01F4:   car $TONIS_RIDE flipped
        01C1:   car $TONIS_RIDE stopped
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY4_FAILED
    end
end
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if or
        0119:   car $TONIS_RIDE wrecked
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
end
03CF: load_wav 'J4T_4' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if or
        0119:   car $TONIS_RIDE wrecked
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
end
03D1: play_wav 1
00BC: print_now 'JM4_13' 5000 ms 1   // // So no fancy crap OK?
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if or
        0119:   car $TONIS_RIDE wrecked
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
end
if
    8118:   NOT   actor $TONI_CIPRIANI dead
then
    022F: set_actor $TONI_CIPRIANI stop_looking
    0230: set_player $PLAYER stop_looking
end
00BE: text_clear_all
02A3: toggle_widescreen 0 (off)
01B4: set_player $PLAYER can_move 1 (unfrozen)
03A2: set_car_status $TONIS_RIDE 0
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
015A: restore_camera
01EB: set_car_density_to 1.0
014C: set_parked_car_generator $GEN_CAR12 cars_to_generate_to 0
0247: request_model #GANG03
0247: request_model #GANG04
0247: request_model #BAT
0247: request_model #COLT45
03CF: load_wav 'J4_A' as 1
while true
if or
        8248:   NOT   model #GANG03 available
        8248:   NOT   model #GANG04 available
        8248:   NOT   model #BAT available
        8248:   NOT   model #COLT45 available
        83D0:   NOT   wav 1 loaded
    jf break
    wait 0 ms
end
022B: switch_ped_roads_off 489.875 -633.75 19.0 510.25 -693.75 24.0
01E8: switch_roads_off 489.875 -633.75 19.0 510.25 -693.75 24.0
0395: clear_area 1 at 508.375 -663.75 21.0 range 10.0
018A: $BLIP1_JM4 = create_checkpoint_at 508.0 -660.0 -100.0
018B: change_blip $BLIP1_JM4 display 2
009A: $JOEY4_TRIAD1 = create_actor 8 #GANG03 at 515.0 -663.0 20.6875
01ED: reset_actor $JOEY4_TRIAD1 flags
02AB: set_actor $JOEY4_TRIAD1 immunities 1 1 1 1 1
009A: $JOEY4_TRIAD2 = create_actor 8 #GANG04 at 515.0 -664.688 20.6875
01ED: reset_actor $JOEY4_TRIAD2 flags
02AB: set_actor $JOEY4_TRIAD2 immunities 1 1 1 1 1
020E: actor $JOEY4_TRIAD1 look_at_actor $JOEY4_TRIAD2
020E: actor $JOEY4_TRIAD2 look_at_actor $JOEY4_TRIAD1
0164: remove_blip $BLIP1_JM4
0004: $FLAG_CAR_BLIP_DISPLAYED_JM4 = 1
0004: $BLOB_FLAG = 1
if
    0119:   car $TONIS_RIDE wrecked
then
    00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
    jump @MISSION_JOEY4_FAILED
end
while true
    if or
        81A0:   NOT   player $PLAYER stopped $BLOB_FLAG in_cube_in_car 504.188 -667.375 20.0 507.062 -673.875 23.0  // never used in VC
        010F:   player $PLAYER wanted_level > 0
        80DC:   NOT   player $PLAYER driving $TONIS_RIDE
    jf break
    wait 0 ms
    if
        0119:   car $TONIS_RIDE wrecked
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if and
        01F4:   car $TONIS_RIDE flipped
        01C1:   car $TONIS_RIDE stopped
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY4_FAILED
    end
    if
        80DC:   NOT   player $PLAYER driving $TONIS_RIDE
    then
        if
            0038:   $FLAG_CAR_BLIP_DISPLAYED_JM4 == 0
        then
            0186: $BLIP2_JM4 = create_marker_above_car $TONIS_RIDE
            0004: $BLOB_FLAG = 0
            0164: remove_blip $BLIP1_JM4
            00BC: print_now 'IN_VEH' 5000 ms 1   // // ~g~Hey! Get back in the vehicle!
            0004: $FLAG_CAR_BLIP_DISPLAYED_JM4 = 1
        end
    end
    if
        00DC:   player $PLAYER driving $TONIS_RIDE
    then
        if
            0038:   $FLAG_CAR_BLIP_DISPLAYED_JM4 == 1
        then
            018A: $BLIP1_JM4 = create_checkpoint_at 508.0 -660.0 -100.0
            0004: $BLOB_FLAG = 1
            0164: remove_blip $BLIP2_JM4
            0004: $FLAG_CAR_BLIP_DISPLAYED_JM4 = 0
        end
    end
    if and
        8185:   NOT   car $TONIS_RIDE health >= 900
        0038:   $TONI_ABUSE1_DONE_BEFORE == 0
    then
        00BC: print_now 'JM4_6' 5000 ms 1   // // Hey watch the car! I said no fancy crap.
        03D1: play_wav 1
        0004: $TONI_ABUSE1_DONE_BEFORE = 1
    end
    if
        01A0:   player $PLAYER stopped 0 in_cube_in_car 504.188 -667.375 20.0 507.062 -673.875 23.0  // never used in VC
    then
        if
            010F:   player $PLAYER wanted_level > 0
        then
            if
                0038:   $FLAG_DISPLAYED_WANTED_MESSAGE_JM4 == 0
            then
                00BC: print_now 'WANTED1' 3000 ms 1   // // ~g~Shake the cops and lose your wanted level!
                0004: $FLAG_DISPLAYED_WANTED_MESSAGE_JM4 = 1
            end
        end
    else
        if
            8057:   NOT   player $PLAYER 0 in_cube 504.188 -667.375 20.0 507.062 -673.875 23.0
        then
            0004: $FLAG_DISPLAYED_WANTED_MESSAGE_JM4 = 0
        end
    end
end
0164: remove_blip $BLIP1_JM4
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
01B4: set_player $PLAYER can_move 0 (frozen)
02A3: toggle_widescreen 1 (on)
015F: set_camera_position 490.562 -680.562 22.5625 0.0 0.0 0.0
0160: point_camera 491.312 -679.875 22.5 2
03CF: load_wav 'J4_B' as 1

//TONI LANDRETTE CUT_SCENE
if and
    8118:   NOT   actor $JOEY4_TRIAD1 dead
    8118:   NOT   actor $JOEY4_TRIAD2 dead
then
    03F9: make_actors $JOEY4_TRIAD1 $JOEY4_TRIAD2 converse_in 999999 ms
end
if
    8118:   NOT   actor $TONI_CIPRIANI dead
then
    02AB: set_actor $TONI_CIPRIANI immunities 1 1 1 1 1
end
gosub @AUDIO1_PLAY
00BC: print_now 'JM4_2' 5000 ms 1   // // Wait here! Keep the engine running. This ain't a social call.
0395: clear_area 1 at 508.375 -663.75 21.0 range 10.0
wait 4000 ms
if or
    0119:   car $TONIS_RIDE wrecked
    0118:   actor $TONI_CIPRIANI dead
then
    00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
    jump @MISSION_JOEY4_FAILED
end
01B2: give_actor $TONI_CIPRIANI weapon 6 ammo 0  // Load the weapon model before using this
01D3: actor $TONI_CIPRIANI leave_car $TONIS_RIDE
while 00DB:   actor $TONI_CIPRIANI in_car $TONIS_RIDE
    wait 0 ms
    if
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0119:   car $TONIS_RIDE wrecked
    then
        jump @MISSION_JOEY4_FAILED
    end
    if and
        01F4:   car $TONIS_RIDE flipped
        01C1:   car $TONIS_RIDE stopped
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY4_FAILED
    end
end
015F: set_camera_position 506.25 -669.062 22.5 0.0 0.0 0.0
0160: point_camera 507.062 -668.5 22.3125 2
if or
    0119:   car $TONIS_RIDE wrecked
    0118:   actor $TONI_CIPRIANI dead
then
    00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
    jump @MISSION_JOEY4_FAILED
end
01BE: set_actor $TONI_CIPRIANI to_look_at_spot 508.875 -663.688 21.0625
0006: 17@ = 0
0211: actor $TONI_CIPRIANI walk_to 508.875 -663.688
while 8126:   NOT   actor $TONI_CIPRIANI walking
    wait 0 ms
    if
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0119:   car $TONIS_RIDE wrecked
    then
        jump @MISSION_JOEY4_FAILED
    end
    if and
        01F4:   car $TONIS_RIDE flipped
        01C1:   car $TONIS_RIDE stopped
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0019:   17@ > 10000
    then
        if
            8118:   NOT   actor $TONI_CIPRIANI dead
        then
            00A1: put_actor $TONI_CIPRIANI at 508.875 -663.688 19.875
        end
    end
end
//OPEN DOORS
while true
    if or
        834D:   NOT unknown_rotate_object $LAUNDRETE_DOOR1 angle 90.0 10.0 0
        834D:   NOT unknown_rotate_object $LAUNDRETE_DOOR2 angle 90.0 10.0 0
    jf break
    wait 0 ms
    if
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0119:   car $TONIS_RIDE wrecked
    then
        jump @MISSION_JOEY4_FAILED
    end
    if and
        01F4:   car $TONIS_RIDE flipped
        01C1:   car $TONIS_RIDE stopped
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY4_FAILED
    end
end
if or
    0119:   car $TONIS_RIDE wrecked
    0118:   actor $TONI_CIPRIANI dead
then
    00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
    jump @MISSION_JOEY4_FAILED
end
0006: 17@ = 0
0211: actor $TONI_CIPRIANI walk_to 513.062 -663.375
while 8126:   NOT   actor $TONI_CIPRIANI walking
    wait 0 ms
    if
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0119:   car $TONIS_RIDE wrecked
    then
        jump @MISSION_JOEY4_FAILED
    end
    if and
        01F4:   car $TONIS_RIDE flipped
        01C1:   car $TONIS_RIDE stopped
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0019:   17@ > 10000
    then
        if
            8118:   NOT   actor $TONI_CIPRIANI dead
        then
            00A1: put_actor $TONI_CIPRIANI at 513.062 -663.375 19.875
        end
    end
end
0192: set_actor $TONI_CIPRIANI objective_to_stand_still
if and
    8118:   NOT   actor $JOEY4_TRIAD1 dead
    8118:   NOT   actor $JOEY4_TRIAD2 dead
then
    03F9: make_actors $JOEY4_TRIAD1 $JOEY4_TRIAD2 converse_in 0 ms
end
wait 0 ms
if and
    8118:   NOT   actor $JOEY4_TRIAD1 dead
    8118:   NOT   actor $JOEY4_TRIAD2 dead
    8118:   NOT   actor $TONI_CIPRIANI dead
then
    020E: actor $JOEY4_TRIAD1 look_at_actor $TONI_CIPRIANI
    020E: actor $JOEY4_TRIAD2 look_at_actor $TONI_CIPRIANI
    022C: set_actor $JOEY4_TRIAD1 to_look_at_actor $TONI_CIPRIANI
    022C: set_actor $JOEY4_TRIAD2 to_look_at_actor $TONI_CIPRIANI
end
wait 5000 ms
018C: play_sound 0 at 510.0 -663.0 20.0
0176: $DOOR1_POSITION_JM4 = object $LAUNDRETE_DOOR1 z_angle
0176: $DOOR2_POSITION_JM4 = object $LAUNDRETE_DOOR2 z_angle
if
    0118:   actor $TONI_CIPRIANI dead
then
    00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
    jump @MISSION_JOEY4_FAILED
end
01BE: set_actor $TONI_CIPRIANI to_look_at_spot 508.875 -663.688 21.0625
if or
    8118:   NOT   actor $JOEY4_TRIAD1 dead
    8118:   NOT   actor $JOEY4_TRIAD2 dead
then
    01B2: give_actor $JOEY4_TRIAD1 weapon 17 ammo 100  // Load the weapon model before using this
    01B2: give_actor $JOEY4_TRIAD2 weapon 17 ammo 100  // Load the weapon model before using this
end
0319: set_actor $TONI_CIPRIANI running 1
if or
    8118:   NOT   actor $JOEY4_TRIAD1 dead
    8118:   NOT   actor $JOEY4_TRIAD2 dead
then
    0350: set_char_stay_in_same_place $JOEY4_TRIAD1  1
    0350: set_char_stay_in_same_place $JOEY4_TRIAD2  1
    01C9: actor $JOEY4_TRIAD1 kill_actor $TONI_CIPRIANI
    01C9: actor $JOEY4_TRIAD2 kill_actor $TONI_CIPRIANI
end
//TONI RUNS OUT
0395: clear_area 1 at 508.375 -663.75 21.0 range 10.0
0006: 17@ = 0
if and
    8118:   NOT   actor $JOEY4_TRIAD1 dead
    8118:   NOT   actor $JOEY4_TRIAD2 dead
then
    022F: set_actor $JOEY4_TRIAD1 stop_looking
    022F: set_actor $JOEY4_TRIAD2 stop_looking
end
0239: actor $TONI_CIPRIANI run_to 508.875 -663.688
while 8126:   NOT   actor $TONI_CIPRIANI walking
    wait 0 ms
    if
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0119:   car $TONIS_RIDE wrecked
    then
        jump @MISSION_JOEY4_FAILED
    end
    if and
        01F4:   car $TONIS_RIDE flipped
        01C1:   car $TONIS_RIDE stopped
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0019:   17@ > 10000
    then
        if
            8118:   NOT   actor $TONI_CIPRIANI dead
        then
            00A1: put_actor $TONI_CIPRIANI at 508.875 -663.688 19.875
        end
    end
end
01D4: actor $TONI_CIPRIANI go_to_car $TONIS_RIDE and_enter_it_as_a_passenger
015F: set_camera_position 501.0 -677.812 21.8125 0.0 0.0 0.0
0160: point_camera 501.688 -677.125 21.625 2
wait 1500 ms
if and
    8118:   NOT   actor $JOEY4_TRIAD1 dead
    8118:   NOT   actor $JOEY4_TRIAD2 dead
then
    0350: set_char_stay_in_same_place $JOEY4_TRIAD1  0
    0350: set_char_stay_in_same_place $JOEY4_TRIAD2  0
    0239: actor $JOEY4_TRIAD1 run_to 507.0 -663.75
    0239: actor $JOEY4_TRIAD2 run_to 508.5 -663.75
end
//TRIADS RUN OUT
while 8038:   NOT   $TRIADS_OJECTIVE_PASSED == 2
    wait 0 ms
    if
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0119:   car $TONIS_RIDE wrecked
    then
        jump @MISSION_JOEY4_FAILED
    end
    if and
        0118:   actor $JOEY4_TRIAD1 dead
        0038:   $OJECTIVE_TRIAD1_DONE_BEFORE == 0
    then
        0008: $TRIADS_OJECTIVE_PASSED += 1
        0004: $OJECTIVE_TRIAD1_DONE_BEFORE = 1
    end
    if and
        0118:   actor $JOEY4_TRIAD2 dead
        0038:   $OJECTIVE_TRIAD2_DONE_BEFORE == 0
    then
        0008: $TRIADS_OJECTIVE_PASSED += 1
        0004: $OJECTIVE_TRIAD2_DONE_BEFORE = 1
    end
    if and
        0126:   actor $JOEY4_TRIAD1 walking
        0038:   $OJECTIVE_TRIAD1_DONE_BEFORE == 0
    then
        01D9: actor $JOEY4_TRIAD1 destroy_car $TONIS_RIDE
        0008: $TRIADS_OJECTIVE_PASSED += 1
        0004: $OJECTIVE_TRIAD1_DONE_BEFORE = 1
    end
    if and
        0126:   actor $JOEY4_TRIAD2 walking
        0038:   $OJECTIVE_TRIAD2_DONE_BEFORE == 0
    then
        01D9: actor $JOEY4_TRIAD2 destroy_car $TONIS_RIDE
        0008: $TRIADS_OJECTIVE_PASSED += 1
        0004: $OJECTIVE_TRIAD2_DONE_BEFORE = 1
    end
end
while 80DB:   NOT   actor $TONI_CIPRIANI in_car $TONIS_RIDE
    wait 0 ms
    if
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0119:   car $TONIS_RIDE wrecked
    then
        jump @MISSION_JOEY4_FAILED
    end
    if and
        01F4:   car $TONIS_RIDE flipped
        01C1:   car $TONIS_RIDE stopped
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY4_FAILED
    end
end
009A: $TRIAD3_JM4 = create_actor 8 #GANG03 at 508.062 -689.0 19.875
01B2: give_actor $TRIAD3_JM4 weapon 17 ammo 100  // Load the weapon model before using this
01CA: actor $TRIAD3_JM4 kill_player $PLAYER
011A: set_actor $TRIAD3_JM4 flags 1
009A: $TRIAD4_JM4 = create_actor 8 #GANG04 at 509.25 -634.75 19.875
01B2: give_actor $TRIAD4_JM4 weapon 17 ammo 100  // Load the weapon model before using this
01CA: actor $TRIAD4_JM4 kill_player $PLAYER
011A: set_actor $TRIAD4_JM4 flags 1
if
    8118:   NOT   actor $TONI_CIPRIANI dead
then
    02AB: set_actor $TONI_CIPRIANI immunities 0 0 0 0 0
end
if and
    8118:   NOT   actor $JOEY4_TRIAD1 dead
    8118:   NOT   actor $JOEY4_TRIAD2 dead
then
    02AB: set_actor $JOEY4_TRIAD1 immunities 0 0 0 0 0
    02AB: set_actor $JOEY4_TRIAD2 immunities 0 0 0 0 0
end
01B4: set_player $PLAYER can_move 1 (unfrozen)
02A3: toggle_widescreen 0 (off)
015A: restore_camera
03CF: load_wav 'J4_C' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
00BC: print_now 'JM4_3' 4000 ms 1   // // It's a Triad ambush! Get us out of here kid!
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
018A: $BLIP3_JM4 = create_checkpoint_at 881.75 -327.562 -100.0
018B: change_blip $BLIP3_JM4 display 2

while true
    if or
        834D:   NOT unknown_rotate_object $LAUNDRETE_DOOR1 angle 0.0 10.0 0
        834D:   NOT unknown_rotate_object $LAUNDRETE_DOOR2 angle 180.0 10.0 0
    jf break
    wait 0 ms
    if
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0119:   car $TONIS_RIDE wrecked
    then
        jump @MISSION_JOEY4_FAILED
    end
    if and
        01F4:   car $TONIS_RIDE flipped
        01C1:   car $TONIS_RIDE stopped
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY4_FAILED
    end
end
0004: $IS_CHAR1_DEAD_JM4 = 0
0004: $IS_CHAR2_DEAD_JM4 = 0
0004: $IS_CHAR3_DEAD_JM4 = 0
0004: $IS_CHAR4_DEAD_JM4 = 0
0004: $FLAG_CAR_BLIP_DISPLAYED_JM4 = 1
0164: remove_blip $BLIP3_JM4
if
    8118:   NOT   actor $JOEY4_TRIAD1 dead
then
    011A: set_actor $JOEY4_TRIAD1 flags 1
end
if
    8118:   NOT   actor $JOEY4_TRIAD2 dead
then
    011A: set_actor $JOEY4_TRIAD2 flags 1
end
0395: clear_area 1 at 881.6899 -328.062 32.0 range 6.0
0004: $FLAG_DISPLAYED_WANTED_MESSAGE_JM4 = 0
0004: $BLOB_FLAG = 1

while true
    if or
        81A0:   NOT   player $PLAYER stopped $BLOB_FLAG in_cube_in_car 880.0 -326.875 31.0 885.1899 -330.5 33.0  // never used in VC
        010F:   player $PLAYER wanted_level > 0
        80DC:   NOT   player $PLAYER driving $TONIS_RIDE
    jf break
    wait 0 ms
    if
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0119:   car $TONIS_RIDE wrecked
    then
        jump @MISSION_JOEY4_FAILED
    end
    if
        80DC:   NOT   player $PLAYER driving $TONIS_RIDE
    then
        if
            0038:   $FLAG_CAR_BLIP_DISPLAYED_JM4 == 0
        then
            0186: $BLIP2_JM4 = create_marker_above_car $TONIS_RIDE
            0164: remove_blip $BLIP3_JM4
            00BC: print_now 'IN_VEH' 5000 ms 1   // // ~g~Hey! Get back in the vehicle!
            0004: $BLOB_FLAG = 0
            0004: $FLAG_CAR_BLIP_DISPLAYED_JM4 = 1
        end
    end
    if
        00DC:   player $PLAYER driving $TONIS_RIDE
    then
        if
            0038:   $FLAG_CAR_BLIP_DISPLAYED_JM4 == 1
        then
            018A: $BLIP3_JM4 = create_checkpoint_at 881.75 -327.562 31.9
            0164: remove_blip $BLIP2_JM4
            0004: $BLOB_FLAG = 1
            0004: $FLAG_CAR_BLIP_DISPLAYED_JM4 = 0
        end
    end
    if and
        01F4:   car $TONIS_RIDE flipped
        01C1:   car $TONIS_RIDE stopped
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY4_FAILED
    end
    if and
        0118:   actor $JOEY4_TRIAD1 dead
        0038:   $IS_CHAR1_DEAD_JM4 == 0
    then
        0004: $IS_CHAR1_DEAD_JM4 = 1
    end
    if and
        0118:   actor $JOEY4_TRIAD2 dead
        0038:   $IS_CHAR2_DEAD_JM4 == 0
    then
        0004: $IS_CHAR2_DEAD_JM4 = 1
    end
    if and
        0118:   actor $TRIAD3_JM4 dead
        0038:   $IS_CHAR3_DEAD_JM4 == 0
    then
        0004: $IS_CHAR3_DEAD_JM4 = 1
    end
    if and
        0118:   actor $TRIAD4_JM4 dead
        0038:   $IS_CHAR4_DEAD_JM4 == 0
    then
        0004: $IS_CHAR4_DEAD_JM4 = 1
    end
    if and
        0038:   $IS_CHAR1_DEAD_JM4 == 1
        0038:   $IS_CHAR2_DEAD_JM4 == 1
        0038:   $IS_CHAR3_DEAD_JM4 == 1
        0038:   $IS_CHAR4_DEAD_JM4 == 1
        0038:   $PLAYED_TUNE_BEFORE == 0
    then
        0109: player $PLAYER money += 2000
        0054: store_player $PLAYER position_to $PLAYER_X $PLAYER_Y $PLAYER_Z
        018C: play_sound 1 at $PLAYER_X $PLAYER_Y $PLAYER_Z
        0004: $PLAYED_TUNE_BEFORE = 1
    end
    if
        01A0:   player $PLAYER stopped 0 in_cube_in_car 880.0 -326.875 31.0 885.1899 -330.5 33.0  // never used in VC
    then
        if
            010F:   player $PLAYER wanted_level > 0
        then
            if
                0038:   $FLAG_DISPLAYED_WANTED_MESSAGE_JM4 == 0
            then
                00BC: print_now 'WANTED1' 3000 ms 1   // // ~g~Shake the cops and lose your wanted level!
                0004: $FLAG_DISPLAYED_WANTED_MESSAGE_JM4 = 1
            end
        end
    else
        if
           8057:   NOT   player $PLAYER 0 in_cube 880.0 -326.875 31.0 885.1899 -330.5 33.0
        then
            0004: $FLAG_DISPLAYED_WANTED_MESSAGE_JM4 = 0
        end
    end
end //while
0164: remove_blip $BLIP3_JM4

0395: clear_area 1 at 881.5 -326.75 32.0 range 6.0
0395: clear_area 1 at 884.5601 -319.188 33.6875 range 2.0
01B4: set_player $PLAYER can_move 0 (frozen)
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
02A3: toggle_widescreen 1 (on)
015F: set_camera_position 889.0601 -333.375 32.5 0.0 0.0 0.0
0160: point_camera 888.38 -332.688 32.5625 2
if
    8118:   NOT   actor $TONI_CIPRIANI dead
then
    01B9: set_actor $TONI_CIPRIANI armed_weapon_to 0
    022D: set_actor $TONI_CIPRIANI to_look_at_player $PLAYER
    022E: set_player $PLAYER to_look_at_actor $TONI_CIPRIANI
end
0164: remove_blip $BLIP2_JM4
03CF: load_wav 'J4_D' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
00BC: print_now 'JM4_4' 4000 ms 1   // // The Triads think they can mess with me the triads with ME!
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if or
        0119:   car $TONIS_RIDE wrecked
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
end
03CF: load_wav 'J4_E' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
00BC: print_now 'JM4_5' 5000 ms 1   // // Drop by later and we'll give them something to launder their own blood stained clothes!
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if or
        0119:   car $TONIS_RIDE wrecked
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
end
03CF: load_wav 'J4_F' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if or
        0119:   car $TONIS_RIDE wrecked
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
end
if or
    0119:   car $TONIS_RIDE wrecked
    0118:   actor $TONI_CIPRIANI dead
then
    00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
    jump @MISSION_JOEY4_FAILED
end
if
    8118:   NOT   actor $TONI_CIPRIANI dead
then
    0319: set_actor $TONI_CIPRIANI running 0
    01D3: actor $TONI_CIPRIANI leave_car $TONIS_RIDE
    022F: set_actor $TONI_CIPRIANI stop_looking
    0230: set_player $PLAYER stop_looking
end
while 00DB:   actor $TONI_CIPRIANI in_car $TONIS_RIDE
    wait 0 ms
    if or
        0119:   car $TONIS_RIDE wrecked
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if and
        01F4:   car $TONIS_RIDE flipped
        01C1:   car $TONIS_RIDE stopped
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY4_FAILED
    end
end
if
    0118:   actor $TONI_CIPRIANI dead
then
    00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
    jump @MISSION_JOEY4_FAILED
end
0006: 17@ = 0
0395: clear_area 1 at 884.38 -324.375 32.0625 range 2.0
0211: actor $TONI_CIPRIANI walk_to 884.38 -324.375
while 8126:   NOT   actor $TONI_CIPRIANI walking
    wait 0 ms
    if
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0019:   17@ > 10000
    then
        if
            8118:   NOT   actor $TONI_CIPRIANI dead
        then
            00A1: put_actor $TONI_CIPRIANI at 884.38 -324.375 -100.0
        end
    end
end
if
    0118:   actor $TONI_CIPRIANI dead
then
    00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
    jump @MISSION_JOEY4_FAILED
end
0006: 17@ = 0
0395: clear_area 1 at 884.5 -315.375 35.875 range 2.0
0211: actor $TONI_CIPRIANI walk_to 884.5 -318.6

while 8126:   NOT   actor $TONI_CIPRIANI walking
    wait 0 ms
    if
        0118:   actor $TONI_CIPRIANI dead
    then
        00BC: print_now 'JM4_8' 5000 ms 1   // // ~r~Toni's been wasted!
        jump @MISSION_JOEY4_FAILED
    end
    if
        0019:   17@ > 10000
    then
        if
            8118:   NOT   actor $TONI_CIPRIANI dead
        then
            00A1: put_actor $TONI_CIPRIANI at 884.5 -318.562 34.375
        end
    end
end
02A3: toggle_widescreen 0 (off)
01B4: set_player $PLAYER can_move 1 (unfrozen)
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
02EB: restore_camera_jumpcut
009B: destroy_actor_instantly $TONI_CIPRIANI
jump @MISSION_JOEY4_PASSED

:MISSION_JOEY4_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // // MISSION FAILED!
return

:MISSION_JOEY4_PASSED
0394: play_music 1
01E3: text_1number_styled 'M_PASS' 3000 5000 ms 1   // // MISSION PASSED! $~1~
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 3000
0004: $CIPRIANIS_CHAUFFEUR_COMPLETED = 1
0318: set_latest_mission_passed 'JM4'   // // 'CIPRIANI'S CHAUFFEUR'
030C: set_mission_points += 1
0215: destroy_pickup $SHOP_UZI
0213: $SHOP_UZI2 = create_pickup #UZI type 1 at 735.5 -400.75 21.1875
004F: create_thread @JOEY_MISSION5_LOOP
004F: create_thread @UZI_MESSAGE
// if started with DEBUG_MASTERDEBUG on, these are already running
0164: remove_blip $TONI_MISSION_MARKER
02A7: $TONI_MISSION_MARKER = create_icon_marker_and_sphere 22 at 884.5601 -321.0 32.375
0459: end_thread_named 'TM1'
004F: create_thread @TONI_MISSION1_LOOP
return

:MISSION_CLEANUP_JOEY4
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_JOEY = 0
0164: remove_blip $BLIP1_JM4
0164: remove_blip $BLIP2_JM4
0164: remove_blip $BLIP3_JM4
0249: mark_model_as_no_longer_needed #MAFIA
0249: mark_model_as_no_longer_needed #GANG03
0249: mark_model_as_no_longer_needed #GANG04
040D: unload_wav 1
022A: switch_ped_roads_on 489.875 -633.75 19.0 510.25 -693.75 24.0
01E7: switch_roads_on 489.875 -633.75 19.0 510.25 -693.75 24.0
0296: unload_special_actor 3
014C: set_parked_car_generator $GEN_CAR12 cars_to_generate_to 101
034F: remove_char_elegantly $TONI_CIPRIANI
mission_cleanup
return
