//-------------Mission 57-------------
// Originally: Ray mission 4 'GONE FISHING'

:M57_GONEFISHING
03A4: name_thread 'RAY4'
054C: use_GXT_table 'RAY4'
058E: set_restart_mission_taxi_destination -221.6 -696.3 31.66 180.0
gosub @MISSION_START_RAY4
if
    wasted_or_busted
then
    gosub @MISSION_RAY4_FAILED
end
gosub @MISSION_CLEANUP_RAY4
end_thread

:MISSION_START_RAY4
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_RAY = 1
0004: $RAYS_CUTSCENE_FLAG = 1
0317: increment_mission_attempts
wait 0 ms
0004: $MINE_CURRENT_TIMER = 0
0004: $LAST_MINE_DROPPED_TIMER = 0
0004: $TEMPORARY_TIME_MINE = 0
0004: $RANDOM_INT = 0
0004: $BOAT_SPEED_FLAG = 0
0004: $BOAT_NODE_COUNTER = 2
0004: $PARTNERS_CAR_IS_DEAD = 0
0004: $SHOOT_AT_PLAYER_FLAG = 0
0004: $GOTAWAY_TIMER_RESET_FLAG = 0
0004: $PARTNER_ON_FOOT_COUNTER = 0
0004: $PARTNER_ON_FOOT_FLAG = 0
0004: $GOTO_MISSION_RAY4_FAILED = 0
0004: $TIMER_RESET_FLAG_R4 = 0
0004: $TIMERC_R4 = 0
0004: $TIMERC_CURRENT_R4 = 0
0004: $TIMERC_STARTED_R4 = 0
0004: $TIMERC_RESET_FLAG_R4 = 0
0004: $EXIT_BOAT_FLAG = 0

0005: $PARTNER_STUCK_X = 0.0
0005: $PARTNER_STUCK_Y = 0.0
0005: $PARTNER_STUCK_Z = 0.0

0005: $NODE_0_X = 1070.4399
0005: $NODE_0_Y = -598.688

0005: $NODE_1_X = 1375.0601
0005: $NODE_1_Y = -371.688

0005: $NODE_2_X = 1378.12
0005: $NODE_2_Y = -498.375

0005: $NODE_3_X = 1297.25
0005: $NODE_3_Y = -601.5

0005: $NODE_4_X = 1284.8101
0005: $NODE_4_Y = -764.938

0005: $NODE_5_X = 1318.25
0005: $NODE_5_Y = -822.375

0005: $NODE_6_X = 1346.75
0005: $NODE_6_Y = -775.25

0005: $NODE_7_X = 1347.88
0005: $NODE_7_Y = -590.438

0005: $NODE_8_X = 1242.6899
0005: $NODE_8_Y = -498.938

0005: $NODE_9_X = 1241.3101
0005: $NODE_9_Y = -361.688

0005: $NODE_10_X = 1233.38
0005: $NODE_10_Y = -249.0

0005: $NODE_11_X = 1293.12
0005: $NODE_11_Y = -195.562
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'RAY'
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'RAYH'
02F3: load_object #CUTOBJ03 'BOGDOOR'
0247: request_model #TOILET
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CUTOBJ03 available
        8248:   NOT   model #TOILET available
    jf break
    wait 0 ms
end
0395: clear_area 1 at -296.0 -723.5 28.0 range 1.0
0055: set_player_coordinates $PLAYER at -296.0 -723.5 28.0
0171: set_player $PLAYER z_angle_to 90.0
0363: toggle_model_render_at -287.6875 -732.0 28.8125 radius 4.0 object #TOILET_CUBICLE_DR2 0
02E4: load_cutscene_data 'R4_GF'
0244: set_cutscene_pos -295.625 -726.625 27.6875
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_RAY = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_RAY 'RAY'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
//02F4: create_cutscene_actor $RAY_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_RAY
//02F5: set_head_anim $RAY_CSHEAD 'RAY'
02E5: $CS_LUDOOR = create_cutscene_object #CUTOBJ03
02E6: set_cutscene_anim $CS_LUDOOR 'BOGDOOR'
03AD: set_rubbish 0 (invisible)
016A: fade 1 (back)  1500 ms
03AF: set_streaming 1 (enabled)
041D: set_camera_near_clip 0.1875
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   4285 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM4_A' 4000 ms 1   // // I think my partner's a rat.
while 001A:   6389 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM4_B' 4000 ms 1   // // We gotta shut him up permanently.
while 001A:   8524 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM4_C' 4000 ms 1   // // He goes fishing out of his boat near the lighthouse on Portland Rock most nights.
while 001A:   13026 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM4_D' 4000 ms 1   // // Steal a police boat and make sure his back stabbing plans are sunk!
while 001A:   17497 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM4_E' 4000 ms 1   // // I want him sleeping with the fishes not eating them.
while 001A:   21000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
03AF: set_streaming 1 (enabled)
03AD: set_rubbish 1 (visible)
00BE: text_clear_all
while NOT fading
    wait 0 ms
end
02EA: clear_cutscene
016A: fade 0  0 ms
041D: set_camera_near_clip 0.875
01B6: set_weather 0
0373: set_camera_directly_behind_player
wait 500 ms
0004: $RAYS_CUTSCENE_FLAG = 0
016A: fade 1 (back)  1500 ms
0363: toggle_model_render_at -287.6875 -732.0 28.8125 radius 4.0 object #TOILET_CUBICLE_DR2 1
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #TOILET
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CUTOBJ03
0247: request_model #PREDATOR
0247: request_model #GHOST
0247: request_model #SENTINEL
0247: request_model #RCBANDIT
0247: request_model #GRENADE
while true
    if or
        8248:   NOT  model #PREDATOR available
        8248:   NOT  model #GHOST available
        8248:   NOT  model #SENTINEL available
        8248:   NOT  model #RCBANDIT available
        8248:   NOT  model #GRENADE available
    jf break
    wait 0 ms
end
00A5: $PLAYERS_BOAT_WITH_GUNS = create_car #PREDATOR at 502.0 -1115.5601 5.8125
0175: set_car $PLAYERS_BOAT_WITH_GUNS z_angle_to 140.0
0186: $PLAYERS_BOAT_WITH_GUNS_BLIP = create_marker_above_car $PLAYERS_BOAT_WITH_GUNS
00BC: print_now 'RM4_1' 5000 ms 1   // // ~g~Go and steal a police boat.
while 80DE:   NOT  player $PLAYER driving_vehicle_type #PREDATOR
    wait 0 ms
end
0164: remove_blip $PLAYERS_BOAT_WITH_GUNS_BLIP
00A5: $PARTNERS_BOAT = create_car #GHOST at 1360.0 -381.5 4.625
03AB: set_vehicle $PARTNERS_BOAT strong 1
0107: $BARREL2_A = create_object #BARREL2 at 502.0 -1115.5601 16.0
0107: $BARREL2_B = create_object #BARREL2 at 502.0 -1115.5601 26.0
0382: set_object $BARREL2_A collision_detection 0
0382: set_object $BARREL2_B collision_detection 0
0392: object $BARREL2_A toggle_in_moving_list 0
0392: object $BARREL2_B toggle_in_moving_list 0
035C: place_object $BARREL2_A relative_to_car $PARTNERS_BOAT offset -0.25 -2.5 0.1875
035C: place_object $BARREL2_B relative_to_car $PARTNERS_BOAT offset 0.25 -2.5 0.1875
00BC: print_now 'RM4_2' 5000 ms 1   // // ~g~Get to the lighthouse and 'rub out' Ray's partner!
0227: $PARTNERS_BOAT_HEALTH = car $PARTNERS_BOAT health
0161: tie_marker $PARTNERS_BLIP to_car $PARTNERS_BOAT 1 3
0168: set_marker $PARTNERS_BLIP size_to 3
while true
    if and
        80E3:   NOT   player $PLAYER 0 near_point 1365.0 -383.0 radius 180.0 180.0
        801A:   NOT   980 > $PARTNERS_BOAT_HEALTH
    jf break
    wait 0 ms
    if
        8119:   NOT  car $PARTNERS_BOAT wrecked
    then
        0227: $PARTNERS_BOAT_HEALTH = car $PARTNERS_BOAT health
        gosub @OBJECT_PLACEMENT
    end
end
0174: $DISTANCE_RESULTB = car $PARTNERS_BOAT z_angle
00AA: store_car $PARTNERS_BOAT position_to $PARTNER_X $PARTNER_Y $PARTNER_Z
02F8: store_car $PARTNERS_BOAT cosine_to $PARTNERS_BOAT_FORWARD_X
02F9: store_car $PARTNERS_BOAT sinus_to $PARTNERS_BOAT_FORWARD_Y
0005: $TEMP_DOT_PRODUCT_X = 0.0
0069: $TEMP_DOT_PRODUCT_X *= $PARTNERS_BOAT_FORWARD_Y   // still 0.0?
0005: $TEMP_DOT_PRODUCT_Y = 0.0
0069: $TEMP_DOT_PRODUCT_Y *= $PARTNERS_BOAT_FORWARD_X  // still 0.0?
0005: $TEMP_X = 1.8
0069: $TEMP_X *= $PARTNERS_BOAT_FORWARD_X
0005: $TEMP_Y = 1.8
0069: $TEMP_Y *= $PARTNERS_BOAT_FORWARD_Y
0086: $VECTOR_X = $TEMP_DOT_PRODUCT_X          // 0.0?
0061: $VECTOR_X -= $TEMP_X
0086: $VECTOR_Y = $TEMP_DOT_PRODUCT_Y          // 0.0?
0061: $VECTOR_Y -= $TEMP_Y
0059: $VECTOR_X += $PARTNER_X
0059: $VECTOR_Y += $PARTNER_Y
0009: $PARTNER_Z += 0.4
000D: $DISTANCE_RESULTB -= 90.0
if
    0022:   0.0 > $DISTANCE_RESULTB
then
    0009: $DISTANCE_RESULTB += 360.0
end
0164: remove_blip $PARTNERS_BLIP
009A: $RAYS_PARTNER = create_actor 4 #MALE01 at $VECTOR_X $VECTOR_Y $PARTNER_Z
0173: set_actor $RAYS_PARTNER z_angle_to $DISTANCE_RESULTB
0350: set_char_stay_in_same_place $RAYS_PARTNER  1
01ED: reset_actor $RAYS_PARTNER flags
035F: set_actor $RAYS_PARTNER armour_to 100
0372: set_actor $RAYS_PARTNER anim 14 wait_state_time 1700 ms
0006: 16@ = 0
while 001B:   1200 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
02A3: toggle_widescreen 1 (on)
01B4: set_player $PLAYER can_move 0 (frozen)
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
03F4: set_all_cars_can_be_damaged 0
if
    00E0:   player $PLAYER driving
then
    if or
        00DE:   player $PLAYER driving_vehicle_type #PREDATOR
        00DE:   player $PLAYER driving_vehicle_type #REEFER
        00DE:   player $PLAYER driving_vehicle_type #GHOST
    then
        01C3: remove_references_to_car $PLAYERS_BOAT_WITH_GUNS  // Like turning a car into any random car
        00DA: $PLAYERS_BOAT_WITH_GUNS = player $PLAYER car
        0323: anchor_boat $PLAYERS_BOAT_WITH_GUNS flag 1
    end
    0221: set_player $PLAYER trapped_in_car 1
end
if or
    0118:   actor $RAYS_PARTNER dead
    0119:   car $PARTNERS_BOAT wrecked
then
    jump @MISSION_RAY4_PASSED
end
02AB: set_actor $RAYS_PARTNER immunities 1 1 1 1 1
02AC: set_car $PARTNERS_BOAT immunities 1 1 1 1 1
00AA: store_car $PARTNERS_BOAT position_to $PARTNER_X $PARTNER_Y $PARTNER_Z
02F8: store_car $PARTNERS_BOAT cosine_to $PARTNERS_BOAT_FORWARD_X
02F9: store_car $PARTNERS_BOAT sinus_to $PARTNERS_BOAT_FORWARD_Y
0005: $TEMP_DOT_PRODUCT_X = -5.0
0069: $TEMP_DOT_PRODUCT_X *= $PARTNERS_BOAT_FORWARD_Y
0005: $TEMP_DOT_PRODUCT_Y = 5.0
0069: $TEMP_DOT_PRODUCT_Y *= $PARTNERS_BOAT_FORWARD_X
0005: $TEMP_X = 3.75
0069: $TEMP_X *= $PARTNERS_BOAT_FORWARD_X
0005: $TEMP_Y = 3.75
0069: $TEMP_Y *= $PARTNERS_BOAT_FORWARD_Y
0086: $VECTOR_X = $TEMP_DOT_PRODUCT_X
0061: $VECTOR_X -= $TEMP_X
0086: $VECTOR_Y = $TEMP_DOT_PRODUCT_Y
0061: $VECTOR_Y -= $TEMP_Y
0059: $VECTOR_X += $PARTNER_X
0059: $VECTOR_Y += $PARTNER_Y
0009: $PARTNER_Z += 2.0
015F: set_camera_position $VECTOR_X $VECTOR_Y $PARTNER_Z 0.0 0.0 0.0
0159: camera_on_ped $RAYS_PARTNER 15 2
0006: 16@ = 0
while 001B:   1500 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
if or
    0118:   actor $RAYS_PARTNER dead
    0119:   car $PARTNERS_BOAT wrecked
then
    jump @MISSION_RAY4_PASSED
end
0372: set_actor $RAYS_PARTNER anim 3 wait_state_time 1600 ms
00AA: store_car $PARTNERS_BOAT position_to $PARTNER_X $PARTNER_Y $PARTNER_Z
02F8: store_car $PARTNERS_BOAT cosine_to $PARTNERS_BOAT_FORWARD_X
02F9: store_car $PARTNERS_BOAT sinus_to $PARTNERS_BOAT_FORWARD_Y
0005: $TEMP_DOT_PRODUCT_X = 25.0
0069: $TEMP_DOT_PRODUCT_X *= $PARTNERS_BOAT_FORWARD_Y
0005: $TEMP_DOT_PRODUCT_Y = -25.0
0069: $TEMP_DOT_PRODUCT_Y *= $PARTNERS_BOAT_FORWARD_X
0005: $TEMP_X = 1.75
0069: $TEMP_X *= $PARTNERS_BOAT_FORWARD_X
0005: $TEMP_Y = 1.75
0069: $TEMP_Y *= $PARTNERS_BOAT_FORWARD_Y
0086: $VECTOR_X = $TEMP_DOT_PRODUCT_X
0061: $VECTOR_X -= $TEMP_X
0086: $VECTOR_Y = $TEMP_DOT_PRODUCT_Y
0061: $VECTOR_Y -= $TEMP_Y
0059: $VECTOR_X += $PARTNER_X
0059: $VECTOR_Y += $PARTNER_Y
0005: $PARTNER_Z = -2.0
$PARTNER_Z += 6.0 // account for the world z shift
0006: 16@ = 0
while 001B:   1600 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
if or
    0118:   actor $RAYS_PARTNER dead
    0119:   car $PARTNERS_BOAT wrecked
then
    jump @MISSION_RAY4_PASSED
end
00A5: $FISH_TARGET = create_car #RCBANDIT at $VECTOR_X $VECTOR_Y $PARTNER_Z
01B2: give_actor $RAYS_PARTNER weapon 12 ammo $RAYS_PARTNER  // Load the weapon model before using this
011C: actor $RAYS_PARTNER clear_objective
0372: set_actor $RAYS_PARTNER anim 0 wait_state_time 100 ms
01D9: actor $RAYS_PARTNER destroy_car $FISH_TARGET
00AA: store_car $FISH_TARGET position_to $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
0086: $PARTNER_X = $FISH_TARGET_X
000D: $PARTNER_X -= 2.0
0086: $PARTNER_Y = $FISH_TARGET_Y
000D: $PARTNER_Y -= 2.0
0086: $PARTNER_Z = $FISH_TARGET_Z
000D: $PARTNER_Z -= 2.0
0009: $TEMP_X += 2.0
0009: $VECTOR_X += 2.0
0009: $VECTOR_Y += 1.0
17@ = 0
while true
    if and
        82EE:   NOT   projectile_in_cube_keep $PARTNER_X $PARTNER_Y $PARTNER_Z $TEMP_X $VECTOR_X $VECTOR_Y
        NOT 17@ > 3500      //breaks loop if condition can't be met after 3.5 seconds
    jf break
    wait 0 ms
    gosub @OBJECT_PLACEMENT
    if or
        0118:   actor $RAYS_PARTNER dead
        0119:   car $PARTNERS_BOAT wrecked
    then
        jump @MISSION_RAY4_PASSED
    end
    00AB: put_car $FISH_TARGET at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
end //while
02AB: set_actor $RAYS_PARTNER immunities 0 0 0 0 0
02AC: set_car $PARTNERS_BOAT immunities 0 0 0 0 0
011C: actor $RAYS_PARTNER clear_objective
02EF: projectile_in_area_destroy $PARTNER_X $PARTNER_Y $PARTNER_Z $TEMP_X $VECTOR_X $VECTOR_Y
00AA: store_car $FISH_TARGET position_to $PARTNER_X $PARTNER_Y $PARTNER_Z
0009: $PARTNER_Z += 1.0
0086: $FISH_TARGET_X = $PARTNER_X
0086: $FISH_TARGET_Y = $PARTNER_Y
0086: $FISH_TARGET_Z = $PARTNER_Z
0160: point_camera $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z 1
00A6: destroy_car $FISH_TARGET
0006: 16@ = 0
while 001B:   300 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
0005: $PARTNER_Z = 0.0
$PARTNER_Z += 6.0 // account for the world z shift
020C: create_explosion_with_radius 0 at $PARTNER_X $PARTNER_Y $PARTNER_Z
0005: $PARTNER_Z = 0.25
$PARTNER_Z += 6.0 // account for the world z shift
if
    0119:   car $PARTNERS_BOAT wrecked
then
    jump @MISSION_RAY4_PASSED
end
00AA: store_car $PARTNERS_BOAT position_to $PARTNER_X $PARTNER_Y $PARTNER_Z
02F8: store_car $PARTNERS_BOAT cosine_to $PARTNERS_BOAT_FORWARD_X
02F9: store_car $PARTNERS_BOAT sinus_to $PARTNERS_BOAT_FORWARD_Y
0005: $TEMP_DOT_PRODUCT_X = 30.0
0069: $TEMP_DOT_PRODUCT_X *= $PARTNERS_BOAT_FORWARD_Y
0005: $TEMP_DOT_PRODUCT_Y = -30.0
0069: $TEMP_DOT_PRODUCT_Y *= $PARTNERS_BOAT_FORWARD_X
0005: $TEMP_X = 2.1875
0069: $TEMP_X *= $PARTNERS_BOAT_FORWARD_X
0005: $TEMP_Y = 2.1875
0069: $TEMP_Y *= $PARTNERS_BOAT_FORWARD_Y
0086: $VECTOR_X = $TEMP_DOT_PRODUCT_X
0061: $VECTOR_X -= $TEMP_X
0086: $VECTOR_Y = $TEMP_DOT_PRODUCT_Y
0061: $VECTOR_Y -= $TEMP_Y
0059: $VECTOR_X += $PARTNER_X
0059: $VECTOR_Y += $PARTNER_Y
0009: $PARTNER_Z += 1.5
0006: 16@ = 0
while 001B:   1000 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
000D: $FISH_TARGET_Z -= 0.1875
015F: set_camera_position $VECTOR_X $VECTOR_Y $PARTNER_Z 0.0 0.0 0.0
0160: point_camera $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z 2
0006: 16@ = 0
while 001B:   1500 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
0005: $FISH_TARGET_Z = -0.5
$FISH_TARGET_Z += 6.0 // account for the world z shift
0086: $PARTNER_X = $FISH_TARGET_X
0086: $PARTNER_Y = $FISH_TARGET_Y
0086: $PARTNER_Z = $FISH_TARGET_Z
0086: $FISH_TARGET_X = $PARTNER_X
000D: $FISH_TARGET_X -= 0.1875
0086: $FISH_TARGET_Y = $PARTNER_Y
000D: $FISH_TARGET_Y -= 0.1875
0086: $FISH_TARGET_Z = $PARTNER_Z
0107: $FISHY_1 = create_object #FISH01 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
0392: object $FISHY_1 toggle_in_moving_list 1
038C: object $FISHY_1 scatter 0.0 0.0 1.0
0208: $TEMP_X = random_float 0.0 359.9
0177: set_object $FISHY_1 z_angle_to $TEMP_X
0006: 16@ = 0
while 001B:   600 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
0009: $FISH_TARGET_X += 0.9
0009: $FISH_TARGET_Y += 0.3
0208: $TEMP_X = random_float -4.0 2.0
0086: $FISH_TARGET_X = $PARTNER_X
0059: $FISH_TARGET_X += $TEMP_X
0208: $TEMP_X = random_float -3.0 3.0
0086: $FISH_TARGET_Y = $PARTNER_Y
0059: $FISH_TARGET_Y += $TEMP_X
0107: $FISHY_10 = create_object #FISH01 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
0392: object $FISHY_10 toggle_in_moving_list 1
038C: object $FISHY_10 scatter 0.0 0.0 1.0
0208: $TEMP_X = random_float 0.0 359.875
0177: set_object $FISHY_10 z_angle_to $TEMP_X
0006: 16@ = 0
while 001B:   200 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
0208: $TEMP_X = random_float -4.0 2.0
0086: $FISH_TARGET_X = $PARTNER_X
0059: $FISH_TARGET_X += $TEMP_X
0208: $TEMP_X = random_float -3.0 3.0
0086: $FISH_TARGET_Y = $PARTNER_Y
0059: $FISH_TARGET_Y += $TEMP_X
0107: $FISHY_2 = create_object #FISH01 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
0392: object $FISHY_2 toggle_in_moving_list 1
038C: object $FISHY_2 scatter 0.0 0.0 1.0
0208: $TEMP_X = random_float 0.0 359.875
0177: set_object $FISHY_2 z_angle_to $TEMP_X
0006: 16@ = 0
while 001B:   400 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
0208: $TEMP_X = random_float -4.0 2.0
0086: $FISH_TARGET_X = $PARTNER_X
0059: $FISH_TARGET_X += $TEMP_X
0208: $TEMP_X = random_float -3.0 3.0
0086: $FISH_TARGET_Y = $PARTNER_Y
0059: $FISH_TARGET_Y += $TEMP_X
0107: $FISHY_3 = create_object #FISH01 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
0392: object $FISHY_3 toggle_in_moving_list 1
038C: object $FISHY_3 scatter 0.0 0.0 1.0
0208: $TEMP_X = random_float 0.0 359.875
0177: set_object $FISHY_3 z_angle_to $TEMP_X
0006: 16@ = 0
while 001B:   100 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
0208: $TEMP_X = random_float -4.0 2.0
0086: $FISH_TARGET_X = $PARTNER_X
0059: $FISH_TARGET_X += $TEMP_X
0208: $TEMP_X = random_float -3.0 3.0
0086: $FISH_TARGET_Y = $PARTNER_Y
0059: $FISH_TARGET_Y += $TEMP_X
0107: $FISHY_4 = create_object #FISH01 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
0392: object $FISHY_4 toggle_in_moving_list 1
038C: object $FISHY_4 scatter 0.0 0.0 1.0
0208: $TEMP_X = random_float 0.0 359.875
0177: set_object $FISHY_4 z_angle_to $TEMP_X
0006: 16@ = 0
while 001B:   300 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
0208: $TEMP_X = random_float -4.0 2.0
0086: $FISH_TARGET_X = $PARTNER_X
0059: $FISH_TARGET_X += $TEMP_X
0208: $TEMP_X = random_float -3.0 3.0
0086: $FISH_TARGET_Y = $PARTNER_Y
0059: $FISH_TARGET_Y += $TEMP_X
0107: $FISHY_5 = create_object #FISH01 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
0392: object $FISHY_5 toggle_in_moving_list 1
038C: object $FISHY_5 scatter 0.0 0.0 1.0
0208: $TEMP_X = random_float 0.0 359.875
0177: set_object $FISHY_5 z_angle_to $TEMP_X
0006: 16@ = 0
while 001B:   200 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
0208: $TEMP_X = random_float -4.0 2.0
0086: $FISH_TARGET_X = $PARTNER_X
0059: $FISH_TARGET_X += $TEMP_X
0208: $TEMP_X = random_float -3.0 3.0
0086: $FISH_TARGET_Y = $PARTNER_Y
0059: $FISH_TARGET_Y += $TEMP_X
0107: $FISHY_6 = create_object #FISH01 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
0392: object $FISHY_6 toggle_in_moving_list 1
038C: object $FISHY_6 scatter 0.0 0.0 1.0
0208: $TEMP_X = random_float 0.0 359.875
0177: set_object $FISHY_6 z_angle_to $TEMP_X
0006: 16@ = 0
while 001B:   120 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
0208: $TEMP_X = random_float -4.0 2.0
0086: $FISH_TARGET_X = $PARTNER_X
0059: $FISH_TARGET_X += $TEMP_X
0208: $TEMP_X = random_float -3.0 3.0
0086: $FISH_TARGET_Y = $PARTNER_Y
0059: $FISH_TARGET_Y += $TEMP_X
0107: $FISHY_7 = create_object #FISH01 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
0392: object $FISHY_7 toggle_in_moving_list 1
038C: object $FISHY_7 scatter 0.0 0.0 1.0
0208: $TEMP_X = random_float 0.0 359.875
0177: set_object $FISHY_7 z_angle_to $TEMP_X
0006: 16@ = 0
while 001B:   70 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
0208: $TEMP_X = random_float -4.0 2.0
0086: $FISH_TARGET_X = $PARTNER_X
0059: $FISH_TARGET_X += $TEMP_X
0208: $TEMP_X = random_float -3.0 3.0
0086: $FISH_TARGET_Y = $PARTNER_Y
0059: $FISH_TARGET_Y += $TEMP_X
0107: $FISHY_8 = create_object #FISH01 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
0392: object $FISHY_8 toggle_in_moving_list 1
038C: object $FISHY_8 scatter 0.0 0.0 1.0
0208: $TEMP_X = random_float 0.0 359.875
0177: set_object $FISHY_8 z_angle_to $TEMP_X
0006: 16@ = 0
while 001B:   35 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
0208: $TEMP_X = random_float -4.0 2.0
0086: $FISH_TARGET_X = $PARTNER_X
0059: $FISH_TARGET_X += $TEMP_X
0208: $TEMP_X = random_float -3.0 3.0
0086: $FISH_TARGET_Y = $PARTNER_Y
0059: $FISH_TARGET_Y += $TEMP_X
0107: $FISHY_9 = create_object #FISH01 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
0392: object $FISHY_9 toggle_in_moving_list 1
038C: object $FISHY_9 scatter 0.0 0.0 1.0
0208: $TEMP_X = random_float 0.0 359.875
0177: set_object $FISHY_9 z_angle_to $TEMP_X
0006: 16@ = 0
while 001B:   2500 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
if
    0118:   actor $RAYS_PARTNER dead
then
    jump @MISSION_RAY4_PASSED
end
0159: camera_on_ped $RAYS_PARTNER 15 1
0006: 16@ = 0
while 001B:   200 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
if
    0119:   car $PARTNERS_BOAT wrecked
then
    jump @MISSION_RAY4_PASSED
end
00AA: store_car $PARTNERS_BOAT position_to $PARTNER_X $PARTNER_Y $PARTNER_Z
02F8: store_car $PARTNERS_BOAT cosine_to $PARTNERS_BOAT_FORWARD_X
02F9: store_car $PARTNERS_BOAT sinus_to $PARTNERS_BOAT_FORWARD_Y
0005: $TEMP_DOT_PRODUCT_X = 10.0
0069: $TEMP_DOT_PRODUCT_X *= $PARTNERS_BOAT_FORWARD_Y
0005: $TEMP_DOT_PRODUCT_Y = -10.0
0069: $TEMP_DOT_PRODUCT_Y *= $PARTNERS_BOAT_FORWARD_X
0005: $TEMP_X = 2.1875
0069: $TEMP_X *= $PARTNERS_BOAT_FORWARD_X
0005: $TEMP_Y = 2.1875
0069: $TEMP_Y *= $PARTNERS_BOAT_FORWARD_Y
0086: $VECTOR_X = $TEMP_DOT_PRODUCT_X
0061: $VECTOR_X -= $TEMP_X
0086: $VECTOR_Y = $TEMP_DOT_PRODUCT_Y
0061: $VECTOR_Y -= $TEMP_Y
0059: $VECTOR_X += $PARTNER_X
0059: $VECTOR_Y += $PARTNER_Y
0009: $PARTNER_Z += 2.0
000D: $FISH_TARGET_Z -= 0.1875
015F: set_camera_position $VECTOR_X $VECTOR_Y $PARTNER_Z 0.0 0.0 0.0
0006: 16@ = 0
while 001B:   800 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
if
    0118:   actor $RAYS_PARTNER dead
then
    jump @MISSION_RAY4_PASSED
end
022D: set_actor $RAYS_PARTNER to_look_at_player $PLAYER
0006: 16@ = 0
while 001B:   600 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
if
    0118:   actor $RAYS_PARTNER dead
then
    jump @MISSION_RAY4_PASSED
end
022F: set_actor $RAYS_PARTNER stop_looking
if or
    0118:   actor $RAYS_PARTNER dead
    0119:   car $PARTNERS_BOAT wrecked
then
    jump @MISSION_RAY4_PASSED
end
00AA: store_car $PARTNERS_BOAT position_to $PARTNER_X $PARTNER_Y $PARTNER_Z
0211: actor $RAYS_PARTNER walk_to $PARTNER_X $PARTNER_Y
0006: 16@ = 0
while 001B:   1000 > 16@
    wait 0 ms
    gosub @OBJECT_PLACEMENT
end
if or
    0118:   actor $RAYS_PARTNER dead
    0119:   car $PARTNERS_BOAT wrecked
then
    jump @MISSION_RAY4_PASSED
end
02AC: set_car $PARTNERS_BOAT immunities 0 0 0 0 0
009B: destroy_actor_instantly $RAYS_PARTNER
0129: $RAYS_PARTNER = create_actor 4 #MALE01 in_car $PARTNERS_BOAT driverseat
011A: set_actor $RAYS_PARTNER flags 1
0243: set_actor $RAYS_PARTNER ped_stats_to 16
0223: set_actor $RAYS_PARTNER health_to 300
0187: $PARTNERS_BLIP = create_marker_above_actor $RAYS_PARTNER
02A3: toggle_widescreen 0 (off)
01B4: set_player $PLAYER can_move 1 (unfrozen)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
03F4: set_all_cars_can_be_damaged 1
0221: set_player $PLAYER trapped_in_car 0
if
    00AC:   is_car_still_alive $PLAYERS_BOAT_WITH_GUNS      //herehere test if crashes
    //8119:   NOT  car $PARKED_CAR1 wrecked          //replacement???
then
    0323: anchor_boat $PLAYERS_BOAT_WITH_GUNS flag 0
end
015A: restore_camera
00A5: $PARTNERS_CAR = create_car #SENTINEL at 994.88 -641.688 17.125
0175: set_car $PARTNERS_CAR z_angle_to 180.812
02D3: boat $PARTNERS_BOAT drive_to $NODE_2_X $NODE_2_Y 0.0
0086: $BOAT_NODE_X = $NODE_2_X
0086: $BOAT_NODE_Y = $NODE_2_Y
01BD: $MINE_CURRENT_TIMER = current_time_in_ms
01BD: $LAST_MINE_DROPPED_TIMER = current_time_in_ms
0227: $PARTNERS_BOAT_HEALTH = car $PARTNERS_BOAT health
000C: $PARTNERS_BOAT_HEALTH -= 250
0010: $PARTNERS_BOAT_HEALTH *= 100
0014: $PARTNERS_BOAT_HEALTH /= 750
0084: $PARTNERS_BOAT_HEALTH2 = $PARTNERS_BOAT_HEALTH
0004: $PARTNERS_BOAT_HEALTH = 100
0060: $PARTNERS_BOAT_HEALTH -= $PARTNERS_BOAT_HEALTH2
03C4: set_status_text_to $PARTNERS_BOAT_HEALTH 1 (bar)  'DAM'   // // Damage
while true //BOAT_LOOOP
    wait 0 ms
    if
        0118:   actor $RAYS_PARTNER dead
    then
        if
            03CA:   object $BARREL2_A exists
        then
            01BB: store_object $BARREL2_A position_to $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
            020C: create_explosion_with_radius 0 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
            0108: destroy_object $BARREL2_A
        end
        if
            03CA:   object $BARREL2_B exists
        then
            01BB: store_object $BARREL2_B position_to $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
            020C: create_explosion_with_radius 0 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
            0108: destroy_object $BARREL2_B
        end
        jump @MISSION_RAY4_PASSED
    end
    if
        0038:   $PARTNER_ON_FOOT_FLAG == -1
    then
        if
            8119:   NOT   car $PARTNERS_BOAT wrecked
        then
            if and
                03CA:   object $BARREL2_A exists
                03CA:   object $BARREL2_B exists
            then
                gosub @OBJECT_PLACEMENT
            end
        end
        if
            0019:   16@ > 500
        then
            0006: 16@ = 0
            if
                00E0:   player $PLAYER driving
            then
                01C3: remove_references_to_car $PLAYERS_BOAT_WITH_GUNS  // Like turning a car into any random car
                00DA: $PLAYERS_BOAT_WITH_GUNS = player $PLAYER car
                02E2: set_actor $RAYS_PARTNER weapon_accuracy_to 100
                01D9: actor $RAYS_PARTNER destroy_car $PLAYERS_BOAT_WITH_GUNS
            else
                01CA: actor $RAYS_PARTNER kill_player $PLAYER
            end
        end
    end
    if
        0038:   $PARTNER_ON_FOOT_FLAG == 0
    then
        if
            8119:   NOT   car $PARTNERS_BOAT wrecked
        then
            if and
                03CA:   object $BARREL2_A exists
                03CA:   object $BARREL2_B exists
            then
                gosub @OBJECT_PLACEMENT
            end
            gosub @BOAT_HEALTH_COUNTER
            if
                0018:   $BOAT_NODE_COUNTER > 0
            then
                gosub @DROP_MINES
                if
                    0038:   $BOAT_SPEED_FLAG == 1
                then
                    if
                        81FC:   NOT   player $PLAYER near_car $PARTNERS_BOAT radius 100.0 100.0 0
                    then
                        02DB: set_boat $PARTNERS_BOAT speed_to 25.0
                        0004: $BOAT_SPEED_FLAG = 0
                    end
                end
                if
                    0038:   $BOAT_SPEED_FLAG == 0
                then
                    if
                        01FC:   player $PLAYER near_car $PARTNERS_BOAT radius 80.0 80.0 0
                    then
                        02DB: set_boat $PARTNERS_BOAT speed_to 35.0
                        0004: $BOAT_SPEED_FLAG = 1
                    end
                end
            end
            if
                8038:   NOT   $BOAT_NODE_COUNTER == 0
            then
                if
                    01AD:   car $PARTNERS_BOAT 0 near_point $BOAT_NODE_X $BOAT_NODE_Y 5.0 5.0
                then
                    gosub @SELECT_BOAT_NODE
                    02D3: boat $PARTNERS_BOAT drive_to $BOAT_NODE_X $BOAT_NODE_Y 0.0
                end
            end
            if
                0038:   $BOAT_NODE_COUNTER == 0
            then
                if
                    03CA:   object $BARREL2_A exists
                then
                    01BB: store_object $BARREL2_A position_to $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
                    0108: destroy_object $BARREL2_A
                    02F1: create_gta3_exploding_barrel2_at  $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
                end
                if
                    03CA:   object $BARREL2_B exists
                then
                    01BB: store_object $BARREL2_B position_to $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
                    0108: destroy_object $BARREL2_B
                    02F1: create_gta3_exploding_barrel2_at  $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
                end
                if
                    01A3:   actor $RAYS_PARTNER stopped 0 in_rectangle 1029.0601 -614.5 1138.75 -560.188  // never used in VC
                then
                    gosub @EXIT_BOAT
                    0004: $PARTNER_ON_FOOT_FLAG = 1
                end
            end
            if
                01AF:   car $PARTNERS_BOAT 0 near_point $PARTNER_STUCK_X $PARTNER_STUCK_Y $PARTNER_STUCK_Z radius 4.0 4.0 4.0
            then
                if
                    0038:   $TIMERC_RESET_FLAG_R4 == 0
                then
                    01BD: $TIMERC_STARTED_R4 = current_time_in_ms
                    0004: $TIMERC_RESET_FLAG_R4 = 1
                end
                if
                    0038:   $TIMERC_RESET_FLAG_R4 == 1
                then
                    01BD: $TIMERC_CURRENT_R4 = current_time_in_ms
                    0084: $TIMERC_R4 = $TIMERC_CURRENT_R4
                    0060: $TIMERC_R4 -= $TIMERC_STARTED_R4
                    if
                        0018:   $TIMERC_R4 > 8000
                    then
                        if
                            00A3:   actor $RAYS_PARTNER 0 in_rectangle 1273.0 -536.0 1349.0 -472.0
                        then
                            gosub @EXIT_BOAT
                            0350: set_char_stay_in_same_place $RAYS_PARTNER  1
                            if
                                00E0:   player $PLAYER driving
                            then
                                01C3: remove_references_to_car $PLAYERS_BOAT_WITH_GUNS  // Like turning a car into any random car
                                00DA: $PLAYERS_BOAT_WITH_GUNS = player $PLAYER car
                                02E2: set_actor $RAYS_PARTNER weapon_accuracy_to 100
                                01D9: actor $RAYS_PARTNER destroy_car $PLAYERS_BOAT_WITH_GUNS
                            else
                                01CA: actor $RAYS_PARTNER kill_player $PLAYER
                            end
                            0004: $TIMERC_RESET_FLAG_R4 = 1
                            0004: $PARTNER_ON_FOOT_FLAG = -1
                        else
                            00AA: store_car $PARTNERS_BOAT position_to $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
                            02CE: $FISH_TARGET_Z = ground_z $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
                            if
                                8042:   NOT   $FISH_TARGET_Z == 0.0
                            then
                                gosub @EXIT_BOAT
                                0350: set_char_stay_in_same_place $RAYS_PARTNER  1
                                if
                                    00E0:   player $PLAYER driving
                                then
                                    01C3: remove_references_to_car $PLAYERS_BOAT_WITH_GUNS  // Like turning a car into any random car
                                    00DA: $PLAYERS_BOAT_WITH_GUNS = player $PLAYER car
                                    02E2: set_actor $RAYS_PARTNER weapon_accuracy_to 100
                                    01D9: actor $RAYS_PARTNER destroy_car $PLAYERS_BOAT_WITH_GUNS
                                else
                                    01CA: actor $RAYS_PARTNER kill_player $PLAYER
                                end
                                0004: $TIMERC_RESET_FLAG_R4 = 1
                                0004: $PARTNER_ON_FOOT_FLAG = -1
                            end
                        end
                    end
                end
            end
            if
                81AF:   NOT   car $PARTNERS_BOAT 0 near_point $PARTNER_STUCK_X $PARTNER_STUCK_Y $PARTNER_STUCK_Z radius 4.0 4.0 4.0
            then
                00AA: store_car $PARTNERS_BOAT position_to $PARTNER_STUCK_X $PARTNER_STUCK_Y $PARTNER_STUCK_Z
                0004: $TIMERC_RESET_FLAG_R4 = 0
            end
        else
            if
                03CA:   object $BARREL2_A exists
            then
                01BB: store_object $BARREL2_A position_to $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
                020C: create_explosion_with_radius 0 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
                0108: destroy_object $BARREL2_A
            end
            if
                03CA:   object $BARREL2_B exists
            then
                01BB: store_object $BARREL2_B position_to $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
                020C: create_explosion_with_radius 0 at $FISH_TARGET_X $FISH_TARGET_Y $FISH_TARGET_Z
                0108: destroy_object $BARREL2_B
            end
        end
    end
    if
        0038:   $PARTNER_ON_FOOT_FLAG == 1
    then
        gosub @PARTNER_ESCAPE_CHECKS
        if
            0038:   $GOTO_MISSION_RAY4_FAILED == 1
        then
            jump @MISSION_RAY4_FAILED
        end
        if
            0038:   $PARTNER_ON_FOOT_COUNTER == 0
        then
            if
                8056:   NOT   player $PLAYER 0 in_rectangle 1029.0601 -614.5 1138.75 -560.188
            then
                0239: actor $RAYS_PARTNER run_to 1118.38 -583.375
                0004: $SHOOT_AT_PLAYER_FLAG = 1
            else
                0239: actor $RAYS_PARTNER run_to 1030.6899 -617.125
            end
            0004: $PARTNER_ON_FOOT_COUNTER = 1
        end
        if
            0018:   $SHOOT_AT_PLAYER_FLAG > 0
        then
            if
                0038:   $SHOOT_AT_PLAYER_FLAG == 1
            then
                if
                    00ED:   actor $RAYS_PARTNER 0 near_point_on_foot 1118.38 -583.375 radius 1.0 1.0
                then
                    if
                        8056:   NOT   player $PLAYER 0 in_rectangle 1029.0601 -614.5 1138.75 -560.188
                    then
                        if
                            00E0:   player $PLAYER driving
                        then
                            01C3: remove_references_to_car $PLAYERS_BOAT_WITH_GUNS  // Like turning a car into any random car
                            00DA: $PLAYERS_BOAT_WITH_GUNS = player $PLAYER car
                            02E2: set_actor $RAYS_PARTNER weapon_accuracy_to 100
                            0350: set_char_stay_in_same_place $RAYS_PARTNER  1
                            01D9: actor $RAYS_PARTNER destroy_car $PLAYERS_BOAT_WITH_GUNS
                        end
                    end
                    0004: $SHOOT_AT_PLAYER_FLAG = 2
                end
            end
            if
                0038:   $SHOOT_AT_PLAYER_FLAG == 2
            then
                if
                    0056:   player $PLAYER 0 in_rectangle 1029.0601 -614.5 1138.75 -560.188
                then
                    0350: set_char_stay_in_same_place $RAYS_PARTNER  0
                    0239: actor $RAYS_PARTNER run_to 1030.6899 -617.125
                    0004: $PARTNER_ON_FOOT_COUNTER = 2
                    0004: $SHOOT_AT_PLAYER_FLAG = 0
                end
            end
        end
        if
            8038:   NOT   $PARTNERS_BOAT_HEALTH == -1
        then
            0226: $PARTNERS_BOAT_HEALTH = actor $RAYS_PARTNER health
            if
                001A:   250 > $PARTNERS_BOAT_HEALTH
            then
                0291: set_char_heed_threats $RAYS_PARTNER  1
                0004: $PARTNERS_BOAT_HEALTH = -1
            end
        end
        if
            0038:   $PARTNER_ON_FOOT_COUNTER == 1
        then
            if
                0038:   $SHOOT_AT_PLAYER_FLAG == 0
            then
                if
                    00ED:   actor $RAYS_PARTNER 0 near_point_on_foot 1030.6899 -617.125 radius 1.0 1.0
                then
                    0239: actor $RAYS_PARTNER run_to 1009.5601 -617.25
                    0004: $PARTNER_ON_FOOT_COUNTER = 2
                end
            end
        end
        if
            0038:   $PARTNER_ON_FOOT_COUNTER == 2
        then
            if
                00ED:   actor $RAYS_PARTNER 0 near_point_on_foot 1009.5601 -617.25 radius 1.0 1.0
            then
                0239: actor $RAYS_PARTNER run_to 1005.5 -614.0
                0004: $PARTNER_ON_FOOT_COUNTER = 3
            end
        end
        if
            0038:   $PARTNER_ON_FOOT_COUNTER == 3
        then
            if
                00ED:   actor $RAYS_PARTNER 0 near_point_on_foot 1005.5 -614.0 radius 1.0 1.0
            then
                0239: actor $RAYS_PARTNER run_to 1001.62 -616.938
                0004: $PARTNER_ON_FOOT_COUNTER = 4
            end
        end
        if
            0038:   $PARTNER_ON_FOOT_COUNTER == 4
        then
            if
                00ED:   actor $RAYS_PARTNER 0 near_point_on_foot 1001.62 -616.938 radius 1.0 1.0
            then
                0239: actor $RAYS_PARTNER run_to 998.75 -631.938
                0004: $PARTNER_ON_FOOT_COUNTER = 5
            end
        end
        if
            0038:   $PARTNER_ON_FOOT_COUNTER == 5
        then
            if
                00ED:   actor $RAYS_PARTNER 0 near_point_on_foot 998.75 -631.938 radius 1.0 1.0
            then
                0239: actor $RAYS_PARTNER run_to 997.6899 -636.812
                0004: $PARTNER_ON_FOOT_COUNTER = 6
            end
        end
        if
            0038:   $PARTNER_ON_FOOT_COUNTER == 6
        then
            if
                00ED:   actor $RAYS_PARTNER 0 near_point_on_foot 997.6899 -636.812 radius 1.0 1.0
            then
                if
                    0119:   car $PARTNERS_CAR wrecked
                then
                    0239: actor $RAYS_PARTNER run_to 996.75 -678.125
                    0004: $PARTNERS_CAR_IS_DEAD = 1
                else
                    01D5: actor $RAYS_PARTNER go_to_and_drive_car $PARTNERS_CAR
                    0004: $PARTNERS_CAR_IS_DEAD = -1
                end
                0004: $PARTNER_ON_FOOT_COUNTER = 7
            end
        end
        if
            0038:   $PARTNERS_CAR_IS_DEAD == 1
        then
            if
                0038:   $PARTNER_ON_FOOT_COUNTER == 7
            then
                if
                    00ED:   actor $RAYS_PARTNER 0 near_point_on_foot 996.75 -678.125 radius 1.0 1.0
                then
                    0239: actor $RAYS_PARTNER run_to 996.38 -709.062
                    0004: $PARTNER_ON_FOOT_COUNTER = 8
                end
            end
            if
                0038:   $PARTNER_ON_FOOT_COUNTER == 8
            then
                if
                    00ED:   actor $RAYS_PARTNER 0 near_point_on_foot 996.38 -709.062 radius 1.0 1.0
                then
                    0239: actor $RAYS_PARTNER run_to 990.62 -710.875
                    0004: $PARTNER_ON_FOOT_COUNTER = 9
                end
            end
            if
                0038:   $PARTNER_ON_FOOT_COUNTER == 9
            then
                if
                    00ED:   actor $RAYS_PARTNER 0 near_point_on_foot 990.62 -710.875 radius 1.0 1.0
                then
                    0239: actor $RAYS_PARTNER run_to 974.88 -695.25
                    0004: $PARTNER_ON_FOOT_COUNTER = 10
                end
            end
            if
                0038:   $PARTNER_ON_FOOT_COUNTER == 10
            then
                if
                    00ED:   actor $RAYS_PARTNER 0 near_point_on_foot 974.88 -695.25 radius 1.0 1.0
                then
                    gosub @STEAL_A_CAR
                    0004: $PARTNER_ON_FOOT_COUNTER = 11
                end
            end
            if
                0038:   $PARTNER_ON_FOOT_COUNTER == 11
            then
                if
                    00DF:   actor $RAYS_PARTNER driving
                then
                    01C3: remove_references_to_car $PARTNERS_CAR  // Like turning a car into any random car
                    00D9: $PARTNERS_CAR = actor $RAYS_PARTNER car
                    02AA: set_car $PARTNERS_CAR immune_to_nonplayer 1
                    00AD: set_car $PARTNERS_CAR max_speed_to 50.0
                    00AE: set_car $PARTNERS_CAR driving_style 2  // DRIVINGMODE_AVOIDCARS
                    00A8: set_car $PARTNERS_CAR to_psycho_driver
                    0428: set_car_avoid_level_transitions $PARTNERS_CAR flag 1
                    03ED: set_upsidedown_car_not_damaged $PARTNERS_CAR 1
                    0004: $PARTNER_ON_FOOT_FLAG = 2
                end
            end
        end
        if
            0038:   $PARTNERS_CAR_IS_DEAD == -1
        then
            if
                0038:   $PARTNER_ON_FOOT_COUNTER == 7
            then
                if
                    00DF:   actor $RAYS_PARTNER driving
                then
                    01C3: remove_references_to_car $PARTNERS_CAR  // Like turning a car into any random car
                    00D9: $PARTNERS_CAR = actor $RAYS_PARTNER car
                    02AA: set_car $PARTNERS_CAR immune_to_nonplayer 1
                    00AD: set_car $PARTNERS_CAR max_speed_to 30.0
                    00AE: set_car $PARTNERS_CAR driving_style 3  // DRIVINGMODE_PLOUGHTHROUGH
                    02C2: car $PARTNERS_CAR drive_to_point 996.1899 -662.438 17.0
                    0004: $PARTNER_ON_FOOT_COUNTER = 8
                end
            end
            if
                8119:   NOT   car $PARTNERS_CAR wrecked
            then
                if
                    0038:   $PARTNER_ON_FOOT_COUNTER == 8
                then
                    if
                        00EE:   actor $RAYS_PARTNER 0 near_point_in_car 996.1899 -662.438 radius 5.0 5.0
                    then
                        02C2: car $PARTNERS_CAR drive_to_point 996.1899 -685.188 17.3125
                        0004: $PARTNER_ON_FOOT_COUNTER = 9
                    end
                end
                if
                    0038:   $PARTNER_ON_FOOT_COUNTER == 9
                then
                    if
                        00EE:   actor $RAYS_PARTNER 0 near_point_in_car 996.1899 -685.188 radius 5.0 5.0
                    then
                        02C2: car $PARTNERS_CAR drive_to_point 996.0 -696.562 18.25
                        0004: $PARTNER_ON_FOOT_COUNTER = 10
                    end
                end
                if
                    0038:   $PARTNER_ON_FOOT_COUNTER == 10
                then
                    if
                        00EE:   actor $RAYS_PARTNER 0 near_point_in_car 996.0 -696.562 radius 5.0 5.0
                    then
                        02C2: car $PARTNERS_CAR drive_to_point 996.38 -715.438 20.1875
                        0004: $PARTNER_ON_FOOT_COUNTER = 11
                    end
                end
                if
                    0038:   $PARTNER_ON_FOOT_COUNTER == 11
                then
                    if
                        00EE:   actor $RAYS_PARTNER 0 near_point_in_car 996.38 -715.438 radius 5.0 5.0
                    then
                        01C3: remove_references_to_car $PARTNERS_CAR  // Like turning a car into any random car
                        00D9: $PARTNERS_CAR = actor $RAYS_PARTNER car
                        02AA: set_car $PARTNERS_CAR immune_to_nonplayer 1
                        00AD: set_car $PARTNERS_CAR max_speed_to 50.0
                        00AE: set_car $PARTNERS_CAR driving_style 2  // DRIVINGMODE_AVOIDCARS
                        00A8: set_car $PARTNERS_CAR to_psycho_driver
                        0428: set_car_avoid_level_transitions $PARTNERS_CAR flag 1
                        03ED: set_upsidedown_car_not_damaged $PARTNERS_CAR 1
                        0004: $PARTNER_ON_FOOT_FLAG = 2
                    end
                end
            end
        end
        if and
            00DF:   actor $RAYS_PARTNER driving
            0038:   $PARTNER_ON_FOOT_FLAG == 3
        then
            01C3: remove_references_to_car $PARTNERS_CAR  // Like turning a car into any random car
            00D9: $PARTNERS_CAR = actor $RAYS_PARTNER car
            02AA: set_car $PARTNERS_CAR immune_to_nonplayer 1
            00AD: set_car $PARTNERS_CAR max_speed_to 50.0
            00AE: set_car $PARTNERS_CAR driving_style 2  // DRIVINGMODE_AVOIDCARS
            00A8: set_car $PARTNERS_CAR to_psycho_driver
            0428: set_car_avoid_level_transitions $PARTNERS_CAR flag 1
            03ED: set_upsidedown_car_not_damaged $PARTNERS_CAR 1
            0004: $PARTNER_ON_FOOT_FLAG = 2
        end
        if
            0038:   $PARTNER_ON_FOOT_FLAG == 2
        then
            if
                80DF:   NOT   actor $RAYS_PARTNER driving
            then
                gosub @STEAL_A_CAR
                0004: $PARTNER_ON_FOOT_FLAG = 3
            end
        end
        if
            0038:   $PARTNER_ON_FOOT_FLAG == 2
        then
            if
                8119:   NOT   car $PARTNERS_CAR wrecked
            then
                if
                    0019:   17@ > 1000
                then
                    0006: 17@ = 0
                    if
                        00E9:   player $PLAYER 0 near_actor $RAYS_PARTNER radius 30.0 30.0
                    then
                        00AD: set_car $PARTNERS_CAR max_speed_to 50.0
                    else
                        if
                            00E9:   player $PLAYER 0 near_actor $RAYS_PARTNER radius 80.0 80.0
                        then
                            00AD: set_car $PARTNERS_CAR max_speed_to 40.0
                        else
                            00AD: set_car $PARTNERS_CAR max_speed_to 30.0
                        end
                    end
                end
                if
                    01C1:   car $PARTNERS_CAR stopped
                then
                    if
                        0038:   $TIMER_RESET_FLAG_R4 == 0
                    then
                        0006: 16@ = 0
                        0004: $TIMER_RESET_FLAG_R4 = 1
                    end
                    if and
                        0019:   16@ > 8000
                        0038:   $TIMER_RESET_FLAG_R4 == 1
                    then
                        if
                            00E9:   player $PLAYER 0 near_actor $RAYS_PARTNER radius 120.0 120.0
                        then
                            01D3: actor $RAYS_PARTNER leave_car $PARTNERS_CAR
                            0004: $TIMER_RESET_FLAG_R4 = 0
                        else
                            if
                                82CA:   NOT   car $PARTNERS_CAR is_on_screen
                            then
                                00AA: store_car $PARTNERS_CAR position_to $PARTNER_X $PARTNER_Y $PARTNER_Z
                                03D3: point $PARTNER_X $PARTNER_Y $PARTNER_Z get_nearby_vector $PARTNER_X $PARTNER_Y $PARTNER_Z $DISTANCE_BETWEEN_BOATS
                                if
                                    80C2:   NOT   sphere_onscreen $PARTNER_X $PARTNER_Y $PARTNER_Z 4.0
                                then
                                    00AB: put_car $PARTNERS_CAR at $PARTNER_X $PARTNER_Y $PARTNER_Z
                                    0175: set_car $PARTNERS_CAR z_angle_to $DISTANCE_BETWEEN_BOATS
                                    0004: $TIMER_RESET_FLAG_R4 = 0
                                end
                            end
                        end
                    end
                end
                if and
                    01F4:   car $PARTNERS_CAR flipped
                    01C1:   car $PARTNERS_CAR stopped
                then
                    if
                        00E9:   player $PLAYER 0 near_actor $RAYS_PARTNER radius 120.0 120.0
                    then
                        01D3: actor $RAYS_PARTNER leave_car $PARTNERS_CAR
                        03ED: set_upsidedown_car_not_damaged $PARTNERS_CAR 0
                    else
                        if
                           82CA:   NOT   car $PARTNERS_CAR is_on_screen
                        then
                            00AA: store_car $PARTNERS_CAR position_to $PARTNER_X $PARTNER_Y $PARTNER_Z
                            03D3: point $PARTNER_X $PARTNER_Y $PARTNER_Z get_nearby_vector $PARTNER_X $PARTNER_Y $PARTNER_Z $DISTANCE_BETWEEN_BOATS
                            if
                                80C2:   NOT   sphere_onscreen $PARTNER_X $PARTNER_Y $PARTNER_Z 4.0
                            then
                                00AB: put_car $PARTNERS_CAR at $PARTNER_X $PARTNER_Y $PARTNER_Z
                                0175: set_car $PARTNERS_CAR z_angle_to $DISTANCE_BETWEEN_BOATS
                            end
                        end
                    end
                end
                if
                    01AF:   car $PARTNERS_CAR 0 near_point $PARTNER_STUCK_X $PARTNER_STUCK_Y $PARTNER_STUCK_Z radius 4.0 4.0 4.0
                then
                    if
                        0038:   $TIMERC_RESET_FLAG_R4 == 0
                    then
                        01BD: $TIMERC_STARTED_R4 = current_time_in_ms
                        0004: $TIMERC_RESET_FLAG_R4 = 1
                    end
                    if
                        0038:   $TIMERC_RESET_FLAG_R4 == 1
                    then
                        01BD: $TIMERC_CURRENT_R4 = current_time_in_ms
                        0084: $TIMERC_R4 = $TIMERC_CURRENT_R4
                        0060: $TIMERC_R4 -= $TIMERC_STARTED_R4
                        if
                            0018:   $TIMERC_R4 > 8000
                        then
                            if
                                00E9:   player $PLAYER 0 near_actor $RAYS_PARTNER radius 120.0 120.0
                            then
                                01D3: actor $RAYS_PARTNER leave_car $PARTNERS_CAR
                                0004: $TIMERC_RESET_FLAG_R4 = 0
                            else
                                00AA: store_car $PARTNERS_CAR position_to $PARTNER_X $PARTNER_Y $PARTNER_Z
                                03D3: point $PARTNER_X $PARTNER_Y $PARTNER_Z get_nearby_vector $PARTNER_X $PARTNER_Y $PARTNER_Z $DISTANCE_BETWEEN_BOATS
                                if
                                    838A:   NOT   car_in_cube $PARTNER_X $PARTNER_Y $PARTNER_Z 4.0 4.0 4.0
                                then
                                    if
                                        80C2:   NOT   sphere_onscreen $PARTNER_X $PARTNER_Y $PARTNER_Z 4.0
                                    then
                                        00AB: put_car $PARTNERS_CAR at $PARTNER_X $PARTNER_Y $PARTNER_Z
                                        0175: set_car $PARTNERS_CAR z_angle_to $DISTANCE_BETWEEN_BOATS
                                        0004: $TIMERC_RESET_FLAG_R4 = 0
                                    end
                                end
                            end
                        end
                    end
                end
                if
                    81AF:   NOT   car $PARTNERS_CAR 0 near_point $PARTNER_STUCK_X $PARTNER_STUCK_Y $PARTNER_STUCK_Z radius 4.0 4.0 4.0
                then
                    00AA: store_car $PARTNERS_CAR position_to $PARTNER_STUCK_X $PARTNER_STUCK_Y $PARTNER_STUCK_Z
                    0004: $TIMERC_RESET_FLAG_R4 = 0
                end
                if
                    8185:   NOT   car $PARTNERS_CAR health >= 400
                then
                    01D3: actor $RAYS_PARTNER leave_car $PARTNERS_CAR
                end
            end
        end
    end
end //while

:MISSION_RAY4_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // // MISSION FAILED!
return

:MISSION_RAY4_PASSED
0004: $GONE_FISHING_COMPLETED = 1
01E3: text_1number_styled 'M_PASS' 15000 2000 ms 1   // // MISSION PASSED! $~1~
0109: player $PLAYER money += 15000
0110: clear_player $PLAYER wanted_level
0318: set_latest_mission_passed 'RM4'   // // 'GONE FISHING'
0394: play_music 1
030C: set_mission_points += 1
004F: create_thread @RAY_MISSION5_LOOP
return

:MISSION_CLEANUP_RAY4
0164: remove_blip $PARTNERS_BLIP
0164: remove_blip $PLAYERS_BOAT_WITH_GUNS_BLIP
0151: remove_status_text $PARTNERS_BOAT_HEALTH
0249: mark_model_as_no_longer_needed #PREDATOR
0249: mark_model_as_no_longer_needed #GHOST
0249: mark_model_as_no_longer_needed #SENTINEL
0249: mark_model_as_no_longer_needed #RCBANDIT
0249: mark_model_as_no_longer_needed #GRENADE
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_RAY = 0
mission_cleanup
return

//######################################################################
//######################       GOSUBS       ############################
//######################################################################

:OBJECT_PLACEMENT
if
    8119:   NOT   car $PARTNERS_BOAT wrecked
then
    035C: place_object $BARREL2_A relative_to_car $PARTNERS_BOAT offset -0.5 -3.75 1.0625
    035C: place_object $BARREL2_B relative_to_car $PARTNERS_BOAT offset 0.5 -3.75 1.0625
end
return

:DROP_MINES
01BD: $MINE_CURRENT_TIMER = current_time_in_ms
0084: $TEMPORARY_TIME_MINE = $MINE_CURRENT_TIMER
0060: $TEMPORARY_TIME_MINE -= $LAST_MINE_DROPPED_TIMER
if
    0018:   $TEMPORARY_TIME_MINE > 2000
then
    0209: $RANDOM_INT = random_int 0 4
    01BD: $LAST_MINE_DROPPED_TIMER = current_time_in_ms
    if
        0038:   $RANDOM_INT == 2
    then
        02E3: $PARTNERS_BOAT_SPEED = car $PARTNERS_BOAT speed
        0054: store_player $PLAYER position_to $PLAYER_X $PLAYER_Y $PLAYER_Z
        00AA: store_car $PARTNERS_BOAT position_to $PARTNER_X $PARTNER_Y $PARTNER_Z
        if
            80E9:   NOT   player $PLAYER 0 near_actor $RAYS_PARTNER radius 5.0 5.0
        then
            if
                0020:   $PARTNERS_BOAT_SPEED > 12.0
            then
                0086: $VECTOR_X = $PARTNER_X
                0061: $VECTOR_X -= $PLAYER_X
                0086: $VECTOR_Y = $PARTNER_Y
                0061: $VECTOR_Y -= $PLAYER_Y
                0086: $TEMP_VECTOR_X = $VECTOR_X
                0069: $TEMP_VECTOR_X *= $VECTOR_X
                0086: $TEMP_VECTOR_Y = $VECTOR_Y
                0069: $TEMP_VECTOR_Y *= $VECTOR_Y
                0086: $TEMP_DISTANCE = $TEMP_VECTOR_X
                0059: $TEMP_DISTANCE += $TEMP_VECTOR_Y
                01FB: $DISTANCE_BETWEEN_BOATS = square_root $TEMP_DISTANCE
                if
                    0022:   60.0 > $DISTANCE_BETWEEN_BOATS
                then
                    02F8: store_car $PARTNERS_BOAT cosine_to $PARTNERS_BOAT_FORWARD_X
                    02F9: store_car $PARTNERS_BOAT sinus_to $PARTNERS_BOAT_FORWARD_Y
                    0071: $VECTOR_X /= $DISTANCE_BETWEEN_BOATS
                    0071: $VECTOR_Y /= $DISTANCE_BETWEEN_BOATS
                    0086: $TEMP_DOT_PRODUCT_X = $VECTOR_X
                    0069: $TEMP_DOT_PRODUCT_X *= $PARTNERS_BOAT_FORWARD_X
                    0086: $TEMP_DOT_PRODUCT_Y = $VECTOR_Y
                    0069: $TEMP_DOT_PRODUCT_Y *= $PARTNERS_BOAT_FORWARD_Y
                    0086: $DOT_PRODUCT = $TEMP_DOT_PRODUCT_X
                    0059: $DOT_PRODUCT += $TEMP_DOT_PRODUCT_Y
                    if
                        0020:   $DOT_PRODUCT > -0.5
                    then
                        02F1: create_gta3_exploding_barrel2_at  $PARTNER_X $PARTNER_Y $PARTNER_Z
                        0086: $TEMP_X = $PARTNER_X
                        0086: $TEMP_Y = $PARTNER_Y
                    end
                end
            end
        end
    end
end
return

:EXIT_BOAT
if
    0038:   $EXIT_BOAT_FLAG == 0
then
    02D4: boat_stop $PARTNERS_BOAT engine
    00AA: store_car $PARTNERS_BOAT position_to $PARTNER_X $PARTNER_Y $PARTNER_Z
    02F8: store_car $PARTNERS_BOAT cosine_to $PARTNERS_BOAT_FORWARD_X
    02F9: store_car $PARTNERS_BOAT sinus_to $PARTNERS_BOAT_FORWARD_Y
    0005: $TEMP_DOT_PRODUCT_X = 3.0
    0069: $TEMP_DOT_PRODUCT_X *= $PARTNERS_BOAT_FORWARD_Y
    0005: $TEMP_DOT_PRODUCT_Y = -3.0
    0069: $TEMP_DOT_PRODUCT_Y *= $PARTNERS_BOAT_FORWARD_X
    0005: $TEMP_X = 0.25
    0069: $TEMP_X *= $PARTNERS_BOAT_FORWARD_X
    0005: $TEMP_Y = 0.25
    0069: $TEMP_Y *= $PARTNERS_BOAT_FORWARD_Y
    0086: $VECTOR_X = $TEMP_DOT_PRODUCT_X
    0061: $VECTOR_X -= $TEMP_X
    0086: $VECTOR_Y = $TEMP_DOT_PRODUCT_Y
    0061: $VECTOR_Y -= $TEMP_Y
    0059: $VECTOR_X += $PARTNER_X
    0059: $VECTOR_Y += $PARTNER_Y
    0005: $TEMP_DOT_PRODUCT_X = -3.0
    0069: $TEMP_DOT_PRODUCT_X *= $PARTNERS_BOAT_FORWARD_Y
    0005: $TEMP_DOT_PRODUCT_Y = 3.0
    0069: $TEMP_DOT_PRODUCT_Y *= $PARTNERS_BOAT_FORWARD_X
    0005: $TEMP_X = 0.25
    0069: $TEMP_X *= $PARTNERS_BOAT_FORWARD_X
    0005: $TEMP_Y = 0.25
    0069: $TEMP_Y *= $PARTNERS_BOAT_FORWARD_Y
    0086: $TEMP_VECTOR_X = $TEMP_DOT_PRODUCT_X
    0061: $TEMP_VECTOR_X -= $TEMP_X
    0086: $TEMP_VECTOR_Y = $TEMP_DOT_PRODUCT_Y
    0061: $TEMP_VECTOR_Y -= $TEMP_Y
    0059: $TEMP_VECTOR_X += $PARTNER_X
    0059: $TEMP_VECTOR_Y += $PARTNER_Y
    0054: store_player $PLAYER position_to $SNIPER_OBJECT_A_X $SNIPER_OBJECT_A_Y $DOT_PRODUCT
    0086: $PARTNER_X = $SNIPER_OBJECT_A_X
    0061: $PARTNER_X -= $VECTOR_X
    0086: $PARTNER_Y = $SNIPER_OBJECT_A_Y
    0061: $PARTNER_Y -= $VECTOR_Y
    0069: $PARTNER_X *= $PARTNER_X
    0069: $PARTNER_Y *= $PARTNER_Y
    0086: $DOT_PRODUCT = $PARTNER_X
    0059: $DOT_PRODUCT += $PARTNER_Y
    01FB: $DISTANCE_RESULTA = square_root $DOT_PRODUCT
    0086: $PARTNER_X = $SNIPER_OBJECT_A_X
    0061: $PARTNER_X -= $TEMP_VECTOR_X
    0086: $PARTNER_Y = $SNIPER_OBJECT_A_Y
    0061: $PARTNER_Y -= $TEMP_VECTOR_Y
    0069: $PARTNER_X *= $PARTNER_X
    0069: $PARTNER_Y *= $PARTNER_Y
    0086: $DOT_PRODUCT = $PARTNER_X
    0059: $DOT_PRODUCT += $PARTNER_Y
    01FB: $DISTANCE_RESULTB = square_root $DOT_PRODUCT
    if
        0024:   $DISTANCE_RESULTB > $DISTANCE_RESULTA
    then
        02CE: $DOT_PRODUCT = ground_z $VECTOR_X $VECTOR_Y $PARTNER_Z
        0086: $TEMP_X = $PARTNER_Z
        0009: $TEMP_X += 15.0
        02CE: $TEMP_X = ground_z $VECTOR_X $VECTOR_Y $TEMP_X
        if
            0024:   $TEMP_X > $DOT_PRODUCT
        then
            0086: $DOT_PRODUCT = $TEMP_X
            0009: $DOT_PRODUCT += 1.0
        end
        if
            8042:   NOT   $DOT_PRODUCT == 0.0
        then
            0362: remove_actor $RAYS_PARTNER from_car_and_place_at $VECTOR_X $VECTOR_Y $PARTNER_Z
            0173: set_actor $RAYS_PARTNER z_angle_to 90.0
        else
            0362: remove_actor $RAYS_PARTNER from_car_and_place_at $TEMP_VECTOR_X $TEMP_VECTOR_Y $PARTNER_Z
            0173: set_actor $RAYS_PARTNER z_angle_to 90.0
        end
    else
        02CE: $DOT_PRODUCT = ground_z $TEMP_VECTOR_X $TEMP_VECTOR_Y $PARTNER_Z
        if
            8042:   NOT   $DOT_PRODUCT == 0.0
        then
            0362: remove_actor $RAYS_PARTNER from_car_and_place_at $TEMP_VECTOR_X $TEMP_VECTOR_Y $PARTNER_Z
            0173: set_actor $RAYS_PARTNER z_angle_to 90.0
        else
            0362: remove_actor $RAYS_PARTNER from_car_and_place_at $VECTOR_X $VECTOR_Y $PARTNER_Z
            0173: set_actor $RAYS_PARTNER z_angle_to 90.0
        end
    end
    01B2: give_actor $RAYS_PARTNER weapon 27 ammo 9999  // ak47
    0319: set_actor $RAYS_PARTNER running 1
    0151: remove_status_text $PARTNERS_BOAT_HEALTH
    0004: $EXIT_BOAT_FLAG = 1

end
return

:BOAT_HEALTH_COUNTER
0227: $PARTNERS_BOAT_HEALTH = car $PARTNERS_BOAT health
000C: $PARTNERS_BOAT_HEALTH -= 250
0010: $PARTNERS_BOAT_HEALTH *= 100
0014: $PARTNERS_BOAT_HEALTH /= 750
0084: $PARTNERS_BOAT_HEALTH2 = $PARTNERS_BOAT_HEALTH
0004: $PARTNERS_BOAT_HEALTH = 100
0060: $PARTNERS_BOAT_HEALTH -= $PARTNERS_BOAT_HEALTH2
return

:STEAL_A_CAR
if
    00E9:   player $PLAYER 0 near_actor $RAYS_PARTNER radius 100.0 100.0
then
    0377: set_actor $RAYS_PARTNER objective_to-32
else
    03D3: point 974.88 -695.25 21.375 get_nearby_vector $PARTNER_X $PARTNER_Y $PARTNER_Z $DOT_PRODUCT
    01C3: remove_references_to_car $PARTNERS_CAR  // Like turning a car into any random car
    00A5: $PARTNERS_CAR = create_car #SENTINEL at $PARTNER_X $PARTNER_Y $PARTNER_Z
    0175: set_car $PARTNERS_CAR z_angle_to $DOT_PRODUCT
    01D5: actor $RAYS_PARTNER go_to_and_drive_car $PARTNERS_CAR
end
return

:SELECT_BOAT_NODE
if
    0038:   $BOAT_NODE_COUNTER == 1
then
    if
        001A:   50 > $PARTNERS_BOAT_HEALTH
    then
        0086: $BOAT_NODE_X = $NODE_11_X
        0086: $BOAT_NODE_Y = $NODE_11_Y
        0004: $BOAT_NODE_COUNTER = 11
    else
        0086: $BOAT_NODE_X = $NODE_2_X
        0086: $BOAT_NODE_Y = $NODE_2_Y
        0004: $BOAT_NODE_COUNTER = 2
    end
    return
end
if
    0038:   $BOAT_NODE_COUNTER == 2
then
    0086: $BOAT_NODE_X = $NODE_3_X
    0086: $BOAT_NODE_Y = $NODE_3_Y
    0004: $BOAT_NODE_COUNTER = 3
    return
end
if
    0038:   $BOAT_NODE_COUNTER == 3
then
    if
        001A:   50 > $PARTNERS_BOAT_HEALTH
    then
        0086: $BOAT_NODE_X = $NODE_4_X
        0086: $BOAT_NODE_Y = $NODE_4_Y
        0004: $BOAT_NODE_COUNTER = 4
    else
        0086: $BOAT_NODE_X = $NODE_0_X
        0086: $BOAT_NODE_Y = $NODE_0_Y
        0004: $BOAT_NODE_COUNTER = 0
        02DB: set_boat $PARTNERS_BOAT speed_to 35.0
        0004: $BOAT_SPEED_FLAG = -100
    end
    return
end
if
    0038:   $BOAT_NODE_COUNTER == 4
then
    0086: $BOAT_NODE_X = $NODE_5_X
    0086: $BOAT_NODE_Y = $NODE_5_Y
    0004: $BOAT_NODE_COUNTER = 5
    return
end
if
    0038:   $BOAT_NODE_COUNTER == 5
then
    0086: $BOAT_NODE_X = $NODE_6_X
    0086: $BOAT_NODE_Y = $NODE_6_Y
    0004: $BOAT_NODE_COUNTER = 6
    return
end
if
    0038:   $BOAT_NODE_COUNTER == 6
then
    0086: $BOAT_NODE_X = $NODE_7_X
    0086: $BOAT_NODE_Y = $NODE_7_Y
    0004: $BOAT_NODE_COUNTER = 7
    return
end
if
    0038:   $BOAT_NODE_COUNTER == 7
then
    if
        001A:   50 > $PARTNERS_BOAT_HEALTH
    then
        0086: $BOAT_NODE_X = $NODE_8_X
        0086: $BOAT_NODE_Y = $NODE_8_Y
        0004: $BOAT_NODE_COUNTER = 8
    else
        0086: $BOAT_NODE_X = $NODE_3_X
        0086: $BOAT_NODE_Y = $NODE_3_Y
        0004: $BOAT_NODE_COUNTER = 3
    end
    return
end
if
    0038:   $BOAT_NODE_COUNTER == 8
then
    if
        001A:   50 > $PARTNERS_BOAT_HEALTH
    then
        0086: $BOAT_NODE_X = $NODE_1_X
        0086: $BOAT_NODE_Y = $NODE_1_Y
        0004: $BOAT_NODE_COUNTER = 1
    else
        0086: $BOAT_NODE_X = $NODE_3_X
        0086: $BOAT_NODE_Y = $NODE_3_Y
        0004: $BOAT_NODE_COUNTER = 3
    end
    return
end
if
    0038:   $BOAT_NODE_COUNTER == 9
then
    if
        001A:   50 > $PARTNERS_BOAT_HEALTH
    then
        0086: $BOAT_NODE_X = $NODE_2_X
        0086: $BOAT_NODE_Y = $NODE_2_Y
        0004: $BOAT_NODE_COUNTER = 2
    else
        0086: $BOAT_NODE_X = $NODE_8_X
        0086: $BOAT_NODE_Y = $NODE_8_Y
        0004: $BOAT_NODE_COUNTER = 8
    end
    return
end
if
    0038:   $BOAT_NODE_COUNTER == 10
then
    0086: $BOAT_NODE_X = $NODE_9_X
    0086: $BOAT_NODE_Y = $NODE_9_Y
    0004: $BOAT_NODE_COUNTER = 9
    return
end
if
    0038:   $BOAT_NODE_COUNTER == 11
then
    0086: $BOAT_NODE_X = $NODE_10_X
    0086: $BOAT_NODE_Y = $NODE_10_Y
    0004: $BOAT_NODE_COUNTER = 10
    return
end
return

:PARTNER_ESCAPE_CHECKS
if and
    80E9:   NOT   player $PLAYER 0 near_actor $RAYS_PARTNER radius 160.0 160.0
    82CB:   NOT   actor $RAYS_PARTNER is_on_screen
then
    if
        0038:   $GOTAWAY_TIMER_RESET_FLAG == 0
    then
        0164: remove_blip $PARTNERS_BLIP
        01BD: $GOTAWAY_TIMER_STARTED = current_time_in_ms
        0004: $GOTAWAY_TIMER_RESET_FLAG = 1
    end
    if
        0038:   $GOTAWAY_TIMER_RESET_FLAG == 1
    then
        01BD: $GOTAWAY_TIMER_CURRENT = current_time_in_ms
        0084: $GOTAWAY_TIMER = $GOTAWAY_TIMER_CURRENT
        0060: $GOTAWAY_TIMER -= $GOTAWAY_TIMER_STARTED
        if
            0018:   $GOTAWAY_TIMER > 8000
        then
            if
                82CB:   NOT   actor $RAYS_PARTNER is_on_screen
            then
                0004: $GOTAWAY_TIMER_RESET_FLAG = 0
                009B: destroy_actor_instantly $RAYS_PARTNER
                00BC: print_now 'RM4_3' 5000 ms 1   // // ~r~Ray's partner has escaped!
                0004: $GOTO_MISSION_RAY4_FAILED = 1
            end
        end
    end
end
if
    0038:   $GOTAWAY_TIMER_RESET_FLAG == 1
then
    if or
        00E9:   player $PLAYER 0 near_actor $RAYS_PARTNER radius 160.0 160.0
        02CB:   actor $RAYS_PARTNER is_on_screen
    then
        0164: remove_blip $PARTNERS_BLIP
        0187: $PARTNERS_BLIP = create_marker_above_actor $RAYS_PARTNER
        0004: $GOTAWAY_TIMER_RESET_FLAG = 0
    end
end
return
