//-------------Mission 6-------------
// Originally: Radio car mission 'CASINO CALAMITY'

:M06_CASINOCALAMITY
03A4: name_thread 'RC3'
gosub @MISSION_START_RC4
if
    wasted_or_busted
then
    gosub @MISSION_RC4_FAILED
end
gosub @MISSION_CLEANUP_RC4
end_thread

:MISSION_START_RC4
$FLAG_PLAYER_ON_MISSION = 1
if
    $CASINO_CALAMITY_COMPLETED == 0
then
    increment_mission_attempts
end
wait 0 ms
$RC_BUGGY_KILLS = 0
$FLAG_BUGGY_HELP1_HM2 = 0
$CONTROLMODE = 0
$RC_REWARD = 0
$RC_MISSION_CAMERA_X = 35.0
$RC_MISSION_CAMERA_Y = -1316.0
$RC_MISSION_CAMERA_Z = 35.0
$RC_MISSION_BUGGY_X = 38.0
$RC_MISSION_BUGGY_Y = -1317.0
$RC_MISSION_BUGGY_Z = 32.5
$COUNTDOWN_TIME1 = 120000
0297: reset_num_of_models_killed_by_player
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
01B4: set_player $PLAYER can_move 0 (frozen)
01C0: $WANTED_4X4 = player $PLAYER wanted_level
0110: clear_player $PLAYER wanted_level
00DA: $PLAYER_CAR = player $PLAYER car
02A3: toggle_widescreen 1 (on)
0152: set_zone_car_info 'YAKUSA' 1 (day)  20 0 0 0 200 0 0 0 0 0 40
0152: set_zone_car_info 'YAKUSA' 0 (night)  17 0 0 0 250 0 0 0 0 0 20
015F: set_camera_position $RC_MISSION_CAMERA_X $RC_MISSION_CAMERA_Y $RC_MISSION_CAMERA_Z 0.0 0.0 0.0
if
    8119:   NOT   car $PLAYER_CAR wrecked
then
    020A: set_car $PLAYER_CAR door_status_to 2
    0158: camera_on_vehicle $PLAYER_CAR 15 2
    0395: clear_area 1 at $RC_MISSION_BUGGY_X $RC_MISSION_BUGGY_Y $RC_MISSION_BUGGY_Z range 5.0
end
00BC: print_now 'RC_3' 4000 ms 1   // You have 2 minutes to blow up as many Yakuza Gang Cars as possible! Cars as possible!
0247: request_model #RCBANDIT
0247: request_model #YAKUZA
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #RCBANDIT available
        8248:   NOT   model #YAKUZA available
    jf break
    wait 0 ms
end
03C4: set_status_text_to $RC_BUGGY_KILLS 0 (number)  'KILLS'   // KILLS:
014E: set_timer_to $COUNTDOWN_TIME1 type 1
01BD: $TIMER_INTRO_START = current_time_in_ms
while 801A:   NOT   1 > $COUNTDOWN_TIME1
    wait 0 ms
    01BD: $TIMER_INTRO_NOW = current_time_in_ms
    0084: $INTRO_TIME_LAPSED = $TIMER_INTRO_NOW
    0060: $INTRO_TIME_LAPSED -= $TIMER_INTRO_START
    if
        0119:   car $PLAYER_CAR wrecked
    then
        00BC: print_now 'WRECKED' 3000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_RC4_FAILED
    end
    if
        0256:   player $PLAYER defined
    then
        0110: clear_player $PLAYER wanted_level
        if and
            $INTRO_TIME_LAPSED > 4000
            $FLAG_BUGGY_HELP1_HM2 == 0
        then
            // Code optimized and made compatible with GInput
            0293: $CONTROLMODE = current_controls
            if
                $CONTROLMODE == 2
            then
				// Text altered for GInput
                03E5: text_box 'RCHELPA'   // Press the  ~c~  button, or drive the RC car into vehicle's wheels to detonate.
			else
				if
					$CONTROLMODE == 4
				then
					// New text for GInput
					03E5: text_box 'RCHELPB'   // Press the  ~i~  button, or drive the RC car into vehicle's wheels to detonate.
				else
					03E5: text_box 'RCHELP'   // Press the ~h~~k~~PED_FIREWEAPON~ button~w~, or drive the RC car into vehicle's wheels to detonate.
				end
            end
			$FLAG_BUGGY_HELP1_HM2 = 1
            02A3: toggle_widescreen 0 (off)
            01B4: set_player $PLAYER can_move 1 (unfrozen)
            015A: restore_camera
        end
        if
            8442:   NOT   player $PLAYER in_car $PLAYER_CAR
        then
            jump @MISSION_RC4_FAILED
        end
    else
        jump @MISSION_RC4_FAILED
    end
    0298: $RC_BUGGY_KILLS = rampage_kills #YAKUZA
    if
        $INTRO_TIME_LAPSED > 4000
    then
        if
            8241:   NOT   player $PLAYER in_remote_mode
        then
            010C: change_player_into_rc_buggy $PLAYER at $RC_MISSION_BUGGY_X $RC_MISSION_BUGGY_Y $RC_MISSION_BUGGY_Z 60.0
        end
    end
end
014F: stop_timer $COUNTDOWN_TIME1
0151: remove_status_text $RC_BUGGY_KILLS
0409: blow_up_rc_buggy
0006: 16@ = 0
while 1500 > 16@
    wait 0 ms
end
if
    001C:   $RC_BUGGY_KILLS > $REC_RC4
then
    0084: $RC_REWARD = $RC_BUGGY_KILLS
    0060: $RC_REWARD -= $REC_RC4
    0010: $RC_REWARD *= 1000
    0084: $REC_RC4 = $RC_BUGGY_KILLS
    jump @MISSION_RC4_PASSED
end

:MISSION_RC4_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // MISSION FAILED!
00BC: print_now 'NRECORD' 5000 ms 1   // ~r~NO NEW RECORD!
return

:MISSION_RC4_PASSED
01E3: text_1number_styled 'M_PASS' $RC_REWARD 5000 ms 1   // MISSION PASSED! $~1~
00BC: print_now 'RECORD' 3000 ms 1   //  ~g~NEW RECORD!!
0394: play_music 1
0109: player $PLAYER money += $RC_REWARD
if
    $CASINO_CALAMITY_COMPLETED == 0
then
    030C: set_mission_points += 1
    $CASINO_CALAMITY_COMPLETED = 1
    0318: set_latest_mission_passed 'RC3'   // 'CASINO CALAMITY'
end
042F: register_highest_int_stat 3 to $REC_RC4
return

:MISSION_CLEANUP_RC4
$FLAG_PLAYER_ON_MISSION = 0
$FLAG_JUST_DONE_RC_MISSION = 1
03CB: set_camera $RC_MISSION_CAMERA_X $RC_MISSION_CAMERA_Y $RC_MISSION_CAMERA_Z
0249: mark_model_as_no_longer_needed #YAKUZA
0249: mark_model_as_no_longer_needed #RCBANDIT
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
01B4: set_player $PLAYER can_move 1 (unfrozen)
015A: restore_camera
02A3: toggle_widescreen 0 (off)
010D: set_player $PLAYER wanted_level_to $WANTED_4X4
014F: stop_timer $COUNTDOWN_TIME1
0151: remove_status_text $RC_BUGGY_KILLS
0409: blow_up_rc_buggy
if
    8119:   NOT   car $PLAYER_CAR wrecked
then
    020A: set_car $PLAYER_CAR door_status_to 1
end
0152: set_zone_car_info 'YAKUSA' 1 (day)  20 0 0 0 100 0 0 0 0 0 40
0152: set_zone_car_info 'YAKUSA' 0 (night)  17 0 0 0 150 0 0 0 0 0 20
mission_cleanup
return
