//-------------Mission 34-------------
// Originally: Toni mission 5 'BLOW FISH'

:M34_BLOWFISH
03A4: name_thread 'TONI5'
054C: use GXT table 'TONI5'
058E: set_restart_mission_taxi_destination 864.4 -320.6 30.57 0.0
gosub @MISSION_START_TONI5
if
    wasted_or_busted
then
    gosub @MISSION_TONI5_FAILED
end
gosub @MISSION_CLEANUP_TONI5
end_thread

:MISSION_START_TONI5
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_TONI = 1
wait 0 ms
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'TONY'
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'TONYH'
0247: request_model #IND_NEWRIZZOS
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #IND_NEWRIZZOS available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'T5_BF'
0244: set_cutscene_pos 883.38 -314.5 34.875
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_TONY = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_TONY 'TONY'
//02F4: create_cutscene_actor $TONY_CSHEAD from_head #CUTOBJ02 and_body $CUTSCENE_TONY
//02F5: set_head_anim $TONY_CSHEAD 'TONY'
//02F4: create_cutscene_actor $PLAYER_CSHEAD from_head #CUTOBJ01 and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
0395: clear_area 1 at 884.5 -321.062 33.5 range 1.0
0055: set_player_coordinates $PLAYER at 884.5 -321.062 32.375
0171: set_player $PLAYER z_angle_to 180.0
0395: clear_area 1 at 881.0601 -313.0 35.875 range 10.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   1350 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM5_B' 10000 ms 1   // // ~w~OK I've had enough of this shit.
while 001A:   3169 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM5_C' 10000 ms 1   // // ~w~We're gonna finish the Triads in Liberty once and for all!
while 001A:   5730 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM5_D' 10000 ms 1   // // 8-Ball's rigged a dustcart with a bomb.
while 001A:   7755 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM5_E' 10000 ms 1   // // ~w~It's on a timer so if you mess up there'll be no evidence. Go and pick up the dustcart.
while 001A:   12490 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM5_F' 10000 ms 1   // // ~w~Careful 8-Ball says it's real sensitive and the slightest bump could set that thing off!
while 001A:   17220 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM5_G' 10000 ms 1   // // ~w~Their fish factory will open its gates for a dustcart so you can drive right in.
while 001A:   21330 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM5_H' 10000 ms 1   // // ~w~Park up between the gas canisters and get the hell out of there!
while 001A:   24141 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM5_I' 10000 ms 1   // // ~w~I want it to rain mackerel.
while 001A:   25817 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM5_J' 10000 ms 1   // // ~w~We're talking real biblical here nothing low budget.
while 001A:   28632 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BE: text_clear_all
while 001A:   30000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
03AD: set_rubbish 1 (visible)
02EA: clear_cutscene
03C8: set_camera_in_front_of_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #IND_NEWRIZZOS
0247: request_model #TRASH
while 8248:   NOT   model #TRASH available
    wait 0 ms
end
0004: $TRIADS_SPOT_YOU = 0
0004: $CLEAR_TRIADS_THREATS = 0
00A5: $EXPLOSIVE_TRUCK = create_car #TRASH at 979.0 -106.0 -100.0
02AC: set_car $EXPLOSIVE_TRUCK immunities 1 1 0 0 1
0242: set_car $EXPLOSIVE_TRUCK bomb_status_to 1
0004: $FISH_FACTORY_DESTROYED = 0
0186: $TONI5_GARBAGE_TRUCK_MARKER = create_marker_above_car $EXPLOSIVE_TRUCK
while 80DC:   NOT   player $PLAYER driving $EXPLOSIVE_TRUCK
    wait 0 ms
    if
        0119:   car $EXPLOSIVE_TRUCK wrecked
    then
        jump @MISSION_TONI5_FAILED
    end
    gosub @TRIAD_AI
    if and
        8185:   NOT   car $EXPLOSIVE_TRUCK health >= 860
        80B1:   NOT   car $EXPLOSIVE_TRUCK 0 in_cube 626.0 -1112.5 18.5 634.5 -1122.75 21.0
    then
        020B: explode_car $EXPLOSIVE_TRUCK
        jump @MISSION_TONI5_FAILED
    end
end
0004: $TONI5_TIMER = 151000
014E: set_timer_to $TONI5_TIMER type 1
0227: $EXPLOSIVE_TRUCK_HEALTH = car $EXPLOSIVE_TRUCK health
03C4: set_status_text_to $EXPLOSIVE_TRUCK_HEALTH 1 (bar)  'DAM'   // // Damage
0004: $EXPLOSIVE_TRUCK_HEALTH2 = 1000
0060: $EXPLOSIVE_TRUCK_HEALTH2 -= $EXPLOSIVE_TRUCK_HEALTH
if
    0018:   $EXPLOSIVE_TRUCK_HEALTH2 > 100
then
    0004: $EXPLOSIVE_TRUCK_HEALTH2 = 100
end
0084: $EXPLOSIVE_TRUCK_HEALTH = $EXPLOSIVE_TRUCK_HEALTH2
0004: $FLAG_CAR_BLIP_DISPLAYED_TM5 = 1
0004: $BLOB_FLAG = 1

:TONI5_WAIT_FOR_VAN
wait 0 ms
if
    0119:   car $EXPLOSIVE_TRUCK wrecked
then
    jump @MISSION_TONI5_FAILED
end
while 81AC:   NOT   car $EXPLOSIVE_TRUCK stopped $BLOB_FLAG in_cube 626.0 -1112.5 18.5 634.5 -1122.75 21.0  // never used in VC
    wait 0 ms
    if
        0119:   car $EXPLOSIVE_TRUCK wrecked
    then
        039D: scatter_particles 17 4.0 0 0 0 4000 at $TONI5_GARBAGE_TRUCK_X $TONI5_GARBAGE_TRUCK_Y $TONI5_GARBAGE_TRUCK_Z 0.0 0.0 0.0
        jump @MISSION_TONI5_FAILED
    end
    gosub @TRIAD_AI
    gosub @TRUCK_HEALTH
    00AA: store_car $EXPLOSIVE_TRUCK position_to $TONI5_GARBAGE_TRUCK_X $TONI5_GARBAGE_TRUCK_Y $TONI5_GARBAGE_TRUCK_Z
    if
        00DC:   player $PLAYER driving $EXPLOSIVE_TRUCK
    then
        if
            0038:   $FLAG_CAR_BLIP_DISPLAYED_TM5 == 1
        then
            018A: $BLIP2_TM5 = create_checkpoint_at 630.0 -1117.0 -100.0
            0004: $BLOB_FLAG = 1
            0164: remove_blip $TONI5_GARBAGE_TRUCK_MARKER
            0004: $FLAG_CAR_BLIP_DISPLAYED_TM5 = 0
        end
    end
    if
        80DC:   not player $PLAYER driving $EXPLOSIVE_TRUCK
    then
        if
            0038:   $FLAG_CAR_BLIP_DISPLAYED_TM5 == 0
        then
            0186: $TONI5_GARBAGE_TRUCK_MARKER = create_marker_above_car $EXPLOSIVE_TRUCK
            0004: $BLOB_FLAG = 0
            0164: remove_blip $BLIP2_TM5
            00BC: print_now 'IN_VEH' 5000 ms 1  // ~g~Hey! Get back in the vehicle!
            0004: $FLAG_CAR_BLIP_DISPLAYED_TM5 = 1
        end
    end
    if and
        8185:   not car $EXPLOSIVE_TRUCK health >= 900
        80B1:   not car $EXPLOSIVE_TRUCK 0 in_cube 626.0 -1112.5 18.5 634.5 -1122.75 21.0
    then
        020B: explode_car $EXPLOSIVE_TRUCK
        039D: scatter_particles 17 4.0 0 0 0 4000 at $TONI5_GARBAGE_TRUCK_X $TONI5_GARBAGE_TRUCK_Y $TONI5_GARBAGE_TRUCK_Z 0.0 0.0 0.0
        jump @MISSION_TONI5_FAILED
    end
    if and
        0038:   $TONI5_TIMER == 0
        80B1:   not car $EXPLOSIVE_TRUCK 0 in_cube 626.0 -1112.5 18.5 634.5 -1122.75 21.0
    then
        020B: explode_car $EXPLOSIVE_TRUCK
        039D: scatter_particles 17 4.0 0 0 0 4000 at $TONI5_GARBAGE_TRUCK_X $TONI5_GARBAGE_TRUCK_Y $TONI5_GARBAGE_TRUCK_Z 0.0 0.0 0.0
        jump @MISSION_TONI5_FAILED
    end
end //while
0247: request_model #FSHFCTRY_DSTRYD
00BC: print_now 'JM1_3' 5000 ms 2  // ~g~Activate the car bomb then get out of there!
01B5: force_weather 0
if
    0119:   car $EXPLOSIVE_TRUCK wrecked
then
    00BC: print_now 'WRECKED' 5000 ms 1  // ~r~The vehicle is wrecked!
    jump @MISSION_TONI5_FAILED
end

while 8356:   NOT  is_explosion_in_area 3 626.0 -1112.5 18.5 634.5 -1122.75 21.0
    wait 0 ms
    if
        0119:   car $EXPLOSIVE_TRUCK wrecked
    then
        039D: scatter_particles 17 4.0 0 0 0 4000 at $TONI5_GARBAGE_TRUCK_X $TONI5_GARBAGE_TRUCK_Y $TONI5_GARBAGE_TRUCK_Z 0.0 0.0 0.0
        jump @EXPLOSION
    end
    gosub @TRIAD_AI
    gosub @TRUCK_HEALTH
    00AA: store_car $EXPLOSIVE_TRUCK position_to $TONI5_GARBAGE_TRUCK_X $TONI5_GARBAGE_TRUCK_Y $TONI5_GARBAGE_TRUCK_Z
    if
        80B1:   not car $EXPLOSIVE_TRUCK 0 in_cube 626.0 -1112.5 18.5 634.5 -1122.75 21.0
    then
        jump @TONI5_WAIT_FOR_VAN
    end
    if and
        80DC:   not player $PLAYER driving $EXPLOSIVE_TRUCK
        8228:   not car $EXPLOSIVE_TRUCK bomb_status == 4
    then
        00BC: print_now 'JM1_5' 5000 ms 1  // ~g~The car bomb's not set!
    end
    if
        8185:   not car $EXPLOSIVE_TRUCK health >= 900
    then
        020B: explode_car $EXPLOSIVE_TRUCK
        039D: scatter_particles 17 4.0 0 0 0 4000 at $TONI5_GARBAGE_TRUCK_X $TONI5_GARBAGE_TRUCK_Y $TONI5_GARBAGE_TRUCK_Z 0.0 0.0 0.0
        jump @EXPLOSION
    end
    if
        0038:   $TONI5_TIMER == 0
    then
        020B: explode_car $EXPLOSIVE_TRUCK
        039D: scatter_particles 17 4.0 0 0 0 4000 at $TONI5_GARBAGE_TRUCK_X $TONI5_GARBAGE_TRUCK_Y $TONI5_GARBAGE_TRUCK_Z 0.0 0.0 0.0
        jump @EXPLOSION
    end
end //while

:EXPLOSION
014F: stop_timer $TONI5_TIMER
01B4: set_player $PLAYER can_move 0 (frozen)
02A3: toggle_widescreen 1 (on)
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
015F: set_camera_position 605.25 -1136.75 22.5 0.0 0.0 0.0
0160: point_camera 606.062 -1136.12 22.5 2
0164: remove_blip $TONI5_GARBAGE_TRUCK_MARKER
0164: remove_blip $BLIP2_TM5
wait 300 ms
0003: shake_camera 300
020C: create_explosion_with_radius 6 at 630.75 -1111.88 21.5
02CF: $FISH_FIRE3 = create_fire_at 631.0 -1111.75 19.75
020C: create_explosion_with_radius 6 at 631.0 -1123.0 21.375
wait 600 ms
0003: shake_camera 400
020C: create_explosion_with_radius 6 at 635.0 -1119.0 22.0
wait 300 ms
0003: shake_camera 300
020C: create_explosion_with_radius 6 at 650.0 -1119.0 20.0
wait 400 ms
0003: shake_camera 400
020C: create_explosion_with_radius 6 at 650.0 -1120.0 26.0
wait 200 ms
0003: shake_camera 300
015F: set_camera_position 625.5 -1094.0 27.0625 0.0 0.0 0.0
0160: point_camera 626.188 -1094.6899 26.75 2
020C: create_explosion_with_radius 6 at 634.188 -1104.0 24.25
wait 300 ms
0003: shake_camera 400
020C: create_explosion_with_radius 6 at 633.375 -1119.1899 23.375
wait 200 ms
0003: shake_camera 300
020C: create_explosion_with_radius 6 at 644.375 -1103.88 24.875
wait 300 ms
0003: shake_camera 400
020C: create_explosion_with_radius 6 at 641.0 -1108.25 27.375
wait 300 ms
0003: shake_camera 300
039D: scatter_particles 17 5.0 0 0 0 5000 at 634.75 -1104.88 24.6875 0.0 0.0 0.0
020C: create_explosion_with_radius 6 at 637.688 -1102.1899 24.5
020C: create_explosion_with_radius 6 at 651.25 -1103.38 20.6875
0107: $DEBRIS1_TM5 = create_object #FISH01 at 637.688 -1103.5601 26.5625
0107: $DEBRIS2_TM5 = create_object #FISH01 at 637.688 -1103.1899 26.5625
0107: $DEBRIS3_TM5 = create_object #FISH01 at 643.75 -1107.1899 27.5625
0107: $DEBRIS4_TM5 = create_object #FISH01 at 644.75 -1105.1899 27.5625
0392: object $DEBRIS1_TM5 toggle_in_moving_list 1
0392: object $DEBRIS2_TM5 toggle_in_moving_list 1
0392: object $DEBRIS3_TM5 toggle_in_moving_list 1
0392: object $DEBRIS4_TM5 toggle_in_moving_list 1
0381: throw_object $DEBRIS1_TM5 distance -10.0 6.0 18.0
0381: throw_object $DEBRIS2_TM5 distance 8.0 7.0 16.0
0381: throw_object $DEBRIS3_TM5 distance -7.0 10.0 14.0
0381: throw_object $DEBRIS4_TM5 distance 9.0 6.0 15.0
018C: play_sound 0 at 634.75 -1104.88 24.6875
wait 400 ms
0003: shake_camera 500
039D: scatter_particles 17 5.0 0 0 0 5000 at 639.188 -1129.75 25.5 0.0 0.0 0.0
020C: create_explosion_with_radius 6 at 647.0 -1102.75 23.375
020C: create_explosion_with_radius 6 at 638.562 -1128.75 25.5625
0107: $DEBRIS5_TM5 = create_object #FISH01 at 647.0 -1103.75 26.375
0107: $DEBRIS6_TM5 = create_object #FISH01 at 647.0 -1103.0 26.375
0107: $DEBRIS7_TM5 = create_object #FISH01 at 648.0 -1112.0 26.375
0107: $DEBRIS8_TM5 = create_object #FISH01 at 650.0 -1108.0 25.375
0107: $DEBRIS9_TM5 = create_object #FISH01 at 642.0 -1113.0 27.375
0107: $DEBRIS10 = create_object #FISH01 at 641.0 -1115.0 27.375
0392: object $DEBRIS5_TM5 toggle_in_moving_list 1
0392: object $DEBRIS6_TM5 toggle_in_moving_list 1
0392: object $DEBRIS7_TM5 toggle_in_moving_list 1
0392: object $DEBRIS8_TM5 toggle_in_moving_list 1
0392: object $DEBRIS9_TM5 toggle_in_moving_list 1
0392: object $DEBRIS10 toggle_in_moving_list 1
0381: throw_object $DEBRIS5_TM5 distance -3.0 6.0 18.0
0381: throw_object $DEBRIS6_TM5 distance 5.0 7.0 16.0
0381: throw_object $DEBRIS7_TM5 distance -6.0 7.0 17.0
0381: throw_object $DEBRIS8_TM5 distance 8.0 9.0 16.0
0381: throw_object $DEBRIS9_TM5 distance -7.0 8.0 14.0
0381: throw_object $DEBRIS10 distance -1.0 10.0 14.0
018C: play_sound 0 at 639.188 -1129.75 25.5
0169: set_fade_color 255 255 255
016A: fade 0  400 ms
if
    8117:   NOT   player $PLAYER wasted
then
    03B6: replace_model_at 646.5 -1123.88 22.6875 radius 80.0 from #FISHFCTORY to #FSHFCTRY_DSTRYD
end
016A: fade 1 (back)  400 ms
02CF: $FISH_FIRE2 = create_fire_at 644.25 -1106.0601 20.6875
02CF: $FISH_FIRE4 = create_fire_at 646.0 -1132.0 20.0
02CF: $FISH_FIRE6 = create_fire_at 635.562 -1107.5 24.5
02CF: $FISH_FIRE7 = create_fire_at 630.75 -1123.38 20.0
0004: $FISH_FACTORY_DESTROYED = 1
wait 3000 ms
01B7: release_weather
02A3: toggle_widescreen 0 (off)
01B4: set_player $PLAYER can_move 1 (unfrozen)
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
02EB: restore_camera_jumpcut
jump @MISSION_TONI5_PASSED

:MISSION_TONI5_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // // MISSION FAILED!
return

:MISSION_TONI5_PASSED
0004: $BLOW_FISH_COMPLETED = 1
0394: play_music 1
01E3: text_1number_styled 'M_PASS' 30000 5000 ms 1   // // MISSION PASSED! $~1~
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 30000
0164: remove_blip $SALVATORE_MISSION_MARKER
02A7: $SALVATORE_MISSION_MARKER = create_icon_marker_and_sphere 19 at 1120.69 -187.25 62.5625
015C: set_zone_gang_info 'FISHFAC' 1 (day)  0 0 0 0 0 0 0 0 0 0 0
015C: set_zone_gang_info 'FISHFAC' 0 (night)  0 0 0 0 0 0 0 0 0 0 0
014C: set_parked_car_generator $GEN_CAR47 cars_to_generate_to 0
014C: set_parked_car_generator $GEN_CAR48 cars_to_generate_to 0
014C: set_parked_car_generator $GEN_CAR49 cars_to_generate_to 0
0004: $FLAG_FRANKIE_SWITCHED_OFF = 0
0318: set_latest_mission_passed 'TM5'   // // 'BLOW FISH'
030C: set_mission_points += 1
0164: remove_blip $TONI_MISSION_MARKER
004F: create_thread @TONI5_FLAMES_LOOP
return

:MISSION_CLEANUP_TONI5
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_TONI = 0
0164: remove_blip $TONI5_GARBAGE_TRUCK_MARKER
0164: remove_blip $BLIP2_TM5
014F: stop_timer $TONI5_TIMER
0151: remove_status_text $EXPLOSIVE_TRUCK_HEALTH
0249: mark_model_as_no_longer_needed #TRASH
0249: mark_model_as_no_longer_needed #FSHFCTRY_DSTRYD
03F1: pedtype 8 add_threat 1
0169: set_fade_color 1 1 1
mission_cleanup
return

:TRIAD_AI
if and
    0121:   player $PLAYER in_zone 'PORT_W'
    0038:   $HAS_PLAYER_BEEN_AT_FISH_BEFORE == 1
    0038:   $CLEAR_TRIADS_THREATS == 0
then
    if
        8118:   NOT   actor $FISH_TRIAD1 dead
    then
        01ED: reset_actor $FISH_TRIAD1 flags
    end
    if
        8118:   NOT   actor $FISH_TRIAD2 dead
    then
        01ED: reset_actor $FISH_TRIAD2 flags
    end
    if
        8118:   NOT   actor $FISH_TRIAD3 dead
    then
        01ED: reset_actor $FISH_TRIAD3 flags
    end
    if
        8118:   NOT   actor $FISH_TRIAD4 dead
    then
        01ED: reset_actor $FISH_TRIAD4 flags
    end
    if
        8118:   NOT   actor $FISH_TRIAD5 dead
    then
        01ED: reset_actor $FISH_TRIAD5 flags
    end
    if
        8118:   NOT   actor $FISH_TRIAD6 dead
    then
        01ED: reset_actor $FISH_TRIAD6 flags
    end
    03F2: pedgroup 8 remove_threat 1
    0004: $CLEAR_TRIADS_THREATS = 1
end

if
    0057:   player $PLAYER  0 ()in cube 609.208 -1149.81 -3.72576 681.14 -1076.01 46.2742
    //0121:   player $PLAYER in_zone 'FISHFAC'  // CAUSED a CRASH above line replaces it
then
    if
        0038:   $TRIADS_SPOT_YOU == 0
    then
        if
            80E0:   NOT   player $PLAYER driving
        then
            if
                8118:   NOT   actor $FISH_TRIAD1 dead
            then
                011A: set_actor $FISH_TRIAD1 flags 1
            end
            if
                8118:   NOT   actor $FISH_TRIAD2 dead
            then
                011A: set_actor $FISH_TRIAD2 flags 1
            end
            if
                8118:   NOT   actor $FISH_TRIAD3 dead
            then
                011A: set_actor $FISH_TRIAD3 flags 1
            end
            if
                8118:   NOT   actor $FISH_TRIAD4 dead
            then
                011A: set_actor $FISH_TRIAD4 flags 1
            end
            if
                8118:   NOT   actor $FISH_TRIAD5 dead
            then
                011A: set_actor $FISH_TRIAD5 flags 1
            end
            if
                8118:   NOT   actor $FISH_TRIAD6 dead
            then
                011A: set_actor $FISH_TRIAD6 flags 1
            end
            03F1: pedtype 8 add_threat 1
            0004: $TRIADS_SPOT_YOU = 1
        end
        if or
            0118:   actor $FISH_TRIAD1 dead
            0118:   actor $FISH_TRIAD2 dead
            0118:   actor $FISH_TRIAD3 dead
            0118:   actor $FISH_TRIAD4 dead
            0118:   actor $FISH_TRIAD5 dead
            0118:   actor $FISH_TRIAD6 dead
        then
            if
                8118:   NOT   actor $FISH_TRIAD1 dead
            then
                011A: set_actor $FISH_TRIAD1 flags 1
            end
            if
                8118:   NOT   actor $FISH_TRIAD2 dead
            then
                011A: set_actor $FISH_TRIAD2 flags 1
            end
            if
                8118:   NOT   actor $FISH_TRIAD3 dead
            then
                011A: set_actor $FISH_TRIAD3 flags 1
            end
            if
                8118:   NOT   actor $FISH_TRIAD4 dead
            then
                011A: set_actor $FISH_TRIAD4 flags 1
            end
            if
                8118:   NOT   actor $FISH_TRIAD5 dead
            then
                011A: set_actor $FISH_TRIAD5 flags 1
            end
            if
                8118:   NOT   actor $FISH_TRIAD6 dead
            then
                011A: set_actor $FISH_TRIAD6 flags 1
            end
            03F1: pedtype 8 add_threat 1
            0004: $TRIADS_SPOT_YOU = 1
        end
    end
end
return

:TRUCK_HEALTH
if
    8119:   NOT   car $EXPLOSIVE_TRUCK wrecked
then
    0227: $EXPLOSIVE_TRUCK_HEALTH = car $EXPLOSIVE_TRUCK health
    0004: $EXPLOSIVE_TRUCK_HEALTH2 = 1000
    0060: $EXPLOSIVE_TRUCK_HEALTH2 -= $EXPLOSIVE_TRUCK_HEALTH
    if
        0018:   $EXPLOSIVE_TRUCK_HEALTH2 > 100
    then
        0004: $EXPLOSIVE_TRUCK_HEALTH2 = 100
    end
    0084: $EXPLOSIVE_TRUCK_HEALTH = $EXPLOSIVE_TRUCK_HEALTH2
end
return
