:SUBWAY
03A4: name_thread 'SUBWAY'

0004: $SUBWAY_STATION = 0
//--------------------------
// Create objects for subway1
//--------------------------
049C: $WANDERER3 = scripted_path_file 1 width 5.0
029B: $SUBWAY1 = init_object #TRAIN at 0.0 0.0 0.0
029B: $SUBWAY1_DL = init_object #TRAIN_DL at 0.0 0.0 0.0
029B: $SUBWAY1_DR = init_object #TRAIN_DR at 0.0 0.0 0.0
01C7: remove_object_from_mission_cleanup_list $SUBWAY1
01C7: remove_object_from_mission_cleanup_list $SUBWAY1_DL
01C7: remove_object_from_mission_cleanup_list $SUBWAY1_DR
049D: attach_scripted_file $WANDERER3 with_object $SUBWAY1
049D: attach_scripted_file $WANDERER3 with_object $SUBWAY1_DL
049D: attach_scripted_file $WANDERER3 with_object $SUBWAY1_DR

//------------------------------
// Determine coords of stations
//------------------------------
049F: set_scripted_file $WANDERER3 distance_along_path_to 53.0
wait 0 ms
01BB: store_object $SUBWAY1 position_to $SUBWAY_STAT0_X $SUBWAY_STAT0_Y $SUBWAY_STAT0_Z

049F: set_scripted_file $WANDERER3 distance_along_path_to 1387.0
wait 0 ms
01BB: store_object $SUBWAY1 position_to $SUBWAY_STAT1_X $SUBWAY_STAT1_Y $SUBWAY_STAT1_Z

049F: set_scripted_file $WANDERER3 distance_along_path_to 2333.0
wait 0 ms
01BB: store_object $SUBWAY1 position_to $SUBWAY_STAT2_X $SUBWAY_STAT2_Y $SUBWAY_STAT2_Z

049F: set_scripted_file $WANDERER3 distance_along_path_to 3989.0
wait 0 ms
01BB: store_object $SUBWAY1 position_to $SUBWAY_STAT3_X $SUBWAY_STAT3_Y $SUBWAY_STAT3_Z

//------------------------------------
// position wanderers and start moving
//------------------------------------
049F: set_scripted_file $WANDERER3 distance_along_path_to 53.0

049E: set_scripted_file $WANDERER3 speed_to 20.0

//0188: $TEMP_MARKER2 = create_marker_above_object $SUBWAY1

0004: $SUBWAY_STATION = 1

//------------------------------------
// MAIN LOOP
//------------------------------------
while true
    gosub @SUBWAY_GET_STATION_COORDS

    //----------------------------------------------------------------
    // The subway will slowdown when approaching the station,
    // to stop just beyond the station coords $SUBWAY_STATION_X $SUBWAY_STATION_Y $SUBWAY_STATION_Z
    // Speed = (2.0 * distance), clipped to [1.0, 20.0]
    // until the station-coords are passed.
    //----------------------------------------------------------------
    0005: $SUBWAY_TOGO = 9999.9

    :SUBWAY_RIDE
    wait 100 ms
    if
        0039:   15@ == 1
    then
        0006: 15@ = 0
        wait 2000 ms
        // 0164: remove_blip  $TEMP_MARKER2
        0108: destroy_object $SUBWAY1
        0108: destroy_object $SUBWAY1_DL
        0108: destroy_object $SUBWAY1_DR
        wait 0 ms
        04A1: release_scripted_file $WANDERER3
        wait 20000 ms
        jump @SUBWAY
    end
    008B: 3@ = $SUBWAY1
    gosub @TRAIN_CHECK_COLISSION
    01BB: store_object $SUBWAY1 position_to $SUBWAY1_X $SUBWAY1_Y $SUBWAY1_Z
    0086: $SUBWAY_TOGO_OLD = $SUBWAY_TOGO
    0509: $SUBWAY_TOGO = distance between point $SUBWAY_STATION_X $SUBWAY_STATION_Y and point $SUBWAY1_X $SUBWAY1_Y
    0086: $SUBWAY_SPEED = $SUBWAY_TOGO
    0011: $SUBWAY_SPEED *= 2.0
    if
        8022:   NOT  20.0 > $SUBWAY_SPEED
    then
        jump @SUBWAY_RIDE
    end
    if
        0022:   1.0 > $SUBWAY_SPEED
    then
        0005: $SUBWAY_SPEED = 1.0
    end
    049E: set_scripted_file $WANDERER3 speed_to $SUBWAY_SPEED
    if
        8024:   NOT  $SUBWAY_TOGO > $SUBWAY_TOGO_OLD
    then
        jump @SUBWAY_RIDE
    end
    049E: set_scripted_file $WANDERER3 speed_to 0.0

    //---------------------------------------------------------------
    //  The subway has stopped at the station, now destroy the
    //  wanderer-objects to enable seperate movement of the doors.
    //  Calculate the 'open'-positions of the doors and open the doors.
    //---------------------------------------------------------------
    wait 0 ms
    04A1: release_scripted_file $WANDERER3

    0400: create_coordinate $SUBWAY1_DRX $SUBWAY1_DRY $SUBWAY1_DRZ from_object $SUBWAY1 offset 0.0 -1.0 0.0
    0400: create_coordinate $SUBWAY1_DLX $SUBWAY1_DLY $SUBWAY1_DLZ from_object $SUBWAY1 offset 0.0 1.0 0.0

    while true
        if or
            834E:   NOT slide_object $SUBWAY1_DR to $SUBWAY1_DRX $SUBWAY1_DRY $SUBWAY1_DRZ angle .05 .05 .05 0
            834E:   NOT slide_object $SUBWAY1_DL to $SUBWAY1_DLX $SUBWAY1_DLY $SUBWAY1_DLZ angle .05 .05 .05 0
        jf break
        wait 0 ms
    end
    //----------------------------------------------------------------
    // wait for 10 seconds at the station (Allowing player to enter/exit the subway)
    //----------------------------------------------------------------
    0006: 16@ = 0
    while 8019:   NOT  16@ > 10000
        wait 100 ms
        if
            0256:   player $PLAYER defined
        then
            if
                00F5:   player $PLAYER 0 near_point $SUBWAY1_X $SUBWAY1_Y $SUBWAY1_Z radius 30.0 30.0 3.0
            then
                if
                    0039:   0@ == 0
                then
                    0007: 4@ = -1.0
                    // does player want to enter the subway ?
                    // --------------------------------------
                    008B: 3@ = $SUBWAY1
                    gosub @TRAIN_CHECK_ENTER
                else
                    gosub @TRAIN_CHECK_LEAVE
                end
            end
        end
    end
    //----------------------------------------------------------------
    // Move the doors back to the closed position ( = subway_position)
    //----------------------------------------------------------------
    while true
        if or
            834E:   NOT slide_object $SUBWAY1_DR to $SUBWAY1_X $SUBWAY1_Y $SUBWAY1_Z angle .05 .05 .05 0
            834E:   NOT slide_object $SUBWAY1_DL to $SUBWAY1_X $SUBWAY1_Y $SUBWAY1_Z angle .05 .05 .05 0
        jf break
        wait 0 ms
    end
    //----------------------------------------------------------------
    // Create new wanderers and attach the subway at the correct
    // position for the current station, taking into account the
    // overshoot during the braking ($subway_togo)
    //----------------------------------------------------------------
    049C: $WANDERER3 = scripted_path_file 1 width 5.0
    if
        0038:   $SUBWAY_STATION == 0
    then
        0009: $SUBWAY_TOGO += 53.0
    else
        if
            0038:   $SUBWAY_STATION == 1
        then
            0009: $SUBWAY_TOGO += 1387.0
        else
            if
                0038:   $SUBWAY_STATION == 2
            then
                0009: $SUBWAY_TOGO += 2333.0
            else
                0009: $SUBWAY_TOGO += 3989.0
            end
        end
    end
    049F: set_scripted_file $WANDERER3 distance_along_path_to $SUBWAY_TOGO

    049D: attach_scripted_file $WANDERER3 with_object $SUBWAY1
    049D: attach_scripted_file $WANDERER3 with_object $SUBWAY1_DL
    049D: attach_scripted_file $WANDERER3 with_object $SUBWAY1_DR
    049E: set_scripted_file $WANDERER3 speed_to 0.0

    //----------------------------------------------------------------
    // Accelerate away from this station
    //----------------------------------------------------------------
    0005: $SUBWAY_TOGO = 1.0

    while 8020:   NOT  $SUBWAY_TOGO > 20.0
        wait 100 ms
        008B: 3@ = $SUBWAY1
        gosub @TRAIN_CHECK_COLISSION
        049E: set_scripted_file $WANDERER3 speed_to $SUBWAY_TOGO
        0009: $SUBWAY_TOGO += 1.0
    end
    //----------------------------------------------------------------
    // Select the next station and restart the procedure
    //----------------------------------------------------------------
    0008: $SUBWAY_STATION += 1
    if
        0038:   $SUBWAY_STATION == 4
    then
        0004: $SUBWAY_STATION = 0
    end
end //while (main loop)

//=====================================================
// This routine selects the station coordinates,
// as determined during initialisation
//=====================================================
:SUBWAY_GET_STATION_COORDS
if
    0038:   $SUBWAY_STATION == 0
then
    0086: $SUBWAY_STATION_X = $SUBWAY_STAT0_X
    0086: $SUBWAY_STATION_Y = $SUBWAY_STAT0_Y
    0086: $SUBWAY_STATION_Z = $SUBWAY_STAT0_Z
    return
end
if
    0038:   $SUBWAY_STATION == 1
then
    0086: $SUBWAY_STATION_X = $SUBWAY_STAT1_X
    0086: $SUBWAY_STATION_Y = $SUBWAY_STAT1_Y
    0086: $SUBWAY_STATION_Z = $SUBWAY_STAT1_Z
    return
end
if
    0038:   $SUBWAY_STATION == 2
then
    0086: $SUBWAY_STATION_X = $SUBWAY_STAT2_X
    0086: $SUBWAY_STATION_Y = $SUBWAY_STAT2_Y
    0086: $SUBWAY_STATION_Z = $SUBWAY_STAT2_Z
    return
end
0086: $SUBWAY_STATION_X = $SUBWAY_STAT3_X
0086: $SUBWAY_STATION_Y = $SUBWAY_STAT3_Y
0086: $SUBWAY_STATION_Z = $SUBWAY_STAT3_Z
return
//=========== END OF SUBWAY CODE ====================

:TRAIN
03A4: name_thread 'TRAIN'

0006: 0@ = 0
//--------------------------
// Create objects for train1
//--------------------------
049C: $WANDERER1 = scripted_path_file 0 width 5.0
029B: $TRAIN1 = init_object #TRAIN at 0.0 0.0 0.0
029B: $TRAIN1_DL = init_object #TRAIN_DL at 0.0 0.0 0.0
029B: $TRAIN1_DR = init_object #TRAIN_DR at 0.0 0.0 0.0
01C7: remove_object_from_mission_cleanup_list $TRAIN1
01C7: remove_object_from_mission_cleanup_list $TRAIN1_DL
01C7: remove_object_from_mission_cleanup_list $TRAIN1_DR
049D: attach_scripted_file $WANDERER1 with_object $TRAIN1
049D: attach_scripted_file $WANDERER1 with_object $TRAIN1_DL
049D: attach_scripted_file $WANDERER1 with_object $TRAIN1_DR

//--------------------------
// Create objects for train2
//--------------------------
049C: $WANDERER2 = scripted_path_file 0 width 5.0
029B: $TRAIN2 = init_object #STRAIN at 0.0 0.0 0.0
029B: $TRAIN2_DL = init_object #TRAIN_DL at 0.0 0.0 0.0
029B: $TRAIN2_DR = init_object #TRAIN_DR at 0.0 0.0 0.0
01C7: remove_object_from_mission_cleanup_list $TRAIN2
01C7: remove_object_from_mission_cleanup_list $TRAIN2_DL
01C7: remove_object_from_mission_cleanup_list $TRAIN2_DR
049D: attach_scripted_file $WANDERER2 with_object $TRAIN2
049D: attach_scripted_file $WANDERER2 with_object $TRAIN2_DL
049D: attach_scripted_file $WANDERER2 with_object $TRAIN2_DR

//------------------------------
// Determine coords of stations
//------------------------------
049F: set_scripted_file $WANDERER1 distance_along_path_to 38.0
wait 0 ms
01BB: store_object $TRAIN1 position_to $TRAIN_STAT0_X $TRAIN_STAT0_Y $TRAIN_STAT0_Z

049F: set_scripted_file $WANDERER1 distance_along_path_to 1017.0
wait 0 ms
01BB: store_object $TRAIN1 position_to $TRAIN_STAT1_X $TRAIN_STAT1_Y $TRAIN_STAT1_Z

049F: set_scripted_file $WANDERER1 distance_along_path_to 1666.0
wait 0 ms
01BB: store_object $TRAIN1 position_to $TRAIN_STAT2_X $TRAIN_STAT2_Y $TRAIN_STAT2_Z

//------------------------------------
// position wanderers and start moving
//------------------------------------
049F: set_scripted_file $WANDERER1 distance_along_path_to 38.0
049F: set_scripted_file $WANDERER2 distance_along_path_to 18.0

049E: set_scripted_file $WANDERER1 speed_to 20.0
049E: set_scripted_file $WANDERER2 speed_to 20.0

0004: $TRAIN_STATION = 1
//#######################remove marker for release ##########
//0188: $TEMP_MARKER1 = create_marker_above_object $TRAIN1

//------------------------------------
// MAIN LOOP
//------------------------------------
while true
    gosub @TRAIN_GET_STATION_COORDS
    //----------------------------------------------------------------
    // The train will slowdown when approaching the station,
    // to stop just beyond the station coords  $train_station_x $train_station_y $train_station_z
    // Speed = (2.0 * distance), clipped to [1.0,20.0],
    // until the station-coords are passed.
    //----------------------------------------------------------------
    0005: $TRAIN_TOGO = 9999.9

    :TRAIN_RIDE
    wait 100 ms
    if
        0039:   15@ == 1
    then
        0006: 15@ = 0
        wait 2000 ms
        // 0164: remove_blip  $TEMP_MARKER1
        0108: destroy_object $TRAIN1
        0108: destroy_object $TRAIN1_DL
        0108: destroy_object $TRAIN1_DR
        0108: destroy_object $TRAIN2
        0108: destroy_object $TRAIN2_DL
        0108: destroy_object $TRAIN2_DR
        wait 0 ms
        04A1: release_scripted_file $WANDERER1
        04A1: release_scripted_file $WANDERER2
        wait 20000 ms
        jump @TRAIN
    end
    008B: 3@ = $TRAIN1
    gosub @TRAIN_CHECK_COLISSION
    01BB: store_object $TRAIN1 position_to $TRAIN1_X $TRAIN1_Y $TRAIN1_Z
    01BB: store_object $TRAIN2 position_to $TRAIN2_X $TRAIN2_Y $TRAIN2_Z
    0086: $TRAIN_TOGO_OLD = $TRAIN_TOGO
    0509: unknown $TRAIN_TOGO = distance between point $TRAIN_STATION_X $TRAIN_STATION_Y and point $TRAIN1_X $TRAIN1_Y
    0086: $TRAIN_SPEED = $TRAIN_TOGO
    0011: $TRAIN_SPEED *= 2.0
    if
        8022:   NOT  20.0 > $TRAIN_SPEED
    then
        jump @TRAIN_RIDE
    end
    if
        0022:   1.0 > $TRAIN_SPEED
    then
        0005: $TRAIN_SPEED = 1.0
    end
    049E: set_scripted_file $WANDERER1 speed_to $TRAIN_SPEED
    049E: set_scripted_file $WANDERER2 speed_to $TRAIN_SPEED
    if
        8024:   NOT  $TRAIN_TOGO > $TRAIN_TOGO_OLD
    then
        jump @TRAIN_RIDE
    end
    049E: set_scripted_file $WANDERER1 speed_to 0.0
    049E: set_scripted_file $WANDERER2 speed_to 0.0

    //---------------------------------------------------------------
    //  The train has stopped at the station, now destroy the
    //  wanderer-objects to enable seperate movement of the doors.
    //  Calculate the 'open'-positions of the doors and open the doors.
    //---------------------------------------------------------------
    wait 0 ms
    04A1: release_scripted_file $WANDERER1
    04A1: release_scripted_file $WANDERER2

    0400: create_coordinate $TRAIN1_DRX $TRAIN1_DRY $TRAIN1_DRZ from_object $TRAIN1 offset 0.0 -1.0 0.0
    0400: create_coordinate $TRAIN1_DLX $TRAIN1_DLY $TRAIN1_DLZ from_object $TRAIN1 offset 0.0 1.0 0.0
    0400: create_coordinate $TRAIN2_DRX $TRAIN2_DRY $TRAIN2_DRZ from_object $TRAIN2 offset 0.0 -1.0 0.0
    0400: create_coordinate $TRAIN2_DLX $TRAIN2_DLY $TRAIN2_DLZ from_object $TRAIN2 offset 0.0 1.0 0.0
    while true
        if or
            834E:   NOT slide_object $TRAIN1_DR to $TRAIN1_DRX $TRAIN1_DRY $TRAIN1_DRZ angle .05 .05 .05 0
            834E:   NOT slide_object $TRAIN1_DL to $TRAIN1_DLX $TRAIN1_DLY $TRAIN1_DLZ angle .05 .05 .05 0
            834E:   NOT slide_object $TRAIN2_DR to $TRAIN2_DRX $TRAIN2_DRY $TRAIN2_DRZ angle .05 .05 .05 0
            834E:   NOT slide_object $TRAIN2_DL to $TRAIN2_DLX $TRAIN2_DLY $TRAIN2_DLZ angle .05 .05 .05 0
        jf break
        wait 0 ms
    end
    //----------------------------------------------------------------
    // wait for 10 seconds at the station (Allowing player to enter/exit the train)
    //----------------------------------------------------------------
    0006: 16@ = 0
    while 8019:   NOT  16@ > 10000
        wait 100 ms
        if
            0256:   player $PLAYER defined
        then
            if or
                00F5:   player $PLAYER 0 near_point $TRAIN1_X $TRAIN1_Y $TRAIN1_Z radius 30.0 30.0 3.0
                00F5:   player $PLAYER 0 near_point $TRAIN2_X $TRAIN2_Y $TRAIN2_Z radius 30.0 30.0 3.0
            then
                if
                    0039:   0@ == 0
                then
                    0007: 4@ = 1.0
                    // does player want to enter the train ?
                    // --------------------------------------
                    008B: 3@ = $TRAIN1
                    gosub @TRAIN_CHECK_ENTER
                    008B: 3@ = $TRAIN2
                    gosub @TRAIN_CHECK_ENTER
                else
                    gosub @TRAIN_CHECK_LEAVE
                end
            end
        end
    end //while

    //----------------------------------------------------------------
    // Move the doors back to the closed position ( = train_position)
    //----------------------------------------------------------------
    while true
        if or
            834E:   NOT slide_object $TRAIN1_DR to $TRAIN1_X $TRAIN1_Y $TRAIN1_Z angle .05 .05 .05 0
            834E:   NOT slide_object $TRAIN1_DL to $TRAIN1_X $TRAIN1_Y $TRAIN1_Z angle .05 .05 .05 0
            834E:   NOT slide_object $TRAIN2_DR to $TRAIN2_X $TRAIN2_Y $TRAIN2_Z angle .05 .05 .05 0
            834E:   NOT slide_object $TRAIN2_DL to $TRAIN2_X $TRAIN2_Y $TRAIN2_Z angle .05 .05 .05 0
        jf break
        wait 0 ms
    end
    //----------------------------------------------------------------
    // Create new wanderers and attach the train at the correct
    // position for the current station, taking into account the
    // overshoot during the braking ($train_togo)
    //----------------------------------------------------------------
    049C: $WANDERER1 = scripted_path_file 0 width 5.0
    049C: $WANDERER2 = scripted_path_file 0 width 5.0
    if
        0038:   $TRAIN_STATION == 0
    then
        0009: $TRAIN_TOGO += 18.0
    else
        if
            0038:   $TRAIN_STATION == 1
        then
            0009: $TRAIN_TOGO += 997.0
        else
            0009: $TRAIN_TOGO += 1646.0
        end
    end
    049F: set_scripted_file $WANDERER2 distance_along_path_to $TRAIN_TOGO
    0009: $TRAIN_TOGO += 20.0
    049F: set_scripted_file $WANDERER1 distance_along_path_to $TRAIN_TOGO

    049D: attach_scripted_file $WANDERER1 with_object $TRAIN1
    049D: attach_scripted_file $WANDERER1 with_object $TRAIN1_DL
    049D: attach_scripted_file $WANDERER1 with_object $TRAIN1_DR
    049E: set_scripted_file $WANDERER1 speed_to 0.0

    049D: attach_scripted_file $WANDERER2 with_object $TRAIN2
    049D: attach_scripted_file $WANDERER2 with_object $TRAIN2_DL
    049D: attach_scripted_file $WANDERER2 with_object $TRAIN2_DR
    049E: set_scripted_file $WANDERER2 speed_to 0.0

    //----------------------------------------------------------------
    // Accelerate away from this station
    //----------------------------------------------------------------
    0005: $TRAIN_TOGO = 1.0

    while 8020:   NOT  $TRAIN_TOGO > 20.0
        wait 100 ms
        008B: 3@ = $TRAIN1
        gosub @TRAIN_CHECK_COLISSION
        049E: set_scripted_file $WANDERER1 speed_to $TRAIN_TOGO
        049E: set_scripted_file $WANDERER2 speed_to $TRAIN_TOGO
        0009: $TRAIN_TOGO += 1.0
    end
    //----------------------------------------------------------------
    // Select the next station and restart the procedure
    //----------------------------------------------------------------
    0008: $TRAIN_STATION += 1
    if
        0038:   $TRAIN_STATION == 3
    then
        0004: $TRAIN_STATION = 0
    end
end //while (main loop)

//=====================================================
// This routine selects the station coordinates,
// as determined during initialisation
//=====================================================
:TRAIN_GET_STATION_COORDS
if
    0038:   $TRAIN_STATION == 0
then
    0086: $TRAIN_STATION_X = $TRAIN_STAT0_X
    0086: $TRAIN_STATION_Y = $TRAIN_STAT0_Y
    0086: $TRAIN_STATION_Z = $TRAIN_STAT0_Z
    return
end
if
    0038:   $TRAIN_STATION == 1
then
    0086: $TRAIN_STATION_X = $TRAIN_STAT1_X
    0086: $TRAIN_STATION_Y = $TRAIN_STAT1_Y
    0086: $TRAIN_STATION_Z = $TRAIN_STAT1_Z
    return
end
0086: $TRAIN_STATION_X = $TRAIN_STAT2_X
0086: $TRAIN_STATION_Y = $TRAIN_STAT2_Y
0086: $TRAIN_STATION_Z = $TRAIN_STAT2_Z
return

//=============================================
// This routine checks if the player wants to leave the train at the station
//=============================================
:TRAIN_CHECK_LEAVE
if
    00E1:   key_pressed 0 15
then
    // the player wants to exit the train
    // ------------------------------------
    if
        0256:   player $PLAYER defined
    then
        0007: 6@ = 0.4
        0400: create_coordinate 7@ 8@ 9@ from_object 1@ offset 4@ 2@ 6@
        01B4: set_player $PLAYER can_move 0 (frozen)
        0170: $TRAIN_ANGLE = player $PLAYER z_angle
        0465: remove_actor $SCRIPT_CONTROLLED_PLAYER from_turret_mode
        0055: set_player_coordinates $PLAYER at 7@ 8@ 9@
        04E2: $PLAYER 0
        0171: set_player $PLAYER z_angle_to $TRAIN_ANGLE
        000F: 4@ -= 3.0
        0400: create_coordinate 7@ 8@ 9@ from_object 1@ offset 4@ 2@ 6@
        wait 500 ms
        if
            0256:   player $PLAYER defined
        then
            0239: actor $SCRIPT_CONTROLLED_PLAYER run_to 7@ 8@
            0006: 17@ = 0

            while true
                if and
                    829F:   NOT  player $PLAYER stopped
                    8029:   NOT  17@ >= 3000
                jf break
                wait 100 ms
                if
                    8256:   NOT player $PLAYER defined
                then
                    return
                end
            end //while
            0006: 0@ = 0
            01B4: set_player $PLAYER can_move 1 (unfrozen)
        end
    end
end
return

//=====================================
// this subroutine checks if a players wants to enter a train
// by checking each of the three doors
// param: 3@ - contains the train to be checked
//=====================================
:TRAIN_CHECK_ENTER
0007: 5@ = 0.0
0007: 6@ = 1.9
gosub @TRAIN_CHECK_DOOR
0007: 5@ = -6.5
gosub @TRAIN_CHECK_DOOR
0007: 5@ = 6.5
gosub @TRAIN_CHECK_DOOR
return

:TRAIN_CHECK_DOOR
// calculate absolute position of player lock position
0400: create_coordinate 7@ 8@ 9@ from_object 3@ offset 4@ 5@ 6@
// calculate position of point outside the current door
000F: 4@ -= 3.0
0400: create_coordinate 10@ 11@ 12@ from_object 3@ offset 4@ 5@ 6@
000B: 4@ += 3.0
if
    0256:   player $PLAYER defined
then
    if
        00F5:   player $PLAYER 0 near_point 7@ 8@ 9@ radius 1.9 1.9 1.9
    then

        // Bump player away from door ( and tell he should press the magic key )
        //----------------------------------------------------------------------------------
        0502: unknown_actor $SCRIPT_CONTROLLED_PLAYER sprint_to 10@ 11@
        wait 250 ms
        0293: $CONTROLMODE = current_controls
        if
            0038:   $CONTROLMODE == 2
        then
            03E5: text_box 'HELP26'   // Press the ~h~~k~~VEHICLE_ENTER_EXIT~ ~w~button to enter or exit a vehicle.
            return
        end
        03E5: text_box 'HELP21'   // Press the ~h~~k~~VEHICLE_ENTER_EXIT~ ~w~button to enter or exit a vehicle.
        return

        // Check if the player presses the key near to this door
        //---------------------------------------------------------------
    end
    if
        0256:   player $PLAYER defined
    then
        if and
            00E1:   key_pressed 0 15
            00F6:   player $PLAYER 0 near_point_on_foot 7@ 8@ 9@ radius 5.0 5.0 4.0
        then
            01B4: set_player $PLAYER can_move 0 (frozen)
            0239: actor $SCRIPT_CONTROLLED_PLAYER run_to 10@ 11@
            0006: 17@ = 0
            while true
                if and
                    829F:   NOT  player $PLAYER stopped
                    8029:   NOT  17@ >= 3000
                jf break
                wait 100 ms
                if
                    8256:   NOT  player $PLAYER defined
                then
                    return
                end
            end
            0239: actor $SCRIPT_CONTROLLED_PLAYER run_to 7@ 8@
            0006: 17@ = 0
            while true
                if or
                    829F:   NOT  player $PLAYER stopped
                    8029:   NOT  17@ >= 3000
                jf break
                wait 100 ms
                if
                    8256:   NOT  player $PLAYER defined
                then
                    return
                end
            end //while
            04F4: unknown_align_actor $SCRIPT_CONTROLLED_PLAYER with_scripted_file_path_object 3@ offset 4@ 5@ 6@ 0 360.0 0
            0006: 0@ = 1
            0085: 1@ = 3@
            0087: 2@ = 5@
            01B4: set_player $PLAYER can_move 1 (unfrozen)
        end
    end
end
return

//=========================================================
// This routine checks if Claude is in hit by a running train
//=========================================================
:TRAIN_CHECK_COLISSION
0400: create_coordinate 7@ 8@ 9@ from_object 3@ offset 1.0 9.5 0.0
if
    0256:   player $PLAYER defined
then
    0006: 15@ = 0
    if and
        0039:   0@ == 0
        00F5:   player $PLAYER 0 near_point 7@ 8@ 9@ radius 2.0 2.0 1.9
    then
        //------------------------------------------
        // The Dude is dead
        //------------------------------------------
        0222: set_player $PLAYER health_to 0
        0006: 15@ = 1
        if
            00E0:   player $PLAYER driving
        then
            03C1: 15@ = player $PLAYER car
            0224: set_car 15@ health_to 0
            0006: 15@ = 1
        end
    end
end
return