//#####################################################################################
//#####################################################################################
// BEGIN HEALTH HELP MONITOR
//#####################################################################################
//#####################################################################################

:WASTED_LOOP
03A4: name_thread 'WAST_H'
while true
    wait 0 ms
    if
        0256:   player $PLAYER defined
    then
        if and
            0121:   player $PLAYER in_zone 'S_VIEW'
            0038:   $FLAG_PLAYER_ON_MISSION == 0
            0038:   $HEAL_INFO_TRIP == 1
        then
            if
                0214:   pickup $WASTED_INFO_PICKUP picked_up
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                while fading
                    wait 0 ms
                end
                036B: dont_touch_restart_taxi_next_time 1   // Restart taxi needs this custom opcode
                0417: start_mission M01_HOSPITALHELP
                end_thread
            end
        end
    end
end
//#####################################################################################
//#####################################################################################
// END HEALTH HELP MONITOR / BEGIN POLICE HELP MONITOR
//#####################################################################################
//#####################################################################################

:BUSTED_LOOP
03A4: name_thread 'BUST_H'
while true
    wait 0 ms
    if
        0256:   player $PLAYER defined
    then
        if and
            0121:   player $PLAYER in_zone 'S_VIEW'
            0038:   $FLAG_PLAYER_ON_MISSION == 0
            0038:   $WANTED_INFO_TRIP == 1
        then
            if
                0214:   pickup $BUSTED_INFO_PICKUP picked_up
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                while fading
                    wait 0 ms
                end
                036B: dont_touch_restart_taxi_next_time 1   // Restart taxi needs this custom opcode
                0417: start_mission M02_POLICEHELP
                end_thread
            end
        end
    end
end

//#####################################################################################
//#####################################################################################
// END POLICE HELP MONITOR / BEGIN MARTY MONITORS
//#####################################################################################
//#####################################################################################

:MEAT_MISSION1_LOOP
03A4: name_thread 'MEA_1'

:MEAT_MISSION1_LOOP_INNER
wait $WAIT_TIME ms
if
    0038:   $THE_CROOK_COMPLETED == 1
then
    024E: disable_phone $PHONE_MARTY
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    00BF: $TEMP_TIME_HOURS = current_time_hours, $TEMP_TIME_MINUTES = current_time_minutes
    if and
        0028:   $TEMP_TIME_HOURS >= 9
        001A:   19 > $TEMP_TIME_HOURS
    then
        0405: enable_phone $PHONE_MARTY
    else
        024E: disable_phone $PHONE_MARTY
    end
else
    024E: disable_phone $PHONE_MARTY
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot 889.56 -840.25 21.0 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_MARTY
                00BF: $TEMP_TIME_HOURS = current_time_hours, $TEMP_TIME_MINUTES = current_time_minutes
                if and
                    0028:   $TEMP_TIME_HOURS >= 9
                    001A:   19 > $TEMP_TIME_HOURS
                then
                    01B4: set_player $PLAYER can_move 0 (frozen)
                    0169: set_fade_color 0 0 0
                    016A: fade 0  1500 ms
                    00BA: text_styled 'MEA1' 5000 ms 2   // 'THE CROOK'
                    while fading
                        wait 0 ms
                    end
                    0417: start_mission M15_THECROOK
                end
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @MEAT_MISSION1_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 889.56 -840.25 21.0 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @MEAT_MISSION1_LOOP_INNER
                end
            end
        end
    end
end
jump @MEAT_MISSION1_LOOP_INNER

:MEAT_MISSION2_LOOP
03A4: name_thread 'MEA_2'

:MEAT_MISSION2_LOOP_INNER
wait $WAIT_TIME ms
if
    0038:   $THE_THIEVES_COMPLETED == 1
then
    024E: disable_phone $PHONE_MARTY
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    00BF: $TEMP_TIME_HOURS = current_time_hours, $TEMP_TIME_MINUTES = current_time_minutes
    if and
        0028:   $TEMP_TIME_HOURS >= 9
        001A:   19 > $TEMP_TIME_HOURS
    then
        0405: enable_phone $PHONE_MARTY
    else
        024E: disable_phone $PHONE_MARTY
    end
else
    024E: disable_phone $PHONE_MARTY
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot 889.56 -840.25 21.0 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_MARTY
                00BF: $TEMP_TIME_HOURS = current_time_hours, $TEMP_TIME_MINUTES = current_time_minutes
                if and
                    0028:   $TEMP_TIME_HOURS >= 9
                    001A:   19 > $TEMP_TIME_HOURS
                then
                    01B4: set_player $PLAYER can_move 0 (frozen)
                    0169: set_fade_color 0 0 0
                    016A: fade 0 (in)  1500 ms
                    00BA: text_styled 'MEA2' 5000 ms 2   // 'THE THIEVES'
                    while fading
                        wait 0 ms
                    end
                    0417: start_mission M16_THETHIEVES
                end
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @MEAT_MISSION2_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 889.56 -840.25 21.0 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @MEAT_MISSION2_LOOP_INNER
                end
            end
        end
    end
end
jump @MEAT_MISSION2_LOOP_INNER

:MEAT_MISSION3_LOOP
03A4: name_thread 'MEA_3'

:MEAT_MISSION3_LOOP_INNER
wait $WAIT_TIME ms
if
    0038:   $THE_WIFE_COMPLETED == 1
then
    024E: disable_phone $PHONE_MARTY
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    00BF: $TEMP_TIME_HOURS = current_time_hours, $TEMP_TIME_MINUTES = current_time_minutes
    if and
        0028:   $TEMP_TIME_HOURS >= 9
        001A:   19 > $TEMP_TIME_HOURS
    then
        0405: enable_phone $PHONE_MARTY
    else
        024E: disable_phone $PHONE_MARTY
    end
else
    024E: disable_phone $PHONE_MARTY
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot 889.56 -840.25 21.0 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_MARTY
                00BF: $TEMP_TIME_HOURS = current_time_hours, $TEMP_TIME_MINUTES = current_time_minutes
                if and
                    0028:   $TEMP_TIME_HOURS >= 9
                    001A:   19 > $TEMP_TIME_HOURS
                then
                    01B4: set_player $PLAYER can_move 0 (frozen)
                    0169: set_fade_color 0 0 0
                    016A: fade 0 (in)  1500 ms
                    00BA: text_styled 'MEA3' 5000 ms 2   // 'THE WIFE'
                    while fading
                        wait 0 ms
                    end
                    0417: start_mission M17_THEWIFE
                end
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @MEAT_MISSION3_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 889.56 -840.25 21.0 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @MEAT_MISSION3_LOOP_INNER
                end
            end
        end
    end
end
jump @MEAT_MISSION3_LOOP_INNER

:MEAT_MISSION4_LOOP
03A4: name_thread 'MEA_4'

:MEAT_MISSION4_LOOP_INNER
wait $WAIT_TIME ms
if
    0038:   $HER_LOVER_COMPLETED == 1
then
    024E: disable_phone $PHONE_MARTY
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    00BF: $TEMP_TIME_HOURS = current_time_hours, $TEMP_TIME_MINUTES = current_time_minutes
    if and
        0028:   $TEMP_TIME_HOURS >= 9
        001A:   19 > $TEMP_TIME_HOURS
    then
        0405: enable_phone $PHONE_MARTY
    else
        024E: disable_phone $PHONE_MARTY
    end
else
    024E: disable_phone $PHONE_MARTY
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot 889.56 -840.25 21.0 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_MARTY
                00BF: $TEMP_TIME_HOURS = current_time_hours, $TEMP_TIME_MINUTES = current_time_minutes
                if and
                    0028:   $TEMP_TIME_HOURS >= 9
                    001A:   19 > $TEMP_TIME_HOURS
                then
                    01B4: set_player $PLAYER can_move 0 (frozen)
                    0169: set_fade_color 0 0 0
                    016A: fade 0 (in)  1500 ms
                    00BA: text_styled 'MEA4' 5000 ms 2   // 'HER LOVER'
                    while fading
                        wait 0 ms
                    end
                    0417: start_mission M18_HERLOVER
                end
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @MEAT_MISSION4_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 889.56 -840.25 21.0 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @MEAT_MISSION4_LOOP_INNER
                end
            end
        end
    end
end
jump @MEAT_MISSION4_LOOP_INNER

//#####################################################################################
//#####################################################################################
// END MARTY MONITORS / BEGIN LUIGI MONITORS
//#####################################################################################
//#####################################################################################

:LUIGI_MISSION1_LOOP
03A4: name_thread 'LUIGI_1'

:LLUIGI_MISSION1_LOOP_INNER
wait 0 ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $LUIGIS_GIRLS_COMPLETED == 1
then
    end_thread
end
if and
    0256:   player $PLAYER defined
    0038:   $ON_LUIGIS_GIRLS_MISSION == 0
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    if
        0038:   $FLAG_REACHED_HIDEOUT == 0
    then
        if
            00E4:   player $PLAYER 0 near_point_on_foot 476.875 -939.938 radius 3.5 3.5
        then
            if
                03EE:   player $PLAYER controllable
            then
                0417: start_mission M19_GIVEMELIBERTY
                0004: $ON_LUIGIS_GIRLS_MISSION = 1
                jump @LLUIGI_MISSION1_LOOP_INNER
            end
        end
    end
    if
        00E4:   player $PLAYER 0 near_point_on_foot 548.5 -308.188 radius 3.5 3.5
    then
        if
            03EE:   player $PLAYER controllable
        then
            0417: start_mission M19_GIVEMELIBERTY
            0004: $ON_LUIGIS_GIRLS_MISSION = 1
        end
    end
end
jump @LLUIGI_MISSION1_LOOP_INNER

:LUIGI_MISSION2_LOOP
03A4: name_thread 'LUIGI_2'

:LUIGI_MISSION2_LOOP_INNER
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $DONT_SPANK_MA_BITCH_UP_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 557.75 -425.75 19.875 radius 1.5 2.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'LM2' 5000 ms 2   // 'DON'T SPANK MA BITCH UP'
                while fading
                    wait 0 ms
                end
                0417: start_mission M20_DONTSPANKMABITCHUP
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @LUIGI_MISSION2_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 557.75 -425.75 19.875 radius 1.5 2.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @LUIGI_MISSION2_LOOP_INNER
                end
            end
        end
    end
end
jump @LUIGI_MISSION2_LOOP_INNER

:LUIGI_MISSION3_LOOP
03A4: name_thread 'LUIGI_3'

:LUIGI_MISSION3_LOOP_INNER
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $DRIVE_MISTY_FOR_ME_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 557.75 -425.75 19.875 radius 1.5 2.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'LM3' 5000 ms 2   // 'DRIVE MISTY FOR ME'
                while fading
                    wait 0 ms
                end
                0417: start_mission M21_DRIVEMISTYFORME
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @LUIGI_MISSION3_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 557.75 -425.75 19.875 radius 1.5 2.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @LUIGI_MISSION3_LOOP_INNER
                end
            end
        end
    end
end
jump @LUIGI_MISSION3_LOOP_INNER

:LUIGI_MISSION4_LOOP
03A4: name_thread 'LUIGI_4'

:LUIGI_MISSION4_LOOP_INNER
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $PUMP_ACTION_PIMP_COMPLETED == 1
then
    end_thread
end
if and
    0038:   $SALVATORES_CALLED_A_MEETING_COMPLETED == 1
    0038:   $CHAPERONE_COMPLETED == 0
then
    0004: $FLAG_LUIGI_MISSION4_TERMINATED = 1
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 557.75 -425.75 19.875 radius 1.5 2.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'LM4' 5000 ms 2   // 'PUMP-ACTION PIMP'
                while fading
                    wait 0 ms
                end
                0417: start_mission M22_PUMPACTIONPIMP
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @LUIGI_MISSION4_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 557.75 -425.75 19.875 radius 1.5 2.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @LUIGI_MISSION4_LOOP_INNER
                end
            end
        end
    end
end
jump @LUIGI_MISSION4_LOOP_INNER

:LUIGI_MISSION5_LOOP
03A4: name_thread 'LUIGI_5'

:LUIGI_MISSION5_LOOP_INNER
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $THE_FUZZ_BALL_COMPLETED == 1
then
    end_thread
end
if and
    0038:   $SALVATORES_CALLED_A_MEETING_COMPLETED == 1
    0038:   $CHAPERONE_COMPLETED == 0
then
    0004: $FLAG_LUIGI_MISSION5_TERMINATED = 1
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 557.75 -425.75 19.875 radius 1.5 2.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'LM5' 5000 ms 2   // 'THE FUZZ BALL'
                while fading
                    wait 0 ms
                end
                0417: start_mission M23_THEFUZZBALL
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @LUIGI_MISSION5_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 557.75 -425.75 19.875 radius 1.5 2.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @LUIGI_MISSION5_LOOP_INNER
                end
            end
        end
    end
end
jump @LUIGI_MISSION5_LOOP_INNER

//#####################################################################################
//#####################################################################################
// END LUIGI MONITORS / BEGIN JOEY MONITORS
//#####################################################################################
//#####################################################################################

:JOEY_MISSION1_LOOP
03A4: name_thread 'JM1'

:JOEY_MISSION1_LOOP_INNER
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $MIKE_LIPS_LAST_LUNCH_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            00BF: $CURRENT_TIME_HOURS = current_time_hours, $CURRENT_TIME_MINUTES = current_time_minutes
            if and
                0028:   $CURRENT_TIME_HOURS >= 5
                001A:   21 > $CURRENT_TIME_HOURS
            then
                if
                    03EE:   player $PLAYER controllable
                then
                    01B4: set_player $PLAYER can_move 0 (frozen)
                    0169: set_fade_color 0 0 0
                    016A: fade 0  1500 ms
                    03AF: set_streaming 0 (disabled)
                    00BA: text_styled 'JM1' 5000 ms 2   // 'MIKE LIPS LAST LUNCH'
                    while fading
                        wait 0 ms
                    end
                    0417: start_mission M24_MIKELIPSLASTLUNCH
                end
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @JOEY_MISSION1_LOOP_INNER
                end
                while 00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
                    wait 0 ms
                    if
                        8256:   NOT   player $PLAYER defined
                    then
                        jump @JOEY_MISSION1_LOOP_INNER
                    end
                end
            else
                00BC: print_now 'WRONGT1' 5000 ms 1   // ~g~Come back between 05:00 and 21:00 for a job
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @JOEY_MISSION1_LOOP
                end
                00BF: $CURRENT_TIME_HOURS = current_time_hours, $CURRENT_TIME_MINUTES = current_time_minutes
                if and
                    0028:   $CURRENT_TIME_HOURS >= 5
                    001A:   21 > $CURRENT_TIME_HOURS
                then
                    jump @JOEY_MISSION1_LOOP_INNER
                end
            end
        end
    end
end
jump @JOEY_MISSION1_LOOP_INNER

:JOEY_MISSION2_LOOP
03A4: name_thread 'JM2'

:JOEY_MISSION2_LOOP_INNER
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $FAREWELL_CHUNKY_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'JM2' 5000 ms 2   // 'FAREWELL 'CHUNKY' LEE CHONG'
                while fading
                    wait 0 ms
                end
                0417: start_mission M25_FAREWELLCHUNKYLEECHONG
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @JOEY_MISSION2_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @JOEY_MISSION2_LOOP_INNER
                end
            end
        end
    end
end
jump @JOEY_MISSION2_LOOP_INNER

:JOEY_MISSION3_LOOP
03A4: name_thread 'JM3'

:JOEY_MISSION3_LOOP_INNER
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $VAN_HEIST_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'JM3' 5000 ms 2   // 'VAN HEIST'
                while fading
                    wait 0 ms
                end
                0417: start_mission M26_VANHEIST
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @JOEY_MISSION3_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @JOEY_MISSION3_LOOP_INNER
                end
            end
        end
    end
end
jump @JOEY_MISSION3_LOOP_INNER

:JOEY_MISSION4_LOOP
03A4: name_thread 'JM4'

:JOEY_MISSION4_LOOP_INNER
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $CIPRIANIS_CHAUFFEUR_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'JM4' 5000 ms 2   // 'CIPRIANI'S CHAUFFEUR'
                while fading
                    wait 0 ms
                end
                0417: start_mission M27_CIPRIANISCHAUFFEUR
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @JOEY_MISSION4_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @JOEY_MISSION4_LOOP_INNER
                end
            end
        end
    end
end
jump @JOEY_MISSION4_LOOP_INNER

:JOEY_MISSION5_LOOP
03A4: name_thread 'JM5'

:JOEY_MISSION5_LOOP_INNER
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $DEAD_SKUNK_IN_THE_TRUNK_COMPLETED == 1
then
    end_thread
end
if and
    0038:   $SALVATORES_CALLED_A_MEETING_COMPLETED == 1
    0038:   $CHAPERONE_COMPLETED == 0
then
    0004: $FLAG_JOEY_MISSION5_TERMINATED = 1
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'JM5' 5000 ms 2   // 'DEAD SKUNK IN THE TRUNK'
                while fading
                    wait 0 ms
                end
                0417: start_mission M28_DEADSKUNKINTHETRUNK
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @JOEY_MISSION5_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @JOEY_MISSION5_LOOP_INNER
                end
            end
        end
    end
end
jump @JOEY_MISSION5_LOOP_INNER

:JOEY_MISSION6_LOOP
03A4: name_thread 'JM6'

:JOEY_MISSION6_LOOP_INNER
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $THE_GETAWAY_COMPLETED == 1
then
    end_thread
end
if and
    0038:   $SALVATORES_CALLED_A_MEETING_COMPLETED == 1
    0038:   $CHAPERONE_COMPLETED == 0
then
    0004: $FLAG_JOEY_MISSION6_TERMINATED = 1
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            00BF: $CURRENT_TIME_HOURS = current_time_hours, $CURRENT_TIME_MINUTES = current_time_minutes
            if and
                0028:   $CURRENT_TIME_HOURS >= 6
                001A:   14 > $CURRENT_TIME_HOURS
            then
                if
                    03EE:   player $PLAYER controllable
                then
                    01B4: set_player $PLAYER can_move 0 (frozen)
                    0169: set_fade_color 0 0 0
                    016A: fade 0  1500 ms
                    03AF: set_streaming 0 (disabled)
                    00BA: text_styled 'JM6' 5000 ms 2   // 'THE GETAWAY'
                    while fading
                        wait 0 ms
                    end
                    0417: start_mission M29_THEGETAWAY
                end
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @JOEY_MISSION6_LOOP_INNER
                end
                while 00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
                    wait 0 ms
                    if
                        8256:   NOT   player $PLAYER defined
                    then
                        jump @JOEY_MISSION6_LOOP_INNER
                    end
                end
            else
                00BC: print_now 'WRONGT2' 5000 ms 1   // ~g~Come back between 06:00 and 14:00 for a job
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 856.69 -870.0 21.0 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @JOEY_MISSION6_LOOP_INNER
                end
                00BF: $CURRENT_TIME_HOURS = current_time_hours, $CURRENT_TIME_MINUTES = current_time_minutes
                if and
                    0028:   $CURRENT_TIME_HOURS >= 6
                    001A:   14 > $CURRENT_TIME_HOURS
                then
                    jump @JOEY_MISSION6_LOOP_INNER
                end
            end
        end
    end
end
jump @JOEY_MISSION6_LOOP_INNER

//#####################################################################################
//#####################################################################################
// END JOEY MONITORS / BEGIN TONI MONITORS
//#####################################################################################
//#####################################################################################

:TONI_MISSION1_LOOP
03A4: name_thread 'TM1'

:TONI_MISSION1_LOOP_INNER
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $TAKING_OUT_THE_LAUNDRY_COMPLETED == 1
    $CHAPERONE_COMPLETED == 1 // added check
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 884.75 -319.688 33.375 radius 1.0 2.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'TM1' 5000 ms 2   // 'TAKING OUT THE LAUNDRY'
                while fading
                    wait 0 ms
                end
                0417: start_mission M30_TAKINGOUTTHELAUNDRY
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @TONI_MISSION1_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 884.75 -319.688 33.375 radius 1.0 2.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @TONI_MISSION1_LOOP_INNER
                end
            end
        end
    end
end
jump @TONI_MISSION1_LOOP_INNER

:TONI_MISSION2_LOOP
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $THE_PICKUP_COMPLETED == 1
    $CHAPERONE_COMPLETED == 1 // added check
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 884.75 -319.688 33.375 radius 1.0 2.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'TM2' 5000 ms 2   // 'THE PICK-UP'
                while fading
                    wait 0 ms
                end
                0417: start_mission M31_THEPICKUP
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @TONI_MISSION2_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 884.75 -319.688 33.375 radius 1.0 2.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @TONI_MISSION2_LOOP
                end
            end
        end
    end
end
jump @TONI_MISSION2_LOOP

:TONI_MISSION3_LOOP
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $SALVATORES_CALLED_A_MEETING_COMPLETED == 1
    $CHAPERONE_COMPLETED == 1 // added check
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 884.75 -319.688 33.375 radius 1.0 2.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'TM3' 5000 ms 2   // 'SALVATORE'S CALLED A MEETING'
                while fading
                    wait 0 ms
                end
                0417: start_mission M32_SALVATORESCALLEDAMEETING
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @TONI_MISSION3_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 884.75 -319.688 33.375 radius 1.0 2.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @TONI_MISSION3_LOOP
                end
            end
        end
    end
end
jump @TONI_MISSION3_LOOP

:TONI_MISSION4_LOOP
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $TRIADS_AND_TRIBULATIONS_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 884.75 -319.688 33.375 radius 1.0 2.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'TM4' 5000 ms 2   // 'TRIADS AND TRIBULATIONS'
                while fading
                    wait 0 ms
                end
                0417: start_mission M33_TRIADSANDTRIBULATIONS
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @TONI_MISSION4_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 884.75 -319.688 33.375 radius 1.0 2.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @TONI_MISSION4_LOOP
                end
            end
        end
    end
end
jump @TONI_MISSION4_LOOP

:TONI_MISSION5_LOOP
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $BLOW_FISH_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 884.75 -319.688 33.375 radius 1.0 2.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'TM5' 5000 ms 2   // 'BLOW FISH'
                while fading
                    wait 0 ms
                end
                0417: start_mission M34_BLOWFISH
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @TONI_MISSION5_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 884.75 -319.688 33.375 radius 1.0 2.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @TONI_MISSION5_LOOP
                end
            end
        end
    end
end
jump @TONI_MISSION5_LOOP

//#####################################################################################
//#####################################################################################
// END TONI MONITORS / BEGIN SALVATORE MONITORS
//#####################################################################################
//#####################################################################################

:FRANKIE_MISSION1_LOOP
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $CHAPERONE_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if or
        00F6:   player $PLAYER 0 near_point_on_foot 1120.6899 -187.25 61.5625 radius 1.0 1.0 2.0
        02B4:   player $PLAYER in_cube_on_foot 1131.1899 -175.0 56.0 1117.88 -172.062 66.0 radius 11.5625 sphere 0
    then
        if and
            0038:   $FLAG_FRANKIE_SWITCHED_OFF == 0
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'FM1' 5000 ms 2   // 'CHAPERONE'
                while fading
                    wait 0 ms
                end
                0417: start_mission M35_CHAPERONE
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @FRANKIE_MISSION1_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 1120.6899 -187.25 61.5625 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @FRANKIE_MISSION1_LOOP
                end
            end
        end
    end
end
jump @FRANKIE_MISSION1_LOOP

:FRANKIE_MISSION2_LOOP
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $CUTTING_THE_GRASS_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if or
        00F6:   player $PLAYER 0 near_point_on_foot 1120.6899 -187.25 61.5625 radius 1.0 1.0 2.0
        02B4:   player $PLAYER in_cube_on_foot 1131.1899 -175.0 56.0 1117.88 -172.062 66.0 radius 11.5625 sphere 0
    then
        if and
            0038:   $FLAG_FRANKIE_SWITCHED_OFF == 0
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'FM2' 5000 ms 2   // 'CUTTING THE GRASS'
                while fading
                    wait 0 ms
                end
                0417: start_mission M36_CUTTINGTHEGRASS
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @FRANKIE_MISSION2_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 1120.6899 -187.25 61.5625 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @FRANKIE_MISSION2_LOOP
                end
            end
        end
    end
end
jump @FRANKIE_MISSION2_LOOP

:FRANKIE_MISSION21_LOOP
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $BOMB_DA_BASE_ACT_I_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if or
        00F6:   player $PLAYER 0 near_point_on_foot 1120.6899 -187.25 61.5625 radius 1.0 1.0 2.0
        02B4:   player $PLAYER in_cube_on_foot 1131.1899 -175.0 56.0 1117.88 -172.062 66.0 radius 11.5625 sphere 0
    then
        if
            0038:   $FLAG_FRANKIE_SWITCHED_OFF == 0
        then
            if
                0038:   $FLAG_PLAYER_ON_MISSION == 0
            then
                if
                    03EE:   player $PLAYER controllable
                then
                    01B4: set_player $PLAYER can_move 0 (frozen)
                    0169: set_fade_color 0 0 0
                    016A: fade 0  1500 ms
                    03AF: set_streaming 0 (disabled)
                    00BA: text_styled 'FM21' 5000 ms 2   // 'BOMB DA BASE: ACT I'
                    while fading
                        wait 0 ms
                    end
                    0417: start_mission M37_BOMBDABASEACTI
                end
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @FRANKIE_MISSION21_LOOP
                end
                while 00F6:   player $PLAYER 0 near_point_on_foot 1120.6899 -187.25 61.5625 radius 1.0 1.0 2.0
                    wait 0 ms
                    if
                        8256:   NOT   player $PLAYER defined
                    then
                        jump @FRANKIE_MISSION21_LOOP
                    end
                end
            end
        else
            00BC: print_now 'FRANGO' 5000 ms 1   // ~g~Salvatore wants you to help Toni deal with the Triads first!
        end
        while 00F6:   player $PLAYER 0 near_point_on_foot 1120.6899 -187.25 61.5625 radius 1.0 1.0 2.0
            wait 0 ms
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @FRANKIE_MISSION21_LOOP
            end
        end
    end
end
jump @FRANKIE_MISSION21_LOOP

:FRANKIE_MISSION3_LOOP
wait $WAIT_TIME ms
if or
    0038:   $LAST_REQUESTS_COMPLETED == 1
    0038:   $BOMB_DA_BASE_ACT_II_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 937.19 -92.875 19.75 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'FM3' 5000 ms 2   // 'BOMB DA BASE: ACT II'
                while fading
                    wait 0 ms
                end
                0417: start_mission M38_BOMBDABASEACTII
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @FRANKIE_MISSION3_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 937.19 -92.875 19.75 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @FRANKIE_MISSION3_LOOP
                end
            end
        end
    end
end
jump @FRANKIE_MISSION3_LOOP

:FRANKIE_MISSION4_LOOP
wait $WAIT_TIME ms
if
    0038:   $LAST_REQUESTS_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if or
        00F6:   player $PLAYER 0 near_point_on_foot 1120.6899 -187.25 61.5625 radius 1.0 1.0 2.0
        02B4:   player $PLAYER in_cube_on_foot 1131.1899 -175.0 56.0 1117.88 -172.062 66.0 radius 11.5625 sphere 0
    then
        if and
            0038:   $FLAG_FRANKIE_SWITCHED_OFF == 0
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'FM4' 5000 ms 2   // 'LAST REQUESTS'
                while fading
                    wait 0 ms
                end
                0417: start_mission M39_LASTREQUESTS
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @FRANKIE_MISSION4_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 1120.6899 -187.25 61.5625 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @FRANKIE_MISSION4_LOOP
                end
            end
        end
    end
end
jump @FRANKIE_MISSION4_LOOP

//#####################################################################################
//#####################################################################################
// END SALVATORE MONITORS / BEGIN ASUKA1 MONITORS
//#####################################################################################
//#####################################################################################

:ASUKA_MISSION1_LOOP
wait $WAIT_TIME ms
if
    0038:   $SAYONARA_SALVATORE_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 188.688 -639.0 22.0625 radius 1.0 4.5 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
            03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'AM1' 5000 ms 2   // 'SAYONARA SALVATORE'
                while fading
                    wait 0 ms
                end
                0417: start_mission M44_SAYONARASALVATORE
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @ASUKA_MISSION1_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 188.688 -639.0 22.0625 radius 1.0 4.5 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @ASUKA_MISSION1_LOOP
                end
            end
        end
    end
end
jump @ASUKA_MISSION1_LOOP

:ASUKA_MISSION2_LOOP
wait $WAIT_TIME ms
if
    0038:   $UNDER_SURVEILLANCE_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 188.688 -639.0 22.0625 radius 1.0 4.5 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'AM2' 5000 ms 2   // 'UNDER SURVEILLANCE'
                while fading
                    wait 0 ms
                end
                0417: start_mission M45_UNDERSURVEILLANCE
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @ASUKA_MISSION2_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 188.688 -639.0 22.0625 radius 1.0 4.5 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @ASUKA_MISSION2_LOOP
                end
            end
        end
    end
end
jump @ASUKA_MISSION2_LOOP

:ASUKA_MISSION3_LOOP
wait $WAIT_TIME ms
if
    0038:   $PAPARAZZI_PURGE_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 188.688 -639.0 22.0625 radius 1.0 4.5 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'AM3' 5000 ms 2   // 'PAPARAZZI PURGE'
                while fading
                    wait 0 ms
                end
                0417: start_mission M46_PAPARAZZIPURGE
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @ASUKA_MISSION3_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 188.688 -639.0 22.0625 radius 1.0 4.5 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @ASUKA_MISSION3_LOOP
                end
            end
        end
    end
end
jump @ASUKA_MISSION3_LOOP

:ASUKA_MISSION4_LOOP
wait $WAIT_TIME ms
if
    0038:   $PAYDAY_FOR_RAY_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 188.688 -639.0 22.0625 radius 1.0 4.5 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'AM4' 5000 ms 2   // 'PAYDAY FOR RAY'
                while fading
                    wait 0 ms
                end
                0417: start_mission M47_PAYDAYFORRAY
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @ASUKA_MISSION4_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 188.688 -639.0 22.0625 radius 1.0 4.5 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @ASUKA_MISSION4_LOOP
                end
            end
        end
    end
end
jump @ASUKA_MISSION4_LOOP

:ASUKA_MISSION5_LOOP
wait $WAIT_TIME ms
if or
    0038:   $GRAND_THEFT_AERO_COMPLETED == 1
    0038:   $TWO_FACED_TANNER_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 188.688 -639.0 22.0625 radius 1.0 4.5 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'AM5' 5000 ms 2   // 'TWO_FACED TANNER'
                while fading
                    wait 0 ms
                end
                0417: start_mission M48_TWOFACEDTANNER
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @ASUKA_MISSION5_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 188.688 -639.0 22.0625 radius 1.0 4.5 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @ASUKA_MISSION5_LOOP
                end
            end
        end
    end
end
jump @ASUKA_MISSION5_LOOP

//#####################################################################################
//#####################################################################################
// END ASUKA1 MONITORS / BEGIN KENJI MONITORS
//#####################################################################################
//#####################################################################################

:KENJI_MISSION1_LOOP
03A4: name_thread 'KM1'

:KENJI_MISSION1_LOOP_INNER
wait $WAIT_TIME ms
if or
    0038:   $KANBU_BUST_OUT_COMPLETED == 1
    0038:   $WAKAGASHIRA_WIPEOUT_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 124.062 -1413.0 32.0625 radius 1.5 1.5 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'KM1' 5000 ms 2   // 'KANBU BUST-OUT'
                while fading
                    wait 0 ms
                end
                0417: start_mission M49_KANBUBUSTOUT
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @KENJI_MISSION1_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 124.062 -1413.0 32.0625 radius 1.5 1.5 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @KENJI_MISSION1_LOOP_INNER
                end
            end
        end
    end
end
jump @KENJI_MISSION1_LOOP_INNER

:KENJI_MISSION2_LOOP
wait $WAIT_TIME ms
if or
    0038:   $GRAND_THEFT_AUTO_COMPLETED == 1
    0038:   $WAKAGASHIRA_WIPEOUT_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 124.062 -1413.0 32.0625 radius 1.5 1.5 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'KM2' 5000 ms 2   // 'GRAND THEFT AUTO'
                while fading
                    wait 0 ms
                end
                0417: start_mission M50_GRANDTHEFTAUTO
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @KENJI_MISSION2_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 124.062 -1413.0 32.0625 radius 1.5 1.5 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @KENJI_MISSION2_LOOP
                end
            end
        end
    end
end
jump @KENJI_MISSION2_LOOP

:KENJI_MISSION3_LOOP
wait $WAIT_TIME ms
if or
    0038:   $DEAL_STEAL_COMPLETED == 1
    0038:   $WAKAGASHIRA_WIPEOUT_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 124.062 -1413.0 32.0625 radius 1.5 1.5 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'KM3' 5000 ms 2   // 'DEAL STEAL'
                while fading
                    wait 0 ms
                end
                0417: start_mission M51_DEALSTEAL
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @KENJI_MISSION3_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 124.062 -1413.0 32.0625 radius 1.5 1.5 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @KENJI_MISSION3_LOOP
                end
            end
        end
    end
end
jump @KENJI_MISSION3_LOOP

:KENJI_MISSION4_LOOP
wait $WAIT_TIME ms
if or
    0038:   $SHIMA_COMPLETED == 1
    0038:   $WAKAGASHIRA_WIPEOUT_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 124.062 -1413.0 32.0625 radius 1.5 1.5 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'KM4' 5000 ms 2   // 'SHIMA'
                while fading
                    wait 0 ms
                end
                0417: start_mission M52_SHIMA
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @KENJI_MISSION4_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 124.062 -1413.0 32.0625 radius 1.5 1.5 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @KENJI_MISSION4_LOOP
                end
            end
        end
    end
end
jump @KENJI_MISSION4_LOOP

:KENJI_MISSION5_LOOP
wait $WAIT_TIME ms
if or
    0038:   $SMACK_DOWN_COMPLETED == 1
    0038:   $WAKAGASHIRA_WIPEOUT_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 124.062 -1413.0 32.0625 radius 1.5 1.5 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'KM5' 5000 ms 2   // 'SMACK DOWN'
                while fading
                    wait 0 ms
                end
                0417: start_mission M53_SMACKDOWN
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @KENJI_MISSION5_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 124.062 -1413.0 32.0625 radius 1.5 1.5 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @KENJI_MISSION5_LOOP
                end
            end
        end
    end
end
jump @KENJI_MISSION5_LOOP

//#####################################################################################
//#####################################################################################
// END KENJI MONITORS / BEGIN RAY MONITORS
//#####################################################################################
//#####################################################################################

:RAY_MISSION1_LOOP
03A4: name_thread 'RM1'

:RAY_MISSION1_LOOP_INNER
wait 0 ms
if
    0038:   $SILENCE_THE_SNEAK_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -296.75 -725.375 28.75 radius 1.1875 1.1875 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                0004: $RAYS_CUTSCENE_FLAG = 1
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'RM1' 5000 ms 2   // 'SILENCE THE SNEAK'
                while fading
                    wait 0 ms
                end
                0417: start_mission M54_SILENCETHESNEAK
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @RAY_MISSION1_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -296.75 -725.375 28.75 radius 1.1875 1.1875 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @RAY_MISSION1_LOOP_INNER
                end
            end
        end
    end
end
jump @RAY_MISSION1_LOOP_INNER

:RAY_MISSION2_LOOP
wait 0 ms
if
    0038:   $ARMS_SHORTAGE_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -296.75 -725.375 28.75 radius 1.1875 1.1875 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                0004: $RAYS_CUTSCENE_FLAG = 1
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'RM2' 5000 ms 2   // 'ARMS SHORTAGE'
                while fading
                    wait 0 ms
                end
                0417: start_mission M55_ARMSSHORTAGE
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @RAY_MISSION2_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -296.75 -725.375 28.75 radius 1.1875 1.1875 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @RAY_MISSION2_LOOP
                end
            end
        end
    end
end
jump @RAY_MISSION2_LOOP

:RAY_MISSION3_LOOP
wait 0 ms
if
    0038:   $EVIDENCE_DASH_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -296.75 -725.375 28.75 radius 1.1875 1.1875 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                0004: $RAYS_CUTSCENE_FLAG = 1
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'RM3' 5000 ms 2   // 'EVIDENCE DASH'
                while fading
                    wait 0 ms
                end
                0417: start_mission M56_EVIDENCEDASH
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @RAY_MISSION3_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -296.75 -725.375 28.75 radius 1.1875 1.1875 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @RAY_MISSION3_LOOP
                end
            end
        end
    end
end
jump @RAY_MISSION3_LOOP

:RAY_MISSION4_LOOP
wait 0 ms
if
    0038:   $GONE_FISHING_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -296.75 -725.375 28.75 radius 1.1875 1.1875 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                0004: $RAYS_CUTSCENE_FLAG = 1
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'RM4' 5000 ms 2   // 'GONE FISHING'
                while fading
                    wait 0 ms
                end
                0417: start_mission M57_GONEFISHING
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @RAY_MISSION4_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -296.75 -725.375 28.75 radius 1.1875 1.1875 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @RAY_MISSION4_LOOP
                end
            end
        end
    end
end
jump @RAY_MISSION4_LOOP

:RAY_MISSION5_LOOP
wait 0 ms
if
    0038:   $PLASTER_BLASTER_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -296.75 -725.375 28.75 radius 1.1875 1.1875 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                0004: $RAYS_CUTSCENE_FLAG = 1
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'RM5' 5000 ms 2   // 'PLASTER BLASTER'
                while fading
                    wait 0 ms
                end
                0417: start_mission M58_PLASTERBLASTER
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @RAY_MISSION5_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -296.75 -725.375 28.75 radius 1.1875 1.1875 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @RAY_MISSION5_LOOP
                end
            end
        end
    end
end
jump @RAY_MISSION5_LOOP

:RAY_MISSION6_LOOP
wait 0 ms
if
    0038:   $MARKED_MAN_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -296.75 -725.375 28.75 radius 1.1875 1.1875 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'RM6' 5000 ms 2   // 'MARKED MAN'
                while fading
                    wait 0 ms
                end
                0417: start_mission M59_MARKEDMAN
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @RAY_MISSION6_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -296.75 -725.375 28.75 radius 1.1875 1.1875 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @RAY_MISSION6_LOOP
                end
            end
        end
    end
end
jump @RAY_MISSION6_LOOP

//#####################################################################################
//#####################################################################################
// END RAY MONITORS / BEGIN DONALD LOVE MONITORS
//#####################################################################################
//#####################################################################################

:LOVE_MISSION1_LOOP
wait $WAIT_TIME ms
if
    0038:   $LIBERATOR_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'LOVE1' 5000 ms 2   // 'LIBERATOR'
                while fading
                    wait 0 ms
                end
                0417: start_mission M60_LIBERATOR
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @LOVE_MISSION1_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @LOVE_MISSION1_LOOP
                end
            end
        end
    end
end
jump @LOVE_MISSION1_LOOP

:LOVE_MISSION2_LOOP
wait $WAIT_TIME ms
if
    0038:   $WAKAGASHIRA_WIPEOUT_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'LOVE2' 5000 ms 2   // 'WAKA-GASHIRA WIPEOUT!'
                while fading
                    wait 0 ms
                end
                0417: start_mission M61_WAKAGASHIRAWIPEOUT
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @LOVE_MISSION2_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @LOVE_MISSION2_LOOP
                end
            end
        end
    end
end
jump @LOVE_MISSION2_LOOP

:LOVE_MISSION3_LOOP
wait $WAIT_TIME ms
if
    0038:   $A_DROP_IN_THE_OCEAN_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'LOVE3' 5000 ms 2   // 'A DROP IN THE OCEAN'
                while fading
                    wait 0 ms
                end
                0417: start_mission M62_ADROPINTHEOCEAN
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @LOVE_MISSION3_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @LOVE_MISSION3_LOOP
                end
            end
        end
    end
end
jump @LOVE_MISSION3_LOOP

:LOVE_MISSION4_LOOP
wait $WAIT_TIME ms
if
    0038:   $GRAND_THEFT_AERO_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'LOVE4' 5000 ms 2   // 'GRAND THEFT AERO'
                while fading
                    wait 0 ms
                end
                0417: start_mission M67_GRANDTHEFTAERO
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @LOVE_MISSION4_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @LOVE_MISSION4_LOOP
                end
            end
        end
    end
end
jump @LOVE_MISSION4_LOOP

:LOVE_MISSION5_LOOP
wait $WAIT_TIME ms
if
    0038:   $ESCORT_SERVICE_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'LOVE5' 5000 ms 2   // 'ESCORT SERVICE'
                while fading
                    wait 0 ms
                end
                0417: start_mission M68_ESCORTSERVICE
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @LOVE_MISSION5_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @LOVE_MISSION5_LOOP
                end
            end
        end
    end
end
jump @LOVE_MISSION5_LOOP

:LOVE_MISSION6_LOOP
wait $WAIT_TIME ms
if
    0038:   $DECOY_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'LOVE6' 5000 ms 2   // 'DECOY'
                while fading
                    wait 0 ms
                end
                0417: start_mission M69_DECOY
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @LOVE_MISSION6_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @LOVE_MISSION6_LOOP
                end
            end
        end
    end
end
jump @LOVE_MISSION6_LOOP

:LOVE_MISSION7_LOOP
wait $WAIT_TIME ms
if
    0038:   $LOVES_DISAPPEARANCE_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'LOVE7' 5000 ms 2   // LOVE'S DISAPPEARANCE
                while fading
                    wait 0 ms
                end
                0417: start_mission M70_LOVESDISAPPERANCE
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @LOVE_MISSION7_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -248.25 -1548.5601 34.25 radius 2.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @LOVE_MISSION7_LOOP
                end
            end
        end
    end
end
jump @LOVE_MISSION7_LOOP

//#####################################################################################
//#####################################################################################
// END DONALD LOVE MONITORS / BEGIN ASUKA2 MONITORS
//#####################################################################################
//#####################################################################################

:ASUKA_SUBURBAN_MISSION1_LOOP
03A4: name_thread 'AS1'

:ASUKA_SUBURBAN_MISSION1_LOOP_INNER
wait $WAIT_TIME ms
if
    0038:   $BAIT_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 32.25 -328.062 25.5 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'AS1' 15000 ms 2   // 'BAIT'
                while fading
                    wait 0 ms
                end
                0417: start_mission M71_BAIT
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @ASUKA_SUBURBAN_MISSION1_LOOP_INNER
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 32.25 -328.062 25.5 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @ASUKA_SUBURBAN_MISSION1_LOOP_INNER
                end
            end
        end
    end
end
jump @ASUKA_SUBURBAN_MISSION1_LOOP_INNER

:ASUKA_SUBURBAN_MISSION2_LOOP
wait $WAIT_TIME ms
if
    0038:   $ESPRESSO_2_GO_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 32.25 -328.062 25.5 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'AS2' 5000 ms 2   // 'ESPRESSO-2-GO!'
                while fading
                    wait 0 ms
                end
                0417: start_mission M72_ESPRESSO2GO
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @ASUKA_SUBURBAN_MISSION2_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 32.25 -328.062 25.5 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @ASUKA_SUBURBAN_MISSION2_LOOP
                end
            end
        end
    end
end
jump @ASUKA_SUBURBAN_MISSION2_LOOP

:ASUKA_SUBURBAN_MISSION3_LOOP
wait $WAIT_TIME ms
if
    0038:   $SAM_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot 32.25 -328.062 25.5 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                03AF: set_streaming 0 (disabled)
                00BA: text_styled 'AS3' 5000 ms 2   // 'S.A.M.'
                while fading
                    wait 0 ms
                end
                0417: start_mission M73_SAM
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @ASUKA_SUBURBAN_MISSION3_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 32.25 -328.062 25.5 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @ASUKA_SUBURBAN_MISSION3_LOOP
                end
            end
        end
    end
end
jump @ASUKA_SUBURBAN_MISSION3_LOOP

//#####################################################################################
//#####################################################################################
// END ASUKA2 MONITORS / BEGIN THE EXCHANGE MONITOR
//#####################################################################################
//#####################################################################################

:CAT_MISSION1_LOOP
03A4: name_thread 'CAT2'

:CAT_MISSION1_LOOP_INNER
wait $WAIT_TIME ms
if
    0038:   $THE_EXCHANGE_COMPLETED == 1
then
    end_thread
end
if
    0256:   player $PLAYER defined
then
    if
        00F6:   player $PLAYER 0 near_point_on_foot -697.75 246.5 66.0 radius 4.5 4.5 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if or
                0038:   $NICKED_HALF_A_MIL_BEFORE == 1
                010A:   player $PLAYER money > 499999
            then
                if
                    03EE:   player $PLAYER controllable
                then
                    01B4: set_player $PLAYER can_move 0 (frozen)
                    0169: set_fade_color 0 0 0
                    016A: fade 0  1500 ms
                    03AF: set_streaming 0 (disabled)
                    00BA: text_styled 'CAT2' 5000 ms 2   // 'THE EXCHANGE'
                    while fading
                        wait 0 ms
                    end
                    0417: start_mission M79_THEEXCHANGE
                end
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @CAT_MISSION1_LOOP_INNER
                end
                while 00F6:   player $PLAYER 0 near_point_on_foot -697.75 246.5 66.0 radius 4.5 4.5 2.0
                    wait 0 ms
                    if
                        8256:   NOT   player $PLAYER defined
                    then
                        jump @CAT_MISSION1_LOOP_INNER
                    end
                end
            else
                if
                    0038:   $NICKED_HALF_A_MIL_BEFORE == 0
                then
                    00BC: print_now 'CAT_MON' 5000 ms 1   // ~g~You don't have enough money yet. You need $500,000.
                end
                while 00F6:   player $PLAYER 0 near_point_on_foot -697.75 246.5 66.0 radius 4.5 4.5 2.0
                    wait 0 ms
                    if
                        8256:   NOT   player $PLAYER defined
                    then
                        jump @CAT_MISSION1_LOOP_INNER
                    end
                end
            end
        end
    end
end
jump @CAT_MISSION1_LOOP_INNER

//#####################################################################################
//#####################################################################################
// END THE EXCHANGE MONITOR / BEGIN 4x4 MISSION MONITORS
//#####################################################################################
//#####################################################################################

:4x4_MISSION1_LOOP
03A4: name_thread 'O4X4_1'

:4x4_MISSION1_LOOP_INNER
wait $WAIT_TIME ms
if
    0038:   $PATRIOT_PLAYGROUND_COMPLETED == 0
then
    0004: $PATRIOT_PLAYGROUND_BEST_TIME = 300
end
if
    0256:   player $PLAYER defined
then
    if and
        0038:   $FLAG_PLAYER_ON_MISSION == 0
        0121:   player $PLAYER in_zone 'S_VIEW'
    then
        if and
            00DE:   player $PLAYER driving_vehicle_type #PATRIOT
            8056:   NOT   player $PLAYER 0 in_rectangle 959.0 -656.0 981.0 -638.0
        then
            0004: $ON_PATRIOT_PLAYGROUND_MISSION = 1
        end
        if and
            00DE:   player $PLAYER driving_vehicle_type #PATRIOT
            0038:   $ON_PATRIOT_PLAYGROUND_MISSION == 0
        then
            00BA: text_styled 'T4X4_1' 5000 ms 2   // 'PATRIOT PLAYGROUND'
            wait 0 ms
            0417: start_mission M07_PATRIOTPLAYGROUND
        end
        if
            0256:   player $PLAYER defined
        then
            if
                80E0:   NOT   player $PLAYER driving
            then
                0004: $ON_PATRIOT_PLAYGROUND_MISSION = 0
            end
        end
    end
end
jump @4x4_MISSION1_LOOP_INNER

:4x4_MISSION2_LOOP
03A4: name_thread 'O4X4_2'

:4x4_MISSION2_LOOP_INNER
wait $WAIT_TIME ms
if
    0038:   $A_RIDE_IN_THE_PARK_COMPLETED == 0
then
    0004: $A_RIDE_IN_THE_PARK_BEST_TIME = 120
end
if
    0256:   player $PLAYER defined
then
    if and
        0038:   $FLAG_PLAYER_ON_MISSION == 0
        0121:   player $PLAYER in_zone 'PARK'
    then
        if and
            00DE:   player $PLAYER driving_vehicle_type #LANDSTAL
            8056:   NOT   player $PLAYER 0 in_rectangle -277.0 -585.0 -267.0 -595.0
        then
            0004: $ON_A_RIDE_IN_THE_PARK_MISSION = 1
        end
        if and
            00DE:   player $PLAYER driving_vehicle_type #LANDSTAL
            0038:   $ON_A_RIDE_IN_THE_PARK_MISSION == 0
        then
            00BA: text_styled 'T4X4_2' 5000 ms 2   // 'A Ride In The Park'
            wait 0 ms
            0417: start_mission M08_ARIDEINTHEPARK
        end
        if
            0256:   player $PLAYER defined
        then
            if
                80E0:   NOT   player $PLAYER driving
            then
                0004: $ON_A_RIDE_IN_THE_PARK_MISSION = 0
            end
        end
    end
end
jump @4x4_MISSION2_LOOP_INNER

:4x4_MISSION3_LOOP
03A4: name_thread 'O4X4_3'

:4x4_MISSION3_LOOP_INNER
wait $WAIT_TIME ms
if
    0038:   $GRIPPED_COMPLETED == 0
then
    0004: $GRIPPED_BEST_TIME = 300
end
if
    0256:   player $PLAYER defined
then
    if and
        0038:   $FLAG_PLAYER_ON_MISSION == 0
        0056:   player $PLAYER 0 in_rectangle -565.0 255.0 -545.0 275.0
    then
        if and
            00DE:   player $PLAYER driving_vehicle_type #PATRIOT
            8056:   NOT   player $PLAYER 0 in_rectangle -565.0 255.0 -545.0 275.0
        then
            0004: $ON_GRIPPED_MISSION = 1
        end
        if and
            00DE:   player $PLAYER driving_vehicle_type #PATRIOT
            0038:   $ON_GRIPPED_MISSION == 0
        then
            00BA: text_styled 'T4X4_3' 5000 ms 2   // 'GRIPPED!'
            wait 0 ms
            0417: start_mission M09_GRIPPED
        end
        if
            0256:   player $PLAYER defined
        then
            if
                80E0:   NOT   player $PLAYER driving
            then
                0004: $ON_GRIPPED_MISSION = 0
            end
        end
    end
end
jump @4x4_MISSION3_LOOP_INNER

:4x4_MISSION4_LOOP
03A4: name_thread 'O4X4_4'

:4x4_MISSION4_LOOP_INNER
wait $WAIT_TIME ms
if
    0038:   $MULTISTOREY_MAYHEM_COMPLETED == 0
then
    0004: $MULTISTOREY_MAYHEM_BEST_TIME = 120
end
if
    0256:   player $PLAYER defined
then
    if and
        0038:   $FLAG_PLAYER_ON_MISSION == 0
        0121:   player $PLAYER in_zone 'COM_EAS'
    then
        if and
            00DE:   player $PLAYER driving_vehicle_type #STALLION
            8056:   NOT   player $PLAYER 0 in_rectangle -97.0 -612.0 -51.0 -469.0  //3rd was -68.0
        then
            0004: $ON_MULTISTOREY_MAYHEM_MISSION = 1
        end
        if and
            00DE:   player $PLAYER driving_vehicle_type #STALLION
            0038:   $ON_MULTISTOREY_MAYHEM_MISSION == 0
        then
            00BA: text_styled 'T4X4_4' 5000 ms 2   // 'MULTISTOREY MAYHEM'
            wait 0 ms
            0417: start_mission M10_MULTISTOREYMAYHEM
        end
        if
            0256:   player $PLAYER defined
        then
            if
                80E0:   NOT   player $PLAYER driving
            then
                0004: $ON_MULTISTOREY_MAYHEM_MISSION = 0
            end
        end
    end
end
jump @4x4_MISSION4_LOOP_INNER

//#####################################################################################
//#####################################################################################
// END 4x4 MISSION MONITORS / BEGIN RC TRIGGERS
//#####################################################################################
//#####################################################################################

:RC_LOOP
03A4: name_thread 'RCTRIG'

while true
    wait 0 ms
    if and
        0256:   player $PLAYER defined
        0038:   $FLAG_JUST_DONE_RC_MISSION == 0
        0038:   $FLAG_PLAYER_ON_MISSION == 0
    then
        if
            00DE:   player $PLAYER driving_vehicle_type #TOYZ
        then
            if
                00F5:   player $PLAYER 0 near_point 679.0 -120.0 11.0 radius 5.0 5.0 5.0
            then
                00BA: text_styled 'RC1' 5000 ms 2   // 'DIABLO DESTRUCTION'
                0417: start_mission M03_DIABLODESTRUCTION
            end
            if
                00F5:   player $PLAYER 0 near_point 823.0 -309.0 29.0 radius 5.0 5.0 5.0
            then
                00BA: text_styled 'RC2' 5000 ms 2   // 'MAFIA MASSACRE'
                 0417: start_mission M04_MAFIAMASSACRE
            end
            if
                00F5:   player $PLAYER 0 near_point -971.0 65.0 25.0 radius 5.0 5.0 5.0
            then
                00BA: text_styled 'RC4' 5000 ms 2   // 'RUMPO RAMPAGE'
                0417: start_mission M05_RUMPORAMPAGE
            end
            if
                00F5:   player $PLAYER 0 near_point 31.0 -1312.0 32.0 radius 5.0 5.0 5.0
            then
                00BA: text_styled 'RC3' 5000 ms 2   // 'CASINO CALAMITY'
                0417: start_mission M06_CASINOCALAMITY
            end
        end
    end
    if
        80DE:   NOT   player $PLAYER driving_vehicle_type #TOYZ
    then
        0004: $FLAG_JUST_DONE_RC_MISSION = 0
    end
end

//#####################################################################################
//#####################################################################################
// END RC TRIGGERS / BEGIN DIABLO MONITORS
//#####################################################################################
//#####################################################################################

:DIABLO_PHONE_START
03A4: name_thread 'DIAB_PH'

wait 10000 ms
while true
    if or
        8256:  NOT  player $PLAYER defined
        83C6:  NOT  is_collision_in_memory 1
        8038:  NOT  $FLAG_PLAYER_ON_MISSION == 0
    jf break
    wait 0 ms
end
if
    82BD:   NOT   debug_mode == DEBUG_SKIPHELP
then
    014D: add_pager_message 'DIAB1_A'  140  2  0    // El Burro wants to offer you an opportunity. Get to the payphone in Hepburn Heights if you want more info.
end
004F: create_thread @DIABLO_RADAR               //El Burro starter
004F: create_thread @DIABLO_MISSION1_LOOP       //TURISMO
//004F: create_thread @DIABLO_MISSION2_LOOP       //I SCREAM YOU SCREAM
//004F: create_thread @DIABLO_MISSION3_LOOP       //TRIAL BY FIRE
//004F: create_thread @DIABLO_MISSION4_LOOP       //BIG N VEINY
end_thread

:DIABLO_RADAR
03A4: name_thread 'DIAB_BP'

while true
    wait 1000 ms
    if
        0256:   player $PLAYER defined
    then
        if
            03C6:   is_collision_in_memory 1
        then
            if
                0038:   $BIG_N_VEINY_COMPLETED == 1
            then
                end_thread
            end
            if
                0038:   $DIABLOS_RADAR_DISPLAYED == 0
            then
                0164: remove_blip $DIABLO_PHONE_MARKER
                02A7: $DIABLO_PHONE_MARKER = create_icon_marker_and_sphere 11 at 603.375 -230.5 -100.0
                0004: $DIABLOS_RADAR_DISPLAYED = 1
            end
         else
            if
                0038:   $DIABLOS_RADAR_DISPLAYED == 1
            then
                0164: remove_blip $DIABLO_PHONE_MARKER
                0004: $DIABLOS_RADAR_DISPLAYED = 0
            end
        end
    end
end //while

:DIABLO_MISSION1_LOOP
wait $WAIT_TIME ms
if
    0038:   $TURISMO_COMPLETED == 1
then
    if
        0038:   $BIG_N_VEINY_COMPLETED == 0
    then
        024E: disable_phone $PHONE_DIABLOS
        end_thread
    end
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0405: enable_phone $PHONE_DIABLOS
else
    024E: disable_phone $PHONE_DIABLOS
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot 603.375 -230.5 9.875 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_DIABLOS
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0 ()  1500 ms
                00BA: text_styled 'DIAB1' 5000 ms 2   // TURISMO
                while fading
                    wait 0 ms
                end
                0417: start_mission M40_TURISMO
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @DIABLO_MISSION1_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 603.375 -230.5 9.875 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @DIABLO_MISSION1_LOOP
                end
            end
        end
    end
end
jump @DIABLO_MISSION1_LOOP

:DIABLO_MISSION2_LOOP
wait $WAIT_TIME ms
if
    0038:   $I_SCREAM_YOU_SCREAM_COMPLETED == 1
then
    024E: disable_phone $PHONE_DIABLOS
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0405: enable_phone $PHONE_DIABLOS
else
    024E: disable_phone $PHONE_DIABLOS
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot 603.375 -230.5 9.875 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_DIABLOS
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                00BA: text_styled 'DIAB2' 5000 ms 2   // 'I SCREAM YOU SCREAM'
                while fading
                    wait 0 ms
                end
                0417: start_mission M41_ISCREAMYOUSCREAM
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @DIABLO_MISSION2_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 603.375 -230.5 9.875 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @DIABLO_MISSION2_LOOP
                end
            end
        end
    end
end
jump @DIABLO_MISSION2_LOOP

:DIABLO_MISSION3_LOOP
wait $WAIT_TIME ms
if
    0038:   $TRIAL_BY_FIRE_COMPLETED == 1
then
    024E: disable_phone $PHONE_DIABLOS
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0405: enable_phone $PHONE_DIABLOS
else
    024E: disable_phone $PHONE_DIABLOS
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot 603.375 -230.5 9.875 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_DIABLOS
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                00BA: text_styled 'DIAB3' 5000 ms 2   // 'TRIAL BY FIRE'
                while fading
                    wait 0 ms
                end
                0417: start_mission M42_TRIALBYFIRE
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @DIABLO_MISSION3_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 603.375 -230.5 9.875 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @DIABLO_MISSION3_LOOP
                end
            end
        end
    end
end
jump @DIABLO_MISSION3_LOOP

:DIABLO_MISSION4_LOOP
wait $WAIT_TIME ms
if
    0038:   $BIG_N_VEINY_COMPLETED == 1
then
    024E: disable_phone $PHONE_DIABLOS
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0405: enable_phone $PHONE_DIABLOS
else
    024E: disable_phone $PHONE_DIABLOS
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot 603.375 -230.5 9.875 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_DIABLOS
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                00BA: text_styled 'DIAB4' 5000 ms 2   // 'BIG'N'VEINY'
                while fading
                    wait 0 ms
                end
                0417: start_mission M43_BIGNVEINY
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @DIABLO_MISSION4_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot 603.375 -230.5 9.875 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @DIABLO_MISSION4_LOOP
                end
            end
        end
    end
end
jump @DIABLO_MISSION4_LOOP

//#####################################################################################
//#####################################################################################
// END DIABLO MONITORS / BEGIN YARDIE MONITORS
//#####################################################################################
//#####################################################################################

:YARDIE_PHONE_START
03A4: name_thread 'YARD_PH'

wait 10000 ms
while true
    if or
        8256:  NOT  player $PLAYER defined
        83C6:  NOT  is_collision_in_memory 2
        8038:  NOT  $FLAG_PLAYER_ON_MISSION == 0
    jf break
    wait 0 ms
end
if
    82BD:   NOT   debug_mode == DEBUG_SKIPHELP
then
    014D: add_pager_message 'YD_P'  140  2  0    // King Courtney would like a word. Get to the payphone in Aspatria!!
end
0459: end_thread_named 'YARD_BP'
0164: disable_marker $YARDIE_PHONE_MARKER
004F: create_thread @YARDIE_RADAR                   //Yardie starter
004F: create_thread @YARDIE_MISSION1_LOOP           //BLING BLING SCRAMBLE
//004F: create_thread @YARDIE_MISSION2_LOOP           //UZI RIDER
//004F: create_thread @YARDIE_MISSION3_LOOP           //GANG CAR ROUND UP
//004F: create_thread @YARDIE_MISSION4_LOOP           //KINGDOM COME
end_thread

:YARDIE_RADAR
03A4: name_thread 'YARD_BP'

while true
    wait 1000 ms
    if
        0256:   player $PLAYER defined
    then
        if
            03C6:   is_collision_in_memory 2  // integer values
        then
            if
                0038:   $KINGDOM_COME_COMPLETED == 1  // integer values
            then
                end_thread
            end
            if
                0038:   $YARDIES_RADAR_DISPLAYED == 0  // integer values
            then
                0164: disable_marker $YARDIE_PHONE_MARKER
                02A7: $YARDIE_PHONE_MARKER = create_icon_marker_and_sphere 15 at -214.688 -272.062 22.0625
                0004: $YARDIES_RADAR_DISPLAYED = 1  // integer values
            end
        else
            if
                0038:   $YARDIES_RADAR_DISPLAYED == 1  // integer values
            then
                0164: disable_marker $YARDIE_PHONE_MARKER
                0004: $YARDIES_RADAR_DISPLAYED = 0  // integer values
            end
        end
    end
end //while

:YARDIE_MISSION1_LOOP
wait $WAIT_TIME ms
if
    0038:   $BLING_BLING_SCRAMBLE_COMPLETED == 1
then
    if
        0038:   $KINGDOM_COME_COMPLETED == 0
    then
        024E: disable_phone $PHONE_YARDIES
        end_thread
    end
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0405: enable_phone $PHONE_YARDIES
else
    024E: disable_phone $PHONE_YARDIES
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot -214.688 -272.062 22.0625 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_YARDIES
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                00BA: text_styled 'YD1' 15000 ms 2   // 'BLING-BLING SCRAMBLE'
                while fading
                    wait 0 ms
                end
                0417: start_mission M63_BLINGBLINGSCRAMBLE
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @YARDIE_MISSION1_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -214.688 -272.062 22.0625 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @YARDIE_MISSION1_LOOP
                end
            end
        end
    end
end
jump @YARDIE_MISSION1_LOOP

:YARDIE_MISSION2_LOOP
wait $WAIT_TIME ms
if
    0038:   $UZI_RIDER_COMPLETED == 1
then
    024E: disable_phone $PHONE_YARDIES
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0405: enable_phone $PHONE_YARDIES
else
    024E: disable_phone $PHONE_YARDIES
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot -214.688 -272.062 22.0625 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_YARDIES
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                00BA: text_styled 'YD2' 15000 ms 2   // 'UZI RIDER'
                while fading
                    wait 0 ms
                end
                0417: start_mission M64_UZIRIDER
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @YARDIE_MISSION2_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -214.688 -272.062 22.0625 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @YARDIE_MISSION2_LOOP
                end
            end
        end
    end
end
jump @YARDIE_MISSION2_LOOP

:YARDIE_MISSION3_LOOP
wait $WAIT_TIME ms
if
    0038:   $GANGCAR_ROUNDUP_COMPLETED == 1
then
    024E: disable_phone $PHONE_YARDIES
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0405: enable_phone $PHONE_YARDIES
else
    024E: disable_phone $PHONE_YARDIES
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot -214.688 -272.062 22.0625 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_YARDIES
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                00BA: text_styled 'YD3' 15000 ms 2   // 'GANGCAR ROUND-UP'
                while fading
                    wait 0 ms
                end
                0417: start_mission M65_GANGCARROUNDUP
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @YARDIE_MISSION3_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -214.688 -272.062 22.0625 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @YARDIE_MISSION3_LOOP
                end
            end
        end
    end
end
jump @YARDIE_MISSION3_LOOP

:YARDIE_MISSION4_LOOP
wait $WAIT_TIME ms
if
    0038:   $KINGDOM_COME_COMPLETED == 1
then
    024E: disable_phone $PHONE_YARDIES
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0405: enable_phone $PHONE_YARDIES
else
    024E: disable_phone $PHONE_YARDIES
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot -214.688 -272.062 22.0625 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_YARDIES
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0  1500 ms
                00BA: text_styled 'YD4' 15000 ms 2   // 'KINGDOM COME'
                while fading
                    wait 0 ms
                end
                0417: start_mission M66_KINGDOMCOME
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @YARDIE_MISSION4_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -214.688 -272.062 22.0625 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @YARDIE_MISSION4_LOOP
                end
            end
        end
    end
end
jump @YARDIE_MISSION4_LOOP

//#####################################################################################
//#####################################################################################
// END YARDIE MONITORS / BEGIN HOODS MONITORS
//#####################################################################################
//#####################################################################################

:HOOD_PHONE_START
03A4: name_thread 'HOOD_PH'

wait 10000 ms
while true
    if or
        8256:  NOT  player $PLAYER defined
        83C6:  NOT  is_collision_in_memory 3
        8038:  NOT  $FLAG_PLAYER_ON_MISSION == 0
    jf break
    wait 0 ms
end
if
    82BD:   NOT   debug_mode == DEBUG_SKIPHELP
then
    014D: add_pager_message 'HOOD1_A'  140  2  0    // Get to the payphone in Wichita Gardens and we'll talk business.
end
004F: create_thread @HOODS_RADAR                  //starter Hoods
004F: create_thread @HOODS_MISSION1_LOOP          //UZI MONEY
//004F: create_thread @HOODS_MISSION2_LOOP          //TOYMINATOR
//004F: create_thread @HOODS_MISSION3_LOOP          //RIGGED TO BLOW
//004F: create_thread @HOODS_MISSION4_LOOP          //BULLION RUN
//004F: create_thread @HOODS_MISSION5_LOOP          //RUMBLE
end_thread

:HOODS_RADAR
03A4: name_thread 'HOOD_BP'

while true
    wait 1000 ms
    if
        0256:   player $PLAYER defined
    then
        if
            03C6:   is_collision_in_memory 3
        then
            if
                0038:   $RUMBLE_COMPLETED == 1
            then
                end_thread
            end
            if
                0038:   $HOODS_RADAR_DISPLAYED == 0
            then
                0164: remove_blip $HOODS_PHONE_MARKER
                02A7: $HOODS_PHONE_MARKER = create_icon_marker_and_sphere 12 at -778.5 -6.0625 9.75
                0004: $HOODS_RADAR_DISPLAYED = 1
            end
        else
            if
                0038:   $HOODS_RADAR_DISPLAYED == 1
            then
                0164: remove_blip $HOODS_PHONE_MARKER
                0004: $HOODS_RADAR_DISPLAYED = 0
            end
        end
    end
end //while

:HOODS_MISSION1_LOOP
wait $WAIT_TIME ms
if
    0038:   $UZI_MONEY_COMPLETED == 1
then
    024E: disable_phone $PHONE_HOODS
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0405: enable_phone $PHONE_HOODS
else
    024E: disable_phone $PHONE_HOODS
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot -778.5 -6.0625 9.75 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_HOODS
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0 ()  1500 ms
                00BA: text_styled 'HM_1' 5000 ms 2   // 'UZI MONEY'
                while fading
                    wait 0 ms
                end
                0419: $UZI_MONEY_OLD_AMMO = player $PLAYER weapon 23 ammo
                0417: start_mission M74_UZIMONEY
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @HOODS_MISSION1_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -778.5 -6.0625 9.75 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @HOODS_MISSION1_LOOP
                end
            end
        end
    end
end
jump @HOODS_MISSION1_LOOP

:HOODS_MISSION2_LOOP
wait $WAIT_TIME ms
if
    0038:   $TOYMINATOR_COMPLETED == 1
then
    024E: disable_phone $PHONE_HOODS
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0405: enable_phone $PHONE_HOODS
else
    024E: disable_phone $PHONE_HOODS
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot -778.5 -6.0625 9.75 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_HOODS
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0 ()  1500 ms
                00BA: text_styled 'HM_2' 5000 ms 2   // 'TOYMINATOR'
                while fading
                    wait 0 ms
                end
                0417: start_mission M75_TOYMINATOR
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @HOODS_MISSION2_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -778.5 -6.0625 9.75 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @HOODS_MISSION2_LOOP
                end
            end
        end
    end
end
jump @HOODS_MISSION2_LOOP

:HOODS_MISSION3_LOOP
wait $WAIT_TIME ms
if
    0038:   $RIGGED_TO_BLOW_COMPLETED == 1
then
    if
        0038:   $RUMBLE_COMPLETED == 0
    then
        024E: disable_phone $PHONE_HOODS
        end_thread
    end
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0405: enable_phone $PHONE_HOODS
else
    024E: disable_phone $PHONE_HOODS
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot -778.5 -6.0625 9.75 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_HOODS
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0 ()  1500 ms
                00BA: text_styled 'HM_3' 5000 ms 2   // 'RIGGED TO BLOW'
                while fading
                    wait 0 ms
                end
                0417: start_mission M76_RIGGEDTOBLOW
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @HOODS_MISSION3_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -428.5 -6.0625 9.75 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @HOODS_MISSION3_LOOP
                end
            end
        end
    end
end
jump @HOODS_MISSION3_LOOP

:HOODS_MISSION4_LOOP
wait $WAIT_TIME ms
if
    0038:   $BULLION_RUN_COMPLETED == 1
then
    024E: disable_phone $PHONE_HOODS
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0405: enable_phone $PHONE_HOODS
else
    024E: disable_phone $PHONE_HOODS
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot -778.5 -6.0625 9.75 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_HOODS
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0 ()  1500 ms
                00BA: text_styled 'HM_4' 5000 ms 2   // 'BULLION RUN'
                while fading
                    wait 0 ms
                end
                0417: start_mission M77_BULLIONRUN
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @HOODS_MISSION4_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -778.5 -6.0625 9.75 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @HOODS_MISSION4_LOOP
                end
            end
        end
    end
end
jump @HOODS_MISSION4_LOOP

:HOODS_MISSION5_LOOP
wait $WAIT_TIME ms
if
    0038:   $RUMBLE_COMPLETED == 1
then
    024E: disable_phone $PHONE_HOODS
    end_thread
end
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0405: enable_phone $PHONE_HOODS
else
    024E: disable_phone $PHONE_HOODS
end
if
    0256:   player $PLAYER defined
then
    if
        00F9:   player $PLAYER stopped 0 near_point_on_foot -778.5 -6.0625 9.75 radius 1.0 1.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03EE:   player $PLAYER controllable
            then
                024E: disable_phone $PHONE_HOODS
                01B4: set_player $PLAYER can_move 0 (frozen)
                0169: set_fade_color 0 0 0
                016A: fade 0 ()  1500 ms
                00BA: text_styled 'HM_5' 5000 ms 2   // 'RUMBLE'
                while fading
                    wait 0 ms
                end
                0417: start_mission M78_RUMBLE
            end
            if
                8256:   NOT   player $PLAYER defined
            then
                jump @HOODS_MISSION5_LOOP
            end
            while 00F6:   player $PLAYER 0 near_point_on_foot -778.5 -6.0625 9.75 radius 1.0 1.0 2.0
                wait 0 ms
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @HOODS_MISSION5_LOOP
                end
            end
        end
    end
end
jump @HOODS_MISSION5_LOOP

//#####################################################################################
//#####################################################################################
// END HOODS MONITORS / BEGIN PARAMEDIC MONITOR
//#####################################################################################
//#####################################################################################

:PAREMEDIC_LOOP
03A4: name_thread 'AMBUL_M'

:PAREMEDIC_LOOP_INNER
wait 0 ms
if
    0256:   player $PLAYER defined
then
    if
        00DE:   player $PLAYER driving_vehicle_type #AMBULAN
    then
        if and
            0038:   $FLAG_PLAYER_ON_MISSION == 0
            0038:   $ON_PARAMEDIC_MISSION == 0
        then
            0293: $CONTROLMODE = current_controls
            if
                0038:   $DISPLAYED_PARAMEDIC_HELP == 0
            then
                if
                    8038:   NOT   $CONTROLMODE == 3
                then
                    03E5: text_box 'ATUTOR'   // Press the ~h~~k~~TOGGLE_SUBMISSIONS~ button~w~ to toggle Paramedic missions on or off.
                else
                    03E5: text_box 'ATUTOR3'   // Press the ~h~~k~~TOGGLE_SUBMISSIONS~ button~w~ to toggle Paramedic missions on or off.
                end
                0004: $DISPLAYED_PARAMEDIC_HELP = 1
            end
            if
                8038:   NOT   $CONTROLMODE == 3
            then
                if
                    00E1:   key_pressed 0 19
                then
                    while 00E1:   key_pressed 0 19
                        wait 0 ms
                        if
                            8256:   NOT   player $PLAYER defined
                        then
                            jump @PAREMEDIC_LOOP_INNER
                        end
                    end //while
                    00BA: text_styled 'AMBUL_M' 4000 ms 5   // 'PARAMEDIC'
                    wait 0 ms
                    0417: start_mission M11_PARAMEDIC
                    0004: $DISPLAYED_PARAMEDIC_HELP = 1
                end
            else
                if
                    00E1:   key_pressed 0 14
                then
                    while 00E1:   key_pressed 0 14
                        wait 0 ms
                        if
                            8256:   NOT   player $PLAYER defined
                        then
                            jump @PAREMEDIC_LOOP_INNER
                        end
                    end //while
                    00BA: text_styled 'AMBUL_M' 4000 ms 5   // 'PARAMEDIC'
                    wait 0 ms
                    0417: start_mission M11_PARAMEDIC
                    0004: $DISPLAYED_PARAMEDIC_HELP = 1
                end
            end
        end
    else
        if
            0038:   $DISPLAYED_PARAMEDIC_HELP == 1
        then
            03E6: remove_text_box
            0004: $DISPLAYED_PARAMEDIC_HELP = 0
        end
    end
end
jump @PAREMEDIC_LOOP_INNER

//#####################################################################################
//#####################################################################################
// END PARAMEDIC MONITOR / BEGIN FIRE MONITOR
//#####################################################################################
//#####################################################################################

:FIRE_LOOP
03A4: name_thread 'FIRE_M'

:FIRE_LOOP_INNER
wait 0 ms
if
    0256:   player $PLAYER defined
then
    if
        00DE:   player $PLAYER driving_vehicle_type #FIRETRUK
    then
        if and
            0038:   $FLAG_PLAYER_ON_MISSION == 0
            0038:   $ON_FIREFIGHTER_MISSION == 0
        then
            0293: $CONTROLMODE = current_controls
            if
                0038:   $FIRETRUCK_HELP_DISPLAYED == 0
            then
                if
                    8038:   NOT   $CONTROLMODE == 3
                then
                    03E5: text_box 'FTUTOR'   // Press the ~h~~k~~TOGGLE_SUBMISSIONS~ button~w~ to toggle fire truck missions on or off.
                else
                    03E5: text_box 'FTUTOR2'   // Press the ~h~~k~~TOGGLE_SUBMISSIONS~ button~w~ to toggle fire truck missions on or off.
                end
                0004: $FIRETRUCK_HELP_DISPLAYED = 1
            end
            if
                8038:   NOT   $CONTROLMODE == 3
            then
                if
                    00E1:   key_pressed 0 19
                then
                    while 00E1:   key_pressed 0 19
                        wait 0 ms
                        if
                            8256:   NOT   player $PLAYER defined
                        then
                            jump @FIRE_LOOP_INNER
                        end
                    end
                    00BA: text_styled 'FIRE_M' 4000 ms 5   // 'FIREFIGHTER'
                    wait 0 ms
                    0417: start_mission M12_FIREFIGHTER
                    0004: $FIRETRUCK_HELP_DISPLAYED = 1
                end
            else
                if
                    00E1:   key_pressed 0 14
                then
                    while 00E1:   key_pressed 0 14
                        wait 0 ms
                        if
                            8256:   NOT   player $PLAYER defined
                        then
                            jump @FIRE_LOOP_INNER
                        end
                    end
                    00BA: text_styled 'FIRE_M' 4000 ms 5   // 'FIREFIGHTER'
                    wait 0 ms
                    0417: start_mission M12_FIREFIGHTER
                    0004: $FIRETRUCK_HELP_DISPLAYED = 1
                end
            end
        end
    else
        if
            0038:   $FIRETRUCK_HELP_DISPLAYED == 1
        then
            03E6: remove_text_box
            0004: $FIRETRUCK_HELP_DISPLAYED = 0
        end
    end
end
jump @FIRE_LOOP_INNER

//#####################################################################################
//#####################################################################################
// END FIRE MONITOR / BEGIN VIGILANTE MONITOR
//#####################################################################################
//#####################################################################################

:VIGILANTE_LOOP
03A4: name_thread 'COP_M'

:VIGILANTE_LOOP_INNER
wait 0 ms
if
    0256:   player $PLAYER defined
then
    if or
        00DE:   player $PLAYER driving_vehicle_type #POLICE
        00DE:   player $PLAYER driving_vehicle_type #ENFORCER
        00DE:   player $PLAYER driving_vehicle_type #VICECHEE
        00DE:   player $PLAYER driving_vehicle_type #RHINO
        00DE:   player $PLAYER driving_vehicle_type #FBICAR
        00DE:   player $PLAYER driving_vehicle_type #HUNTER
    then
        if and
            0038:   $FLAG_PLAYER_ON_MISSION == 0
            0038:   $ON_VIGILANTE_MISSION == 0
        then
            0293: $CONTROLMODE = current_controls
            if
                0038:   $VIGILANTE_HELP_DISPLAYED == 0
            then
                if
                    8038:   NOT   $CONTROLMODE == 3
                then
                    03E5: text_box 'CTUTOR'   // Press the ~h~~k~~TOGGLE_SUBMISSIONS~ button~w~ to toggle Vigilante missions on or off.
                else
                    03E5: text_box 'CTUTOR2'   // Press the ~h~~k~~TOGGLE_SUBMISSIONS~ button~w~ to toggle Vigilante missions on or off.
                end
                0004: $VIGILANTE_HELP_DISPLAYED = 1
            end
            if
                8038:   NOT   $CONTROLMODE == 3
            then
                if
                    00E1:   key_pressed 0 19
                then
                    while 00E1:   key_pressed 0 19
                        wait 0 ms
                        if
                            8256:   NOT   player $PLAYER defined
                        then
                            jump @VIGILANTE_LOOP_INNER
                        end
                    end
                    00BA: text_styled 'COP_M' 4000 ms 5   // 'VIGILANTE'
                    wait 0 ms
                    0417: start_mission M13_VIGILANTE
                    0004: $VIGILANTE_HELP_DISPLAYED = 1
                end
            else
                if
                    00E1:   key_pressed 0 14
                then
                    while 00E1:   key_pressed 0 14
                        wait 0 ms
                        if
                            8256:   NOT   player $PLAYER defined
                        then
                            jump @VIGILANTE_LOOP_INNER
                        end
                    end
                    00BA: text_styled 'COP_M' 4000 ms 5   // 'VIGILANTE'
                    wait 0 ms
                    0417: start_mission M13_VIGILANTE
                    0004: $VIGILANTE_HELP_DISPLAYED = 1
                end
            end
        end
    else
        if
            0038:   $VIGILANTE_HELP_DISPLAYED == 1
        then
            03E6: remove_text_box
            0004: $VIGILANTE_HELP_DISPLAYED = 0
        end
    end
end
jump @VIGILANTE_LOOP_INNER

//#####################################################################################
//#####################################################################################
// END VIGILANTE MONITOR / BEGIN TAXI MONITOR
//#####################################################################################
//#####################################################################################

:TAXI_LOOP
03A4: name_thread 'TAXI_L'

:TAXI_LOOP_INNER
wait 0 ms
if
    0256:   player $PLAYER defined
then
    if
        8596:   not player $PLAYER riding_mission_restart_taxi // GTA LC extension
    then
        if
            02DE:   player $PLAYER driving_taxi_vehicle
        then
            if and
                0038:   $FLAG_PLAYER_ON_MISSION == 0
                0038:   $ON_TAXI_MISSION == 0
            then
                0293: $CONTROLMODE = current_controls
                if
                    0038:   $TAXI_HELP_DISPLAYED == 0
                then
                    if
                        8038:   not  $CONTROLMODE == 3
                    then
                        03E5: text_box 'TTUTOR'  // Press the ~h~~k~~TOGGLE_SUBMISSIONS~ button~w~ to toggle taxi missions on or off.
                    else
                        03E5: text_box 'TTUTOR2'  // Press the ~h~~k~~TOGGLE_SUBMISSIONS~ button~w~ to toggle taxi missions on or off.
                    end
                    0004: $TAXI_HELP_DISPLAYED = 1
                end
                if
                    8038:   not  $CONTROLMODE == 3
                then
                    if
                        00E1:   pad 0 key_pressed 19
                    then

                        while 00E1:   pad 0 key_pressed 19
                            wait 0 ms
                            if
                                8256:   not player $PLAYER defined
                            then
                                jump @TAXI_LOOP_INNER
                            end
                        end
                        00BA: text_styled 'TAXI_M' 4000 ms 5  // 'TAXI DRIVER'
                        wait 0 ms
                        if
                            02BD:   debug_mode == DEBUG_VICECITY
                        then
                            0417: start_mission M82_TAXI
                        else
                            0417: start_mission M14_TAXI
                        end
                        0004: $ON_TAXI_MISSION = 1
                    end
                else
                    if
                        00E1:   pad 0 key_pressed 14
                    then

                        while 00E1:   pad 0 key_pressed 14
                            wait 0 ms
                            if
                                8256:   not player $PLAYER defined
                            then
                                jump @TAXI_LOOP_INNER
                            end
                        end
                        00BA: text_styled 'TAXI_M' 4000 ms 5  // 'TAXI DRIVER'
                        wait 0 ms
                        if
                            02BD:   debug_mode == DEBUG_VICECITY
                        then
                            0417: start_mission M82_TAXI
                        else
                            0417: start_mission M14_TAXI
                        end
                        0004: $ON_TAXI_MISSION = 1
                    end
                end
            end
        else
            if
                0038:   $TAXI_HELP_DISPLAYED == 1
            then
                03E6: remove_text_box
                0004: $TAXI_HELP_DISPLAYED = 0
            end
        end
    end
end
jump @TAXI_LOOP_INNER

//#####################################################################################
//#####################################################################################
// END TAXI MONITOR / BEGIN SILENT'S BIKE MISSION TRIGGERS
//#####################################################################################
//#####################################################################################

:M80_IND_LOOP
03A4: name_thread 'BIKERS0'

while true
    wait $WAIT_TIME ms
    if
        0038:   $ALLEYS_ANGELS_COMPLETED == 0
    then
        0004: $ALLEYS_ANGELS_BEST_TIME = 120
    end
    if
        0256:   player $PLAYER defined
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if and
                00DE:   player $PLAYER driving_vehicle_type #ANGEL
                8056:   NOT   player $PLAYER 0 in_rectangle 933.4 -103.8 934.5 -107.0
            then
                0004: $ON_ALLEYS_ANGELS_MISSION = 1
            end
            if and
                00DE:   player $PLAYER driving_vehicle_type #ANGEL
                0038:   $ON_ALLEYS_ANGELS_MISSION == 0
            then
                00BA: text_styled 'BIKE_0' 5000 ms 2  // 'ALLEYS AND ANGELS'
                0004: $BIKE_ISLAND = 0
                wait 0 ms
                0417: start_mission M80_BIKECHALLENGE
            end
            if
                0256:   player $PLAYER defined
            then
                if
                    80E0:   NOT   player $PLAYER driving
                then
                    0004: $ON_ALLEYS_ANGELS_MISSION = 0
                end
            end
        end
    end
end

:M80_COM_LOOP
03A4: name_thread 'BIKERS1'

while true
    wait $WAIT_TIME ms
    if
        0038:   $COLLEGE_TOUR_COMPLETED == 0
    then
        0004: $COLLEGE_TOUR_BEST_TIME = 150
    end
    if
        0256:   player $PLAYER defined
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if and
                00DE:   player $PLAYER driving_vehicle_type #SANCHEZ
                8056:   NOT   player $PLAYER 0 in_rectangle -48.5 -261.1 -49.8 -258.5
            then
                0004: $ON_COLLEGE_TOUR_MISSION = 1
            end
            if and
                00DE:   player $PLAYER driving_vehicle_type #SANCHEZ
                0038:   $ON_COLLEGE_TOUR_MISSION == 0
            then
                00BA: text_styled 'BIKE_1' 5000 ms 2  // 'COLLEGE TOUR'
                0004: $BIKE_ISLAND = 1
                wait 0 ms
                0417: start_mission M80_BIKECHALLENGE
            end
            if
                0256:   player $PLAYER defined
            then
                if
                    80E0:   NOT   player $PLAYER driving
                then
                    0004: $ON_COLLEGE_TOUR_MISSION = 0
                end
            end
        end
    end
end

:M80_SUB_LOOP
03A4: name_thread 'BIKERS2'

while true
    wait $WAIT_TIME ms
    if
        0038:   $AIRPORT_AGGRESSION_COMPLETED == 0
    then
        0004: $AIRPORT_AGGRESSION_BEST_TIME = 360
    end
    if
        0256:   player $PLAYER defined
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if and
                00DE:   player $PLAYER driving_vehicle_type #PCJ600
                8056:   NOT   player $PLAYER 0 in_rectangle -1085.08 -538.1737 -1088.005 -539.3569
            then
                0004: $ON_AIRPORT_AGGRESSION_MISSION = 1
            end
            if and
                00DE:   player $PLAYER driving_vehicle_type #PCJ600
                0038:   $ON_AIRPORT_AGGRESSION_MISSION == 0
            then
                00BA: text_styled 'BIKE_2' 5000 ms 2  // 'AIRPORT AGGRESSION'
                0004: $BIKE_ISLAND = 2
                wait 0 ms
                0417: start_mission M80_BIKECHALLENGE
            end
            if
                0256:   player $PLAYER defined
            then
                if
                    80E0:   NOT   player $PLAYER driving
                then
                    0004: $ON_AIRPORT_AGGRESSION_MISSION = 0
                end
            end
        end
    end
end

//#####################################################################################
//#####################################################################################
// END SILENT'S BIKE MISSION TRIGGERS / BEGIN DISTRIBUTION MONITOR
//#####################################################################################
//#####################################################################################

:ICECRE_LOOP
03A4: name_thread 'ICE1'

:ICECRE_LOOP_INNER
wait $WAIT_TIME ms
if
    02BD:   debug_mode == DEBUG_VICECITY
then
    if
        0256:   player $PLAYER defined
    then
        if
            00DE:   player $PLAYER driving_vehicle_type #MRWHOOP
        then
            if
                $FLAG_PLAYER_ON_MISSION == 0
            then
                if
                    not $CONTROLMODE == 3
                then
                    if
                        00E1:   key_pressed 0 19
                    then
                        while 00E1:   key_pressed 0 19
                            wait 0 ms
                            if
                                8256:   NOT   player $PLAYER defined
                            then
                                jump @ICECRE_LOOP_INNER
                            end
                        end
                        wait 0 ms
                        0417: start_mission M81_ICECRE1
                    end
                else
                    if
                        00E1:   key_pressed 0 14
                    then
                        while 00E1:   key_pressed 0 14
                            wait 0 ms
                            if
                                8256:   NOT   player $PLAYER defined
                            then
                                jump @ICECRE_LOOP_INNER
                            end
                        end
                        wait 0 ms
                        0417: start_mission M81_ICECRE1
                    end
                end
            end
        end
    end
end
jump @ICECRE_LOOP_INNER