//-------------Mission 64-------------
// Originally: Yardies mission 2 'UZI RIDER'

:M64_UZIRIDER
03A4: name_thread 'YARD2'
054C: use_GXT_table 'YARD2'
gosub @MISSION_START_YD2
if
    wasted_or_busted
then
    gosub @MISSION_YD2_FAILED
end
gosub @MISSION_CLEANUP_YD2
end_thread

:MISSION_START_YD2
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_YARDIES = 1
wait 0 ms
03DE: set_pedestrians_density_multiplier_to 0.0
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03CB: set_camera -215.0 -272.25 21.25
023C: load_special_actor 1 'PLAYER'
while true
    if
        823D:   NOT   special_actor 1 loaded
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'YD_PH2'
0244: set_cutscene_pos -214.0 -272.25 21.25
042B: clear_peds_from_cube -234.5 -250.0 6.0 -204.5 -290.0 31.0
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
016A: fade 1 (back)  1500 ms
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   2000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD2_A' 10000 ms 1   // ~w~I need to see if you're capable of doing my dirty work.
while 001A:   4581 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD2_A1' 10000 ms 1   // ~w~See if you can be trusted.
while 001A:   7135 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD2_B' 10000 ms 1   // ~w~Two of my boys will be there any second to take you for a ride
while 001A:   10431 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD2_B1' 10000 ms 1   // ~w~see if you are who you say you are.
while 001A:   13900 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while fading
    wait 0 ms
end
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
03AF: set_streaming 1 (enabled)
00BE: text_clear_all
02EA: clear_cutscene
wait 0 ms
0296: unload_special_actor 1
0247: request_model #PEREN
0247: request_model #GANG09
0247: request_model #GANG10
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #PEREN available
        8248:   NOT   model #GANG09 available
        8248:   NOT   model #GANG10 available
    jf break
    wait 0 ms
end
0004: $TIMER_DIF_YD2 = 0
0004: $FLAG_OUT_OF_CAR_MESSAGE = 0
0004: $FLAG_UPSIDEDOWN = 0
//0004: $FLAG_CHAP_1_NV = 0    -not used
//0004: $FLAG_CHAP_2_NV = 0    -not used
0004: $FLAG_CLEAR = 0
0004: $BODY_COUNT_YD2 = 0
0004: $DRIVEBY_TOTAL_1 = 0
0004: $DRIVEBY_TOTAL_2 = 0
0297: reset_num_of_models_killed_by_player
0005: $DRIVEBY_X = 605.0
0005: $DRIVEBY_Y = -220.0
0005: $YD2TURF_X = -104.0
0005: $YD2TURF_Y = -531.0

01C0: $WANTED_YD2 = player $PLAYER wanted_level
0110: clear_player $PLAYER wanted_level
01B4: set_player $PLAYER can_move 0 (frozen)
01F5: $SCRIPT_CONTROLLED_PLAYER = get_player_char $PLAYER
015F: set_camera_position -218.25 -266.25 23.0 0.0 0.0 0.0
0157: camera_on_player $PLAYER 15 2
02A3: toggle_widescreen 1 (on)
01EB: set_car_density_to 0.0
0395: clear_area 1 at -331.1875 -310.062 22.0 range 40.0
0395: clear_area 1 at -238.0 -285.5 22.0 range 50.0
016A: fade 1 (out)  1500 ms
wait 1500 ms
00A5: $GANG_CAR_YD2 = create_car #PEREN at -331.1875 -310.062 22.0
0175: set_car $GANG_CAR_YD2 z_angle_to 0.0
02AA: set_car $GANG_CAR_YD2 immune_to_nonplayer 1
0129: $CHAPERONE_1 = create_actor 11 #GANG09 in_car $GANG_CAR_YD2 driverseat
01C8: $CHAPERONE_2 = create_actor 11 #GANG10 in_car $GANG_CAR_YD2 passenger_seat 0
00A7: car $GANG_CAR_YD2 drive_to -222.0 -272.0 22.0
00AD: set_car $GANG_CAR_YD2 max_speed_to 25.0
00AE: set_car $GANG_CAR_YD2 driving_style 3   //I never saw 3 before
if
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    0158: camera_on_vehicle $GANG_CAR_YD2 15 1
end
while 81AD:   NOT   car $GANG_CAR_YD2 0 near_point -222.0 -272.0 5.0 5.0
    wait 0 ms
    if
        0119:   car $GANG_CAR_YD2 wrecked
    then
        jump @MISSION_YD2_FAILED_ASSERT
    end
    if
        0038:   $FLAG_CLEAR == 0
    then
        0395: clear_area 1 at -220.0 -272.0 22.0 range 10.0
        0004: $FLAG_CLEAR = 1
    end
end //while
wait 1000 ms
01BE: set_actor $SCRIPT_CONTROLLED_PLAYER to_look_at_spot -220.0 -272.0 22.0
if
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    00A9: set_car $GANG_CAR_YD2 to_normal_driver
    if and
        8118:   NOT   actor $CHAPERONE_2 dead
        8118:   NOT   actor $CHAPERONE_1 dead
    then
        01D3: actor $CHAPERONE_1 leave_car $GANG_CAR_YD2
        01D3: actor $CHAPERONE_2 leave_car $GANG_CAR_YD2
    end
end
if and
    8118:   NOT   actor $CHAPERONE_2 dead
    8118:   NOT   actor $CHAPERONE_1 dead
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    while true
        if or
            00DB:   actor $CHAPERONE_2 in_car $GANG_CAR_YD2
            00DB:   actor $CHAPERONE_1 in_car $GANG_CAR_YD2
        jf break
        wait 0 ms
        if or
            0118:   actor $CHAPERONE_2 dead
            0118:   actor $CHAPERONE_1 dead
            0119:   car $GANG_CAR_YD2 wrecked
        then
            jump @MISSION_YD2_FAILED_ASSERT
        end
    end
else
    jump @MISSION_YD2_FAILED_ASSERT
end
if
    8118:   NOT   actor $CHAPERONE_2 dead
then
    0159: camera_on_ped $CHAPERONE_2 15 1
end
if and
    8118:   NOT   actor $CHAPERONE_1 dead
    8118:   NOT   actor $SCRIPT_CONTROLLED_PLAYER dead
then
    022C: set_actor $CHAPERONE_1 to_look_at_actor $SCRIPT_CONTROLLED_PLAYER
end

:PLINKY_YD2
wait 0 ms
0054: store_player $PLAYER position_to $Y2_X $Y2_Y $Y2_Z
if and
    8118:   NOT   actor $CHAPERONE_2 dead
    8118:   NOT   actor $CHAPERONE_1 dead
then
    0223: set_actor $CHAPERONE_1 health_to 100
    0223: set_actor $CHAPERONE_2 health_to 100
    000D: $Y2_Y -= 1.0
    0211: actor $CHAPERONE_2 walk_to $Y2_X $Y2_Y
    0192: set_actor $CHAPERONE_1 objective_to_stand_still
    022C: set_actor $CHAPERONE_2 to_look_at_actor $SCRIPT_CONTROLLED_PLAYER
    022C: set_actor $SCRIPT_CONTROLLED_PLAYER to_look_at_actor $CHAPERONE_2
    if
        80ED:   NOT   actor $CHAPERONE_2 0 near_point_on_foot $Y2_X $Y2_Y radius 2.0 2.0
    then
        jump @PLINKY_YD2
    end
else
    jump @MISSION_YD2_FAILED_ASSERT
end
if
    8118:   NOT   actor $CHAPERONE_2 dead
then
    020F: actor $CHAPERONE_2 look_at_player $PLAYER
    020E: actor $SCRIPT_CONTROLLED_PLAYER look_at_actor $CHAPERONE_2
    0192: set_actor $CHAPERONE_2 objective_to_stand_still
else
    jump @MISSION_YD2_FAILED_ASSERT
end
03CF: load_wav 'YD2_A' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @POODLE
    end
end
03D1: play_wav 1
00BC: print_now 'YD2_C' 10000 ms 1   // ~w~We're going for a little ride into Hepburn Heights whack us some filthy Diablos been dissing Queen Lizzy.
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @POODLE
    end
end
00BE: text_clear_all
if
    8118:   NOT   actor $CHAPERONE_1 dead
then
    0223: set_actor $CHAPERONE_1 health_to 100
end
if
    8118:   NOT   actor $CHAPERONE_2 dead
then
    0223: set_actor $CHAPERONE_2 health_to 100
end
040D: unload_wav 1
03CF: load_wav 'YD2_B' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @POODLE
    end
end
03D1: play_wav 1
00BC: print_now 'YD2_D' 10000 ms 1   // ~w~You do the driving and shooting. We'll make sure you don't get cold feet.
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @POODLE
    end
end
00BE: text_clear_all
if
    8118:   NOT   actor $CHAPERONE_1 dead
then
    0223: set_actor $CHAPERONE_1 health_to 100
end
if
    8118:   NOT   actor $CHAPERONE_2 dead
then
    0223: set_actor $CHAPERONE_2 health_to 100
end
040D: unload_wav 1
03CF: load_wav 'YD2_C' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @POODLE
    end
end
03D1: play_wav 1
00BC: print_now 'YD2_CC' 10000 ms 1   // ~w~Here you'll need a 'piece'.
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @POODLE
    end
end
040D: unload_wav 1
00BE: text_clear_all

:POODLE
040D: unload_wav 1
00BE: text_clear_all
0247: request_model #UZI
038B: load_all_models_now
while 8248:   NOT   model #UZI available
    wait 0 ms
end
022F: set_actor $SCRIPT_CONTROLLED_PLAYER stop_looking
01B1: give_player $PLAYER weapon 23 ammo 150  // uzi
wait 1000 ms
01B8: set_player $PLAYER armed_weapon_to 23
while 82D7:   NOT   player $PLAYER currentweapon == 23
    wait 0 ms
end
0157: camera_on_player $PLAYER 15 1
if
    8118:   NOT   actor $CHAPERONE_1 dead
then
    0223: set_actor $CHAPERONE_1 health_to 100
    022F: set_actor $CHAPERONE_1 stop_looking
    if
        8119:   NOT   car $GANG_CAR_YD2 wrecked
    then
        01D4: actor $CHAPERONE_1 go_to_car $GANG_CAR_YD2 and_enter_it_as_a_passenger
    end
end
if
    8118:   NOT   actor $CHAPERONE_2 dead
then
    0223: set_actor $CHAPERONE_2 health_to 100
    022C: set_actor $CHAPERONE_2 to_look_at_actor $SCRIPT_CONTROLLED_PLAYER
end
041E: set_radio_station 2 0
if
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    01D5: actor $SCRIPT_CONTROLLED_PLAYER go_to_and_drive_car $GANG_CAR_YD2
else
    jump @MISSION_YD2_FAILED_ASSERT
end
while 80DB:   NOT   actor $SCRIPT_CONTROLLED_PLAYER in_car $GANG_CAR_YD2
    wait 0 ms
    if
        0119:   car $GANG_CAR_YD2 wrecked
    then
        jump @MISSION_YD2_FAILED_ASSERT
    end
    if
        8118:   NOT   actor $CHAPERONE_1 dead
    then
        0223: set_actor $CHAPERONE_1 health_to 100
    end
    if
        8118:   NOT   actor $CHAPERONE_2 dead
    then
        0223: set_actor $CHAPERONE_2 health_to 100
    end
end //while
if and
    8119:   NOT   car $GANG_CAR_YD2 wrecked
    8118:   NOT   actor $CHAPERONE_2 dead
    8118:   NOT   actor $CHAPERONE_1 dead
then
    022F: set_actor $CHAPERONE_1 stop_looking
    022F: set_actor $CHAPERONE_2 stop_looking
    01D4: actor $CHAPERONE_2 go_to_car $GANG_CAR_YD2 and_enter_it_as_a_passenger
    while true
        if or
            80DB:   NOT   actor $CHAPERONE_2 in_car $GANG_CAR_YD2
            80DB:   NOT   actor $CHAPERONE_1 in_car $GANG_CAR_YD2
        jf break
        wait 0 ms
        if or
            0118:   actor $CHAPERONE_2 dead
            0118:   actor $CHAPERONE_1 dead
            0119:   car $GANG_CAR_YD2 wrecked
        then
            jump @MISSION_YD2_FAILED_ASSERT
        end
        if
            8118:   NOT   actor $CHAPERONE_1 dead
        then
            0223: set_actor $CHAPERONE_1 health_to 100
        end
        if
            8118:   NOT   actor $CHAPERONE_2 dead
        then
            0223: set_actor $CHAPERONE_2 health_to 100
        end
    end //while
else
    jump @MISSION_YD2_FAILED_ASSERT
end
if
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    02AA: set_car $GANG_CAR_YD2 immune_to_nonplayer 0
end
if
    8118:   NOT   actor $CHAPERONE_1 dead
then
    039E: set_char_cant_be_dragged_out $CHAPERONE_1 1
    0526: set_actor_stay_in_car $CHAPERONE_1 1
    054A: set_actor $CHAPERONE_1 vulnerable_to_car_headshots 1
end
if
    8118:   NOT   actor $CHAPERONE_2 dead
then
    039E: set_char_cant_be_dragged_out $CHAPERONE_2 1
    0526: set_actor_stay_in_car $CHAPERONE_2 1
    054A: set_actor $CHAPERONE_2 vulnerable_to_car_headshots 1
end
02EB: restore_camera_jumpcut
02A3: toggle_widescreen 0 (off)
01B4: set_player $PLAYER can_move 1 (unfrozen)
03CF: load_wav 'YD2_C1' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
00BD: print_soon 'YD2_E' 4000 ms 1   // ~w~Let's drive!!
while 83D2:   NOT   wav 1 ended
    wait 0 ms
end
018A: $BLIP_DRIVEBY_YD2 = create_checkpoint_at $DRIVEBY_X $DRIVEBY_Y 11.0
03DE: set_pedestrians_density_multiplier_to 1.0
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
01EB: set_car_density_to 1.0
015C: set_zone_gang_info 'TOWERS' 1 (day)  15 0 0 700 0 0 0 0 0 0 20
015C: set_zone_gang_info 'TOWERS' 0 (night)  10 0 0 800 0 0 0 0 0 0 10
010D: set_player $PLAYER wanted_level_to $WANTED_YD2
//Getting there
if
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    while 8121:   NOT   player $PLAYER in_zone 'TOWERS'
        wait 0 ms
        if
            8119:   NOT   car $GANG_CAR_YD2 wrecked
        then
            if and
                01F4:   car $GANG_CAR_YD2 flipped
                01C1:   car $GANG_CAR_YD2 stopped
            then
                0004: $FLAG_UPSIDEDOWN = 1
                jump @MISSION_YD2_FAILED
            end
            if
                8185:   NOT   car $GANG_CAR_YD2 health >= 250
            then
                if and
                    81AF:   NOT   car $GANG_CAR_YD2 0 near_point 44.0 -493.688 32.1875 radius 15.0 15.0 15.0
                    81AF:   NOT   car $GANG_CAR_YD2 0 near_point 590.375 -358.688 16.75 radius 15.0 15.0 15.0
                then
                    0004: $FLAG_UPSIDEDOWN = 1
                    jump @MISSION_YD2_FAILED
                end
            end
            if
                80DC:   NOT   player $PLAYER driving $GANG_CAR_YD2
            then
                0004: $FLAG_UPSIDEDOWN = 2
                gosub @PLAYER_OUT_OF_CAR
                if
                    8119:   NOT   car $GANG_CAR_YD2 wrecked
                then
                    if
                        80DC:   NOT   player $PLAYER driving $GANG_CAR_YD2
                    then
                        0004: $FLAG_UPSIDEDOWN = 2
                        jump @MISSION_YD2_FAILED
                    end
                else
                    jump @MISSION_YD2_FAILED_ASSERT
                end
                020A: set_car $GANG_CAR_YD2 door_status_to 2
            end
        else
            jump @MISSION_YD2_FAILED_ASSERT
        end
    end //while
else
    jump @MISSION_YD2_FAILED_ASSERT
end
040D: unload_wav 1
03CF: load_wav 'YD2_F' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
00BC: print_now 'YD2_G1' 2500 ms 1   // ~w~Hepburn Heightslet's kill me some filthy Diablos...
03F1: pedtype 9 add_threat 1
while 83D2:   NOT   wav 1 ended
    wait 0 ms
end
040D: unload_wav 1
03CF: load_wav 'YD2_G' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
00BD: print_soon 'YD2_G2' 2500 ms 1   // ~w~But remember ~r~You don't leave this car!!
while 83D2:   NOT   wav 1 ended
    wait 0 ms
end
0164: remove_blip $BLIP_DRIVEBY_YD2
03C4: set_status_text_to $BODY_COUNT_YD2 0  'KILLS'   // KILLS:
while 001A:   10 > $BODY_COUNT_YD2
    wait 0 ms
    if
        8119:   NOT   car $GANG_CAR_YD2 wrecked
    then
        if and
            01F4:   car $GANG_CAR_YD2 flipped
            01C1:   car $GANG_CAR_YD2 stopped
        then
            0004: $FLAG_UPSIDEDOWN = 1
            jump @MISSION_YD2_FAILED
        end
        if
            8185:   NOT   car $GANG_CAR_YD2 health >= 250
        then
            if and
                81AF:   NOT   car $GANG_CAR_YD2 0 near_point 44.0 -493.688 32.1875 radius 15.0 15.0 15.0
                81AF:   NOT   car $GANG_CAR_YD2 0 near_point 590.375 -358.688 16.75 radius 15.0 15.0 15.0
            then
                0004: $FLAG_UPSIDEDOWN = 1
                jump @MISSION_YD2_FAILED
            end
        end
        if
            80DC:   NOT   player $PLAYER driving $GANG_CAR_YD2
        then
            gosub @PLAYER_OUT_OF_CAR
            if
                8119:   NOT   car $GANG_CAR_YD2 wrecked
            then
                if
                    80DC:   NOT   player $PLAYER driving $GANG_CAR_YD2
                then
                    0004: $FLAG_UPSIDEDOWN = 2
                    jump @MISSION_YD2_FAILED
                end
            else
                jump @MISSION_YD2_FAILED_ASSERT
            end
        end
    else
        jump @MISSION_YD2_FAILED_ASSERT
    end
    0298: $DRIVEBY_TOTAL_1 = rampage_kills #GANG05
    0298: $DRIVEBY_TOTAL_2 = rampage_kills #GANG06
    0084: $BODY_COUNT_YD2 = $DRIVEBY_TOTAL_1
    0058: $BODY_COUNT_YD2 += $DRIVEBY_TOTAL_2
end //while
040D: unload_wav 1
03CF: load_wav 'YD2_H' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
00BC: print_now 'YD2_H' 2500 ms 1   // ~w~OK Get us back to Yardie turf! GO GO GO!!
while 83D2:   NOT   wav 1 ended
    wait 0 ms
end
0151: remove_status_text $BODY_COUNT_YD2
018A: $BLIP_DRIVEBY_YD2 = create_checkpoint_at -104.0 -531.0 32.0
if
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    while 81B0:   NOT   car $GANG_CAR_YD2 stopped 1 near_point $YD2TURF_X $YD2TURF_Y 32.0 radius 5.0 5.0 5.0
        wait 0 ms
        if
            8119:   NOT   car $GANG_CAR_YD2 wrecked
        then
            if and
                01F4:   car $GANG_CAR_YD2 flipped
                01C1:   car $GANG_CAR_YD2 stopped
            then
                0004: $FLAG_UPSIDEDOWN = 1
                jump @MISSION_YD2_FAILED
            end
            if
                8185:   NOT   car $GANG_CAR_YD2 health >= 250
            then
                if and
                    81AF:   NOT   car $GANG_CAR_YD2 0 near_point 44.0 -493.688 32.1875 radius 15.0 15.0 15.0
                    81AF:   NOT   car $GANG_CAR_YD2 0 near_point 590.375 -358.688 16.75 radius 15.0 15.0 15.0
                then
                    0004: $FLAG_UPSIDEDOWN = 1
                    jump @MISSION_YD2_FAILED
                end
            end
            if
                80DC:   NOT   player $PLAYER driving $GANG_CAR_YD2
            then
                gosub @PLAYER_OUT_OF_CAR
                if
                    8119:   NOT   car $GANG_CAR_YD2 wrecked
                then
                    if
                        80DC:   NOT   player $PLAYER driving $GANG_CAR_YD2
                    then
                        0004: $FLAG_UPSIDEDOWN = 2
                        jump @MISSION_YD2_FAILED
                    end
                else
                    jump @MISSION_YD2_FAILED_ASSERT
                end
            end
        else
            jump @MISSION_YD2_FAILED_ASSERT
        end
    end //while
else
    jump @MISSION_YD2_FAILED_ASSERT
end
01B4: set_player $PLAYER can_move 0 (frozen)
if and
    8118:   NOT   actor $CHAPERONE_1 dead
    8118:   NOT   actor $CHAPERONE_2 dead
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    0224: set_car $GANG_CAR_YD2 health_to 850
    01D3: actor $CHAPERONE_1 leave_car $GANG_CAR_YD2
    01D3: actor $CHAPERONE_2 leave_car $GANG_CAR_YD2
else
    jump @MISSION_YD2_FAILED_ASSERT
end
040D: unload_wav 1
03CF: load_wav 'YD2_OK' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
00BC: print_now 'YD2_L' 4000 ms 1   // ~w~You did good Reaperman!
while 83D2:   NOT   wav 1 ended
    wait 0 ms
end
01B4: set_player $PLAYER can_move 1 (unfrozen)
jump @MISSION_YD2_PASSED

:MISSION_YD2_FAILED
if and
    8118:   NOT   actor $CHAPERONE_1 dead
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    01D3: actor $CHAPERONE_1 leave_car $GANG_CAR_YD2
end
if and
    8118:   NOT   actor $CHAPERONE_2 dead
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    01D3: actor $CHAPERONE_2 leave_car $GANG_CAR_YD2
end
if
    0038:   $FLAG_UPSIDEDOWN == 1
then
    040D: unload_wav 1
    03CF: load_wav 'YD2_D' as 1
    while 83D0:   NOT   wav 1 loaded
        wait 0 ms
    end
    03D1: play_wav 1
    00BC: print_now 'YD2_M' 4000 ms 1   // ~r~He's wrecked my car! Waste him!
end
if
    0038:   $FLAG_UPSIDEDOWN == 2
then
    040D: unload_wav 1
    03CF: load_wav 'YD2_E' as 1
    while 83D0:   NOT   wav 1 loaded
        wait 0 ms
    end
    03D1: play_wav 1
    00BC: print_now 'YD2_F' 4000 ms 1   // ~r~He's bailed out on us cap his yellow ass!!!
end
if and
    8118:   NOT   actor $CHAPERONE_1 dead
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    while 00DB:   actor $CHAPERONE_1 in_car $GANG_CAR_YD2
        wait 0 ms
        if
            0118:   actor $CHAPERONE_1 dead
        then
            jump @BODDLE
        end
        if
            0119:   car $GANG_CAR_YD2 wrecked
        then
            jump @BODDLE
        end
    end
end

:BODDLE
if and
    8118:   NOT   actor $CHAPERONE_2 dead
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    while 00DB:   actor $CHAPERONE_2 in_car $GANG_CAR_YD2
        wait 0 ms
        if
            0118:   actor $CHAPERONE_2 dead
        then
            jump @MISSION_YD2_FAILED_ASSERT
        end
        if
            0119:   car $GANG_CAR_YD2 wrecked
        then
            jump @MISSION_YD2_FAILED_ASSERT
        end
    end
end
0247: request_model #UZI
0247: request_model #SHOTGUN
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #UZI available
        8248:   NOT   model #SHOTGUN available
    jf break
    wait 0 ms
end
if
    8118:   NOT   actor $CHAPERONE_1 dead
then
    01B2: give_actor $CHAPERONE_1 weapon 21 ammo 10  // Load the weapon model before using this
    while 82D8:   NOT   actor $CHAPERONE_1 currentweapon == 21
        wait 0 ms
        if
            0118:   actor $CHAPERONE_1 dead
        then
            jump @OINK
        end
    end
    if
        8118:   NOT   actor $CHAPERONE_1 dead
    then
        020F: actor $CHAPERONE_1 look_at_player $PLAYER
        if
            0121:   player $PLAYER in_zone 'TOWERS'
        then
            011A: set_actor $CHAPERONE_1 flags 512
        end
        011A: set_actor $CHAPERONE_1 flags 1
        01CC: actor $CHAPERONE_2 kill_player $PLAYER
    end
end

:OINK
if
    8118:   NOT   actor $CHAPERONE_2 dead
then
    01B2: give_actor $CHAPERONE_2 weapon 23 ammo 30  // Load the weapon model before using this
    while 82D8:   NOT   actor $CHAPERONE_2 currentweapon == 23
        wait 0 ms
        if
            0118:   actor $CHAPERONE_2 dead
        then
            jump @MISSION_YD2_FAILED_ASSERT
        end
    end
    if
        8118:   NOT   actor $CHAPERONE_2 dead
    then
        020F: actor $CHAPERONE_2 look_at_player $PLAYER
        if
            0121:   player $PLAYER in_zone 'TOWERS'
        then
            011A: set_actor $CHAPERONE_2 flags 512
        end
        011A: set_actor $CHAPERONE_2 flags 1
        01CC: actor $CHAPERONE_2 kill_player $PLAYER
    end
end

:MISSION_YD2_FAILED_ASSERT
00BA: text_styled 'M_FAIL' 2000 ms 1   // MISSION FAILED!
return

:MISSION_YD2_PASSED
if and
    8118:   NOT   actor $CHAPERONE_1 dead
    8118:   NOT   actor $CHAPERONE_2 dead
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    while true
        if or
            00DB:   actor $CHAPERONE_1 in_car $GANG_CAR_YD2
            00DB:   actor $CHAPERONE_2 in_car $GANG_CAR_YD2
        jf break
        wait 0 ms
        if or
            0118:   actor $CHAPERONE_1 dead
            0118:   actor $CHAPERONE_2 dead
            0119:   car $GANG_CAR_YD2 wrecked
        then
            jump @FILBY
        end
    end //while
else
    jump @FILBY
end

:FILBY
if
    8118:   NOT   actor $CHAPERONE_1 dead
then
    0193: set_actor $CHAPERONE_1 objective_to_act_like_ped
end
if
    8118:   NOT   actor $CHAPERONE_2 dead
then
    0193: set_actor $CHAPERONE_2 objective_to_act_like_ped
end
01E3: text_1number_styled 'M_PASS' 10000 5000 ms 1   // MISSION PASSED! $~1~
0394: play_music 1
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 10000
0318: set_latest_mission_passed 'YD2'   // 'UZI RIDER'
030C: set_mission_points += 1
03F1: pedtype  9 add_threat  1
0004: $UZI_RIDER_COMPLETED = 1
004F: create_thread @YARDIE_MISSION3_LOOP
return

:MISSION_CLEANUP_YD2
0164: remove_blip $BLIP_DRIVEBY_YD2
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_YARDIES = 0
0151: remove_status_text $BODY_COUNT_YD2
0164: remove_blip $BLIP_DRIVEBY_YD2
02A3: toggle_widescreen 0 (off)
02EB: restore_camera_jumpcut
if
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    020A: set_car $GANG_CAR_YD2 door_status_to 1
end
0249: mark_model_as_no_longer_needed #GANG09
0249: mark_model_as_no_longer_needed #GANG10
0249: mark_model_as_no_longer_needed #PEREN
015C: set_zone_gang_info 'TOWERS' 1 (day)  15 0 0 300 0 0 0 0 0 0 20
015C: set_zone_gang_info 'TOWERS' 0 (night)  10 0 0 500 0 0 0 0 0 0 10
mission_cleanup
return

:PLAYER_OUT_OF_CAR
if
    8119:   NOT   car $GANG_CAR_YD2 wrecked
then
    020A: set_car $GANG_CAR_YD2 door_status_to 1
end
while 001A:   7500 > $TIMER_DIF_YD2
    wait 0 ms
    if
        8119:   NOT   car $GANG_CAR_YD2 wrecked
    then
        if
            8185:   NOT   car $GANG_CAR_YD2 health >= 250
        then
            if and
                81AF:   NOT   car $GANG_CAR_YD2 0 near_point 44.0 -493.688 32.1875 radius 15.0 15.0 15.0
                81AF:   NOT   car $GANG_CAR_YD2 0 near_point 590.375 -358.688 16.75 radius 15.0 15.0 15.0
            then
                0004: $FLAG_UPSIDEDOWN = 1
                jump @MISSION_YD2_FAILED
            end
        end
        if
            0038:   $FLAG_OUT_OF_CAR_MESSAGE == 0
        then
            040D: unload_wav 1
            03CF: load_wav 'YD2_ASS' as 1
            while 83D0:   NOT   wav 1 loaded
                wait 0 ms
            end
            03D1: play_wav 1
            00BC: print_now 'YD2_N' 3000 ms 1   // ~w~Get your ass back in this car!
            0004: $FLAG_OUT_OF_CAR_MESSAGE = 1
            01BD: $TIMER_START_YD2 = current_time_in_ms
        end
        01BD: $TIMER_NOW_YD2 = current_time_in_ms
        0084: $TIMER_DIF_YD2 = $TIMER_NOW_YD2
        0060: $TIMER_DIF_YD2 -= $TIMER_START_YD2
        if
            8119:   NOT   car $GANG_CAR_YD2 wrecked
        then
            if
                00DC:   player $PLAYER driving $GANG_CAR_YD2
            then
                0004: $FLAG_OUT_OF_CAR_MESSAGE = 0
                return
            end
        end
    end
end //while
020A: set_car $GANG_CAR_YD2 door_status_to 2
return
