//-------------Mission 75-------------
// Originally: Hood Mission 2 'TOYMINATOR'

:M75_TOYMINATOR
03A4: name_thread 'HOOD2'
054C: use_GXT_table 'HOOD2'
gosub @MISSION_START_HOOD2
if
    wasted_or_busted
then
    gosub @MISSION_HOOD2_FAILED
end
gosub @MISSION_CLEANUP_HOOD2
end_thread

:MISSION_START_HOOD2
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_HOODS = 1
increment_mission_attempts
wait 0 ms
0004: $FLAG_VAN1_DEAD_HM2 = 0
0004: $FLAG_VAN2_DEAD_HM2 = 0
0004: $FLAG_VAN3_DEAD_HM2 = 0
0004: $COUNTER_ALL_VANS_DEAD_HM2 = 0
0004: $COUNTER_NO_OF_CARS_PLAYER_HAD_HM2 = 0
0004: $FLAG_PLAYER_GOT_CAR_HM2 = 0
0004: $FLAG_BUGGY_HELP2_HM2 = 0
0004: $FLAG_BUGGY_HELP3_HM2 = 0
0004: $FLAG_BUGGY_HELP1_HM2 = 0
0004: $BUGGIES_LEFT_HM2 = 0
0004: $TOTAL_BUGGY_HM2 = 5
03DE: set_pedestrians_density_multiplier_to 0.0
042B: clear_peds_from_cube -749.5625 97.6875 7.0 -924.25 -101.75 26.0
03CB: set_camera -779.6875 -6.3125 8.875
023C: load_special_actor 1 'PLAYER'
while true
    if
        823D:   NOT   special_actor 1 loaded
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'HD_PH2'
0244: set_cutscene_pos -779.688 -6.3125 8.875
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
016A: fade 1 (back)  1500 ms
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime

while 001A:   2000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM2_A' 10000 ms 1   // Those Nines are pressing me.
while 001A:   3468 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM2_B' 10000 ms 1   // These Bitches got armored cars and now they're running SPANK...
while 001A:   6630 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM2_C' 10000 ms 1   // and slinging it to brothers with no fear.
while 001A:   8077 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM2_D' 10000 ms 1   // There's a car parked up the way.
while 001A:   9819 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM2_E' 10000 ms 1   // There's some stuff in there to put these sissys on blass...
while 001A:   12413 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM2_F' 10000 ms 1   // and wreck all their armored stuff.
while 001A:   14200 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
03D5: remove_text 'HM2_F'   // and wreck all their armored stuff.
while 001A:   15333 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
03DE: set_pedestrians_density_multiplier_to 1.0
0247: request_model #TOYZ
0247: request_model #SECURICA
0247: request_model #RCBANDIT
038B: load_all_models_now
while true
    if or
        8248:  NOT  model #TOYZ available
        8248:  NOT  model #SECURICA available
        8248:  NOT  model #RCBANDIT available
    jf break
    wait 0 ms
end
00A5: $MISSION_CAR_HM2 = create_car #TOYZ at -1017.0 76.5625 -100.0
0186: $RADAR_BLIP_CAR1_HM2 = create_marker_above_car $MISSION_CAR_HM2

while 8442:   NOT   player $PLAYER in_car $MISSION_CAR_HM2
    wait 0 ms
    if
        0119:   car $MISSION_CAR_HM2 wrecked
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_HOOD2_FAILED
    end
end
0084: $BUGGIES_LEFT_HM2 = $TOTAL_BUGGY_HM2
0060: $BUGGIES_LEFT_HM2 -= $COUNTER_NO_OF_CARS_PLAYER_HAD_HM2
03C4: set_status_text_to $BUGGIES_LEFT_HM2 0 (number)  'BUGGY'   // BUGGIES LEFT:
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
0164: remove_blip $RADAR_BLIP_CAR1_HM2
// Code optimized and made compatible with GInput
0293: $CONTROLMODE = current_controls
if
    0038:   $CONTROLMODE == 2
then
	// Text altered for GInput
	03E5: text_box 'HM2_1A'   // Use the RC buggies to destroy the armored cars. Press the  ~c~  button to detonate.
else
	if
		0038:   $CONTROLMODE == 4
	then
		// New text for GInput
		03E5: text_box 'HM2_1B'   // Use the RC buggies to destroy the armored cars. Press the  ~i~  button to detonate.
	else
		03E5: text_box 'HM2_1'   // Use the RC buggies to destroy the armored cars. Press the ~h~~k~~PED_FIREWEAPON~ button ~w~to detonate.
	end
end
0004: $FLAG_BUGGY_HELP1_HM2 = 1
0395: clear_area 1 at -1016.375 91.3125 23.6875 range 2.0
010C: change_player_into_rc_buggy $PLAYER at -1016.375 91.3125 23.6875 94.0
0008: $COUNTER_NO_OF_CARS_PLAYER_HAD_HM2 += 1
00A5: $TARGET_VAN1_HM2 = create_car #SECURICA at -1176.0 -130.0 -100.0
0129: $VAN_DRIVER1_HM2 = create_actor 4 #MALE01 in_car $TARGET_VAN1_HM2 driverseat
02AA: set_car $TARGET_VAN1_HM2 immune_to_nonplayer 1
0428: set_car_avoid_level_transitions $TARGET_VAN1_HM2 flag 1
0186: $RADAR_BLIP_VAN1_HM2 = create_marker_above_car $TARGET_VAN1_HM2
00AE: set_car $TARGET_VAN1_HM2 driving_style 2  // DRIVINGMODE_AVOIDCARS
00AD: set_car $TARGET_VAN1_HM2 max_speed_to 12.0
00A8: set_car $TARGET_VAN1_HM2 to_psycho_driver
00A5: $TARGET_VAN2_HM2 = create_car #SECURICA at -772.0 -67.0 -100.0
0129: $VAN_DRIVER2_HM2 = create_actor 4 #MALE01 in_car $TARGET_VAN2_HM2 driverseat
02AA: set_car $TARGET_VAN2_HM2 immune_to_nonplayer 1
0428: set_car_avoid_level_transitions $TARGET_VAN2_HM2 flag 1
0186: $RADAR_BLIP_VAN2_HM2 = create_marker_above_car $TARGET_VAN2_HM2
00AE: set_car $TARGET_VAN2_HM2 driving_style 2  // DRIVINGMODE_AVOIDCARS
00AD: set_car $TARGET_VAN2_HM2 max_speed_to 12.0
00A8: set_car $TARGET_VAN2_HM2 to_psycho_driver
00A5: $TARGET_VAN3_HM2 = create_car #SECURICA at -1507.0 467.0 -100.0
0129: $VAN_DRIVER3_HM2 = create_actor 4 #MALE01 in_car $TARGET_VAN3_HM2 driverseat
02AA: set_car $TARGET_VAN3_HM2 immune_to_nonplayer 1
0428: set_car_avoid_level_transitions $TARGET_VAN3_HM2 flag 1
0186: $RADAR_BLIP_VAN3_HM2 = create_marker_above_car $TARGET_VAN3_HM2
00AE: set_car $TARGET_VAN3_HM2 driving_style 2  // DRIVINGMODE_AVOIDCARS
00AD: set_car $TARGET_VAN3_HM2 max_speed_to 12.0
00A8: set_car $TARGET_VAN3_HM2 to_psycho_driver
0084: $BUGGIES_LEFT_HM2 = $TOTAL_BUGGY_HM2
0060: $BUGGIES_LEFT_HM2 -= $COUNTER_NO_OF_CARS_PLAYER_HAD_HM2
0006: 17@ = 0

while 8038:   NOT   $COUNTER_ALL_VANS_DEAD_HM2 == 3
    wait 0 ms
    0084: $BUGGIES_LEFT_HM2 = $TOTAL_BUGGY_HM2
    0060: $BUGGIES_LEFT_HM2 -= $COUNTER_NO_OF_CARS_PLAYER_HAD_HM2
    if and
        0038:   $FLAG_BUGGY_HELP2_HM2 == 0
        0038:   $FLAG_BUGGY_HELP1_HM2 == 1
    then
        if
            0019:   17@ > 7000
        then
            03E5: text_box 'HM2_3'   // If you hit a vehicle's wheels the RC buggy will detonate!
            0004: $FLAG_BUGGY_HELP2_HM2 = 1
        end
    end
    if
        0038:   $FLAG_BUGGY_HELP3_HM2 == 0
    then
        if
            0038:   $FLAG_BUGGY_HELP2_HM2 == 1
        then
            if
                0019:   17@ > 14000
            then
                03E5: text_box 'HM2_4'   // If it goes out of range the RC buggy will detonate!
                0004: $FLAG_BUGGY_HELP3_HM2 = 1
            end
        end
    end
    0110: clear_player $PLAYER wanted_level
    if
        8119:   NOT   car $MISSION_CAR_HM2 wrecked
    then
        if and
            8241:   NOT   player $PLAYER in_remote_mode
            001A:   6 > $COUNTER_NO_OF_CARS_PLAYER_HAD_HM2
            0038:   $FLAG_PLAYER_GOT_CAR_HM2 == 0
            0442:   player $PLAYER in_car $MISSION_CAR_HM2
        then
            0395: clear_area 0 at -1016.375 91.3125 23.6875 range 2.0
            010C: change_player_into_rc_buggy $PLAYER at -1016.375 91.3125 23.6875 94.0
            0008: $COUNTER_NO_OF_CARS_PLAYER_HAD_HM2 += 1
            0004: $FLAG_PLAYER_GOT_CAR_HM2 = 1
        end
    end
    if
        8241:   NOT   player $PLAYER in_remote_mode
    then
        0004: $FLAG_PLAYER_GOT_CAR_HM2 = 0
    end
    if
        0038:   $FLAG_VAN1_DEAD_HM2 == 0
    then
        if
            0119:   car $TARGET_VAN1_HM2 wrecked
        then
            0008: $COUNTER_ALL_VANS_DEAD_HM2 += 1
            00BC: print_now 'HM2_6' 5000 ms 1   // ~g~Armored Car destroyed!
            0164: remove_blip $RADAR_BLIP_VAN1_HM2
            0004: $FLAG_VAN1_DEAD_HM2 = 1
        end
    end
    if
        0038:   $FLAG_VAN2_DEAD_HM2 == 0
    then
        if
            0119:   car $TARGET_VAN2_HM2 wrecked
        then
            0008: $COUNTER_ALL_VANS_DEAD_HM2 += 1
            00BC: print_now 'HM2_6' 5000 ms 1   // ~g~Armored Car destroyed!
            0164: remove_blip $RADAR_BLIP_VAN2_HM2
            0004: $FLAG_VAN2_DEAD_HM2 = 1
        end
    end
    if
        0038:   $FLAG_VAN3_DEAD_HM2 == 0
    then
        if
            0119:   car $TARGET_VAN3_HM2 wrecked
        then
            0008: $COUNTER_ALL_VANS_DEAD_HM2 += 1
            00BC: print_now 'HM2_6' 5000 ms 1   // ~g~Armored Car destroyed!
            0164: remove_blip $RADAR_BLIP_VAN3_HM2
            0004: $FLAG_VAN3_DEAD_HM2 = 1
        end
    end
    if and
        0038:   $COUNTER_NO_OF_CARS_PLAYER_HAD_HM2 == 5
        0038:   $FLAG_PLAYER_GOT_CAR_HM2 == 0
        8038:   NOT   $COUNTER_ALL_VANS_DEAD_HM2 == 3
    then
        00BC: print_now 'HM2_2' 5000 ms 1   // ~r~You failed to destroy all the armored cars!
        jump @MISSION_HOOD2_FAILED
    end
    if
        80E0:   NOT   player $PLAYER driving
    then
        00BA: text_styled 'M_FAIL' 5000 ms 1   // MISSION FAILED!
        00BC: print_now 'HM2_2' 5000 ms 1   // ~r~You failed to destroy all the armored cars!
        jump @MISSION_HOOD2_FAILED
    end
end
0409: blow_up_rc_buggy
jump @MISSION_HOOD2_PASSED

:MISSION_HOOD2_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // MISSION FAILED!
return

:MISSION_HOOD2_PASSED
0004: $TOYMINATOR_COMPLETED = 1
0318: set_latest_mission_passed 'HM_2'   // 'TOYMINATOR'
030C: set_mission_points += 1
01E3: text_1number_styled 'M_PASS' 10000 5000 ms 1   // MISSION PASSED! $~1~
0394: play_music 1
0109: player $PLAYER money += 10000
wait 100 ms
0110: clear_player $PLAYER wanted_level
004F: create_thread @HOODS_MISSION3_LOOP
return

:MISSION_CLEANUP_HOOD2
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_HOODS = 0
03CB: set_camera -995.875 76.0 24.6875
0249: mark_model_as_no_longer_needed #TOYZ
0249: mark_model_as_no_longer_needed #SECURICA
0249: mark_model_as_no_longer_needed #RCBANDIT
0151: remove_status_text $BUGGIES_LEFT_HM2
0164: remove_blip $RADAR_BLIP_CAR1_HM2
0164: remove_blip $RADAR_BLIP_VAN1_HM2
0164: remove_blip $RADAR_BLIP_VAN2_HM2
0164: remove_blip $RADAR_BLIP_VAN3_HM2
mission_cleanup
return
