//-------------Mission 29-------------
// Originally: Joey mission 6 'THE GETAWAY'

:M29_THEGETAWAY
03A4: name_thread 'JOEY6'
054C: use_GXT_table 'JOEY6'
058E: set_restart_mission_taxi_destination 867.48 -868.85 20.77 angle 133.3
gosub @MISSION_START_JOEY6
if
    wasted_or_busted
then
    gosub @MISSION_JOEY6_FAILED
end
gosub @MISSION_CLEANUP_JOEY6
end_thread

:MISSION_START_JOEY6
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_JOEY = 1
wait 0 ms
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'JOEY'
02F3: load_object #CUTOBJ01 'JOEYH'
02F3: load_object #CUTOBJ02 'PLAYERH'
02F3: load_object #CUTOBJ03 'TROLL'
0247: request_model #STALLION
0247: request_model #JOGARAGEEXT
0247: request_model #JOGARAGEINT
038B: load_all_models_now
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CUTOBJ03 available
    jf break
    wait 0 ms
end
while true
    if or
        8248:   NOT   model #JOGARAGEEXT available
        8248:   NOT   model #JOGARAGEINT available
        8248:   NOT   model #STALLION available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'J6_TBJ'
0244: set_cutscene_pos 855.0601 -869.812 19.9375
00A5: $CUT_CAR3_LM3 = create_car #STALLION at 857.88 -860.75 20.0
0175: set_car $CUT_CAR3_LM3 z_angle_to 150.0
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_JOEY = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_JOEY 'JOEY'
//02F4: create_cutscene_actor $JOEY_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_JOEY
//02F5: set_head_anim $JOEY_CSHEAD 'JOEY'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
02E5: $CS_TROLL = create_cutscene_object #CUTOBJ03
02E6: set_cutscene_anim $CS_TROLL 'TROLL'
0395: clear_area 1 at 856.88 -870.375 21.0 range 1.0
0055: set_player_coordinates $PLAYER at 856.88 -870.375 -100.0
0171: set_player $PLAYER z_angle_to 230.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   4434 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM6_A' 10000 ms 2   // // What a ride she's gonna be huh?
while 001A:   6704 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM6_B' 10000 ms 2   // // Alright listen. Get some wheels to the safehouse at St. Marks and pick up a few friends of mine.
while 001A:   12000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM6_C' 10000 ms 2   // // They're hittin' a bank and they need a driver.
while 001A:   14274 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM6_D' 10000 ms 2   // // I gave my word that you were the man so don't screw this up.
while 001A:   17302 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM6_E' 10000 ms 2   // // Get them to the bank before five o'clock not a minute after.
while 001A:   21000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
03AD: set_rubbish 1 (visible)
02EA: clear_cutscene
03C8: set_camera_in_front_of_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CUTOBJ03
0249: mark_model_as_no_longer_needed #STALLION
0249: mark_model_as_no_longer_needed #JOGARAGEEXT
0249: mark_model_as_no_longer_needed #JOGARAGEINT
00A6: destroy_car $CUT_CAR3_LM3
0004: $THUGS_SCORE = 0
0004: $SOUND_ALREADY_CREATED_BEFORE = 0
0004: $FLAG_NOT_ENOUGH_SEATS = 0
023C: load_special_actor 2 'ROBBER'
0247: request_model #COLT45
0247: request_model #UZI
0247: request_model #SHOTGUN
while true
    if or
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #COLT45 available
        8248:   NOT   model #UZI available
        8248:   NOT   model #SHOTGUN available
    jf break
    wait 0 ms
end
// START OF MISSION
018A: $BLIP1_JM6 = create_checkpoint_at 751.0 -227.0 15.21
018B: change_blip $BLIP1_JM6 display 2
//0004: $FLAG_DISPLAYED_HORN_MESSAGE_JM6 = 0
0004: $FLAG_DISPLAYED_WANTED_MESSAGE_JM6 = 0
0004: $THUG1_IS_DEAD = 0
0004: $THUG2_IS_DEAD = 0
0004: $THUG3_IS_DEAD = 0
0004: $BLIP_FOR_THUG_ADDED1 = 0
0004: $BLIP_FOR_THUG_ADDED2 = 0
0004: $BLIP_FOR_THUG_ADDED3 = 0
//PICK UP THE THUGS
:PICK_UP_THUGS
wait 0 ms
while true
    if or
        819B:   NOT   player $PLAYER stopped 1 in_rectangle_in_car 754.88 -223.875 749.5 -228.5  // never used in VC
        8122:   NOT   player $PLAYER pressing_horn
        010F:   player $PLAYER wanted_level > 0
    jf break
    wait 0 ms
    if
        019B:   player $PLAYER stopped 0 in_rectangle_in_car 754.88 -223.875 749.5 -228.5  // never used in VC
    then
        if
            010F:   player $PLAYER wanted_level > 0
        then
            if
                0038:   $FLAG_NOT_ENOUGH_SEATS == 0
            then
                00BC: print_now 'WANTED1' 5000 ms 1   // // ~g~Shake the cops and lose your wanted level!
            end
        else
            if
                0038:   $FLAG_NOT_ENOUGH_SEATS == 0
            then
                00BC: print_now 'HORN' 5000 ms 1   // // ~g~Sound the horn.
            end
        end
    else
        0004: $FLAG_NOT_ENOUGH_SEATS = 0
    end
    if
        8198:   NOT   player $PLAYER 0 in_rectangle_in_car 754.88 -223.875 749.5 -228.5  // never used in VC
    then
        03D5: remove_text 'WANTED1'   // // ~g~Shake the cops and lose your wanted level!
        03D5: remove_text 'HORN'   // // ~g~Sound the horn.
    end
    if
        0197:   player $PLAYER 0 in_rectangle_on_foot 754.88 -223.875 749.5 -228.5  // never used in VC
    then
        00BC: print_now 'JM6_5' 5000 ms 1   // // ~g~You need a getaway vehicle Idiot!
    else
        03D5: remove_text 'JM6_5'   // // ~g~You need a getaway vehicle Idiot!
    end
    00BF: $CURRENT_TIME_HOURS = current_time_hours, $CURRENT_TIME_MINUTES = current_time_minutes
    if
        0028:   $CURRENT_TIME_HOURS >= 17
    then
        00BC: print_now 'OUTTIME' 5000 ms 1   // // ~r~Too slow man too slow!
        jump @MISSION_JOEY6_FAILED
    end
end
00DA: $ANY_CAR_JM6 = player $PLAYER car
01EA: $MAXPASSENGERS = car $ANY_CAR_JM6 max_passengers
03D5: remove_text 'WANTED1'   // // ~g~Shake the cops and lose your wanted level!
03D5: remove_text 'HORN'   // // ~g~Sound the horn.
if
    8018:   NOT   $MAXPASSENGERS > 2
then
    00BC: print_now 'NODOORS' 5000 ms 1   // // ~g~They ain't sardines! Get some wheels with enough seats.
    0004: $FLAG_NOT_ENOUGH_SEATS = 1
    jump @PICK_UP_THUGS
end
if or
    00DE:   player $PLAYER driving_vehicle_type #COACH
    00DE:   player $PLAYER driving_vehicle_type #BUS
then
    00BC: print_now 'JM6_6' 5000 ms 1   // // ~g~Go and get a vehicle less conspicuous!
    0004: $FLAG_NOT_ENOUGH_SEATS = 1
    jump @PICK_UP_THUGS
end
//PICK UP THUGS CUT_SCENE**************************************************************************************
0395: clear_area 1 at 752.6899 -229.188 14.0 range 6.0
if
    8119:   NOT   car $ANY_CAR_JM6 wrecked
then
    020A: set_car $ANY_CAR_JM6 door_status_to 4
end
wait 500 ms
01B4: set_player $PLAYER can_move 0 (frozen)
02A3: toggle_widescreen 1 (on)
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
if
    8119:   NOT   car $ANY_CAR_JM6 wrecked
then
    020A: set_car $ANY_CAR_JM6 door_status_to 1
end
0164: remove_blip $BLIP1_JM6
009A: $THUG1 = create_actor 21 #SPECIAL02 at 751.5 -238.25 15.0
020F: actor $THUG1 look_at_player $PLAYER
009F: set_actor $THUG1 objective_to-1
009A: $THUG2 = create_actor 21 #SPECIAL02 at 753.38 -237.875 15.0
020F: actor $THUG2 look_at_player $PLAYER
009F: set_actor $THUG2 objective_to-1
009A: $THUG3 = create_actor 21 #SPECIAL02 at 755.38 -238.0 15.0
020F: actor $THUG3 look_at_player $PLAYER
009F: set_actor $THUG3 objective_to-1
01B2: give_actor $THUG1 weapon 17 ammo 100  // Load the weapon model before using this
01B2: give_actor $THUG2 weapon 21 ammo 50  // Load the weapon model before using this
01B2: give_actor $THUG3 weapon 23 ammo 100  // Load the weapon model before using this
015F: set_camera_position 743.75 -232.438 18.1875 0.0 0.0 0.0
0160: point_camera 744.6899 -232.125 17.9375 2
0243: set_actor $THUG1 ped_stats_to 16
0243: set_actor $THUG2 ped_stats_to 16
0243: set_actor $THUG3 ped_stats_to 16
011A: set_actor $THUG1 flags 64
011A: set_actor $THUG2 flags 64
011A: set_actor $THUG3 flags 64
wait 1000 ms
while 834E:   NOT slide_object $BANKJOB_DOOR to 752.5 -233.75 19.5 angle 0.0 0.0 0.0625 0
    wait 0 ms
    00BF: $CURRENT_TIME_HOURS = current_time_hours, $CURRENT_TIME_MINUTES = current_time_minutes
    if
        0028:   $CURRENT_TIME_HOURS >= 17
    then
        00BC: print_now 'OUTTIME' 5000 ms 1   // // ~r~Too slow man too slow!
        jump @MISSION_JOEY6_FAILED
    end
    if or
        0118:   actor $THUG1 dead
        0118:   actor $THUG2 dead
        0118:   actor $THUG3 dead
    then
        00BC: print_now 'JM6_7' 5000 ms 1   // // ~g~You need all 3 to rob the bank!
        jump @MISSION_JOEY6_FAILED
    end
end
if
    8118:   NOT   actor $THUG1 dead
then
    01DF: tie_actor $THUG1 to_player $PLAYER
    0319: set_actor $THUG1 running 1
    wait 800 ms
end
if
    8118:   NOT   actor $THUG2 dead
then
    01DF: tie_actor $THUG2 to_player $PLAYER
    0319: set_actor $THUG2 running 1
    wait 800 ms
end
if
    8118:   NOT   actor $THUG3 dead
then
    01DF: tie_actor $THUG3 to_player $PLAYER
    0319: set_actor $THUG3 running 1
end
if and
    8119:   NOT   car $ANY_CAR_JM6 wrecked
    8118:   NOT   actor $THUG1 dead
    8118:   NOT   actor $THUG2 dead
    8118:   NOT   actor $THUG3 dead
then
    0006: 17@ = 0
    while true
        if or
            80DB:   NOT   actor $THUG1 in_car $ANY_CAR_JM6
            80DB:   NOT   actor $THUG2 in_car $ANY_CAR_JM6
            80DB:   NOT   actor $THUG3 in_car $ANY_CAR_JM6
        jf break
        wait 0 ms
        if or
            0118:   actor $THUG1 dead
            0118:   actor $THUG2 dead
            0118:   actor $THUG3 dead
        then
            00BC: print_now 'JM6_7' 5000 ms 1   // // ~g~You need all 3 to rob the bank!
            jump @MISSION_JOEY6_FAILED
        end
        if
            0119:   car $ANY_CAR_JM6 wrecked
        then
            jump @MISSION_JOEY6_FAILED
        end
        00BF: $CURRENT_TIME_HOURS = current_time_hours, $CURRENT_TIME_MINUTES = current_time_minutes
        if
            0028:   $CURRENT_TIME_HOURS >= 17
        then
            00BC: print_now 'OUTTIME' 5000 ms 1   // // ~r~Too slow man too slow!
            jump @MISSION_JOEY6_FAILED
        end
        if
            0019:   17@ > 15000
        then
            jump @NEXT_ROBBER_BIT
        end
    end //while
end

:NEXT_ROBBER_BIT
03CF: load_wav 'J6_A' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
02EB: restore_camera_jumpcut
0221: set_player $PLAYER trapped_in_car 0
01B4: set_player $PLAYER can_move 1 (unfrozen)
02A3: toggle_widescreen 0 (off)
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
//END OF PICK UP THUGS CUT_SCENE*******************************************************************************
00BC: print_now 'JM6_1' 5000 ms 1   // // Get to the bank on the main drag.
while 834E:   NOT slide_object $BANKJOB_DOOR to 752.5 -233.75 17.0 angle 0.0 0.0 0.1875 0
    wait 0 ms
    00BF: $CURRENT_TIME_HOURS = current_time_hours, $CURRENT_TIME_MINUTES = current_time_minutes
    if
        0028:   $CURRENT_TIME_HOURS >= 17
    then
        00BC: print_now 'OUTTIME' 5000 ms 1   // // ~r~Too slow man too slow!
        jump @MISSION_JOEY6_FAILED
    end
    if or
        0118:   actor $THUG1 dead
        0118:   actor $THUG2 dead
        0118:   actor $THUG3 dead
    then
        00BC: print_now 'JM6_7' 5000 ms 1   // // ~g~You need all 3 to rob the bank!
        jump @MISSION_JOEY6_FAILED
    end
end
018A: $BLIP3_JM6 = create_checkpoint_at 703.0 -700.0 -100.0
0004: $FLAG_DISPLAYED_WANTED_MESSAGE_JM6 = 0

:GET_TO_THE_BANK
wait 0 ms
while true
    if or
        819E:   NOT   player $PLAYER stopped 1 in_cube 705.5 -691.5 20.0 708.75 -698.5 23.0  // never used in VC
        80E0:   NOT   player $PLAYER driving
        010F:   player $PLAYER wanted_level > 0
    jf break
    wait 0 ms
    if
        00E0:   player $PLAYER driving
    then
        00DA: $ANY_CAR_JM6 = player $PLAYER car
    end
    if
        8118:   NOT   actor $THUG1 dead
    then
        if
            8320:   NOT   actor $THUG1 in_range_of_player $PLAYER
        then
            if
                0038:   $BLIP_FOR_THUG_ADDED1 == 0
            then
                0187: $THUG1_BLIP = create_marker_above_actor $THUG1
                0004: $BLIP_FOR_THUG_ADDED1 = 1
            end
            if
                00E9:   player $PLAYER 0 near_actor $THUG1 radius 30.0 30.0
            then
                if
                    0038:   $BLIP_FOR_THUG_ADDED1 == 1
                then
                    01DF: tie_actor $THUG1 to_player $PLAYER
                    0164: remove_blip $THUG1_BLIP
                    0004: $BLIP_FOR_THUG_ADDED1 = 0
                end
            end
        end
    end
    if
        8118:   NOT   actor $THUG2 dead
    then
        if
            8320:   NOT   actor $THUG2 in_range_of_player $PLAYER
        then
            if
                0038:   $BLIP_FOR_THUG_ADDED2 == 0
            then
                0187: $THUG2_BLIP = create_marker_above_actor $THUG2
                0004: $BLIP_FOR_THUG_ADDED2 = 1
            end
            if
                00E9:   player $PLAYER 0 near_actor $THUG2 radius 30.0 30.0
            then
                if
                    0038:   $BLIP_FOR_THUG_ADDED2 == 1
                then
                    01DF: tie_actor $THUG2 to_player $PLAYER
                    0164: remove_blip $THUG2_BLIP
                    0004: $BLIP_FOR_THUG_ADDED2 = 0
                end
            end
        end
    end
    if
        8118:   NOT   actor $THUG3 dead
    then
        if
            8320:   NOT   actor $THUG3 in_range_of_player $PLAYER
        then
            if
                0038:   $BLIP_FOR_THUG_ADDED3 == 0
            then
                0187: $THUG3_BLIP = create_marker_above_actor $THUG3
                0004: $BLIP_FOR_THUG_ADDED3 = 1
            end
            if
                00E9:   player $PLAYER 0 near_actor $THUG3 radius 30.0 30.0
            then
                if
                    0038:   $BLIP_FOR_THUG_ADDED3 == 1
                then
                    01DF: tie_actor $THUG3 to_player $PLAYER
                    0164: remove_blip $THUG3_BLIP
                    0004: $BLIP_FOR_THUG_ADDED3 = 0
                end
            end
        end
    end
    if or
        0118:   actor $THUG1 dead
        0118:   actor $THUG2 dead
        0118:   actor $THUG3 dead
    then
        00BC: print_now 'JM6_7' 5000 ms 1   // // ~g~You need all 3 to rob the bank!
        jump @MISSION_JOEY6_FAILED
    end
    if
        01A0:   player $PLAYER stopped 0 in_cube_in_car 705.5 -691.5 20.0 708.75 -698.5 23.0  // never used in VC
    then
        if
            010F:   player $PLAYER wanted_level > 0
        then
            if
                0038:   $FLAG_DISPLAYED_WANTED_MESSAGE_JM6 == 0
            then
                00BC: print_now 'WANTED1' 5000 ms 1   // // ~g~Shake the cops and lose your wanted level!
                0004: $FLAG_DISPLAYED_WANTED_MESSAGE_JM6 = 1
            end
        end
    else
        if
            8057:   NOT   player $PLAYER 0 in_cube 705.5 -691.5 20.0 708.75 -698.5 23.0
        then
            0004: $FLAG_DISPLAYED_WANTED_MESSAGE_JM6 = 0
        end
    end
    if
        019C:   player $PLAYER 0 in_cube_on_foot 705.5 -691.5 20.0 708.75 -698.5 23.0  // never used in VC
    then
        00BC: print_now 'JM6_5' 5000 ms 1   // // ~g~You need a getaway vehicle Idiot!
    else
        03D5: remove_text 'JM6_5'   // // ~g~You need a getaway vehicle Idiot!
    end
    00BF: $CURRENT_TIME_HOURS = current_time_hours, $CURRENT_TIME_MINUTES = current_time_minutes
    if
        0028:   $CURRENT_TIME_HOURS >= 17
    then
        00BC: print_now 'OUTTIME' 5000 ms 1   // // ~r~Too slow man too slow!
        jump @MISSION_JOEY6_FAILED
    end
end
if or
    00DE:   player $PLAYER driving_vehicle_type #COACH
    00DE:   player $PLAYER driving_vehicle_type #BUS
then
    00BC: print_now 'JM6_6' 5000 ms 1   // // ~g~Go and get a vehicle less conspicuous!
    jump @GET_TO_THE_BANK
end
if or
    0118:   actor $THUG1 dead
    0118:   actor $THUG2 dead
    0118:   actor $THUG3 dead
then
    00BC: print_now 'JM6_7' 5000 ms 1   // // ~g~You need all 3 to rob the bank!
    jump @MISSION_JOEY6_FAILED
end
if or
    80DB:   NOT   actor $THUG1 in_car $ANY_CAR_JM6
    80DB:   NOT   actor $THUG2 in_car $ANY_CAR_JM6
    80DB:   NOT   actor $THUG3 in_car $ANY_CAR_JM6
then
    00BC: print_now 'JM6_7' 5000 ms 1   // // ~g~You need all 3 to rob the bank!
    jump @GET_TO_THE_BANK
end
// BANK ROBBERY CUT SCENE**************************************************************************************
0395: clear_area 1 at 702.25 -699.562 21.0 range 6.0
03DE: set_pedestrians_density_multiplier_to 0.0
01B4: set_player $PLAYER can_move 0 (frozen)
02A3: toggle_widescreen 1 (on)
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03BF: set_player $PLAYER ignored_by_everyone_to 1
0221: set_player $PLAYER trapped_in_car 1
015F: set_camera_position 701.4399 -705.562 20.5 0.0 0.0 0.0
0160: point_camera 701.62 -704.625 20.5625 2
0164: remove_blip $BLIP3_JM6
03CF: load_wav 'J6_B' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
00BC: print_now 'JM6_2' 5000 ms 1   // // Keep the engine running we'll be in and out in no time.
00DA: $ANY_CAR_JM6 = player $PLAYER car
if
    8119:   NOT   car $ANY_CAR_JM6 wrecked
then
    if
        8118:   NOT   actor $THUG1 dead
    then
        01E0: leave_group $THUG1
        01D3: actor $THUG1 leave_car $ANY_CAR_JM6
    end
end
wait 400 ms
if
    8119:   NOT   car $ANY_CAR_JM6 wrecked
then
    if
        8118:   NOT   actor $THUG2 dead
    then
        01E0: leave_group $THUG2
        01D3: actor $THUG2 leave_car $ANY_CAR_JM6
    end
end
wait 400 ms
if
    8119:   NOT   car $ANY_CAR_JM6 wrecked
then
    if
        8118:   NOT   actor $THUG3 dead
    then
        01E0: leave_group $THUG3
        01D3: actor $THUG3 leave_car $ANY_CAR_JM6
    end
end
0004: $OBJECTIVE_COUNT = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 0
//WAITING FOR THUGS TO GET OUT OF CAR
while 8038:   NOT   $OBJECTIVE_COUNT == 3
    wait 0 ms
    if and
        0118:   actor $THUG1 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
        0004: $THUG1_IS_DEAD = 1
    end
    if and
        0118:   actor $THUG2 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
        0004: $THUG2_IS_DEAD = 1
    end
    if and
        0118:   actor $THUG3 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
        0004: $THUG3_IS_DEAD = 1
    end
    if and
        0038:   $THUG1_IS_DEAD == 1
        0038:   $THUG2_IS_DEAD == 1
        0038:   $THUG3_IS_DEAD == 1
    then
        jump @MISSION_JOEY6_FAILED
    end
    if
        0119:   car $ANY_CAR_JM6 wrecked
    then
        jump @MISSION_JOEY6_FAILED
    end
    if and
        8119:   NOT   car $ANY_CAR_JM6 wrecked
        8118:   NOT   actor $THUG1 dead
    then
        if
            0038:   $THUG1_IS_DEAD == 0
        then
            if and
                80DB:   NOT   actor $THUG1 in_car $ANY_CAR_JM6
                0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
            then
                0239: actor $THUG1 run_to 702.38 -699.875
                wait 300 ms
                0008: $OBJECTIVE_COUNT += 1
                0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
            end
        end
    end
    if and
        8119:   NOT   car $ANY_CAR_JM6 wrecked
        8118:   NOT   actor $THUG2 dead
    then
        if
            0038:   $THUG2_IS_DEAD == 0
        then
            if and
                80DB:   NOT   actor $THUG2 in_car $ANY_CAR_JM6
                0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
            then
                0239: actor $THUG2 run_to 702.38 -699.875
                wait 300 ms
                0008: $OBJECTIVE_COUNT += 1
                0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
            end
        end
    end
    if and
        8119:   NOT   car $ANY_CAR_JM6 wrecked
        8118:   NOT   actor $THUG3 dead
    then
        if
            0038:   $THUG3_IS_DEAD == 0
        then
            if and
                80DB:   NOT   actor $THUG3 in_car $ANY_CAR_JM6
                0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
            then
                0239: actor $THUG3 run_to 702.38 -699.875
                0008: $OBJECTIVE_COUNT += 1
                0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
            end
        end
    end
end //while
0004: $OBJECTIVE_COUNT = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 0
01BB: store_object $CHINABANK_DOOR1 position_to $BANKDOOR_X $BANKDOOR_Y $BANKDOOR_Z
000D: $BANKDOOR_Y -= 1.0
01BB: store_object $CHINABANK_DOOR2 position_to $BANKDOOR2_X $BANKDOOR2_Y $BANKDOOR2_Z
0009: $BANKDOOR2_Y += 1.0
while true
    if or
        834E:   NOT slide_object $CHINABANK_DOOR1 to $BANKDOOR_X $BANKDOOR_Y $BANKDOOR_Z angle 0.0 0.0625 0.0 0
        834E:   NOT slide_object $CHINABANK_DOOR2 to $BANKDOOR2_X $BANKDOOR2_Y $BANKDOOR2_Z angle 0.0 0.0625 0.0 0
    jf break
    wait 0 ms
end
0006: 17@ = 0
while 8038:   NOT   $OBJECTIVE_COUNT == 3
    wait 0 ms
    if and
        0118:   actor $THUG1 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
        0004: $THUG1_IS_DEAD = 1
    end
    if and
        0118:   actor $THUG2 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
        0004: $THUG2_IS_DEAD = 1
    end
    if and
        0118:   actor $THUG3 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
        0004: $THUG3_IS_DEAD = 1
    end
    if and
        0038:   $THUG1_IS_DEAD == 1
        0038:   $THUG2_IS_DEAD == 1
        0038:   $THUG3_IS_DEAD == 1
    then
        jump @MISSION_JOEY6_FAILED
    end
    if
        0038:   $THUG1_IS_DEAD == 0
    then
        if and
            0126:   actor $THUG1 walking
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
        then
            0239: actor $THUG1 run_to 697.88 -700.188
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
        end
    end
    if
        0038:   $THUG2_IS_DEAD == 0
    then
        if and
            0126:   actor $THUG2 walking
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
        then
            0239: actor $THUG2 run_to 697.88 -700.188
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
        end
    end
    if
        0038:   $THUG3_IS_DEAD == 0
    then
        if and
            0126:   actor $THUG3 walking
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
        then
            0239: actor $THUG3 run_to 697.88 -700.188
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
        end
    end
    if
        0019:   17@ > 15000
    then
        if
            8118:   NOT   actor $THUG1 dead
        then
            00A1: put_actor $THUG1 at 702.38 -699.875 19.875
        end
        if
            8118:   NOT   actor $THUG2 dead
        then
            00A1: put_actor $THUG2 at 702.38 -699.875 19.875
        end
        if
            8118:   NOT   actor $THUG3 dead
        then
            00A1: put_actor $THUG3 at 702.38 -699.875 19.875
        end
    end
end //while
0004: $OBJECTIVE_COUNT = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 0
0006: 17@ = 0
while 8038:   NOT   $OBJECTIVE_COUNT == 3
    wait 0 ms
    if and
        0118:   actor $THUG1 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
        0004: $THUG1_IS_DEAD = 1
    end
    if and
        0118:   actor $THUG2 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
        0004: $THUG2_IS_DEAD = 1
    end
    if and
        0118:   actor $THUG3 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
        0004: $THUG3_IS_DEAD = 1
    end
    if and
        0038:   $THUG1_IS_DEAD == 1
        0038:   $THUG2_IS_DEAD == 1
        0038:   $THUG3_IS_DEAD == 1
    then
        jump @MISSION_JOEY6_FAILED
    end
    if
        0038:   $THUG1_IS_DEAD == 0
    then
        if and
            0126:   actor $THUG1 walking
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
        then
            00A1: put_actor $THUG1 at 769.0 -792.0 20.0
            0192: set_actor $THUG1 objective_to_stand_still
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
        end
    end
    if
        0038:   $THUG2_IS_DEAD == 0
    then
        if and
            0126:   actor $THUG2 walking
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
        then
            00A1: put_actor $THUG2 at 767.0 -792.0 20.0
            0192: set_actor $THUG2 objective_to_stand_still
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
        end
    end
    if
        0038:   $THUG3_IS_DEAD == 0
    then
        if and
            0126:   actor $THUG3 walking
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
        then
            00A1: put_actor $THUG3 at 765.0 -792.0 20.0
            0192: set_actor $THUG3 objective_to_stand_still
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
        end
    end
    if
        0019:   17@ > 15000
    then
        if
            8118:   NOT   actor $THUG1 dead
        then
            00A1: put_actor $THUG1 at 697.88 -700.188 19.875
        end
        if
            8118:   NOT   actor $THUG2 dead
        then
            00A1: put_actor $THUG2 at 697.88 -700.188 19.875
        end
        if
            8118:   NOT   actor $THUG3 dead
        then
            00A1: put_actor $THUG3 at 697.88 -700.188 19.875
        end
    end
end //while
03CF: load_wav 'J6_1' as 1
01BB: store_object $CHINABANK_DOOR1 position_to $BANKDOOR_X $BANKDOOR_Y $BANKDOOR_Z
0009: $BANKDOOR_Y += 1.0
01BB: store_object $CHINABANK_DOOR2 position_to $BANKDOOR2_X $BANKDOOR2_Y $BANKDOOR2_Z
000D: $BANKDOOR2_Y -= 1.0
while true
    if or
        834E:   NOT slide_object $CHINABANK_DOOR1 to $BANKDOOR_X $BANKDOOR_Y $BANKDOOR_Z angle 0.0 0.0625 0.0 0
        834E:   NOT slide_object $CHINABANK_DOOR2 to $BANKDOOR2_X $BANKDOOR2_Y $BANKDOOR2_Z angle 0.0 0.0625 0.0 0
    jf break
    wait 0 ms
end
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
while 83D2:   NOT   wav 1 ended
    wait 0 ms
end
wait 1000 ms
//THUGS COME OUT OF BANK
0395: clear_area 1 at 702.25 -699.562 21.0 range 4.0
01BB: store_object $CHINABANK_DOOR1 position_to $BANKDOOR_X $BANKDOOR_Y $BANKDOOR_Z
000D: $BANKDOOR_Y -= 1.0
01BB: store_object $CHINABANK_DOOR2 position_to $BANKDOOR2_X $BANKDOOR2_Y $BANKDOOR2_Z
0009: $BANKDOOR2_Y += 1.0
while true
    if or
        834E:   NOT slide_object $CHINABANK_DOOR1 to $BANKDOOR_X $BANKDOOR_Y $BANKDOOR_Z angle 0.0 0.0625 0.0 0
        834E:   NOT slide_object $CHINABANK_DOOR2 to $BANKDOOR2_X $BANKDOOR2_Y $BANKDOOR2_Z angle 0.0 0.0625 0.0 0
    jf break
    wait 0 ms
end
if
    8118:   NOT   actor $THUG1 dead
then
    00A1: put_actor $THUG1 at 697.88 -700.188 21.0
    0239: actor $THUG1 run_to 701.88 -700.188
end
wait 800 ms
if
    8118:   NOT   actor $THUG2 dead
then
    00A1: put_actor $THUG2 at 697.88 -700.188 21.0
    0239: actor $THUG2 run_to 701.88 -700.188
end
wait 800 ms
if
    8118:   NOT   actor $THUG3 dead
then
    00A1: put_actor $THUG3 at 697.88 -700.188 21.0
    0239: actor $THUG3 run_to 701.88 -700.188
end
0004: $OBJECTIVE_COUNT = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 0
0006: 17@ = 0
while 8038:   NOT   $OBJECTIVE_COUNT == 3
    wait 0 ms
    if and
        0118:   actor $THUG1 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
        0004: $THUG1_IS_DEAD = 1
    end
    if and
        0118:   actor $THUG2 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
        0004: $THUG2_IS_DEAD = 1
    end
    if and
        0118:   actor $THUG3 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
        0004: $THUG3_IS_DEAD = 1
    end
    if and
        0038:   $THUG1_IS_DEAD == 1
        0038:   $THUG2_IS_DEAD == 1
        0038:   $THUG3_IS_DEAD == 1
    then
        jump @MISSION_JOEY6_FAILED
    end
    if
        0038:   $THUG1_IS_DEAD == 0
    then
        if and
            0126:   actor $THUG1 walking
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
        then
            01DF: tie_actor $THUG1 to_player $PLAYER
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
        end
    end
    if
        0038:   $THUG2_IS_DEAD == 0
    then
        if and
            0126:   actor $THUG2 walking
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
        then
            01DF: tie_actor $THUG2 to_player $PLAYER
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
        end
    end
    if
        0038:   $THUG3_IS_DEAD == 0
    then
        if and
            0126:   actor $THUG3 walking
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
        then
            01DF: tie_actor $THUG3 to_player $PLAYER
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
        end
    end
    if
        0019:   17@ > 15000
    then
        if
            8118:   NOT   actor $THUG1 dead
        then
            00A1: put_actor $THUG1 at 701.88 -700.188 19.875
        end
        if
            8118:   NOT   actor $THUG2 dead
        then
            00A1: put_actor $THUG2 at 701.88 -700.188 19.875
        end
        if
            8118:   NOT   actor $THUG3 dead
        then
            00A1: put_actor $THUG3 at 701.88 -700.188 19.875
        end
    end
end
018D: $JOEY_ALARM_LOOP = create_sound 0 at 699.75 -700.062 21.0
0004: $SOUND_ALREADY_CREATED_BEFORE = 1
03CF: load_wav 'J6_D' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
010E: set_player $PLAYER minimum_wanted_level_to 3
01BB: store_object $CHINABANK_DOOR1 position_to $BANKDOOR_X $BANKDOOR_Y $BANKDOOR_Z
0009: $BANKDOOR_Y += 1.0
01BB: store_object $CHINABANK_DOOR2 position_to $BANKDOOR2_X $BANKDOOR2_Y $BANKDOOR2_Z
000D: $BANKDOOR2_Y -= 1.0
while true
    if or
        834E:   NOT slide_object $CHINABANK_DOOR1 to $BANKDOOR_X $BANKDOOR_Y $BANKDOOR_Z angle 0.0 0.0625 0.0 0
        834E:   NOT slide_object $CHINABANK_DOOR2 to $BANKDOOR2_X $BANKDOOR2_Y $BANKDOOR2_Z angle 0.0 0.0625 0.0 0
    jf break
    wait 0 ms
end
while 83D2:   NOT   wav 1 ended
    wait 0 ms
end
0004: $OBJECTIVE_COUNT = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 0
01B4: set_player $PLAYER can_move 1 (unfrozen)
02A3: toggle_widescreen 0 (off)
02EB: restore_camera_jumpcut
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
0221: set_player $PLAYER trapped_in_car 0
03DE: set_pedestrians_density_multiplier_to 1.0
0006: 17@ = 0
while 8038:   NOT   $OBJECTIVE_COUNT == 3    //WAITING FOR THUGS TO GET BACK INTO CAR
    wait 0 ms
    if and
        0118:   actor $THUG1 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
        0004: $THUG1_IS_DEAD = 1
    end
    if and
        0118:   actor $THUG2 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
        0004: $THUG2_IS_DEAD = 1
    end
    if and
        0118:   actor $THUG3 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
        0004: $THUG3_IS_DEAD = 1
    end
    if and
        0038:   $THUG1_IS_DEAD == 1
        0038:   $THUG2_IS_DEAD == 1
        0038:   $THUG3_IS_DEAD == 1
    then
        jump @MISSION_JOEY6_FAILED
    end
    if
        0119:   car $ANY_CAR_JM6 wrecked
    then
        jump @MISSION_JOEY6_FAILED
    end
    if
        0038:   $THUG1_IS_DEAD == 0
    then
        if and
            00DB:   actor $THUG1 in_car $ANY_CAR_JM6
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
        then
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
        end
    end
    if
        0038:   $THUG2_IS_DEAD == 0
    then
        if and
            00DB:   actor $THUG2 in_car $ANY_CAR_JM6
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
        then
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
        end
    end
    if
        0038:   $THUG3_IS_DEAD == 0
    then
        if and
            00DB:   actor $THUG3 in_car $ANY_CAR_JM6
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
        then
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
        end
    end
end //while
//END OF BANK ROBBERY CUT SCENE********************************************************************************
018A: $BLIP2_JM6 = create_checkpoint_at 751.0 -227.0 -100.0
018B: change_blip $BLIP2_JM6 display 2
03CF: load_wav 'J6_C' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D1: play_wav 1
00BC: print_now 'JM6_3' 3000 ms 1   // // Get us out of here!!
//Get back to warehouse
:BACK_TO_SAFE_HOUSE
wait 0 ms
while true
    if or
        8199:   NOT   player $PLAYER stopped_in-sphere 1 in_rectangle 754.88 -223.875 749.5 -228.5  // never used in VC
        80E0:   NOT   player $PLAYER driving
        010F:   player $PLAYER wanted_level > 0
    jf break
    wait 0 ms
    if
        00E0:   player $PLAYER driving
    then
        00DA: $ANY_CAR_JM6 = player $PLAYER car
    end
    if and
        0118:   actor $THUG1 dead
        0118:   actor $THUG2 dead
        0118:   actor $THUG3 dead
    then
        00BC: print_now 'JM6_8' 5000 ms 1   // // ~r~You've lost all the robbers!
        jump @MISSION_JOEY6_FAILED
    end
    if
        8118:   NOT   actor $THUG1 dead
    then
        if
            8320:   NOT   actor $THUG1 in_range_of_player $PLAYER
        then
            if
                0038:   $BLIP_FOR_THUG_ADDED1 == 0
            then
                0187: $THUG1_BLIP = create_marker_above_actor $THUG1
                0004: $BLIP_FOR_THUG_ADDED1 = 1
            end
            if
                00E9:   player $PLAYER 0 near_actor $THUG1 radius 30.0 30.0
            then
                if
                    0038:   $BLIP_FOR_THUG_ADDED1 == 1
                then
                    01DF: tie_actor $THUG1 to_player $PLAYER
                    0164: remove_blip $THUG1_BLIP
                    0004: $BLIP_FOR_THUG_ADDED1 = 0
                end
            end
        end
    end
    if
        8118:   NOT   actor $THUG2 dead
    then
        if
            8320:   NOT   actor $THUG2 in_range_of_player $PLAYER
        then
            if
                0038:   $BLIP_FOR_THUG_ADDED2 == 0
            then
                0187: $THUG2_BLIP = create_marker_above_actor $THUG2
                0004: $BLIP_FOR_THUG_ADDED2 = 1
            end
            if
                00E9:   player $PLAYER 0 near_actor $THUG2 radius 30.0 30.0
            then
                if
                    0038:   $BLIP_FOR_THUG_ADDED2 == 1
                then
                    01DF: tie_actor $THUG2 to_player $PLAYER
                    0164: remove_blip $THUG2_BLIP
                    0004: $BLIP_FOR_THUG_ADDED2 = 0
                end
            end
        end
    end
    if
        8118:   NOT   actor $THUG3 dead
    then
        if
            8320:   NOT   actor $THUG3 in_range_of_player $PLAYER
        then
            if
                0038:   $BLIP_FOR_THUG_ADDED3 == 0
            then
                0187: $THUG3_BLIP = create_marker_above_actor $THUG3
                0004: $BLIP_FOR_THUG_ADDED3 = 1
            end
            if
                00E9:   player $PLAYER 0 near_actor $THUG3 radius 30.0 30.0
            then
                if
                    0038:   $BLIP_FOR_THUG_ADDED3 == 1
                then
                    01DF: tie_actor $THUG3 to_player $PLAYER
                    0164: remove_blip $THUG3_BLIP
                    0004: $BLIP_FOR_THUG_ADDED3 = 0
                end
            end
        end
    end
    if
        019B:   player $PLAYER stopped 0 in_rectangle_in_car 754.88 -223.875 749.5 -228.5  // never used in VC
    then
        if
            010F:   player $PLAYER wanted_level > 0
        then
            if
                0038:   $FLAG_DISPLAYED_WANTED_MESSAGE_JM6 == 0
            then
                00BC: print_now 'WANTED1' 5000 ms 1   // // ~g~Shake the cops and lose your wanted level!
                0004: $FLAG_DISPLAYED_WANTED_MESSAGE_JM6 = 1
            end
        end
    else
        if
            8056:   NOT   player $PLAYER 0 in_rectangle 754.88 -223.875 749.5 -228.5
        then
            0004: $FLAG_DISPLAYED_WANTED_MESSAGE_JM6 = 0
        end
    end
    if
        0197:   player $PLAYER in-sphere 1 in_rectangle_on_foot 754.88 -223.875 749.5 -228.5  // never used in VC
    then
        00BC: print_now 'EBAL_5' 5000 ms 1   // // ~g~Get a vehicle!
    else
        03D5: remove_text 'EBAL_5'   // // ~g~Get a vehicle!
    end
end //while
//THUGS GO BACK INTO SAFEHOUSE CUT_SCENE***********************************************************************
if
    8118:   NOT   actor $THUG1 dead
then
    if
        8320:   NOT   actor $THUG1 in_range_of_player $PLAYER
    then
        00BC: print_now 'HEY2' 4000 ms 1   // // ~g~Don't split up keep the group together!
        jump @BACK_TO_SAFE_HOUSE
    end
end
if
    8118:   NOT   actor $THUG2 dead
then
    if
        8320:   NOT   actor $THUG2 in_range_of_player $PLAYER
    then
        00BC: print_now 'HEY2' 4000 ms 1   // // ~g~Don't split up keep the group together!
        jump @BACK_TO_SAFE_HOUSE
    end
end
if
    8118:   NOT   actor $THUG3 dead
then
    if
        8320:   NOT   actor $THUG3 in_range_of_player $PLAYER
    then
        00BC: print_now 'HEY2' 4000 ms 1   // // ~g~Don't split up keep the group together!
        jump @BACK_TO_SAFE_HOUSE
    end
end
0395: clear_area 1 at 752.6899 -229.188 14.0 range 6.0
01B4: set_player $PLAYER can_move 0 (frozen)
02A3: toggle_widescreen 1 (on)
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
015F: set_camera_position 763.75 -228.875 22.6875 0.0 0.0 0.0
0160: point_camera 763.0 -229.062 22.0625 2
if
    8119:   NOT   car $ANY_CAR_JM6 wrecked
then
    0221: set_player $PLAYER trapped_in_car 1
    if
        8118:   NOT   actor $THUG1 dead
    then
        01E0: leave_group $THUG1
        if
            00DF:   actor $THUG1 driving
        then
            00D9: $ANY_CAR_JM6 = actor $THUG1 car
            01D3: actor $THUG1 leave_car $ANY_CAR_JM6
        end
    end
    wait 400 ms
    if
        8118:   NOT   actor $THUG2 dead
    then
        01E0: leave_group $THUG2
        if
            00DF:   actor $THUG2 driving
        then
            00D9: $ANY_CAR_JM6 = actor $THUG2 car
            01D3: actor $THUG2 leave_car $ANY_CAR_JM6
        end
    end
    wait 400 ms
    if
        8118:   NOT   actor $THUG3 dead
    then
        01E0: leave_group $THUG3
        if
            00DF:   actor $THUG3 driving
        then
            00D9: $ANY_CAR_JM6 = actor $THUG3 car
            01D3: actor $THUG3 leave_car $ANY_CAR_JM6
        end
    end
end
if
    8118:   NOT   actor $THUG1 dead
then
    if
        80E9:   NOT   player $PLAYER 0 near_actor $THUG1 radius 30.0 30.0
    then
        if
            8118:   NOT   actor $THUG1 dead
        then
            01C2: remove_references_to_actor $THUG1  // Like turning an actor into a random pedestrian
        end
    end
end
if
    8118:   NOT   actor $THUG2 dead
then
    if
        80E9:   NOT   player $PLAYER 0 near_actor $THUG2 radius 30.0 30.0
    then
        if
            8118:   NOT   actor $THUG2 dead
        then
            01C2: remove_references_to_actor $THUG2  // Like turning an actor into a random pedestrian
        end
    end
end
if
    8118:   NOT   actor $THUG3 dead
then
    if
        80E9:   NOT   player $PLAYER 0 near_actor $THUG3 radius 30.0 30.0
    then
        if
            8118:   NOT   actor $THUG3 dead
        then
            01C2: remove_references_to_actor $THUG3  // Like turning an actor into a random pedestrian
        end
    end
end
0004: $OBJECTIVE_COUNT = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 0
while 834E:   NOT slide_object $BANKJOB_DOOR to 752.5 -233.75 20.0 angle 0.0 0.0 0.1875 0
    wait 0 ms
end
while 8038:   NOT   $OBJECTIVE_COUNT == 3  //WAITING FOR THUGS TO GET OUT OF CAR
    wait 0 ms
    if
        0118:   actor $THUG1 dead
    then
        if
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
        then
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
            0004: $THUG1_IS_DEAD = 1
        end
    end
    if and
        0118:   actor $THUG2 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
        0004: $THUG2_IS_DEAD = 1
    end
    if and
        0118:   actor $THUG3 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
        0004: $THUG3_IS_DEAD = 1
    end
    if and
        0038:   $THUG1_IS_DEAD == 1
        0038:   $THUG2_IS_DEAD == 1
        0038:   $THUG3_IS_DEAD == 1
    then
        jump @MISSION_JOEY6_FAILED
    end
    if
        8119:   NOT   car $ANY_CAR_JM6 wrecked
    then
        if
            0038:   $THUG1_IS_DEAD == 0
        then
            if and
                80DB:   NOT   actor $THUG1 in_car $ANY_CAR_JM6
                0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
            then
                0239: actor $THUG1 run_to 752.0 -238.562
                0008: $OBJECTIVE_COUNT += 1
                0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
            end
        end
        if
            0038:   $THUG2_IS_DEAD == 0
        then
            if and
                80DB:   NOT   actor $THUG2 in_car $ANY_CAR_JM6
                0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
            then
                0239: actor $THUG2 run_to 752.5 -238.562
                0008: $OBJECTIVE_COUNT += 1
                0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
            end
        end
        if
            0038:   $THUG3_IS_DEAD == 0
        then
            if and
                80DB:   NOT   actor $THUG3 in_car $ANY_CAR_JM6
                0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
            then
                0239: actor $THUG3 run_to 753.0 -238.562
                0008: $OBJECTIVE_COUNT += 1
                0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
            end
        end
    end
end //while
0164: remove_blip $BLIP1_JM6
if
    8118:   NOT   actor $THUG1 dead
then
    0239: actor $THUG1 run_to 752.0 -238.562
end
if
    8118:   NOT   actor $THUG2 dead
then
    0239: actor $THUG2 run_to 752.5 -238.562
end
if
    8118:   NOT   actor $THUG3 dead
then
    0239: actor $THUG3 run_to 753.0 -238.562
end
0004: $OBJECTIVE_COUNT = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 0
0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 0
0006: 17@ = 0
while 8038:   NOT   $OBJECTIVE_COUNT == 3
    wait 0 ms
    if and
        0118:   actor $THUG1 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
        0004: $THUG1_IS_DEAD = 1
    end
    if and
        0118:   actor $THUG2 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
        0004: $THUG2_IS_DEAD = 1
    end
    if and
        0118:   actor $THUG3 dead
        0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
    then
        0008: $OBJECTIVE_COUNT += 1
        0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
        0004: $THUG3_IS_DEAD = 1
    end
    if and
        0038:   $THUG1_IS_DEAD == 1
        0038:   $THUG2_IS_DEAD == 1
        0038:   $THUG3_IS_DEAD == 1
    then
        jump @MISSION_JOEY6_FAILED
    end
    if
        0038:   $THUG1_IS_DEAD == 0
    then
        if and
            0126:   actor $THUG1 walking
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE1 == 0
        then
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE1 = 1
        end
    end
    if
        0038:   $THUG2_IS_DEAD == 0
    then
        if and
            0126:   actor $THUG2 walking
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE2 == 0
        then
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE2 = 1
        end
    end
    if
        0038:   $THUG3_IS_DEAD == 0
    then
        if and
            0126:   actor $THUG3 walking
            0038:   $OBJECTIVE_COUNT_DONE_BEFORE3 == 0
        then
            0008: $OBJECTIVE_COUNT += 1
            0004: $OBJECTIVE_COUNT_DONE_BEFORE3 = 1
        end
    end
    if
        0019:   17@ > 15000
    then
        if
            8118:   NOT   actor $THUG1 dead
        then
            00A1: put_actor $THUG1 at 752.0 -238.562 16.0
        end
        if
            8118:   NOT   actor $THUG2 dead
        then
            00A1: put_actor $THUG2 at 752.5 -238.562 16.0
        end
        if
            8118:   NOT   actor $THUG3 dead
        then
            00A1: put_actor $THUG3 at 753.0 -238.562 16.0
        end
    end
end //while
if
    8118:   NOT   actor $THUG1 dead
then
    0192: set_actor $THUG1 objective_to_stand_still
end
if
    8118:   NOT   actor $THUG2 dead
then
    0192: set_actor $THUG2 objective_to_stand_still
end
if
    8118:   NOT   actor $THUG3 dead
then
    0192: set_actor $THUG3 objective_to_stand_still
end
while 834E:   NOT slide_object $BANKJOB_DOOR to 752.5 -233.75 17.0 angle 0.0 0.0 0.0625 0
    wait 0 ms
end
01B4: set_player $PLAYER can_move 1 (unfrozen)
02A3: toggle_widescreen 0 (off)
02EB: restore_camera_jumpcut
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
0221: set_player $PLAYER trapped_in_car 0
//THUGS GO BACK INTO SAFEHOUSE CUT_SCENE***********************************************************************
jump @MISSION_JOEY6_PASSED

:MISSION_JOEY6_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // // MISSION FAILED!
return

:MISSION_JOEY6_PASSED
0004: $THE_GETAWAY_COMPLETED = 1
if
    8118:   NOT   actor $THUG1 dead
then
    0008: $THUGS_SCORE += 10000
end
009B: destroy_actor_instantly $THUG1
if
    8118:   NOT   actor $THUG2 dead
then
    0008: $THUGS_SCORE += 10000
end
009B: destroy_actor_instantly $THUG2
if
    8118:   NOT   actor $THUG3 dead
then
    0008: $THUGS_SCORE += 10000
end
009B: destroy_actor_instantly $THUG3
0394: play_music 1
01E3: text_1number_styled 'M_PASS' $THUGS_SCORE 5000 ms 1   // // MISSION PASSED! $~1~
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += $THUGS_SCORE
0318: set_latest_mission_passed 'JM6'   // // 'THE GETAWAY'
030C: set_mission_points += 1
0164: remove_blip $JOEY_MISSION_MARKER
return

:MISSION_CLEANUP_JOEY6
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_JOEY = 0
if
    0038:   $SOUND_ALREADY_CREATED_BEFORE == 1
then
    018E: stop_sound $JOEY_ALARM_LOOP
end
0164: remove_blip $BLIP1_JM6
0164: remove_blip $BLIP3_JM6
0164: remove_blip $BLIP2_JM6
0164: remove_blip $THUG1_BLIP
0164: remove_blip $THUG2_BLIP
0164: remove_blip $THUG3_BLIP
040D: unload_wav 1
03DE: set_pedestrians_density_multiplier_to 1.0
0296: unload_special_actor 2
mission_cleanup
return
