//-------------Mission 50-------------
// Originally: Kenji mission 2 'GRAND THEFT AUTO'

:M50_GRANDTHEFTAUTO
03A4: name_thread 'KENJI2'
054C: use_GXT_table 'KENJI2'
058E: set_restart_mission_taxi_destination 75.0 -1400.0 31.65 0.0
gosub @MISSION_START_KENJI2
if
    wasted_or_busted
then
    gosub @MISSION_KENJI2_FAILED
end
gosub @MISSION_CLEANUP_KENJI2
end_thread

:MISSION_START_KENJI2
$FLAG_PLAYER_ON_MISSION = 1
$ON_MISSION_FOR_KENJI = 1
increment_mission_attempts
wait 0 ms

$FLAG_PLAYER_DAMAGE_MESSAGE_CAR1_KM2 = 0
$FLAG_PLAYER_DAMAGE_MESSAGE_CAR2_KM2 = 0
$FLAG_PLAYER_DAMAGE_MESSAGE_CAR3_KM2 = 0
$FLAG_PLAYER_DAMAGE_MESSAGE_CAR4_KM2 = 0
$FLAG_PLAYER_DAMAGE_MESSAGE_CAR5_KM2 = 0

$FLAG_CAR1_IN_GARAGE = 0
$FLAG_CAR2_IN_GARAGE = 0
$FLAG_CAR3_IN_GARAGE = 0
$FLAG_CAR4_IN_GARAGE = 0
$FLAG_CAR5_IN_GARAGE = 0

$COUNTER_NUMBER_OF_CARS_IN_GARAGE_KM2 = 0
$RADAR_BLIP_CAR1_KM2 = 0

//0004: $COUNTER_NUMBER_OF_CARS_IN_GARAGE_KM2 = 0    unused by Rockstar

$FLAG_BLIP_CAR1_ON = 0
$FLAG_BLIP_CAR2_ON = 0
$FLAG_BLIP_CAR3_ON = 0
$FLAG_BLIP_CAR4_ON = 0
$FLAG_BLIP_CAR5_ON = 0

$FLAG_CAR1_DESTROYED = 0
$FLAG_CAR2_DESTROYED = 0
$FLAG_CAR3_DESTROYED = 0
$FLAG_CAR4_DESTROYED = 0
$FLAG_CAR5_DESTROYED = 0

$FLAG_GARAGE_NO_BLIP_CAR1_KM2 = 0
$FLAG_GARAGE_NO_BLIP_CAR2_KM2 = 0
$FLAG_GARAGE_NO_BLIP_CAR3_KM2 = 0
$FLAG_GARAGE_NO_BLIP_CAR4_KM2 = 0
$FLAG_GARAGE_NO_BLIP_CAR5_KM2 = 0

$FLAG_SPRAY_BLIP_ON_CAR1_KM2 = 0
$FLAG_SPRAY_BLIP_ON_CAR2_KM2 = 0
$FLAG_SPRAY_BLIP_ON_CAR3_KM2 = 0
$FLAG_SPRAY_BLIP_ON_CAR4_KM2 = 0
$FLAG_SPRAY_BLIP_ON_CAR5_KM2 = 0
if
    02BD:   debug_mode == DEBUG_MASTEREXTRAS2
then
    $TIMER_KM2 = 601000     // 10 minutes - time limit for all 5 cars
    $KM2_CARS_NEEDED_TO_FINISH = 5
    $KM2_REWARD = 45000
else
    $TIMER_KM2 = 361000
    $KM2_CARS_NEEDED_TO_FINISH = 3
    $KM2_REWARD = 25000
end
$FLAG_PLAYER_HAD_GARAGE_CAR1_MESSAGE = 0
$FLAG_PLAYER_HAD_GARAGE_CAR2_MESSAGE = 0
$FLAG_PLAYER_HAD_GARAGE_CAR3_MESSAGE = 0
$FLAG_PLAYER_HAD_GARAGE_CAR4_MESSAGE = 0
$FLAG_PLAYER_HAD_GARAGE_CAR5_MESSAGE = 0

023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'KENJI'
02F3: load_object #CUTOBJ01 'KENJIH'
02F3: load_object #CUTOBJ02 'PLAYERH'
02F3: load_object #CUTOBJ03 'MINNOTE'
0247: request_model #CASINO_GARDEN
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model available #CUTOBJ01
        8248:   NOT   model available #CUTOBJ02
        8248:   NOT   model available #CUTOBJ03
        8248:   NOT   model available #CASINO_GARDEN
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'K2_GIS'
0244: set_cutscene_pos 141.375 -1382.12 73.3125
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_KENJI = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_KENJI 'KENJI'
//02F4: create_cutscene_actor $KENJI_CSHEAD from_head #CUTOBJ01 and_body $CUTSCENE_KENJI
//02F5: set_head_anim $KENJI_CSHEAD 'KENJI'
02E5: $CS_NOTE = create_cutscene_object #CUTOBJ03
02E6: set_cutscene_anim $CS_NOTE 'MINNOTE'
//02F4: create_cutscene_actor $PLAYER_CSHEAD from_head #CUTOBJ02 and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
0395: clear_area 1 at 124.062 -1413.0 31.0625 range 1.0
0055: set_player_coordinates $PLAYER at 124.062 -1413.0 31.0625
0171: set_player $PLAYER z_angle_to 132.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   3902 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM2_A' 10000 ms 1   // It is impossible to over-estimate the importance of etiquette in this line of work.
while 001A:   8570 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM2_B' 10000 ms 1   // To my eternal shame a man once did me a favor and I have never had the opportunity to repay his kindness.
while 001A:   15119 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM2_C' 10000 ms 1   // The man's weakness is motor cars and he has requested that we acquire him certain models for his collection.
while 001A:   21459 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM2_D' 10000 ms 1   // Needless to say we must give him the cars as a gift to repay the debt that I owe him.
while 001A:   27033 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM2_E' 10000 ms 1   // You must obtain the cars on this list and deliver them to a garage behind the car park in Newport.
while 001A:   33164 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM2_F' 10000 ms 1   // My honor demands it.
while 001A:   34918 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
03D5: remove_text 'KM2_F' 10000 ms 1   // My honor demands it.
while 001A:   39333 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
03AD: set_rubbish 1 (visible)
03C8: set_camera_in_front_of_player
wait 500 ms
fade 1 1500 ms
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CUTOBJ03
0249: mark_model_as_no_longer_needed #CASINO_GARDEN
0247: request_model #CHEETAH
0247: request_model #STINGER
0247: request_model #INFERNUS
0247: request_model #BANSHEE
0247: request_model #PCJ600
//0247: request_model #LANDSTAL
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #CHEETAH available
        8248:   NOT   model #STINGER available
        8248:   NOT   model #INFERNUS available
        8248:   NOT   model #BANSHEE available
        8248:   NOT   model #PCJ600 available
//        8248:   NOT   model #LANDSTAL available
    jf break
    wait 0 ms
end
00BC: print_now 'KM2_3' 5000 ms 1   // ~g~Remember the ~r~cars~g~ have to be in mint condition to be accepted by the ~p~garage~g~.
018A: $RADAR_BLIP_COORD1_KM2 = create_checkpoint_at 40.0 -506.875 31.8

00A5: $CAR_TO_STEAL1_KM2 = create_car #CHEETAH at 13.3 -0.5 22.0
0175: set_car $CAR_TO_STEAL1_KM2 z_angle_to 270.0
0229: set_car $CAR_TO_STEAL1_KM2 color_to 13 13
0294: set_can_respray_car $CAR_TO_STEAL1_KM2 flag 0
0186: $RADAR_BLIP_CAR1_KM2 = create_marker_above_car $CAR_TO_STEAL1_KM2
0004: $FLAG_BLIP_CAR1_ON = 1

if
    02BD:   debug_mode == DEBUG_MASTEREXTRAS2
then
    00A5: $CAR_TO_STEAL2_KM2 = create_car #BANSHEE at -123.8 -312.4 21.5
    0175: set_car $CAR_TO_STEAL2_KM2 z_angle_to 90.0
    0229: set_car $CAR_TO_STEAL2_KM2 color_to 13 13
    0294: set_can_respray_car $CAR_TO_STEAL2_KM2 flag 0
    0186: $RADAR_BLIP_CAR2_KM2 = create_marker_above_car $CAR_TO_STEAL2_KM2
    0004: $FLAG_BLIP_CAR2_ON = 1
end

00A5: $CAR_TO_STEAL3_KM2 = create_car #STINGER at -406.1 -1467.4 31.1
0175: set_car $CAR_TO_STEAL3_KM2 z_angle_to 270.0
0229: set_car $CAR_TO_STEAL3_KM2 color_to 13 13
0294: set_can_respray_car $CAR_TO_STEAL3_KM2 flag 0
0186: $RADAR_BLIP_CAR3_KM2 = create_marker_above_car $CAR_TO_STEAL3_KM2
0004: $FLAG_BLIP_CAR3_ON = 1

00A5: $CAR_TO_STEAL4_KM2 = create_car #INFERNUS at -396.7 -358.4 21.2
0175: set_car $CAR_TO_STEAL4_KM2 z_angle_to 90.0
0229: set_car $CAR_TO_STEAL4_KM2 color_to 13 13
0294: set_can_respray_car $CAR_TO_STEAL4_KM2 flag 0
0186: $RADAR_BLIP_CAR4_KM2 = create_marker_above_car $CAR_TO_STEAL4_KM2
0004: $FLAG_BLIP_CAR4_ON = 1

if
    02BD:   debug_mode == DEBUG_MASTEREXTRAS2
then
    00A5: $CAR_TO_STEAL5_KM2 = create_car #PCJ600 at -134.3 -1006.2 31.1
    //00A5: $CAR_TO_STEAL5_KM2 = create_car #LANDSTAL at -134.3 -1006.2 31.1
    0175: set_car $CAR_TO_STEAL5_KM2 z_angle_to 90.0
    0229: set_car $CAR_TO_STEAL5_KM2 color_to 13 13
    0294: set_can_respray_car $CAR_TO_STEAL5_KM2 flag 0
    0186: $RADAR_BLIP_CAR5_KM2 = create_marker_above_car $CAR_TO_STEAL5_KM2
    0004: $FLAG_BLIP_CAR5_ON = 1
end

014E: set_timer_to $TIMER_KM2 type 1

while $TIMER_KM2 > 0
    wait 0 ms
    if
        003A:   $COUNTER_NUMBER_OF_CARS_IN_GARAGE_KM2 == $KM2_CARS_NEEDED_TO_FINISH
    then
        jump @MISSION_KENJI2_PASSED
    end

    //Check for car 1 - Cheetah
    if
        $FLAG_CAR1_IN_GARAGE == 0
    then
        if and
            021C:   car_inside_garage $KENJI_LOCKUP_GARAGE
            $FLAG_GARAGE_NO_BLIP_CAR1_KM2 == 1
        then
            $FLAG_CAR1_DESTROYED = 1
            $COUNTER_NUMBER_OF_CARS_IN_GARAGE_KM2 += 1
            018C: play_sound 1 at 45.3 -506.8 32.1
            00BC: print_now 'KM2_2' 5000 ms 1   // ~g~Car delivered.
            if
                8119:   NOT   car $CAR_TO_STEAL1_KM2 wrecked
            then
                00A6: destroy_car $CAR_TO_STEAL1_KM2
            end
            $FLAG_CAR1_IN_GARAGE = 1
        end

        if
            $FLAG_CAR1_DESTROYED == 0
        then
            if
                0119:   car $CAR_TO_STEAL1_KM2 wrecked
            then
                00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
                0004: $FLAG_CAR1_DESTROYED = 1
                jump @MISSION_KENJI2_FAILED   // Mission Failed
            else
                if and
                    01F4:   car $CAR_TO_STEAL1_KM2 flipped
                    01C1:   car $CAR_TO_STEAL1_KM2 stopped
                then
                    00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
                    jump @MISSION_KENJI2_FAILED   // Mission Failed
                end
            end

            if
                01AC:   car $CAR_TO_STEAL1_KM2 stopped 0 in_cube 42.3 -511.4 31.1132 48.7 -502.0 36.0
            then
                if
                    83C9:   NOT   car $CAR_TO_STEAL1_KM2 damaged
                then
                    $FLAG_GARAGE_NO_BLIP_CAR1_KM2 = 1
                end
                if
                    0422:   garage_contain_car $KENJI_LOCKUP_GARAGE $CAR_TO_STEAL1_KM2  // requires updated dinput8.dll
                then
                    if
                        $FLAG_PLAYER_HAD_GARAGE_CAR1_MESSAGE == 0
                    then
                        00BC: print_now 'GARAGE1' 5000 ms 1   // ~g~Get out of the vehicle and walk outside. // Yes
                        $FLAG_PLAYER_HAD_GARAGE_CAR1_MESSAGE = 1
                    end
                else
                    $FLAG_PLAYER_HAD_GARAGE_CAR1_MESSAGE = 0
                end
            else
                $FLAG_GARAGE_NO_BLIP_CAR1_KM2 = 0
            end

            if
                00DC:   player $PLAYER driving $CAR_TO_STEAL1_KM2
            then
                if
                    $FLAG_BLIP_CAR1_ON == 1
                then
                    0164: remove_blip $RADAR_BLIP_CAR1_KM2
                    $FLAG_BLIP_CAR1_ON = 0
                end

                if
                    03C9:   car $CAR_TO_STEAL1_KM2 damaged
                then
                    if
                        $FLAG_PLAYER_DAMAGE_MESSAGE_CAR1_KM2 == 0
                    then
                        00BC: print_now 'KM2_1' 7000 ms 1   // ~g~Repair the car it's gotta be mint.
                        021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car -1
                        $FLAG_PLAYER_DAMAGE_MESSAGE_CAR1_KM2 = 1
                    end
                    if
                        $FLAG_SPRAY_BLIP_ON_CAR1_KM2 == 0
                    then
                        02A8: $KENJI2_PAYNSPRAY_MARKER = create_marker 21 at 44.0 -493.8 31.2
                        $FLAG_SPRAY_BLIP_ON_CAR1_KM2 = 1
                    end
                else
                    021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car $CAR_TO_STEAL1_KM2
                    $FLAG_PLAYER_DAMAGE_MESSAGE_CAR1_KM2 = 0
                    if
                        $FLAG_SPRAY_BLIP_ON_CAR1_KM2 == 1
                    then
                        0164: remove_blip $KENJI2_PAYNSPRAY_MARKER
                        $FLAG_SPRAY_BLIP_ON_CAR1_KM2 = 0
                    end
                end
            else
                $FLAG_PLAYER_DAMAGE_MESSAGE_CAR1_KM2 = 0
                if
                    $FLAG_SPRAY_BLIP_ON_CAR1_KM2 == 1
                then
                    0164: remove_blip $KENJI2_PAYNSPRAY_MARKER
                    $FLAG_SPRAY_BLIP_ON_CAR1_KM2 = 0
                end
                if
                    $FLAG_BLIP_CAR1_ON == 0
                then
                    if
                        $FLAG_GARAGE_NO_BLIP_CAR1_KM2 == 0
                    then
                        0186: $RADAR_BLIP_CAR1_KM2 = create_marker_above_car $CAR_TO_STEAL1_KM2
                        021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car -1
                        $FLAG_BLIP_CAR1_ON = 1
                    end
                end
            end
        end
    end

    //Check for car 2 - Banshee - not in final game
    if
        02BD:   debug_mode == DEBUG_MASTEREXTRAS2
    then

        if
            $FLAG_CAR2_IN_GARAGE == 0
        then
            if and
                021C:   car_inside_garage $KENJI_LOCKUP_GARAGE
                $FLAG_GARAGE_NO_BLIP_CAR2_KM2 == 1
            then
                $FLAG_CAR2_DESTROYED = 1
                $COUNTER_NUMBER_OF_CARS_IN_GARAGE_KM2 += 1
                018C: play_sound 1 at 45.3 -506.8 32.1
                00BC: print_now 'KM2_2' 5000 ms 1   // ~g~Car delivered.
                if
                    8119:   NOT   car $CAR_TO_STEAL2_KM2 wrecked
                then
                    00A6: destroy_car $CAR_TO_STEAL2_KM2
                end
                $FLAG_CAR2_IN_GARAGE = 1
            end

            if
                $FLAG_CAR2_DESTROYED == 0
            then
                if
                    0119:   car $CAR_TO_STEAL2_KM2 wrecked
                then
                    00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
                    0004: $FLAG_CAR2_DESTROYED = 1
                    jump @MISSION_KENJI2_FAILED   // Mission Failed
                else
                    if and
                        01F4:   car $CAR_TO_STEAL2_KM2 flipped
                        01C1:   car $CAR_TO_STEAL2_KM2 stopped
                    then
                        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
                        jump @MISSION_KENJI2_FAILED   // Mission Failed
                    end
                end

                if
                    01AC:   car $CAR_TO_STEAL2_KM2 stopped 0 in_cube 42.3 -511.4 31.1132 48.7 -502.0 36.0
                then
                    if
                        83C9:   NOT   car $CAR_TO_STEAL2_KM2 damaged
                    then
                        $FLAG_GARAGE_NO_BLIP_CAR2_KM2 = 1
                    end
                    if
                        0422:   garage_contain_car $KENJI_LOCKUP_GARAGE $CAR_TO_STEAL2_KM2  // requires updated dinput8.dll
                    then
                        if
                            $FLAG_PLAYER_HAD_GARAGE_CAR2_MESSAGE == 0
                        then
                            00BC: print_now 'GARAGE1' 5000 ms 1   // ~g~Get out of the vehicle and walk outside. // Yes
                            $FLAG_PLAYER_HAD_GARAGE_CAR2_MESSAGE = 1
                        end
                    else
                        $FLAG_PLAYER_HAD_GARAGE_CAR2_MESSAGE = 0
                    end
                else
                    $FLAG_GARAGE_NO_BLIP_CAR2_KM2 = 0
                end

                if
                    00DC:   player $PLAYER driving $CAR_TO_STEAL2_KM2
                then
                    if
                        $FLAG_BLIP_CAR2_ON == 1
                    then
                        0164: remove_blip $RADAR_BLIP_CAR2_KM2
                        $FLAG_BLIP_CAR2_ON = 0
                    end

                    if
                        03C9:   car $CAR_TO_STEAL2_KM2 damaged
                    then
                        if
                            $FLAG_PLAYER_DAMAGE_MESSAGE_CAR2_KM2 == 0
                        then
                            00BC: print_now 'KM2_1' 7000 ms 1   // ~g~Repair the car it's gotta be mint.
                            021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car -1
                            $FLAG_PLAYER_DAMAGE_MESSAGE_CAR2_KM2 = 1
                        end
                        if
                            $FLAG_SPRAY_BLIP_ON_CAR2_KM2 == 0
                        then
                            02A8: $KENJI2_PAYNSPRAY_MARKER = create_marker 21 at 44.0 -493.8 31.2
                            $FLAG_SPRAY_BLIP_ON_CAR2_KM2 = 1
                        end
                    else
                        021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car $CAR_TO_STEAL2_KM2
                        $FLAG_PLAYER_DAMAGE_MESSAGE_CAR2_KM2 = 0
                        if
                            $FLAG_SPRAY_BLIP_ON_CAR2_KM2 == 1
                        then
                            0164: remove_blip $KENJI2_PAYNSPRAY_MARKER
                            $FLAG_SPRAY_BLIP_ON_CAR2_KM2 = 0
                        end
                    end
                else
                    $FLAG_PLAYER_DAMAGE_MESSAGE_CAR2_KM2 = 0
                    if
                        $FLAG_SPRAY_BLIP_ON_CAR2_KM2 == 1
                    then
                        0164: remove_blip $KENJI2_PAYNSPRAY_MARKER
                        $FLAG_SPRAY_BLIP_ON_CAR2_KM2 = 0
                    end
                    if
                        $FLAG_BLIP_CAR2_ON == 0
                    then
                        if
                            $FLAG_GARAGE_NO_BLIP_CAR2_KM2 == 0
                        then
                            0186: $RADAR_BLIP_CAR2_KM2 = create_marker_above_car $CAR_TO_STEAL2_KM2
                            021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car -1
                            $FLAG_BLIP_CAR2_ON = 1
                        end
                    end
                end
            end
        end
    end

    //Check for car 3 - Stinger
    if
        $FLAG_CAR3_IN_GARAGE == 0
    then
        if and
            021C:   car_inside_garage $KENJI_LOCKUP_GARAGE
            $FLAG_GARAGE_NO_BLIP_CAR3_KM2 == 1
        then
            $FLAG_CAR3_DESTROYED = 1
            $COUNTER_NUMBER_OF_CARS_IN_GARAGE_KM2 += 1
            018C: play_sound 1 at 45.3 -506.8 32.1
            00BC: print_now 'KM2_2' 5000 ms 1   // ~g~Car delivered.
            if
                8119:   NOT   car $CAR_TO_STEAL3_KM2 wrecked
            then
                00A6: destroy_car $CAR_TO_STEAL3_KM2
            end
            $FLAG_CAR3_IN_GARAGE = 1
        end

        if
            $FLAG_CAR3_DESTROYED == 0
        then
            if
                0119:   car $CAR_TO_STEAL3_KM2 wrecked
            then
                00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
                0004: $FLAG_CAR3_DESTROYED = 1
                jump @MISSION_KENJI2_FAILED   // Mission Failed
            else
                if and
                    01F4:   car $CAR_TO_STEAL3_KM2 flipped
                    01C1:   car $CAR_TO_STEAL3_KM2 stopped
                then
                    00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
                    jump @MISSION_KENJI2_FAILED   // Mission Failed
                end
            end

            if
                01AC:   car $CAR_TO_STEAL3_KM2 stopped 0 in_cube 42.3 -511.4 31.1132 48.7 -502.0 36.0
            then
                if
                    83C9:   NOT   car $CAR_TO_STEAL3_KM2 damaged
                then
                    $FLAG_GARAGE_NO_BLIP_CAR3_KM2 = 1
                end
                if
                    0422:   garage_contain_car $KENJI_LOCKUP_GARAGE $CAR_TO_STEAL3_KM2  // requires updated dinput8.dll
                then
                    if
                        $FLAG_PLAYER_HAD_GARAGE_CAR3_MESSAGE == 0
                    then
                        00BC: print_now 'GARAGE1' 5000 ms 1   // ~g~Get out of the vehicle and walk outside. // Yes
                        $FLAG_PLAYER_HAD_GARAGE_CAR3_MESSAGE = 1
                    end
                else
                    $FLAG_PLAYER_HAD_GARAGE_CAR3_MESSAGE = 0
                end
            else
                $FLAG_GARAGE_NO_BLIP_CAR3_KM2 = 0
            end

            if
                00DC:   player $PLAYER driving $CAR_TO_STEAL3_KM2
            then
                if
                    $FLAG_BLIP_CAR3_ON == 1
                then
                    0164: remove_blip $RADAR_BLIP_CAR3_KM2
                    $FLAG_BLIP_CAR3_ON = 0
                end

                if
                    03C9:   car $CAR_TO_STEAL3_KM2 damaged
                then
                    if
                        $FLAG_PLAYER_DAMAGE_MESSAGE_CAR3_KM2 == 0
                    then
                        00BC: print_now 'KM2_1' 7000 ms 1   // ~g~Repair the car it's gotta be mint.
                        021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car -1
                        $FLAG_PLAYER_DAMAGE_MESSAGE_CAR3_KM2 = 1
                    end
                    if
                        $FLAG_SPRAY_BLIP_ON_CAR3_KM2 == 0
                    then
                        02A8: $KENJI2_PAYNSPRAY_MARKER = create_marker 21 at 44.0 -493.8 31.2
                        $FLAG_SPRAY_BLIP_ON_CAR3_KM2 = 1
                    end
                else
                    021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car $CAR_TO_STEAL3_KM2
                    $FLAG_PLAYER_DAMAGE_MESSAGE_CAR3_KM2 = 0
                    if
                        $FLAG_SPRAY_BLIP_ON_CAR3_KM2 == 1
                    then
                        0164: remove_blip $KENJI2_PAYNSPRAY_MARKER
                        $FLAG_SPRAY_BLIP_ON_CAR3_KM2 = 0
                    end
                end
            else
                $FLAG_PLAYER_DAMAGE_MESSAGE_CAR3_KM2 = 0
                if
                    $FLAG_SPRAY_BLIP_ON_CAR3_KM2 == 1
                then
                    0164: remove_blip $KENJI2_PAYNSPRAY_MARKER
                    $FLAG_SPRAY_BLIP_ON_CAR3_KM2 = 0
                end
                if
                    $FLAG_BLIP_CAR3_ON == 0
                then
                    if
                        $FLAG_GARAGE_NO_BLIP_CAR3_KM2 == 0
                    then
                        0186: $RADAR_BLIP_CAR3_KM2 = create_marker_above_car $CAR_TO_STEAL3_KM2
                        021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car -1
                        $FLAG_BLIP_CAR3_ON = 1
                    end
                end
            end
        end
    end

    //Check for car 4 - Infernus
    if
        $FLAG_CAR4_IN_GARAGE == 0
    then
        if and
            021C:   car_inside_garage $KENJI_LOCKUP_GARAGE
            $FLAG_GARAGE_NO_BLIP_CAR4_KM2 == 1
        then
            $FLAG_CAR4_DESTROYED = 1
            $COUNTER_NUMBER_OF_CARS_IN_GARAGE_KM2 += 1
            018C: play_sound 1 at 45.3 -506.8 32.1
            00BC: print_now 'KM2_2' 5000 ms 1   // ~g~Car delivered.
            if
                8119:   NOT   car $CAR_TO_STEAL4_KM2 wrecked
            then
                00A6: destroy_car $CAR_TO_STEAL4_KM2
            end
            $FLAG_CAR4_IN_GARAGE = 1
        end

        if
            $FLAG_CAR4_DESTROYED == 0
        then
            if
                0119:   car $CAR_TO_STEAL4_KM2 wrecked
            then
                00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
                0004: $FLAG_CAR4_DESTROYED = 1
                jump @MISSION_KENJI2_FAILED   // Mission Failed
            else
                if and
                    01F4:   car $CAR_TO_STEAL4_KM2 flipped
                    01C1:   car $CAR_TO_STEAL4_KM2 stopped
                then
                    00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
                    jump @MISSION_KENJI2_FAILED   // Mission Failed
                end
            end

            if
                01AC:   car $CAR_TO_STEAL4_KM2 stopped 0 in_cube 42.3 -511.4 31.1132 48.7 -502.0 36.0
            then
                if
                    83C9:   NOT   car $CAR_TO_STEAL4_KM2 damaged
                then
                    $FLAG_GARAGE_NO_BLIP_CAR4_KM2 = 1
                end
                if
                    0422:   garage_contain_car $KENJI_LOCKUP_GARAGE $CAR_TO_STEAL4_KM2  // requires updated dinput8.dll
                then
                    if
                        $FLAG_PLAYER_HAD_GARAGE_CAR4_MESSAGE == 0
                    then
                        00BC: print_now 'GARAGE1' 5000 ms 1   // ~g~Get out of the vehicle and walk outside. // Yes
                        $FLAG_PLAYER_HAD_GARAGE_CAR4_MESSAGE = 1
                    end
                else
                    $FLAG_PLAYER_HAD_GARAGE_CAR4_MESSAGE = 0
                end
            else
                $FLAG_GARAGE_NO_BLIP_CAR4_KM2 = 0
            end

            if
                00DC:   player $PLAYER driving $CAR_TO_STEAL4_KM2
            then
                if
                    $FLAG_BLIP_CAR4_ON == 1
                then
                    0164: remove_blip $RADAR_BLIP_CAR4_KM2
                    $FLAG_BLIP_CAR4_ON = 0
                end

                if
                    03C9:   car $CAR_TO_STEAL4_KM2 damaged
                then
                    if
                        $FLAG_PLAYER_DAMAGE_MESSAGE_CAR4_KM2 == 0
                    then
                        00BC: print_now 'KM2_1' 7000 ms 1   // ~g~Repair the car it's gotta be mint.
                        021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car -1
                        $FLAG_PLAYER_DAMAGE_MESSAGE_CAR4_KM2 = 1
                    end
                    if
                        $FLAG_SPRAY_BLIP_ON_CAR4_KM2 == 0
                    then
                        02A8: $KENJI2_PAYNSPRAY_MARKER = create_marker 21 at 44.0 -493.8 31.2
                        $FLAG_SPRAY_BLIP_ON_CAR4_KM2 = 1
                    end
                else
                    021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car $CAR_TO_STEAL4_KM2
                    $FLAG_PLAYER_DAMAGE_MESSAGE_CAR4_KM2 = 0
                    if
                        $FLAG_SPRAY_BLIP_ON_CAR4_KM2 == 1
                    then
                        0164: remove_blip $KENJI2_PAYNSPRAY_MARKER
                        $FLAG_SPRAY_BLIP_ON_CAR4_KM2 = 0
                    end
                end
            else
                $FLAG_PLAYER_DAMAGE_MESSAGE_CAR4_KM2 = 0
                if
                    $FLAG_SPRAY_BLIP_ON_CAR4_KM2 == 1
                then
                    0164: remove_blip $KENJI2_PAYNSPRAY_MARKER
                    $FLAG_SPRAY_BLIP_ON_CAR4_KM2 = 0
                end
                if
                    $FLAG_BLIP_CAR4_ON == 0
                then
                    if
                        $FLAG_GARAGE_NO_BLIP_CAR4_KM2 == 0
                    then
                        0186: $RADAR_BLIP_CAR4_KM2 = create_marker_above_car $CAR_TO_STEAL4_KM2
                        021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car -1
                        $FLAG_BLIP_CAR4_ON = 1
                    end
                end
            end
        end
    end

     //Check for car 5 - Landstalker - not in final game, changed to PCJ-600 for GTA:LC
    if
        02BD:   debug_mode == DEBUG_MASTEREXTRAS2
    then

        if
            $FLAG_CAR5_IN_GARAGE == 0
        then
            if and
                021C:   car_inside_garage $KENJI_LOCKUP_GARAGE
                $FLAG_GARAGE_NO_BLIP_CAR5_KM2 == 1
            then
                $FLAG_CAR5_DESTROYED = 1
                $COUNTER_NUMBER_OF_CARS_IN_GARAGE_KM2 += 1
                018C: play_sound 1 at 45.3 -506.8 32.1
                00BC: print_now 'KM2_2' 5000 ms 1   // ~g~Car delivered.
                if
                    8119:   NOT   car $CAR_TO_STEAL5_KM2 wrecked
                then
                    00A6: destroy_car $CAR_TO_STEAL5_KM2
                end
                $FLAG_CAR5_IN_GARAGE = 1
            end

            if
                $FLAG_CAR5_DESTROYED == 0
            then
                if
                    0119:   car $CAR_TO_STEAL5_KM2 wrecked
                then
                    00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
                    0004: $FLAG_CAR5_DESTROYED = 1
                    jump @MISSION_KENJI2_FAILED   // Mission Failed
                else
                    if and
                        01F4:   car $CAR_TO_STEAL5_KM2 flipped
                        01C1:   car $CAR_TO_STEAL5_KM2 stopped
                    then
                        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
                        jump @MISSION_KENJI2_FAILED   // Mission Failed
                    end
                end

                if
                    01AC:   car $CAR_TO_STEAL5_KM2 stopped 0 in_cube 42.3 -511.4 31.1132 48.7 -502.0 36.0
                then
                    if
                        83C9:   NOT   car $CAR_TO_STEAL5_KM2 damaged
                    then
                        $FLAG_GARAGE_NO_BLIP_CAR5_KM2 = 1
                    end
                    if
                        0422:   garage_contain_car $KENJI_LOCKUP_GARAGE $CAR_TO_STEAL5_KM2  // requires updated dinput8.dll
                    then
                        if
                            $FLAG_PLAYER_HAD_GARAGE_CAR5_MESSAGE == 0
                        then
                            00BC: print_now 'GARAGE1' 5000 ms 1   // ~g~Get out of the vehicle and walk outside. // Yes
                            $FLAG_PLAYER_HAD_GARAGE_CAR5_MESSAGE = 1
                        end
                    else
                        $FLAG_PLAYER_HAD_GARAGE_CAR5_MESSAGE = 0
                    end
                else
                    $FLAG_GARAGE_NO_BLIP_CAR5_KM2 = 0
                end

                if
                    00DC:   player $PLAYER driving $CAR_TO_STEAL5_KM2
                then
                    if
                        $FLAG_BLIP_CAR5_ON == 1
                    then
                        0164: remove_blip $RADAR_BLIP_CAR5_KM2
                        $FLAG_BLIP_CAR5_ON = 0
                    end

                    if
                        03C9:   car $CAR_TO_STEAL5_KM2 damaged
                    then
                        if
                            $FLAG_PLAYER_DAMAGE_MESSAGE_CAR5_KM2 == 0
                        then
                            00BC: print_now 'KM2_1' 7000 ms 1   // ~g~Repair the car it's gotta be mint.
                            021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car -1
                            $FLAG_PLAYER_DAMAGE_MESSAGE_CAR5_KM2 = 1
                        end
                        if
                            $FLAG_SPRAY_BLIP_ON_CAR5_KM2 == 0
                        then
                            02A8: $KENJI2_PAYNSPRAY_MARKER = create_marker 21 at 44.0 -493.8 31.2
                            $FLAG_SPRAY_BLIP_ON_CAR5_KM2 = 1
                        end
                    else
                        021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car $CAR_TO_STEAL5_KM2
                        $FLAG_PLAYER_DAMAGE_MESSAGE_CAR5_KM2 = 0
                        if
                            $FLAG_SPRAY_BLIP_ON_CAR5_KM2 == 1
                        then
                            0164: remove_blip $KENJI2_PAYNSPRAY_MARKER
                            $FLAG_SPRAY_BLIP_ON_CAR5_KM2 = 0
                        end
                    end
                else
                    $FLAG_PLAYER_DAMAGE_MESSAGE_CAR5_KM2 = 0
                    if
                        $FLAG_SPRAY_BLIP_ON_CAR5_KM2 == 1
                    then
                        0164: remove_blip $KENJI2_PAYNSPRAY_MARKER
                        $FLAG_SPRAY_BLIP_ON_CAR5_KM2 = 0
                    end
                    if
                        $FLAG_BLIP_CAR5_ON == 0
                    then
                        if
                            $FLAG_GARAGE_NO_BLIP_CAR5_KM2 == 0
                        then
                            0186: $RADAR_BLIP_CAR5_KM2 = create_marker_above_car $CAR_TO_STEAL5_KM2
                            021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car -1
                            $FLAG_BLIP_CAR5_ON = 1
                        end
                    end
                end  //Player driving correct car
            end  // If car not destroyed
        end // Car 5 check
    end // Skip if extra cars is not on
end //while - if time runs out

00BC: print_now 'OUTTIME' 5000 ms 1   // ~r~Too slow man too slow!

:MISSION_KENJI2_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // MISSION FAILED!
return

:MISSION_KENJI2_PASSED
$GRAND_THEFT_AUTO_COMPLETED = 1
0318: set_latest_mission_passed 'KM2'   // 'GRAND THEFT AUTO'
030C: set_mission_points += 1
01E3: text_1number_styled 'M_PASS' $KM2_REWARD 5000 ms 1   // MISSION PASSED! $~1~
0394: play_music 1
0109: player $PLAYER money += $KM2_REWARD
0110: clear_player $PLAYER wanted_level
004F: create_thread @KENJI_MISSION3_LOOP
return

:MISSION_CLEANUP_KENJI2
$FLAG_PLAYER_ON_MISSION = 0
$ON_MISSION_FOR_KENJI = 0
021B: set_garage $KENJI_LOCKUP_GARAGE to_accept_car -1
014F: stop_timer $TIMER_KM2
0164: remove_blip $RADAR_BLIP_COORD1_KM2
0164: remove_blip $RADAR_BLIP_CAR1_KM2
0164: remove_blip $RADAR_BLIP_CAR2_KM2
0164: remove_blip $RADAR_BLIP_CAR3_KM2
0164: remove_blip $RADAR_BLIP_CAR4_KM2
0164: remove_blip $RADAR_BLIP_CAR5_KM2
0164: remove_blip $KENJI2_PAYNSPRAY_MARKER
0249: mark_model_as_no_longer_needed #CHEETAH
0249: mark_model_as_no_longer_needed #BANSHEE
0249: mark_model_as_no_longer_needed #STINGER
0249: mark_model_as_no_longer_needed #INFERNUS
0249: mark_model_as_no_longer_needed #PCJ600
//0249: mark_model_as_no_longer_needed #LANDSTAL
mission_cleanup
return
