//-------------Mission 68-------------
// Originally: Donald Love mission 5 'ESCORT SERVICE'

:M68_ESCORTSERVICE
03A4: name_thread 'LOVE5'
054C: use_GXT_table 'LOVE5'
058E: set_restart_mission_taxi_destination -284.8 -1547.9 31.65 0.0
gosub @MISSION_START_LOVE5
if
    wasted_or_busted
then
    gosub @MISSION_LOVE5_FAILED
end
gosub @MISSION_CLEANUP_LOVE5
end_thread

:MISSION_START_LOVE5
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $FLAG_PLAYER_ON_LOVE_MISSION = 1
0317: increment_mission_attempts
wait 0 ms
0004: $CAR1_ATTACKING_FLAG = 0
0004: $CAR2_ATTACKING_FLAG = 0
0004: $CAR3_ATTACKING_FLAG = 0
0004: $CAR4_ATTACKING_FLAG = 0
0004: $ESCORT_TRUCK_FLAG = 0
0004: $COLOMBIAN_1_FLAG = 0
0004: $COLOMBIAN_2_FLAG = 0
0004: $COLOMBIAN_3_FLAG = 0
0004: $COLOMBIAN_4_FLAG = 0
0004: $DUMMY_HEALTH = 2000
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'LOVE'
0247: request_model #TSHRORCKGRDN
0247: request_model #TSHRORCKGRDN_ALFAS
02F3: load_object #CUTOBJ01 'LOVEH'
03AF: set_streaming 0 (disabled)
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #TSHRORCKGRDN available
        8248:   NOT   model #TSHRORCKGRDN_ALFAS available
        8248:   NOT   model #CUTOBJ01 available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'D5_ES'
0244: set_cutscene_pos -249.8125 -1532.88 249.5
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_LOVE = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_LOVE 'LOVE'
//02F4: create_cutscene_actor $LOVE_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_LOVE
//02F5: set_head_anim $LOVE_CSHEAD 'LOVE'
0395: clear_area 1 at -252.5625 -1548.44 34.0 range 2.0
0055: set_player_coordinates $PLAYER at -252.5625 -1548.44 34.0
0171: set_player $PLAYER z_angle_to 90.0
016A: fade 1 (back)  1500 ms
02E7: start_cutscene
03AD: set_rubbish 0 (invisible)
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   1324 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'LOVE5_A' 5000 ms 1   // // You are proving to be a safe investment a rare thing in these days of false hood.
while 001A:   6061 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BB: text_lowpriority 'LOVE5_B' 5000 ms 1   // // My Oriental friend will need an escort while he takes my latest acquisition to be authenticated.
while 001A:   10660 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BB: text_lowpriority 'LOVE5_C' 5000 ms 1   // // I want you to follow him and make sure both he and my package get to Pike Creek unharmed.
while 001A:   17500 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
03AD: set_rubbish 1 (visible)
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
016A: fade 0  0 ms
0373: set_camera_directly_behind_player
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #TSHRORCKGRDN
0249: mark_model_as_no_longer_needed #TSHRORCKGRDN_ALFAS
0249: mark_model_as_no_longer_needed #CUTOBJ01
0247: request_model #SECURICA
0247: request_model #COLUMB
0247: request_model #GANG11
0247: request_model #M16
0247: request_model #AK47
023C: load_special_actor 2 'OJG'
023C: load_special_actor 3 'S_GUARD'
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #GANG11 available
        8248:   NOT   model #COLUMB available
        823D:   NOT   special_actor 2 loaded
        823D:   NOT   special_actor 3 loaded
        8248:   NOT   model #SECURICA available
        8248:   NOT   model #M16 available
        8248:   NOT   model #AK47 available
    jf break
    wait 0 ms
end
03AF: set_streaming 1 (enabled)
016A: fade 1 (back)  1500 ms
00A5: $ESCORT_TRUCK = create_car #SECURICA at -251.4375 -1592.25 31.0625
0229: set_car $ESCORT_TRUCK color_to 0 0
053F: set car $ESCORT_TRUCK tires vulnerable  0
if
    0119:   car $ESCORT_TRUCK wrecked
then
    00BC: print_now 'LOVE5_5' 5000 ms 1   // // ~r~You failed to protect the truck!
    jump @MISSION_LOVE5_FAILED
end
0129: $TRUCK_DRIVER = create_actor 21 #SPECIAL03 in_car $ESCORT_TRUCK driverseat
01C8: $OJG = create_actor 21 #SPECIAL02 in_car $ESCORT_TRUCK passenger_seat 0
039E: set_char_cant_be_dragged_out $TRUCK_DRIVER 1
0526: set_actor_stay_in_car $TRUCK_DRIVER 1
054A: set_actor $TRUCK_DRIVER vulnerable_to_car_headshots 0
054A: set_actor $OJG vulnerable_to_car_headshots 0
020A: set_car $ESCORT_TRUCK door_status_to 2
0175: set_car $ESCORT_TRUCK z_angle_to 180.0
00AE: set_car $ESCORT_TRUCK driving_style 2  // DRIVINGMODE_AVOIDCARS
00AD: set_car $ESCORT_TRUCK max_speed_to 18.0
00A9: set_car $ESCORT_TRUCK to_normal_driver
03AB: set_vehicle $ESCORT_TRUCK strong 1
02AC: set_car $ESCORT_TRUCK immunities 0 0 1 0 0
0186: $ESCORT_TRUCK_BLIP = create_marker_above_car $ESCORT_TRUCK
032B: $TANK_WEAPON = create_weapon_pickup #M16 3 ammo 600 at -257.375 -1589.0 33.5
while true
    if or
        81FE:   NOT   player $PLAYER near_car_in_car $ESCORT_TRUCK radius 15.0 15.0 0
        80C2:   NOT   sphere_onscreen -251.4375 -1592.25 31.0625 4.0
    jf break
    wait 0 ms
    if
        0119:   car $ESCORT_TRUCK wrecked
    then
        00BC: print_now 'LOVE5_5' 5000 ms 1   // // ~r~You failed to protect the truck!
        jump @MISSION_LOVE5_FAILED
    end
    if
        01FD:   player $PLAYER near_car_on_foot $ESCORT_TRUCK radius 15.0 15.0 0  // never used in VC
    then
        00BC: print_now 'LOVE5_2' 5000 ms 1   // // ~g~You'll need a car!
    end
    if and
        01FD:   player $PLAYER near_car_on_foot $ESCORT_TRUCK radius 1.0 1.0 0  // never used in VC
        029F:   player $PLAYER stopped
    then
        jump @CAR_GOTO_BIT
    end
end //while

:CAR_GOTO_BIT
00A7: car $ESCORT_TRUCK drive_to -161.562 76.25 20.9375
00BC: print_now 'LOVE5_1' 5000 ms 1   // // ~g~Lets go!
0227: $ESCORT_TRUCK_HEALTH = car $ESCORT_TRUCK health
if
    0018:   $DUMMY_HEALTH > 499
then
    if
        001A:   500 > $ESCORT_TRUCK_HEALTH
    then
        0008: $ESCORT_TRUCK_HEALTH += 500
        0224: set_car $ESCORT_TRUCK health_to $ESCORT_TRUCK_HEALTH
        000C: $DUMMY_HEALTH -= 500
    end
end
0227: $ESCORT_TRUCK_HEALTH = car $ESCORT_TRUCK health
0058: $ESCORT_TRUCK_HEALTH += $DUMMY_HEALTH
0014: $ESCORT_TRUCK_HEALTH /= 3
000C: $ESCORT_TRUCK_HEALTH -= 250
0010: $ESCORT_TRUCK_HEALTH *= 100
0014: $ESCORT_TRUCK_HEALTH /= 750
0084: $ESCORT_TRUCK_HEALTH2 = $ESCORT_TRUCK_HEALTH
0004: $ESCORT_TRUCK_HEALTH = 100
0060: $ESCORT_TRUCK_HEALTH -= $ESCORT_TRUCK_HEALTH2
03C4: set_status_text_to $ESCORT_TRUCK_HEALTH 1 (bar)  'DAM'   // // Damage
while 8038:   NOT   $ESCORT_TRUCK_FLAG == 11
    wait 0 ms
    if
        0119:   car $ESCORT_TRUCK wrecked
    then
        00BC: print_now 'LOVE5_5' 5000 ms 1   // // ~r~You failed to protect the truck!
        jump @MISSION_LOVE5_FAILED
    else
        if and
            01F4:   car $ESCORT_TRUCK flipped
            01C1:   car $ESCORT_TRUCK stopped
        then
            jump @MISSION_LOVE5_FAILED
        end
        {IF NOT LOCATE_PLAYER_ANY_MEANS_CAR_2D player escort_truck 220.0 220.0 0
            PRINT_NOW LOVE5_4 500 1 //"Get back to the truck and defend it!"
            GET_CAR_HEALTH escort_truck escort_truck_health
            escort_truck_health -= 3
            IF escort_truck_health < 1                    //commented out by R*
                escort_truck_health = 1
                EXPLODE_CAR escort_truck
            ELSE
                SET_CAR_HEALTH escort_truck escort_truck_health
            ENDIF
        ENDIF    }
    end
    0227: $ESCORT_TRUCK_HEALTH = car $ESCORT_TRUCK health
    if
        0018:   $DUMMY_HEALTH > 499
    then
        if
            001A:   500 > $ESCORT_TRUCK_HEALTH
        then
            0008: $ESCORT_TRUCK_HEALTH += 500
            0224: set_car $ESCORT_TRUCK health_to $ESCORT_TRUCK_HEALTH
            000C: $DUMMY_HEALTH -= 500
        end
    end
    0227: $ESCORT_TRUCK_HEALTH = car $ESCORT_TRUCK health
    0058: $ESCORT_TRUCK_HEALTH += $DUMMY_HEALTH
    0014: $ESCORT_TRUCK_HEALTH /= 3
    000C: $ESCORT_TRUCK_HEALTH -= 250
    0010: $ESCORT_TRUCK_HEALTH *= 100
    0014: $ESCORT_TRUCK_HEALTH /= 750
    0084: $ESCORT_TRUCK_HEALTH2 = $ESCORT_TRUCK_HEALTH
    0004: $ESCORT_TRUCK_HEALTH = 100
    0060: $ESCORT_TRUCK_HEALTH -= $ESCORT_TRUCK_HEALTH2
    if
        0018:   $ESCORT_TRUCK_HEALTH > 100
    then
        0004: $ESCORT_TRUCK_HEALTH = 100
    end
    if
        0038:   $ESCORT_TRUCK_FLAG == 0
    then
        if
            01AD:   car $ESCORT_TRUCK 0 near_point -161.562 76.25 10.0 10.0
        then
            00A7: car $ESCORT_TRUCK drive_to 224.5 88.75 -15.0625
            0004: $ESCORT_TRUCK_FLAG = 1
        end
    end
    if
        0038:   $ESCORT_TRUCK_FLAG == 1
    then
        if
            01AD:   car $ESCORT_TRUCK 0 near_point -33.0 -12.375 10.0 10.0
        then
            044E: toggle_car $ESCORT_TRUCK level 1
            if
                8118:   NOT   actor $OJG dead
            then
                03FC: actor $OJG bind_to_current_island 0
            end
            if
                8118:   NOT   actor $TRUCK_DRIVER dead
            then
                03FC: actor $TRUCK_DRIVER bind_to_current_island 0
            end
            00AE: set_car $ESCORT_TRUCK driving_style 1  // DRIVINGMODE_SLOWDOWNFORCARS
            01EB: set_car_density_to .5
        end
    end
    if
        0038:   $ESCORT_TRUCK_FLAG == 1
    then
        if
            01AD:   car $ESCORT_TRUCK 0 near_point 224.5 88.75 10.0 10.0  //first junction in tunnel
        then
            00A7: car $ESCORT_TRUCK drive_to -655.375 87.125 -15.0625
            0004: $ESCORT_TRUCK_FLAG = 2
        end
    end
    if
        0038:   $ESCORT_TRUCK_FLAG == 2
    then
        if
            01AD:   car $ESCORT_TRUCK 0 near_point -655.375 87.125 10.0 10.0 //before airport junction    in tunnel
        then
            00A7: car $ESCORT_TRUCK drive_to -908.812 -426.375 0.25
            0004: $ESCORT_TRUCK_FLAG = 3
        end
    end
    if
        0038:   $ESCORT_TRUCK_FLAG == 3
    then
        if
            01AD:   car $ESCORT_TRUCK 0 near_point -908.812 -426.375 10.0 10.0 //Before sububan collision loadup
        then
            if
                83C6:   NOT is_collision_in_memory 3
            then
                00BC: print_now 'LOVE5_3' 200 ms 1   // // ~g~Go ahead and scout the exit of the tunnel!
            else
                0004: $ESCORT_TRUCK_FLAG = 4
            end
        end
    end
    if
        0038:   $ESCORT_TRUCK_FLAG == 4
    then
        if
            03C6:   is_collision_in_memory 3
        then
            00A7: car $ESCORT_TRUCK drive_to -969.938 -491.188 21.125
            0004: $ESCORT_TRUCK_FLAG = 5
        end
    end
    if
        0038:   $ESCORT_TRUCK_FLAG == 5
    then
        if
            01AD:   car $ESCORT_TRUCK 0 near_point -969.938 -491.188 10.0 10.0 //at mouth of tunnel at airport
        then
            00A7: car $ESCORT_TRUCK drive_to -1199.438 -282.438 38.5
            044E: toggle_car $ESCORT_TRUCK level 0 (clear)
            03FB: car $ESCORT_TRUCK bind_to_current_island 1 (true)
            if
                8118:   NOT   actor $OJG dead
            then
                03FC: actor  $OJG bind_to_current_island 1 (true)
            end
            if
                8118:   NOT   actor $TRUCK_DRIVER dead
            then
                03FC: actor   $TRUCK_DRIVER bind_to_current_island 1 (true)
            end
            00AE: set_car $ESCORT_TRUCK driving_style 2  // DRIVINGMODE_AVOIDCARS
            01EB: set_car_density_to 1.0
            0004: $ESCORT_TRUCK_FLAG = 6
        end
    end
    if
        0038:   $ESCORT_TRUCK_FLAG == 6
    then
        if
            01AD:   car $ESCORT_TRUCK 0 near_point -1199.438 -282.438 10.0 10.0
        then
            00A7: car $ESCORT_TRUCK drive_to -1310.125 -74.5 42.9375
            0004: $ESCORT_TRUCK_FLAG = 7
        end
    end
    if
        0038:   $ESCORT_TRUCK_FLAG == 7
    then
        if
            01AD:   car $ESCORT_TRUCK 0 near_point -1310.125 -74.5 10.0 10.0
        then
            gosub @CALL_OFF_THE_ATTACKERS
            02C2: car $ESCORT_TRUCK drive_to_point -1379.0 -73.375 43.8125
            00AD: set_car $ESCORT_TRUCK max_speed_to 12.0
            0004: $ESCORT_TRUCK_FLAG = 8
        end
    end
    if
        0038:   $ESCORT_TRUCK_FLAG == 8
    then
        if
            00B0:   car $ESCORT_TRUCK 0 in_rectangle -1357.06 -78.25 -1372.19 -69.125
        then
            0360: open_garage $DONALD_LOVES_STASH_GARAGE
            00AD: set_car $ESCORT_TRUCK max_speed_to 5.0
            0004: $ESCORT_TRUCK_FLAG = 9
        end
    end
    if
        0038:   $ESCORT_TRUCK_FLAG == 9
    then
        if
            01AB:   car $ESCORT_TRUCK stopped 0 in_rectangle -1384.12 -77.4375 -1372.19 -69.125  // never used in VC
        then
            if
                8056:   NOT   player $PLAYER 0 in_rectangle -1384.12 -77.4375 -1372.19 -69.125
            then
                0361: close_garage $DONALD_LOVES_STASH_GARAGE
                0004: $ESCORT_TRUCK_FLAG = 10
            end
        end
    end
    if
        0038:   $ESCORT_TRUCK_FLAG == 10
    then
        if
            0056:   player $PLAYER 0 in_rectangle -1384.12 -77.4375 -1372.19 -69.125
        then
            0360: open_garage $DONALD_LOVES_STASH_GARAGE
            0004: $ESCORT_TRUCK_FLAG = 9
        end
        if
            03B1:   garage $DONALD_LOVES_STASH_GARAGE door_closed
        then
            00A6: destroy_car $ESCORT_TRUCK
            jump @MISSION_LOVE5_PASSED
            0004: $ESCORT_TRUCK_FLAG = 11
        end
    end
    if
        001A:   9 > $ESCORT_TRUCK_FLAG
    then
        if
            0038:   $COLOMBIAN_1_FLAG == 0
        then
            if or
                00E3:   player $PLAYER 0 near_point -348.0 -464.0 radius 220.0 220.0
                01AD:   car $ESCORT_TRUCK 0 near_point -348.0 -464.0 220.0 220.0
            then
                009A: $COLOMBIAN_1 = create_actor 12 #GANG11 at -348.0 -464.0 23.0
                0173: set_actor $COLOMBIAN_1 z_angle_to 270.0
                01B2: give_actor $COLOMBIAN_1 weapon 27 ammo 9999  // ak47
                02A9: set_actor $COLOMBIAN_1 immune_to_nonplayer 1
                009F: set_actor $COLOMBIAN_1 objective_to-1
                0243: set_actor $COLOMBIAN_1 ped_stats_to 16
                011A: set_actor $COLOMBIAN_1 flags 1
                0350: set_char_stay_in_same_place $COLOMBIAN_1  1
                0004: $COLOMBIAN_1_FLAG = 1
            end
        end
        if
            0038:   $COLOMBIAN_1_FLAG == 1
        then
            if or
                80E3:   NOT   player $PLAYER 0 near_point -348.0 -464.0 radius 220.0 220.0
                81AD:   NOT   car $ESCORT_TRUCK 0 near_point -348.0 -464.0 220.0 220.0
            then
                009B: destroy_actor_instantly $COLOMBIAN_1
                0004: $COLOMBIAN_1_FLAG = 0
            end
        end
        if
            0038:   $COLOMBIAN_1_FLAG == 1
        then
            if
                0118:   actor $COLOMBIAN_1 dead
            then
                0004: $COLOMBIAN_1_FLAG = 2
            else
                if
                    0202:   actor $COLOMBIAN_1 near_car $ESCORT_TRUCK radius 40.0 40.0 unknown 0
                then
                    01D9: actor $COLOMBIAN_1 destroy_car $ESCORT_TRUCK
                end
            end
        end
        if
            0038:   $COLOMBIAN_2_FLAG == 0
        then
            if or
                00E3:   player $PLAYER 0 near_point -331.3125 -467.688 radius 220.0 220.0
                01AD:   car $ESCORT_TRUCK 0 near_point -331.3125 -467.688 220.0 220.0
            then
                009A: $COLOMBIAN_2 = create_actor 12 #GANG11 at -331.3125 -467.688 17.0
                0173: set_actor $COLOMBIAN_2 z_angle_to 85.0
                01B2: give_actor $COLOMBIAN_2 weapon 27 ammo 9999  // ak47
                02A9: set_actor $COLOMBIAN_2 immune_to_nonplayer 1
                009F: set_actor $COLOMBIAN_2 objective_to-1
                0243: set_actor $COLOMBIAN_2 ped_stats_to 16
                011A: set_actor $COLOMBIAN_2 flags 1
                0350: set_char_stay_in_same_place $COLOMBIAN_2  1
                0004: $COLOMBIAN_2_FLAG = 1
            end
        end
        if
            0038:   $COLOMBIAN_2_FLAG == 1
        then
            if or
                80E3:   NOT   player $PLAYER 0 near_point -331.3125 -467.688 radius 220.0 220.0
                81AD:   NOT   car $ESCORT_TRUCK 0 near_point -331.3125 -467.688 220.0 220.0
            then
                009B: destroy_actor_instantly $COLOMBIAN_2
                0004: $COLOMBIAN_2_FLAG = 0
            end
        end
        if
            0038:   $COLOMBIAN_2_FLAG == 1
        then
            if
                0118:   actor $COLOMBIAN_2 dead
            then
                0004: $COLOMBIAN_2_FLAG = 2
            else
                if
                    0202:   actor $COLOMBIAN_2 near_car $ESCORT_TRUCK radius 40.0 40.0 unknown 0
                then
                    01D9: actor $COLOMBIAN_2 destroy_car $ESCORT_TRUCK
                end
            end
        end
        if
            0038:   $COLOMBIAN_3_FLAG == 0
        then
            if or
                00E3:   player $PLAYER 0 near_point -210.625 -111.188 radius 220.0 220.0
                01AD:   car $ESCORT_TRUCK 0 near_point -210.625 -111.188 220.0 220.0
            then
                009A: $COLOMBIAN_3 = create_actor 12 #GANG11 at -210.625 -111.188 22.0
                0173: set_actor $COLOMBIAN_3 z_angle_to 85.0
                01B2: give_actor $COLOMBIAN_3 weapon 27 ammo 9999  // ak47
                02A9: set_actor $COLOMBIAN_3 immune_to_nonplayer 1
                009F: set_actor $COLOMBIAN_3 objective_to-1
                0243: set_actor $COLOMBIAN_3 ped_stats_to 16
                011A: set_actor $COLOMBIAN_3 flags 1
                0350: set_char_stay_in_same_place $COLOMBIAN_3  1
                0004: $COLOMBIAN_3_FLAG = 1
            end
        end
        if
            0038:   $COLOMBIAN_3_FLAG == 1
        then
            if or
                80E3:   NOT   player $PLAYER 0 near_point -210.625 -111.188 radius 220.0 220.0
                81AD:   NOT   car $ESCORT_TRUCK 0 near_point -210.625 -111.188 220.0 220.0
            then
                009B: destroy_actor_instantly $COLOMBIAN_3
                0004: $COLOMBIAN_3_FLAG = 0
            end
        end
        if
            0038:   $COLOMBIAN_3_FLAG == 1
        then
            if
                0118:   actor $COLOMBIAN_3 dead
            then
                0004: $COLOMBIAN_3_FLAG = 2
            else
                if
                    0202:   actor $COLOMBIAN_3 near_car $ESCORT_TRUCK radius 40.0 40.0 unknown 0
                then
                    01D9: actor $COLOMBIAN_3 destroy_car $ESCORT_TRUCK
                end
            end
        end
        if
            0038:   $COLOMBIAN_4_FLAG == 0
        then
            if or
                00E3:   player $PLAYER 0 near_point -326.375 -262.688 radius 220.0 220.0
                01AD:   car $ESCORT_TRUCK 0 near_point -336.375 -262.688 220.0 220.0
            then
                009A: $COLOMBIAN_4 = create_actor 12 #GANG11 at -326.375 -262.688 22.0
                0173: set_actor $COLOMBIAN_4 z_angle_to 163.0
                01B2: give_actor $COLOMBIAN_4 weapon 27 ammo 9999  // ak47
                02A9: set_actor $COLOMBIAN_4 immune_to_nonplayer 1
                009F: set_actor $COLOMBIAN_4 objective_to-1
                0243: set_actor $COLOMBIAN_4 ped_stats_to 16
                011A: set_actor $COLOMBIAN_4 flags 1
                0350: set_char_stay_in_same_place $COLOMBIAN_4  1
                0004: $COLOMBIAN_4_FLAG = 1
            end
        end
        if
            0038:   $COLOMBIAN_4_FLAG == 1
        then
            if or
                80E3:   NOT   player $PLAYER 0 near_point -326.375 -262.688 radius 220.0 220.0
                81AD:   NOT   car $ESCORT_TRUCK 0 near_point -326.375 -262.688 220.0 220.0
            then
                009B: destroy_actor_instantly $COLOMBIAN_4
                0004: $COLOMBIAN_4_FLAG = 0
            end
        end
        if
            0038:   $COLOMBIAN_4_FLAG == 1
        then
            if
                0118:   actor $COLOMBIAN_4 dead
            then
                0004: $COLOMBIAN_4_FLAG = 2
            else
                if
                    0202:   actor $COLOMBIAN_4 near_car $ESCORT_TRUCK radius 40.0 40.0 unknown 0
                then
                    01D9: actor $COLOMBIAN_4 destroy_car $ESCORT_TRUCK
                end
            end
        end
        if
            0038:   $COLOMBIAN_5_FLAG == 0
        then
            if or
                00E3:   player $PLAYER 0 near_point -47.438 17.5625 radius 220.0 220.0
                01AD:   car $ESCORT_TRUCK 0 near_point -47.438 17.5625 220.0 220.0
            then
                009A: $COLOMBIAN_5 = create_actor 12 #GANG11 at -47.438 17.5625 25.0625
                0173: set_actor $COLOMBIAN_5 z_angle_to 0.0
                01B2: give_actor $COLOMBIAN_5 weapon 27 ammo 9999  // ak47
                02A9: set_actor $COLOMBIAN_5 immune_to_nonplayer 1
                009F: set_actor $COLOMBIAN_5 objective_to-1
                0243: set_actor $COLOMBIAN_5 ped_stats_to 16
                011A: set_actor $COLOMBIAN_5 flags 1
                0350: set_char_stay_in_same_place $COLOMBIAN_5  1
                0004: $COLOMBIAN_5_FLAG = 1
            end
        end
        if
            0038:   $COLOMBIAN_5_FLAG == 1
        then
            if or
                80E3:   NOT   player $PLAYER 0 near_point -47.438 17.5625 radius 220.0 220.0
                81AD:   NOT   car $ESCORT_TRUCK 0 near_point -47.438 17.5625 220.0 220.0
            then
                009B: destroy_actor_instantly $COLOMBIAN_5
                0004: $COLOMBIAN_5_FLAG = 0
            end
        end
        if
            0038:   $COLOMBIAN_5_FLAG == 1
        then
            if
                0118:   actor $COLOMBIAN_5 dead
            then
                0004: $COLOMBIAN_5_FLAG = 2
            else
                if
                    0202:   actor $COLOMBIAN_5 near_car $ESCORT_TRUCK radius 40.0 40.0 unknown 0
                then
                    01D9: actor $COLOMBIAN_5 destroy_car $ESCORT_TRUCK
                end
            end
        end
        if
            0038:   $COLOMBIAN_6_FLAG == 0
        then
            if or
                00E3:   player $PLAYER 0 near_point 202.75 119.5 radius 220.0 220.0
                01AD:   car $ESCORT_TRUCK 0 near_point 202.75 119.5 220.0 220.0
            then
                009A: $COLOMBIAN_6 = create_actor 12 #GANG11 at 202.75 119.5 -14.3125
                0173: set_actor $COLOMBIAN_6 z_angle_to 238.062
                01B2: give_actor $COLOMBIAN_6 weapon 27 ammo 9999  // ak47
                02A9: set_actor $COLOMBIAN_6 immune_to_nonplayer 1
                009F: set_actor $COLOMBIAN_6 objective_to-1
                0243: set_actor $COLOMBIAN_6 ped_stats_to 16
                011A: set_actor $COLOMBIAN_6 flags 1
                0350: set_char_stay_in_same_place $COLOMBIAN_6  1
                0004: $COLOMBIAN_6_FLAG = 1
            end
        end
        if
            0038:   $COLOMBIAN_6_FLAG == 1
        then
            if or
                80E3:   NOT   player $PLAYER 0 near_point 202.75 119.5 radius 220.0 220.0
                81AD:   NOT   car $ESCORT_TRUCK 0 near_point 202.75 119.5 220.0 220.0
            then
                009B: destroy_actor_instantly $COLOMBIAN_6
                0004: $COLOMBIAN_6_FLAG = 0
            end
        end
        if
            0038:   $COLOMBIAN_6_FLAG == 1
        then
            if
                0118:   actor $COLOMBIAN_6 dead
            then
                0004: $COLOMBIAN_6_FLAG = 2
            else
                if
                    0202:   actor $COLOMBIAN_6 near_car $ESCORT_TRUCK radius 40.0 40.0 unknown 0
                then
                    01D9: actor $COLOMBIAN_6 destroy_car $ESCORT_TRUCK
                end
            end
        end
        if
            0018:   $ESCORT_TRUCK_FLAG > 4
        then
            if
                0038:   $COLOMBIAN_7_FLAG == 0
            then
                if or
                    00E3:   player $PLAYER 0 near_point -967.938 -499.562 radius 220.0 220.0
                    01AD:   car $ESCORT_TRUCK 0 near_point -967.938 -499.562 220.0 220.0
                then
                    009A: $COLOMBIAN_7 = create_actor 12 #GANG11 at -967.938 -499.562 28.3125
                    0173: set_actor $COLOMBIAN_7 z_angle_to 15.1875
                    01B2: give_actor $COLOMBIAN_7 weapon 27 ammo 9999  // ak47
                    02A9: set_actor $COLOMBIAN_7 immune_to_nonplayer 1
                    009F: set_actor $COLOMBIAN_7 objective_to-1
                    0243: set_actor $COLOMBIAN_7 ped_stats_to 16
                    011A: set_actor $COLOMBIAN_7 flags 1
                    0350: set_char_stay_in_same_place $COLOMBIAN_7  1
                    0004: $COLOMBIAN_7_FLAG = 1
                end
            end
        end
        if
            0038:   $COLOMBIAN_7_FLAG == 1
        then
            if or
                80E3:   NOT   player $PLAYER 0 near_point -967.938 -499.562 radius 220.0 220.0
                81AD:   NOT   car $ESCORT_TRUCK 0 near_point -967.938 -499.562 220.0 220.0
            then
                009B: destroy_actor_instantly $COLOMBIAN_7
                0004: $COLOMBIAN_7_FLAG = 0
            end
        end
        if
            0038:   $COLOMBIAN_7_FLAG == 1
        then
            if
                0118:   actor $COLOMBIAN_7 dead
            then
                0004: $COLOMBIAN_7_FLAG = 2
            else
                if
                    0202:   actor $COLOMBIAN_7 near_car $ESCORT_TRUCK radius 40.0 40.0 unknown 0
                then
                    01D9: actor $COLOMBIAN_7 destroy_car $ESCORT_TRUCK
                end
            end
        end
        if
            0038:   $COLOMBIAN_8_FLAG == 0
        then
            if or
                00E3:   player $PLAYER 0 near_point -1317.562 -115.688 radius 220.0 220.0
                01AD:   car $ESCORT_TRUCK 0 near_point -1317.562 -115.688 220.0 220.0
            then
                009A: $COLOMBIAN_8 = create_actor 12 #GANG11 at -1317.562 -115.688 39.0
                0173: set_actor $COLOMBIAN_8 z_angle_to 234.938
                01B2: give_actor $COLOMBIAN_8 weapon 27 ammo 9999  // ak47
                02A9: set_actor $COLOMBIAN_8 immune_to_nonplayer 1
                009F: set_actor $COLOMBIAN_8 objective_to-1
                0243: set_actor $COLOMBIAN_8 ped_stats_to 16
                011A: set_actor $COLOMBIAN_8 flags 1
                0350: set_char_stay_in_same_place $COLOMBIAN_8  1
                0004: $COLOMBIAN_8_FLAG = 1
            end
        end
        if
            0038:   $COLOMBIAN_8_FLAG == 1
        then
            if or
                80E3:   NOT   player $PLAYER 0 near_point -1317.562 -115.688 radius 220.0 220.0
                81AD:   NOT   car $ESCORT_TRUCK 0 near_point -1317.562 -115.688 220.0 220.0
            then
                009B: destroy_actor_instantly $COLOMBIAN_8
                0004: $COLOMBIAN_8_FLAG = 0
            end
        end
        if
            0038:   $COLOMBIAN_8_FLAG == 1
        then
            if
                0118:   actor $COLOMBIAN_8 dead
            then
                0004: $COLOMBIAN_8_FLAG = 2
            else
                if
                    0202:   actor $COLOMBIAN_8 near_car $ESCORT_TRUCK radius 40.0 40.0 unknown 0
                then
                    01D9: actor $COLOMBIAN_8 destroy_car $ESCORT_TRUCK
                end
            end
        end
        if
            0038:   $COLOMBIAN_9_FLAG == 0
        then
            if or
                00E3:   player $PLAYER 0 near_point -1302.812 -103.25 radius 220.0 220.0
                01AD:   car $ESCORT_TRUCK 0 near_point -1302.812 -103.25 220.0 220.0
            then
                009A: $COLOMBIAN_9 = create_actor 12 #GANG11 at -1302.812 -103.25 40.1875
                0173: set_actor $COLOMBIAN_9 z_angle_to 110.375
                01B2: give_actor $COLOMBIAN_9 weapon 27 ammo 9999  // ak47
                02A9: set_actor $COLOMBIAN_9 immune_to_nonplayer 1
                009F: set_actor $COLOMBIAN_9 objective_to-1
                0243: set_actor $COLOMBIAN_9 ped_stats_to 16
                011A: set_actor $COLOMBIAN_9 flags 1
                0350: set_char_stay_in_same_place $COLOMBIAN_9  1
                0004: $COLOMBIAN_9_FLAG = 1
            end
        end
        if
            0038:   $COLOMBIAN_9_FLAG == 1
        then
            if or
                80E3:   NOT   player $PLAYER 0 near_point -1302.812 -103.25 radius 220.0 220.0
                81AD:   NOT   car $ESCORT_TRUCK 0 near_point -1302.812 -103.25 220.0 220.0
            then
                009B: destroy_actor_instantly $COLOMBIAN_9
                0004: $COLOMBIAN_9_FLAG = 0
            end
        end
        if
            0038:   $COLOMBIAN_9_FLAG == 1
        then
            if
                0118:   actor $COLOMBIAN_9 dead
            then
                0004: $COLOMBIAN_9_FLAG = 2
            else
                if
                    0202:   actor $COLOMBIAN_9 near_car $ESCORT_TRUCK radius 40.0 40.0 unknown 0
                then
                    01D9: actor $COLOMBIAN_9 destroy_car $ESCORT_TRUCK
                end
            end
        end
        if
            0018:   $ESCORT_TRUCK_FLAG > 4
        then
            if
                0038:   $COLOMBIAN_10_FLAG == 0
            then
                if or
                    00E3:   player $PLAYER 0 near_point -990.875 -405.625 radius 220.0 220.0
                    01AD:   car $ESCORT_TRUCK 0 near_point -990.875 -405.625 220.0 220.0
                then
                    009A: $COLOMBIAN_10 = create_actor 12 #GANG11 at -990.875 -405.625 23.75
                    0173: set_actor $COLOMBIAN_10 z_angle_to 234.75
                    01B2: give_actor $COLOMBIAN_10 weapon 27 ammo 9999  // ak47
                    02A9: set_actor $COLOMBIAN_10 immune_to_nonplayer 1
                    009F: set_actor $COLOMBIAN_10 objective_to-1
                    0243: set_actor $COLOMBIAN_10 ped_stats_to 16
                    011A: set_actor $COLOMBIAN_10 flags 1
                    0350: set_char_stay_in_same_place $COLOMBIAN_10  1
                    0004: $COLOMBIAN_10_FLAG = 1
                end
            end
        end
        if
            0038:   $COLOMBIAN_10_FLAG == 1
        then
            if or
                80E3:   NOT   player $PLAYER 0 near_point -990.875 -405.625 radius 220.0 220.0
                81AD:   NOT   car $ESCORT_TRUCK 0 near_point -990.875 -405.625 220.0 220.0
            then
                009B: destroy_actor_instantly $COLOMBIAN_10
                0004: $COLOMBIAN_10_FLAG = 0
            end
        end
        if
            0038:   $COLOMBIAN_10_FLAG == 1
        then
            if
                0118:   actor $COLOMBIAN_10 dead
            then
                0004: $COLOMBIAN_10_FLAG = 2
            else
                if
                    0202:   actor $COLOMBIAN_10 near_car $ESCORT_TRUCK radius 40.0 40.0 unknown 0
                then
                    01D9: actor $COLOMBIAN_10 destroy_car $ESCORT_TRUCK
                end
            end
        end
        if
            0038:   $CAR1_ATTACKING_FLAG == 0
        then
            if
                01AD:   car $ESCORT_TRUCK 0 near_point -294.0 -1070.0 40.0 40.0
            then
                if
                    80C2:   NOT   sphere_onscreen -213.0 -1099.0 32.0 4.0
                then
                    00A5: $COLOMBIAN_HUMVEE1 = create_car #COLUMB at -213.0 -1099.0 32.0
                    0175: set_car $COLOMBIAN_HUMVEE1 z_angle_to 65.0
                else
                    00A5: $COLOMBIAN_HUMVEE1 = create_car #COLUMB at -385.0 -1021.0 32.0
                    0175: set_car $COLOMBIAN_HUMVEE1 z_angle_to 240.0
                end
                03FB: car $COLOMBIAN_HUMVEE1 bind_to_current_island 0
                0129: $COLOMBIAN_DRIVER_1 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE1 driverseat
                01C8: $COLOMBIAN_HITMAN_1 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE1 passenger_seat 0
                01C8: $COLOMBIAN_HITMAN_3 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE1 passenger_seat 1
                01C8: $COLOMBIAN_HITMAN_5 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE1 passenger_seat 2
                00AD: set_car $COLOMBIAN_HUMVEE1 max_speed_to 40.0
                0224: set_car $COLOMBIAN_HUMVEE1 health_to 650
                00AE: set_car $COLOMBIAN_HUMVEE1 driving_style 2  // DRIVINGMODE_AVOIDCARS
                00AE: set_car $ESCORT_TRUCK driving_style 2  // DRIVINGMODE_AVOIDCARS
                00AD: set_car $ESCORT_TRUCK max_speed_to 25.0
                00A9: set_car $COLOMBIAN_HUMVEE1 to_normal_driver
                032D: car $COLOMBIAN_HUMVEE1 block $ESCORT_TRUCK
                0004: $CAR1_ATTACKING_FLAG = 1
            end
        end
        if
            0018:   $CAR1_ATTACKING_FLAG > 0
        then
            if
                0119:   car $COLOMBIAN_HUMVEE1 wrecked
            then
                0004: $CAR1_ATTACKING_FLAG = -100
            else
                if
                    8118:   NOT   actor $COLOMBIAN_DRIVER_1 dead
                then
                    if
                        80DB:   NOT   actor $COLOMBIAN_DRIVER_1 in_car $COLOMBIAN_HUMVEE1
                    then
                        01B2: give_actor $COLOMBIAN_DRIVER_1 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_DRIVER_1 destroy_car $ESCORT_TRUCK
                    end
                end
                if
                    00DC:   player $PLAYER driving $COLOMBIAN_HUMVEE1
                then
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_1 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_1 weapon 27 ammo 999  // ak47
                        01CA: actor $COLOMBIAN_HITMAN_1 kill_player $PLAYER
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_3 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_3 weapon 27 ammo 999  // ak47
                        01CA: actor $COLOMBIAN_HITMAN_3 kill_player $PLAYER
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_5 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_5 weapon 27 ammo 999  // ak47
                        01CA: actor $COLOMBIAN_HITMAN_5 kill_player $PLAYER
                    end
                end
                if and
                    01F4:   car $COLOMBIAN_HUMVEE1 flipped
                    01C1:   car $COLOMBIAN_HUMVEE1 stopped
                then
                    if
                        8118:   NOT   actor $COLOMBIAN_DRIVER_1 dead
                    then
                        01B2: give_actor $COLOMBIAN_DRIVER_1 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_DRIVER_1 destroy_car $ESCORT_TRUCK
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_1 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_1 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_HITMAN_1 destroy_car $ESCORT_TRUCK
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_3 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_3 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_HITMAN_3 destroy_car $ESCORT_TRUCK
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_5 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_5 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_HITMAN_5 destroy_car $ESCORT_TRUCK
                    end
                end
            end
        end
        if
            0038:   $CAR1_ATTACKING_FLAG == 1
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_1 dead
            then
                02E3: $ESCORT_TRUCK_SPEED = car $ESCORT_TRUCK speed
                02E3: $COLOMBIAN_HUMVEE1_SPEED = car $COLOMBIAN_HUMVEE1 speed
                if and
                    0022:   10.0 > $COLOMBIAN_HUMVEE1_SPEED
                    0022:   4.0 > $ESCORT_TRUCK_SPEED
                then
                    if
                        0204:   actor $COLOMBIAN_HITMAN_1 near_car_in_car $ESCORT_TRUCK radius 10.0 10.0 unknown 0  // never used in VC
                    then
                        01D3: actor $COLOMBIAN_HITMAN_1 leave_car $COLOMBIAN_HUMVEE1
                        0319: set_actor $COLOMBIAN_HITMAN_1 running 1
                        0004: $CAR1_ATTACKING_FLAG = 2
                    end
                end
            else
                0004: $CAR1_ATTACKING_FLAG = 2
            end
        end
        if
            0038:   $CAR1_ATTACKING_FLAG == 2
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_1 dead
            then
                if
                    80DF:   NOT   actor $COLOMBIAN_HITMAN_1 driving
                then
                    01B2: give_actor $COLOMBIAN_HITMAN_1 weapon 27 ammo 999  // ak47
                    01D9: actor $COLOMBIAN_HITMAN_1 destroy_car $ESCORT_TRUCK
                    00AD: set_car $COLOMBIAN_HUMVEE1 max_speed_to 40.0
                    032D: car $COLOMBIAN_HUMVEE1 block $ESCORT_TRUCK
                    0004: $CAR1_ATTACKING_FLAG = 3
                end
            else
                0004: $CAR1_ATTACKING_FLAG = 3
            end
        end
        if
            0038:   $CAR1_ATTACKING_FLAG == 3
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_3 dead
            then
                02E3: $ESCORT_TRUCK_SPEED = car $ESCORT_TRUCK speed
                02E3: $COLOMBIAN_HUMVEE1_SPEED = car $COLOMBIAN_HUMVEE1 speed
                if and
                    0022:   10.0 > $COLOMBIAN_HUMVEE1_SPEED
                    0022:   4.0 > $ESCORT_TRUCK_SPEED
                then
                    if
                        0204:   actor $COLOMBIAN_HITMAN_3 near_car_in_car $ESCORT_TRUCK radius 10.0 10.0 unknown 0  // never used in VC
                    then
                        01D3: actor $COLOMBIAN_HITMAN_3 leave_car $COLOMBIAN_HUMVEE1
                        0319: set_actor $COLOMBIAN_HITMAN_3 running 1
                        0004: $CAR1_ATTACKING_FLAG = 4
                    end
                end
            else
                0004: $CAR1_ATTACKING_FLAG = 4
            end
        end
        if
            0038:   $CAR1_ATTACKING_FLAG == 4
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_3 dead
            then
                if
                    80DF:   NOT   actor $COLOMBIAN_HITMAN_3 driving
                then
                    01B2: give_actor $COLOMBIAN_HITMAN_3 weapon 27 ammo 999  // ak47
                    01D9: actor $COLOMBIAN_HITMAN_3 destroy_car $ESCORT_TRUCK
                    00AD: set_car $COLOMBIAN_HUMVEE1 max_speed_to 40.0
                    032D: car $COLOMBIAN_HUMVEE1 block $ESCORT_TRUCK
                    0004: $CAR1_ATTACKING_FLAG = 5
                end
            else
                0004: $CAR1_ATTACKING_FLAG = 5
            end
        end
        if
            0038:   $CAR1_ATTACKING_FLAG == 5
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_5 dead
            then
                02E3: $ESCORT_TRUCK_SPEED = car $ESCORT_TRUCK speed
                02E3: $COLOMBIAN_HUMVEE1_SPEED = car $COLOMBIAN_HUMVEE1 speed
                if and
                    0022:   10.0 > $COLOMBIAN_HUMVEE1_SPEED
                    0022:   4.0 > $ESCORT_TRUCK_SPEED
                then
                    if
                        0204:   actor $COLOMBIAN_HITMAN_5 near_car_in_car $ESCORT_TRUCK radius 10.0 10.0 unknown 0  // never used in VC
                    then
                        01D3: actor $COLOMBIAN_HITMAN_5 leave_car $COLOMBIAN_HUMVEE1
                        0319: set_actor $COLOMBIAN_HITMAN_5 running 1
                        0004: $CAR1_ATTACKING_FLAG = 6
                    end
                end
            else
                0004: $CAR1_ATTACKING_FLAG = 6
            end
        end
        if
            0038:   $CAR1_ATTACKING_FLAG == 6
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_5 dead
            then
                if
                    80DF:   NOT   actor $COLOMBIAN_HITMAN_5 driving
                then
                    01B2: give_actor $COLOMBIAN_HITMAN_5 weapon 27 ammo 999  // ak47
                    01D9: actor $COLOMBIAN_HITMAN_5 destroy_car $ESCORT_TRUCK
                    00AD: set_car $COLOMBIAN_HUMVEE1 max_speed_to 40.0
                    032D: car $COLOMBIAN_HUMVEE1 block $ESCORT_TRUCK
                    0004: $CAR1_ATTACKING_FLAG = 7
                end
            else
                0004: $CAR1_ATTACKING_FLAG = 7
            end
        end
        if
            0038:   $CAR1_ATTACKING_FLAG == 7
        then
            00AD: set_car $COLOMBIAN_HUMVEE1 max_speed_to 40.0
            032C: car $COLOMBIAN_HUMVEE1 ram $ESCORT_TRUCK
            0004: $CAR1_ATTACKING_FLAG = 8
        end
        if
            0038:   $CAR2_ATTACKING_FLAG == 0
        then
            if
                01AD:   car $ESCORT_TRUCK 0 near_point -333.0 -405.0 40.0 40.0
            then
                if
                    80C2:   NOT   sphere_onscreen -421.0 -409.0 22.0 4.0
                then
                    00A5: $COLOMBIAN_HUMVEE2 = create_car #COLUMB at -421.0 -409.0 22.0
                    0175: set_car $COLOMBIAN_HUMVEE2 z_angle_to 270.0
                else
                    00A5: $COLOMBIAN_HUMVEE2 = create_car #COLUMB at -435.0 -409.0 22.0
                    0175: set_car $COLOMBIAN_HUMVEE2 z_angle_to 90.0
                end
                03FB: car $COLOMBIAN_HUMVEE2 bind_to_current_island 0
                0129: $COLOMBIAN_DRIVER_2 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE2 driverseat
                01C8: $COLOMBIAN_HITMAN_2 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE2 passenger_seat 0
                01C8: $COLOMBIAN_HITMAN_4 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE2 passenger_seat 1
                01C8: $COLOMBIAN_HITMAN_6 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE2 passenger_seat 2
                00AD: set_car $COLOMBIAN_HUMVEE2 max_speed_to 40.0
                00AE: set_car $COLOMBIAN_HUMVEE2 driving_style 2  // DRIVINGMODE_AVOIDCARS
                0224: set_car $COLOMBIAN_HUMVEE2 health_to 650
                00A9: set_car $COLOMBIAN_HUMVEE2 to_normal_driver
                032D: car $COLOMBIAN_HUMVEE2 block $ESCORT_TRUCK
                0004: $CAR2_ATTACKING_FLAG = 1
            end
        end
        if
            0018:   $CAR2_ATTACKING_FLAG > 0
        then
            if
                0119:   car $COLOMBIAN_HUMVEE2 wrecked
            then
                0004: $CAR2_ATTACKING_FLAG = -100
            else
                if
                    8118:   NOT   actor $COLOMBIAN_DRIVER_2 dead
                then
                    if
                        80DB:   NOT   actor $COLOMBIAN_DRIVER_2 in_car $COLOMBIAN_HUMVEE2
                    then
                        01B2: give_actor $COLOMBIAN_DRIVER_2 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_DRIVER_2 destroy_car $ESCORT_TRUCK
                    end
                end
                if
                    00DC:   player $PLAYER driving $COLOMBIAN_HUMVEE2
                then
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_2 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_2 weapon 27 ammo 999  // ak47
                        01CA: actor $COLOMBIAN_HITMAN_2 kill_player $PLAYER
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_4 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_4 weapon 27 ammo 999  // ak47
                        01CA: actor $COLOMBIAN_HITMAN_4 kill_player $PLAYER
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_6 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_6 weapon 27 ammo 999  // ak47
                        01CA: actor $COLOMBIAN_HITMAN_6 kill_player $PLAYER
                    end
                end
                if and
                    01F4:   car $COLOMBIAN_HUMVEE2 flipped
                    01C1:   car $COLOMBIAN_HUMVEE2 stopped
                then
                    if
                        8118:   NOT   actor $COLOMBIAN_DRIVER_2 dead
                    then
                        01B2: give_actor $COLOMBIAN_DRIVER_2 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_DRIVER_2 destroy_car $ESCORT_TRUCK
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_2 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_2 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_HITMAN_2 destroy_car $ESCORT_TRUCK
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_4 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_4 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_HITMAN_4 destroy_car $ESCORT_TRUCK
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_6 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_6 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_HITMAN_6 destroy_car $ESCORT_TRUCK
                    end
                end
            end
        end
        if
            0038:   $CAR2_ATTACKING_FLAG == 1
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_2 dead
            then
                02E3: $ESCORT_TRUCK_SPEED = car $ESCORT_TRUCK speed
                02E3: $COLOMBIAN_HUMVEE2_SPEED = car $COLOMBIAN_HUMVEE2 speed
                if and
                    0022:   10.0 > $COLOMBIAN_HUMVEE2_SPEED
                    0022:   4.0 > $ESCORT_TRUCK_SPEED
                then
                    if
                        0204:   actor $COLOMBIAN_HITMAN_2 near_car_in_car $ESCORT_TRUCK radius 10.0 10.0 unknown 0  // never used in VC
                    then
                        01D3: actor $COLOMBIAN_HITMAN_2 leave_car $COLOMBIAN_HUMVEE2
                        0319: set_actor $COLOMBIAN_HITMAN_2 running 1
                        0004: $CAR2_ATTACKING_FLAG = 2
                    end
                end
            else
                0004: $CAR2_ATTACKING_FLAG = 2
            end
        end
        if
            0038:   $CAR2_ATTACKING_FLAG == 2
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_2 dead
            then
                if
                    80DF:   NOT   actor $COLOMBIAN_HITMAN_2 driving
                then
                    01B2: give_actor $COLOMBIAN_HITMAN_2 weapon 27 ammo 999  // ak47
                    01D9: actor $COLOMBIAN_HITMAN_2 destroy_car $ESCORT_TRUCK
                    00AD: set_car $COLOMBIAN_HUMVEE2 max_speed_to 40.0
                    032D: car $COLOMBIAN_HUMVEE2 block $ESCORT_TRUCK
                    0004: $CAR2_ATTACKING_FLAG = 3
                end
            else
                0004: $CAR2_ATTACKING_FLAG = 3
            end
        end
        if
            0038:   $CAR2_ATTACKING_FLAG == 3
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_4 dead
            then
                02E3: $ESCORT_TRUCK_SPEED = car $ESCORT_TRUCK speed
                02E3: $COLOMBIAN_HUMVEE2_SPEED = car $COLOMBIAN_HUMVEE2 speed
                if and
                    0022:   10.0 > $COLOMBIAN_HUMVEE2_SPEED
                    0022:   4.0 > $ESCORT_TRUCK_SPEED
                then
                    if
                        0204:   actor $COLOMBIAN_HITMAN_4 near_car_in_car $ESCORT_TRUCK radius 10.0 10.0 unknown 0  // never used in VC
                    then
                        01D3: actor $COLOMBIAN_HITMAN_4 leave_car $COLOMBIAN_HUMVEE2
                        0319: set_actor $COLOMBIAN_HITMAN_4 running 1
                        0004: $CAR2_ATTACKING_FLAG = 4
                    end
                end
            else
                0004: $CAR2_ATTACKING_FLAG = 4
            end
        end
        if
            0038:   $CAR2_ATTACKING_FLAG == 4
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_4 dead
            then
                if
                    80DF:   NOT   actor $COLOMBIAN_HITMAN_4 driving
                then
                    01B2: give_actor $COLOMBIAN_HITMAN_4 weapon 27 ammo 999  // ak47
                    01D9: actor $COLOMBIAN_HITMAN_4 destroy_car $ESCORT_TRUCK
                    00AD: set_car $COLOMBIAN_HUMVEE2 max_speed_to 40.0
                    032D: car $COLOMBIAN_HUMVEE2 block $ESCORT_TRUCK
                    0004: $CAR2_ATTACKING_FLAG = 5
                end
            else
                0004: $CAR2_ATTACKING_FLAG = 5
            end
        end
        if
            0038:   $CAR2_ATTACKING_FLAG == 5
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_6 dead
            then
                02E3: $ESCORT_TRUCK_SPEED = car $ESCORT_TRUCK speed
                02E3: $COLOMBIAN_HUMVEE2_SPEED = car $COLOMBIAN_HUMVEE2 speed
                if and
                    0022:   10.0 > $COLOMBIAN_HUMVEE2_SPEED
                    0022:   4.0 > $ESCORT_TRUCK_SPEED
                then
                    if
                        0204:   actor $COLOMBIAN_HITMAN_6 near_car_in_car $ESCORT_TRUCK radius 10.0 10.0 unknown 0  // never used in VC
                    then
                        01D3: actor $COLOMBIAN_HITMAN_6 leave_car $COLOMBIAN_HUMVEE2
                        0319: set_actor $COLOMBIAN_HITMAN_6 running 1
                        0004: $CAR2_ATTACKING_FLAG = 6
                    end
                end
            else
                0004: $CAR2_ATTACKING_FLAG = 6
            end
        end
        if
            0038:   $CAR2_ATTACKING_FLAG == 6
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_6 dead
            then
                if
                    80DF:   NOT   actor $COLOMBIAN_HITMAN_6 driving
                then
                    01B2: give_actor $COLOMBIAN_HITMAN_6 weapon 27 ammo 999  // ak47
                    01D9: actor $COLOMBIAN_HITMAN_6 destroy_car $ESCORT_TRUCK
                    00AD: set_car $COLOMBIAN_HUMVEE2 max_speed_to 40.0
                    032D: car $COLOMBIAN_HUMVEE2 block $ESCORT_TRUCK
                    0004: $CAR2_ATTACKING_FLAG = 7
                end
            else
                0004: $CAR2_ATTACKING_FLAG = 7
            end
        end
        if
            0038:   $CAR2_ATTACKING_FLAG == 7
        then
            00AD: set_car $COLOMBIAN_HUMVEE2 max_speed_to 40.0
            032C: car $COLOMBIAN_HUMVEE2 ram $ESCORT_TRUCK
            0004: $CAR2_ATTACKING_FLAG = 8
        end
        if
            0018:   $ESCORT_TRUCK_FLAG > 4
        then
            if
                0038:   $CAR3_ATTACKING_FLAG == 0
            then
                if
                    01AD:   car $ESCORT_TRUCK 0 near_point -980.812 -435.938 40.0 40.0
                then
                    if
                        80C2:   NOT   sphere_onscreen -1158.625 -435.062 16.0625 4.0
                    then
                        00A5: $COLOMBIAN_HUMVEE3 = create_car #COLUMB at -1158.625 -435.062 16.0625
                        0175: set_car $COLOMBIAN_HUMVEE3 z_angle_to 272.062
                    else
                        00A5: $COLOMBIAN_HUMVEE3 = create_car #COLUMB at -1070.5 -577.312 13.625
                        0175: set_car $COLOMBIAN_HUMVEE3 z_angle_to 7.75
                    end
                    03FB: car $COLOMBIAN_HUMVEE3 bind_to_current_island 0
                    0129: $COLOMBIAN_DRIVER_3 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE3 driverseat
                    01C8: $COLOMBIAN_HITMAN_7 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE3 passenger_seat 0
                    01C8: $COLOMBIAN_HITMAN_8 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE3 passenger_seat 1
                    01C8: $COLOMBIAN_HITMAN_9 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE3 passenger_seat 2
                    00AD: set_car $COLOMBIAN_HUMVEE3 max_speed_to 40.0
                    0224: set_car $COLOMBIAN_HUMVEE3 health_to 650
                    00AE: set_car $COLOMBIAN_HUMVEE3 driving_style 2  // DRIVINGMODE_AVOIDCARS
                    00A9: set_car $COLOMBIAN_HUMVEE3 to_normal_driver
                    032D: car $COLOMBIAN_HUMVEE3 block $ESCORT_TRUCK
                    0004: $CAR3_ATTACKING_FLAG = 1
                end
            end
        end
        if
            0018:   $CAR3_ATTACKING_FLAG > 0
        then
            if
                0119:   car $COLOMBIAN_HUMVEE3 wrecked
            then
                0004: $CAR3_ATTACKING_FLAG = -100
            else
                if
                    8118:   NOT   actor $COLOMBIAN_DRIVER_3 dead
                then
                    if
                        80DB:   NOT   actor $COLOMBIAN_DRIVER_3 in_car $COLOMBIAN_HUMVEE3
                    then
                        01B2: give_actor $COLOMBIAN_DRIVER_3 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_DRIVER_3 destroy_car $ESCORT_TRUCK
                    end
                end
                if
                    00DC:   player $PLAYER driving $COLOMBIAN_HUMVEE3
                then
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_7 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_7 weapon 27 ammo 999  // ak47
                        01CA: actor $COLOMBIAN_HITMAN_7 kill_player $PLAYER
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_8 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_8 weapon 27 ammo 999  // ak47
                        01CA: actor $COLOMBIAN_HITMAN_8 kill_player $PLAYER
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_9 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_9 weapon 27 ammo 999  // ak47
                        01CA: actor $COLOMBIAN_HITMAN_9 kill_player $PLAYER
                    end
                end
                if and
                    01F4:   car $COLOMBIAN_HUMVEE3 flipped
                    01C1:   car $COLOMBIAN_HUMVEE3 stopped
                then
                    if
                        8118:   NOT   actor $COLOMBIAN_DRIVER_3 dead
                    then
                        01B2: give_actor $COLOMBIAN_DRIVER_3 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_DRIVER_3 destroy_car $ESCORT_TRUCK
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_7 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_7 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_HITMAN_7 destroy_car $ESCORT_TRUCK
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_8 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_8 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_HITMAN_8 destroy_car $ESCORT_TRUCK
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_9 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_9 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_HITMAN_9 destroy_car $ESCORT_TRUCK
                    end
                end
            end
        end
        if
            0038:   $CAR3_ATTACKING_FLAG == 1
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_7 dead
            then
                02E3: $ESCORT_TRUCK_SPEED = car $ESCORT_TRUCK speed
                02E3: $COLOMBIAN_HUMVEE3_SPEED = car $COLOMBIAN_HUMVEE3 speed
                if and
                    0022:   10.0 > $COLOMBIAN_HUMVEE3_SPEED
                    0022:   4.0 > $ESCORT_TRUCK_SPEED
                then
                    if
                        0204:   actor $COLOMBIAN_HITMAN_7 near_car_in_car $ESCORT_TRUCK radius 10.0 10.0 unknown 0  // never used in VC
                    then
                        01D3: actor $COLOMBIAN_HITMAN_7 leave_car $COLOMBIAN_HUMVEE3
                        0319: set_actor $COLOMBIAN_HITMAN_7 running 1
                        0004: $CAR3_ATTACKING_FLAG = 2
                    end
                end
            else
                0004: $CAR3_ATTACKING_FLAG = 2
            end
        end
        if
            0038:   $CAR3_ATTACKING_FLAG == 2
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_7 dead
            then
                if
                    80DF:   NOT   actor $COLOMBIAN_HITMAN_7 driving
                then
                    01B2: give_actor $COLOMBIAN_HITMAN_7 weapon 27 ammo 999  // ak47
                    01D9: actor $COLOMBIAN_HITMAN_7 destroy_car $ESCORT_TRUCK
                    00AD: set_car $COLOMBIAN_HUMVEE3 max_speed_to 40.0
                    032D: car $COLOMBIAN_HUMVEE3 block $ESCORT_TRUCK
                    0004: $CAR3_ATTACKING_FLAG = 3
                end
            else
                0004: $CAR3_ATTACKING_FLAG = 3
            end
        end
        if
            0038:   $CAR3_ATTACKING_FLAG == 3
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_8 dead
            then
                02E3: $ESCORT_TRUCK_SPEED = car $ESCORT_TRUCK speed
                02E3: $COLOMBIAN_HUMVEE3_SPEED = car $COLOMBIAN_HUMVEE3 speed
                if and
                    0022:   10.0 > $COLOMBIAN_HUMVEE3_SPEED
                    0022:   4.0 > $ESCORT_TRUCK_SPEED
                then
                    if
                        0204:   actor $COLOMBIAN_HITMAN_8 near_car_in_car $ESCORT_TRUCK radius 10.0 10.0 unknown 0  // never used in VC
                    then
                        01D3: actor $COLOMBIAN_HITMAN_8 leave_car $COLOMBIAN_HUMVEE3
                        0319: set_actor $COLOMBIAN_HITMAN_8 running 1
                        0004: $CAR3_ATTACKING_FLAG = 4
                    end
                end
            else
                0004: $CAR3_ATTACKING_FLAG = 4
            end
        end
        if
            0038:   $CAR3_ATTACKING_FLAG == 4
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_8 dead
            then
                if
                    80DF:   NOT   actor $COLOMBIAN_HITMAN_8 driving
                then
                    01B2: give_actor $COLOMBIAN_HITMAN_8 weapon 27 ammo 999  // ak47
                    01D9: actor $COLOMBIAN_HITMAN_8 destroy_car $ESCORT_TRUCK
                    00AD: set_car $COLOMBIAN_HUMVEE3 max_speed_to 40.0
                    032D: car $COLOMBIAN_HUMVEE3 block $ESCORT_TRUCK
                    0004: $CAR3_ATTACKING_FLAG = 5
                end
            else
                0004: $CAR3_ATTACKING_FLAG = 5
            end
        end
        if
            0038:   $CAR3_ATTACKING_FLAG == 5
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_9 dead
            then
                02E3: $ESCORT_TRUCK_SPEED = car $ESCORT_TRUCK speed
                02E3: $COLOMBIAN_HUMVEE3_SPEED = car $COLOMBIAN_HUMVEE3 speed
                if and
                    0022:   10.0 > $COLOMBIAN_HUMVEE3_SPEED
                    0022:   4.0 > $ESCORT_TRUCK_SPEED
                then
                    if
                        0204:   actor $COLOMBIAN_HITMAN_9 near_car_in_car $ESCORT_TRUCK radius 10.0 10.0 unknown 0  // never used in VC
                    then
                        01D3: actor $COLOMBIAN_HITMAN_9 leave_car $COLOMBIAN_HUMVEE3
                        0319: set_actor $COLOMBIAN_HITMAN_9 running 1
                        0004: $CAR3_ATTACKING_FLAG = 6
                    end
                end
            else
                0004: $CAR3_ATTACKING_FLAG = 6
            end
        end
        if
            0038:   $CAR3_ATTACKING_FLAG == 6
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_9 dead
            then
                if
                    80DF:   NOT   actor $COLOMBIAN_HITMAN_9 driving
                then
                    01B2: give_actor $COLOMBIAN_HITMAN_9 weapon 27 ammo 999  // ak47
                    01D9: actor $COLOMBIAN_HITMAN_9 destroy_car $ESCORT_TRUCK
                    00AD: set_car $COLOMBIAN_HUMVEE3 max_speed_to 40.0
                    032D: car $COLOMBIAN_HUMVEE3 block $ESCORT_TRUCK
                    0004: $CAR3_ATTACKING_FLAG = 7
                end
            else
                0004: $CAR3_ATTACKING_FLAG = 7
            end
        end
        if
            0038:   $CAR3_ATTACKING_FLAG == 7
        then
            00AD: set_car $COLOMBIAN_HUMVEE3 max_speed_to 40.0
            032C: car $COLOMBIAN_HUMVEE3 ram $ESCORT_TRUCK
            0004: $CAR3_ATTACKING_FLAG = 8
        end
        if
            0038:   $CAR4_ATTACKING_FLAG == 0
        then
            if
                01AD:   car $ESCORT_TRUCK 0 near_point -980.812 -435.938 40.0 40.0
            then
                if
                    80C2:   NOT   sphere_onscreen -1352.62 -226.125 43.9375 4.0
                then
                    00A5: $COLOMBIAN_HUMVEE4 = create_car #COLUMB at -1352.62 -226.125 43.9375
                    0175: set_car $COLOMBIAN_HUMVEE4 z_angle_to 284.938
                else
                    00A5: $COLOMBIAN_HUMVEE4 = create_car #COLUMB at -1213.812 -229.125 34.125
                    0175: set_car $COLOMBIAN_HUMVEE4 z_angle_to 84.5625
                end
                03FB: car $COLOMBIAN_HUMVEE4 bind_to_current_island 0
                0129: $COLOMBIAN_DRIVER_4 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE4 driverseat
                01C8: $COLOMBIAN_HITMAN_10 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE4 passenger_seat 0
                01C8: $COLOMBIAN_HITMAN_11 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE4 passenger_seat 1
                01C8: $COLOMBIAN_HITMAN_12 = create_actor 12 #GANG11 in_car $COLOMBIAN_HUMVEE4 passenger_seat 2
                00AD: set_car $COLOMBIAN_HUMVEE4 max_speed_to 40.0
                0224: set_car $COLOMBIAN_HUMVEE4 health_to 650
                00AE: set_car $COLOMBIAN_HUMVEE4 driving_style 2  // DRIVINGMODE_AVOIDCARS
                00A9: set_car $COLOMBIAN_HUMVEE4 to_normal_driver
                032D: car $COLOMBIAN_HUMVEE4 block $ESCORT_TRUCK
                0004: $CAR4_ATTACKING_FLAG = 1
            end
        end
        if
            0018:   $CAR4_ATTACKING_FLAG > 0
        then
            if
                0119:   car $COLOMBIAN_HUMVEE4 wrecked
            then
                0004: $CAR4_ATTACKING_FLAG = -100
            else
                if
                    8118:   NOT   actor $COLOMBIAN_DRIVER_4 dead
                then
                    if
                        80DB:   NOT   actor $COLOMBIAN_DRIVER_4 in_car $COLOMBIAN_HUMVEE4
                    then
                        01B2: give_actor $COLOMBIAN_DRIVER_4 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_DRIVER_4 destroy_car $ESCORT_TRUCK
                    end
                end
                if
                    00DC:   player $PLAYER driving $COLOMBIAN_HUMVEE4
                then
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_10 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_10 weapon 27 ammo 999  // ak47
                        01CA: actor $COLOMBIAN_HITMAN_10 kill_player $PLAYER
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_11 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_11 weapon 27 ammo 999  // ak47
                        01CA: actor $COLOMBIAN_HITMAN_11 kill_player $PLAYER
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_12 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_12 weapon 27 ammo 999  // ak47
                        01CA: actor $COLOMBIAN_HITMAN_12 kill_player $PLAYER
                    end
                end
                if and
                    01F4:   car $COLOMBIAN_HUMVEE4 flipped
                    01C1:   car $COLOMBIAN_HUMVEE4 stopped
                then
                    if
                        8118:   NOT   actor $COLOMBIAN_DRIVER_4 dead
                    then
                        01B2: give_actor $COLOMBIAN_DRIVER_4 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_DRIVER_4 destroy_car $ESCORT_TRUCK
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_10 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_10 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_HITMAN_10 destroy_car $ESCORT_TRUCK
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_11 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_11 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_HITMAN_11 destroy_car $ESCORT_TRUCK
                    end
                    if
                        8118:   NOT   actor $COLOMBIAN_HITMAN_12 dead
                    then
                        01B2: give_actor $COLOMBIAN_HITMAN_12 weapon 27 ammo 999  // ak47
                        01D9: actor $COLOMBIAN_HITMAN_12 destroy_car $ESCORT_TRUCK
                    end
                end
            end
        end
        if
            0038:   $CAR4_ATTACKING_FLAG == 1
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_10 dead
            then
                02E3: $ESCORT_TRUCK_SPEED = car $ESCORT_TRUCK speed
                02E3: $COLOMBIAN_HUMVEE4_SPEED = car $COLOMBIAN_HUMVEE4 speed
                if and
                    0022:   10.0 > $COLOMBIAN_HUMVEE4_SPEED
                    0022:   4.0 > $ESCORT_TRUCK_SPEED
                then
                    if
                        0204:   actor $COLOMBIAN_HITMAN_10 near_car_in_car $ESCORT_TRUCK radius 10.0 10.0 unknown 0  // never used in VC
                    then
                        01D3: actor $COLOMBIAN_HITMAN_10 leave_car $COLOMBIAN_HUMVEE4
                        0319: set_actor $COLOMBIAN_HITMAN_10 running 1
                        0004: $CAR4_ATTACKING_FLAG = 2
                    end
                end
            else
                0004: $CAR4_ATTACKING_FLAG = 2
            end
        end
        if
            0038:   $CAR4_ATTACKING_FLAG == 2
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_10 dead
            then
                if
                    80DF:   NOT   actor $COLOMBIAN_HITMAN_10 driving
                then
                    01B2: give_actor $COLOMBIAN_HITMAN_10 weapon 27 ammo 999  // ak47
                    01D9: actor $COLOMBIAN_HITMAN_10 destroy_car $ESCORT_TRUCK
                    00AD: set_car $COLOMBIAN_HUMVEE4 max_speed_to 40.0
                    032D: car $COLOMBIAN_HUMVEE4 block $ESCORT_TRUCK
                    0004: $CAR4_ATTACKING_FLAG = 3
                end
            else
                0004: $CAR4_ATTACKING_FLAG = 3
            end
        end
        if
            0038:   $CAR4_ATTACKING_FLAG == 3
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_11 dead
            then
                02E3: $ESCORT_TRUCK_SPEED = car $ESCORT_TRUCK speed
                02E3: $COLOMBIAN_HUMVEE4_SPEED = car $COLOMBIAN_HUMVEE4 speed
                if and
                    0022:   10.0 > $COLOMBIAN_HUMVEE4_SPEED
                    0022:   4.0 > $ESCORT_TRUCK_SPEED
                then
                    if
                        0204:   actor $COLOMBIAN_HITMAN_11 near_car_in_car $ESCORT_TRUCK radius 10.0 10.0 unknown 0  // never used in VC
                    then
                        01D3: actor $COLOMBIAN_HITMAN_11 leave_car $COLOMBIAN_HUMVEE4
                        0319: set_actor $COLOMBIAN_HITMAN_11 running 1
                        0004: $CAR4_ATTACKING_FLAG = 4
                    end
                end
            else
                0004: $CAR4_ATTACKING_FLAG = 4
            end
        end
        if
            0038:   $CAR4_ATTACKING_FLAG == 4
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_11 dead
            then
                if
                    80DF:   NOT   actor $COLOMBIAN_HITMAN_11 driving
                then
                    01B2: give_actor $COLOMBIAN_HITMAN_11 weapon 27 ammo 999  // ak47
                    01D9: actor $COLOMBIAN_HITMAN_11 destroy_car $ESCORT_TRUCK
                    00AD: set_car $COLOMBIAN_HUMVEE4 max_speed_to 40.0
                    032D: car $COLOMBIAN_HUMVEE4 block $ESCORT_TRUCK
                    0004: $CAR4_ATTACKING_FLAG = 5
                end
            else
                0004: $CAR4_ATTACKING_FLAG = 5
            end
        end
        if
            0038:   $CAR4_ATTACKING_FLAG == 5
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_12 dead
            then
                02E3: $ESCORT_TRUCK_SPEED = car $ESCORT_TRUCK speed
                02E3: $COLOMBIAN_HUMVEE4_SPEED = car $COLOMBIAN_HUMVEE4 speed
                if and
                    0022:   10.0 > $COLOMBIAN_HUMVEE4_SPEED
                    0022:   4.0 > $ESCORT_TRUCK_SPEED
                then
                    if
                        0204:   actor $COLOMBIAN_HITMAN_12 near_car_in_car $ESCORT_TRUCK radius 10.0 10.0 unknown 0  // never used in VC
                    then
                        01D3: actor $COLOMBIAN_HITMAN_12 leave_car $COLOMBIAN_HUMVEE4
                        0319: set_actor $COLOMBIAN_HITMAN_12 running 1
                        0004: $CAR4_ATTACKING_FLAG = 6
                    end
                end
            else
                0004: $CAR4_ATTACKING_FLAG = 6
            end
        end
        if
            0038:   $CAR4_ATTACKING_FLAG == 6
        then
            if
                8118:   NOT   actor $COLOMBIAN_HITMAN_12 dead
            then
                if
                    80DF:   NOT   actor $COLOMBIAN_HITMAN_12 driving
                then
                    01B2: give_actor $COLOMBIAN_HITMAN_12 weapon 27 ammo 999  // ak47
                    01D9: actor $COLOMBIAN_HITMAN_12 destroy_car $ESCORT_TRUCK
                    00AD: set_car $COLOMBIAN_HUMVEE4 max_speed_to 40.0
                    032D: car $COLOMBIAN_HUMVEE4 block $ESCORT_TRUCK
                    0004: $CAR4_ATTACKING_FLAG = 7
                end
            else
                0004: $CAR4_ATTACKING_FLAG = 7
            end
        end
        if
            0038:   $CAR4_ATTACKING_FLAG == 7
        then
            00AD: set_car $COLOMBIAN_HUMVEE4 max_speed_to 40.0
            032C: car $COLOMBIAN_HUMVEE4 ram $ESCORT_TRUCK
            0004: $CAR4_ATTACKING_FLAG = 8
        end
    else
        01C3: remove_references_to_car $COLOMBIAN_HUMVEE1  // Like turning a car into any random car
        01C3: remove_references_to_car $COLOMBIAN_HUMVEE2  // Like turning a car into any random car
        01C3: remove_references_to_car $COLOMBIAN_HUMVEE3  // Like turning a car into any random car
        01C3: remove_references_to_car $COLOMBIAN_HUMVEE4  // Like turning a car into any random car
        01C2: remove_references_to_actor $COLOMBIAN_DRIVER_1  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_DRIVER_2  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_DRIVER_3  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_DRIVER_4  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_HITMAN_1  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_HITMAN_2  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_HITMAN_3  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_HITMAN_4  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_HITMAN_5  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_HITMAN_6  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_HITMAN_7  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_HITMAN_8  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_HITMAN_9  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_HITMAN_10  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_HITMAN_11  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_HITMAN_12  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_1  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_2  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_3  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_4  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_5  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_6  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_7  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_8  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_9  // Like turning an actor into a random pedestrian
        01C2: remove_references_to_actor $COLOMBIAN_10  // Like turning an actor into a random pedestrian
    end
end //while
jump @MISSION_LOVE5_PASSED

:MISSION_LOVE5_FAILED
00BA: text_styled 'M_FAIL' 2000 ms 1   // // MISSION FAILED!
return

:MISSION_LOVE5_PASSED
0004: $ESCORT_SERVICE_COMPLETED = 1
01E3: text_1number_styled 'M_PASS' 40000 2000 ms 1   // // MISSION PASSED! $~1~
0109: player $PLAYER money += 40000
0110: clear_player $PLAYER wanted_level
0394: play_music 1
0318: set_latest_mission_passed 'LOVE5'   // // 'ESCORT SERVICE'
030C: set_mission_points += 1
004F: create_thread @LOVE_MISSION6_LOOP
return

:MISSION_CLEANUP_LOVE5
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $FLAG_PLAYER_ON_LOVE_MISSION = 0
if
    8214:   NOT   pickup $TANK_WEAPON picked_up
then
    0215: destroy_pickup $TANK_WEAPON
end
0151: remove_status_text $ESCORT_TRUCK_HEALTH
0249: mark_model_as_no_longer_needed #SECURICA
0249: mark_model_as_no_longer_needed #COLUMB
0249: mark_model_as_no_longer_needed #M16
0249: mark_model_as_no_longer_needed #AK47
0249: mark_model_as_no_longer_needed #GANG11
0296: unload_special_actor 2
0296: unload_special_actor 3
01EB: set_car_density_to 1.0
0164: remove_blip $ESCORT_TRUCK_BLIP
mission_cleanup
return

:CALL_OFF_THE_ATTACKERS
if
    8119:   NOT   car $COLOMBIAN_HUMVEE1 wrecked
then
    00A8: set_car $COLOMBIAN_HUMVEE1 to_psycho_driver
end
if
    8119:   NOT   car $COLOMBIAN_HUMVEE2 wrecked
then
    00A8: set_car $COLOMBIAN_HUMVEE2 to_psycho_driver
end
if
    8119:   NOT   car $COLOMBIAN_HUMVEE3 wrecked
then
    00A8: set_car $COLOMBIAN_HUMVEE3 to_psycho_driver
end
if
    8119:   NOT   car $COLOMBIAN_HUMVEE4 wrecked
then
    00A8: set_car $COLOMBIAN_HUMVEE4 to_psycho_driver
end
if
    8118:   NOT   actor $COLOMBIAN_HITMAN_1 dead
then
    01CC: actor $COLOMBIAN_HITMAN_1 kill_player $PLAYER
end
if
    8118:   NOT   actor $COLOMBIAN_HITMAN_2 dead
then
    01CC: actor $COLOMBIAN_HITMAN_2 kill_player $PLAYER
end
if
    8118:   NOT   actor $COLOMBIAN_HITMAN_3 dead
then
    01CC: actor $COLOMBIAN_HITMAN_3 kill_player $PLAYER
end
if
    8118:   NOT   actor $COLOMBIAN_HITMAN_4 dead
then
    01CC: actor $COLOMBIAN_HITMAN_4 kill_player $PLAYER
end
if
    8118:   NOT   actor $COLOMBIAN_HITMAN_5 dead
then
    01CC: actor $COLOMBIAN_HITMAN_5 kill_player $PLAYER
end
if
    8118:   NOT   actor $COLOMBIAN_HITMAN_6 dead
then
    01CC: actor $COLOMBIAN_HITMAN_6 kill_player $PLAYER
end
if
    8118:   NOT   actor $COLOMBIAN_HITMAN_7 dead
then
    01CC: actor $COLOMBIAN_HITMAN_7 kill_player $PLAYER
end
if
    8118:   NOT   actor $COLOMBIAN_HITMAN_8 dead
then
    01CC: actor $COLOMBIAN_HITMAN_8 kill_player $PLAYER
end
if
    8118:   NOT   actor $COLOMBIAN_HITMAN_9 dead
then
    01CC: actor $COLOMBIAN_HITMAN_9 kill_player $PLAYER
end
if
    8118:   NOT   actor $COLOMBIAN_HITMAN_10 dead
then
    01CC: actor $COLOMBIAN_HITMAN_10 kill_player $PLAYER
end
if
    8118:   NOT   actor $COLOMBIAN_HITMAN_11 dead
then
    01CC: actor $COLOMBIAN_HITMAN_11 kill_player $PLAYER
end
if
    8118:   NOT   actor $COLOMBIAN_HITMAN_12 dead
then
    01CC: actor $COLOMBIAN_HITMAN_12 kill_player $PLAYER
end
01C3: remove_references_to_car $COLOMBIAN_HUMVEE1  // Like turning a car into any random car
01C3: remove_references_to_car $COLOMBIAN_HUMVEE2  // Like turning a car into any random car
01C3: remove_references_to_car $COLOMBIAN_HUMVEE3  // Like turning a car into any random car
01C3: remove_references_to_car $COLOMBIAN_HUMVEE4  // Like turning a car into any random car
01C2: remove_references_to_actor $COLOMBIAN_HITMAN_1  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_HITMAN_2  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_HITMAN_3  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_HITMAN_4  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_HITMAN_5  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_HITMAN_6  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_HITMAN_7  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_HITMAN_8  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_HITMAN_9  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_HITMAN_10  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_HITMAN_11  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_HITMAN_12  // Like turning an actor into a random pedestrian
0004: $CAR1_ATTACKING_FLAG = -100
0004: $CAR2_ATTACKING_FLAG = -100
0004: $CAR3_ATTACKING_FLAG = -100
0004: $CAR4_ATTACKING_FLAG = -100
return
