//#####################################################################################
//#####################################################################################
// CATALINA HELICOPTER SUBSTITUTES
//#####################################################################################
//#####################################################################################

:START_CATALINA_HELI
03A4: name_thread 'CAT_FB'
0004: $CAT1_SPEED = 60
0004: $CAT1_SPEED_SLOW = 40
00A5: $ESCAPE_CHOPPER = create_car #MAVERICK at  -559.0  201.0  89.0
020A: set_car $ESCAPE_CHOPPER door_status_to 2
0587: $ESCAPE_CHOPPER  0
0129: $TEMP_CATALINA_ACTOR = create_actor  21 #SPECIAL02 in_car $ESCAPE_CHOPPER driverseat
02AB: set_actor $TEMP_CATALINA_ACTOR immunities  1  1  1  1  1
04BA: set_car $ESCAPE_CHOPPER speed_instantly  10.0
04A2: heli $ESCAPE_CHOPPER fly_to  -738.9  219.4  83.5 speed  $CAT1_SPEED
while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -738.9  219.4  83.5 radius  5.0  5.0  4.0
    wait  0 ms
    gosub @CATALINA_HELI_CHECK
end
04A2: heli $ESCAPE_CHOPPER fly_to  -849.6  228.3  81.22 speed  $CAT1_SPEED
while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -849.6  228.3  81.22 radius  5.0  5.0  4.0
    wait  0 ms
    gosub @CATALINA_HELI_CHECK
end
04A2: heli $ESCAPE_CHOPPER fly_to  -1161.6  200.4  75.48 speed  $CAT1_SPEED
while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1161.6  200.4  75.48 radius  5.0  5.0  4.0
    wait  0 ms
    gosub @CATALINA_HELI_CHECK
end
04A2: heli $ESCAPE_CHOPPER fly_to  -1531.0  304.3  56.5 speed  $CAT1_SPEED_SLOW
while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1531.0  304.3  56.5 radius  3.0  3.0  3.0
    wait  0 ms
    gosub @CATALINA_HELI_CHECK
end
04A2: heli $ESCAPE_CHOPPER fly_to  -1519.0  302.2  57.5 speed  $CAT1_SPEED_SLOW
while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1519.0  302.2  57.5 radius  3.0  3.0  3.0
    wait  0 ms
    gosub @CATALINA_HELI_CHECK
end
04A2: heli $ESCAPE_CHOPPER fly_to  -1493.0  283.1  58.46 speed  $CAT1_SPEED_SLOW
while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1493.0  283.1  58.46 radius  3.0  3.0  3.0
    wait  0 ms
    gosub @CATALINA_HELI_CHECK
end
04A2: heli $ESCAPE_CHOPPER fly_to  -1492.0  336.1  37.55 speed  10
while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1492.0  336.1  37.55 radius  3.0  3.0  3.0
    wait  0 ms
    gosub @CATALINA_HELI_CHECK
end
04BA: set_car $ESCAPE_CHOPPER speed_instantly  0.0
00AB: put_car $ESCAPE_CHOPPER at -1492.0  336.1  36.04
0175: set_car $ESCAPE_CHOPPER z_angle_to 270.0
0519: lock_car $ESCAPE_CHOPPER in_current_position 1

:CATALINA_HELI_CLEANUP
009B: destroy_actor_instantly $TEMP_CATALINA_ACTOR
end_thread

:CATALINA_HELI_CHECK
if
    8038:  NOT  $ESCAPE_CHOPPER == -1
then
    if
        0119:  car $ESCAPE_CHOPPER wrecked
    then
        jump @CATALINA_HELI_CLEANUP
    end
    return
end
jump @CATALINA_HELI_CLEANUP

:CATALINA_HELI_TAKE_OFF
03A4: name_thread 'CAT_TO'
009A: $TEMP_COLOMBIAN_ACTOR = create_actor  12 #GANG12 at -1485.0  341.1  37.8

while 8203:   NOT  actor $CATALINA near_car_on_foot $ESCAPE_CHOPPER radius  4.0  4.0 unknown 0
wait  0 ms
    wait  0 ms
    gosub @CATALINA_HELI_TAKE_OFF_CHECK
end
036A: put_actor $CATALINA in_car $ESCAPE_CHOPPER
01CC: actor $TEMP_COLOMBIAN_ACTOR kill_player $PLAYER
0464: put_actor $TEMP_COLOMBIAN_ACTOR into_turret_on_car $ESCAPE_CHOPPER at_car_offset  -1.4  1.0 -0.1 unknown  1 angle  90.0 with_weapon  26
0350: set_char_stay_in_same_place $TEMP_COLOMBIAN_ACTOR   1
01B2: give_actor $TEMP_COLOMBIAN_ACTOR weapon  26 ammo  9999  // Load the weapon model before using this
01ED: reset_actor $TEMP_COLOMBIAN_ACTOR flags
011A: set_actor $TEMP_COLOMBIAN_ACTOR flags  1
0291: set_char_heed_threats $TEMP_COLOMBIAN_ACTOR  1
0411: set_char_use_pednode_seek $TEMP_COLOMBIAN_ACTOR  0
01CA: actor $TEMP_COLOMBIAN_ACTOR kill_player $PLAYER
0243: set_actor $TEMP_COLOMBIAN_ACTOR ped_stats_to  16
0006:  17@ =  0
0004: $CAT1_SPEED = 40
0519: lock_car $ESCAPE_CHOPPER in_current_position 0
04A2: heli $ESCAPE_CHOPPER fly_to  -1492.0  336.1  46.94 speed  $CAT1_SPEED
while true
    wait 0 ms
    while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1492.0  336.1  46.94 radius  3.0  3.0  2.0
        wait  0 ms
        gosub @CATALINA_HELI_TAKE_OFF_CHECK
        gosub @CATALINA_HELI_TAKE_OFF_BOMBS
    end
    04A2: heli $ESCAPE_CHOPPER fly_to  -1485.0  358.3  59.6 speed  $CAT1_SPEED
    while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1485.0  358.3  59.6 radius  5.0  5.0  4.0
        wait  0 ms
        gosub @CATALINA_HELI_TAKE_OFF_CHECK
        gosub @CATALINA_HELI_TAKE_OFF_BOMBS
    end
    04A2: heli $ESCAPE_CHOPPER fly_to  -1468.0  414.3  45.62 speed  $CAT1_SPEED
    while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1468.0  414.3  45.62 radius  5.0  5.0  4.0
        wait  0 ms
        gosub @CATALINA_HELI_TAKE_OFF_CHECK
        gosub @CATALINA_HELI_TAKE_OFF_BOMBS
    end
    04A2: heli $ESCAPE_CHOPPER fly_to  -1431.0  458.8  35.9 speed  $CAT1_SPEED
    while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1431.0  458.8  35.9 radius  5.0  5.0  4.0
        wait  0 ms
        gosub @CATALINA_HELI_TAKE_OFF_CHECK
        gosub @CATALINA_HELI_TAKE_OFF_BOMBS
    end
    04A2: heli $ESCAPE_CHOPPER fly_to  -1308.5  433.7  39.01 speed  $CAT1_SPEED
    while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1308.5  433.7  39.01 radius  4.0  4.0  4.0
        wait  0 ms
        gosub @CATALINA_HELI_TAKE_OFF_CHECK
        gosub @CATALINA_HELI_TAKE_OFF_BOMBS
    end
    04A2: heli $ESCAPE_CHOPPER fly_to  -1308.5  342.9  47.5 speed  $CAT1_SPEED
    while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1308.5  342.9  47.5 radius  4.0  4.0  4.0
        wait  0 ms
        gosub @CATALINA_HELI_TAKE_OFF_CHECK
        gosub @CATALINA_HELI_TAKE_OFF_BOMBS
    end
    04A2: heli $ESCAPE_CHOPPER fly_to  -1330.1  314.1  45.27 speed  $CAT1_SPEED
    while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1330.1  314.1  45.27 radius  3.0  3.0  3.0
        wait  0 ms
        gosub @CATALINA_HELI_TAKE_OFF_CHECK
        gosub @CATALINA_HELI_TAKE_OFF_BOMBS
    end
    04A2: heli $ESCAPE_CHOPPER fly_to  -1440.0  316.4  40.42 speed  $CAT1_SPEED
    while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1440.0  316.4  40.42 radius  3.0  3.0  3.0
        wait  0 ms
        gosub @CATALINA_HELI_TAKE_OFF_CHECK
        gosub @CATALINA_HELI_TAKE_OFF_BOMBS
    end
    04A2: heli $ESCAPE_CHOPPER fly_to  -1499.0  355.7  43.87 speed  $CAT1_SPEED
    while 81AF:   NOT  car $ESCAPE_CHOPPER  0 ()near_point  -1499.0  355.7  43.87 radius  3.0  3.0  3.0
        wait  0 ms
        gosub @CATALINA_HELI_TAKE_OFF_CHECK
        gosub @CATALINA_HELI_TAKE_OFF_BOMBS
    end
    04A2: heli $ESCAPE_CHOPPER fly_to  -1492.0  336.1  46.94 speed  $CAT1_SPEED
end

:CATALINA_HELI_TAKE_OFF_CLEANUP
009B: destroy_actor_instantly $TEMP_COLOMBIAN_ACTOR
end_thread

:CATALINA_HELI_TAKE_OFF_BOMBS
if
    0019:   17@ >  5000
then
    if
        0256:   player $PLAYER defined
    then
        if
            01FF:   player $PLAYER near_car $ESCAPE_CHOPPER radius  10.0  10.0  20.0 unknown  0
        then
            00AA: store_car $ESCAPE_CHOPPER position_to $ESCAPE_CHOPPER_X  $ESCAPE_CHOPPER_Y  $ESCAPE_CHOPPER_Z
            0009: $ESCAPE_CHOPPER_Z += -15.0
            020C: create_explosion_with_radius  6 at  $ESCAPE_CHOPPER_X  $ESCAPE_CHOPPER_Y  $ESCAPE_CHOPPER_Z
            0006:  17@ =  0
        end
    end
end
return

:CATALINA_HELI_TAKE_OFF_CHECK
if
    8038:  NOT  $ESCAPE_CHOPPER == -1
then
    if or
        0118:  actor $CATALINA dead
        0119:  car $ESCAPE_CHOPPER wrecked
    then
        jump @CATALINA_HELI_TAKE_OFF_CLEANUP
    end
    return
end
jump @CATALINA_HELI_TAKE_OFF_CLEANUP