//-------------Mission 59-------------
// Originally: Ray mission 6 'MARKED MAN'

:M59_MARKEDMAN
03A4: name_thread 'RAY6'
054C: use_GXT_table 'RAY6'
058E: set_restart_mission_taxi_destination -221.6 -696.3 31.66 180.0
gosub @MISSION_START_RAY6
if
    wasted_or_busted
then
    gosub @MISSION_RAY6_FAILED
end
gosub @MISSION_CLEANUP_RAY6
end_thread

:MISSION_START_RAY6
$FLAG_PLAYER_ON_MISSION = 1
$ON_MISSION_FOR_RAY = 1
$RAYS_CUTSCENE_FLAG = 1

increment_mission_attempts
wait 0 ms
$TIME_TILL_FLIGHT = 180000
$FLAG_BLIP_ON_RAY = 0
$AIRPORT_DOOR_FLAG = 0
$DOOR1_CLOSED = 0
$DOOR2_CLOSED = 0
$TOTAL_CIA = 0
$PICKUPS_CREATED_RM6 = 0
$CIA_1_FLAG = 0
$CIA_2_FLAG = 0
$CIA_3_FLAG = 0
$CIA_4_FLAG = 0
$CIA_5_FLAG = 0
$CIA_6_FLAG = 0
$CIA_7_FLAG = 0
$CIA_8_FLAG = 0
$CIA_9_FLAG = 0
$CIA_10_FLAG = 0
$CIA_11_FLAG = 0
$CIA_12_FLAG = 0
$CIA_13_FLAG = 0
$CIA_14_FLAG = 0
$CIA_15_FLAG = 0
$CIA_16_FLAG = 0
$CIA_17_FLAG = 0

023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'RAY'
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'RAYH'
0247: request_model #TOILET
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #TOILET available
    jf break
    wait 0 ms
end
0395: clear_area 1 at -296.0 -723.5 28.0 range 1.0
0055: set_player_coordinates $PLAYER at -296.0 -723.5 28.0
0171: set_player $PLAYER z_angle_to 90.0
02E4: load_cutscene_data 'R6_MM'
0244: set_cutscene_pos -295.625 -726.625 27.6875
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_RAY = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_RAY 'RAY'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
//02F4: create_cutscene_actor $RAY_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_RAY
//02F5: set_head_anim $RAY_CSHEAD 'RAY'
016A: fade 1 (back)  1500 ms
041D: set_camera_near_clip 0.1875
02E7: start_cutscene
03AF: set_streaming 0 (disabled)
03AD: set_rubbish 0 (invisible)
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   1807 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM6_A' 4000 ms 1   // // You weren't followed? Good.
while 001A:   4920 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM6_B' 4000 ms 1   // // This is it I'm way over my head and I'm starting to drown here!
while 001A:   8597 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM6_C' 4000 ms 1   // // The CIA seem to have a vested interest in SPANK
while 001A:   11482 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM6_C1' 4000 ms 1   // // and they don't like us screwing with the Cartel.
while 001A:   14220 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM6_D' 4000 ms 1   // // I'm a marked man so I'm getting out of here.
while 001A:   17464 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM6_E' 4000 ms 1   // // Get me to my flight at the airport and I'll make it worth your while!
while 001A:   21666 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
03AD: set_rubbish 1 (visible)
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
016A: fade 0  0 ms
041D: set_camera_near_clip 0.875
0373: set_camera_directly_behind_player
0296: unload_special_actor 1
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #TOILET
0247: request_model #B_MAN3
0247: request_model #UZI
0247: request_model #M16
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #B_MAN3 available
        8248:   NOT   model #UZI available
        8248:   NOT   model #M16 available
    jf break
    wait 0 ms
end
009A: $RAY = create_actor 21 #SPECIAL02 at -296.3125 -727.688 28.0
035F: set_actor $RAY armour_to 100
01DF: tie_actor $RAY to_player $PLAYER
03AF: set_streaming 1 (enabled)
016A: fade 1 (back)  1500 ms
0004: $RAYS_CUTSCENE_FLAG = 0
// ******************************************END OF CUTSCENE********************************
014E: set_timer_to $TIME_TILL_FLIGHT type 1
018A: $RAYS_BLIP = create_checkpoint_at -1074.0 -583.0 14.35
if
    0118:   actor $RAY dead
then
    00BC: print_now 'RM6_6' 5000 ms 1   // // ~r~Ray is dead!
    jump @MISSION_RAY6_FAILED
end
0319: set_actor $RAY running 1
00BC: print_now 'RM6_5' 15000 ms 1   // // ~g~The CIA have the bridge under surveillance find another route across.
while 80EF:   NOT   actor $RAY stopped 1 near_point -1073.25 -582.875 radius 8.0 8.0  // never used in VC
    wait 0 ms
    if
        0118:   actor $RAY dead
    then
        00BC: print_now 'RM6_6' 5000 ms 1   // // ~r~Ray is dead!
        jump @MISSION_RAY6_FAILED
    end
    if
        001A:   1 > $TIME_TILL_FLIGHT
    then
        00BC: print_now 'RM6_7' 5000 ms 1   // // ~r~Ray has missed his flight.
        jump @MISSION_RAY6_FAILED
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_1_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -360.8125 -612.5 radius 100.0 100.0
            then
                009A: $CIA_1 = create_actor 4 #B_MAN3 at -360.8125 -612.5 48.125
                0173: set_actor $CIA_1 z_angle_to 239.562
                01B2: give_actor $CIA_1 weapon 26 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_1 immune_to_nonplayer 1
                009F: set_actor $CIA_1 objective_to-1
                0243: set_actor $CIA_1 ped_stats_to 16
                011A: set_actor $CIA_1 flags 1
                0350: set_char_stay_in_same_place $CIA_1  1
                035F: set_actor $CIA_1 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_1_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_1_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -360.8125 -612.5 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_1
            000C: $TOTAL_CIA -= 1
            0004: $CIA_1_FLAG = 0
        end
    end
    if
        0038:   $CIA_1_FLAG == 1
    then
        if
            0118:   actor $CIA_1 dead
        then
            0004: $CIA_1_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_1 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_1 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_1 radius 40.0 40.0
            then
                01CA: actor $CIA_1 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_2_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -359.0 -630.312 radius 100.0 100.0
            then
                009A: $CIA_2 = create_actor 4 #B_MAN3 at -359.0 -630.312 42.0625
                0173: set_actor $CIA_2 z_angle_to 293.562
                01B2: give_actor $CIA_2 weapon 26 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_2 immune_to_nonplayer 1
                009F: set_actor $CIA_2 objective_to-1
                0243: set_actor $CIA_2 ped_stats_to 16
                011A: set_actor $CIA_2 flags 1
                0350: set_char_stay_in_same_place $CIA_2  1
                035F: set_actor $CIA_2 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_2_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_2_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -359.0 -630.312 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_2
            000C: $TOTAL_CIA -= 1
            0004: $CIA_2_FLAG = 0
        end
    end
    if
        0038:   $CIA_2_FLAG == 1
    then
        if
            0118:   actor $CIA_2 dead
        then
            0004: $CIA_2_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_2 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_2 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_2 radius 40.0 40.0
            then
                01CA: actor $CIA_2 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_3_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -370.0625 -632.812 radius 100.0 100.0
            then
                009A: $CIA_3 = create_actor 4 #B_MAN3 at -370.0625 -632.812 48.375
                0173: set_actor $CIA_3 z_angle_to 255.375
                01B2: give_actor $CIA_3 weapon 26 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_3 immune_to_nonplayer 1
                009F: set_actor $CIA_3 objective_to-1
                0243: set_actor $CIA_3 ped_stats_to 16
                011A: set_actor $CIA_3 flags 1
                0350: set_char_stay_in_same_place $CIA_3  1
                035F: set_actor $CIA_3 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_3_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_3_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -370.0625 -632.812 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_3
            000C: $TOTAL_CIA -= 1
            0004: $CIA_3_FLAG = 0
        end
    end
    if
        0038:   $CIA_3_FLAG == 1
    then
        if
            0118:   actor $CIA_3 dead
        then
            0004: $CIA_3_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_3 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_3 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_3 radius 40.0 40.0
            then
                01CA: actor $CIA_3 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_4_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -359.25 -650.438 radius 100.0 100.0
            then
                009A: $CIA_4 = create_actor 4 #B_MAN3 at -359.25 -650.438 46.5625
                0173: set_actor $CIA_4 z_angle_to 344.25
                01B2: give_actor $CIA_4 weapon 26 ammo $CIA_4  // Load the weapon model before using this
                02A9: set_actor $CIA_4 immune_to_nonplayer 1
                009F: set_actor $CIA_4 objective_to-1
                0243: set_actor $CIA_4 ped_stats_to 16
                011A: set_actor $CIA_4 flags 1
                0350: set_char_stay_in_same_place $CIA_4  1
                035F: set_actor $CIA_4 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_4_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_4_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -359.25 -650.438 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_4
            000C: $TOTAL_CIA -= 1
            0004: $CIA_4_FLAG = 0
        end
    end
    if
        0038:   $CIA_4_FLAG == 1
    then
        if
            0118:   actor $CIA_4 dead
        then
            0004: $CIA_4_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_4 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_4 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_4 radius 40.0 40.0
            then
                01CA: actor $CIA_4 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_5_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -552.938 -630.375 radius 100.0 100.0
            then
                009A: $CIA_5 = create_actor 4 #B_MAN3 at -552.938 -630.375 51.9375
                0173: set_actor $CIA_5 z_angle_to 344.25
                01B2: give_actor $CIA_5 weapon 26 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_5 immune_to_nonplayer 1
                009F: set_actor $CIA_5 objective_to-1
                0243: set_actor $CIA_5 ped_stats_to 16
                011A: set_actor $CIA_5 flags 1
                0350: set_char_stay_in_same_place $CIA_5  1
                035F: set_actor $CIA_5 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_5_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_5_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -552.938 -630.375 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_5
            000C: $TOTAL_CIA -= 1
            0004: $CIA_5_FLAG = 0
        end
    end
    if
        0038:   $CIA_5_FLAG == 1
    then
        if
            0118:   actor $CIA_5 dead
        then
            0004: $CIA_5_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_5 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_5 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_5 radius 40.0 40.0
            then
                01CA: actor $CIA_5 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_6_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -547.438 -632.688 radius 100.0 100.0
            then
                009A: $CIA_6 = create_actor 4 #B_MAN3 at -547.438 -632.688 51.9375
                0173: set_actor $CIA_6 z_angle_to 247.0
                01B2: give_actor $CIA_6 weapon 26 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_6 immune_to_nonplayer 1
                009F: set_actor $CIA_6 objective_to-1
                0243: set_actor $CIA_6 ped_stats_to 16
                011A: set_actor $CIA_6 flags 1
                0350: set_char_stay_in_same_place $CIA_6  1
                035F: set_actor $CIA_6 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_6_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_6_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -547.438 -632.688 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_6
            000C: $TOTAL_CIA -= 1
            0004: $CIA_6_FLAG = 0
        end
    end
    if
        0038:   $CIA_6_FLAG == 1
    then
        if
            0118:   actor $CIA_6 dead
        then
            0004: $CIA_6_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_6 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_6 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_6 radius 40.0 40.0
            then
                01CA: actor $CIA_6 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_7_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -772.062 -612.5 radius 100.0 100.0
            then
                009A: $CIA_7 = create_actor 4 #B_MAN3 at -772.062 -612.5 50.5625
                0173: set_actor $CIA_7 z_angle_to 247.0
                01B2: give_actor $CIA_7 weapon 26 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_7 immune_to_nonplayer 1
                009F: set_actor $CIA_7 objective_to-1
                0243: set_actor $CIA_7 ped_stats_to 16
                011A: set_actor $CIA_7 flags 1
                0350: set_char_stay_in_same_place $CIA_7  1
                035F: set_actor $CIA_7 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_7_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_7_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -772.062 -612.5 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_7
            000C: $TOTAL_CIA -= 1
            0004: $CIA_7_FLAG = 0
        end
    end
    if
        0038:   $CIA_7_FLAG == 1
    then
        if
            0118:   actor $CIA_7 dead
        then
            0004: $CIA_7_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_7 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_7 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_7 radius 40.0 40.0
            then
                01CA: actor $CIA_7 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_8_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -869.625 -631.25 radius 100.0 100.0
            then
                009A: $CIA_8 = create_actor 4 #B_MAN3 at -869.625 -631.25 48.25
                0173: set_actor $CIA_8 z_angle_to 247.0
                01B2: give_actor $CIA_8 weapon 26 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_8 immune_to_nonplayer 1
                009F: set_actor $CIA_8 objective_to-1
                0243: set_actor $CIA_8 ped_stats_to 16
                011A: set_actor $CIA_8 flags 1
                0350: set_char_stay_in_same_place $CIA_8  1
                035F: set_actor $CIA_8 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_8_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_8_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -869.625 -631.25 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_8
            000C: $TOTAL_CIA -= 1
            0004: $CIA_8_FLAG = 0
        end
    end
    if
        0038:   $CIA_8_FLAG == 1
    then
        if
            0118:   actor $CIA_8 dead
        then
            0004: $CIA_8_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_8 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_8 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_8 radius 40.0 40.0
            then
                01CA: actor $CIA_8 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_9_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -858.375 -650.375 radius 100.0 100.0
            then
                009A: $CIA_9 = create_actor 4 #B_MAN3 at -858.375 -650.375 48.5
                0173: set_actor $CIA_9 z_angle_to 316.688
                01B2: give_actor $CIA_9 weapon 26 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_9 immune_to_nonplayer 1
                009F: set_actor $CIA_9 objective_to-1
                0243: set_actor $CIA_9 ped_stats_to 16
                011A: set_actor $CIA_9 flags 1
                0350: set_char_stay_in_same_place $CIA_9  1
                035F: set_actor $CIA_9 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_9_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_9_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -858.375 -650.375 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_9
            000C: $TOTAL_CIA -= 1
            0004: $CIA_9_FLAG = 0
        end
    end
    if
        0038:   $CIA_9_FLAG == 1
    then
        if
            0118:   actor $CIA_9 dead
        then
            0004: $CIA_9_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_9 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_9 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_9 radius 40.0 40.0
            then
                01CA: actor $CIA_9 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_10_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -963.062 -498.375 radius 100.0 100.0
            then
                009A: $CIA_10 = create_actor 4 #B_MAN3 at -963.062 -498.375 28.375
                0173: set_actor $CIA_10 z_angle_to 76.5
                01B2: give_actor $CIA_10 weapon 23 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_10 immune_to_nonplayer 1
                009F: set_actor $CIA_10 objective_to-1
                0243: set_actor $CIA_10 ped_stats_to 16
                011A: set_actor $CIA_10 flags 1
                0350: set_char_stay_in_same_place $CIA_10  1
                035F: set_actor $CIA_10 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_10_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_10_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -963.062 -498.375 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_10
            000C: $TOTAL_CIA -= 1
            0004: $CIA_10_FLAG = 0
        end
    end
    if
        0038:   $CIA_10_FLAG == 1
    then
        if
            0118:   actor $CIA_10 dead
        then
            0004: $CIA_10_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_10 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_10 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_10 radius 40.0 40.0
            then
                01CA: actor $CIA_10 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_11_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -972.625 -501.75 radius 100.0 100.0
            then
                009A: $CIA_11 = create_actor 4 #B_MAN3 at -972.625 -501.75 28.3125
                0173: set_actor $CIA_11 z_angle_to 76.5
                01B2: give_actor $CIA_11 weapon 23 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_11 immune_to_nonplayer 1
                009F: set_actor $CIA_11 objective_to-1
                0243: set_actor $CIA_11 ped_stats_to 16
                011A: set_actor $CIA_11 flags 1
                0350: set_char_stay_in_same_place $CIA_11  1
                035F: set_actor $CIA_11 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_11_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_11_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -972.625 -501.75 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_11
            000C: $TOTAL_CIA -= 1
            0004: $CIA_11_FLAG = 0
        end
    end
    if
        0038:   $CIA_11_FLAG == 1
    then
        if
            0118:   actor $CIA_11 dead
        then
            0004: $CIA_11_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_11 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_11 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_11 radius 40.0 40.0
            then
                01CA: actor $CIA_11 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_12_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -1027.25 -563.0 radius 100.0 100.0
            then
                009A: $CIA_12 = create_actor 4 #B_MAN3 at -1027.25 -563.0 27.5
                0173: set_actor $CIA_12 z_angle_to 344.25
                01B2: give_actor $CIA_12 weapon 23 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_12 immune_to_nonplayer 1
                009F: set_actor $CIA_12 objective_to-1
                0243: set_actor $CIA_12 ped_stats_to 16
                011A: set_actor $CIA_12 flags 1
                0350: set_char_stay_in_same_place $CIA_12  1
                035F: set_actor $CIA_12 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_12_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_12_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -1027.25 -563.0 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_12
            000C: $TOTAL_CIA -= 1
            0004: $CIA_12_FLAG = 0
        end
    end
    if
        0038:   $CIA_12_FLAG == 1
    then
        if
            0118:   actor $CIA_12 dead
        then
            0004: $CIA_12_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_12 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_12 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_12 radius 40.0 40.0
            then
                01CA: actor $CIA_12 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_13_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -1006.125 -540.562 radius 100.0 100.0
            then
                009A: $CIA_13 = create_actor 4 #B_MAN3 at -1006.125 -540.562 28.875
                0173: set_actor $CIA_13 z_angle_to 281.875
                01B2: give_actor $CIA_13 weapon 23 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_13 immune_to_nonplayer 1
                009F: set_actor $CIA_13 objective_to-1
                0243: set_actor $CIA_13 ped_stats_to 16
                011A: set_actor $CIA_13 flags 1
                0350: set_char_stay_in_same_place $CIA_13  1
                035F: set_actor $CIA_13 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_13_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_13_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -1006.125 -540.562 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_13
            000C: $TOTAL_CIA -= 1
            0004: $CIA_13_FLAG = 0
        end
    end
    if
        0038:   $CIA_13_FLAG == 1
    then
        if
            0118:   actor $CIA_13 dead
        then
            0004: $CIA_13_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_13 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_13 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_13 radius 40.0 40.0
            then
                01CA: actor $CIA_13 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_14_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -973.375 -419.25 radius 100.0 100.0
            then
                009A: $CIA_14 = create_actor 4 #B_MAN3 at -973.375 -419.25 23.8125
                0173: set_actor $CIA_14 z_angle_to 113.562
                01B2: give_actor $CIA_14 weapon 23 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_14 immune_to_nonplayer 1
                009F: set_actor $CIA_14 objective_to-1
                0243: set_actor $CIA_14 ped_stats_to 16
                011A: set_actor $CIA_14 flags 1
                0350: set_char_stay_in_same_place $CIA_14  1
                035F: set_actor $CIA_14 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_14_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_14_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -973.375 -419.25 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_14
            000C: $TOTAL_CIA -= 1
            0004: $CIA_14_FLAG = 0
        end
    end
    if
        0038:   $CIA_14_FLAG == 1
    then
        if
            0118:   actor $CIA_14 dead
        then
            0004: $CIA_14_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_14 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_14 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_14 radius 40.0 40.0
            then
                01CA: actor $CIA_14 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_15_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -990.312 -404.438 radius 100.0 100.0
            then
                009A: $CIA_15 = create_actor 4 #B_MAN3 at -990.312 -404.438 23.8125
                0173: set_actor $CIA_15 z_angle_to 191.062
                01B2: give_actor $CIA_15 weapon 23 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_15 immune_to_nonplayer 1
                009F: set_actor $CIA_15 objective_to-1
                0243: set_actor $CIA_15 ped_stats_to 16
                011A: set_actor $CIA_15 flags 1
                0350: set_char_stay_in_same_place $CIA_15  1
                035F: set_actor $CIA_15 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_15_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_15_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -990.312 -404.438 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_15
            000C: $TOTAL_CIA -= 1
            0004: $CIA_15_FLAG = 0
        end
    end
    if
        0038:   $CIA_15_FLAG == 1
    then
        if
            0118:   actor $CIA_15 dead
        then
            0004: $CIA_15_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_15 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_15 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_15 radius 40.0 40.0
            then
                01CA: actor $CIA_15 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_16_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -1012.0 -425.0 radius 100.0 100.0
            then
                009A: $CIA_16 = create_actor 4 #B_MAN3 at -1012.0 -425.0 24.5
                0173: set_actor $CIA_16 z_angle_to 265.375
                01B2: give_actor $CIA_16 weapon 23 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_16 immune_to_nonplayer 1
                009F: set_actor $CIA_16 objective_to-1
                0243: set_actor $CIA_16 ped_stats_to 16
                011A: set_actor $CIA_16 flags 1
                0350: set_char_stay_in_same_place $CIA_16  1
                035F: set_actor $CIA_16 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_16_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_16_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -1012.0 -425.0 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_16
            000C: $TOTAL_CIA -= 1
            0004: $CIA_16_FLAG = 0
        end
    end
    if
        0038:   $CIA_16_FLAG == 1
    then
        if
            0118:   actor $CIA_16 dead
        then
            0004: $CIA_16_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_16 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_16 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_16 radius 40.0 40.0
            then
                01CA: actor $CIA_16 kill_player $PLAYER
            end
        end
    end
    ////////
    if
        001A:   16 > $TOTAL_CIA
    then
        if
            0038:   $CIA_17_FLAG == 0
        then
            if
                00E3:   player $PLAYER 0 near_point -1014.125 -485.125 radius 100.0 100.0
            then
                009A: $CIA_17 = create_actor 4 #B_MAN3 at -1014.125 -485.125 24.25
                0173: set_actor $CIA_17 z_angle_to 260.188
                01B2: give_actor $CIA_17 weapon 23 ammo 9999  // Load the weapon model before using this
                02A9: set_actor $CIA_17 immune_to_nonplayer 1
                009F: set_actor $CIA_17 objective_to-1
                0243: set_actor $CIA_17 ped_stats_to 16
                011A: set_actor $CIA_17 flags 1
                0350: set_char_stay_in_same_place $CIA_17  1
                035F: set_actor $CIA_17 armour_to 100
                0008: $TOTAL_CIA += 1
                0004: $CIA_17_FLAG = 1
            end
        end
    end
    if
        0038:   $CIA_17_FLAG == 1
    then
        if
            80E3:   NOT   player $PLAYER 0 near_point -1014.125 -485.125 radius 100.0 100.0
        then
            009B: destroy_actor_instantly $CIA_17
            000C: $TOTAL_CIA -= 1
            0004: $CIA_17_FLAG = 0
        end
    end
    if
        0038:   $CIA_17_FLAG == 1
    then
        if
            0118:   actor $CIA_17 dead
        then
            0004: $CIA_17_FLAG = 2
        else
            if
                00EB:   player $PLAYER 0 near_actor_in_car $CIA_17 radius 40.0 40.0
            then
                00DA: $PLAYER_DEATH_CAR = player $PLAYER car
                01D9: actor $CIA_17 destroy_car $PLAYER_DEATH_CAR
            end
            if
                00EA:   player $PLAYER 0 near_actor_on_foot $CIA_17 radius 40.0 40.0
            then
                01CA: actor $CIA_17 kill_player $PLAYER
            end
        end
    end
    ////////
    if and
        8320:   NOT   actor $RAY in_range_of_player $PLAYER
        0038:   $FLAG_BLIP_ON_RAY == 0
    then
        00BC: print_now 'RM6_8' 5000 ms 1   // // ~g~You have left Ray behind go back and get him.
        0164: remove_blip $RAYS_BLIP
        0187: $RAYS_BLIP = create_marker_above_actor $RAY
        0004: $FLAG_BLIP_ON_RAY = 1
    end
    if
        0038:   $FLAG_BLIP_ON_RAY == 1
    then
        if
            00E9:   player $PLAYER 0 near_actor $RAY radius 8.0 8.0
        then
            01DF: tie_actor $RAY to_player $PLAYER
            0164: remove_blip $RAYS_BLIP
            018A: $RAYS_BLIP = create_checkpoint_at -1074.0 -583.0 14.0
            0004: $FLAG_BLIP_ON_RAY = 0
        end
    end
end //while
0164: remove_blip $RAYS_BLIP
014F: stop_timer $TIME_TILL_FLIGHT
01B4: set_player $PLAYER can_move 0 (frozen)
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
02A3: toggle_widescreen 1 (on)
015F: set_camera_position -1067.0 -571.062 20.0 0.0 0.0 0.0
0159: camera_on_ped $RAY 15 2
if or
    80DF:   NOT   actor $RAY driving
    80E0:   NOT   player $PLAYER driving
then
    020F: actor $RAY look_at_player $PLAYER
    01F5: $SCRIPT_CONTROLLED_PLAYER = get_player_char $PLAYER
    020E: actor $SCRIPT_CONTROLLED_PLAYER look_at_actor $RAY
end
03CF: load_wav 'R6_A' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if
        0118:   actor $RAY dead
    then
        00BC: print_now 'RM6_6' 5000 ms 1   // // ~r~Ray is dead!
        jump @MISSION_RAY6_FAILED
    end
end
03D1: play_wav 1
00BC: print_now 'RM6_1' 5000 ms 1   // // Here's a key to a lock-up.
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        0118:   actor $RAY dead
    then
        00BC: print_now 'RM6_6' 5000 ms 1   // // ~r~Ray is dead!
        jump @MISSION_RAY6_FAILED
    end
end
03CF: load_wav 'R6_A1' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if
        0118:   actor $RAY dead
    then
        00BC: print_now 'RM6_6' 5000 ms 1   // // ~r~Ray is dead!
        jump @MISSION_RAY6_FAILED
    end
end
03D1: play_wav 1
00BC: print_now 'RM6_2' 5000 ms 1   // // You'll find some cash and some 'supplies' I'd stashed in case things got tight.
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        0118:   actor $RAY dead
    then
        00BC: print_now 'RM6_6' 5000 ms 1   // // ~r~Ray is dead!
        jump @MISSION_RAY6_FAILED
    end
end
03CF: load_wav 'R6_B' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if
        0118:   actor $RAY dead
    then
        00BC: print_now 'RM6_6' 5000 ms 1   // // ~r~Ray is dead!
        jump @MISSION_RAY6_FAILED
    end
end
03D1: play_wav 1
00BC: print_now 'RM6_3' 5000 ms 1   // // See y'around.
if
    00DF:   actor $RAY driving
then
    01E0: leave_group $RAY
    00D9: $PLAYER_DEATH_CAR = actor $RAY car
    01D3: actor $RAY leave_car $PLAYER_DEATH_CAR
end
while true
    if or
        8038:   NOT   $AIRPORT_DOOR_FLAG == 6
        8038:   NOT   $DOOR1_CLOSED == 0
        8038:   NOT   $DOOR2_CLOSED == 0
    jf break
    wait 0 ms
    if
        8038:   NOT   $AIRPORT_DOOR_FLAG == 6
    then
        if
            0118:   actor $RAY dead
        then
            00BC: print_now 'RM6_6' 5000 ms 1   // // ~r~Ray is dead!
            jump @MISSION_RAY6_FAILED
        end
    end
    if
        0038:   $AIRPORT_DOOR_FLAG == 0
    then
        if
            80DF:   NOT   actor $RAY driving
        then
            01E0: leave_group $RAY
            0239: actor $RAY run_to -1079.688 -586.438
            015F: set_camera_position -1086.375 -603.0 17.375 0.0 0.0 0.0
            0159: camera_on_ped $RAY 15 2
            0004: $AIRPORT_DOOR_FLAG = 1
        end
    end
    if
        0038:   $AIRPORT_DOOR_FLAG == 1
    then
        if
            00ED:   actor $RAY 0 near_point_on_foot -1079.688 -586.438 radius 1.5 1.5
        then
            0239: actor $RAY run_to -1092.188 -587.25
            0004: $AIRPORT_DOOR_FLAG = 2
        end
    end
    if
        0038:   $AIRPORT_DOOR_FLAG == 2
    then
        if
            00ED:   actor $RAY 0 near_point_on_foot -1092.188 -587.25 radius 1.5 1.5
        then
            0239: actor $RAY run_to -1103.062 -599.375
            0004: $AIRPORT_DOOR_FLAG = 3
        end
    end
    if
        0038:   $AIRPORT_DOOR_FLAG == 3
    then
        if
            00ED:   actor $RAY 0 near_point_on_foot -1103.062 -599.375 radius 1.5 1.5
        then
            0239: actor $RAY run_to -1107.625 -600.375
            0004: $AIRPORT_DOOR_FLAG = 4
        end
    end
    if and
        0018:   $AIRPORT_DOOR_FLAG > 3  //open doors here
        0038:   $DOOR1_CLOSED == 0
    then
        if
            034E: slide_object $AIRPORT_DOOR1 to -1105.375 -597.812 17.8125 angle 0.0625 0.0625 0.0625 0
        then
            0004: $DOOR1_CLOSED = 1
        end
    end
    if and
        0018:   $AIRPORT_DOOR_FLAG > 3  //open doors here
        0038:   $DOOR2_CLOSED == 0
    then
        if
            034E: slide_object $AIRPORT_DOOR2 to -1105.375 -602.875 17.8125 angle 0.0625 0.0625 0.0625 0
        then
            0004: $DOOR2_CLOSED = 1
        end
    end
    if
        0038:   $AIRPORT_DOOR_FLAG == 4
    then
        if
            00ED:   actor $RAY 0 near_point_on_foot -1107.625 -600.375 radius 1.5 1.5
        then
            0239: actor $RAY run_to -1107.562 -604.688
            0004: $AIRPORT_DOOR_FLAG = 5
        end
    end
    if and
        0018:   $AIRPORT_DOOR_FLAG > 4    //CLOSE doors here
        0038:   $DOOR1_CLOSED == 1
    then
        if
            8056:   NOT   player $PLAYER 0 in_rectangle -1108.75 -605.188 -1103.75 -595.562
        then
            if
                034E: slide_object $AIRPORT_DOOR1 to -1105.375 -599.25 17.8125 angle 0.0625 0.0625 0.0625 0
            then
                0004: $DOOR1_CLOSED = 0
            end
        end
    end
    if and
        0018:   $AIRPORT_DOOR_FLAG > 4        //CLOSE doors here
        0038:   $DOOR2_CLOSED == 1
    then
        if
            8056:   NOT   player $PLAYER 0 in_rectangle -1108.75 -605.188 -1103.75 -595.562
        then
            if
                034E: slide_object $AIRPORT_DOOR2 to -1105.375 -601.312 17.8125 angle 0.0625 0.0625 0.0625 0
            then
                0004: $DOOR2_CLOSED = 0
            end
        end
    end
    if
        0038:   $AIRPORT_DOOR_FLAG == 5
    then
        if
            00ED:   actor $RAY 0 near_point_on_foot -1107.562 -604.688 radius 1.5 1.5
        then
            01B4: set_player $PLAYER can_move 1 (unfrozen)
            02A3: toggle_widescreen 0 (off)
            0373: set_camera_directly_behind_player
            02EB: restore_camera_jumpcut
            009B: destroy_actor_instantly $RAY
            0004: $AIRPORT_DOOR_FLAG = 6
        end
    end
end //while
00BC: print_now 'RM6_4' 5000 ms 1   // // ~g~Go over to the lockup and collect Ray's stash.
018A: $RAYS_BLIP = create_checkpoint_at -93.875 -997.75 26.9375
0247: request_model #PATRIOT
while 80E3:   NOT   player $PLAYER 0 near_point -93.875 -997.75 radius 50.0 50.0
    wait 0 ms
end
while 8248:   NOT   model #PATRIOT available
    wait 0 ms
end
00A5: $RAYS_PRIZE_CAR = create_car #PATRIOT at -93.875 -997.75 26.9375
0175: set_car $RAYS_PRIZE_CAR z_angle_to 270.0
02AC: set_car $RAYS_PRIZE_CAR immunities 1 0 0 0 0
03AB: set_vehicle $RAYS_PRIZE_CAR strong 1
032B: $RAYS_PRIZE_WEAPON1 = create_weapon_pickup #M16    3 ammo 1000 at -90.9494 -993.9206 27.5
032B: $RAYS_PRIZE_WEAPON2 = create_weapon_pickup #FLAME  3 ammo 1000 at -97.6774 -998.5697 27.5
032B: $RAYS_PRIZE_WEAPON3 = create_weapon_pickup #ROCKET 3 ammo 25 at   -91.1069 -995.5624 27.5
032B: $RAYS_PRIZE_WEAPON4 = create_weapon_pickup #SNIPER 3 ammo 50 at   -93.7294 -993.6790 27.5
02E1: $RAYS_CASH = create_cash_pickup 20000 at -96.0257 -993.6790 27.5
0004: $PICKUPS_CREATED_RM6 = 1
while 80E3:   NOT   player $PLAYER 0 near_point -104.812 -996.438 radius 2.0 2.0
    wait 0 ms
end
0360: open_garage $RAY_LOCKUP_GARAGE
014D: add_pager_message 'RM6_666'  140  666  1   // // Take care of my bullet proof Patriot. See you in Miami Ray
wait 13000 ms
jump @MISSION_RAY6_PASSED

:MISSION_RAY6_FAILED
if
    0038:   $PICKUPS_CREATED_RM6 == 1
then
    0215: destroy_pickup $RAYS_PRIZE_WEAPON1
    0215: destroy_pickup $RAYS_PRIZE_WEAPON2
    0215: destroy_pickup $RAYS_PRIZE_WEAPON3
    0215: destroy_pickup $RAYS_PRIZE_WEAPON4
    0215: destroy_pickup $RAYS_CASH
    00A6: destroy_car $RAYS_PRIZE_CAR
    0004: $PICKUPS_CREATED_RM6 = 0
end
034F: remove_char_elegantly $RAY
00BA: text_styled 'M_FAIL' 5000 ms 1   // // MISSION FAILED!
return

:MISSION_RAY6_PASSED
0004: $MARKED_MAN_COMPLETED = 1
01E3: text_1number_styled 'M_PASS' 20000 2000 ms 1   // // MISSION PASSED! $~1~
0109: player $PLAYER money += 20000
0110: clear_player $PLAYER wanted_level
0318: set_latest_mission_passed 'RM6'   // // 'MARKED MAN'
0394: play_music 1
030C: set_mission_points += 1
0164: remove_blip $RAY_MISSION_MARKER
return

:MISSION_CLEANUP_RAY6
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_RAY = 0
if
    03CA:   object $AIRPORT_DOOR1 exists
then
    01BC: put_object $AIRPORT_DOOR1 at -1105.375 -599.25 17.8125
end
if
    03CA:   object $AIRPORT_DOOR2 exists
then
    01BC: put_object $AIRPORT_DOOR2 at -1105.375 -601.312 17.8125
end
if
    0056:   player $PLAYER 0 in_rectangle -1108.75 -605.188 -1103.75 -595.562
then
    0055: set_player_coordinates $PLAYER at -1102.812 -600.375 17.0
    0171: set_player $PLAYER z_angle_to 270.0
end
014F: stop_timer $TIME_TILL_FLIGHT
0164: remove_blip $RAYS_BLIP
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #B_MAN3
0249: mark_model_as_no_longer_needed #CHEETAH
0249: mark_model_as_no_longer_needed #PATRIOT
mission_cleanup
return
