//-------------Mission 65-------------
// Originally: Yardies mission 3 'GANGCAR ROUND-UP'

:M65_GANGCARROUNDUP
03A4: name_thread 'YARD3'
054C: use_GXT_table 'YARD3'
gosub @MISSION_START_YD3
if
    wasted_or_busted
then
    gosub @MISSION_YD3_FAILED
end
gosub @MISSION_CLEANUP_YD3
end_thread

:MISSION_START_YD3
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1  
0004: $ON_MISSION_FOR_YARDIES = 1  
wait 0 ms
03DE: set_pedestrians_density_multiplier_to 0.0
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03CB: set_camera -215.0 -272.25 21.25
023C: load_special_actor 1 'PLAYER'
while true
    if
        823D:   NOT   special_actor 1 loaded
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'YD_PH3'
0244: set_cutscene_pos -214.0 -272.25 21.25
042B: clear_peds_from_cube -234.5 -250.0 6.0 -204.5 -290.0 31.0
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
016A: fade 1 (back)  1500 ms
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   2000 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD3_A' 10000 ms 1   // I want you to boost some gang cars
while 001A:   3700 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD3_A1' 10000 ms 1   // so we can do hits on our enemies' turf.
while 001A:   6370 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD3_B' 10000 ms 1   // I need a Mafia Sentinel
while 001A:   8658 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD3_B1' 10000 ms 1   // a Yakuza Stinger and a
while 001A:   10408 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD3_B2' 10000 ms 1   // Diablo Stallion so we can hit any gang in Liberty.
while 001A:   13950 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD3_C' 10000 ms 1   // Drop them off at the garage in Newport and remember
while 001A:   16920 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD3_C1' 10000 ms 1   // they're no use to us wrecked!!
while 001A:   20066 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while fading
    wait 0 ms
end
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
03AF: set_streaming 1 (enabled)
00BE: text_clear_all
02EA: clear_cutscene
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
03DE: set_pedestrians_density_multiplier_to 1.0
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
wait 1000 ms
0004: $COUNTER_CARS_YD3 = 0  

0005: $BLIP_X_YD3 = -75.0  
0005: $BLIP_Y_YD3 = -798.0  

0004: $LOOP_2_PASSPORT = 0  

0004: $FLAG_PLAYER_IN_DIABLOCAR = 0  
0004: $FLAG_PLAYER_IN_MAFIACAR = 0  
0004: $FLAG_PLAYER_IN_YAKUZACAR = 0  
//0004: $FLAG_PLAYER_IN_ANY_GANGCAR = 0

0004: $FLAG_DIABLO_DELIVERED_YD3 = 0  
0004: $FLAG_YAKUZACAR_DELIVERED_YD3 = 0  
0004: $FLAG_MAFIA_DELIVERED_YD3 = 0  

0004: $FLAG_DAM_MESSAGE = 0  
0004: $FLAG_GARAGE_MESSAGE = 0  
0004: $FLAG_ALREADY_BOOSTED_MESSAGE = 0  

//0004: $FLAG_GANGCAR_FLIPPED = 0
0004: $FLAG_MESSAGES = 0  
//0004: $FLAG_BLIP_GARAGE = 0
//0004: $FLAG_BLIP_SPRAY = 0

018A: $BLIP_GARAGE_YD3 = create_checkpoint_at $BLIP_X_YD3 $BLIP_Y_YD3 33.5

:LOOP_1
wait 0 ms
gosub @BLIPPAGE
if
    00E0:   player $PLAYER driving
then
    if
        00DE:   player $PLAYER driving_vehicle_type #DIABLOS
    then
        if
            0038:   $FLAG_DIABLO_DELIVERED_YD3 == 0  
        then
            00DA: $YD3_CAR = player $PLAYER car
            0294: set_can_respray_car $YD3_CAR flag 0
            0004: $FLAG_PLAYER_IN_DIABLOCAR = 1  
            0004: $FLAG_PLAYER_IN_MAFIACAR = 0  
            0004: $FLAG_PLAYER_IN_YAKUZACAR = 0  
            gosub @DAMAGE_CHECK
        end
        if and
            0038:   $FLAG_DIABLO_DELIVERED_YD3 == 1  
            0038:   $FLAG_ALREADY_BOOSTED_MESSAGE == 0  
        then
            00BC: print_now 'YD3_E' 3000 ms 1   // ~r~You've already boosted a diablo gangcar!
            0004: $FLAG_ALREADY_BOOSTED_MESSAGE = 1  
        end
    end
    if
        00DE:   player $PLAYER driving_vehicle_type #MAFIA
    then
        if
            0038:   $FLAG_MAFIA_DELIVERED_YD3 == 0  
        then
            00DA: $YD3_CAR = player $PLAYER car
            0294: set_can_respray_car $YD3_CAR flag 0
            0004: $FLAG_PLAYER_IN_DIABLOCAR = 0  
            0004: $FLAG_PLAYER_IN_MAFIACAR = 1  
            0004: $FLAG_PLAYER_IN_YAKUZACAR = 0  
            gosub @DAMAGE_CHECK
        end
        if and
            0038:   $FLAG_MAFIA_DELIVERED_YD3 == 1  
            0038:   $FLAG_ALREADY_BOOSTED_MESSAGE == 0  
        then
            00BC: print_now 'YD3_F' 3000 ms 1   // ~r~You've already boosted a Mafia gangcar!
            0004: $FLAG_ALREADY_BOOSTED_MESSAGE = 1  
        end
    end
    if
        00DE:   player $PLAYER driving_vehicle_type #YAKUZA
    then
        if
            0038:   $FLAG_YAKUZACAR_DELIVERED_YD3 == 0  
        then
            00DA: $YD3_CAR = player $PLAYER car
            0294: set_can_respray_car $YD3_CAR flag 0
            0004: $FLAG_PLAYER_IN_DIABLOCAR = 0  
            0004: $FLAG_PLAYER_IN_MAFIACAR = 0  
            0004: $FLAG_PLAYER_IN_YAKUZACAR = 1  
            gosub @DAMAGE_CHECK
        end
        if and
            0038:   $FLAG_YAKUZACAR_DELIVERED_YD3 == 1  
            0038:   $FLAG_ALREADY_BOOSTED_MESSAGE == 0  
        then
            00BC: print_now 'YD3_G' 3000 ms 1   // ~r~You've already boosted a Yakuza gangcar!
            0004: $FLAG_ALREADY_BOOSTED_MESSAGE = 1  
        end
    end
else
    0004: $FLAG_DAM_MESSAGE = 0  
    0004: $FLAG_GARAGE_MESSAGE = 0  
    0004: $FLAG_ALREADY_BOOSTED_MESSAGE = 0  
end
if
    0038:   $LOOP_2_PASSPORT == 0  
then
    jump @LOOP_1
end

:LOOP_2
gosub @DAMAGE_CHECK
if
    021C:   car_inside_garage $YARDIE_LOCKUP_GARAGE
then
    if and
        0038:   $FLAG_PLAYER_IN_DIABLOCAR == 1  
        0038:   $FLAG_DIABLO_DELIVERED_YD3 == 0  
    then
        0004: $FLAG_DIABLO_DELIVERED_YD3 = 1  
        0008: $COUNTER_CARS_YD3 += 1  
        0004: $FLAG_PLAYER_IN_DIABLOCAR = 0  
        0004: $LOOP_2_PASSPORT = 0  
        00BC: print_now 'YD3_H' 3000 ms 1   // ~g~Diablo gangcar boosted!
        018C: play_sound 1 at -75.0 -790.0 34.0
    end
    if and
        0038:   $FLAG_PLAYER_IN_MAFIACAR == 1  
        0038:   $FLAG_MAFIA_DELIVERED_YD3 == 0  
    then
        0004: $FLAG_MAFIA_DELIVERED_YD3 = 1  
        0008: $COUNTER_CARS_YD3 += 1  
        0004: $FLAG_PLAYER_IN_MAFIACAR = 0  
        0004: $LOOP_2_PASSPORT = 0  
        00BC: print_now 'YD3_I' 3000 ms 1   // ~g~Mafia gangcar boosted!
        018C: play_sound 1 at -75.0 -790.0 34.0
    end
    if and
        0038:   $FLAG_PLAYER_IN_YAKUZACAR == 1  
        0038:   $FLAG_YAKUZACAR_DELIVERED_YD3 == 0  
    then
        0008: $COUNTER_CARS_YD3 += 1  
        0004: $FLAG_YAKUZACAR_DELIVERED_YD3 = 1  
        0004: $FLAG_PLAYER_IN_YAKUZACAR = 0  
        0004: $LOOP_2_PASSPORT = 0  
        00BC: print_now 'YD3_J' 3000 ms 1   // ~g~Yakuza gangcar boosted!
        018C: play_sound 1 at -75.0 -790.0 34.0
    end
end
if
    8119:   NOT   car $YD3_CAR wrecked
then
    if and
        00B0:   car $YD3_CAR 0 in_rectangle -78.0 -803.0 -72.0 -795.5
        8056:   NOT   player $PLAYER 0 in_rectangle -78.0 -803.0 -72.0 -795.5
        8185:   NOT   car $YD3_CAR health >= 800
    then
        01C3: remove_references_to_car $YD3_CAR  // Like turning a car into any random car
    end
end
if
    001A:   3 > $COUNTER_CARS_YD3  
then
    jump @LOOP_1
end
jump @MISSION_YD3_PASSED

:MISSION_YD3_FAILED
00BA: text_styled 'M_FAIL' 2000 ms 1   // MISSION FAILED!
return

:MISSION_YD3_PASSED
0004: $GANGCAR_ROUNDUP_COMPLETED = 1  
01E3: text_1number_styled 'M_PASS' 10000 5000 ms 1   // MISSION PASSED! $~1~
0394: play_music 1
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 10000
0318: set_latest_mission_passed 'YD3'   // 'GANGCAR ROUND-UP'
030C: set_mission_points += 1
004F: create_thread @YARDIE_MISSION4_LOOP
return

:MISSION_CLEANUP_YD3
0164: remove_blip $BLIP_GARAGE_YD3
021B: set_garage $YARDIE_LOCKUP_GARAGE to_accept_car -1
0004: $FLAG_PLAYER_ON_MISSION = 0  
0004: $ON_MISSION_FOR_YARDIES = 0  
mission_cleanup
return

:BLIPPAGE
if
    0038:   $FLAG_DAM_MESSAGE == 1  
then
    if
        03C6:   is_collision_in_memory 1  
    then
        0164: remove_blip $BLIP_GARAGE_YD3
        02A8: $BLIP_GARAGE_YD3 = create_marker 21 at 590.25 -359.188 17.0
    end
    if
        03C6:   is_collision_in_memory 2  
    then
        0164: remove_blip $BLIP_GARAGE_YD3
        02A8: $BLIP_GARAGE_YD3 = create_marker 21 at 45.375 -493.75 32.1875
    end
    if
        03C6:   is_collision_in_memory 3  
    then
        0164: remove_blip $BLIP_GARAGE_YD3
        02A8: $BLIP_GARAGE_YD3 = create_marker 21 at -1477.0601 34.0 65.0
    end
else
    0164: remove_blip $BLIP_GARAGE_YD3
    018A: $BLIP_GARAGE_YD3 = create_checkpoint_at $BLIP_X_YD3 $BLIP_Y_YD3 33.5
end
return

:DAMAGE_CHECK
if
    00E0:   player $PLAYER driving
then
    if
        8119:   NOT   car $YD3_CAR wrecked
    then
        if
            00DC:   player $PLAYER driving $YD3_CAR
        then
            if or
                0185:   car $YD3_CAR health >= 900
                83C9:   NOT   car $YD3_CAR damaged
            then
                if
                    0038:   $FLAG_GARAGE_MESSAGE == 0  
                then
                    00BC: print_now 'YD3_L' 3000 ms 1   // ~g~Take it to the ~p~garage!
                    021B: set_garage $YARDIE_LOCKUP_GARAGE to_accept_car $YD3_CAR
                    0004: $FLAG_GARAGE_MESSAGE = 1  
                    0004: $FLAG_DAM_MESSAGE = 0  
                    0004: $LOOP_2_PASSPORT = 1  
                end
            else
                if
                    0038:   $FLAG_DAM_MESSAGE == 0  
                then
                    00BC: print_now 'YD3_K' 3000 ms 1   // ~r~The car's nearly wrecked! Get it repaired!
                    021B: set_garage $YARDIE_LOCKUP_GARAGE to_accept_car -1
                    0004: $FLAG_DAM_MESSAGE = 1  
                    0004: $FLAG_GARAGE_MESSAGE = 0  
                    0004: $LOOP_2_PASSPORT = 0  
                end
            end
        end
    end
end
return
